/*
 * Copyright 2017 Palantir Technologies, Inc. All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
import { __decorate } from "tslib";
import classNames from "classnames";
import * as React from "react";
import { polyfill } from "react-lifecycles-compat";
import { AbstractPureComponent2, Classes } from "../../common";
import { DISPLAYNAME_PREFIX } from "../../common/props";
// this component is simple enough that tests would be purely tautological.
/* istanbul ignore next */
let ButtonGroup = class ButtonGroup extends AbstractPureComponent2 {
    static displayName = `${DISPLAYNAME_PREFIX}.ButtonGroup`;
    render() {
        const { alignText, className, fill, minimal, large, vertical, ...htmlProps } = this.props;
        const buttonGroupClasses = classNames(Classes.BUTTON_GROUP, {
            [Classes.FILL]: fill,
            [Classes.LARGE]: large,
            [Classes.MINIMAL]: minimal,
            [Classes.VERTICAL]: vertical,
        }, Classes.alignmentClass(alignText), className);
        return (React.createElement("div", { ...htmlProps, className: buttonGroupClasses }, this.props.children));
    }
};
ButtonGroup = __decorate([
    polyfill
], ButtonGroup);
export { ButtonGroup };
//# sourceMappingURL=buttonGroup.js.map