/**
 * vis-data
 * http://visjs.org/
 *
 * Manage unstructured data using DataSet. Add, update, and remove data, and listen for changes in the data.
 *
 * @version 7.1.6
 * @date    2023-03-22T11:39:37.256Z
 *
 * @copyright (c) 2011-2017 Almende B.V, http://almende.com
 * @copyright (c) 2017-2019 visjs contributors, https://github.com/visjs
 *
 * @license
 * vis.js is dual licensed under both
 *
 *   1. The Apache 2.0 License
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *   and
 *
 *   2. The MIT License
 *      http://opensource.org/licenses/MIT
 *
 * vis.js may be distributed under either license.
 */
function t(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")}var e="undefined"!=typeof globalThis?globalThis:"undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self?self:{};function r(t){return t&&t.__esModule&&Object.prototype.hasOwnProperty.call(t,"default")?t.default:t}var n={},o={get exports(){return n},set exports(t){n=t}},i={},a={get exports(){return i},set exports(t){i=t}},s={},u={get exports(){return s},set exports(t){s=t}},c=function(t){return t&&t.Math==Math&&t},f=c("object"==typeof globalThis&&globalThis)||c("object"==typeof window&&window)||c("object"==typeof self&&self)||c("object"==typeof e&&e)||function(){return this}()||Function("return this")(),l=function(t){try{return!!t()}catch(t){return!0}},p=!l((function(){var t=function(){}.bind();return"function"!=typeof t||t.hasOwnProperty("prototype")})),h=p,v=Function.prototype,d=v.apply,y=v.call,g="object"==typeof Reflect&&Reflect.apply||(h?y.bind(d):function(){return y.apply(d,arguments)}),m=p,b=Function.prototype,x=b.call,_=m&&b.bind.bind(x,x),w=m?_:function(t){return function(){return x.apply(t,arguments)}},E=w,T=E({}.toString),O=E("".slice),S=function(t){return O(T(t),8,-1)},k=S,j=w,A=function(t){if("Function"===k(t))return j(t)},P="object"==typeof document&&document.all,I={all:P,IS_HTMLDDA:void 0===P&&void 0!==P},D=I.all,C=I.IS_HTMLDDA?function(t){return"function"==typeof t||t===D}:function(t){return"function"==typeof t},L={},R=!l((function(){return 7!=Object.defineProperty({},1,{get:function(){return 7}})[1]})),M=p,N=Function.prototype.call,F=M?N.bind(N):function(){return N.apply(N,arguments)},z={},U={}.propertyIsEnumerable,q=Object.getOwnPropertyDescriptor,Y=q&&!U.call({1:2},1);z.f=Y?function(t){var e=q(this,t);return!!e&&e.enumerable}:U;var W,G,X=function(t,e){return{enumerable:!(1&t),configurable:!(2&t),writable:!(4&t),value:e}},V=l,B=S,H=Object,$=w("".split),J=V((function(){return!H("z").propertyIsEnumerable(0)}))?function(t){return"String"==B(t)?$(t,""):H(t)}:H,K=function(t){return null==t},Q=K,Z=TypeError,tt=function(t){if(Q(t))throw Z("Can't call method on "+t);return t},et=J,rt=tt,nt=function(t){return et(rt(t))},ot=C,it=I.all,at=I.IS_HTMLDDA?function(t){return"object"==typeof t?null!==t:ot(t)||t===it}:function(t){return"object"==typeof t?null!==t:ot(t)},st={},ut=st,ct=f,ft=C,lt=function(t){return ft(t)?t:void 0},pt=function(t,e){return arguments.length<2?lt(ut[t])||lt(ct[t]):ut[t]&&ut[t][e]||ct[t]&&ct[t][e]},ht=w({}.isPrototypeOf),vt="undefined"!=typeof navigator&&String(navigator.userAgent)||"",dt=f,yt=vt,gt=dt.process,mt=dt.Deno,bt=gt&&gt.versions||mt&&mt.version,xt=bt&&bt.v8;xt&&(G=(W=xt.split("."))[0]>0&&W[0]<4?1:+(W[0]+W[1])),!G&&yt&&(!(W=yt.match(/Edge\/(\d+)/))||W[1]>=74)&&(W=yt.match(/Chrome\/(\d+)/))&&(G=+W[1]);var _t=G,wt=_t,Et=l,Tt=!!Object.getOwnPropertySymbols&&!Et((function(){var t=Symbol();return!String(t)||!(Object(t)instanceof Symbol)||!Symbol.sham&&wt&&wt<41})),Ot=Tt&&!Symbol.sham&&"symbol"==typeof Symbol.iterator,St=pt,kt=C,jt=ht,At=Object,Pt=Ot?function(t){return"symbol"==typeof t}:function(t){var e=St("Symbol");return kt(e)&&jt(e.prototype,At(t))},It=String,Dt=function(t){try{return It(t)}catch(t){return"Object"}},Ct=C,Lt=Dt,Rt=TypeError,Mt=function(t){if(Ct(t))return t;throw Rt(Lt(t)+" is not a function")},Nt=Mt,Ft=K,zt=function(t,e){var r=t[e];return Ft(r)?void 0:Nt(r)},Ut=F,qt=C,Yt=at,Wt=TypeError,Gt={},Xt={get exports(){return Gt},set exports(t){Gt=t}},Vt=f,Bt=Object.defineProperty,Ht=function(t,e){try{Bt(Vt,t,{value:e,configurable:!0,writable:!0})}catch(r){Vt[t]=e}return e},$t="__core-js_shared__",Jt=f[$t]||Ht($t,{}),Kt=Jt;(Xt.exports=function(t,e){return Kt[t]||(Kt[t]=void 0!==e?e:{})})("versions",[]).push({version:"3.29.0",mode:"pure",copyright:"© 2014-2023 Denis Pushkarev (zloirock.ru)",license:"https://github.com/zloirock/core-js/blob/v3.29.0/LICENSE",source:"https://github.com/zloirock/core-js"});var Qt=tt,Zt=Object,te=function(t){return Zt(Qt(t))},ee=te,re=w({}.hasOwnProperty),ne=Object.hasOwn||function(t,e){return re(ee(t),e)},oe=w,ie=0,ae=Math.random(),se=oe(1..toString),ue=function(t){return"Symbol("+(void 0===t?"":t)+")_"+se(++ie+ae,36)},ce=Gt,fe=ne,le=ue,pe=Tt,he=Ot,ve=f.Symbol,de=ce("wks"),ye=he?ve.for||ve:ve&&ve.withoutSetter||le,ge=function(t){return fe(de,t)||(de[t]=pe&&fe(ve,t)?ve[t]:ye("Symbol."+t)),de[t]},me=F,be=at,xe=Pt,_e=zt,we=function(t,e){var r,n;if("string"===e&&qt(r=t.toString)&&!Yt(n=Ut(r,t)))return n;if(qt(r=t.valueOf)&&!Yt(n=Ut(r,t)))return n;if("string"!==e&&qt(r=t.toString)&&!Yt(n=Ut(r,t)))return n;throw Wt("Can't convert object to primitive value")},Ee=TypeError,Te=ge("toPrimitive"),Oe=function(t,e){if(!be(t)||xe(t))return t;var r,n=_e(t,Te);if(n){if(void 0===e&&(e="default"),r=me(n,t,e),!be(r)||xe(r))return r;throw Ee("Can't convert object to primitive value")}return void 0===e&&(e="number"),we(t,e)},Se=Pt,ke=function(t){var e=Oe(t,"string");return Se(e)?e:e+""},je=at,Ae=f.document,Pe=je(Ae)&&je(Ae.createElement),Ie=function(t){return Pe?Ae.createElement(t):{}},De=Ie,Ce=!R&&!l((function(){return 7!=Object.defineProperty(De("div"),"a",{get:function(){return 7}}).a})),Le=R,Re=F,Me=z,Ne=X,Fe=nt,ze=ke,Ue=ne,qe=Ce,Ye=Object.getOwnPropertyDescriptor;L.f=Le?Ye:function(t,e){if(t=Fe(t),e=ze(e),qe)try{return Ye(t,e)}catch(t){}if(Ue(t,e))return Ne(!Re(Me.f,t,e),t[e])};var We=l,Ge=C,Xe=/#|\.prototype\./,Ve=function(t,e){var r=He[Be(t)];return r==Je||r!=$e&&(Ge(e)?We(e):!!e)},Be=Ve.normalize=function(t){return String(t).replace(Xe,".").toLowerCase()},He=Ve.data={},$e=Ve.NATIVE="N",Je=Ve.POLYFILL="P",Ke=Ve,Qe=Mt,Ze=p,tr=A(A.bind),er=function(t,e){return Qe(t),void 0===e?t:Ze?tr(t,e):function(){return t.apply(e,arguments)}},rr={},nr=R&&l((function(){return 42!=Object.defineProperty((function(){}),"prototype",{value:42,writable:!1}).prototype})),or=at,ir=String,ar=TypeError,sr=function(t){if(or(t))return t;throw ar(ir(t)+" is not an object")},ur=R,cr=Ce,fr=nr,lr=sr,pr=ke,hr=TypeError,vr=Object.defineProperty,dr=Object.getOwnPropertyDescriptor,yr="enumerable",gr="configurable",mr="writable";rr.f=ur?fr?function(t,e,r){if(lr(t),e=pr(e),lr(r),"function"==typeof t&&"prototype"===e&&"value"in r&&mr in r&&!r[mr]){var n=dr(t,e);n&&n[mr]&&(t[e]=r.value,r={configurable:gr in r?r[gr]:n[gr],enumerable:yr in r?r[yr]:n[yr],writable:!1})}return vr(t,e,r)}:vr:function(t,e,r){if(lr(t),e=pr(e),lr(r),cr)try{return vr(t,e,r)}catch(t){}if("get"in r||"set"in r)throw hr("Accessors not supported");return"value"in r&&(t[e]=r.value),t};var br=rr,xr=X,_r=R?function(t,e,r){return br.f(t,e,xr(1,r))}:function(t,e,r){return t[e]=r,t},wr=f,Er=g,Tr=A,Or=C,Sr=L.f,kr=Ke,jr=st,Ar=er,Pr=_r,Ir=ne,Dr=function(t){var e=function(r,n,o){if(this instanceof e){switch(arguments.length){case 0:return new t;case 1:return new t(r);case 2:return new t(r,n)}return new t(r,n,o)}return Er(t,this,arguments)};return e.prototype=t.prototype,e},Cr=function(t,e){var r,n,o,i,a,s,u,c,f,l=t.target,p=t.global,h=t.stat,v=t.proto,d=p?wr:h?wr[l]:(wr[l]||{}).prototype,y=p?jr:jr[l]||Pr(jr,l,{})[l],g=y.prototype;for(i in e)n=!(r=kr(p?i:l+(h?".":"#")+i,t.forced))&&d&&Ir(d,i),s=y[i],n&&(u=t.dontCallGetSet?(f=Sr(d,i))&&f.value:d[i]),a=n&&u?u:e[i],n&&typeof s==typeof a||(c=t.bind&&n?Ar(a,wr):t.wrap&&n?Dr(a):v&&Or(a)?Tr(a):a,(t.sham||a&&a.sham||s&&s.sham)&&Pr(c,"sham",!0),Pr(y,i,c),v&&(Ir(jr,o=l+"Prototype")||Pr(jr,o,{}),Pr(jr[o],i,a),t.real&&g&&(r||!g[i])&&Pr(g,i,a)))},Lr=Cr,Rr=R,Mr=rr.f;Lr({target:"Object",stat:!0,forced:Object.defineProperty!==Mr,sham:!Rr},{defineProperty:Mr});var Nr=st.Object,Fr=u.exports=function(t,e,r){return Nr.defineProperty(t,e,r)};Nr.defineProperty.sham&&(Fr.sham=!0);var zr=s,Ur=zr;a.exports=Ur,o.exports=i;var qr=r(n),Yr={},Wr={get exports(){return Yr},set exports(t){Yr=t}},Gr={},Xr={get exports(){return Gr},set exports(t){Gr=t}},Vr=S,Br=Array.isArray||function(t){return"Array"==Vr(t)},Hr=Math.ceil,$r=Math.floor,Jr=Math.trunc||function(t){var e=+t;return(e>0?$r:Hr)(e)},Kr=function(t){var e=+t;return e!=e||0===e?0:Jr(e)},Qr=Kr,Zr=Math.min,tn=function(t){return t>0?Zr(Qr(t),9007199254740991):0},en=function(t){return tn(t.length)},rn=TypeError,nn=function(t){if(t>9007199254740991)throw rn("Maximum allowed index exceeded");return t},on=ke,an=rr,sn=X,un=function(t,e,r){var n=on(e);n in t?an.f(t,n,sn(0,r)):t[n]=r},cn={};cn[ge("toStringTag")]="z";var fn="[object z]"===String(cn),ln=fn,pn=C,hn=S,vn=ge("toStringTag"),dn=Object,yn="Arguments"==hn(function(){return arguments}()),gn=ln?hn:function(t){var e,r,n;return void 0===t?"Undefined":null===t?"Null":"string"==typeof(r=function(t,e){try{return t[e]}catch(t){}}(e=dn(t),vn))?r:yn?hn(e):"Object"==(n=hn(e))&&pn(e.callee)?"Arguments":n},mn=C,bn=Jt,xn=w(Function.toString);mn(bn.inspectSource)||(bn.inspectSource=function(t){return xn(t)});var _n=bn.inspectSource,wn=w,En=l,Tn=C,On=gn,Sn=_n,kn=function(){},jn=[],An=pt("Reflect","construct"),Pn=/^\s*(?:class|function)\b/,In=wn(Pn.exec),Dn=!Pn.exec(kn),Cn=function(t){if(!Tn(t))return!1;try{return An(kn,jn,t),!0}catch(t){return!1}},Ln=function(t){if(!Tn(t))return!1;switch(On(t)){case"AsyncFunction":case"GeneratorFunction":case"AsyncGeneratorFunction":return!1}try{return Dn||!!In(Pn,Sn(t))}catch(t){return!0}};Ln.sham=!0;var Rn=!An||En((function(){var t;return Cn(Cn.call)||!Cn(Object)||!Cn((function(){t=!0}))||t}))?Ln:Cn,Mn=Br,Nn=Rn,Fn=at,zn=ge("species"),Un=Array,qn=function(t){var e;return Mn(t)&&(e=t.constructor,(Nn(e)&&(e===Un||Mn(e.prototype))||Fn(e)&&null===(e=e[zn]))&&(e=void 0)),void 0===e?Un:e},Yn=function(t,e){return new(qn(t))(0===e?0:e)},Wn=l,Gn=_t,Xn=ge("species"),Vn=function(t){return Gn>=51||!Wn((function(){var e=[];return(e.constructor={})[Xn]=function(){return{foo:1}},1!==e[t](Boolean).foo}))},Bn=Cr,Hn=l,$n=Br,Jn=at,Kn=te,Qn=en,Zn=nn,to=un,eo=Yn,ro=Vn,no=_t,oo=ge("isConcatSpreadable"),io=no>=51||!Hn((function(){var t=[];return t[oo]=!1,t.concat()[0]!==t})),ao=function(t){if(!Jn(t))return!1;var e=t[oo];return void 0!==e?!!e:$n(t)};Bn({target:"Array",proto:!0,arity:1,forced:!io||!ro("concat")},{concat:function(t){var e,r,n,o,i,a=Kn(this),s=eo(a,0),u=0;for(e=-1,n=arguments.length;e<n;e++)if(ao(i=-1===e?a:arguments[e]))for(o=Qn(i),Zn(u+o),r=0;r<o;r++,u++)r in i&&to(s,u,i[r]);else Zn(u+1),to(s,u++,i);return s.length=u,s}});var so=gn,uo=String,co=function(t){if("Symbol"===so(t))throw TypeError("Cannot convert a Symbol value to a string");return uo(t)},fo={},lo=Kr,po=Math.max,ho=Math.min,vo=function(t,e){var r=lo(t);return r<0?po(r+e,0):ho(r,e)},yo=nt,go=vo,mo=en,bo=function(t){return function(e,r,n){var o,i=yo(e),a=mo(i),s=go(n,a);if(t&&r!=r){for(;a>s;)if((o=i[s++])!=o)return!0}else for(;a>s;s++)if((t||s in i)&&i[s]===r)return t||s||0;return!t&&-1}},xo={includes:bo(!0),indexOf:bo(!1)},_o={},wo=ne,Eo=nt,To=xo.indexOf,Oo=_o,So=w([].push),ko=function(t,e){var r,n=Eo(t),o=0,i=[];for(r in n)!wo(Oo,r)&&wo(n,r)&&So(i,r);for(;e.length>o;)wo(n,r=e[o++])&&(~To(i,r)||So(i,r));return i},jo=["constructor","hasOwnProperty","isPrototypeOf","propertyIsEnumerable","toLocaleString","toString","valueOf"],Ao=ko,Po=jo,Io=Object.keys||function(t){return Ao(t,Po)},Do=R,Co=nr,Lo=rr,Ro=sr,Mo=nt,No=Io;fo.f=Do&&!Co?Object.defineProperties:function(t,e){Ro(t);for(var r,n=Mo(e),o=No(e),i=o.length,a=0;i>a;)Lo.f(t,r=o[a++],n[r]);return t};var Fo,zo=pt("document","documentElement"),Uo=ue,qo=Gt("keys"),Yo=function(t){return qo[t]||(qo[t]=Uo(t))},Wo=sr,Go=fo,Xo=jo,Vo=_o,Bo=zo,Ho=Ie,$o="prototype",Jo="script",Ko=Yo("IE_PROTO"),Qo=function(){},Zo=function(t){return"<"+Jo+">"+t+"</"+Jo+">"},ti=function(t){t.write(Zo("")),t.close();var e=t.parentWindow.Object;return t=null,e},ei=function(){try{Fo=new ActiveXObject("htmlfile")}catch(t){}var t,e,r;ei="undefined"!=typeof document?document.domain&&Fo?ti(Fo):(e=Ho("iframe"),r="java"+Jo+":",e.style.display="none",Bo.appendChild(e),e.src=String(r),(t=e.contentWindow.document).open(),t.write(Zo("document.F=Object")),t.close(),t.F):ti(Fo);for(var n=Xo.length;n--;)delete ei[$o][Xo[n]];return ei()};Vo[Ko]=!0;var ri=Object.create||function(t,e){var r;return null!==t?(Qo[$o]=Wo(t),r=new Qo,Qo[$o]=null,r[Ko]=t):r=ei(),void 0===e?r:Go.f(r,e)},ni={},oi=ko,ii=jo.concat("length","prototype");ni.f=Object.getOwnPropertyNames||function(t){return oi(t,ii)};var ai={},si=vo,ui=en,ci=un,fi=Array,li=Math.max,pi=function(t,e,r){for(var n=ui(t),o=si(e,n),i=si(void 0===r?n:r,n),a=fi(li(i-o,0)),s=0;o<i;o++,s++)ci(a,s,t[o]);return a.length=s,a},hi=S,vi=nt,di=ni.f,yi=pi,gi="object"==typeof window&&window&&Object.getOwnPropertyNames?Object.getOwnPropertyNames(window):[];ai.f=function(t){return gi&&"Window"==hi(t)?function(t){try{return di(t)}catch(t){return yi(gi)}}(t):di(vi(t))};var mi={};mi.f=Object.getOwnPropertySymbols;var bi=_r,xi=function(t,e,r,n){return n&&n.enumerable?t[e]=r:bi(t,e,r),t},_i=rr,wi=function(t,e,r){return _i.f(t,e,r)},Ei={},Ti=ge;Ei.f=Ti;var Oi,Si,ki,ji=st,Ai=ne,Pi=Ei,Ii=rr.f,Di=function(t){var e=ji.Symbol||(ji.Symbol={});Ai(e,t)||Ii(e,t,{value:Pi.f(t)})},Ci=F,Li=pt,Ri=ge,Mi=xi,Ni=function(){var t=Li("Symbol"),e=t&&t.prototype,r=e&&e.valueOf,n=Ri("toPrimitive");e&&!e[n]&&Mi(e,n,(function(t){return Ci(r,this)}),{arity:1})},Fi=gn,zi=fn?{}.toString:function(){return"[object "+Fi(this)+"]"},Ui=fn,qi=rr.f,Yi=_r,Wi=ne,Gi=zi,Xi=ge("toStringTag"),Vi=function(t,e,r,n){if(t){var o=r?t:t.prototype;Wi(o,Xi)||qi(o,Xi,{configurable:!0,value:e}),n&&!Ui&&Yi(o,"toString",Gi)}},Bi=C,Hi=f.WeakMap,$i=Bi(Hi)&&/native code/.test(String(Hi)),Ji=f,Ki=at,Qi=_r,Zi=ne,ta=Jt,ea=Yo,ra=_o,na="Object already initialized",oa=Ji.TypeError,ia=Ji.WeakMap;if($i||ta.state){var aa=ta.state||(ta.state=new ia);aa.get=aa.get,aa.has=aa.has,aa.set=aa.set,Oi=function(t,e){if(aa.has(t))throw oa(na);return e.facade=t,aa.set(t,e),e},Si=function(t){return aa.get(t)||{}},ki=function(t){return aa.has(t)}}else{var sa=ea("state");ra[sa]=!0,Oi=function(t,e){if(Zi(t,sa))throw oa(na);return e.facade=t,Qi(t,sa,e),e},Si=function(t){return Zi(t,sa)?t[sa]:{}},ki=function(t){return Zi(t,sa)}}var ua={set:Oi,get:Si,has:ki,enforce:function(t){return ki(t)?Si(t):Oi(t,{})},getterFor:function(t){return function(e){var r;if(!Ki(e)||(r=Si(e)).type!==t)throw oa("Incompatible receiver, "+t+" required");return r}}},ca=er,fa=J,la=te,pa=en,ha=Yn,va=w([].push),da=function(t){var e=1==t,r=2==t,n=3==t,o=4==t,i=6==t,a=7==t,s=5==t||i;return function(u,c,f,l){for(var p,h,v=la(u),d=fa(v),y=ca(c,f),g=pa(d),m=0,b=l||ha,x=e?b(u,g):r||a?b(u,0):void 0;g>m;m++)if((s||m in d)&&(h=y(p=d[m],m,v),t))if(e)x[m]=h;else if(h)switch(t){case 3:return!0;case 5:return p;case 6:return m;case 2:va(x,p)}else switch(t){case 4:return!1;case 7:va(x,p)}return i?-1:n||o?o:x}},ya={forEach:da(0),map:da(1),filter:da(2),some:da(3),every:da(4),find:da(5),findIndex:da(6),filterReject:da(7)},ga=Cr,ma=f,ba=F,xa=w,_a=R,wa=Tt,Ea=l,Ta=ne,Oa=ht,Sa=sr,ka=nt,ja=ke,Aa=co,Pa=X,Ia=ri,Da=Io,Ca=ni,La=ai,Ra=mi,Ma=L,Na=rr,Fa=fo,za=z,Ua=xi,qa=wi,Ya=Gt,Wa=_o,Ga=ue,Xa=ge,Va=Ei,Ba=Di,Ha=Ni,$a=Vi,Ja=ua,Ka=ya.forEach,Qa=Yo("hidden"),Za="Symbol",ts="prototype",es=Ja.set,rs=Ja.getterFor(Za),ns=Object[ts],os=ma.Symbol,is=os&&os[ts],as=ma.TypeError,ss=ma.QObject,us=Ma.f,cs=Na.f,fs=La.f,ls=za.f,ps=xa([].push),hs=Ya("symbols"),vs=Ya("op-symbols"),ds=Ya("wks"),ys=!ss||!ss[ts]||!ss[ts].findChild,gs=_a&&Ea((function(){return 7!=Ia(cs({},"a",{get:function(){return cs(this,"a",{value:7}).a}})).a}))?function(t,e,r){var n=us(ns,e);n&&delete ns[e],cs(t,e,r),n&&t!==ns&&cs(ns,e,n)}:cs,ms=function(t,e){var r=hs[t]=Ia(is);return es(r,{type:Za,tag:t,description:e}),_a||(r.description=e),r},bs=function(t,e,r){t===ns&&bs(vs,e,r),Sa(t);var n=ja(e);return Sa(r),Ta(hs,n)?(r.enumerable?(Ta(t,Qa)&&t[Qa][n]&&(t[Qa][n]=!1),r=Ia(r,{enumerable:Pa(0,!1)})):(Ta(t,Qa)||cs(t,Qa,Pa(1,{})),t[Qa][n]=!0),gs(t,n,r)):cs(t,n,r)},xs=function(t,e){Sa(t);var r=ka(e),n=Da(r).concat(Ts(r));return Ka(n,(function(e){_a&&!ba(_s,r,e)||bs(t,e,r[e])})),t},_s=function(t){var e=ja(t),r=ba(ls,this,e);return!(this===ns&&Ta(hs,e)&&!Ta(vs,e))&&(!(r||!Ta(this,e)||!Ta(hs,e)||Ta(this,Qa)&&this[Qa][e])||r)},ws=function(t,e){var r=ka(t),n=ja(e);if(r!==ns||!Ta(hs,n)||Ta(vs,n)){var o=us(r,n);return!o||!Ta(hs,n)||Ta(r,Qa)&&r[Qa][n]||(o.enumerable=!0),o}},Es=function(t){var e=fs(ka(t)),r=[];return Ka(e,(function(t){Ta(hs,t)||Ta(Wa,t)||ps(r,t)})),r},Ts=function(t){var e=t===ns,r=fs(e?vs:ka(t)),n=[];return Ka(r,(function(t){!Ta(hs,t)||e&&!Ta(ns,t)||ps(n,hs[t])})),n};wa||(Ua(is=(os=function(){if(Oa(is,this))throw as("Symbol is not a constructor");var t=arguments.length&&void 0!==arguments[0]?Aa(arguments[0]):void 0,e=Ga(t),r=function(t){this===ns&&ba(r,vs,t),Ta(this,Qa)&&Ta(this[Qa],e)&&(this[Qa][e]=!1),gs(this,e,Pa(1,t))};return _a&&ys&&gs(ns,e,{configurable:!0,set:r}),ms(e,t)})[ts],"toString",(function(){return rs(this).tag})),Ua(os,"withoutSetter",(function(t){return ms(Ga(t),t)})),za.f=_s,Na.f=bs,Fa.f=xs,Ma.f=ws,Ca.f=La.f=Es,Ra.f=Ts,Va.f=function(t){return ms(Xa(t),t)},_a&&qa(is,"description",{configurable:!0,get:function(){return rs(this).description}})),ga({global:!0,constructor:!0,wrap:!0,forced:!wa,sham:!wa},{Symbol:os}),Ka(Da(ds),(function(t){Ba(t)})),ga({target:Za,stat:!0,forced:!wa},{useSetter:function(){ys=!0},useSimple:function(){ys=!1}}),ga({target:"Object",stat:!0,forced:!wa,sham:!_a},{create:function(t,e){return void 0===e?Ia(t):xs(Ia(t),e)},defineProperty:bs,defineProperties:xs,getOwnPropertyDescriptor:ws}),ga({target:"Object",stat:!0,forced:!wa},{getOwnPropertyNames:Es}),Ha(),$a(os,Za),Wa[Qa]=!0;var Os=Tt&&!!Symbol.for&&!!Symbol.keyFor,Ss=Cr,ks=pt,js=ne,As=co,Ps=Gt,Is=Os,Ds=Ps("string-to-symbol-registry"),Cs=Ps("symbol-to-string-registry");Ss({target:"Symbol",stat:!0,forced:!Is},{for:function(t){var e=As(t);if(js(Ds,e))return Ds[e];var r=ks("Symbol")(e);return Ds[e]=r,Cs[r]=e,r}});var Ls=Cr,Rs=ne,Ms=Pt,Ns=Dt,Fs=Os,zs=Gt("symbol-to-string-registry");Ls({target:"Symbol",stat:!0,forced:!Fs},{keyFor:function(t){if(!Ms(t))throw TypeError(Ns(t)+" is not a symbol");if(Rs(zs,t))return zs[t]}});var Us=w([].slice),qs=Br,Ys=C,Ws=S,Gs=co,Xs=w([].push),Vs=Cr,Bs=pt,Hs=g,$s=F,Js=w,Ks=l,Qs=C,Zs=Pt,tu=Us,eu=function(t){if(Ys(t))return t;if(qs(t)){for(var e=t.length,r=[],n=0;n<e;n++){var o=t[n];"string"==typeof o?Xs(r,o):"number"!=typeof o&&"Number"!=Ws(o)&&"String"!=Ws(o)||Xs(r,Gs(o))}var i=r.length,a=!0;return function(t,e){if(a)return a=!1,e;if(qs(this))return e;for(var n=0;n<i;n++)if(r[n]===t)return e}}},ru=Tt,nu=String,ou=Bs("JSON","stringify"),iu=Js(/./.exec),au=Js("".charAt),su=Js("".charCodeAt),uu=Js("".replace),cu=Js(1..toString),fu=/[\uD800-\uDFFF]/g,lu=/^[\uD800-\uDBFF]$/,pu=/^[\uDC00-\uDFFF]$/,hu=!ru||Ks((function(){var t=Bs("Symbol")();return"[null]"!=ou([t])||"{}"!=ou({a:t})||"{}"!=ou(Object(t))})),vu=Ks((function(){return'"\\udf06\\ud834"'!==ou("\udf06\ud834")||'"\\udead"'!==ou("\udead")})),du=function(t,e){var r=tu(arguments),n=eu(e);if(Qs(n)||void 0!==t&&!Zs(t))return r[1]=function(t,e){if(Qs(n)&&(e=$s(n,this,nu(t),e)),!Zs(e))return e},Hs(ou,null,r)},yu=function(t,e,r){var n=au(r,e-1),o=au(r,e+1);return iu(lu,t)&&!iu(pu,o)||iu(pu,t)&&!iu(lu,n)?"\\u"+cu(su(t,0),16):t};ou&&Vs({target:"JSON",stat:!0,arity:3,forced:hu||vu},{stringify:function(t,e,r){var n=tu(arguments),o=Hs(hu?du:ou,null,n);return vu&&"string"==typeof o?uu(o,fu,yu):o}});var gu=mi,mu=te;Cr({target:"Object",stat:!0,forced:!Tt||l((function(){gu.f(1)}))},{getOwnPropertySymbols:function(t){var e=gu.f;return e?e(mu(t)):[]}}),Di("asyncIterator"),Di("hasInstance"),Di("isConcatSpreadable"),Di("iterator"),Di("match"),Di("matchAll"),Di("replace"),Di("search"),Di("species"),Di("split");var bu=Ni;Di("toPrimitive"),bu();var xu=pt,_u=Vi;Di("toStringTag"),_u(xu("Symbol"),"Symbol"),Di("unscopables"),Vi(f.JSON,"JSON",!0);var wu,Eu,Tu,Ou=st.Symbol,Su={},ku=R,ju=ne,Au=Function.prototype,Pu=ku&&Object.getOwnPropertyDescriptor,Iu=ju(Au,"name"),Du={EXISTS:Iu,PROPER:Iu&&"something"===function(){}.name,CONFIGURABLE:Iu&&(!ku||ku&&Pu(Au,"name").configurable)},Cu=!l((function(){function t(){}return t.prototype.constructor=null,Object.getPrototypeOf(new t)!==t.prototype})),Lu=ne,Ru=C,Mu=te,Nu=Cu,Fu=Yo("IE_PROTO"),zu=Object,Uu=zu.prototype,qu=Nu?zu.getPrototypeOf:function(t){var e=Mu(t);if(Lu(e,Fu))return e[Fu];var r=e.constructor;return Ru(r)&&e instanceof r?r.prototype:e instanceof zu?Uu:null},Yu=l,Wu=C,Gu=at,Xu=ri,Vu=qu,Bu=xi,Hu=ge("iterator"),$u=!1;[].keys&&("next"in(Tu=[].keys())?(Eu=Vu(Vu(Tu)))!==Object.prototype&&(wu=Eu):$u=!0);var Ju=!Gu(wu)||Yu((function(){var t={};return wu[Hu].call(t)!==t}));Wu((wu=Ju?{}:Xu(wu))[Hu])||Bu(wu,Hu,(function(){return this}));var Ku={IteratorPrototype:wu,BUGGY_SAFARI_ITERATORS:$u},Qu=Ku.IteratorPrototype,Zu=ri,tc=X,ec=Vi,rc=Su,nc=function(){return this},oc=w,ic=Mt,ac=C,sc=String,uc=TypeError,cc=function(t,e,r){try{return oc(ic(Object.getOwnPropertyDescriptor(t,e)[r]))}catch(t){}},fc=sr,lc=function(t){if("object"==typeof t||ac(t))return t;throw uc("Can't set "+sc(t)+" as a prototype")},pc=Object.setPrototypeOf||("__proto__"in{}?function(){var t,e=!1,r={};try{(t=cc(Object.prototype,"__proto__","set"))(r,[]),e=r instanceof Array}catch(t){}return function(r,n){return fc(r),lc(n),e?t(r,n):r.__proto__=n,r}}():void 0),hc=Cr,vc=F,dc=function(t,e,r,n){var o=e+" Iterator";return t.prototype=Zu(Qu,{next:tc(+!n,r)}),ec(t,o,!1,!0),rc[o]=nc,t},yc=qu,gc=Vi,mc=xi,bc=Su,xc=Du.PROPER,_c=Ku.BUGGY_SAFARI_ITERATORS,wc=ge("iterator"),Ec="keys",Tc="values",Oc="entries",Sc=function(){return this},kc=function(t,e,r,n,o,i,a){dc(r,e,n);var s,u,c,f=function(t){if(t===o&&d)return d;if(!_c&&t in h)return h[t];switch(t){case Ec:case Tc:case Oc:return function(){return new r(this,t)}}return function(){return new r(this)}},l=e+" Iterator",p=!1,h=t.prototype,v=h[wc]||h["@@iterator"]||o&&h[o],d=!_c&&v||f(o),y="Array"==e&&h.entries||v;if(y&&(s=yc(y.call(new t)))!==Object.prototype&&s.next&&(gc(s,l,!0,!0),bc[l]=Sc),xc&&o==Tc&&v&&v.name!==Tc&&(p=!0,d=function(){return vc(v,this)}),o)if(u={values:f(Tc),keys:i?d:f(Ec),entries:f(Oc)},a)for(c in u)(_c||p||!(c in h))&&mc(h,c,u[c]);else hc({target:e,proto:!0,forced:_c||p},u);return a&&h[wc]!==d&&mc(h,wc,d,{name:o}),bc[e]=d,u},jc=function(t,e){return{value:t,done:e}},Ac=nt,Pc=Su,Ic=ua;rr.f;var Dc=kc,Cc=jc,Lc="Array Iterator",Rc=Ic.set,Mc=Ic.getterFor(Lc);Dc(Array,"Array",(function(t,e){Rc(this,{type:Lc,target:Ac(t),index:0,kind:e})}),(function(){var t=Mc(this),e=t.target,r=t.kind,n=t.index++;return!e||n>=e.length?(t.target=void 0,Cc(void 0,!0)):Cc("keys"==r?n:"values"==r?e[n]:[n,e[n]],!1)}),"values"),Pc.Arguments=Pc.Array;var Nc={CSSRuleList:0,CSSStyleDeclaration:0,CSSValueList:0,ClientRectList:0,DOMRectList:0,DOMStringList:0,DOMTokenList:1,DataTransferItemList:0,FileList:0,HTMLAllCollection:0,HTMLCollection:0,HTMLFormElement:0,HTMLSelectElement:0,MediaList:0,MimeTypeArray:0,NamedNodeMap:0,NodeList:1,PaintRequestList:0,Plugin:0,PluginArray:0,SVGLengthList:0,SVGNumberList:0,SVGPathSegList:0,SVGPointList:0,SVGStringList:0,SVGTransformList:0,SourceBufferList:0,StyleSheetList:0,TextTrackCueList:0,TextTrackList:0,TouchList:0},Fc=f,zc=gn,Uc=_r,qc=Su,Yc=ge("toStringTag");for(var Wc in Nc){var Gc=Fc[Wc],Xc=Gc&&Gc.prototype;Xc&&zc(Xc)!==Yc&&Uc(Xc,Yc,Wc),qc[Wc]=qc.Array}var Vc=Ou;Di("dispose");var Bc=Vc;Di("asyncDispose");var Hc=Cr,$c=w,Jc=pt("Symbol"),Kc=Jc.keyFor,Qc=$c(Jc.prototype.valueOf);Hc({target:"Symbol",stat:!0},{isRegistered:function(t){try{return void 0!==Kc(Qc(t))}catch(t){return!1}}});for(var Zc=Cr,tf=Gt,ef=pt,rf=w,nf=Pt,of=ge,af=ef("Symbol"),sf=af.isWellKnown,uf=ef("Object","getOwnPropertyNames"),cf=rf(af.prototype.valueOf),ff=tf("wks"),lf=0,pf=uf(af),hf=pf.length;lf<hf;lf++)try{var vf=pf[lf];nf(af[vf])&&of(vf)}catch(t){}Zc({target:"Symbol",stat:!0,forced:!0},{isWellKnown:function(t){if(sf&&sf(t))return!0;try{for(var e=cf(t),r=0,n=uf(ff),o=n.length;r<o;r++)if(ff[n[r]]==e)return!0}catch(t){}return!1}}),Di("matcher"),Di("metadataKey"),Di("observable"),Di("metadata"),Di("patternMatch"),Di("replaceAll");var df=Bc;Xr.exports=df,Wr.exports=Gr;var yf=r(Yr),gf={},mf={get exports(){return gf},set exports(t){gf=t}},bf={},xf={get exports(){return bf},set exports(t){bf=t}},_f=w,wf=Kr,Ef=co,Tf=tt,Of=_f("".charAt),Sf=_f("".charCodeAt),kf=_f("".slice),jf=function(t){return function(e,r){var n,o,i=Ef(Tf(e)),a=wf(r),s=i.length;return a<0||a>=s?t?"":void 0:(n=Sf(i,a))<55296||n>56319||a+1===s||(o=Sf(i,a+1))<56320||o>57343?t?Of(i,a):n:t?kf(i,a,a+2):o-56320+(n-55296<<10)+65536}},Af={codeAt:jf(!1),charAt:jf(!0)}.charAt,Pf=co,If=ua,Df=kc,Cf=jc,Lf="String Iterator",Rf=If.set,Mf=If.getterFor(Lf);Df(String,"String",(function(t){Rf(this,{type:Lf,string:Pf(t),index:0})}),(function(){var t,e=Mf(this),r=e.string,n=e.index;return n>=r.length?Cf(void 0,!0):(t=Af(r,n),e.index+=t.length,Cf(t,!1))}));var Nf=Ei.f("iterator"),Ff=Nf;xf.exports=Ff,mf.exports=bf;var zf=r(gf);function Uf(t){return Uf="function"==typeof yf&&"symbol"==typeof zf?function(t){return typeof t}:function(t){return t&&"function"==typeof yf&&t.constructor===yf&&t!==yf.prototype?"symbol":typeof t},Uf(t)}var qf={},Yf={get exports(){return qf},set exports(t){qf=t}},Wf={},Gf={get exports(){return Wf},set exports(t){Wf=t}},Xf=Ei.f("toPrimitive");Gf.exports=Xf,Yf.exports=Wf;var Vf=r(qf);function Bf(t){var e=function(t,e){if("object"!==Uf(t)||null===t)return t;var r=t[Vf];if(void 0!==r){var n=r.call(t,e||"default");if("object"!==Uf(n))return n;throw new TypeError("@@toPrimitive must return a primitive value.")}return("string"===e?String:Number)(t)}(t,"string");return"symbol"===Uf(e)?e:String(e)}function Hf(t,e){for(var r=0;r<e.length;r++){var n=e[r];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),qr(t,Bf(n.key),n)}}function $f(t,e,r){return e&&Hf(t.prototype,e),r&&Hf(t,r),qr(t,"prototype",{writable:!1}),t}function Jf(t,e,r){return(e=Bf(e))in t?qr(t,e,{value:r,enumerable:!0,configurable:!0,writable:!0}):t[e]=r,t}var Kf={},Qf={get exports(){return Kf},set exports(t){Kf=t}},Zf=w,tl=Mt,el=at,rl=ne,nl=Us,ol=p,il=Function,al=Zf([].concat),sl=Zf([].join),ul={},cl=function(t,e,r){if(!rl(ul,e)){for(var n=[],o=0;o<e;o++)n[o]="a["+o+"]";ul[e]=il("C,a","return new C("+sl(n,",")+")")}return ul[e](t,r)},fl=ol?il.bind:function(t){var e=tl(this),r=e.prototype,n=nl(arguments,1),o=function(){var r=al(n,nl(arguments));return this instanceof o?cl(e,r.length,r):e.apply(t,r)};return el(r)&&(o.prototype=r),o},ll=fl;Cr({target:"Function",proto:!0,forced:Function.bind!==ll},{bind:ll});var pl=st,hl=function(t){return pl[t+"Prototype"]},vl=hl("Function").bind,dl=ht,yl=vl,gl=Function.prototype,ml=function(t){var e=t.bind;return t===gl||dl(gl,t)&&e===gl.bind?yl:e};Qf.exports=ml;var bl=r(Kf),xl={},_l={get exports(){return xl},set exports(t){xl=t}},wl=Mt,El=te,Tl=J,Ol=en,Sl=TypeError,kl=function(t){return function(e,r,n,o){wl(r);var i=El(e),a=Tl(i),s=Ol(i),u=t?s-1:0,c=t?-1:1;if(n<2)for(;;){if(u in a){o=a[u],u+=c;break}if(u+=c,t?u<0:s<=u)throw Sl("Reduce of empty array with no initial value")}for(;t?u>=0:s>u;u+=c)u in a&&(o=r(o,a[u],u,i));return o}},jl={left:kl(!1),right:kl(!0)},Al=l,Pl=function(t,e){var r=[][t];return!!r&&Al((function(){r.call(null,e||function(){return 1},1)}))},Il="undefined"!=typeof process&&"process"==S(process),Dl=jl.left;Cr({target:"Array",proto:!0,forced:!Il&&_t>79&&_t<83||!Pl("reduce")},{reduce:function(t){var e=arguments.length;return Dl(this,t,e,e>1?arguments[1]:void 0)}});var Cl=hl("Array").reduce,Ll=ht,Rl=Cl,Ml=Array.prototype,Nl=function(t){var e=t.reduce;return t===Ml||Ll(Ml,t)&&e===Ml.reduce?Rl:e};_l.exports=Nl;var Fl=r(xl),zl={},Ul={get exports(){return zl},set exports(t){zl=t}},ql=ya.filter;Cr({target:"Array",proto:!0,forced:!Vn("filter")},{filter:function(t){return ql(this,t,arguments.length>1?arguments[1]:void 0)}});var Yl=hl("Array").filter,Wl=ht,Gl=Yl,Xl=Array.prototype,Vl=function(t){var e=t.filter;return t===Xl||Wl(Xl,t)&&e===Xl.filter?Gl:e};Ul.exports=Vl;var Bl=r(zl),Hl={},$l={get exports(){return Hl},set exports(t){Hl=t}},Jl=ya.map;Cr({target:"Array",proto:!0,forced:!Vn("map")},{map:function(t){return Jl(this,t,arguments.length>1?arguments[1]:void 0)}});var Kl=hl("Array").map,Ql=ht,Zl=Kl,tp=Array.prototype,ep=function(t){var e=t.map;return t===tp||Ql(tp,t)&&e===tp.map?Zl:e};$l.exports=ep;var rp=r(Hl),np={},op={get exports(){return np},set exports(t){np=t}},ip=Br,ap=en,sp=nn,up=er,cp=function(t,e,r,n,o,i,a,s){for(var u,c,f=o,l=0,p=!!a&&up(a,s);l<n;)l in r&&(u=p?p(r[l],l,e):r[l],i>0&&ip(u)?(c=ap(u),f=cp(t,e,u,c,f,i-1)-1):(sp(f+1),t[f]=u),f++),l++;return f},fp=cp,lp=Mt,pp=te,hp=en,vp=Yn;Cr({target:"Array",proto:!0},{flatMap:function(t){var e,r=pp(this),n=hp(r);return lp(t),(e=vp(r,0)).length=fp(e,r,r,n,0,1,t,arguments.length>1?arguments[1]:void 0),e}});var dp=hl("Array").flatMap,yp=ht,gp=dp,mp=Array.prototype,bp=function(t){var e=t.flatMap;return t===mp||yp(mp,t)&&e===mp.flatMap?gp:e};op.exports=bp;var xp=r(np);function _p(t){return new Ep(t)}var wp=function(){function e(r,n,o){var i,a,s;t(this,e),Jf(this,"_source",void 0),Jf(this,"_transformers",void 0),Jf(this,"_target",void 0),Jf(this,"_listeners",{add:bl(i=this._add).call(i,this),remove:bl(a=this._remove).call(a,this),update:bl(s=this._update).call(s,this)}),this._source=r,this._transformers=n,this._target=o}return $f(e,[{key:"all",value:function(){return this._target.update(this._transformItems(this._source.get())),this}},{key:"start",value:function(){return this._source.on("add",this._listeners.add),this._source.on("remove",this._listeners.remove),this._source.on("update",this._listeners.update),this}},{key:"stop",value:function(){return this._source.off("add",this._listeners.add),this._source.off("remove",this._listeners.remove),this._source.off("update",this._listeners.update),this}},{key:"_transformItems",value:function(t){var e;return Fl(e=this._transformers).call(e,(function(t,e){return e(t)}),t)}},{key:"_add",value:function(t,e){null!=e&&this._target.add(this._transformItems(this._source.get(e.items)))}},{key:"_update",value:function(t,e){null!=e&&this._target.update(this._transformItems(this._source.get(e.items)))}},{key:"_remove",value:function(t,e){null!=e&&this._target.remove(this._transformItems(e.oldData))}}]),e}(),Ep=function(){function e(r){t(this,e),Jf(this,"_source",void 0),Jf(this,"_transformers",[]),this._source=r}return $f(e,[{key:"filter",value:function(t){return this._transformers.push((function(e){return Bl(e).call(e,t)})),this}},{key:"map",value:function(t){return this._transformers.push((function(e){return rp(e).call(e,t)})),this}},{key:"flatMap",value:function(t){return this._transformers.push((function(e){return xp(e).call(e,t)})),this}},{key:"to",value:function(t){return new wp(this._source,this._transformers,t)}}]),e}(),Tp={},Op={get exports(){return Tp},set exports(t){Tp=t}},Sp=F,kp=sr,jp=zt,Ap=function(t,e,r){var n,o;kp(t);try{if(!(n=jp(t,"return"))){if("throw"===e)throw r;return r}n=Sp(n,t)}catch(t){o=!0,n=t}if("throw"===e)throw r;if(o)throw n;return kp(n),r},Pp=sr,Ip=Ap,Dp=Su,Cp=ge("iterator"),Lp=Array.prototype,Rp=function(t){return void 0!==t&&(Dp.Array===t||Lp[Cp]===t)},Mp=gn,Np=zt,Fp=K,zp=Su,Up=ge("iterator"),qp=function(t){if(!Fp(t))return Np(t,Up)||Np(t,"@@iterator")||zp[Mp(t)]},Yp=F,Wp=Mt,Gp=sr,Xp=Dt,Vp=qp,Bp=TypeError,Hp=function(t,e){var r=arguments.length<2?Vp(t):e;if(Wp(r))return Gp(Yp(r,t));throw Bp(Xp(t)+" is not iterable")},$p=er,Jp=F,Kp=te,Qp=function(t,e,r,n){try{return n?e(Pp(r)[0],r[1]):e(r)}catch(e){Ip(t,"throw",e)}},Zp=Rp,th=Rn,eh=en,rh=un,nh=Hp,oh=qp,ih=Array,ah=ge("iterator"),sh=!1;try{var uh=0,ch={next:function(){return{done:!!uh++}},return:function(){sh=!0}};ch[ah]=function(){return this},Array.from(ch,(function(){throw 2}))}catch(t){}var fh=function(t,e){if(!e&&!sh)return!1;var r=!1;try{var n={};n[ah]=function(){return{next:function(){return{done:r=!0}}}},t(n)}catch(t){}return r},lh=function(t){var e=Kp(t),r=th(this),n=arguments.length,o=n>1?arguments[1]:void 0,i=void 0!==o;i&&(o=$p(o,n>2?arguments[2]:void 0));var a,s,u,c,f,l,p=oh(e),h=0;if(!p||this===ih&&Zp(p))for(a=eh(e),s=r?new this(a):ih(a);a>h;h++)l=i?o(e[h],h):e[h],rh(s,h,l);else for(f=(c=nh(e,p)).next,s=r?new this:[];!(u=Jp(f,c)).done;h++)l=i?Qp(c,o,[u.value,h],!0):u.value,rh(s,h,l);return s.length=h,s};Cr({target:"Array",stat:!0,forced:!fh((function(t){Array.from(t)}))},{from:lh});var ph=st.Array.from;Op.exports=ph;var hh=r(Tp),vh={},dh={get exports(){return vh},set exports(t){vh=t}},yh={},gh=qp;({get exports(){return yh},set exports(t){yh=t}}).exports=gh,dh.exports=yh;var mh=r(vh),bh={},xh={get exports(){return bh},set exports(t){bh=t}},_h=st.Object.getOwnPropertySymbols;xh.exports=_h;var wh=r(bh),Eh={},Th={get exports(){return Eh},set exports(t){Eh=t}},Oh={},Sh={get exports(){return Oh},set exports(t){Oh=t}},kh=Cr,jh=l,Ah=nt,Ph=L.f,Ih=R;kh({target:"Object",stat:!0,forced:!Ih||jh((function(){Ph(1)})),sham:!Ih},{getOwnPropertyDescriptor:function(t,e){return Ph(Ah(t),e)}});var Dh=st.Object,Ch=Sh.exports=function(t,e){return Dh.getOwnPropertyDescriptor(t,e)};Dh.getOwnPropertyDescriptor.sham&&(Ch.sham=!0);var Lh=Oh;Th.exports=Lh;var Rh=r(Eh),Mh={},Nh={get exports(){return Mh},set exports(t){Mh=t}},Fh=pt,zh=ni,Uh=mi,qh=sr,Yh=w([].concat),Wh=Fh("Reflect","ownKeys")||function(t){var e=zh.f(qh(t)),r=Uh.f;return r?Yh(e,r(t)):e},Gh=Wh,Xh=nt,Vh=L,Bh=un;Cr({target:"Object",stat:!0,sham:!R},{getOwnPropertyDescriptors:function(t){for(var e,r,n=Xh(t),o=Vh.f,i=Gh(n),a={},s=0;i.length>s;)void 0!==(r=o(n,e=i[s++]))&&Bh(a,e,r);return a}});var Hh=st.Object.getOwnPropertyDescriptors;Nh.exports=Hh;var $h=r(Mh),Jh={},Kh={get exports(){return Jh},set exports(t){Jh=t}},Qh={},Zh={get exports(){return Qh},set exports(t){Qh=t}},tv=Cr,ev=R,rv=fo.f;tv({target:"Object",stat:!0,forced:Object.defineProperties!==rv,sham:!ev},{defineProperties:rv});var nv=st.Object,ov=Zh.exports=function(t,e){return nv.defineProperties(t,e)};nv.defineProperties.sham&&(ov.sham=!0);var iv=Qh;Kh.exports=iv;var av=r(Jh),sv={};({get exports(){return sv},set exports(t){sv=t}}).exports=zr;var uv=r(sv),cv={},fv={get exports(){return cv},set exports(t){cv=t}},lv={},pv={get exports(){return lv},set exports(t){lv=t}};Cr({target:"Array",stat:!0},{isArray:Br});var hv=st.Array.isArray,vv=hv;pv.exports=vv,fv.exports=lv;var dv=r(cv);var yv={},gv={get exports(){return yv},set exports(t){yv=t}},mv={},bv={get exports(){return mv},set exports(t){mv=t}},xv=Cr,_v=Br,wv=Rn,Ev=at,Tv=vo,Ov=en,Sv=nt,kv=un,jv=ge,Av=Us,Pv=Vn("slice"),Iv=jv("species"),Dv=Array,Cv=Math.max;xv({target:"Array",proto:!0,forced:!Pv},{slice:function(t,e){var r,n,o,i=Sv(this),a=Ov(i),s=Tv(t,a),u=Tv(void 0===e?a:e,a);if(_v(i)&&(r=i.constructor,(wv(r)&&(r===Dv||_v(r.prototype))||Ev(r)&&null===(r=r[Iv]))&&(r=void 0),r===Dv||void 0===r))return Av(i,s,u);for(n=new(void 0===r?Dv:r)(Cv(u-s,0)),o=0;s<u;s++,o++)s in i&&kv(n,o,i[s]);return n.length=o,n}});var Lv=hl("Array").slice,Rv=ht,Mv=Lv,Nv=Array.prototype,Fv=function(t){var e=t.slice;return t===Nv||Rv(Nv,t)&&e===Nv.slice?Mv:e},zv=Fv;bv.exports=zv,gv.exports=mv;var Uv=r(yv),qv={},Yv={get exports(){return qv},set exports(t){qv=t}},Wv={},Gv=ph;({get exports(){return Wv},set exports(t){Wv=t}}).exports=Gv,Yv.exports=Wv;var Xv=r(qv);function Vv(t,e){(null==e||e>t.length)&&(e=t.length);for(var r=0,n=new Array(e);r<e;r++)n[r]=t[r];return n}function Bv(t,e){var r;if(t){if("string"==typeof t)return Vv(t,e);var n=Uv(r=Object.prototype.toString.call(t)).call(r,8,-1);return"Object"===n&&t.constructor&&(n=t.constructor.name),"Map"===n||"Set"===n?Xv(t):"Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)?Vv(t,e):void 0}}function Hv(t,e){return function(t){if(dv(t))return t}(t)||function(t,e){var r=null==t?null:void 0!==yf&&mh(t)||t["@@iterator"];if(null!=r){var n,o,i,a,s=[],u=!0,c=!1;try{if(i=(r=r.call(t)).next,0===e){if(Object(r)!==r)return;u=!1}else for(;!(u=(n=i.call(r)).done)&&(s.push(n.value),s.length!==e);u=!0);}catch(t){c=!0,o=t}finally{try{if(!u&&null!=r.return&&(a=r.return(),Object(a)!==a))return}finally{if(c)throw o}}return s}}(t,e)||Bv(t,e)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function $v(t){return function(t){if(dv(t))return Vv(t)}(t)||function(t){if(void 0!==yf&&null!=mh(t)||null!=t["@@iterator"])return Xv(t)}(t)||Bv(t)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var Jv={};({get exports(){return Jv},set exports(t){Jv=t}}).exports=Vc;var Kv=r(Jv),Qv={},Zv={get exports(){return Qv},set exports(t){Qv=t}},td=hl("Array").concat,ed=ht,rd=td,nd=Array.prototype,od=function(t){var e=t.concat;return t===nd||ed(nd,t)&&e===nd.concat?rd:e};Zv.exports=od;var id=r(Qv),ad={};({get exports(){return ad},set exports(t){ad=t}}).exports=Fv;var sd=r(ad),ud={},cd={get exports(){return ud},set exports(t){ud=t}};Cr({target:"Reflect",stat:!0},{ownKeys:Wh});var fd=st.Reflect.ownKeys;cd.exports=fd;var ld=r(ud),pd={};({get exports(){return pd},set exports(t){pd=t}}).exports=hv;var hd=r(pd),vd={},dd={get exports(){return vd},set exports(t){vd=t}},yd=te,gd=Io;Cr({target:"Object",stat:!0,forced:l((function(){gd(1)}))},{keys:function(t){return gd(yd(t))}});var md=st.Object.keys;dd.exports=md;var bd=r(vd),xd={},_d={get exports(){return xd},set exports(t){xd=t}},wd=Cr,Ed=Date,Td=w(Ed.prototype.getTime);wd({target:"Date",stat:!0},{now:function(){return Td(new Ed)}});var Od=st.Date.now;_d.exports=Od;var Sd={},kd={get exports(){return Sd},set exports(t){Sd=t}},jd=ya.forEach,Ad=Pl("forEach")?[].forEach:function(t){return jd(this,t,arguments.length>1?arguments[1]:void 0)};Cr({target:"Array",proto:!0,forced:[].forEach!=Ad},{forEach:Ad});var Pd=hl("Array").forEach,Id=gn,Dd=ne,Cd=ht,Ld=Pd,Rd=Array.prototype,Md={DOMTokenList:!0,NodeList:!0},Nd=function(t){var e=t.forEach;return t===Rd||Cd(Rd,t)&&e===Rd.forEach||Dd(Md,Id(t))?Ld:e};kd.exports=Nd;var Fd=r(Sd),zd={},Ud={get exports(){return zd},set exports(t){zd=t}},qd=Cr,Yd=Br,Wd=w([].reverse),Gd=[1,2];qd({target:"Array",proto:!0,forced:String(Gd)===String(Gd.reverse())},{reverse:function(){return Yd(this)&&(this.length=this.length),Wd(this)}});var Xd=hl("Array").reverse,Vd=ht,Bd=Xd,Hd=Array.prototype,$d=function(t){var e=t.reverse;return t===Hd||Vd(Hd,t)&&e===Hd.reverse?Bd:e};Ud.exports=$d;var Jd=r(zd),Kd={},Qd={get exports(){return Kd},set exports(t){Kd=t}},Zd=R,ty=Br,ey=TypeError,ry=Object.getOwnPropertyDescriptor,ny=Zd&&!function(){if(void 0!==this)return!0;try{Object.defineProperty([],"length",{writable:!1}).length=1}catch(t){return t instanceof TypeError}}(),oy=Dt,iy=TypeError,ay=function(t,e){if(!delete t[e])throw iy("Cannot delete property "+oy(e)+" of "+oy(t))},sy=Cr,uy=te,cy=vo,fy=Kr,ly=en,py=ny?function(t,e){if(ty(t)&&!ry(t,"length").writable)throw ey("Cannot set read only .length");return t.length=e}:function(t,e){return t.length=e},hy=nn,vy=Yn,dy=un,yy=ay,gy=Vn("splice"),my=Math.max,by=Math.min;sy({target:"Array",proto:!0,forced:!gy},{splice:function(t,e){var r,n,o,i,a,s,u=uy(this),c=ly(u),f=cy(t,c),l=arguments.length;for(0===l?r=n=0:1===l?(r=0,n=c-f):(r=l-2,n=by(my(fy(e),0),c-f)),hy(c+r-n),o=vy(u,n),i=0;i<n;i++)(a=f+i)in u&&dy(o,i,u[a]);if(o.length=n,r<n){for(i=f;i<c-n;i++)s=i+r,(a=i+n)in u?u[s]=u[a]:yy(u,s);for(i=c;i>c-n+r;i--)yy(u,i-1)}else if(r>n)for(i=c-n;i>f;i--)s=i+r-1,(a=i+n-1)in u?u[s]=u[a]:yy(u,s);for(i=0;i<r;i++)u[i+f]=arguments[i+2];return py(u,c-n+r),o}});var xy=hl("Array").splice,_y=ht,wy=xy,Ey=Array.prototype,Ty=function(t){var e=t.splice;return t===Ey||_y(Ey,t)&&e===Ey.splice?wy:e};Qd.exports=Ty;var Oy=r(Kd),Sy={},ky={get exports(){return Sy},set exports(t){Sy=t}},jy=R,Ay=w,Py=F,Iy=l,Dy=Io,Cy=mi,Ly=z,Ry=te,My=J,Ny=Object.assign,Fy=Object.defineProperty,zy=Ay([].concat),Uy=!Ny||Iy((function(){if(jy&&1!==Ny({b:1},Ny(Fy({},"a",{enumerable:!0,get:function(){Fy(this,"b",{value:3,enumerable:!1})}}),{b:2})).b)return!0;var t={},e={},r=Symbol(),n="abcdefghijklmnopqrst";return t[r]=7,n.split("").forEach((function(t){e[t]=t})),7!=Ny({},t)[r]||Dy(Ny({},e)).join("")!=n}))?function(t,e){for(var r=Ry(t),n=arguments.length,o=1,i=Cy.f,a=Ly.f;n>o;)for(var s,u=My(arguments[o++]),c=i?zy(Dy(u),i(u)):Dy(u),f=c.length,l=0;f>l;)s=c[l++],jy&&!Py(a,u,s)||(r[s]=u[s]);return r}:Ny,qy=Uy;Cr({target:"Object",stat:!0,arity:2,forced:Object.assign!==qy},{assign:qy});var Yy=st.Object.assign;ky.exports=Yy;var Wy=r(Sy),Gy={},Xy={get exports(){return Gy},set exports(t){Gy=t}},Vy=xo.includes;Cr({target:"Array",proto:!0,forced:l((function(){return!Array(1).includes()}))},{includes:function(t){return Vy(this,t,arguments.length>1?arguments[1]:void 0)}});var By=hl("Array").includes,Hy=at,$y=S,Jy=ge("match"),Ky=function(t){var e;return Hy(t)&&(void 0!==(e=t[Jy])?!!e:"RegExp"==$y(t))},Qy=TypeError,Zy=ge("match"),tg=Cr,eg=function(t){if(Ky(t))throw Qy("The method doesn't accept regular expressions");return t},rg=tt,ng=co,og=function(t){var e=/./;try{"/./"[t](e)}catch(r){try{return e[Zy]=!1,"/./"[t](e)}catch(t){}}return!1},ig=w("".indexOf);tg({target:"String",proto:!0,forced:!og("includes")},{includes:function(t){return!!~ig(ng(rg(this)),ng(eg(t)),arguments.length>1?arguments[1]:void 0)}});var ag=hl("String").includes,sg=ht,ug=By,cg=ag,fg=Array.prototype,lg=String.prototype,pg=function(t){var e=t.includes;return t===fg||sg(fg,t)&&e===fg.includes?ug:"string"==typeof t||t===lg||sg(lg,t)&&e===lg.includes?cg:e};Xy.exports=pg;var hg={},vg={get exports(){return hg},set exports(t){hg=t}},dg=te,yg=qu,gg=Cu;Cr({target:"Object",stat:!0,forced:l((function(){yg(1)})),sham:!gg},{getPrototypeOf:function(t){return yg(dg(t))}});var mg=st.Object.getPrototypeOf;vg.exports=mg;var bg={},xg={get exports(){return bg},set exports(t){bg=t}},_g=R,wg=w,Eg=Io,Tg=nt,Og=wg(z.f),Sg=wg([].push),kg=function(t){return function(e){for(var r,n=Tg(e),o=Eg(n),i=o.length,a=0,s=[];i>a;)r=o[a++],_g&&!Og(n,r)||Sg(s,t?[r,n[r]]:n[r]);return s}},jg={entries:kg(!0),values:kg(!1)}.values;Cr({target:"Object",stat:!0},{values:function(t){return jg(t)}});var Ag=st.Object.values;xg.exports=Ag;var Pg={},Ig={get exports(){return Pg},set exports(t){Pg=t}},Dg="\t\n\v\f\r                　\u2028\u2029\ufeff",Cg=tt,Lg=co,Rg=Dg,Mg=w("".replace),Ng=RegExp("^["+Rg+"]+"),Fg=RegExp("(^|[^"+Rg+"])["+Rg+"]+$"),zg=function(t){return function(e){var r=Lg(Cg(e));return 1&t&&(r=Mg(r,Ng,"")),2&t&&(r=Mg(r,Fg,"$1")),r}},Ug={start:zg(1),end:zg(2),trim:zg(3)},qg=f,Yg=l,Wg=w,Gg=co,Xg=Ug.trim,Vg=Dg,Bg=qg.parseInt,Hg=qg.Symbol,$g=Hg&&Hg.iterator,Jg=/^[+-]?0x/i,Kg=Wg(Jg.exec),Qg=8!==Bg(Vg+"08")||22!==Bg(Vg+"0x16")||$g&&!Yg((function(){Bg(Object($g))}))?function(t,e){var r=Xg(Gg(t));return Bg(r,e>>>0||(Kg(Jg,r)?16:10))}:Bg;Cr({global:!0,forced:parseInt!=Qg},{parseInt:Qg});var Zg=st.parseInt;Ig.exports=Zg;var tm={},em={get exports(){return tm},set exports(t){tm=t}},rm=Cr,nm=xo.indexOf,om=Pl,im=A([].indexOf),am=!!im&&1/im([1],1,-0)<0;rm({target:"Array",proto:!0,forced:am||!om("indexOf")},{indexOf:function(t){var e=arguments.length>1?arguments[1]:void 0;return am?im(this,t,e)||0:nm(this,t,e)}});var sm=hl("Array").indexOf,um=ht,cm=sm,fm=Array.prototype,lm=function(t){var e=t.indexOf;return t===fm||um(fm,t)&&e===fm.indexOf?cm:e};em.exports=lm;var pm={},hm={get exports(){return pm},set exports(t){pm=t}},vm=Du.PROPER,dm=l,ym=Dg,gm=Ug.trim;Cr({target:"String",proto:!0,forced:function(t){return dm((function(){return!!ym[t]()||"​᠎"!=="​᠎"[t]()||vm&&ym[t].name!==t}))}("trim")},{trim:function(){return gm(this)}});var mm=hl("String").trim,bm=ht,xm=mm,_m=String.prototype,wm=function(t){var e=t.trim;return"string"==typeof t||t===_m||bm(_m,t)&&e===_m.trim?xm:e};hm.exports=wm;var Em={},Tm={get exports(){return Em},set exports(t){Em=t}};Cr({target:"Object",stat:!0,sham:!R},{create:ri});var Om=st.Object,Sm=function(t,e){return Om.create(t,e)};Tm.exports=Sm;var km=r(Em),jm={},Am={get exports(){return jm},set exports(t){jm=t}},Pm=st,Im=g;Pm.JSON||(Pm.JSON={stringify:JSON.stringify});var Dm=function(t,e,r){return Im(Pm.JSON.stringify,null,arguments)};Am.exports=Dm;var Cm=r(jm),Lm={},Rm={get exports(){return Lm},set exports(t){Lm=t}},Mm="function"==typeof Bun&&Bun&&"string"==typeof Bun.version,Nm=TypeError,Fm=function(t,e){if(t<e)throw Nm("Not enough arguments");return t},zm=f,Um=g,qm=C,Ym=Mm,Wm=vt,Gm=Us,Xm=Fm,Vm=zm.Function,Bm=/MSIE .\./.test(Wm)||Ym&&function(){var t=zm.Bun.version.split(".");return t.length<3||0==t[0]&&(t[1]<3||3==t[1]&&0==t[2])}(),Hm=function(t,e){var r=e?2:1;return Bm?function(n,o){var i=Xm(arguments.length,1)>r,a=qm(n)?n:Vm(n),s=i?Gm(arguments,r):[],u=i?function(){Um(a,this,s)}:a;return e?t(u,o):t(u)}:t},$m=Cr,Jm=f,Km=Hm(Jm.setInterval,!0);$m({global:!0,bind:!0,forced:Jm.setInterval!==Km},{setInterval:Km});var Qm=Cr,Zm=f,tb=Hm(Zm.setTimeout,!0);Qm({global:!0,bind:!0,forced:Zm.setTimeout!==tb},{setTimeout:tb});var eb=st.setTimeout;Rm.exports=eb;var rb=r(Lm),nb={},ob={get exports(){return nb},set exports(t){nb=t}},ib=te,ab=vo,sb=en;Cr({target:"Array",proto:!0},{fill:function(t){for(var e=ib(this),r=sb(e),n=arguments.length,o=ab(n>1?arguments[1]:void 0,r),i=n>2?arguments[2]:void 0,a=void 0===i?r:ab(i,r);a>o;)e[o++]=t;return e}});var ub=hl("Array").fill,cb=ht,fb=ub,lb=Array.prototype,pb=function(t){var e=t.fill;return t===lb||cb(lb,t)&&e===lb.fill?fb:e};ob.exports=pb;var hb={},vb={get exports(){return hb},set exports(t){hb=t}};!function(t){function e(t){if(t)return function(t){for(var r in e.prototype)t[r]=e.prototype[r];return t}(t)}vb.exports=e,e.prototype.on=e.prototype.addEventListener=function(t,e){return this._callbacks=this._callbacks||{},(this._callbacks["$"+t]=this._callbacks["$"+t]||[]).push(e),this},e.prototype.once=function(t,e){function r(){this.off(t,r),e.apply(this,arguments)}return r.fn=e,this.on(t,r),this},e.prototype.off=e.prototype.removeListener=e.prototype.removeAllListeners=e.prototype.removeEventListener=function(t,e){if(this._callbacks=this._callbacks||{},0==arguments.length)return this._callbacks={},this;var r,n=this._callbacks["$"+t];if(!n)return this;if(1==arguments.length)return delete this._callbacks["$"+t],this;for(var o=0;o<n.length;o++)if((r=n[o])===e||r.fn===e){n.splice(o,1);break}return 0===n.length&&delete this._callbacks["$"+t],this},e.prototype.emit=function(t){this._callbacks=this._callbacks||{};for(var e=new Array(arguments.length-1),r=this._callbacks["$"+t],n=1;n<arguments.length;n++)e[n-1]=arguments[n];if(r){n=0;for(var o=(r=r.slice(0)).length;n<o;++n)r[n].apply(this,e)}return this},e.prototype.listeners=function(t){return this._callbacks=this._callbacks||{},this._callbacks["$"+t]||[]},e.prototype.hasListeners=function(t){return!!this.listeners(t).length}}();var db=hb;
/*! Hammer.JS - v2.0.17-rc - 2019-12-16
 * http://naver.github.io/egjs
 *
 * Forked By Naver egjs
 * Copyright (c) hammerjs
 * Licensed under the MIT license */function yb(){return yb=Object.assign||function(t){for(var e=1;e<arguments.length;e++){var r=arguments[e];for(var n in r)Object.prototype.hasOwnProperty.call(r,n)&&(t[n]=r[n])}return t},yb.apply(this,arguments)}function gb(t,e){t.prototype=Object.create(e.prototype),t.prototype.constructor=t,t.__proto__=e}function mb(t){if(void 0===t)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return t}var bb,xb="function"!=typeof Object.assign?function(t){if(null==t)throw new TypeError("Cannot convert undefined or null to object");for(var e=Object(t),r=1;r<arguments.length;r++){var n=arguments[r];if(null!=n)for(var o in n)n.hasOwnProperty(o)&&(e[o]=n[o])}return e}:Object.assign,_b=["","webkit","Moz","MS","ms","o"],wb="undefined"==typeof document?{style:{}}:document.createElement("div"),Eb="function",Tb=Math.round,Ob=Math.abs,Sb=Date.now;function kb(t,e){for(var r,n,o=e[0].toUpperCase()+e.slice(1),i=0;i<_b.length;){if((n=(r=_b[i])?r+o:e)in t)return n;i++}}bb="undefined"==typeof window?{}:window;var jb=kb(wb.style,"touchAction"),Ab=void 0!==jb;var Pb="compute",Ib="auto",Db="manipulation",Cb="none",Lb="pan-x",Rb="pan-y",Mb=function(){if(!Ab)return!1;var t={},e=bb.CSS&&bb.CSS.supports;return["auto","manipulation","pan-y","pan-x","pan-x pan-y","none"].forEach((function(r){return t[r]=!e||bb.CSS.supports("touch-action",r)})),t}(),Nb="ontouchstart"in bb,Fb=void 0!==kb(bb,"PointerEvent"),zb=Nb&&/mobile|tablet|ip(ad|hone|od)|android/i.test(navigator.userAgent),Ub="touch",qb="mouse",Yb=25,Wb=1,Gb=2,Xb=4,Vb=8,Bb=1,Hb=2,$b=4,Jb=8,Kb=16,Qb=Hb|$b,Zb=Jb|Kb,tx=Qb|Zb,ex=["x","y"],rx=["clientX","clientY"];function nx(t,e,r){var n;if(t)if(t.forEach)t.forEach(e,r);else if(void 0!==t.length)for(n=0;n<t.length;)e.call(r,t[n],n,t),n++;else for(n in t)t.hasOwnProperty(n)&&e.call(r,t[n],n,t)}function ox(t,e){return typeof t===Eb?t.apply(e&&e[0]||void 0,e):t}function ix(t,e){return t.indexOf(e)>-1}var ax=function(){function t(t,e){this.manager=t,this.set(e)}var e=t.prototype;return e.set=function(t){t===Pb&&(t=this.compute()),Ab&&this.manager.element.style&&Mb[t]&&(this.manager.element.style[jb]=t),this.actions=t.toLowerCase().trim()},e.update=function(){this.set(this.manager.options.touchAction)},e.compute=function(){var t=[];return nx(this.manager.recognizers,(function(e){ox(e.options.enable,[e])&&(t=t.concat(e.getTouchAction()))})),function(t){if(ix(t,Cb))return Cb;var e=ix(t,Lb),r=ix(t,Rb);return e&&r?Cb:e||r?e?Lb:Rb:ix(t,Db)?Db:Ib}(t.join(" "))},e.preventDefaults=function(t){var e=t.srcEvent,r=t.offsetDirection;if(this.manager.session.prevented)e.preventDefault();else{var n=this.actions,o=ix(n,Cb)&&!Mb[Cb],i=ix(n,Rb)&&!Mb[Rb],a=ix(n,Lb)&&!Mb[Lb];if(o){var s=1===t.pointers.length,u=t.distance<2,c=t.deltaTime<250;if(s&&u&&c)return}if(!a||!i)return o||i&&r&Qb||a&&r&Zb?this.preventSrc(e):void 0}},e.preventSrc=function(t){this.manager.session.prevented=!0,t.preventDefault()},t}();function sx(t,e){for(;t;){if(t===e)return!0;t=t.parentNode}return!1}function ux(t){var e=t.length;if(1===e)return{x:Tb(t[0].clientX),y:Tb(t[0].clientY)};for(var r=0,n=0,o=0;o<e;)r+=t[o].clientX,n+=t[o].clientY,o++;return{x:Tb(r/e),y:Tb(n/e)}}function cx(t){for(var e=[],r=0;r<t.pointers.length;)e[r]={clientX:Tb(t.pointers[r].clientX),clientY:Tb(t.pointers[r].clientY)},r++;return{timeStamp:Sb(),pointers:e,center:ux(e),deltaX:t.deltaX,deltaY:t.deltaY}}function fx(t,e,r){r||(r=ex);var n=e[r[0]]-t[r[0]],o=e[r[1]]-t[r[1]];return Math.sqrt(n*n+o*o)}function lx(t,e,r){r||(r=ex);var n=e[r[0]]-t[r[0]],o=e[r[1]]-t[r[1]];return 180*Math.atan2(o,n)/Math.PI}function px(t,e){return t===e?Bb:Ob(t)>=Ob(e)?t<0?Hb:$b:e<0?Jb:Kb}function hx(t,e,r){return{x:e/t||0,y:r/t||0}}function vx(t,e){var r=t.session,n=e.pointers,o=n.length;r.firstInput||(r.firstInput=cx(e)),o>1&&!r.firstMultiple?r.firstMultiple=cx(e):1===o&&(r.firstMultiple=!1);var i=r.firstInput,a=r.firstMultiple,s=a?a.center:i.center,u=e.center=ux(n);e.timeStamp=Sb(),e.deltaTime=e.timeStamp-i.timeStamp,e.angle=lx(s,u),e.distance=fx(s,u),function(t,e){var r=e.center,n=t.offsetDelta||{},o=t.prevDelta||{},i=t.prevInput||{};e.eventType!==Wb&&i.eventType!==Xb||(o=t.prevDelta={x:i.deltaX||0,y:i.deltaY||0},n=t.offsetDelta={x:r.x,y:r.y}),e.deltaX=o.x+(r.x-n.x),e.deltaY=o.y+(r.y-n.y)}(r,e),e.offsetDirection=px(e.deltaX,e.deltaY);var c,f,l=hx(e.deltaTime,e.deltaX,e.deltaY);e.overallVelocityX=l.x,e.overallVelocityY=l.y,e.overallVelocity=Ob(l.x)>Ob(l.y)?l.x:l.y,e.scale=a?(c=a.pointers,fx((f=n)[0],f[1],rx)/fx(c[0],c[1],rx)):1,e.rotation=a?function(t,e){return lx(e[1],e[0],rx)+lx(t[1],t[0],rx)}(a.pointers,n):0,e.maxPointers=r.prevInput?e.pointers.length>r.prevInput.maxPointers?e.pointers.length:r.prevInput.maxPointers:e.pointers.length,function(t,e){var r,n,o,i,a=t.lastInterval||e,s=e.timeStamp-a.timeStamp;if(e.eventType!==Vb&&(s>Yb||void 0===a.velocity)){var u=e.deltaX-a.deltaX,c=e.deltaY-a.deltaY,f=hx(s,u,c);n=f.x,o=f.y,r=Ob(f.x)>Ob(f.y)?f.x:f.y,i=px(u,c),t.lastInterval=e}else r=a.velocity,n=a.velocityX,o=a.velocityY,i=a.direction;e.velocity=r,e.velocityX=n,e.velocityY=o,e.direction=i}(r,e);var p,h=t.element,v=e.srcEvent;sx(p=v.composedPath?v.composedPath()[0]:v.path?v.path[0]:v.target,h)&&(h=p),e.target=h}function dx(t,e,r){var n=r.pointers.length,o=r.changedPointers.length,i=e&Wb&&n-o==0,a=e&(Xb|Vb)&&n-o==0;r.isFirst=!!i,r.isFinal=!!a,i&&(t.session={}),r.eventType=e,vx(t,r),t.emit("hammer.input",r),t.recognize(r),t.session.prevInput=r}function yx(t){return t.trim().split(/\s+/g)}function gx(t,e,r){nx(yx(e),(function(e){t.addEventListener(e,r,!1)}))}function mx(t,e,r){nx(yx(e),(function(e){t.removeEventListener(e,r,!1)}))}function bx(t){var e=t.ownerDocument||t;return e.defaultView||e.parentWindow||window}var xx=function(){function t(t,e){var r=this;this.manager=t,this.callback=e,this.element=t.element,this.target=t.options.inputTarget,this.domHandler=function(e){ox(t.options.enable,[t])&&r.handler(e)},this.init()}var e=t.prototype;return e.handler=function(){},e.init=function(){this.evEl&&gx(this.element,this.evEl,this.domHandler),this.evTarget&&gx(this.target,this.evTarget,this.domHandler),this.evWin&&gx(bx(this.element),this.evWin,this.domHandler)},e.destroy=function(){this.evEl&&mx(this.element,this.evEl,this.domHandler),this.evTarget&&mx(this.target,this.evTarget,this.domHandler),this.evWin&&mx(bx(this.element),this.evWin,this.domHandler)},t}();function _x(t,e,r){if(t.indexOf&&!r)return t.indexOf(e);for(var n=0;n<t.length;){if(r&&t[n][r]==e||!r&&t[n]===e)return n;n++}return-1}var wx={pointerdown:Wb,pointermove:Gb,pointerup:Xb,pointercancel:Vb,pointerout:Vb},Ex={2:Ub,3:"pen",4:qb,5:"kinect"},Tx="pointerdown",Ox="pointermove pointerup pointercancel";bb.MSPointerEvent&&!bb.PointerEvent&&(Tx="MSPointerDown",Ox="MSPointerMove MSPointerUp MSPointerCancel");var Sx=function(t){function e(){var r,n=e.prototype;return n.evEl=Tx,n.evWin=Ox,(r=t.apply(this,arguments)||this).store=r.manager.session.pointerEvents=[],r}return gb(e,t),e.prototype.handler=function(t){var e=this.store,r=!1,n=t.type.toLowerCase().replace("ms",""),o=wx[n],i=Ex[t.pointerType]||t.pointerType,a=i===Ub,s=_x(e,t.pointerId,"pointerId");o&Wb&&(0===t.button||a)?s<0&&(e.push(t),s=e.length-1):o&(Xb|Vb)&&(r=!0),s<0||(e[s]=t,this.callback(this.manager,o,{pointers:e,changedPointers:[t],pointerType:i,srcEvent:t}),r&&e.splice(s,1))},e}(xx);function kx(t){return Array.prototype.slice.call(t,0)}function jx(t,e,r){for(var n=[],o=[],i=0;i<t.length;){var a=e?t[i][e]:t[i];_x(o,a)<0&&n.push(t[i]),o[i]=a,i++}return r&&(n=e?n.sort((function(t,r){return t[e]>r[e]})):n.sort()),n}var Ax={touchstart:Wb,touchmove:Gb,touchend:Xb,touchcancel:Vb},Px="touchstart touchmove touchend touchcancel",Ix=function(t){function e(){var r;return e.prototype.evTarget=Px,(r=t.apply(this,arguments)||this).targetIds={},r}return gb(e,t),e.prototype.handler=function(t){var e=Ax[t.type],r=Dx.call(this,t,e);r&&this.callback(this.manager,e,{pointers:r[0],changedPointers:r[1],pointerType:Ub,srcEvent:t})},e}(xx);function Dx(t,e){var r,n,o=kx(t.touches),i=this.targetIds;if(e&(Wb|Gb)&&1===o.length)return i[o[0].identifier]=!0,[o,o];var a=kx(t.changedTouches),s=[],u=this.target;if(n=o.filter((function(t){return sx(t.target,u)})),e===Wb)for(r=0;r<n.length;)i[n[r].identifier]=!0,r++;for(r=0;r<a.length;)i[a[r].identifier]&&s.push(a[r]),e&(Xb|Vb)&&delete i[a[r].identifier],r++;return s.length?[jx(n.concat(s),"identifier",!0),s]:void 0}var Cx={mousedown:Wb,mousemove:Gb,mouseup:Xb},Lx="mousedown",Rx="mousemove mouseup",Mx=function(t){function e(){var r,n=e.prototype;return n.evEl=Lx,n.evWin=Rx,(r=t.apply(this,arguments)||this).pressed=!1,r}return gb(e,t),e.prototype.handler=function(t){var e=Cx[t.type];e&Wb&&0===t.button&&(this.pressed=!0),e&Gb&&1!==t.which&&(e=Xb),this.pressed&&(e&Xb&&(this.pressed=!1),this.callback(this.manager,e,{pointers:[t],changedPointers:[t],pointerType:qb,srcEvent:t}))},e}(xx),Nx=2500,Fx=25;function zx(t){var e=t.changedPointers[0];if(e.identifier===this.primaryTouch){var r={x:e.clientX,y:e.clientY},n=this.lastTouches;this.lastTouches.push(r);setTimeout((function(){var t=n.indexOf(r);t>-1&&n.splice(t,1)}),Nx)}}function Ux(t,e){t&Wb?(this.primaryTouch=e.changedPointers[0].identifier,zx.call(this,e)):t&(Xb|Vb)&&zx.call(this,e)}function qx(t){for(var e=t.srcEvent.clientX,r=t.srcEvent.clientY,n=0;n<this.lastTouches.length;n++){var o=this.lastTouches[n],i=Math.abs(e-o.x),a=Math.abs(r-o.y);if(i<=Fx&&a<=Fx)return!0}return!1}var Yx=function(){return function(t){function e(e,r){var n;return(n=t.call(this,e,r)||this).handler=function(t,e,r){var o=r.pointerType===Ub,i=r.pointerType===qb;if(!(i&&r.sourceCapabilities&&r.sourceCapabilities.firesTouchEvents)){if(o)Ux.call(mb(mb(n)),e,r);else if(i&&qx.call(mb(mb(n)),r))return;n.callback(t,e,r)}},n.touch=new Ix(n.manager,n.handler),n.mouse=new Mx(n.manager,n.handler),n.primaryTouch=null,n.lastTouches=[],n}return gb(e,t),e.prototype.destroy=function(){this.touch.destroy(),this.mouse.destroy()},e}(xx)}();function Wx(t,e,r){return!!Array.isArray(t)&&(nx(t,r[e],r),!0)}var Gx=1,Xx=2,Vx=4,Bx=8,Hx=Bx,$x=16,Jx=32,Kx=1;function Qx(t,e){var r=e.manager;return r?r.get(t):t}function Zx(t){return t&$x?"cancel":t&Bx?"end":t&Vx?"move":t&Xx?"start":""}var t_=function(){function t(t){void 0===t&&(t={}),this.options=yb({enable:!0},t),this.id=Kx++,this.manager=null,this.state=Gx,this.simultaneous={},this.requireFail=[]}var e=t.prototype;return e.set=function(t){return xb(this.options,t),this.manager&&this.manager.touchAction.update(),this},e.recognizeWith=function(t){if(Wx(t,"recognizeWith",this))return this;var e=this.simultaneous;return e[(t=Qx(t,this)).id]||(e[t.id]=t,t.recognizeWith(this)),this},e.dropRecognizeWith=function(t){return Wx(t,"dropRecognizeWith",this)||(t=Qx(t,this),delete this.simultaneous[t.id]),this},e.requireFailure=function(t){if(Wx(t,"requireFailure",this))return this;var e=this.requireFail;return-1===_x(e,t=Qx(t,this))&&(e.push(t),t.requireFailure(this)),this},e.dropRequireFailure=function(t){if(Wx(t,"dropRequireFailure",this))return this;t=Qx(t,this);var e=_x(this.requireFail,t);return e>-1&&this.requireFail.splice(e,1),this},e.hasRequireFailures=function(){return this.requireFail.length>0},e.canRecognizeWith=function(t){return!!this.simultaneous[t.id]},e.emit=function(t){var e=this,r=this.state;function n(r){e.manager.emit(r,t)}r<Bx&&n(e.options.event+Zx(r)),n(e.options.event),t.additionalEvent&&n(t.additionalEvent),r>=Bx&&n(e.options.event+Zx(r))},e.tryEmit=function(t){if(this.canEmit())return this.emit(t);this.state=Jx},e.canEmit=function(){for(var t=0;t<this.requireFail.length;){if(!(this.requireFail[t].state&(Jx|Gx)))return!1;t++}return!0},e.recognize=function(t){var e=xb({},t);if(!ox(this.options.enable,[this,e]))return this.reset(),void(this.state=Jx);this.state&(Hx|$x|Jx)&&(this.state=Gx),this.state=this.process(e),this.state&(Xx|Vx|Bx|$x)&&this.tryEmit(e)},e.process=function(t){},e.getTouchAction=function(){},e.reset=function(){},t}(),e_=function(t){function e(e){var r;return void 0===e&&(e={}),(r=t.call(this,yb({event:"tap",pointers:1,taps:1,interval:300,time:250,threshold:9,posThreshold:10},e))||this).pTime=!1,r.pCenter=!1,r._timer=null,r._input=null,r.count=0,r}gb(e,t);var r=e.prototype;return r.getTouchAction=function(){return[Db]},r.process=function(t){var e=this,r=this.options,n=t.pointers.length===r.pointers,o=t.distance<r.threshold,i=t.deltaTime<r.time;if(this.reset(),t.eventType&Wb&&0===this.count)return this.failTimeout();if(o&&i&&n){if(t.eventType!==Xb)return this.failTimeout();var a=!this.pTime||t.timeStamp-this.pTime<r.interval,s=!this.pCenter||fx(this.pCenter,t.center)<r.posThreshold;if(this.pTime=t.timeStamp,this.pCenter=t.center,s&&a?this.count+=1:this.count=1,this._input=t,0===this.count%r.taps)return this.hasRequireFailures()?(this._timer=setTimeout((function(){e.state=Hx,e.tryEmit()}),r.interval),Xx):Hx}return Jx},r.failTimeout=function(){var t=this;return this._timer=setTimeout((function(){t.state=Jx}),this.options.interval),Jx},r.reset=function(){clearTimeout(this._timer)},r.emit=function(){this.state===Hx&&(this._input.tapCount=this.count,this.manager.emit(this.options.event,this._input))},e}(t_),r_=function(t){function e(e){return void 0===e&&(e={}),t.call(this,yb({pointers:1},e))||this}gb(e,t);var r=e.prototype;return r.attrTest=function(t){var e=this.options.pointers;return 0===e||t.pointers.length===e},r.process=function(t){var e=this.state,r=t.eventType,n=e&(Xx|Vx),o=this.attrTest(t);return n&&(r&Vb||!o)?e|$x:n||o?r&Xb?e|Bx:e&Xx?e|Vx:Xx:Jx},e}(t_);function n_(t){return t===Kb?"down":t===Jb?"up":t===Hb?"left":t===$b?"right":""}var o_=function(t){function e(e){var r;return void 0===e&&(e={}),(r=t.call(this,yb({event:"pan",threshold:10,pointers:1,direction:tx},e))||this).pX=null,r.pY=null,r}gb(e,t);var r=e.prototype;return r.getTouchAction=function(){var t=this.options.direction,e=[];return t&Qb&&e.push(Rb),t&Zb&&e.push(Lb),e},r.directionTest=function(t){var e=this.options,r=!0,n=t.distance,o=t.direction,i=t.deltaX,a=t.deltaY;return o&e.direction||(e.direction&Qb?(o=0===i?Bb:i<0?Hb:$b,r=i!==this.pX,n=Math.abs(t.deltaX)):(o=0===a?Bb:a<0?Jb:Kb,r=a!==this.pY,n=Math.abs(t.deltaY))),t.direction=o,r&&n>e.threshold&&o&e.direction},r.attrTest=function(t){return r_.prototype.attrTest.call(this,t)&&(this.state&Xx||!(this.state&Xx)&&this.directionTest(t))},r.emit=function(e){this.pX=e.deltaX,this.pY=e.deltaY;var r=n_(e.direction);r&&(e.additionalEvent=this.options.event+r),t.prototype.emit.call(this,e)},e}(r_),i_=function(t){function e(e){return void 0===e&&(e={}),t.call(this,yb({event:"swipe",threshold:10,velocity:.3,direction:Qb|Zb,pointers:1},e))||this}gb(e,t);var r=e.prototype;return r.getTouchAction=function(){return o_.prototype.getTouchAction.call(this)},r.attrTest=function(e){var r,n=this.options.direction;return n&(Qb|Zb)?r=e.overallVelocity:n&Qb?r=e.overallVelocityX:n&Zb&&(r=e.overallVelocityY),t.prototype.attrTest.call(this,e)&&n&e.offsetDirection&&e.distance>this.options.threshold&&e.maxPointers===this.options.pointers&&Ob(r)>this.options.velocity&&e.eventType&Xb},r.emit=function(t){var e=n_(t.offsetDirection);e&&this.manager.emit(this.options.event+e,t),this.manager.emit(this.options.event,t)},e}(r_),a_=function(t){function e(e){return void 0===e&&(e={}),t.call(this,yb({event:"pinch",threshold:0,pointers:2},e))||this}gb(e,t);var r=e.prototype;return r.getTouchAction=function(){return[Cb]},r.attrTest=function(e){return t.prototype.attrTest.call(this,e)&&(Math.abs(e.scale-1)>this.options.threshold||this.state&Xx)},r.emit=function(e){if(1!==e.scale){var r=e.scale<1?"in":"out";e.additionalEvent=this.options.event+r}t.prototype.emit.call(this,e)},e}(r_),s_=function(t){function e(e){return void 0===e&&(e={}),t.call(this,yb({event:"rotate",threshold:0,pointers:2},e))||this}gb(e,t);var r=e.prototype;return r.getTouchAction=function(){return[Cb]},r.attrTest=function(e){return t.prototype.attrTest.call(this,e)&&(Math.abs(e.rotation)>this.options.threshold||this.state&Xx)},e}(r_),u_=function(t){function e(e){var r;return void 0===e&&(e={}),(r=t.call(this,yb({event:"press",pointers:1,time:251,threshold:9},e))||this)._timer=null,r._input=null,r}gb(e,t);var r=e.prototype;return r.getTouchAction=function(){return[Ib]},r.process=function(t){var e=this,r=this.options,n=t.pointers.length===r.pointers,o=t.distance<r.threshold,i=t.deltaTime>r.time;if(this._input=t,!o||!n||t.eventType&(Xb|Vb)&&!i)this.reset();else if(t.eventType&Wb)this.reset(),this._timer=setTimeout((function(){e.state=Hx,e.tryEmit()}),r.time);else if(t.eventType&Xb)return Hx;return Jx},r.reset=function(){clearTimeout(this._timer)},r.emit=function(t){this.state===Hx&&(t&&t.eventType&Xb?this.manager.emit(this.options.event+"up",t):(this._input.timeStamp=Sb(),this.manager.emit(this.options.event,this._input)))},e}(t_),c_={domEvents:!1,touchAction:Pb,enable:!0,inputTarget:null,inputClass:null,cssProps:{userSelect:"none",touchSelect:"none",touchCallout:"none",contentZooming:"none",userDrag:"none",tapHighlightColor:"rgba(0,0,0,0)"}},f_=[[s_,{enable:!1}],[a_,{enable:!1},["rotate"]],[i_,{direction:Qb}],[o_,{direction:Qb},["swipe"]],[e_],[e_,{event:"doubletap",taps:2},["tap"]],[u_]];function l_(t,e){var r,n=t.element;n.style&&(nx(t.options.cssProps,(function(o,i){r=kb(n.style,i),e?(t.oldCssProps[r]=n.style[r],n.style[r]=o):n.style[r]=t.oldCssProps[r]||""})),e||(t.oldCssProps={}))}var p_=function(){function t(t,e){var r,n=this;this.options=xb({},c_,e||{}),this.options.inputTarget=this.options.inputTarget||t,this.handlers={},this.session={},this.recognizers=[],this.oldCssProps={},this.element=t,this.input=new((r=this).options.inputClass||(Fb?Sx:zb?Ix:Nb?Yx:Mx))(r,dx),this.touchAction=new ax(this,this.options.touchAction),l_(this,!0),nx(this.options.recognizers,(function(t){var e=n.add(new t[0](t[1]));t[2]&&e.recognizeWith(t[2]),t[3]&&e.requireFailure(t[3])}),this)}var e=t.prototype;return e.set=function(t){return xb(this.options,t),t.touchAction&&this.touchAction.update(),t.inputTarget&&(this.input.destroy(),this.input.target=t.inputTarget,this.input.init()),this},e.stop=function(t){this.session.stopped=t?2:1},e.recognize=function(t){var e=this.session;if(!e.stopped){var r;this.touchAction.preventDefaults(t);var n=this.recognizers,o=e.curRecognizer;(!o||o&&o.state&Hx)&&(e.curRecognizer=null,o=null);for(var i=0;i<n.length;)r=n[i],2===e.stopped||o&&r!==o&&!r.canRecognizeWith(o)?r.reset():r.recognize(t),!o&&r.state&(Xx|Vx|Bx)&&(e.curRecognizer=r,o=r),i++}},e.get=function(t){if(t instanceof t_)return t;for(var e=this.recognizers,r=0;r<e.length;r++)if(e[r].options.event===t)return e[r];return null},e.add=function(t){if(Wx(t,"add",this))return this;var e=this.get(t.options.event);return e&&this.remove(e),this.recognizers.push(t),t.manager=this,this.touchAction.update(),t},e.remove=function(t){if(Wx(t,"remove",this))return this;var e=this.get(t);if(t){var r=this.recognizers,n=_x(r,e);-1!==n&&(r.splice(n,1),this.touchAction.update())}return this},e.on=function(t,e){if(void 0===t||void 0===e)return this;var r=this.handlers;return nx(yx(t),(function(t){r[t]=r[t]||[],r[t].push(e)})),this},e.off=function(t,e){if(void 0===t)return this;var r=this.handlers;return nx(yx(t),(function(t){e?r[t]&&r[t].splice(_x(r[t],e),1):delete r[t]})),this},e.emit=function(t,e){this.options.domEvents&&function(t,e){var r=document.createEvent("Event");r.initEvent(t,!0,!0),r.gesture=e,e.target.dispatchEvent(r)}(t,e);var r=this.handlers[t]&&this.handlers[t].slice();if(r&&r.length){e.type=t,e.preventDefault=function(){e.srcEvent.preventDefault()};for(var n=0;n<r.length;)r[n](e),n++}},e.destroy=function(){this.element&&l_(this,!1),this.handlers={},this.session={},this.input.destroy(),this.element=null},t}(),h_={touchstart:Wb,touchmove:Gb,touchend:Xb,touchcancel:Vb},v_="touchstart",d_="touchstart touchmove touchend touchcancel",y_=function(t){function e(){var r,n=e.prototype;return n.evTarget=v_,n.evWin=d_,(r=t.apply(this,arguments)||this).started=!1,r}return gb(e,t),e.prototype.handler=function(t){var e=h_[t.type];if(e===Wb&&(this.started=!0),this.started){var r=g_.call(this,t,e);e&(Xb|Vb)&&r[0].length-r[1].length==0&&(this.started=!1),this.callback(this.manager,e,{pointers:r[0],changedPointers:r[1],pointerType:Ub,srcEvent:t})}},e}(xx);function g_(t,e){var r=kx(t.touches),n=kx(t.changedTouches);return e&(Xb|Vb)&&(r=jx(r.concat(n),"identifier",!0)),[r,n]}function m_(t,e,r){var n="DEPRECATED METHOD: "+e+"\n"+r+" AT \n";return function(){var e=new Error("get-stack-trace"),r=e&&e.stack?e.stack.replace(/^[^\(]+?[\n$]/gm,"").replace(/^\s+at\s+/gm,"").replace(/^Object.<anonymous>\s*\(/gm,"{anonymous}()@"):"Unknown Stack Trace",o=window.console&&(window.console.warn||window.console.log);return o&&o.call(window.console,n,r),t.apply(this,arguments)}}var b_=m_((function(t,e,r){for(var n=Object.keys(e),o=0;o<n.length;)(!r||r&&void 0===t[n[o]])&&(t[n[o]]=e[n[o]]),o++;return t}),"extend","Use `assign`."),x_=m_((function(t,e){return b_(t,e,!0)}),"merge","Use `assign`.");function __(t,e,r){var n,o=e.prototype;(n=t.prototype=Object.create(o)).constructor=t,n._super=o,r&&xb(n,r)}function w_(t,e){return function(){return t.apply(e,arguments)}}var E_=function(){var t=function(t,e){return void 0===e&&(e={}),new p_(t,yb({recognizers:f_.concat()},e))};return t.VERSION="2.0.17-rc",t.DIRECTION_ALL=tx,t.DIRECTION_DOWN=Kb,t.DIRECTION_LEFT=Hb,t.DIRECTION_RIGHT=$b,t.DIRECTION_UP=Jb,t.DIRECTION_HORIZONTAL=Qb,t.DIRECTION_VERTICAL=Zb,t.DIRECTION_NONE=Bb,t.DIRECTION_DOWN=Kb,t.INPUT_START=Wb,t.INPUT_MOVE=Gb,t.INPUT_END=Xb,t.INPUT_CANCEL=Vb,t.STATE_POSSIBLE=Gx,t.STATE_BEGAN=Xx,t.STATE_CHANGED=Vx,t.STATE_ENDED=Bx,t.STATE_RECOGNIZED=Hx,t.STATE_CANCELLED=$x,t.STATE_FAILED=Jx,t.Manager=p_,t.Input=xx,t.TouchAction=ax,t.TouchInput=Ix,t.MouseInput=Mx,t.PointerEventInput=Sx,t.TouchMouseInput=Yx,t.SingleTouchInput=y_,t.Recognizer=t_,t.AttrRecognizer=r_,t.Tap=e_,t.Pan=o_,t.Swipe=i_,t.Pinch=a_,t.Rotate=s_,t.Press=u_,t.on=gx,t.off=mx,t.each=nx,t.merge=x_,t.extend=b_,t.bindFn=w_,t.assign=xb,t.inherit=__,t.bindFn=w_,t.prefixed=kb,t.toArray=kx,t.inArray=_x,t.uniqueArray=jx,t.splitStr=yx,t.boolOrFn=ox,t.hasParent=sx,t.addEventListeners=gx,t.removeEventListeners=mx,t.defaults=xb({},c_,{preset:f_}),t}();function T_(t,e){var r=void 0!==Kv&&mh(t)||t["@@iterator"];if(!r){if(hd(t)||(r=function(t,e){var r;if(!t)return;if("string"==typeof t)return O_(t,e);var n=sd(r=Object.prototype.toString.call(t)).call(r,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return hh(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return O_(t,e)}(t))||e&&t&&"number"==typeof t.length){r&&(t=r);var n=0,o=function(){};return{s:o,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var i,a=!0,s=!1;return{s:function(){r=r.call(t)},n:function(){var t=r.next();return a=t.done,t},e:function(t){s=!0,i=t},f:function(){try{a||null==r.return||r.return()}finally{if(s)throw i}}}}function O_(t,e){(null==e||e>t.length)&&(e=t.length);for(var r=0,n=new Array(e);r<e;r++)n[r]=t[r];return n}var S_=Kv("DELETE");function k_(){var t=j_.apply(void 0,arguments);return P_(t),t}function j_(){for(var t=arguments.length,e=new Array(t),r=0;r<t;r++)e[r]=arguments[r];if(e.length<2)return e[0];var n;if(e.length>2)return j_.apply(void 0,id(n=[k_(e[0],e[1])]).call(n,$v(sd(e).call(e,2))));var o,i=e[0],a=e[1],s=T_(ld(a));try{for(s.s();!(o=s.n()).done;){var u=o.value;Object.prototype.propertyIsEnumerable.call(a,u)&&(a[u]===S_?delete i[u]:null===i[u]||null===a[u]||"object"!==Uf(i[u])||"object"!==Uf(a[u])||hd(i[u])||hd(a[u])?i[u]=A_(a[u]):i[u]=j_(i[u],a[u]))}}catch(t){s.e(t)}finally{s.f()}return i}function A_(t){return hd(t)?rp(t).call(t,(function(t){return A_(t)})):"object"===Uf(t)&&null!==t?j_({},t):t}function P_(t){for(var e=0,r=bd(t);e<r.length;e++){var n=r[e];t[n]===S_?delete t[n]:"object"===Uf(t[n])&&null!==t[n]&&P_(t[n])}}var I_="undefined"!=typeof window?window.Hammer||E_:function(){return function(){var t=function(){};return{on:t,off:t,destroy:t,emit:t,get:function(){return{set:t}}}}()};function D_(t){var e,r=this;this._cleanupQueue=[],this.active=!1,this._dom={container:t,overlay:document.createElement("div")},this._dom.overlay.classList.add("vis-overlay"),this._dom.container.appendChild(this._dom.overlay),this._cleanupQueue.push((function(){r._dom.overlay.parentNode.removeChild(r._dom.overlay)}));var n=I_(this._dom.overlay);n.on("tap",bl(e=this._onTapOverlay).call(e,this)),this._cleanupQueue.push((function(){n.destroy()}));var o=["tap","doubletap","press","pinch","pan","panstart","panmove","panend"];Fd(o).call(o,(function(t){n.on(t,(function(t){t.srcEvent.stopPropagation()}))})),document&&document.body&&(this._onClick=function(e){(function(t,e){for(;t;){if(t===e)return!0;t=t.parentNode}return!1})(e.target,t)||r.deactivate()},document.body.addEventListener("click",this._onClick),this._cleanupQueue.push((function(){document.body.removeEventListener("click",r._onClick)}))),this._escListener=function(t){("key"in t?"Escape"===t.key:27===t.keyCode)&&r.deactivate()}}db(D_.prototype),D_.current=null,D_.prototype.destroy=function(){var t,e;this.deactivate();var r,n=T_(Jd(t=Oy(e=this._cleanupQueue).call(e,0)).call(t));try{for(n.s();!(r=n.n()).done;){(0,r.value)()}}catch(t){n.e(t)}finally{n.f()}},D_.prototype.activate=function(){D_.current&&D_.current.deactivate(),D_.current=this,this.active=!0,this._dom.overlay.style.display="none",this._dom.container.classList.add("vis-active"),this.emit("change"),this.emit("activate"),document.body.addEventListener("keydown",this._escListener)},D_.prototype.deactivate=function(){this.active=!1,this._dom.overlay.style.display="block",this._dom.container.classList.remove("vis-active"),document.body.removeEventListener("keydown",this._escListener),this.emit("change"),this.emit("deactivate")},D_.prototype._onTapOverlay=function(t){this.activate(),t.srcEvent.stopPropagation()};var C_={},L_={get exports(){return C_},set exports(t){C_=t}},R_=Rn,M_=Dt,N_=TypeError,F_=function(t){if(R_(t))return t;throw N_(M_(t)+" is not a constructor")},z_=Cr,U_=g,q_=fl,Y_=F_,W_=sr,G_=at,X_=ri,V_=l,B_=pt("Reflect","construct"),H_=Object.prototype,$_=[].push,J_=V_((function(){function t(){}return!(B_((function(){}),[],t)instanceof t)})),K_=!V_((function(){B_((function(){}))})),Q_=J_||K_;z_({target:"Reflect",stat:!0,forced:Q_,sham:Q_},{construct:function(t,e){Y_(t),W_(e);var r=arguments.length<3?t:Y_(arguments[2]);if(K_&&!J_)return B_(t,e,r);if(t==r){switch(e.length){case 0:return new t;case 1:return new t(e[0]);case 2:return new t(e[0],e[1]);case 3:return new t(e[0],e[1],e[2]);case 4:return new t(e[0],e[1],e[2],e[3])}var n=[null];return U_($_,n,e),new(U_(q_,t,n))}var o=r.prototype,i=X_(G_(o)?o:H_),a=U_(t,i,e);return G_(a)?a:i}});var Z_=st.Reflect.construct;L_.exports=Z_;var tw=r(C_);function ew(t){if(void 0===t)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return t}var rw={},nw={get exports(){return rw},set exports(t){rw=t}},ow={},iw=Sm;({get exports(){return ow},set exports(t){ow=t}}).exports=iw,nw.exports=ow;var aw=r(rw),sw={},uw={get exports(){return sw},set exports(t){sw=t}},cw={},fw={get exports(){return cw},set exports(t){cw=t}};Cr({target:"Object",stat:!0},{setPrototypeOf:pc});var lw=st.Object.setPrototypeOf;fw.exports=lw,uw.exports=cw;var pw=r(sw),hw={},vw={get exports(){return hw},set exports(t){hw=t}},dw={},yw=ml;({get exports(){return dw},set exports(t){dw=t}}).exports=yw,vw.exports=dw;var gw=r(hw);function mw(t,e){var r;return mw=pw?gw(r=pw).call(r):function(t,e){return t.__proto__=e,t},mw(t,e)}function bw(t,e){if("function"!=typeof e&&null!==e)throw new TypeError("Super expression must either be null or a function");t.prototype=aw(e&&e.prototype,{constructor:{value:t,writable:!0,configurable:!0}}),qr(t,"prototype",{writable:!1}),e&&mw(t,e)}function xw(t,e){if(e&&("object"===Uf(e)||"function"==typeof e))return e;if(void 0!==e)throw new TypeError("Derived constructors may only return object or undefined");return ew(t)}var _w={},ww={get exports(){return _w},set exports(t){_w=t}},Ew={},Tw=mg;({get exports(){return Ew},set exports(t){Ew=t}}).exports=Tw,ww.exports=Ew;var Ow=r(_w);function Sw(t){var e;return Sw=pw?gw(e=Ow).call(e):function(t){return t.__proto__||Ow(t)},Sw(t)}var kw={},jw={get exports(){return kw},set exports(t){kw=t}},Aw={};!function(t){var e=Yr,r=gf;function n(o){return t.exports=n="function"==typeof e&&"symbol"==typeof r?function(t){return typeof t}:function(t){return t&&"function"==typeof e&&t.constructor===e&&t!==e.prototype?"symbol":typeof t},t.exports.__esModule=!0,t.exports.default=t.exports,n(o)}t.exports=n,t.exports.__esModule=!0,t.exports.default=t.exports}({get exports(){return Aw},set exports(t){Aw=t}});var Pw={},Iw={get exports(){return Pw},set exports(t){Pw=t}},Dw={},Cw=Nd;({get exports(){return Dw},set exports(t){Dw=t}}).exports=Cw,Iw.exports=Dw;var Lw={},Rw={get exports(){return Lw},set exports(t){Lw=t}},Mw={},Nw={get exports(){return Mw},set exports(t){Mw=t}},Fw=ne,zw=Wh,Uw=L,qw=rr,Yw=at,Ww=_r,Gw=Error,Xw=w("".replace),Vw=String(Gw("zxcasd").stack),Bw=/\n\s*at [^:]*:[^\n]*/,Hw=Bw.test(Vw),$w=X,Jw=!l((function(){var t=Error("a");return!("stack"in t)||(Object.defineProperty(t,"stack",$w(1,7)),7!==t.stack)})),Kw=_r,Qw=function(t,e){if(Hw&&"string"==typeof t&&!Gw.prepareStackTrace)for(;e--;)t=Xw(t,Bw,"");return t},Zw=Jw,tE=Error.captureStackTrace,eE=er,rE=F,nE=sr,oE=Dt,iE=Rp,aE=en,sE=ht,uE=Hp,cE=qp,fE=Ap,lE=TypeError,pE=function(t,e){this.stopped=t,this.result=e},hE=pE.prototype,vE=function(t,e,r){var n,o,i,a,s,u,c,f=r&&r.that,l=!(!r||!r.AS_ENTRIES),p=!(!r||!r.IS_RECORD),h=!(!r||!r.IS_ITERATOR),v=!(!r||!r.INTERRUPTED),d=eE(e,f),y=function(t){return n&&fE(n,"normal",t),new pE(!0,t)},g=function(t){return l?(nE(t),v?d(t[0],t[1],y):d(t[0],t[1])):v?d(t,y):d(t)};if(p)n=t.iterator;else if(h)n=t;else{if(!(o=cE(t)))throw lE(oE(t)+" is not iterable");if(iE(o)){for(i=0,a=aE(t);a>i;i++)if((s=g(t[i]))&&sE(hE,s))return s;return new pE(!1)}n=uE(t,o)}for(u=p?t.next:n.next;!(c=rE(u,n)).done;){try{s=g(c.value)}catch(t){fE(n,"throw",t)}if("object"==typeof s&&s&&sE(hE,s))return s}return new pE(!1)},dE=co,yE=Cr,gE=ht,mE=qu,bE=pc,xE=function(t,e,r){for(var n=zw(e),o=qw.f,i=Uw.f,a=0;a<n.length;a++){var s=n[a];Fw(t,s)||r&&Fw(r,s)||o(t,s,i(e,s))}},_E=ri,wE=_r,EE=X,TE=function(t,e){Yw(e)&&"cause"in e&&Ww(t,"cause",e.cause)},OE=function(t,e,r,n){Zw&&(tE?tE(t,e):Kw(t,"stack",Qw(r,n)))},SE=vE,kE=function(t,e){return void 0===t?arguments.length<2?"":e:dE(t)},jE=ge("toStringTag"),AE=Error,PE=[].push,IE=function(t,e){var r,n=gE(DE,this);bE?r=bE(AE(),n?mE(this):DE):(r=n?this:_E(DE),wE(r,jE,"Error")),void 0!==e&&wE(r,"message",kE(e)),OE(r,IE,r.stack,1),arguments.length>2&&TE(r,arguments[2]);var o=[];return SE(t,PE,{that:o}),wE(r,"errors",o),r};bE?bE(IE,AE):xE(IE,AE,{name:!0});var DE=IE.prototype=_E(AE.prototype,{constructor:EE(1,IE),message:EE(1,""),name:EE(1,"AggregateError")});yE({global:!0,constructor:!0,arity:2},{AggregateError:IE});var CE,LE,RE,ME,NE=pt,FE=wi,zE=R,UE=ge("species"),qE=function(t){var e=NE(t);zE&&e&&!e[UE]&&FE(e,UE,{configurable:!0,get:function(){return this}})},YE=ht,WE=TypeError,GE=function(t,e){if(YE(e,t))return t;throw WE("Incorrect invocation")},XE=sr,VE=F_,BE=K,HE=ge("species"),$E=function(t,e){var r,n=XE(t).constructor;return void 0===n||BE(r=XE(n)[HE])?e:VE(r)},JE=/(?:ipad|iphone|ipod).*applewebkit/i.test(vt),KE=f,QE=g,ZE=er,tT=C,eT=ne,rT=l,nT=zo,oT=Us,iT=Ie,aT=Fm,sT=JE,uT=Il,cT=KE.setImmediate,fT=KE.clearImmediate,lT=KE.process,pT=KE.Dispatch,hT=KE.Function,vT=KE.MessageChannel,dT=KE.String,yT=0,gT={},mT="onreadystatechange";rT((function(){CE=KE.location}));var bT=function(t){if(eT(gT,t)){var e=gT[t];delete gT[t],e()}},xT=function(t){return function(){bT(t)}},_T=function(t){bT(t.data)},wT=function(t){KE.postMessage(dT(t),CE.protocol+"//"+CE.host)};cT&&fT||(cT=function(t){aT(arguments.length,1);var e=tT(t)?t:hT(t),r=oT(arguments,1);return gT[++yT]=function(){QE(e,void 0,r)},LE(yT),yT},fT=function(t){delete gT[t]},uT?LE=function(t){lT.nextTick(xT(t))}:pT&&pT.now?LE=function(t){pT.now(xT(t))}:vT&&!sT?(ME=(RE=new vT).port2,RE.port1.onmessage=_T,LE=ZE(ME.postMessage,ME)):KE.addEventListener&&tT(KE.postMessage)&&!KE.importScripts&&CE&&"file:"!==CE.protocol&&!rT(wT)?(LE=wT,KE.addEventListener("message",_T,!1)):LE=mT in iT("script")?function(t){nT.appendChild(iT("script"))[mT]=function(){nT.removeChild(this),bT(t)}}:function(t){setTimeout(xT(t),0)});var ET={set:cT,clear:fT},TT=function(){this.head=null,this.tail=null};TT.prototype={add:function(t){var e={item:t,next:null},r=this.tail;r?r.next=e:this.head=e,this.tail=e},get:function(){var t=this.head;if(t)return null===(this.head=t.next)&&(this.tail=null),t.item}};var OT,ST,kT,jT,AT,PT=TT,IT=/ipad|iphone|ipod/i.test(vt)&&"undefined"!=typeof Pebble,DT=/web0s(?!.*chrome)/i.test(vt),CT=f,LT=er,RT=L.f,MT=ET.set,NT=PT,FT=JE,zT=IT,UT=DT,qT=Il,YT=CT.MutationObserver||CT.WebKitMutationObserver,WT=CT.document,GT=CT.process,XT=CT.Promise,VT=RT(CT,"queueMicrotask"),BT=VT&&VT.value;if(!BT){var HT=new NT,$T=function(){var t,e;for(qT&&(t=GT.domain)&&t.exit();e=HT.get();)try{e()}catch(t){throw HT.head&&OT(),t}t&&t.enter()};FT||qT||UT||!YT||!WT?!zT&&XT&&XT.resolve?((jT=XT.resolve(void 0)).constructor=XT,AT=LT(jT.then,jT),OT=function(){AT($T)}):qT?OT=function(){GT.nextTick($T)}:(MT=LT(MT,CT),OT=function(){MT($T)}):(ST=!0,kT=WT.createTextNode(""),new YT($T).observe(kT,{characterData:!0}),OT=function(){kT.data=ST=!ST}),BT=function(t){HT.head||OT(),HT.add(t)}}var JT=BT,KT=function(t){try{return{error:!1,value:t()}}catch(t){return{error:!0,value:t}}},QT=f.Promise,ZT="object"==typeof Deno&&Deno&&"object"==typeof Deno.version,tO=!ZT&&!Il&&"object"==typeof window&&"object"==typeof document,eO=f,rO=QT,nO=C,oO=Ke,iO=_n,aO=ge,sO=tO,uO=ZT,cO=_t,fO=rO&&rO.prototype,lO=aO("species"),pO=!1,hO=nO(eO.PromiseRejectionEvent),vO=oO("Promise",(function(){var t=iO(rO),e=t!==String(rO);if(!e&&66===cO)return!0;if(!fO.catch||!fO.finally)return!0;if(!cO||cO<51||!/native code/.test(t)){var r=new rO((function(t){t(1)})),n=function(t){t((function(){}),(function(){}))};if((r.constructor={})[lO]=n,!(pO=r.then((function(){}))instanceof n))return!0}return!e&&(sO||uO)&&!hO})),dO={CONSTRUCTOR:vO,REJECTION_EVENT:hO,SUBCLASSING:pO},yO={},gO=Mt,mO=TypeError,bO=function(t){var e,r;this.promise=new t((function(t,n){if(void 0!==e||void 0!==r)throw mO("Bad Promise constructor");e=t,r=n})),this.resolve=gO(e),this.reject=gO(r)};yO.f=function(t){return new bO(t)};var xO,_O,wO=Cr,EO=Il,TO=f,OO=F,SO=xi,kO=Vi,jO=qE,AO=Mt,PO=C,IO=at,DO=GE,CO=$E,LO=ET.set,RO=JT,MO=function(t,e){try{1==arguments.length?console.error(t):console.error(t,e)}catch(t){}},NO=KT,FO=PT,zO=ua,UO=QT,qO=yO,YO="Promise",WO=dO.CONSTRUCTOR,GO=dO.REJECTION_EVENT,XO=zO.getterFor(YO),VO=zO.set,BO=UO&&UO.prototype,HO=UO,$O=BO,JO=TO.TypeError,KO=TO.document,QO=TO.process,ZO=qO.f,tS=ZO,eS=!!(KO&&KO.createEvent&&TO.dispatchEvent),rS="unhandledrejection",nS=function(t){var e;return!(!IO(t)||!PO(e=t.then))&&e},oS=function(t,e){var r,n,o,i=e.value,a=1==e.state,s=a?t.ok:t.fail,u=t.resolve,c=t.reject,f=t.domain;try{s?(a||(2===e.rejection&&cS(e),e.rejection=1),!0===s?r=i:(f&&f.enter(),r=s(i),f&&(f.exit(),o=!0)),r===t.promise?c(JO("Promise-chain cycle")):(n=nS(r))?OO(n,r,u,c):u(r)):c(i)}catch(t){f&&!o&&f.exit(),c(t)}},iS=function(t,e){t.notified||(t.notified=!0,RO((function(){for(var r,n=t.reactions;r=n.get();)oS(r,t);t.notified=!1,e&&!t.rejection&&sS(t)})))},aS=function(t,e,r){var n,o;eS?((n=KO.createEvent("Event")).promise=e,n.reason=r,n.initEvent(t,!1,!0),TO.dispatchEvent(n)):n={promise:e,reason:r},!GO&&(o=TO["on"+t])?o(n):t===rS&&MO("Unhandled promise rejection",r)},sS=function(t){OO(LO,TO,(function(){var e,r=t.facade,n=t.value;if(uS(t)&&(e=NO((function(){EO?QO.emit("unhandledRejection",n,r):aS(rS,r,n)})),t.rejection=EO||uS(t)?2:1,e.error))throw e.value}))},uS=function(t){return 1!==t.rejection&&!t.parent},cS=function(t){OO(LO,TO,(function(){var e=t.facade;EO?QO.emit("rejectionHandled",e):aS("rejectionhandled",e,t.value)}))},fS=function(t,e,r){return function(n){t(e,n,r)}},lS=function(t,e,r){t.done||(t.done=!0,r&&(t=r),t.value=e,t.state=2,iS(t,!0))},pS=function(t,e,r){if(!t.done){t.done=!0,r&&(t=r);try{if(t.facade===e)throw JO("Promise can't be resolved itself");var n=nS(e);n?RO((function(){var r={done:!1};try{OO(n,e,fS(pS,r,t),fS(lS,r,t))}catch(e){lS(r,e,t)}})):(t.value=e,t.state=1,iS(t,!1))}catch(e){lS({done:!1},e,t)}}};WO&&($O=(HO=function(t){DO(this,$O),AO(t),OO(xO,this);var e=XO(this);try{t(fS(pS,e),fS(lS,e))}catch(t){lS(e,t)}}).prototype,(xO=function(t){VO(this,{type:YO,done:!1,notified:!1,parent:!1,reactions:new FO,rejection:!1,state:0,value:void 0})}).prototype=SO($O,"then",(function(t,e){var r=XO(this),n=ZO(CO(this,HO));return r.parent=!0,n.ok=!PO(t)||t,n.fail=PO(e)&&e,n.domain=EO?QO.domain:void 0,0==r.state?r.reactions.add(n):RO((function(){oS(n,r)})),n.promise})),_O=function(){var t=new xO,e=XO(t);this.promise=t,this.resolve=fS(pS,e),this.reject=fS(lS,e)},qO.f=ZO=function(t){return t===HO||undefined===t?new _O(t):tS(t)}),wO({global:!0,constructor:!0,wrap:!0,forced:WO},{Promise:HO}),kO(HO,YO,!1,!0),jO(YO);var hS=QT,vS=dO.CONSTRUCTOR||!fh((function(t){hS.all(t).then(void 0,(function(){}))})),dS=F,yS=Mt,gS=yO,mS=KT,bS=vE;Cr({target:"Promise",stat:!0,forced:vS},{all:function(t){var e=this,r=gS.f(e),n=r.resolve,o=r.reject,i=mS((function(){var r=yS(e.resolve),i=[],a=0,s=1;bS(t,(function(t){var u=a++,c=!1;s++,dS(r,e,t).then((function(t){c||(c=!0,i[u]=t,--s||n(i))}),o)})),--s||n(i)}));return i.error&&o(i.value),r.promise}});var xS=Cr,_S=dO.CONSTRUCTOR;QT&&QT.prototype,xS({target:"Promise",proto:!0,forced:_S,real:!0},{catch:function(t){return this.then(void 0,t)}});var wS=F,ES=Mt,TS=yO,OS=KT,SS=vE;Cr({target:"Promise",stat:!0,forced:vS},{race:function(t){var e=this,r=TS.f(e),n=r.reject,o=OS((function(){var o=ES(e.resolve);SS(t,(function(t){wS(o,e,t).then(r.resolve,n)}))}));return o.error&&n(o.value),r.promise}});var kS=F,jS=yO;Cr({target:"Promise",stat:!0,forced:dO.CONSTRUCTOR},{reject:function(t){var e=jS.f(this);return kS(e.reject,void 0,t),e.promise}});var AS=sr,PS=at,IS=yO,DS=function(t,e){if(AS(t),PS(e)&&e.constructor===t)return e;var r=IS.f(t);return(0,r.resolve)(e),r.promise},CS=Cr,LS=QT,RS=dO.CONSTRUCTOR,MS=DS,NS=pt("Promise"),FS=!RS;CS({target:"Promise",stat:!0,forced:true},{resolve:function(t){return MS(FS&&this===NS?LS:this,t)}});var zS=F,US=Mt,qS=yO,YS=KT,WS=vE;Cr({target:"Promise",stat:!0,forced:vS},{allSettled:function(t){var e=this,r=qS.f(e),n=r.resolve,o=r.reject,i=YS((function(){var r=US(e.resolve),o=[],i=0,a=1;WS(t,(function(t){var s=i++,u=!1;a++,zS(r,e,t).then((function(t){u||(u=!0,o[s]={status:"fulfilled",value:t},--a||n(o))}),(function(t){u||(u=!0,o[s]={status:"rejected",reason:t},--a||n(o))}))})),--a||n(o)}));return i.error&&o(i.value),r.promise}});var GS=F,XS=Mt,VS=pt,BS=yO,HS=KT,$S=vE,JS="No one promise resolved";Cr({target:"Promise",stat:!0,forced:vS},{any:function(t){var e=this,r=VS("AggregateError"),n=BS.f(e),o=n.resolve,i=n.reject,a=HS((function(){var n=XS(e.resolve),a=[],s=0,u=1,c=!1;$S(t,(function(t){var f=s++,l=!1;u++,GS(n,e,t).then((function(t){l||c||(c=!0,o(t))}),(function(t){l||c||(l=!0,a[f]=t,--u||i(new r(a,JS)))}))})),--u||i(new r(a,JS))}));return a.error&&i(a.value),n.promise}});var KS=Cr,QS=QT,ZS=l,tk=pt,ek=C,rk=$E,nk=DS,ok=QS&&QS.prototype;KS({target:"Promise",proto:!0,real:!0,forced:!!QS&&ZS((function(){ok.finally.call({then:function(){}},(function(){}))}))},{finally:function(t){var e=rk(this,tk("Promise")),r=ek(t);return this.then(r?function(r){return nk(e,t()).then((function(){return r}))}:t,r?function(r){return nk(e,t()).then((function(){throw r}))}:t)}});var ik=st.Promise,ak=yO,sk=KT;Cr({target:"Promise",stat:!0,forced:!0},{try:function(t){var e=ak.f(this),r=sk(t);return(r.error?e.reject:e.resolve)(r.value),e.promise}});var uk=ik;Nw.exports=uk,Rw.exports=Mw;var ck={},fk={get exports(){return ck},set exports(t){ck=t}},lk={},pk=$d;({get exports(){return lk},set exports(t){lk=t}}).exports=pk,fk.exports=lk,function(t){var e=Aw.default,r=n,o=Yr,i=rw,a=_w,s=Pw,u=sw,c=Lw,f=ck,l=yv;function p(){t.exports=p=function(){return n},t.exports.__esModule=!0,t.exports.default=t.exports;var n={},h=Object.prototype,v=h.hasOwnProperty,d=r||function(t,e,r){t[e]=r.value},y="function"==typeof o?o:{},g=y.iterator||"@@iterator",m=y.asyncIterator||"@@asyncIterator",b=y.toStringTag||"@@toStringTag";function x(t,e,n){return r(t,e,{value:n,enumerable:!0,configurable:!0,writable:!0}),t[e]}try{x({},"")}catch(t){x=function(t,e,r){return t[e]=r}}function _(t,e,r,n){var o=e&&e.prototype instanceof T?e:T,a=i(o.prototype),s=new M(n||[]);return d(a,"_invoke",{value:D(t,r,s)}),a}function w(t,e,r){try{return{type:"normal",arg:t.call(e,r)}}catch(t){return{type:"throw",arg:t}}}n.wrap=_;var E={};function T(){}function O(){}function S(){}var k={};x(k,g,(function(){return this}));var j=a&&a(a(N([])));j&&j!==h&&v.call(j,g)&&(k=j);var A=S.prototype=T.prototype=i(k);function P(t){var e;s(e=["next","throw","return"]).call(e,(function(e){x(t,e,(function(t){return this._invoke(e,t)}))}))}function I(t,r){function n(o,i,a,s){var u=w(t[o],t,i);if("throw"!==u.type){var c=u.arg,f=c.value;return f&&"object"==e(f)&&v.call(f,"__await")?r.resolve(f.__await).then((function(t){n("next",t,a,s)}),(function(t){n("throw",t,a,s)})):r.resolve(f).then((function(t){c.value=t,a(c)}),(function(t){return n("throw",t,a,s)}))}s(u.arg)}var o;d(this,"_invoke",{value:function(t,e){function i(){return new r((function(r,o){n(t,e,r,o)}))}return o=o?o.then(i,i):i()}})}function D(t,e,r){var n="suspendedStart";return function(o,i){if("executing"===n)throw new Error("Generator is already running");if("completed"===n){if("throw"===o)throw i;return F()}for(r.method=o,r.arg=i;;){var a=r.delegate;if(a){var s=C(a,r);if(s){if(s===E)continue;return s}}if("next"===r.method)r.sent=r._sent=r.arg;else if("throw"===r.method){if("suspendedStart"===n)throw n="completed",r.arg;r.dispatchException(r.arg)}else"return"===r.method&&r.abrupt("return",r.arg);n="executing";var u=w(t,e,r);if("normal"===u.type){if(n=r.done?"completed":"suspendedYield",u.arg===E)continue;return{value:u.arg,done:r.done}}"throw"===u.type&&(n="completed",r.method="throw",r.arg=u.arg)}}}function C(t,e){var r=e.method,n=t.iterator[r];if(void 0===n)return e.delegate=null,"throw"===r&&t.iterator.return&&(e.method="return",e.arg=void 0,C(t,e),"throw"===e.method)||"return"!==r&&(e.method="throw",e.arg=new TypeError("The iterator does not provide a '"+r+"' method")),E;var o=w(n,t.iterator,e.arg);if("throw"===o.type)return e.method="throw",e.arg=o.arg,e.delegate=null,E;var i=o.arg;return i?i.done?(e[t.resultName]=i.value,e.next=t.nextLoc,"return"!==e.method&&(e.method="next",e.arg=void 0),e.delegate=null,E):i:(e.method="throw",e.arg=new TypeError("iterator result is not an object"),e.delegate=null,E)}function L(t){var e={tryLoc:t[0]};1 in t&&(e.catchLoc=t[1]),2 in t&&(e.finallyLoc=t[2],e.afterLoc=t[3]),this.tryEntries.push(e)}function R(t){var e=t.completion||{};e.type="normal",delete e.arg,t.completion=e}function M(t){this.tryEntries=[{tryLoc:"root"}],s(t).call(t,L,this),this.reset(!0)}function N(t){if(t){var e=t[g];if(e)return e.call(t);if("function"==typeof t.next)return t;if(!isNaN(t.length)){var r=-1,n=function e(){for(;++r<t.length;)if(v.call(t,r))return e.value=t[r],e.done=!1,e;return e.value=void 0,e.done=!0,e};return n.next=n}}return{next:F}}function F(){return{value:void 0,done:!0}}return O.prototype=S,d(A,"constructor",{value:S,configurable:!0}),d(S,"constructor",{value:O,configurable:!0}),O.displayName=x(S,b,"GeneratorFunction"),n.isGeneratorFunction=function(t){var e="function"==typeof t&&t.constructor;return!!e&&(e===O||"GeneratorFunction"===(e.displayName||e.name))},n.mark=function(t){return u?u(t,S):(t.__proto__=S,x(t,b,"GeneratorFunction")),t.prototype=i(A),t},n.awrap=function(t){return{__await:t}},P(I.prototype),x(I.prototype,m,(function(){return this})),n.AsyncIterator=I,n.async=function(t,e,r,o,i){void 0===i&&(i=c);var a=new I(_(t,e,r,o),i);return n.isGeneratorFunction(e)?a:a.next().then((function(t){return t.done?t.value:a.next()}))},P(A),x(A,b,"Generator"),x(A,g,(function(){return this})),x(A,"toString",(function(){return"[object Generator]"})),n.keys=function(t){var e=Object(t),r=[];for(var n in e)r.push(n);return f(r).call(r),function t(){for(;r.length;){var n=r.pop();if(n in e)return t.value=n,t.done=!1,t}return t.done=!0,t}},n.values=N,M.prototype={constructor:M,reset:function(t){var e;if(this.prev=0,this.next=0,this.sent=this._sent=void 0,this.done=!1,this.delegate=null,this.method="next",this.arg=void 0,s(e=this.tryEntries).call(e,R),!t)for(var r in this)"t"===r.charAt(0)&&v.call(this,r)&&!isNaN(+l(r).call(r,1))&&(this[r]=void 0)},stop:function(){this.done=!0;var t=this.tryEntries[0].completion;if("throw"===t.type)throw t.arg;return this.rval},dispatchException:function(t){if(this.done)throw t;var e=this;function r(r,n){return i.type="throw",i.arg=t,e.next=r,n&&(e.method="next",e.arg=void 0),!!n}for(var n=this.tryEntries.length-1;n>=0;--n){var o=this.tryEntries[n],i=o.completion;if("root"===o.tryLoc)return r("end");if(o.tryLoc<=this.prev){var a=v.call(o,"catchLoc"),s=v.call(o,"finallyLoc");if(a&&s){if(this.prev<o.catchLoc)return r(o.catchLoc,!0);if(this.prev<o.finallyLoc)return r(o.finallyLoc)}else if(a){if(this.prev<o.catchLoc)return r(o.catchLoc,!0)}else{if(!s)throw new Error("try statement without catch or finally");if(this.prev<o.finallyLoc)return r(o.finallyLoc)}}}},abrupt:function(t,e){for(var r=this.tryEntries.length-1;r>=0;--r){var n=this.tryEntries[r];if(n.tryLoc<=this.prev&&v.call(n,"finallyLoc")&&this.prev<n.finallyLoc){var o=n;break}}o&&("break"===t||"continue"===t)&&o.tryLoc<=e&&e<=o.finallyLoc&&(o=null);var i=o?o.completion:{};return i.type=t,i.arg=e,o?(this.method="next",this.next=o.finallyLoc,E):this.complete(i)},complete:function(t,e){if("throw"===t.type)throw t.arg;return"break"===t.type||"continue"===t.type?this.next=t.arg:"return"===t.type?(this.rval=this.arg=t.arg,this.method="return",this.next="end"):"normal"===t.type&&e&&(this.next=e),E},finish:function(t){for(var e=this.tryEntries.length-1;e>=0;--e){var r=this.tryEntries[e];if(r.finallyLoc===t)return this.complete(r.completion,r.afterLoc),R(r),E}},catch:function(t){for(var e=this.tryEntries.length-1;e>=0;--e){var r=this.tryEntries[e];if(r.tryLoc===t){var n=r.completion;if("throw"===n.type){var o=n.arg;R(r)}return o}}throw new Error("illegal catch attempt")},delegateYield:function(t,e,r){return this.delegate={iterator:N(t),resultName:e,nextLoc:r},"next"===this.method&&(this.arg=void 0),E}},n}t.exports=p,t.exports.__esModule=!0,t.exports.default=t.exports}(jw);var hk=kw(),vk=hk;try{regeneratorRuntime=hk}catch(t){"object"==typeof globalThis?globalThis.regeneratorRuntime=hk:Function("r","regeneratorRuntime = r")(hk)}var dk={},yk={get exports(){return dk},set exports(t){dk=t}},gk={},mk={get exports(){return gk},set exports(t){gk=t}},bk=l((function(){if("function"==typeof ArrayBuffer){var t=new ArrayBuffer(8);Object.isExtensible(t)&&Object.defineProperty(t,"a",{value:8})}})),xk=l,_k=at,wk=S,Ek=bk,Tk=Object.isExtensible,Ok=xk((function(){Tk(1)}))||Ek?function(t){return!!_k(t)&&((!Ek||"ArrayBuffer"!=wk(t))&&(!Tk||Tk(t)))}:Tk,Sk=!l((function(){return Object.isExtensible(Object.preventExtensions({}))})),kk=Cr,jk=w,Ak=_o,Pk=at,Ik=ne,Dk=rr.f,Ck=ni,Lk=ai,Rk=Ok,Mk=Sk,Nk=!1,Fk=ue("meta"),zk=0,Uk=function(t){Dk(t,Fk,{value:{objectID:"O"+zk++,weakData:{}}})},qk=mk.exports={enable:function(){qk.enable=function(){},Nk=!0;var t=Ck.f,e=jk([].splice),r={};r[Fk]=1,t(r).length&&(Ck.f=function(r){for(var n=t(r),o=0,i=n.length;o<i;o++)if(n[o]===Fk){e(n,o,1);break}return n},kk({target:"Object",stat:!0,forced:!0},{getOwnPropertyNames:Lk.f}))},fastKey:function(t,e){if(!Pk(t))return"symbol"==typeof t?t:("string"==typeof t?"S":"P")+t;if(!Ik(t,Fk)){if(!Rk(t))return"F";if(!e)return"E";Uk(t)}return t[Fk].objectID},getWeakData:function(t,e){if(!Ik(t,Fk)){if(!Rk(t))return!0;if(!e)return!1;Uk(t)}return t[Fk].weakData},onFreeze:function(t){return Mk&&Nk&&Rk(t)&&!Ik(t,Fk)&&Uk(t),t}};Ak[Fk]=!0;var Yk=Cr,Wk=f,Gk=gk,Xk=l,Vk=_r,Bk=vE,Hk=GE,$k=C,Jk=at,Kk=Vi,Qk=rr.f,Zk=ya.forEach,tj=R,ej=ua.set,rj=ua.getterFor,nj=function(t,e,r){var n,o=-1!==t.indexOf("Map"),i=-1!==t.indexOf("Weak"),a=o?"set":"add",s=Wk[t],u=s&&s.prototype,c={};if(tj&&$k(s)&&(i||u.forEach&&!Xk((function(){(new s).entries().next()})))){var f=(n=e((function(e,r){ej(Hk(e,f),{type:t,collection:new s}),null!=r&&Bk(r,e[a],{that:e,AS_ENTRIES:o})}))).prototype,l=rj(t);Zk(["add","clear","delete","forEach","get","has","set","keys","values","entries"],(function(t){var e="add"==t||"set"==t;!(t in u)||i&&"clear"==t||Vk(f,t,(function(r,n){var o=l(this).collection;if(!e&&i&&!Jk(r))return"get"==t&&void 0;var a=o[t](0===r?0:r,n);return e?this:a}))})),i||Qk(f,"size",{configurable:!0,get:function(){return l(this).collection.size}})}else n=r.getConstructor(e,t,o,a),Gk.enable();return Kk(n,t,!1,!0),c[t]=n,Yk({global:!0,forced:!0},c),i||r.setStrong(n,t,o),n},oj=xi,ij=ri,aj=wi,sj=function(t,e,r){for(var n in e)r&&r.unsafe&&t[n]?t[n]=e[n]:oj(t,n,e[n],r);return t},uj=er,cj=GE,fj=K,lj=vE,pj=kc,hj=jc,vj=qE,dj=R,yj=gk.fastKey,gj=ua.set,mj=ua.getterFor,bj={getConstructor:function(t,e,r,n){var o=t((function(t,o){cj(t,i),gj(t,{type:e,index:ij(null),first:void 0,last:void 0,size:0}),dj||(t.size=0),fj(o)||lj(o,t[n],{that:t,AS_ENTRIES:r})})),i=o.prototype,a=mj(e),s=function(t,e,r){var n,o,i=a(t),s=u(t,e);return s?s.value=r:(i.last=s={index:o=yj(e,!0),key:e,value:r,previous:n=i.last,next:void 0,removed:!1},i.first||(i.first=s),n&&(n.next=s),dj?i.size++:t.size++,"F"!==o&&(i.index[o]=s)),t},u=function(t,e){var r,n=a(t),o=yj(e);if("F"!==o)return n.index[o];for(r=n.first;r;r=r.next)if(r.key==e)return r};return sj(i,{clear:function(){for(var t=a(this),e=t.index,r=t.first;r;)r.removed=!0,r.previous&&(r.previous=r.previous.next=void 0),delete e[r.index],r=r.next;t.first=t.last=void 0,dj?t.size=0:this.size=0},delete:function(t){var e=this,r=a(e),n=u(e,t);if(n){var o=n.next,i=n.previous;delete r.index[n.index],n.removed=!0,i&&(i.next=o),o&&(o.previous=i),r.first==n&&(r.first=o),r.last==n&&(r.last=i),dj?r.size--:e.size--}return!!n},forEach:function(t){for(var e,r=a(this),n=uj(t,arguments.length>1?arguments[1]:void 0);e=e?e.next:r.first;)for(n(e.value,e.key,this);e&&e.removed;)e=e.previous},has:function(t){return!!u(this,t)}}),sj(i,r?{get:function(t){var e=u(this,t);return e&&e.value},set:function(t,e){return s(this,0===t?0:t,e)}}:{add:function(t){return s(this,t=0===t?0:t,t)}}),dj&&aj(i,"size",{configurable:!0,get:function(){return a(this).size}}),o},setStrong:function(t,e,r){var n=e+" Iterator",o=mj(e),i=mj(n);pj(t,e,(function(t,e){gj(this,{type:n,target:t,state:o(t),kind:e,last:void 0})}),(function(){for(var t=i(this),e=t.kind,r=t.last;r&&r.removed;)r=r.previous;return t.target&&(t.last=r=r?r.next:t.state.first)?hj("keys"==e?r.key:"values"==e?r.value:[r.key,r.value],!1):(t.target=void 0,hj(void 0,!0))}),r?"entries":"values",!r,!0),vj(e)}};nj("Map",(function(t){return function(){return t(this,arguments.length?arguments[0]:void 0)}}),bj);var xj=st.Map;yk.exports=xj;var _j=r(dk),wj={},Ej={get exports(){return wj},set exports(t){wj=t}},Tj=ya.some;Cr({target:"Array",proto:!0,forced:!Pl("some")},{some:function(t){return Tj(this,t,arguments.length>1?arguments[1]:void 0)}});var Oj=hl("Array").some,Sj=ht,kj=Oj,jj=Array.prototype,Aj=function(t){var e=t.some;return t===jj||Sj(jj,t)&&e===jj.some?kj:e};Ej.exports=Aj;var Pj=r(wj),Ij={},Dj={get exports(){return Ij},set exports(t){Ij=t}},Cj=hl("Array").keys,Lj=gn,Rj=ne,Mj=ht,Nj=Cj,Fj=Array.prototype,zj={DOMTokenList:!0,NodeList:!0},Uj=function(t){var e=t.keys;return t===Fj||Mj(Fj,t)&&e===Fj.keys||Rj(zj,Lj(t))?Nj:e};Dj.exports=Uj;var qj=r(Ij),Yj={},Wj={get exports(){return Yj},set exports(t){Yj=t}},Gj=pi,Xj=Math.floor,Vj=function(t,e){var r=t.length,n=Xj(r/2);return r<8?Bj(t,e):Hj(t,Vj(Gj(t,0,n),e),Vj(Gj(t,n),e),e)},Bj=function(t,e){for(var r,n,o=t.length,i=1;i<o;){for(n=i,r=t[i];n&&e(t[n-1],r)>0;)t[n]=t[--n];n!==i++&&(t[n]=r)}return t},Hj=function(t,e,r,n){for(var o=e.length,i=r.length,a=0,s=0;a<o||s<i;)t[a+s]=a<o&&s<i?n(e[a],r[s])<=0?e[a++]:r[s++]:a<o?e[a++]:r[s++];return t},$j=Vj,Jj=vt.match(/firefox\/(\d+)/i),Kj=!!Jj&&+Jj[1],Qj=/MSIE|Trident/.test(vt),Zj=vt.match(/AppleWebKit\/(\d+)\./),tA=!!Zj&&+Zj[1],eA=Cr,rA=w,nA=Mt,oA=te,iA=en,aA=ay,sA=co,uA=l,cA=$j,fA=Pl,lA=Kj,pA=Qj,hA=_t,vA=tA,dA=[],yA=rA(dA.sort),gA=rA(dA.push),mA=uA((function(){dA.sort(void 0)})),bA=uA((function(){dA.sort(null)})),xA=fA("sort"),_A=!uA((function(){if(hA)return hA<70;if(!(lA&&lA>3)){if(pA)return!0;if(vA)return vA<603;var t,e,r,n,o="";for(t=65;t<76;t++){switch(e=String.fromCharCode(t),t){case 66:case 69:case 70:case 72:r=3;break;case 68:case 71:r=4;break;default:r=2}for(n=0;n<47;n++)dA.push({k:e+n,v:r})}for(dA.sort((function(t,e){return e.v-t.v})),n=0;n<dA.length;n++)e=dA[n].k.charAt(0),o.charAt(o.length-1)!==e&&(o+=e);return"DGBEFHACIJK"!==o}}));eA({target:"Array",proto:!0,forced:mA||!bA||!xA||!_A},{sort:function(t){void 0!==t&&nA(t);var e=oA(this);if(_A)return void 0===t?yA(e):yA(e,t);var r,n,o=[],i=iA(e);for(n=0;n<i;n++)n in e&&gA(o,e[n]);for(cA(o,function(t){return function(e,r){return void 0===r?-1:void 0===e?1:void 0!==t?+t(e,r)||0:sA(e)>sA(r)?1:-1}}(t)),r=iA(o),n=0;n<r;)e[n]=o[n++];for(;n<i;)aA(e,n++);return e}});var wA=hl("Array").sort,EA=ht,TA=wA,OA=Array.prototype,SA=function(t){var e=t.sort;return t===OA||EA(OA,t)&&e===OA.sort?TA:e};Wj.exports=SA;var kA=r(Yj),jA={},AA={get exports(){return jA},set exports(t){jA=t}},PA=hl("Array").values,IA=gn,DA=ne,CA=ht,LA=PA,RA=Array.prototype,MA={DOMTokenList:!0,NodeList:!0},NA=function(t){var e=t.values;return t===RA||CA(RA,t)&&e===RA.values||DA(MA,IA(t))?LA:e};AA.exports=NA;var FA=r(jA),zA={};({get exports(){return zA},set exports(t){zA=t}}).exports=Nf;var UA=r(zA),qA={},YA={get exports(){return qA},set exports(t){qA=t}},WA=hl("Array").entries,GA=gn,XA=ne,VA=ht,BA=WA,HA=Array.prototype,$A={DOMTokenList:!0,NodeList:!0},JA=function(t){var e=t.entries;return t===HA||VA(HA,t)&&e===HA.entries||XA($A,GA(t))?BA:e};YA.exports=JA;var KA=r(qA);let QA;const ZA=new Uint8Array(16);function tP(){if(!QA&&(QA="undefined"!=typeof crypto&&crypto.getRandomValues&&crypto.getRandomValues.bind(crypto),!QA))throw new Error("crypto.getRandomValues() not supported. See https://github.com/uuidjs/uuid#getrandomvalues-not-supported");return QA(ZA)}const eP=[];for(let t=0;t<256;++t)eP.push((t+256).toString(16).slice(1));var rP={randomUUID:"undefined"!=typeof crypto&&crypto.randomUUID&&crypto.randomUUID.bind(crypto)};function nP(t,e,r){if(rP.randomUUID&&!e&&!t)return rP.randomUUID();const n=(t=t||{}).random||(t.rng||tP)();if(n[6]=15&n[6]|64,n[8]=63&n[8]|128,e){r=r||0;for(let t=0;t<16;++t)e[r+t]=n[t];return e}return function(t,e=0){return(eP[t[e+0]]+eP[t[e+1]]+eP[t[e+2]]+eP[t[e+3]]+"-"+eP[t[e+4]]+eP[t[e+5]]+"-"+eP[t[e+6]]+eP[t[e+7]]+"-"+eP[t[e+8]]+eP[t[e+9]]+"-"+eP[t[e+10]]+eP[t[e+11]]+eP[t[e+12]]+eP[t[e+13]]+eP[t[e+14]]+eP[t[e+15]]).toLowerCase()}(n)}function oP(t){return"string"==typeof t||"number"==typeof t}var iP=function(){function e(r){t(this,e),Jf(this,"delay",void 0),Jf(this,"max",void 0),Jf(this,"_queue",[]),Jf(this,"_timeout",null),Jf(this,"_extended",null),this.delay=null,this.max=1/0,this.setOptions(r)}return $f(e,[{key:"setOptions",value:function(t){t&&void 0!==t.delay&&(this.delay=t.delay),t&&void 0!==t.max&&(this.max=t.max),this._flushIfNeeded()}},{key:"destroy",value:function(){if(this.flush(),this._extended){for(var t=this._extended.object,e=this._extended.methods,r=0;r<e.length;r++){var n=e[r];n.original?t[n.name]=n.original:delete t[n.name]}this._extended=null}}},{key:"replace",value:function(t,e){var r=this,n=t[e];if(!n)throw new Error("Method "+e+" undefined");t[e]=function(){for(var t=arguments.length,e=new Array(t),o=0;o<t;o++)e[o]=arguments[o];r.queue({args:e,fn:n,context:this})}}},{key:"queue",value:function(t){"function"==typeof t?this._queue.push({fn:t}):this._queue.push(t),this._flushIfNeeded()}},{key:"_flushIfNeeded",value:function(){var t=this;this._queue.length>this.max&&this.flush(),null!=this._timeout&&(clearTimeout(this._timeout),this._timeout=null),this.queue.length>0&&"number"==typeof this.delay&&(this._timeout=rb((function(){t.flush()}),this.delay))}},{key:"flush",value:function(){var t,e;Fd(t=Oy(e=this._queue).call(e,0)).call(t,(function(t){t.fn.apply(t.context||t.fn,t.args||[])}))}}],[{key:"extend",value:function(t,r){var n=new e(r);if(void 0!==t.flush)throw new Error("Target object already has a property flush");t.flush=function(){n.flush()};var o=[{name:"flush",original:void 0}];if(r&&r.replace)for(var i=0;i<r.replace.length;i++){var a=r.replace[i];o.push({name:a,original:t[a]}),n.replace(t,a)}return n._extended={object:t,methods:o},n}}]),e}(),aP=function(){function e(){t(this,e),Jf(this,"_subscribers",{"*":[],add:[],remove:[],update:[]}),Jf(this,"subscribe",e.prototype.on),Jf(this,"unsubscribe",e.prototype.off)}return $f(e,[{key:"_trigger",value:function(t,e,r){var n,o;if("*"===t)throw new Error("Cannot trigger event *");Fd(n=id(o=[]).call(o,$v(this._subscribers[t]),$v(this._subscribers["*"]))).call(n,(function(n){n(t,e,null!=r?r:null)}))}},{key:"on",value:function(t,e){"function"==typeof e&&this._subscribers[t].push(e)}},{key:"off",value:function(t,e){var r;this._subscribers[t]=Bl(r=this._subscribers[t]).call(r,(function(t){return t!==e}))}}]),e}(),sP={},uP={get exports(){return sP},set exports(t){sP=t}};nj("Set",(function(t){return function(){return t(this,arguments.length?arguments[0]:void 0)}}),bj);var cP=st.Set;uP.exports=cP;var fP=r(sP),lP={},pP={get exports(){return lP},set exports(t){lP=t}},hP={},vP=Hp;({get exports(){return hP},set exports(t){hP=t}}).exports=vP,pP.exports=hP;var dP,yP=r(lP);function gP(t,e){var r=void 0!==Kv&&mh(t)||t["@@iterator"];if(!r){if(hd(t)||(r=function(t,e){var r;if(!t)return;if("string"==typeof t)return mP(t,e);var n=sd(r=Object.prototype.toString.call(t)).call(r,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return hh(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return mP(t,e)}(t))||e&&t&&"number"==typeof t.length){r&&(t=r);var n=0,o=function(){};return{s:o,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var i,a=!0,s=!1;return{s:function(){r=r.call(t)},n:function(){var t=r.next();return a=t.done,t},e:function(t){s=!0,i=t},f:function(){try{a||null==r.return||r.return()}finally{if(s)throw i}}}}function mP(t,e){(null==e||e>t.length)&&(e=t.length);for(var r=0,n=new Array(e);r<e;r++)n[r]=t[r];return n}dP=UA;var bP=function(){function e(r){t(this,e),Jf(this,"_pairs",void 0),this._pairs=r}return $f(e,[{key:dP,value:vk.mark((function t(){var e,r,n,o,i;return vk.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=gP(this._pairs),t.prev=1,e.s();case 3:if((r=e.n()).done){t.next=9;break}return n=Hv(r.value,2),o=n[0],i=n[1],t.next=7,[o,i];case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"entries",value:vk.mark((function t(){var e,r,n,o,i;return vk.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=gP(this._pairs),t.prev=1,e.s();case 3:if((r=e.n()).done){t.next=9;break}return n=Hv(r.value,2),o=n[0],i=n[1],t.next=7,[o,i];case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"keys",value:vk.mark((function t(){var e,r,n,o;return vk.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=gP(this._pairs),t.prev=1,e.s();case 3:if((r=e.n()).done){t.next=9;break}return n=Hv(r.value,1),o=n[0],t.next=7,o;case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"values",value:vk.mark((function t(){var e,r,n,o;return vk.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=gP(this._pairs),t.prev=1,e.s();case 3:if((r=e.n()).done){t.next=9;break}return n=Hv(r.value,2),o=n[1],t.next=7,o;case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"toIdArray",value:function(){var t;return rp(t=$v(this._pairs)).call(t,(function(t){return t[0]}))}},{key:"toItemArray",value:function(){var t;return rp(t=$v(this._pairs)).call(t,(function(t){return t[1]}))}},{key:"toEntryArray",value:function(){return $v(this._pairs)}},{key:"toObjectMap",value:function(){var t,e=km(null),r=gP(this._pairs);try{for(r.s();!(t=r.n()).done;){var n=Hv(t.value,2),o=n[0],i=n[1];e[o]=i}}catch(t){r.e(t)}finally{r.f()}return e}},{key:"toMap",value:function(){return new _j(this._pairs)}},{key:"toIdSet",value:function(){return new fP(this.toIdArray())}},{key:"toItemSet",value:function(){return new fP(this.toItemArray())}},{key:"cache",value:function(){return new e($v(this._pairs))}},{key:"distinct",value:function(t){var e,r=new fP,n=gP(this._pairs);try{for(n.s();!(e=n.n()).done;){var o=Hv(e.value,2),i=o[0],a=o[1];r.add(t(a,i))}}catch(t){n.e(t)}finally{n.f()}return r}},{key:"filter",value:function(t){var r=this._pairs;return new e(Jf({},UA,vk.mark((function e(){var n,o,i,a,s;return vk.wrap((function(e){for(;;)switch(e.prev=e.next){case 0:n=gP(r),e.prev=1,n.s();case 3:if((o=n.n()).done){e.next=10;break}if(i=Hv(o.value,2),a=i[0],s=i[1],!t(s,a)){e.next=8;break}return e.next=8,[a,s];case 8:e.next=3;break;case 10:e.next=15;break;case 12:e.prev=12,e.t0=e.catch(1),n.e(e.t0);case 15:return e.prev=15,n.f(),e.finish(15);case 18:case"end":return e.stop()}}),e,null,[[1,12,15,18]])}))))}},{key:"forEach",value:function(t){var e,r=gP(this._pairs);try{for(r.s();!(e=r.n()).done;){var n=Hv(e.value,2),o=n[0];t(n[1],o)}}catch(t){r.e(t)}finally{r.f()}}},{key:"map",value:function(t){var r=this._pairs;return new e(Jf({},UA,vk.mark((function e(){var n,o,i,a,s;return vk.wrap((function(e){for(;;)switch(e.prev=e.next){case 0:n=gP(r),e.prev=1,n.s();case 3:if((o=n.n()).done){e.next=9;break}return i=Hv(o.value,2),a=i[0],s=i[1],e.next=7,[a,t(s,a)];case 7:e.next=3;break;case 9:e.next=14;break;case 11:e.prev=11,e.t0=e.catch(1),n.e(e.t0);case 14:return e.prev=14,n.f(),e.finish(14);case 17:case"end":return e.stop()}}),e,null,[[1,11,14,17]])}))))}},{key:"max",value:function(t){var e=yP(this._pairs),r=e.next();if(r.done)return null;for(var n=r.value[1],o=t(r.value[1],r.value[0]);!(r=e.next()).done;){var i=Hv(r.value,2),a=i[0],s=i[1],u=t(s,a);u>o&&(o=u,n=s)}return n}},{key:"min",value:function(t){var e=yP(this._pairs),r=e.next();if(r.done)return null;for(var n=r.value[1],o=t(r.value[1],r.value[0]);!(r=e.next()).done;){var i=Hv(r.value,2),a=i[0],s=i[1],u=t(s,a);u<o&&(o=u,n=s)}return n}},{key:"reduce",value:function(t,e){var r,n=gP(this._pairs);try{for(n.s();!(r=n.n()).done;){var o=Hv(r.value,2),i=o[0];e=t(e,o[1],i)}}catch(t){n.e(t)}finally{n.f()}return e}},{key:"sort",value:function(t){var r=this;return new e(Jf({},UA,(function(){var e;return yP(kA(e=$v(r._pairs)).call(e,(function(e,r){var n=Hv(e,2),o=n[0],i=n[1],a=Hv(r,2),s=a[0],u=a[1];return t(i,u,o,s)})))})))}}]),e}();function xP(t,e){var r=bd(t);if(wh){var n=wh(t);e&&(n=Bl(n).call(n,(function(e){return Rh(t,e).enumerable}))),r.push.apply(r,n)}return r}function _P(t){for(var e=1;e<arguments.length;e++){var r,n,o=null!=arguments[e]?arguments[e]:{};e%2?Fd(r=xP(Object(o),!0)).call(r,(function(e){Jf(t,e,o[e])})):$h?av(t,$h(o)):Fd(n=xP(Object(o))).call(n,(function(e){uv(t,e,Rh(o,e))}))}return t}function wP(t,e){var r=void 0!==Kv&&mh(t)||t["@@iterator"];if(!r){if(hd(t)||(r=function(t,e){var r;if(!t)return;if("string"==typeof t)return EP(t,e);var n=sd(r=Object.prototype.toString.call(t)).call(r,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return hh(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return EP(t,e)}(t))||e&&t&&"number"==typeof t.length){r&&(t=r);var n=0,o=function(){};return{s:o,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var i,a=!0,s=!1;return{s:function(){r=r.call(t)},n:function(){var t=r.next();return a=t.done,t},e:function(t){s=!0,i=t},f:function(){try{a||null==r.return||r.return()}finally{if(s)throw i}}}}function EP(t,e){(null==e||e>t.length)&&(e=t.length);for(var r=0,n=new Array(e);r<e;r++)n[r]=t[r];return n}function TP(t){var e=function(){if("undefined"==typeof Reflect||!tw)return!1;if(tw.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(tw(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var r,n=Sw(t);if(e){var o=Sw(this).constructor;r=tw(n,arguments,o)}else r=n.apply(this,arguments);return xw(this,r)}}var OP=function(e){bw(n,aP);var r=TP(n);function n(e,o){var i;return t(this,n),Jf(ew(i=r.call(this)),"flush",void 0),Jf(ew(i),"length",void 0),Jf(ew(i),"_options",void 0),Jf(ew(i),"_data",void 0),Jf(ew(i),"_idProp",void 0),Jf(ew(i),"_queue",null),e&&!hd(e)&&(o=e,e=[]),i._options=o||{},i._data=new _j,i.length=0,i._idProp=i._options.fieldId||"id",e&&e.length&&i.add(e),i.setOptions(o),i}return $f(n,[{key:"idProp",get:function(){return this._idProp}},{key:"setOptions",value:function(t){t&&void 0!==t.queue&&(!1===t.queue?this._queue&&(this._queue.destroy(),this._queue=null):(this._queue||(this._queue=iP.extend(this,{replace:["add","update","remove"]})),t.queue&&"object"===Uf(t.queue)&&this._queue.setOptions(t.queue)))}},{key:"add",value:function(t,e){var r,n=this,o=[];if(hd(t)){var i=rp(t).call(t,(function(t){return t[n._idProp]}));if(Pj(i).call(i,(function(t){return n._data.has(t)})))throw new Error("A duplicate id was found in the parameter array.");for(var a=0,s=t.length;a<s;a++)r=this._addItem(t[a]),o.push(r)}else{if(!t||"object"!==Uf(t))throw new Error("Unknown dataType");r=this._addItem(t),o.push(r)}return o.length&&this._trigger("add",{items:o},e),o}},{key:"update",value:function(t,e){var r=this,n=[],o=[],i=[],a=[],s=this._idProp,u=function(t){var e=t[s];if(null!=e&&r._data.has(e)){var u=t,c=Wy({},r._data.get(e)),f=r._updateItem(u);o.push(f),a.push(u),i.push(c)}else{var l=r._addItem(t);n.push(l)}};if(hd(t))for(var c=0,f=t.length;c<f;c++)t[c]&&"object"===Uf(t[c])?u(t[c]):console.warn("Ignoring input item, which is not an object at index "+c);else{if(!t||"object"!==Uf(t))throw new Error("Unknown dataType");u(t)}if(n.length&&this._trigger("add",{items:n},e),o.length){var l={items:o,oldData:i,data:a};this._trigger("update",l,e)}return id(n).call(n,o)}},{key:"updateOnly",value:function(t,e){var r,n=this;hd(t)||(t=[t]);var o=rp(r=rp(t).call(t,(function(t){var e=n._data.get(t[n._idProp]);if(null==e)throw new Error("Updating non-existent items is not allowed.");return{oldData:e,update:t}}))).call(r,(function(t){var e=t.oldData,r=t.update,o=e[n._idProp],i=function(t){for(var e,r=arguments.length,n=new Array(r>1?r-1:0),o=1;o<r;o++)n[o-1]=arguments[o];return k_.apply(void 0,id(e=[{},t]).call(e,n))}(e,r);return n._data.set(o,i),{id:o,oldData:e,updatedData:i}}));if(o.length){var i={items:rp(o).call(o,(function(t){return t.id})),oldData:rp(o).call(o,(function(t){return t.oldData})),data:rp(o).call(o,(function(t){return t.updatedData}))};return this._trigger("update",i,e),i.items}return[]}},{key:"get",value:function(t,e){var r=void 0,n=void 0,o=void 0;oP(t)?(r=t,o=e):hd(t)?(n=t,o=e):o=t;var i,a=o&&"Object"===o.returnType?"Object":"Array",s=o&&Bl(o),u=[],c=void 0,f=void 0,l=void 0;if(null!=r)(c=this._data.get(r))&&s&&!s(c)&&(c=void 0);else if(null!=n)for(var p=0,h=n.length;p<h;p++)null==(c=this._data.get(n[p]))||s&&!s(c)||u.push(c);else for(var v,d=0,y=(f=$v(qj(v=this._data).call(v))).length;d<y;d++)l=f[d],null==(c=this._data.get(l))||s&&!s(c)||u.push(c);if(o&&o.order&&null==r&&this._sort(u,o.order),o&&o.fields){var g=o.fields;if(null!=r&&null!=c)c=this._filterFields(c,g);else for(var m=0,b=u.length;m<b;m++)u[m]=this._filterFields(u[m],g)}if("Object"==a){for(var x={},_=0,w=u.length;_<w;_++){var E=u[_];x[E[this._idProp]]=E}return x}return null!=r?null!==(i=c)&&void 0!==i?i:null:u}},{key:"getIds",value:function(t){var e=this._data,r=t&&Bl(t),n=t&&t.order,o=$v(qj(e).call(e)),i=[];if(r)if(n){for(var a=[],s=0,u=o.length;s<u;s++){var c=o[s],f=this._data.get(c);null!=f&&r(f)&&a.push(f)}this._sort(a,n);for(var l=0,p=a.length;l<p;l++)i.push(a[l][this._idProp])}else for(var h=0,v=o.length;h<v;h++){var d=o[h],y=this._data.get(d);null!=y&&r(y)&&i.push(y[this._idProp])}else if(n){for(var g=[],m=0,b=o.length;m<b;m++){var x=o[m];g.push(e.get(x))}this._sort(g,n);for(var _=0,w=g.length;_<w;_++)i.push(g[_][this._idProp])}else for(var E=0,T=o.length;E<T;E++){var O=o[E],S=e.get(O);null!=S&&i.push(S[this._idProp])}return i}},{key:"getDataSet",value:function(){return this}},{key:"forEach",value:function(t,e){var r=e&&Bl(e),n=this._data,o=$v(qj(n).call(n));if(e&&e.order)for(var i=this.get(e),a=0,s=i.length;a<s;a++){var u=i[a];t(u,u[this._idProp])}else for(var c=0,f=o.length;c<f;c++){var l=o[c],p=this._data.get(l);null==p||r&&!r(p)||t(p,l)}}},{key:"map",value:function(t,e){for(var r=e&&Bl(e),n=[],o=this._data,i=$v(qj(o).call(o)),a=0,s=i.length;a<s;a++){var u=i[a],c=this._data.get(u);null==c||r&&!r(c)||n.push(t(c,u))}return e&&e.order&&this._sort(n,e.order),n}},{key:"_filterFields",value:function(t,e){var r;return t?Fl(r=hd(e)?e:bd(e)).call(r,(function(e,r){return e[r]=t[r],e}),{}):t}},{key:"_sort",value:function(t,e){if("string"==typeof e){var r=e;kA(t).call(t,(function(t,e){var n=t[r],o=e[r];return n>o?1:n<o?-1:0}))}else{if("function"!=typeof e)throw new TypeError("Order must be a function or a string");kA(t).call(t,e)}}},{key:"remove",value:function(t,e){for(var r=[],n=[],o=hd(t)?t:[t],i=0,a=o.length;i<a;i++){var s=this._remove(o[i]);if(s){var u=s[this._idProp];null!=u&&(r.push(u),n.push(s))}}return r.length&&this._trigger("remove",{items:r,oldData:n},e),r}},{key:"_remove",value:function(t){var e;if(oP(t)?e=t:t&&"object"===Uf(t)&&(e=t[this._idProp]),null!=e&&this._data.has(e)){var r=this._data.get(e)||null;return this._data.delete(e),--this.length,r}return null}},{key:"clear",value:function(t){for(var e,r=$v(qj(e=this._data).call(e)),n=[],o=0,i=r.length;o<i;o++)n.push(this._data.get(r[o]));return this._data.clear(),this.length=0,this._trigger("remove",{items:r,oldData:n},t),r}},{key:"max",value:function(t){var e,r,n=null,o=null,i=wP(FA(e=this._data).call(e));try{for(i.s();!(r=i.n()).done;){var a=r.value,s=a[t];"number"==typeof s&&(null==o||s>o)&&(n=a,o=s)}}catch(t){i.e(t)}finally{i.f()}return n||null}},{key:"min",value:function(t){var e,r,n=null,o=null,i=wP(FA(e=this._data).call(e));try{for(i.s();!(r=i.n()).done;){var a=r.value,s=a[t];"number"==typeof s&&(null==o||s<o)&&(n=a,o=s)}}catch(t){i.e(t)}finally{i.f()}return n||null}},{key:"distinct",value:function(t){for(var e=this._data,r=$v(qj(e).call(e)),n=[],o=0,i=0,a=r.length;i<a;i++){for(var s=r[i],u=e.get(s)[t],c=!1,f=0;f<o;f++)if(n[f]==u){c=!0;break}c||void 0===u||(n[o]=u,o++)}return n}},{key:"_addItem",value:function(t){var e=function(t,e){return null==t[e]&&(t[e]=nP()),t}(t,this._idProp),r=e[this._idProp];if(this._data.has(r))throw new Error("Cannot add item: item with id "+r+" already exists");return this._data.set(r,e),++this.length,r}},{key:"_updateItem",value:function(t){var e=t[this._idProp];if(null==e)throw new Error("Cannot update item: item has no id (item: "+Cm(t)+")");var r=this._data.get(e);if(!r)throw new Error("Cannot update item: no item with id "+e+" found");return this._data.set(e,_P(_P({},r),t)),e}},{key:"stream",value:function(t){if(t){var e=this._data;return new bP(Jf({},UA,vk.mark((function r(){var n,o,i,a;return vk.wrap((function(r){for(;;)switch(r.prev=r.next){case 0:n=wP(t),r.prev=1,n.s();case 3:if((o=n.n()).done){r.next=11;break}if(i=o.value,null==(a=e.get(i))){r.next=9;break}return r.next=9,[i,a];case 9:r.next=3;break;case 11:r.next=16;break;case 13:r.prev=13,r.t0=r.catch(1),n.e(r.t0);case 16:return r.prev=16,n.f(),r.finish(16);case 19:case"end":return r.stop()}}),r,null,[[1,13,16,19]])}))))}var r;return new bP(Jf({},UA,bl(r=KA(this._data)).call(r,this._data)))}}]),n}();function SP(t,e){var r=void 0!==Kv&&mh(t)||t["@@iterator"];if(!r){if(hd(t)||(r=function(t,e){var r;if(!t)return;if("string"==typeof t)return kP(t,e);var n=sd(r=Object.prototype.toString.call(t)).call(r,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return hh(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return kP(t,e)}(t))||e&&t&&"number"==typeof t.length){r&&(t=r);var n=0,o=function(){};return{s:o,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var i,a=!0,s=!1;return{s:function(){r=r.call(t)},n:function(){var t=r.next();return a=t.done,t},e:function(t){s=!0,i=t},f:function(){try{a||null==r.return||r.return()}finally{if(s)throw i}}}}function kP(t,e){(null==e||e>t.length)&&(e=t.length);for(var r=0,n=new Array(e);r<e;r++)n[r]=t[r];return n}function jP(t){var e=function(){if("undefined"==typeof Reflect||!tw)return!1;if(tw.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(tw(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var r,n=Sw(t);if(e){var o=Sw(this).constructor;r=tw(n,arguments,o)}else r=n.apply(this,arguments);return xw(this,r)}}var AP=function(e){bw(n,aP);var r=jP(n);function n(e,o){var i,a;return t(this,n),Jf(ew(a=r.call(this)),"length",0),Jf(ew(a),"_listener",void 0),Jf(ew(a),"_data",void 0),Jf(ew(a),"_ids",new fP),Jf(ew(a),"_options",void 0),a._options=o||{},a._listener=bl(i=a._onEvent).call(i,ew(a)),a.setData(e),a}return $f(n,[{key:"idProp",get:function(){return this.getDataSet().idProp}},{key:"setData",value:function(t){if(this._data){this._data.off&&this._data.off("*",this._listener);var e=this._data.getIds({filter:Bl(this._options)}),r=this._data.get(e);this._ids.clear(),this.length=0,this._trigger("remove",{items:e,oldData:r})}if(null!=t){this._data=t;for(var n=this._data.getIds({filter:Bl(this._options)}),o=0,i=n.length;o<i;o++){var a=n[o];this._ids.add(a)}this.length=n.length,this._trigger("add",{items:n})}else this._data=new OP;this._data.on&&this._data.on("*",this._listener)}},{key:"refresh",value:function(){for(var t=this._data.getIds({filter:Bl(this._options)}),e=$v(this._ids),r={},n=[],o=[],i=[],a=0,s=t.length;a<s;a++){var u=t[a];r[u]=!0,this._ids.has(u)||(n.push(u),this._ids.add(u))}for(var c=0,f=e.length;c<f;c++){var l=e[c],p=this._data.get(l);null==p?console.error("If you see this, report it please."):r[l]||(o.push(l),i.push(p),this._ids.delete(l))}this.length+=n.length-o.length,n.length&&this._trigger("add",{items:n}),o.length&&this._trigger("remove",{items:o,oldData:i})}},{key:"get",value:function(t,e){if(null==this._data)return null;var r,n=null;oP(t)||hd(t)?(n=t,r=e):r=t;var o=Wy({},this._options,r),i=Bl(this._options),a=r&&Bl(r);return i&&a&&(o.filter=function(t){return i(t)&&a(t)}),null==n?this._data.get(o):this._data.get(n,o)}},{key:"getIds",value:function(t){if(this._data.length){var e,r=Bl(this._options),n=null!=t?Bl(t):null;return e=n?r?function(t){return r(t)&&n(t)}:n:r,this._data.getIds({filter:e,order:t&&t.order})}return[]}},{key:"forEach",value:function(t,e){if(this._data){var r,n,o=Bl(this._options),i=e&&Bl(e);n=i?o?function(t){return o(t)&&i(t)}:i:o,Fd(r=this._data).call(r,t,{filter:n,order:e&&e.order})}}},{key:"map",value:function(t,e){if(this._data){var r,n,o=Bl(this._options),i=e&&Bl(e);return n=i?o?function(t){return o(t)&&i(t)}:i:o,rp(r=this._data).call(r,t,{filter:n,order:e&&e.order})}return[]}},{key:"getDataSet",value:function(){return this._data.getDataSet()}},{key:"stream",value:function(t){var e;return this._data.stream(t||Jf({},UA,bl(e=qj(this._ids)).call(e,this._ids)))}},{key:"dispose",value:function(){var t;null!==(t=this._data)&&void 0!==t&&t.off&&this._data.off("*",this._listener);var e,r="This data view has already been disposed of.",o={get:function(){throw new Error(r)},set:function(){throw new Error(r)},configurable:!1},i=SP(ld(n.prototype));try{for(i.s();!(e=i.n()).done;){var a=e.value;uv(this,a,o)}}catch(t){i.e(t)}finally{i.f()}}},{key:"_onEvent",value:function(t,e,r){if(e&&e.items&&this._data){var n=e.items,o=[],i=[],a=[],s=[],u=[],c=[];switch(t){case"add":for(var f=0,l=n.length;f<l;f++){var p=n[f];this.get(p)&&(this._ids.add(p),o.push(p))}break;case"update":for(var h=0,v=n.length;h<v;h++){var d=n[h];this.get(d)?this._ids.has(d)?(i.push(d),u.push(e.data[h]),s.push(e.oldData[h])):(this._ids.add(d),o.push(d)):this._ids.has(d)&&(this._ids.delete(d),a.push(d),c.push(e.oldData[h]))}break;case"remove":for(var y=0,g=n.length;y<g;y++){var m=n[y];this._ids.has(m)&&(this._ids.delete(m),a.push(m),c.push(e.oldData[y]))}}this.length+=o.length-a.length,o.length&&this._trigger("add",{items:o},r),i.length&&this._trigger("update",{items:i,oldData:s,data:u},r),a.length&&this._trigger("remove",{items:a,oldData:c},r)}}}]),n}();function PP(t,e){return"object"===Uf(e)&&null!==e&&t===e.idProp&&"function"==typeof e.add&&"function"==typeof e.clear&&"function"==typeof e.distinct&&"function"==typeof Fd(e)&&"function"==typeof e.get&&"function"==typeof e.getDataSet&&"function"==typeof e.getIds&&"number"==typeof e.length&&"function"==typeof rp(e)&&"function"==typeof e.max&&"function"==typeof e.min&&"function"==typeof e.off&&"function"==typeof e.on&&"function"==typeof e.remove&&"function"==typeof e.setOptions&&"function"==typeof e.stream&&"function"==typeof e.update&&"function"==typeof e.updateOnly}function IP(t,e){return"object"===Uf(e)&&null!==e&&t===e.idProp&&"function"==typeof Fd(e)&&"function"==typeof e.get&&"function"==typeof e.getDataSet&&"function"==typeof e.getIds&&"number"==typeof e.length&&"function"==typeof rp(e)&&"function"==typeof e.off&&"function"==typeof e.on&&"function"==typeof e.stream&&PP(t,e.getDataSet())}export{S_ as DELETE,OP as DataSet,bP as DataStream,AP as DataView,iP as Queue,_p as createNewDataPipeFrom,PP as isDataSetLike,IP as isDataViewLike};
//# sourceMappingURL=vis-data.min.js.map
