/**
 * vis-data
 * http://visjs.org/
 *
 * Manage unstructured data using DataSet. Add, update, and remove data, and listen for changes in the data.
 *
 * @version 7.1.6
 * @date    2023-03-22T11:39:37.256Z
 *
 * @copyright (c) 2011-2017 Almende B.V, http://almende.com
 * @copyright (c) 2017-2019 visjs contributors, https://github.com/visjs
 *
 * @license
 * vis.js is dual licensed under both
 *
 *   1. The Apache 2.0 License
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *   and
 *
 *   2. The MIT License
 *      http://opensource.org/licenses/MIT
 *
 * vis.js may be distributed under either license.
 */
!function(t,e){"object"==typeof exports&&"undefined"!=typeof module?e(exports):"function"==typeof define&&define.amd?define(["exports"],e):e((t="undefined"!=typeof globalThis?globalThis:t||self).vis=t.vis||{})}(this,(function(t){function e(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")}var r="undefined"!=typeof globalThis?globalThis:"undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self?self:{};function n(t){return t&&t.__esModule&&Object.prototype.hasOwnProperty.call(t,"default")?t.default:t}var o={},i={get exports(){return o},set exports(t){o=t}},a={},u={get exports(){return a},set exports(t){a=t}},s={},c={get exports(){return s},set exports(t){s=t}},f=function(t){return t&&t.Math==Math&&t},l=f("object"==typeof globalThis&&globalThis)||f("object"==typeof window&&window)||f("object"==typeof self&&self)||f("object"==typeof r&&r)||function(){return this}()||Function("return this")(),p=function(t){try{return!!t()}catch(t){return!0}},h=!p((function(){var t=function(){}.bind();return"function"!=typeof t||t.hasOwnProperty("prototype")})),v=h,d=Function.prototype,y=d.apply,g=d.call,m="object"==typeof Reflect&&Reflect.apply||(v?g.bind(y):function(){return g.apply(y,arguments)}),b=h,x=Function.prototype,_=x.call,w=b&&x.bind.bind(_,_),E=b?w:function(t){return function(){return _.apply(t,arguments)}},T=E,O=T({}.toString),S=T("".slice),k=function(t){return S(O(t),8,-1)},j=k,A=E,P=function(t){if("Function"===j(t))return A(t)},I="object"==typeof document&&document.all,D={all:I,IS_HTMLDDA:void 0===I&&void 0!==I},L=D.all,C=D.IS_HTMLDDA?function(t){return"function"==typeof t||t===L}:function(t){return"function"==typeof t},R={},M=!p((function(){return 7!=Object.defineProperty({},1,{get:function(){return 7}})[1]})),N=h,F=Function.prototype.call,z=N?F.bind(F):function(){return F.apply(F,arguments)},U={},q={}.propertyIsEnumerable,Y=Object.getOwnPropertyDescriptor,W=Y&&!q.call({1:2},1);U.f=W?function(t){var e=Y(this,t);return!!e&&e.enumerable}:q;var G,X,V=function(t,e){return{enumerable:!(1&t),configurable:!(2&t),writable:!(4&t),value:e}},B=p,H=k,$=Object,J=E("".split),K=B((function(){return!$("z").propertyIsEnumerable(0)}))?function(t){return"String"==H(t)?J(t,""):$(t)}:$,Q=function(t){return null==t},Z=Q,tt=TypeError,et=function(t){if(Z(t))throw tt("Can't call method on "+t);return t},rt=K,nt=et,ot=function(t){return rt(nt(t))},it=C,at=D.all,ut=D.IS_HTMLDDA?function(t){return"object"==typeof t?null!==t:it(t)||t===at}:function(t){return"object"==typeof t?null!==t:it(t)},st={},ct=st,ft=l,lt=C,pt=function(t){return lt(t)?t:void 0},ht=function(t,e){return arguments.length<2?pt(ct[t])||pt(ft[t]):ct[t]&&ct[t][e]||ft[t]&&ft[t][e]},vt=E({}.isPrototypeOf),dt="undefined"!=typeof navigator&&String(navigator.userAgent)||"",yt=l,gt=dt,mt=yt.process,bt=yt.Deno,xt=mt&&mt.versions||bt&&bt.version,_t=xt&&xt.v8;_t&&(X=(G=_t.split("."))[0]>0&&G[0]<4?1:+(G[0]+G[1])),!X&&gt&&(!(G=gt.match(/Edge\/(\d+)/))||G[1]>=74)&&(G=gt.match(/Chrome\/(\d+)/))&&(X=+G[1]);var wt=X,Et=wt,Tt=p,Ot=!!Object.getOwnPropertySymbols&&!Tt((function(){var t=Symbol();return!String(t)||!(Object(t)instanceof Symbol)||!Symbol.sham&&Et&&Et<41})),St=Ot&&!Symbol.sham&&"symbol"==typeof Symbol.iterator,kt=ht,jt=C,At=vt,Pt=Object,It=St?function(t){return"symbol"==typeof t}:function(t){var e=kt("Symbol");return jt(e)&&At(e.prototype,Pt(t))},Dt=String,Lt=function(t){try{return Dt(t)}catch(t){return"Object"}},Ct=C,Rt=Lt,Mt=TypeError,Nt=function(t){if(Ct(t))return t;throw Mt(Rt(t)+" is not a function")},Ft=Nt,zt=Q,Ut=function(t,e){var r=t[e];return zt(r)?void 0:Ft(r)},qt=z,Yt=C,Wt=ut,Gt=TypeError,Xt={},Vt={get exports(){return Xt},set exports(t){Xt=t}},Bt=l,Ht=Object.defineProperty,$t=function(t,e){try{Ht(Bt,t,{value:e,configurable:!0,writable:!0})}catch(r){Bt[t]=e}return e},Jt="__core-js_shared__",Kt=l[Jt]||$t(Jt,{}),Qt=Kt;(Vt.exports=function(t,e){return Qt[t]||(Qt[t]=void 0!==e?e:{})})("versions",[]).push({version:"3.29.0",mode:"pure",copyright:"© 2014-2023 Denis Pushkarev (zloirock.ru)",license:"https://github.com/zloirock/core-js/blob/v3.29.0/LICENSE",source:"https://github.com/zloirock/core-js"});var Zt=et,te=Object,ee=function(t){return te(Zt(t))},re=ee,ne=E({}.hasOwnProperty),oe=Object.hasOwn||function(t,e){return ne(re(t),e)},ie=E,ae=0,ue=Math.random(),se=ie(1..toString),ce=function(t){return"Symbol("+(void 0===t?"":t)+")_"+se(++ae+ue,36)},fe=Xt,le=oe,pe=ce,he=Ot,ve=St,de=l.Symbol,ye=fe("wks"),ge=ve?de.for||de:de&&de.withoutSetter||pe,me=function(t){return le(ye,t)||(ye[t]=he&&le(de,t)?de[t]:ge("Symbol."+t)),ye[t]},be=z,xe=ut,_e=It,we=Ut,Ee=function(t,e){var r,n;if("string"===e&&Yt(r=t.toString)&&!Wt(n=qt(r,t)))return n;if(Yt(r=t.valueOf)&&!Wt(n=qt(r,t)))return n;if("string"!==e&&Yt(r=t.toString)&&!Wt(n=qt(r,t)))return n;throw Gt("Can't convert object to primitive value")},Te=TypeError,Oe=me("toPrimitive"),Se=function(t,e){if(!xe(t)||_e(t))return t;var r,n=we(t,Oe);if(n){if(void 0===e&&(e="default"),r=be(n,t,e),!xe(r)||_e(r))return r;throw Te("Can't convert object to primitive value")}return void 0===e&&(e="number"),Ee(t,e)},ke=It,je=function(t){var e=Se(t,"string");return ke(e)?e:e+""},Ae=ut,Pe=l.document,Ie=Ae(Pe)&&Ae(Pe.createElement),De=function(t){return Ie?Pe.createElement(t):{}},Le=De,Ce=!M&&!p((function(){return 7!=Object.defineProperty(Le("div"),"a",{get:function(){return 7}}).a})),Re=M,Me=z,Ne=U,Fe=V,ze=ot,Ue=je,qe=oe,Ye=Ce,We=Object.getOwnPropertyDescriptor;R.f=Re?We:function(t,e){if(t=ze(t),e=Ue(e),Ye)try{return We(t,e)}catch(t){}if(qe(t,e))return Fe(!Me(Ne.f,t,e),t[e])};var Ge=p,Xe=C,Ve=/#|\.prototype\./,Be=function(t,e){var r=$e[He(t)];return r==Ke||r!=Je&&(Xe(e)?Ge(e):!!e)},He=Be.normalize=function(t){return String(t).replace(Ve,".").toLowerCase()},$e=Be.data={},Je=Be.NATIVE="N",Ke=Be.POLYFILL="P",Qe=Be,Ze=Nt,tr=h,er=P(P.bind),rr=function(t,e){return Ze(t),void 0===e?t:tr?er(t,e):function(){return t.apply(e,arguments)}},nr={},or=M&&p((function(){return 42!=Object.defineProperty((function(){}),"prototype",{value:42,writable:!1}).prototype})),ir=ut,ar=String,ur=TypeError,sr=function(t){if(ir(t))return t;throw ur(ar(t)+" is not an object")},cr=M,fr=Ce,lr=or,pr=sr,hr=je,vr=TypeError,dr=Object.defineProperty,yr=Object.getOwnPropertyDescriptor,gr="enumerable",mr="configurable",br="writable";nr.f=cr?lr?function(t,e,r){if(pr(t),e=hr(e),pr(r),"function"==typeof t&&"prototype"===e&&"value"in r&&br in r&&!r[br]){var n=yr(t,e);n&&n[br]&&(t[e]=r.value,r={configurable:mr in r?r[mr]:n[mr],enumerable:gr in r?r[gr]:n[gr],writable:!1})}return dr(t,e,r)}:dr:function(t,e,r){if(pr(t),e=hr(e),pr(r),fr)try{return dr(t,e,r)}catch(t){}if("get"in r||"set"in r)throw vr("Accessors not supported");return"value"in r&&(t[e]=r.value),t};var xr=nr,_r=V,wr=M?function(t,e,r){return xr.f(t,e,_r(1,r))}:function(t,e,r){return t[e]=r,t},Er=l,Tr=m,Or=P,Sr=C,kr=R.f,jr=Qe,Ar=st,Pr=rr,Ir=wr,Dr=oe,Lr=function(t){var e=function(r,n,o){if(this instanceof e){switch(arguments.length){case 0:return new t;case 1:return new t(r);case 2:return new t(r,n)}return new t(r,n,o)}return Tr(t,this,arguments)};return e.prototype=t.prototype,e},Cr=function(t,e){var r,n,o,i,a,u,s,c,f,l=t.target,p=t.global,h=t.stat,v=t.proto,d=p?Er:h?Er[l]:(Er[l]||{}).prototype,y=p?Ar:Ar[l]||Ir(Ar,l,{})[l],g=y.prototype;for(i in e)n=!(r=jr(p?i:l+(h?".":"#")+i,t.forced))&&d&&Dr(d,i),u=y[i],n&&(s=t.dontCallGetSet?(f=kr(d,i))&&f.value:d[i]),a=n&&s?s:e[i],n&&typeof u==typeof a||(c=t.bind&&n?Pr(a,Er):t.wrap&&n?Lr(a):v&&Sr(a)?Or(a):a,(t.sham||a&&a.sham||u&&u.sham)&&Ir(c,"sham",!0),Ir(y,i,c),v&&(Dr(Ar,o=l+"Prototype")||Ir(Ar,o,{}),Ir(Ar[o],i,a),t.real&&g&&(r||!g[i])&&Ir(g,i,a)))},Rr=Cr,Mr=M,Nr=nr.f;Rr({target:"Object",stat:!0,forced:Object.defineProperty!==Nr,sham:!Mr},{defineProperty:Nr});var Fr=st.Object,zr=c.exports=function(t,e,r){return Fr.defineProperty(t,e,r)};Fr.defineProperty.sham&&(zr.sham=!0);var Ur=s,qr=Ur;!function(t){t.exports=qr}(u),function(t){t.exports=a}(i);var Yr=n(o),Wr={},Gr={get exports(){return Wr},set exports(t){Wr=t}},Xr={},Vr={get exports(){return Xr},set exports(t){Xr=t}},Br=k,Hr=Array.isArray||function(t){return"Array"==Br(t)},$r=Math.ceil,Jr=Math.floor,Kr=Math.trunc||function(t){var e=+t;return(e>0?Jr:$r)(e)},Qr=function(t){var e=+t;return e!=e||0===e?0:Kr(e)},Zr=Qr,tn=Math.min,en=function(t){return t>0?tn(Zr(t),9007199254740991):0},rn=function(t){return en(t.length)},nn=TypeError,on=function(t){if(t>9007199254740991)throw nn("Maximum allowed index exceeded");return t},an=je,un=nr,sn=V,cn=function(t,e,r){var n=an(e);n in t?un.f(t,n,sn(0,r)):t[n]=r},fn={};fn[me("toStringTag")]="z";var ln="[object z]"===String(fn),pn=ln,hn=C,vn=k,dn=me("toStringTag"),yn=Object,gn="Arguments"==vn(function(){return arguments}()),mn=pn?vn:function(t){var e,r,n;return void 0===t?"Undefined":null===t?"Null":"string"==typeof(r=function(t,e){try{return t[e]}catch(t){}}(e=yn(t),dn))?r:gn?vn(e):"Object"==(n=vn(e))&&hn(e.callee)?"Arguments":n},bn=C,xn=Kt,_n=E(Function.toString);bn(xn.inspectSource)||(xn.inspectSource=function(t){return _n(t)});var wn=xn.inspectSource,En=E,Tn=p,On=C,Sn=mn,kn=wn,jn=function(){},An=[],Pn=ht("Reflect","construct"),In=/^\s*(?:class|function)\b/,Dn=En(In.exec),Ln=!In.exec(jn),Cn=function(t){if(!On(t))return!1;try{return Pn(jn,An,t),!0}catch(t){return!1}},Rn=function(t){if(!On(t))return!1;switch(Sn(t)){case"AsyncFunction":case"GeneratorFunction":case"AsyncGeneratorFunction":return!1}try{return Ln||!!Dn(In,kn(t))}catch(t){return!0}};Rn.sham=!0;var Mn=!Pn||Tn((function(){var t;return Cn(Cn.call)||!Cn(Object)||!Cn((function(){t=!0}))||t}))?Rn:Cn,Nn=Hr,Fn=Mn,zn=ut,Un=me("species"),qn=Array,Yn=function(t){var e;return Nn(t)&&(e=t.constructor,(Fn(e)&&(e===qn||Nn(e.prototype))||zn(e)&&null===(e=e[Un]))&&(e=void 0)),void 0===e?qn:e},Wn=function(t,e){return new(Yn(t))(0===e?0:e)},Gn=p,Xn=wt,Vn=me("species"),Bn=function(t){return Xn>=51||!Gn((function(){var e=[];return(e.constructor={})[Vn]=function(){return{foo:1}},1!==e[t](Boolean).foo}))},Hn=Cr,$n=p,Jn=Hr,Kn=ut,Qn=ee,Zn=rn,to=on,eo=cn,ro=Wn,no=Bn,oo=wt,io=me("isConcatSpreadable"),ao=oo>=51||!$n((function(){var t=[];return t[io]=!1,t.concat()[0]!==t})),uo=function(t){if(!Kn(t))return!1;var e=t[io];return void 0!==e?!!e:Jn(t)};Hn({target:"Array",proto:!0,arity:1,forced:!ao||!no("concat")},{concat:function(t){var e,r,n,o,i,a=Qn(this),u=ro(a,0),s=0;for(e=-1,n=arguments.length;e<n;e++)if(uo(i=-1===e?a:arguments[e]))for(o=Zn(i),to(s+o),r=0;r<o;r++,s++)r in i&&eo(u,s,i[r]);else to(s+1),eo(u,s++,i);return u.length=s,u}});var so=mn,co=String,fo=function(t){if("Symbol"===so(t))throw TypeError("Cannot convert a Symbol value to a string");return co(t)},lo={},po=Qr,ho=Math.max,vo=Math.min,yo=function(t,e){var r=po(t);return r<0?ho(r+e,0):vo(r,e)},go=ot,mo=yo,bo=rn,xo=function(t){return function(e,r,n){var o,i=go(e),a=bo(i),u=mo(n,a);if(t&&r!=r){for(;a>u;)if((o=i[u++])!=o)return!0}else for(;a>u;u++)if((t||u in i)&&i[u]===r)return t||u||0;return!t&&-1}},_o={includes:xo(!0),indexOf:xo(!1)},wo={},Eo=oe,To=ot,Oo=_o.indexOf,So=wo,ko=E([].push),jo=function(t,e){var r,n=To(t),o=0,i=[];for(r in n)!Eo(So,r)&&Eo(n,r)&&ko(i,r);for(;e.length>o;)Eo(n,r=e[o++])&&(~Oo(i,r)||ko(i,r));return i},Ao=["constructor","hasOwnProperty","isPrototypeOf","propertyIsEnumerable","toLocaleString","toString","valueOf"],Po=jo,Io=Ao,Do=Object.keys||function(t){return Po(t,Io)},Lo=M,Co=or,Ro=nr,Mo=sr,No=ot,Fo=Do;lo.f=Lo&&!Co?Object.defineProperties:function(t,e){Mo(t);for(var r,n=No(e),o=Fo(e),i=o.length,a=0;i>a;)Ro.f(t,r=o[a++],n[r]);return t};var zo,Uo=ht("document","documentElement"),qo=ce,Yo=Xt("keys"),Wo=function(t){return Yo[t]||(Yo[t]=qo(t))},Go=sr,Xo=lo,Vo=Ao,Bo=wo,Ho=Uo,$o=De,Jo="prototype",Ko="script",Qo=Wo("IE_PROTO"),Zo=function(){},ti=function(t){return"<"+Ko+">"+t+"</"+Ko+">"},ei=function(t){t.write(ti("")),t.close();var e=t.parentWindow.Object;return t=null,e},ri=function(){try{zo=new ActiveXObject("htmlfile")}catch(t){}var t,e,r;ri="undefined"!=typeof document?document.domain&&zo?ei(zo):(e=$o("iframe"),r="java"+Ko+":",e.style.display="none",Ho.appendChild(e),e.src=String(r),(t=e.contentWindow.document).open(),t.write(ti("document.F=Object")),t.close(),t.F):ei(zo);for(var n=Vo.length;n--;)delete ri[Jo][Vo[n]];return ri()};Bo[Qo]=!0;var ni=Object.create||function(t,e){var r;return null!==t?(Zo[Jo]=Go(t),r=new Zo,Zo[Jo]=null,r[Qo]=t):r=ri(),void 0===e?r:Xo.f(r,e)},oi={},ii=jo,ai=Ao.concat("length","prototype");oi.f=Object.getOwnPropertyNames||function(t){return ii(t,ai)};var ui={},si=yo,ci=rn,fi=cn,li=Array,pi=Math.max,hi=function(t,e,r){for(var n=ci(t),o=si(e,n),i=si(void 0===r?n:r,n),a=li(pi(i-o,0)),u=0;o<i;o++,u++)fi(a,u,t[o]);return a.length=u,a},vi=k,di=ot,yi=oi.f,gi=hi,mi="object"==typeof window&&window&&Object.getOwnPropertyNames?Object.getOwnPropertyNames(window):[];ui.f=function(t){return mi&&"Window"==vi(t)?function(t){try{return yi(t)}catch(t){return gi(mi)}}(t):yi(di(t))};var bi={};bi.f=Object.getOwnPropertySymbols;var xi=wr,_i=function(t,e,r,n){return n&&n.enumerable?t[e]=r:xi(t,e,r),t},wi=nr,Ei=function(t,e,r){return wi.f(t,e,r)},Ti={},Oi=me;Ti.f=Oi;var Si,ki,ji,Ai=st,Pi=oe,Ii=Ti,Di=nr.f,Li=function(t){var e=Ai.Symbol||(Ai.Symbol={});Pi(e,t)||Di(e,t,{value:Ii.f(t)})},Ci=z,Ri=ht,Mi=me,Ni=_i,Fi=function(){var t=Ri("Symbol"),e=t&&t.prototype,r=e&&e.valueOf,n=Mi("toPrimitive");e&&!e[n]&&Ni(e,n,(function(t){return Ci(r,this)}),{arity:1})},zi=mn,Ui=ln?{}.toString:function(){return"[object "+zi(this)+"]"},qi=ln,Yi=nr.f,Wi=wr,Gi=oe,Xi=Ui,Vi=me("toStringTag"),Bi=function(t,e,r,n){if(t){var o=r?t:t.prototype;Gi(o,Vi)||Yi(o,Vi,{configurable:!0,value:e}),n&&!qi&&Wi(o,"toString",Xi)}},Hi=C,$i=l.WeakMap,Ji=Hi($i)&&/native code/.test(String($i)),Ki=l,Qi=ut,Zi=wr,ta=oe,ea=Kt,ra=Wo,na=wo,oa="Object already initialized",ia=Ki.TypeError,aa=Ki.WeakMap;if(Ji||ea.state){var ua=ea.state||(ea.state=new aa);ua.get=ua.get,ua.has=ua.has,ua.set=ua.set,Si=function(t,e){if(ua.has(t))throw ia(oa);return e.facade=t,ua.set(t,e),e},ki=function(t){return ua.get(t)||{}},ji=function(t){return ua.has(t)}}else{var sa=ra("state");na[sa]=!0,Si=function(t,e){if(ta(t,sa))throw ia(oa);return e.facade=t,Zi(t,sa,e),e},ki=function(t){return ta(t,sa)?t[sa]:{}},ji=function(t){return ta(t,sa)}}var ca={set:Si,get:ki,has:ji,enforce:function(t){return ji(t)?ki(t):Si(t,{})},getterFor:function(t){return function(e){var r;if(!Qi(e)||(r=ki(e)).type!==t)throw ia("Incompatible receiver, "+t+" required");return r}}},fa=rr,la=K,pa=ee,ha=rn,va=Wn,da=E([].push),ya=function(t){var e=1==t,r=2==t,n=3==t,o=4==t,i=6==t,a=7==t,u=5==t||i;return function(s,c,f,l){for(var p,h,v=pa(s),d=la(v),y=fa(c,f),g=ha(d),m=0,b=l||va,x=e?b(s,g):r||a?b(s,0):void 0;g>m;m++)if((u||m in d)&&(h=y(p=d[m],m,v),t))if(e)x[m]=h;else if(h)switch(t){case 3:return!0;case 5:return p;case 6:return m;case 2:da(x,p)}else switch(t){case 4:return!1;case 7:da(x,p)}return i?-1:n||o?o:x}},ga={forEach:ya(0),map:ya(1),filter:ya(2),some:ya(3),every:ya(4),find:ya(5),findIndex:ya(6),filterReject:ya(7)},ma=Cr,ba=l,xa=z,_a=E,wa=M,Ea=Ot,Ta=p,Oa=oe,Sa=vt,ka=sr,ja=ot,Aa=je,Pa=fo,Ia=V,Da=ni,La=Do,Ca=oi,Ra=ui,Ma=bi,Na=R,Fa=nr,za=lo,Ua=U,qa=_i,Ya=Ei,Wa=Xt,Ga=wo,Xa=ce,Va=me,Ba=Ti,Ha=Li,$a=Fi,Ja=Bi,Ka=ca,Qa=ga.forEach,Za=Wo("hidden"),tu="Symbol",eu="prototype",ru=Ka.set,nu=Ka.getterFor(tu),ou=Object[eu],iu=ba.Symbol,au=iu&&iu[eu],uu=ba.TypeError,su=ba.QObject,cu=Na.f,fu=Fa.f,lu=Ra.f,pu=Ua.f,hu=_a([].push),vu=Wa("symbols"),du=Wa("op-symbols"),yu=Wa("wks"),gu=!su||!su[eu]||!su[eu].findChild,mu=wa&&Ta((function(){return 7!=Da(fu({},"a",{get:function(){return fu(this,"a",{value:7}).a}})).a}))?function(t,e,r){var n=cu(ou,e);n&&delete ou[e],fu(t,e,r),n&&t!==ou&&fu(ou,e,n)}:fu,bu=function(t,e){var r=vu[t]=Da(au);return ru(r,{type:tu,tag:t,description:e}),wa||(r.description=e),r},xu=function(t,e,r){t===ou&&xu(du,e,r),ka(t);var n=Aa(e);return ka(r),Oa(vu,n)?(r.enumerable?(Oa(t,Za)&&t[Za][n]&&(t[Za][n]=!1),r=Da(r,{enumerable:Ia(0,!1)})):(Oa(t,Za)||fu(t,Za,Ia(1,{})),t[Za][n]=!0),mu(t,n,r)):fu(t,n,r)},_u=function(t,e){ka(t);var r=ja(e),n=La(r).concat(Ou(r));return Qa(n,(function(e){wa&&!xa(wu,r,e)||xu(t,e,r[e])})),t},wu=function(t){var e=Aa(t),r=xa(pu,this,e);return!(this===ou&&Oa(vu,e)&&!Oa(du,e))&&(!(r||!Oa(this,e)||!Oa(vu,e)||Oa(this,Za)&&this[Za][e])||r)},Eu=function(t,e){var r=ja(t),n=Aa(e);if(r!==ou||!Oa(vu,n)||Oa(du,n)){var o=cu(r,n);return!o||!Oa(vu,n)||Oa(r,Za)&&r[Za][n]||(o.enumerable=!0),o}},Tu=function(t){var e=lu(ja(t)),r=[];return Qa(e,(function(t){Oa(vu,t)||Oa(Ga,t)||hu(r,t)})),r},Ou=function(t){var e=t===ou,r=lu(e?du:ja(t)),n=[];return Qa(r,(function(t){!Oa(vu,t)||e&&!Oa(ou,t)||hu(n,vu[t])})),n};Ea||(iu=function(){if(Sa(au,this))throw uu("Symbol is not a constructor");var t=arguments.length&&void 0!==arguments[0]?Pa(arguments[0]):void 0,e=Xa(t),r=function(t){this===ou&&xa(r,du,t),Oa(this,Za)&&Oa(this[Za],e)&&(this[Za][e]=!1),mu(this,e,Ia(1,t))};return wa&&gu&&mu(ou,e,{configurable:!0,set:r}),bu(e,t)},qa(au=iu[eu],"toString",(function(){return nu(this).tag})),qa(iu,"withoutSetter",(function(t){return bu(Xa(t),t)})),Ua.f=wu,Fa.f=xu,za.f=_u,Na.f=Eu,Ca.f=Ra.f=Tu,Ma.f=Ou,Ba.f=function(t){return bu(Va(t),t)},wa&&Ya(au,"description",{configurable:!0,get:function(){return nu(this).description}})),ma({global:!0,constructor:!0,wrap:!0,forced:!Ea,sham:!Ea},{Symbol:iu}),Qa(La(yu),(function(t){Ha(t)})),ma({target:tu,stat:!0,forced:!Ea},{useSetter:function(){gu=!0},useSimple:function(){gu=!1}}),ma({target:"Object",stat:!0,forced:!Ea,sham:!wa},{create:function(t,e){return void 0===e?Da(t):_u(Da(t),e)},defineProperty:xu,defineProperties:_u,getOwnPropertyDescriptor:Eu}),ma({target:"Object",stat:!0,forced:!Ea},{getOwnPropertyNames:Tu}),$a(),Ja(iu,tu),Ga[Za]=!0;var Su=Ot&&!!Symbol.for&&!!Symbol.keyFor,ku=Cr,ju=ht,Au=oe,Pu=fo,Iu=Xt,Du=Su,Lu=Iu("string-to-symbol-registry"),Cu=Iu("symbol-to-string-registry");ku({target:"Symbol",stat:!0,forced:!Du},{for:function(t){var e=Pu(t);if(Au(Lu,e))return Lu[e];var r=ju("Symbol")(e);return Lu[e]=r,Cu[r]=e,r}});var Ru=Cr,Mu=oe,Nu=It,Fu=Lt,zu=Su,Uu=Xt("symbol-to-string-registry");Ru({target:"Symbol",stat:!0,forced:!zu},{keyFor:function(t){if(!Nu(t))throw TypeError(Fu(t)+" is not a symbol");if(Mu(Uu,t))return Uu[t]}});var qu=E([].slice),Yu=Hr,Wu=C,Gu=k,Xu=fo,Vu=E([].push),Bu=Cr,Hu=ht,$u=m,Ju=z,Ku=E,Qu=p,Zu=C,ts=It,es=qu,rs=function(t){if(Wu(t))return t;if(Yu(t)){for(var e=t.length,r=[],n=0;n<e;n++){var o=t[n];"string"==typeof o?Vu(r,o):"number"!=typeof o&&"Number"!=Gu(o)&&"String"!=Gu(o)||Vu(r,Xu(o))}var i=r.length,a=!0;return function(t,e){if(a)return a=!1,e;if(Yu(this))return e;for(var n=0;n<i;n++)if(r[n]===t)return e}}},ns=Ot,os=String,is=Hu("JSON","stringify"),as=Ku(/./.exec),us=Ku("".charAt),ss=Ku("".charCodeAt),cs=Ku("".replace),fs=Ku(1..toString),ls=/[\uD800-\uDFFF]/g,ps=/^[\uD800-\uDBFF]$/,hs=/^[\uDC00-\uDFFF]$/,vs=!ns||Qu((function(){var t=Hu("Symbol")();return"[null]"!=is([t])||"{}"!=is({a:t})||"{}"!=is(Object(t))})),ds=Qu((function(){return'"\\udf06\\ud834"'!==is("\udf06\ud834")||'"\\udead"'!==is("\udead")})),ys=function(t,e){var r=es(arguments),n=rs(e);if(Zu(n)||void 0!==t&&!ts(t))return r[1]=function(t,e){if(Zu(n)&&(e=Ju(n,this,os(t),e)),!ts(e))return e},$u(is,null,r)},gs=function(t,e,r){var n=us(r,e-1),o=us(r,e+1);return as(ps,t)&&!as(hs,o)||as(hs,t)&&!as(ps,n)?"\\u"+fs(ss(t,0),16):t};is&&Bu({target:"JSON",stat:!0,arity:3,forced:vs||ds},{stringify:function(t,e,r){var n=es(arguments),o=$u(vs?ys:is,null,n);return ds&&"string"==typeof o?cs(o,ls,gs):o}});var ms=bi,bs=ee;Cr({target:"Object",stat:!0,forced:!Ot||p((function(){ms.f(1)}))},{getOwnPropertySymbols:function(t){var e=ms.f;return e?e(bs(t)):[]}}),Li("asyncIterator"),Li("hasInstance"),Li("isConcatSpreadable"),Li("iterator"),Li("match"),Li("matchAll"),Li("replace"),Li("search"),Li("species"),Li("split");var xs=Fi;Li("toPrimitive"),xs();var _s=ht,ws=Bi;Li("toStringTag"),ws(_s("Symbol"),"Symbol"),Li("unscopables"),Bi(l.JSON,"JSON",!0);var Es,Ts,Os,Ss=st.Symbol,ks={},js=M,As=oe,Ps=Function.prototype,Is=js&&Object.getOwnPropertyDescriptor,Ds=As(Ps,"name"),Ls={EXISTS:Ds,PROPER:Ds&&"something"===function(){}.name,CONFIGURABLE:Ds&&(!js||js&&Is(Ps,"name").configurable)},Cs=!p((function(){function t(){}return t.prototype.constructor=null,Object.getPrototypeOf(new t)!==t.prototype})),Rs=oe,Ms=C,Ns=ee,Fs=Cs,zs=Wo("IE_PROTO"),Us=Object,qs=Us.prototype,Ys=Fs?Us.getPrototypeOf:function(t){var e=Ns(t);if(Rs(e,zs))return e[zs];var r=e.constructor;return Ms(r)&&e instanceof r?r.prototype:e instanceof Us?qs:null},Ws=p,Gs=C,Xs=ut,Vs=ni,Bs=Ys,Hs=_i,$s=me("iterator"),Js=!1;[].keys&&("next"in(Os=[].keys())?(Ts=Bs(Bs(Os)))!==Object.prototype&&(Es=Ts):Js=!0);var Ks=!Xs(Es)||Ws((function(){var t={};return Es[$s].call(t)!==t}));Gs((Es=Ks?{}:Vs(Es))[$s])||Hs(Es,$s,(function(){return this}));var Qs={IteratorPrototype:Es,BUGGY_SAFARI_ITERATORS:Js},Zs=Qs.IteratorPrototype,tc=ni,ec=V,rc=Bi,nc=ks,oc=function(){return this},ic=E,ac=Nt,uc=C,sc=String,cc=TypeError,fc=function(t,e,r){try{return ic(ac(Object.getOwnPropertyDescriptor(t,e)[r]))}catch(t){}},lc=sr,pc=function(t){if("object"==typeof t||uc(t))return t;throw cc("Can't set "+sc(t)+" as a prototype")},hc=Object.setPrototypeOf||("__proto__"in{}?function(){var t,e=!1,r={};try{(t=fc(Object.prototype,"__proto__","set"))(r,[]),e=r instanceof Array}catch(t){}return function(r,n){return lc(r),pc(n),e?t(r,n):r.__proto__=n,r}}():void 0),vc=Cr,dc=z,yc=function(t,e,r,n){var o=e+" Iterator";return t.prototype=tc(Zs,{next:ec(+!n,r)}),rc(t,o,!1,!0),nc[o]=oc,t},gc=Ys,mc=Bi,bc=_i,xc=ks,_c=Ls.PROPER,wc=Qs.BUGGY_SAFARI_ITERATORS,Ec=me("iterator"),Tc="keys",Oc="values",Sc="entries",kc=function(){return this},jc=function(t,e,r,n,o,i,a){yc(r,e,n);var u,s,c,f=function(t){if(t===o&&d)return d;if(!wc&&t in h)return h[t];switch(t){case Tc:case Oc:case Sc:return function(){return new r(this,t)}}return function(){return new r(this)}},l=e+" Iterator",p=!1,h=t.prototype,v=h[Ec]||h["@@iterator"]||o&&h[o],d=!wc&&v||f(o),y="Array"==e&&h.entries||v;if(y&&(u=gc(y.call(new t)))!==Object.prototype&&u.next&&(mc(u,l,!0,!0),xc[l]=kc),_c&&o==Oc&&v&&v.name!==Oc&&(p=!0,d=function(){return dc(v,this)}),o)if(s={values:f(Oc),keys:i?d:f(Tc),entries:f(Sc)},a)for(c in s)(wc||p||!(c in h))&&bc(h,c,s[c]);else vc({target:e,proto:!0,forced:wc||p},s);return a&&h[Ec]!==d&&bc(h,Ec,d,{name:o}),xc[e]=d,s},Ac=function(t,e){return{value:t,done:e}},Pc=ot,Ic=ks,Dc=ca;nr.f;var Lc=jc,Cc=Ac,Rc="Array Iterator",Mc=Dc.set,Nc=Dc.getterFor(Rc);Lc(Array,"Array",(function(t,e){Mc(this,{type:Rc,target:Pc(t),index:0,kind:e})}),(function(){var t=Nc(this),e=t.target,r=t.kind,n=t.index++;return!e||n>=e.length?(t.target=void 0,Cc(void 0,!0)):Cc("keys"==r?n:"values"==r?e[n]:[n,e[n]],!1)}),"values"),Ic.Arguments=Ic.Array;var Fc={CSSRuleList:0,CSSStyleDeclaration:0,CSSValueList:0,ClientRectList:0,DOMRectList:0,DOMStringList:0,DOMTokenList:1,DataTransferItemList:0,FileList:0,HTMLAllCollection:0,HTMLCollection:0,HTMLFormElement:0,HTMLSelectElement:0,MediaList:0,MimeTypeArray:0,NamedNodeMap:0,NodeList:1,PaintRequestList:0,Plugin:0,PluginArray:0,SVGLengthList:0,SVGNumberList:0,SVGPathSegList:0,SVGPointList:0,SVGStringList:0,SVGTransformList:0,SourceBufferList:0,StyleSheetList:0,TextTrackCueList:0,TextTrackList:0,TouchList:0},zc=l,Uc=mn,qc=wr,Yc=ks,Wc=me("toStringTag");for(var Gc in Fc){var Xc=zc[Gc],Vc=Xc&&Xc.prototype;Vc&&Uc(Vc)!==Wc&&qc(Vc,Wc,Gc),Yc[Gc]=Yc.Array}var Bc=Ss;Li("dispose");var Hc=Bc;Li("asyncDispose");var $c=Cr,Jc=E,Kc=ht("Symbol"),Qc=Kc.keyFor,Zc=Jc(Kc.prototype.valueOf);$c({target:"Symbol",stat:!0},{isRegistered:function(t){try{return void 0!==Qc(Zc(t))}catch(t){return!1}}});for(var tf=Cr,ef=Xt,rf=ht,nf=E,of=It,af=me,uf=rf("Symbol"),sf=uf.isWellKnown,cf=rf("Object","getOwnPropertyNames"),ff=nf(uf.prototype.valueOf),lf=ef("wks"),pf=0,hf=cf(uf),vf=hf.length;pf<vf;pf++)try{var df=hf[pf];of(uf[df])&&af(df)}catch(t){}tf({target:"Symbol",stat:!0,forced:!0},{isWellKnown:function(t){if(sf&&sf(t))return!0;try{for(var e=ff(t),r=0,n=cf(lf),o=n.length;r<o;r++)if(lf[n[r]]==e)return!0}catch(t){}return!1}}),Li("matcher"),Li("metadataKey"),Li("observable"),Li("metadata"),Li("patternMatch"),Li("replaceAll");var yf=Hc;!function(t){t.exports=yf}(Vr),function(t){t.exports=Xr}(Gr);var gf=n(Wr),mf={},bf={get exports(){return mf},set exports(t){mf=t}},xf={},_f={get exports(){return xf},set exports(t){xf=t}},wf=E,Ef=Qr,Tf=fo,Of=et,Sf=wf("".charAt),kf=wf("".charCodeAt),jf=wf("".slice),Af=function(t){return function(e,r){var n,o,i=Tf(Of(e)),a=Ef(r),u=i.length;return a<0||a>=u?t?"":void 0:(n=kf(i,a))<55296||n>56319||a+1===u||(o=kf(i,a+1))<56320||o>57343?t?Sf(i,a):n:t?jf(i,a,a+2):o-56320+(n-55296<<10)+65536}},Pf={codeAt:Af(!1),charAt:Af(!0)}.charAt,If=fo,Df=ca,Lf=jc,Cf=Ac,Rf="String Iterator",Mf=Df.set,Nf=Df.getterFor(Rf);Lf(String,"String",(function(t){Mf(this,{type:Rf,string:If(t),index:0})}),(function(){var t,e=Nf(this),r=e.string,n=e.index;return n>=r.length?Cf(void 0,!0):(t=Pf(r,n),e.index+=t.length,Cf(t,!1))}));var Ff=Ti.f("iterator"),zf=Ff;!function(t){t.exports=zf}(_f),function(t){t.exports=xf}(bf);var Uf=n(mf);function qf(t){return qf="function"==typeof gf&&"symbol"==typeof Uf?function(t){return typeof t}:function(t){return t&&"function"==typeof gf&&t.constructor===gf&&t!==gf.prototype?"symbol":typeof t},qf(t)}var Yf={},Wf={get exports(){return Yf},set exports(t){Yf=t}},Gf={},Xf={get exports(){return Gf},set exports(t){Gf=t}},Vf=Ti.f("toPrimitive");!function(t){t.exports=Vf}(Xf),function(t){t.exports=Gf}(Wf);var Bf=n(Yf);function Hf(t){var e=function(t,e){if("object"!==qf(t)||null===t)return t;var r=t[Bf];if(void 0!==r){var n=r.call(t,e||"default");if("object"!==qf(n))return n;throw new TypeError("@@toPrimitive must return a primitive value.")}return("string"===e?String:Number)(t)}(t,"string");return"symbol"===qf(e)?e:String(e)}function $f(t,e){for(var r=0;r<e.length;r++){var n=e[r];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Yr(t,Hf(n.key),n)}}function Jf(t,e,r){return e&&$f(t.prototype,e),r&&$f(t,r),Yr(t,"prototype",{writable:!1}),t}function Kf(t,e,r){return(e=Hf(e))in t?Yr(t,e,{value:r,enumerable:!0,configurable:!0,writable:!0}):t[e]=r,t}var Qf={},Zf={get exports(){return Qf},set exports(t){Qf=t}},tl=E,el=Nt,rl=ut,nl=oe,ol=qu,il=h,al=Function,ul=tl([].concat),sl=tl([].join),cl={},fl=function(t,e,r){if(!nl(cl,e)){for(var n=[],o=0;o<e;o++)n[o]="a["+o+"]";cl[e]=al("C,a","return new C("+sl(n,",")+")")}return cl[e](t,r)},ll=il?al.bind:function(t){var e=el(this),r=e.prototype,n=ol(arguments,1),o=function(){var r=ul(n,ol(arguments));return this instanceof o?fl(e,r.length,r):e.apply(t,r)};return rl(r)&&(o.prototype=r),o},pl=ll;Cr({target:"Function",proto:!0,forced:Function.bind!==pl},{bind:pl});var hl=st,vl=function(t){return hl[t+"Prototype"]},dl=vl("Function").bind,yl=vt,gl=dl,ml=Function.prototype,bl=function(t){var e=t.bind;return t===ml||yl(ml,t)&&e===ml.bind?gl:e};!function(t){t.exports=bl}(Zf);var xl=n(Qf),_l={},wl={get exports(){return _l},set exports(t){_l=t}},El=Nt,Tl=ee,Ol=K,Sl=rn,kl=TypeError,jl=function(t){return function(e,r,n,o){El(r);var i=Tl(e),a=Ol(i),u=Sl(i),s=t?u-1:0,c=t?-1:1;if(n<2)for(;;){if(s in a){o=a[s],s+=c;break}if(s+=c,t?s<0:u<=s)throw kl("Reduce of empty array with no initial value")}for(;t?s>=0:u>s;s+=c)s in a&&(o=r(o,a[s],s,i));return o}},Al={left:jl(!1),right:jl(!0)},Pl=p,Il=function(t,e){var r=[][t];return!!r&&Pl((function(){r.call(null,e||function(){return 1},1)}))},Dl="undefined"!=typeof process&&"process"==k(process),Ll=Al.left;Cr({target:"Array",proto:!0,forced:!Dl&&wt>79&&wt<83||!Il("reduce")},{reduce:function(t){var e=arguments.length;return Ll(this,t,e,e>1?arguments[1]:void 0)}});var Cl=vl("Array").reduce,Rl=vt,Ml=Cl,Nl=Array.prototype,Fl=function(t){var e=t.reduce;return t===Nl||Rl(Nl,t)&&e===Nl.reduce?Ml:e};!function(t){t.exports=Fl}(wl);var zl=n(_l),Ul={},ql={get exports(){return Ul},set exports(t){Ul=t}},Yl=ga.filter;Cr({target:"Array",proto:!0,forced:!Bn("filter")},{filter:function(t){return Yl(this,t,arguments.length>1?arguments[1]:void 0)}});var Wl=vl("Array").filter,Gl=vt,Xl=Wl,Vl=Array.prototype,Bl=function(t){var e=t.filter;return t===Vl||Gl(Vl,t)&&e===Vl.filter?Xl:e};!function(t){t.exports=Bl}(ql);var Hl=n(Ul),$l={},Jl={get exports(){return $l},set exports(t){$l=t}},Kl=ga.map;Cr({target:"Array",proto:!0,forced:!Bn("map")},{map:function(t){return Kl(this,t,arguments.length>1?arguments[1]:void 0)}});var Ql=vl("Array").map,Zl=vt,tp=Ql,ep=Array.prototype,rp=function(t){var e=t.map;return t===ep||Zl(ep,t)&&e===ep.map?tp:e};!function(t){t.exports=rp}(Jl);var np=n($l),op={},ip={get exports(){return op},set exports(t){op=t}},ap=Hr,up=rn,sp=on,cp=rr,fp=function(t,e,r,n,o,i,a,u){for(var s,c,f=o,l=0,p=!!a&&cp(a,u);l<n;)l in r&&(s=p?p(r[l],l,e):r[l],i>0&&ap(s)?(c=up(s),f=fp(t,e,s,c,f,i-1)-1):(sp(f+1),t[f]=s),f++),l++;return f},lp=fp,pp=Nt,hp=ee,vp=rn,dp=Wn;Cr({target:"Array",proto:!0},{flatMap:function(t){var e,r=hp(this),n=vp(r);return pp(t),(e=dp(r,0)).length=lp(e,r,r,n,0,1,t,arguments.length>1?arguments[1]:void 0),e}});var yp=vl("Array").flatMap,gp=vt,mp=yp,bp=Array.prototype,xp=function(t){var e=t.flatMap;return t===bp||gp(bp,t)&&e===bp.flatMap?mp:e};!function(t){t.exports=xp}(ip);var _p=n(op);var wp=function(){function t(r,n,o){var i,a,u;e(this,t),Kf(this,"_source",void 0),Kf(this,"_transformers",void 0),Kf(this,"_target",void 0),Kf(this,"_listeners",{add:xl(i=this._add).call(i,this),remove:xl(a=this._remove).call(a,this),update:xl(u=this._update).call(u,this)}),this._source=r,this._transformers=n,this._target=o}return Jf(t,[{key:"all",value:function(){return this._target.update(this._transformItems(this._source.get())),this}},{key:"start",value:function(){return this._source.on("add",this._listeners.add),this._source.on("remove",this._listeners.remove),this._source.on("update",this._listeners.update),this}},{key:"stop",value:function(){return this._source.off("add",this._listeners.add),this._source.off("remove",this._listeners.remove),this._source.off("update",this._listeners.update),this}},{key:"_transformItems",value:function(t){var e;return zl(e=this._transformers).call(e,(function(t,e){return e(t)}),t)}},{key:"_add",value:function(t,e){null!=e&&this._target.add(this._transformItems(this._source.get(e.items)))}},{key:"_update",value:function(t,e){null!=e&&this._target.update(this._transformItems(this._source.get(e.items)))}},{key:"_remove",value:function(t,e){null!=e&&this._target.remove(this._transformItems(e.oldData))}}]),t}(),Ep=function(){function t(r){e(this,t),Kf(this,"_source",void 0),Kf(this,"_transformers",[]),this._source=r}return Jf(t,[{key:"filter",value:function(t){return this._transformers.push((function(e){return Hl(e).call(e,t)})),this}},{key:"map",value:function(t){return this._transformers.push((function(e){return np(e).call(e,t)})),this}},{key:"flatMap",value:function(t){return this._transformers.push((function(e){return _p(e).call(e,t)})),this}},{key:"to",value:function(t){return new wp(this._source,this._transformers,t)}}]),t}(),Tp={},Op={get exports(){return Tp},set exports(t){Tp=t}},Sp=z,kp=sr,jp=Ut,Ap=function(t,e,r){var n,o;kp(t);try{if(!(n=jp(t,"return"))){if("throw"===e)throw r;return r}n=Sp(n,t)}catch(t){o=!0,n=t}if("throw"===e)throw r;if(o)throw n;return kp(n),r},Pp=sr,Ip=Ap,Dp=ks,Lp=me("iterator"),Cp=Array.prototype,Rp=function(t){return void 0!==t&&(Dp.Array===t||Cp[Lp]===t)},Mp=mn,Np=Ut,Fp=Q,zp=ks,Up=me("iterator"),qp=function(t){if(!Fp(t))return Np(t,Up)||Np(t,"@@iterator")||zp[Mp(t)]},Yp=z,Wp=Nt,Gp=sr,Xp=Lt,Vp=qp,Bp=TypeError,Hp=function(t,e){var r=arguments.length<2?Vp(t):e;if(Wp(r))return Gp(Yp(r,t));throw Bp(Xp(t)+" is not iterable")},$p=rr,Jp=z,Kp=ee,Qp=function(t,e,r,n){try{return n?e(Pp(r)[0],r[1]):e(r)}catch(e){Ip(t,"throw",e)}},Zp=Rp,th=Mn,eh=rn,rh=cn,nh=Hp,oh=qp,ih=Array,ah=me("iterator"),uh=!1;try{var sh=0,ch={next:function(){return{done:!!sh++}},return:function(){uh=!0}};ch[ah]=function(){return this},Array.from(ch,(function(){throw 2}))}catch(t){}var fh=function(t,e){if(!e&&!uh)return!1;var r=!1;try{var n={};n[ah]=function(){return{next:function(){return{done:r=!0}}}},t(n)}catch(t){}return r},lh=function(t){var e=Kp(t),r=th(this),n=arguments.length,o=n>1?arguments[1]:void 0,i=void 0!==o;i&&(o=$p(o,n>2?arguments[2]:void 0));var a,u,s,c,f,l,p=oh(e),h=0;if(!p||this===ih&&Zp(p))for(a=eh(e),u=r?new this(a):ih(a);a>h;h++)l=i?o(e[h],h):e[h],rh(u,h,l);else for(f=(c=nh(e,p)).next,u=r?new this:[];!(s=Jp(f,c)).done;h++)l=i?Qp(c,o,[s.value,h],!0):s.value,rh(u,h,l);return u.length=h,u};Cr({target:"Array",stat:!0,forced:!fh((function(t){Array.from(t)}))},{from:lh});var ph=st.Array.from;!function(t){t.exports=ph}(Op);var hh=n(Tp),vh={},dh={get exports(){return vh},set exports(t){vh=t}},yh={},gh=qp;!function(t){t.exports=gh}({get exports(){return yh},set exports(t){yh=t}}),function(t){t.exports=yh}(dh);var mh=n(vh),bh={},xh={get exports(){return bh},set exports(t){bh=t}},_h=st.Object.getOwnPropertySymbols;!function(t){t.exports=_h}(xh);var wh=n(bh),Eh={},Th={get exports(){return Eh},set exports(t){Eh=t}},Oh={},Sh={get exports(){return Oh},set exports(t){Oh=t}},kh=Cr,jh=p,Ah=ot,Ph=R.f,Ih=M;kh({target:"Object",stat:!0,forced:!Ih||jh((function(){Ph(1)})),sham:!Ih},{getOwnPropertyDescriptor:function(t,e){return Ph(Ah(t),e)}});var Dh=st.Object,Lh=Sh.exports=function(t,e){return Dh.getOwnPropertyDescriptor(t,e)};Dh.getOwnPropertyDescriptor.sham&&(Lh.sham=!0);var Ch=Oh;!function(t){t.exports=Ch}(Th);var Rh=n(Eh),Mh={},Nh={get exports(){return Mh},set exports(t){Mh=t}},Fh=ht,zh=oi,Uh=bi,qh=sr,Yh=E([].concat),Wh=Fh("Reflect","ownKeys")||function(t){var e=zh.f(qh(t)),r=Uh.f;return r?Yh(e,r(t)):e},Gh=Wh,Xh=ot,Vh=R,Bh=cn;Cr({target:"Object",stat:!0,sham:!M},{getOwnPropertyDescriptors:function(t){for(var e,r,n=Xh(t),o=Vh.f,i=Gh(n),a={},u=0;i.length>u;)void 0!==(r=o(n,e=i[u++]))&&Bh(a,e,r);return a}});var Hh=st.Object.getOwnPropertyDescriptors;!function(t){t.exports=Hh}(Nh);var $h=n(Mh),Jh={},Kh={get exports(){return Jh},set exports(t){Jh=t}},Qh={},Zh={get exports(){return Qh},set exports(t){Qh=t}},tv=Cr,ev=M,rv=lo.f;tv({target:"Object",stat:!0,forced:Object.defineProperties!==rv,sham:!ev},{defineProperties:rv});var nv=st.Object,ov=Zh.exports=function(t,e){return nv.defineProperties(t,e)};nv.defineProperties.sham&&(ov.sham=!0);var iv=Qh;!function(t){t.exports=iv}(Kh);var av=n(Jh),uv={};!function(t){t.exports=Ur}({get exports(){return uv},set exports(t){uv=t}});var sv=n(uv),cv={},fv={get exports(){return cv},set exports(t){cv=t}},lv={},pv={get exports(){return lv},set exports(t){lv=t}};Cr({target:"Array",stat:!0},{isArray:Hr});var hv=st.Array.isArray,vv=hv;!function(t){t.exports=vv}(pv),function(t){t.exports=lv}(fv);var dv=n(cv);var yv={},gv={get exports(){return yv},set exports(t){yv=t}},mv={},bv={get exports(){return mv},set exports(t){mv=t}},xv=Cr,_v=Hr,wv=Mn,Ev=ut,Tv=yo,Ov=rn,Sv=ot,kv=cn,jv=me,Av=qu,Pv=Bn("slice"),Iv=jv("species"),Dv=Array,Lv=Math.max;xv({target:"Array",proto:!0,forced:!Pv},{slice:function(t,e){var r,n,o,i=Sv(this),a=Ov(i),u=Tv(t,a),s=Tv(void 0===e?a:e,a);if(_v(i)&&(r=i.constructor,(wv(r)&&(r===Dv||_v(r.prototype))||Ev(r)&&null===(r=r[Iv]))&&(r=void 0),r===Dv||void 0===r))return Av(i,u,s);for(n=new(void 0===r?Dv:r)(Lv(s-u,0)),o=0;u<s;u++,o++)u in i&&kv(n,o,i[u]);return n.length=o,n}});var Cv=vl("Array").slice,Rv=vt,Mv=Cv,Nv=Array.prototype,Fv=function(t){var e=t.slice;return t===Nv||Rv(Nv,t)&&e===Nv.slice?Mv:e},zv=Fv;!function(t){t.exports=zv}(bv),function(t){t.exports=mv}(gv);var Uv=n(yv),qv={},Yv={get exports(){return qv},set exports(t){qv=t}},Wv={},Gv=ph;!function(t){t.exports=Gv}({get exports(){return Wv},set exports(t){Wv=t}}),function(t){t.exports=Wv}(Yv);var Xv=n(qv);function Vv(t,e){(null==e||e>t.length)&&(e=t.length);for(var r=0,n=new Array(e);r<e;r++)n[r]=t[r];return n}function Bv(t,e){var r;if(t){if("string"==typeof t)return Vv(t,e);var n=Uv(r=Object.prototype.toString.call(t)).call(r,8,-1);return"Object"===n&&t.constructor&&(n=t.constructor.name),"Map"===n||"Set"===n?Xv(t):"Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)?Vv(t,e):void 0}}function Hv(t,e){return function(t){if(dv(t))return t}(t)||function(t,e){var r=null==t?null:void 0!==gf&&mh(t)||t["@@iterator"];if(null!=r){var n,o,i,a,u=[],s=!0,c=!1;try{if(i=(r=r.call(t)).next,0===e){if(Object(r)!==r)return;s=!1}else for(;!(s=(n=i.call(r)).done)&&(u.push(n.value),u.length!==e);s=!0);}catch(t){c=!0,o=t}finally{try{if(!s&&null!=r.return&&(a=r.return(),Object(a)!==a))return}finally{if(c)throw o}}return u}}(t,e)||Bv(t,e)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function $v(t){return function(t){if(dv(t))return Vv(t)}(t)||function(t){if(void 0!==gf&&null!=mh(t)||null!=t["@@iterator"])return Xv(t)}(t)||Bv(t)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var Jv={};!function(t){t.exports=Bc}({get exports(){return Jv},set exports(t){Jv=t}});var Kv=n(Jv),Qv={},Zv={get exports(){return Qv},set exports(t){Qv=t}},td=vl("Array").concat,ed=vt,rd=td,nd=Array.prototype,od=function(t){var e=t.concat;return t===nd||ed(nd,t)&&e===nd.concat?rd:e};!function(t){t.exports=od}(Zv);var id=n(Qv),ad={};!function(t){t.exports=Fv}({get exports(){return ad},set exports(t){ad=t}});var ud=n(ad),sd={},cd={get exports(){return sd},set exports(t){sd=t}};Cr({target:"Reflect",stat:!0},{ownKeys:Wh});var fd=st.Reflect.ownKeys;!function(t){t.exports=fd}(cd);var ld=n(sd),pd={};!function(t){t.exports=hv}({get exports(){return pd},set exports(t){pd=t}});var hd=n(pd),vd={},dd={get exports(){return vd},set exports(t){vd=t}},yd=ee,gd=Do;Cr({target:"Object",stat:!0,forced:p((function(){gd(1)}))},{keys:function(t){return gd(yd(t))}});var md=st.Object.keys;!function(t){t.exports=md}(dd);var bd=n(vd),xd={},_d={get exports(){return xd},set exports(t){xd=t}},wd=Cr,Ed=Date,Td=E(Ed.prototype.getTime);wd({target:"Date",stat:!0},{now:function(){return Td(new Ed)}});var Od=st.Date.now;!function(t){t.exports=Od}(_d);var Sd={},kd={get exports(){return Sd},set exports(t){Sd=t}},jd=ga.forEach,Ad=Il("forEach")?[].forEach:function(t){return jd(this,t,arguments.length>1?arguments[1]:void 0)};Cr({target:"Array",proto:!0,forced:[].forEach!=Ad},{forEach:Ad});var Pd=vl("Array").forEach,Id=mn,Dd=oe,Ld=vt,Cd=Pd,Rd=Array.prototype,Md={DOMTokenList:!0,NodeList:!0},Nd=function(t){var e=t.forEach;return t===Rd||Ld(Rd,t)&&e===Rd.forEach||Dd(Md,Id(t))?Cd:e};!function(t){t.exports=Nd}(kd);var Fd=n(Sd),zd={},Ud={get exports(){return zd},set exports(t){zd=t}},qd=Cr,Yd=Hr,Wd=E([].reverse),Gd=[1,2];qd({target:"Array",proto:!0,forced:String(Gd)===String(Gd.reverse())},{reverse:function(){return Yd(this)&&(this.length=this.length),Wd(this)}});var Xd=vl("Array").reverse,Vd=vt,Bd=Xd,Hd=Array.prototype,$d=function(t){var e=t.reverse;return t===Hd||Vd(Hd,t)&&e===Hd.reverse?Bd:e};!function(t){t.exports=$d}(Ud);var Jd=n(zd),Kd={},Qd={get exports(){return Kd},set exports(t){Kd=t}},Zd=M,ty=Hr,ey=TypeError,ry=Object.getOwnPropertyDescriptor,ny=Zd&&!function(){if(void 0!==this)return!0;try{Object.defineProperty([],"length",{writable:!1}).length=1}catch(t){return t instanceof TypeError}}(),oy=Lt,iy=TypeError,ay=function(t,e){if(!delete t[e])throw iy("Cannot delete property "+oy(e)+" of "+oy(t))},uy=Cr,sy=ee,cy=yo,fy=Qr,ly=rn,py=ny?function(t,e){if(ty(t)&&!ry(t,"length").writable)throw ey("Cannot set read only .length");return t.length=e}:function(t,e){return t.length=e},hy=on,vy=Wn,dy=cn,yy=ay,gy=Bn("splice"),my=Math.max,by=Math.min;uy({target:"Array",proto:!0,forced:!gy},{splice:function(t,e){var r,n,o,i,a,u,s=sy(this),c=ly(s),f=cy(t,c),l=arguments.length;for(0===l?r=n=0:1===l?(r=0,n=c-f):(r=l-2,n=by(my(fy(e),0),c-f)),hy(c+r-n),o=vy(s,n),i=0;i<n;i++)(a=f+i)in s&&dy(o,i,s[a]);if(o.length=n,r<n){for(i=f;i<c-n;i++)u=i+r,(a=i+n)in s?s[u]=s[a]:yy(s,u);for(i=c;i>c-n+r;i--)yy(s,i-1)}else if(r>n)for(i=c-n;i>f;i--)u=i+r-1,(a=i+n-1)in s?s[u]=s[a]:yy(s,u);for(i=0;i<r;i++)s[i+f]=arguments[i+2];return py(s,c-n+r),o}});var xy=vl("Array").splice,_y=vt,wy=xy,Ey=Array.prototype,Ty=function(t){var e=t.splice;return t===Ey||_y(Ey,t)&&e===Ey.splice?wy:e};!function(t){t.exports=Ty}(Qd);var Oy=n(Kd),Sy={},ky={get exports(){return Sy},set exports(t){Sy=t}},jy=M,Ay=E,Py=z,Iy=p,Dy=Do,Ly=bi,Cy=U,Ry=ee,My=K,Ny=Object.assign,Fy=Object.defineProperty,zy=Ay([].concat),Uy=!Ny||Iy((function(){if(jy&&1!==Ny({b:1},Ny(Fy({},"a",{enumerable:!0,get:function(){Fy(this,"b",{value:3,enumerable:!1})}}),{b:2})).b)return!0;var t={},e={},r=Symbol(),n="abcdefghijklmnopqrst";return t[r]=7,n.split("").forEach((function(t){e[t]=t})),7!=Ny({},t)[r]||Dy(Ny({},e)).join("")!=n}))?function(t,e){for(var r=Ry(t),n=arguments.length,o=1,i=Ly.f,a=Cy.f;n>o;)for(var u,s=My(arguments[o++]),c=i?zy(Dy(s),i(s)):Dy(s),f=c.length,l=0;f>l;)u=c[l++],jy&&!Py(a,s,u)||(r[u]=s[u]);return r}:Ny,qy=Uy;Cr({target:"Object",stat:!0,arity:2,forced:Object.assign!==qy},{assign:qy});var Yy=st.Object.assign;!function(t){t.exports=Yy}(ky);var Wy=n(Sy),Gy={},Xy={get exports(){return Gy},set exports(t){Gy=t}},Vy=_o.includes;Cr({target:"Array",proto:!0,forced:p((function(){return!Array(1).includes()}))},{includes:function(t){return Vy(this,t,arguments.length>1?arguments[1]:void 0)}});var By=vl("Array").includes,Hy=ut,$y=k,Jy=me("match"),Ky=function(t){var e;return Hy(t)&&(void 0!==(e=t[Jy])?!!e:"RegExp"==$y(t))},Qy=TypeError,Zy=me("match"),tg=Cr,eg=function(t){if(Ky(t))throw Qy("The method doesn't accept regular expressions");return t},rg=et,ng=fo,og=function(t){var e=/./;try{"/./"[t](e)}catch(r){try{return e[Zy]=!1,"/./"[t](e)}catch(t){}}return!1},ig=E("".indexOf);tg({target:"String",proto:!0,forced:!og("includes")},{includes:function(t){return!!~ig(ng(rg(this)),ng(eg(t)),arguments.length>1?arguments[1]:void 0)}});var ag=vl("String").includes,ug=vt,sg=By,cg=ag,fg=Array.prototype,lg=String.prototype,pg=function(t){var e=t.includes;return t===fg||ug(fg,t)&&e===fg.includes?sg:"string"==typeof t||t===lg||ug(lg,t)&&e===lg.includes?cg:e};!function(t){t.exports=pg}(Xy);var hg={},vg={get exports(){return hg},set exports(t){hg=t}},dg=ee,yg=Ys,gg=Cs;Cr({target:"Object",stat:!0,forced:p((function(){yg(1)})),sham:!gg},{getPrototypeOf:function(t){return yg(dg(t))}});var mg=st.Object.getPrototypeOf;!function(t){t.exports=mg}(vg);var bg={},xg={get exports(){return bg},set exports(t){bg=t}},_g=M,wg=E,Eg=Do,Tg=ot,Og=wg(U.f),Sg=wg([].push),kg=function(t){return function(e){for(var r,n=Tg(e),o=Eg(n),i=o.length,a=0,u=[];i>a;)r=o[a++],_g&&!Og(n,r)||Sg(u,t?[r,n[r]]:n[r]);return u}},jg={entries:kg(!0),values:kg(!1)}.values;Cr({target:"Object",stat:!0},{values:function(t){return jg(t)}});var Ag=st.Object.values;!function(t){t.exports=Ag}(xg);var Pg={},Ig={get exports(){return Pg},set exports(t){Pg=t}},Dg="\t\n\v\f\r                　\u2028\u2029\ufeff",Lg=et,Cg=fo,Rg=Dg,Mg=E("".replace),Ng=RegExp("^["+Rg+"]+"),Fg=RegExp("(^|[^"+Rg+"])["+Rg+"]+$"),zg=function(t){return function(e){var r=Cg(Lg(e));return 1&t&&(r=Mg(r,Ng,"")),2&t&&(r=Mg(r,Fg,"$1")),r}},Ug={start:zg(1),end:zg(2),trim:zg(3)},qg=l,Yg=p,Wg=E,Gg=fo,Xg=Ug.trim,Vg=Dg,Bg=qg.parseInt,Hg=qg.Symbol,$g=Hg&&Hg.iterator,Jg=/^[+-]?0x/i,Kg=Wg(Jg.exec),Qg=8!==Bg(Vg+"08")||22!==Bg(Vg+"0x16")||$g&&!Yg((function(){Bg(Object($g))}))?function(t,e){var r=Xg(Gg(t));return Bg(r,e>>>0||(Kg(Jg,r)?16:10))}:Bg;Cr({global:!0,forced:parseInt!=Qg},{parseInt:Qg});var Zg=st.parseInt;!function(t){t.exports=Zg}(Ig);var tm={},em={get exports(){return tm},set exports(t){tm=t}},rm=Cr,nm=_o.indexOf,om=Il,im=P([].indexOf),am=!!im&&1/im([1],1,-0)<0;rm({target:"Array",proto:!0,forced:am||!om("indexOf")},{indexOf:function(t){var e=arguments.length>1?arguments[1]:void 0;return am?im(this,t,e)||0:nm(this,t,e)}});var um=vl("Array").indexOf,sm=vt,cm=um,fm=Array.prototype,lm=function(t){var e=t.indexOf;return t===fm||sm(fm,t)&&e===fm.indexOf?cm:e};!function(t){t.exports=lm}(em);var pm={},hm={get exports(){return pm},set exports(t){pm=t}},vm=Ls.PROPER,dm=p,ym=Dg,gm=Ug.trim;Cr({target:"String",proto:!0,forced:function(t){return dm((function(){return!!ym[t]()||"​᠎"!=="​᠎"[t]()||vm&&ym[t].name!==t}))}("trim")},{trim:function(){return gm(this)}});var mm=vl("String").trim,bm=vt,xm=mm,_m=String.prototype,wm=function(t){var e=t.trim;return"string"==typeof t||t===_m||bm(_m,t)&&e===_m.trim?xm:e};!function(t){t.exports=wm}(hm);var Em={},Tm={get exports(){return Em},set exports(t){Em=t}};Cr({target:"Object",stat:!0,sham:!M},{create:ni});var Om=st.Object,Sm=function(t,e){return Om.create(t,e)};!function(t){t.exports=Sm}(Tm);var km=n(Em),jm={},Am={get exports(){return jm},set exports(t){jm=t}},Pm=st,Im=m;Pm.JSON||(Pm.JSON={stringify:JSON.stringify});var Dm=function(t,e,r){return Im(Pm.JSON.stringify,null,arguments)},Lm=Dm;!function(t){t.exports=Lm}(Am);var Cm=n(jm),Rm={},Mm={get exports(){return Rm},set exports(t){Rm=t}},Nm="function"==typeof Bun&&Bun&&"string"==typeof Bun.version,Fm=TypeError,zm=function(t,e){if(t<e)throw Fm("Not enough arguments");return t},Um=l,qm=m,Ym=C,Wm=Nm,Gm=dt,Xm=qu,Vm=zm,Bm=Um.Function,Hm=/MSIE .\./.test(Gm)||Wm&&function(){var t=Um.Bun.version.split(".");return t.length<3||0==t[0]&&(t[1]<3||3==t[1]&&0==t[2])}(),$m=function(t,e){var r=e?2:1;return Hm?function(n,o){var i=Vm(arguments.length,1)>r,a=Ym(n)?n:Bm(n),u=i?Xm(arguments,r):[],s=i?function(){qm(a,this,u)}:a;return e?t(s,o):t(s)}:t},Jm=Cr,Km=l,Qm=$m(Km.setInterval,!0);Jm({global:!0,bind:!0,forced:Km.setInterval!==Qm},{setInterval:Qm});var Zm=Cr,tb=l,eb=$m(tb.setTimeout,!0);Zm({global:!0,bind:!0,forced:tb.setTimeout!==eb},{setTimeout:eb});var rb=st.setTimeout;!function(t){t.exports=rb}(Mm);var nb=n(Rm),ob={},ib={get exports(){return ob},set exports(t){ob=t}},ab=ee,ub=yo,sb=rn,cb=function(t){for(var e=ab(this),r=sb(e),n=arguments.length,o=ub(n>1?arguments[1]:void 0,r),i=n>2?arguments[2]:void 0,a=void 0===i?r:ub(i,r);a>o;)e[o++]=t;return e};Cr({target:"Array",proto:!0},{fill:cb});var fb=vl("Array").fill,lb=vt,pb=fb,hb=Array.prototype,vb=function(t){var e=t.fill;return t===hb||lb(hb,t)&&e===hb.fill?pb:e};!function(t){t.exports=vb}(ib);var db={};!function(t){function e(t){if(t)return function(t){for(var r in e.prototype)t[r]=e.prototype[r];return t}(t)}t.exports=e,e.prototype.on=e.prototype.addEventListener=function(t,e){return this._callbacks=this._callbacks||{},(this._callbacks["$"+t]=this._callbacks["$"+t]||[]).push(e),this},e.prototype.once=function(t,e){function r(){this.off(t,r),e.apply(this,arguments)}return r.fn=e,this.on(t,r),this},e.prototype.off=e.prototype.removeListener=e.prototype.removeAllListeners=e.prototype.removeEventListener=function(t,e){if(this._callbacks=this._callbacks||{},0==arguments.length)return this._callbacks={},this;var r,n=this._callbacks["$"+t];if(!n)return this;if(1==arguments.length)return delete this._callbacks["$"+t],this;for(var o=0;o<n.length;o++)if((r=n[o])===e||r.fn===e){n.splice(o,1);break}return 0===n.length&&delete this._callbacks["$"+t],this},e.prototype.emit=function(t){this._callbacks=this._callbacks||{};for(var e=new Array(arguments.length-1),r=this._callbacks["$"+t],n=1;n<arguments.length;n++)e[n-1]=arguments[n];if(r){n=0;for(var o=(r=r.slice(0)).length;n<o;++n)r[n].apply(this,e)}return this},e.prototype.listeners=function(t){return this._callbacks=this._callbacks||{},this._callbacks["$"+t]||[]},e.prototype.hasListeners=function(t){return!!this.listeners(t).length}}({get exports(){return db},set exports(t){db=t}});var yb,gb=db;
/*! Hammer.JS - v2.0.17-rc - 2019-12-16
   * http://naver.github.io/egjs
   *
   * Forked By Naver egjs
   * Copyright (c) hammerjs
   * Licensed under the MIT license */function mb(){return mb=Object.assign||function(t){for(var e=1;e<arguments.length;e++){var r=arguments[e];for(var n in r)Object.prototype.hasOwnProperty.call(r,n)&&(t[n]=r[n])}return t},mb.apply(this,arguments)}function bb(t,e){t.prototype=Object.create(e.prototype),t.prototype.constructor=t,t.__proto__=e}function xb(t){if(void 0===t)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return t}yb="function"!=typeof Object.assign?function(t){if(null==t)throw new TypeError("Cannot convert undefined or null to object");for(var e=Object(t),r=1;r<arguments.length;r++){var n=arguments[r];if(null!=n)for(var o in n)n.hasOwnProperty(o)&&(e[o]=n[o])}return e}:Object.assign;var _b,wb=yb,Eb=["","webkit","Moz","MS","ms","o"],Tb="undefined"==typeof document?{style:{}}:document.createElement("div"),Ob="function",Sb=Math.round,kb=Math.abs,jb=Date.now;function Ab(t,e){for(var r,n,o=e[0].toUpperCase()+e.slice(1),i=0;i<Eb.length;){if((n=(r=Eb[i])?r+o:e)in t)return n;i++}}_b="undefined"==typeof window?{}:window;var Pb=Ab(Tb.style,"touchAction"),Ib=void 0!==Pb;var Db="compute",Lb="auto",Cb="manipulation",Rb="none",Mb="pan-x",Nb="pan-y",Fb=function(){if(!Ib)return!1;var t={},e=_b.CSS&&_b.CSS.supports;return["auto","manipulation","pan-y","pan-x","pan-x pan-y","none"].forEach((function(r){return t[r]=!e||_b.CSS.supports("touch-action",r)})),t}(),zb="ontouchstart"in _b,Ub=void 0!==Ab(_b,"PointerEvent"),qb=zb&&/mobile|tablet|ip(ad|hone|od)|android/i.test(navigator.userAgent),Yb="touch",Wb="mouse",Gb=25,Xb=1,Vb=2,Bb=4,Hb=8,$b=1,Jb=2,Kb=4,Qb=8,Zb=16,tx=Jb|Kb,ex=Qb|Zb,rx=tx|ex,nx=["x","y"],ox=["clientX","clientY"];function ix(t,e,r){var n;if(t)if(t.forEach)t.forEach(e,r);else if(void 0!==t.length)for(n=0;n<t.length;)e.call(r,t[n],n,t),n++;else for(n in t)t.hasOwnProperty(n)&&e.call(r,t[n],n,t)}function ax(t,e){return typeof t===Ob?t.apply(e&&e[0]||void 0,e):t}function ux(t,e){return t.indexOf(e)>-1}var sx=function(){function t(t,e){this.manager=t,this.set(e)}var e=t.prototype;return e.set=function(t){t===Db&&(t=this.compute()),Ib&&this.manager.element.style&&Fb[t]&&(this.manager.element.style[Pb]=t),this.actions=t.toLowerCase().trim()},e.update=function(){this.set(this.manager.options.touchAction)},e.compute=function(){var t=[];return ix(this.manager.recognizers,(function(e){ax(e.options.enable,[e])&&(t=t.concat(e.getTouchAction()))})),function(t){if(ux(t,Rb))return Rb;var e=ux(t,Mb),r=ux(t,Nb);return e&&r?Rb:e||r?e?Mb:Nb:ux(t,Cb)?Cb:Lb}(t.join(" "))},e.preventDefaults=function(t){var e=t.srcEvent,r=t.offsetDirection;if(this.manager.session.prevented)e.preventDefault();else{var n=this.actions,o=ux(n,Rb)&&!Fb[Rb],i=ux(n,Nb)&&!Fb[Nb],a=ux(n,Mb)&&!Fb[Mb];if(o){var u=1===t.pointers.length,s=t.distance<2,c=t.deltaTime<250;if(u&&s&&c)return}if(!a||!i)return o||i&&r&tx||a&&r&ex?this.preventSrc(e):void 0}},e.preventSrc=function(t){this.manager.session.prevented=!0,t.preventDefault()},t}();function cx(t,e){for(;t;){if(t===e)return!0;t=t.parentNode}return!1}function fx(t){var e=t.length;if(1===e)return{x:Sb(t[0].clientX),y:Sb(t[0].clientY)};for(var r=0,n=0,o=0;o<e;)r+=t[o].clientX,n+=t[o].clientY,o++;return{x:Sb(r/e),y:Sb(n/e)}}function lx(t){for(var e=[],r=0;r<t.pointers.length;)e[r]={clientX:Sb(t.pointers[r].clientX),clientY:Sb(t.pointers[r].clientY)},r++;return{timeStamp:jb(),pointers:e,center:fx(e),deltaX:t.deltaX,deltaY:t.deltaY}}function px(t,e,r){r||(r=nx);var n=e[r[0]]-t[r[0]],o=e[r[1]]-t[r[1]];return Math.sqrt(n*n+o*o)}function hx(t,e,r){r||(r=nx);var n=e[r[0]]-t[r[0]],o=e[r[1]]-t[r[1]];return 180*Math.atan2(o,n)/Math.PI}function vx(t,e){return t===e?$b:kb(t)>=kb(e)?t<0?Jb:Kb:e<0?Qb:Zb}function dx(t,e,r){return{x:e/t||0,y:r/t||0}}function yx(t,e){var r=t.session,n=e.pointers,o=n.length;r.firstInput||(r.firstInput=lx(e)),o>1&&!r.firstMultiple?r.firstMultiple=lx(e):1===o&&(r.firstMultiple=!1);var i=r.firstInput,a=r.firstMultiple,u=a?a.center:i.center,s=e.center=fx(n);e.timeStamp=jb(),e.deltaTime=e.timeStamp-i.timeStamp,e.angle=hx(u,s),e.distance=px(u,s),function(t,e){var r=e.center,n=t.offsetDelta||{},o=t.prevDelta||{},i=t.prevInput||{};e.eventType!==Xb&&i.eventType!==Bb||(o=t.prevDelta={x:i.deltaX||0,y:i.deltaY||0},n=t.offsetDelta={x:r.x,y:r.y}),e.deltaX=o.x+(r.x-n.x),e.deltaY=o.y+(r.y-n.y)}(r,e),e.offsetDirection=vx(e.deltaX,e.deltaY);var c,f,l=dx(e.deltaTime,e.deltaX,e.deltaY);e.overallVelocityX=l.x,e.overallVelocityY=l.y,e.overallVelocity=kb(l.x)>kb(l.y)?l.x:l.y,e.scale=a?(c=a.pointers,px((f=n)[0],f[1],ox)/px(c[0],c[1],ox)):1,e.rotation=a?function(t,e){return hx(e[1],e[0],ox)+hx(t[1],t[0],ox)}(a.pointers,n):0,e.maxPointers=r.prevInput?e.pointers.length>r.prevInput.maxPointers?e.pointers.length:r.prevInput.maxPointers:e.pointers.length,function(t,e){var r,n,o,i,a=t.lastInterval||e,u=e.timeStamp-a.timeStamp;if(e.eventType!==Hb&&(u>Gb||void 0===a.velocity)){var s=e.deltaX-a.deltaX,c=e.deltaY-a.deltaY,f=dx(u,s,c);n=f.x,o=f.y,r=kb(f.x)>kb(f.y)?f.x:f.y,i=vx(s,c),t.lastInterval=e}else r=a.velocity,n=a.velocityX,o=a.velocityY,i=a.direction;e.velocity=r,e.velocityX=n,e.velocityY=o,e.direction=i}(r,e);var p,h=t.element,v=e.srcEvent;cx(p=v.composedPath?v.composedPath()[0]:v.path?v.path[0]:v.target,h)&&(h=p),e.target=h}function gx(t,e,r){var n=r.pointers.length,o=r.changedPointers.length,i=e&Xb&&n-o==0,a=e&(Bb|Hb)&&n-o==0;r.isFirst=!!i,r.isFinal=!!a,i&&(t.session={}),r.eventType=e,yx(t,r),t.emit("hammer.input",r),t.recognize(r),t.session.prevInput=r}function mx(t){return t.trim().split(/\s+/g)}function bx(t,e,r){ix(mx(e),(function(e){t.addEventListener(e,r,!1)}))}function xx(t,e,r){ix(mx(e),(function(e){t.removeEventListener(e,r,!1)}))}function _x(t){var e=t.ownerDocument||t;return e.defaultView||e.parentWindow||window}var wx=function(){function t(t,e){var r=this;this.manager=t,this.callback=e,this.element=t.element,this.target=t.options.inputTarget,this.domHandler=function(e){ax(t.options.enable,[t])&&r.handler(e)},this.init()}var e=t.prototype;return e.handler=function(){},e.init=function(){this.evEl&&bx(this.element,this.evEl,this.domHandler),this.evTarget&&bx(this.target,this.evTarget,this.domHandler),this.evWin&&bx(_x(this.element),this.evWin,this.domHandler)},e.destroy=function(){this.evEl&&xx(this.element,this.evEl,this.domHandler),this.evTarget&&xx(this.target,this.evTarget,this.domHandler),this.evWin&&xx(_x(this.element),this.evWin,this.domHandler)},t}();function Ex(t,e,r){if(t.indexOf&&!r)return t.indexOf(e);for(var n=0;n<t.length;){if(r&&t[n][r]==e||!r&&t[n]===e)return n;n++}return-1}var Tx={pointerdown:Xb,pointermove:Vb,pointerup:Bb,pointercancel:Hb,pointerout:Hb},Ox={2:Yb,3:"pen",4:Wb,5:"kinect"},Sx="pointerdown",kx="pointermove pointerup pointercancel";_b.MSPointerEvent&&!_b.PointerEvent&&(Sx="MSPointerDown",kx="MSPointerMove MSPointerUp MSPointerCancel");var jx=function(t){function e(){var r,n=e.prototype;return n.evEl=Sx,n.evWin=kx,(r=t.apply(this,arguments)||this).store=r.manager.session.pointerEvents=[],r}return bb(e,t),e.prototype.handler=function(t){var e=this.store,r=!1,n=t.type.toLowerCase().replace("ms",""),o=Tx[n],i=Ox[t.pointerType]||t.pointerType,a=i===Yb,u=Ex(e,t.pointerId,"pointerId");o&Xb&&(0===t.button||a)?u<0&&(e.push(t),u=e.length-1):o&(Bb|Hb)&&(r=!0),u<0||(e[u]=t,this.callback(this.manager,o,{pointers:e,changedPointers:[t],pointerType:i,srcEvent:t}),r&&e.splice(u,1))},e}(wx);function Ax(t){return Array.prototype.slice.call(t,0)}function Px(t,e,r){for(var n=[],o=[],i=0;i<t.length;){var a=e?t[i][e]:t[i];Ex(o,a)<0&&n.push(t[i]),o[i]=a,i++}return r&&(n=e?n.sort((function(t,r){return t[e]>r[e]})):n.sort()),n}var Ix={touchstart:Xb,touchmove:Vb,touchend:Bb,touchcancel:Hb},Dx="touchstart touchmove touchend touchcancel",Lx=function(t){function e(){var r;return e.prototype.evTarget=Dx,(r=t.apply(this,arguments)||this).targetIds={},r}return bb(e,t),e.prototype.handler=function(t){var e=Ix[t.type],r=Cx.call(this,t,e);r&&this.callback(this.manager,e,{pointers:r[0],changedPointers:r[1],pointerType:Yb,srcEvent:t})},e}(wx);function Cx(t,e){var r,n,o=Ax(t.touches),i=this.targetIds;if(e&(Xb|Vb)&&1===o.length)return i[o[0].identifier]=!0,[o,o];var a=Ax(t.changedTouches),u=[],s=this.target;if(n=o.filter((function(t){return cx(t.target,s)})),e===Xb)for(r=0;r<n.length;)i[n[r].identifier]=!0,r++;for(r=0;r<a.length;)i[a[r].identifier]&&u.push(a[r]),e&(Bb|Hb)&&delete i[a[r].identifier],r++;return u.length?[Px(n.concat(u),"identifier",!0),u]:void 0}var Rx={mousedown:Xb,mousemove:Vb,mouseup:Bb},Mx="mousedown",Nx="mousemove mouseup",Fx=function(t){function e(){var r,n=e.prototype;return n.evEl=Mx,n.evWin=Nx,(r=t.apply(this,arguments)||this).pressed=!1,r}return bb(e,t),e.prototype.handler=function(t){var e=Rx[t.type];e&Xb&&0===t.button&&(this.pressed=!0),e&Vb&&1!==t.which&&(e=Bb),this.pressed&&(e&Bb&&(this.pressed=!1),this.callback(this.manager,e,{pointers:[t],changedPointers:[t],pointerType:Wb,srcEvent:t}))},e}(wx),zx=2500,Ux=25;function qx(t){var e=t.changedPointers[0];if(e.identifier===this.primaryTouch){var r={x:e.clientX,y:e.clientY},n=this.lastTouches;this.lastTouches.push(r);setTimeout((function(){var t=n.indexOf(r);t>-1&&n.splice(t,1)}),zx)}}function Yx(t,e){t&Xb?(this.primaryTouch=e.changedPointers[0].identifier,qx.call(this,e)):t&(Bb|Hb)&&qx.call(this,e)}function Wx(t){for(var e=t.srcEvent.clientX,r=t.srcEvent.clientY,n=0;n<this.lastTouches.length;n++){var o=this.lastTouches[n],i=Math.abs(e-o.x),a=Math.abs(r-o.y);if(i<=Ux&&a<=Ux)return!0}return!1}var Gx=function(){return function(t){function e(e,r){var n;return(n=t.call(this,e,r)||this).handler=function(t,e,r){var o=r.pointerType===Yb,i=r.pointerType===Wb;if(!(i&&r.sourceCapabilities&&r.sourceCapabilities.firesTouchEvents)){if(o)Yx.call(xb(xb(n)),e,r);else if(i&&Wx.call(xb(xb(n)),r))return;n.callback(t,e,r)}},n.touch=new Lx(n.manager,n.handler),n.mouse=new Fx(n.manager,n.handler),n.primaryTouch=null,n.lastTouches=[],n}return bb(e,t),e.prototype.destroy=function(){this.touch.destroy(),this.mouse.destroy()},e}(wx)}();function Xx(t,e,r){return!!Array.isArray(t)&&(ix(t,r[e],r),!0)}var Vx=1,Bx=2,Hx=4,$x=8,Jx=$x,Kx=16,Qx=32,Zx=1;function t_(t,e){var r=e.manager;return r?r.get(t):t}function e_(t){return t&Kx?"cancel":t&$x?"end":t&Hx?"move":t&Bx?"start":""}var r_=function(){function t(t){void 0===t&&(t={}),this.options=mb({enable:!0},t),this.id=Zx++,this.manager=null,this.state=Vx,this.simultaneous={},this.requireFail=[]}var e=t.prototype;return e.set=function(t){return wb(this.options,t),this.manager&&this.manager.touchAction.update(),this},e.recognizeWith=function(t){if(Xx(t,"recognizeWith",this))return this;var e=this.simultaneous;return e[(t=t_(t,this)).id]||(e[t.id]=t,t.recognizeWith(this)),this},e.dropRecognizeWith=function(t){return Xx(t,"dropRecognizeWith",this)||(t=t_(t,this),delete this.simultaneous[t.id]),this},e.requireFailure=function(t){if(Xx(t,"requireFailure",this))return this;var e=this.requireFail;return-1===Ex(e,t=t_(t,this))&&(e.push(t),t.requireFailure(this)),this},e.dropRequireFailure=function(t){if(Xx(t,"dropRequireFailure",this))return this;t=t_(t,this);var e=Ex(this.requireFail,t);return e>-1&&this.requireFail.splice(e,1),this},e.hasRequireFailures=function(){return this.requireFail.length>0},e.canRecognizeWith=function(t){return!!this.simultaneous[t.id]},e.emit=function(t){var e=this,r=this.state;function n(r){e.manager.emit(r,t)}r<$x&&n(e.options.event+e_(r)),n(e.options.event),t.additionalEvent&&n(t.additionalEvent),r>=$x&&n(e.options.event+e_(r))},e.tryEmit=function(t){if(this.canEmit())return this.emit(t);this.state=Qx},e.canEmit=function(){for(var t=0;t<this.requireFail.length;){if(!(this.requireFail[t].state&(Qx|Vx)))return!1;t++}return!0},e.recognize=function(t){var e=wb({},t);if(!ax(this.options.enable,[this,e]))return this.reset(),void(this.state=Qx);this.state&(Jx|Kx|Qx)&&(this.state=Vx),this.state=this.process(e),this.state&(Bx|Hx|$x|Kx)&&this.tryEmit(e)},e.process=function(t){},e.getTouchAction=function(){},e.reset=function(){},t}(),n_=function(t){function e(e){var r;return void 0===e&&(e={}),(r=t.call(this,mb({event:"tap",pointers:1,taps:1,interval:300,time:250,threshold:9,posThreshold:10},e))||this).pTime=!1,r.pCenter=!1,r._timer=null,r._input=null,r.count=0,r}bb(e,t);var r=e.prototype;return r.getTouchAction=function(){return[Cb]},r.process=function(t){var e=this,r=this.options,n=t.pointers.length===r.pointers,o=t.distance<r.threshold,i=t.deltaTime<r.time;if(this.reset(),t.eventType&Xb&&0===this.count)return this.failTimeout();if(o&&i&&n){if(t.eventType!==Bb)return this.failTimeout();var a=!this.pTime||t.timeStamp-this.pTime<r.interval,u=!this.pCenter||px(this.pCenter,t.center)<r.posThreshold;if(this.pTime=t.timeStamp,this.pCenter=t.center,u&&a?this.count+=1:this.count=1,this._input=t,0===this.count%r.taps)return this.hasRequireFailures()?(this._timer=setTimeout((function(){e.state=Jx,e.tryEmit()}),r.interval),Bx):Jx}return Qx},r.failTimeout=function(){var t=this;return this._timer=setTimeout((function(){t.state=Qx}),this.options.interval),Qx},r.reset=function(){clearTimeout(this._timer)},r.emit=function(){this.state===Jx&&(this._input.tapCount=this.count,this.manager.emit(this.options.event,this._input))},e}(r_),o_=function(t){function e(e){return void 0===e&&(e={}),t.call(this,mb({pointers:1},e))||this}bb(e,t);var r=e.prototype;return r.attrTest=function(t){var e=this.options.pointers;return 0===e||t.pointers.length===e},r.process=function(t){var e=this.state,r=t.eventType,n=e&(Bx|Hx),o=this.attrTest(t);return n&&(r&Hb||!o)?e|Kx:n||o?r&Bb?e|$x:e&Bx?e|Hx:Bx:Qx},e}(r_);function i_(t){return t===Zb?"down":t===Qb?"up":t===Jb?"left":t===Kb?"right":""}var a_=function(t){function e(e){var r;return void 0===e&&(e={}),(r=t.call(this,mb({event:"pan",threshold:10,pointers:1,direction:rx},e))||this).pX=null,r.pY=null,r}bb(e,t);var r=e.prototype;return r.getTouchAction=function(){var t=this.options.direction,e=[];return t&tx&&e.push(Nb),t&ex&&e.push(Mb),e},r.directionTest=function(t){var e=this.options,r=!0,n=t.distance,o=t.direction,i=t.deltaX,a=t.deltaY;return o&e.direction||(e.direction&tx?(o=0===i?$b:i<0?Jb:Kb,r=i!==this.pX,n=Math.abs(t.deltaX)):(o=0===a?$b:a<0?Qb:Zb,r=a!==this.pY,n=Math.abs(t.deltaY))),t.direction=o,r&&n>e.threshold&&o&e.direction},r.attrTest=function(t){return o_.prototype.attrTest.call(this,t)&&(this.state&Bx||!(this.state&Bx)&&this.directionTest(t))},r.emit=function(e){this.pX=e.deltaX,this.pY=e.deltaY;var r=i_(e.direction);r&&(e.additionalEvent=this.options.event+r),t.prototype.emit.call(this,e)},e}(o_),u_=function(t){function e(e){return void 0===e&&(e={}),t.call(this,mb({event:"swipe",threshold:10,velocity:.3,direction:tx|ex,pointers:1},e))||this}bb(e,t);var r=e.prototype;return r.getTouchAction=function(){return a_.prototype.getTouchAction.call(this)},r.attrTest=function(e){var r,n=this.options.direction;return n&(tx|ex)?r=e.overallVelocity:n&tx?r=e.overallVelocityX:n&ex&&(r=e.overallVelocityY),t.prototype.attrTest.call(this,e)&&n&e.offsetDirection&&e.distance>this.options.threshold&&e.maxPointers===this.options.pointers&&kb(r)>this.options.velocity&&e.eventType&Bb},r.emit=function(t){var e=i_(t.offsetDirection);e&&this.manager.emit(this.options.event+e,t),this.manager.emit(this.options.event,t)},e}(o_),s_=function(t){function e(e){return void 0===e&&(e={}),t.call(this,mb({event:"pinch",threshold:0,pointers:2},e))||this}bb(e,t);var r=e.prototype;return r.getTouchAction=function(){return[Rb]},r.attrTest=function(e){return t.prototype.attrTest.call(this,e)&&(Math.abs(e.scale-1)>this.options.threshold||this.state&Bx)},r.emit=function(e){if(1!==e.scale){var r=e.scale<1?"in":"out";e.additionalEvent=this.options.event+r}t.prototype.emit.call(this,e)},e}(o_),c_=function(t){function e(e){return void 0===e&&(e={}),t.call(this,mb({event:"rotate",threshold:0,pointers:2},e))||this}bb(e,t);var r=e.prototype;return r.getTouchAction=function(){return[Rb]},r.attrTest=function(e){return t.prototype.attrTest.call(this,e)&&(Math.abs(e.rotation)>this.options.threshold||this.state&Bx)},e}(o_),f_=function(t){function e(e){var r;return void 0===e&&(e={}),(r=t.call(this,mb({event:"press",pointers:1,time:251,threshold:9},e))||this)._timer=null,r._input=null,r}bb(e,t);var r=e.prototype;return r.getTouchAction=function(){return[Lb]},r.process=function(t){var e=this,r=this.options,n=t.pointers.length===r.pointers,o=t.distance<r.threshold,i=t.deltaTime>r.time;if(this._input=t,!o||!n||t.eventType&(Bb|Hb)&&!i)this.reset();else if(t.eventType&Xb)this.reset(),this._timer=setTimeout((function(){e.state=Jx,e.tryEmit()}),r.time);else if(t.eventType&Bb)return Jx;return Qx},r.reset=function(){clearTimeout(this._timer)},r.emit=function(t){this.state===Jx&&(t&&t.eventType&Bb?this.manager.emit(this.options.event+"up",t):(this._input.timeStamp=jb(),this.manager.emit(this.options.event,this._input)))},e}(r_),l_={domEvents:!1,touchAction:Db,enable:!0,inputTarget:null,inputClass:null,cssProps:{userSelect:"none",touchSelect:"none",touchCallout:"none",contentZooming:"none",userDrag:"none",tapHighlightColor:"rgba(0,0,0,0)"}},p_=[[c_,{enable:!1}],[s_,{enable:!1},["rotate"]],[u_,{direction:tx}],[a_,{direction:tx},["swipe"]],[n_],[n_,{event:"doubletap",taps:2},["tap"]],[f_]];function h_(t,e){var r,n=t.element;n.style&&(ix(t.options.cssProps,(function(o,i){r=Ab(n.style,i),e?(t.oldCssProps[r]=n.style[r],n.style[r]=o):n.style[r]=t.oldCssProps[r]||""})),e||(t.oldCssProps={}))}var v_=function(){function t(t,e){var r,n=this;this.options=wb({},l_,e||{}),this.options.inputTarget=this.options.inputTarget||t,this.handlers={},this.session={},this.recognizers=[],this.oldCssProps={},this.element=t,this.input=new((r=this).options.inputClass||(Ub?jx:qb?Lx:zb?Gx:Fx))(r,gx),this.touchAction=new sx(this,this.options.touchAction),h_(this,!0),ix(this.options.recognizers,(function(t){var e=n.add(new t[0](t[1]));t[2]&&e.recognizeWith(t[2]),t[3]&&e.requireFailure(t[3])}),this)}var e=t.prototype;return e.set=function(t){return wb(this.options,t),t.touchAction&&this.touchAction.update(),t.inputTarget&&(this.input.destroy(),this.input.target=t.inputTarget,this.input.init()),this},e.stop=function(t){this.session.stopped=t?2:1},e.recognize=function(t){var e=this.session;if(!e.stopped){var r;this.touchAction.preventDefaults(t);var n=this.recognizers,o=e.curRecognizer;(!o||o&&o.state&Jx)&&(e.curRecognizer=null,o=null);for(var i=0;i<n.length;)r=n[i],2===e.stopped||o&&r!==o&&!r.canRecognizeWith(o)?r.reset():r.recognize(t),!o&&r.state&(Bx|Hx|$x)&&(e.curRecognizer=r,o=r),i++}},e.get=function(t){if(t instanceof r_)return t;for(var e=this.recognizers,r=0;r<e.length;r++)if(e[r].options.event===t)return e[r];return null},e.add=function(t){if(Xx(t,"add",this))return this;var e=this.get(t.options.event);return e&&this.remove(e),this.recognizers.push(t),t.manager=this,this.touchAction.update(),t},e.remove=function(t){if(Xx(t,"remove",this))return this;var e=this.get(t);if(t){var r=this.recognizers,n=Ex(r,e);-1!==n&&(r.splice(n,1),this.touchAction.update())}return this},e.on=function(t,e){if(void 0===t||void 0===e)return this;var r=this.handlers;return ix(mx(t),(function(t){r[t]=r[t]||[],r[t].push(e)})),this},e.off=function(t,e){if(void 0===t)return this;var r=this.handlers;return ix(mx(t),(function(t){e?r[t]&&r[t].splice(Ex(r[t],e),1):delete r[t]})),this},e.emit=function(t,e){this.options.domEvents&&function(t,e){var r=document.createEvent("Event");r.initEvent(t,!0,!0),r.gesture=e,e.target.dispatchEvent(r)}(t,e);var r=this.handlers[t]&&this.handlers[t].slice();if(r&&r.length){e.type=t,e.preventDefault=function(){e.srcEvent.preventDefault()};for(var n=0;n<r.length;)r[n](e),n++}},e.destroy=function(){this.element&&h_(this,!1),this.handlers={},this.session={},this.input.destroy(),this.element=null},t}(),d_={touchstart:Xb,touchmove:Vb,touchend:Bb,touchcancel:Hb},y_="touchstart",g_="touchstart touchmove touchend touchcancel",m_=function(t){function e(){var r,n=e.prototype;return n.evTarget=y_,n.evWin=g_,(r=t.apply(this,arguments)||this).started=!1,r}return bb(e,t),e.prototype.handler=function(t){var e=d_[t.type];if(e===Xb&&(this.started=!0),this.started){var r=b_.call(this,t,e);e&(Bb|Hb)&&r[0].length-r[1].length==0&&(this.started=!1),this.callback(this.manager,e,{pointers:r[0],changedPointers:r[1],pointerType:Yb,srcEvent:t})}},e}(wx);function b_(t,e){var r=Ax(t.touches),n=Ax(t.changedTouches);return e&(Bb|Hb)&&(r=Px(r.concat(n),"identifier",!0)),[r,n]}function x_(t,e,r){var n="DEPRECATED METHOD: "+e+"\n"+r+" AT \n";return function(){var e=new Error("get-stack-trace"),r=e&&e.stack?e.stack.replace(/^[^\(]+?[\n$]/gm,"").replace(/^\s+at\s+/gm,"").replace(/^Object.<anonymous>\s*\(/gm,"{anonymous}()@"):"Unknown Stack Trace",o=window.console&&(window.console.warn||window.console.log);return o&&o.call(window.console,n,r),t.apply(this,arguments)}}var __=x_((function(t,e,r){for(var n=Object.keys(e),o=0;o<n.length;)(!r||r&&void 0===t[n[o]])&&(t[n[o]]=e[n[o]]),o++;return t}),"extend","Use `assign`."),w_=x_((function(t,e){return __(t,e,!0)}),"merge","Use `assign`.");function E_(t,e,r){var n,o=e.prototype;(n=t.prototype=Object.create(o)).constructor=t,n._super=o,r&&wb(n,r)}function T_(t,e){return function(){return t.apply(e,arguments)}}var O_=function(){var t=function(t,e){return void 0===e&&(e={}),new v_(t,mb({recognizers:p_.concat()},e))};return t.VERSION="2.0.17-rc",t.DIRECTION_ALL=rx,t.DIRECTION_DOWN=Zb,t.DIRECTION_LEFT=Jb,t.DIRECTION_RIGHT=Kb,t.DIRECTION_UP=Qb,t.DIRECTION_HORIZONTAL=tx,t.DIRECTION_VERTICAL=ex,t.DIRECTION_NONE=$b,t.DIRECTION_DOWN=Zb,t.INPUT_START=Xb,t.INPUT_MOVE=Vb,t.INPUT_END=Bb,t.INPUT_CANCEL=Hb,t.STATE_POSSIBLE=Vx,t.STATE_BEGAN=Bx,t.STATE_CHANGED=Hx,t.STATE_ENDED=$x,t.STATE_RECOGNIZED=Jx,t.STATE_CANCELLED=Kx,t.STATE_FAILED=Qx,t.Manager=v_,t.Input=wx,t.TouchAction=sx,t.TouchInput=Lx,t.MouseInput=Fx,t.PointerEventInput=jx,t.TouchMouseInput=Gx,t.SingleTouchInput=m_,t.Recognizer=r_,t.AttrRecognizer=o_,t.Tap=n_,t.Pan=a_,t.Swipe=u_,t.Pinch=s_,t.Rotate=c_,t.Press=f_,t.on=bx,t.off=xx,t.each=ix,t.merge=w_,t.extend=__,t.bindFn=T_,t.assign=wb,t.inherit=E_,t.bindFn=T_,t.prefixed=Ab,t.toArray=Ax,t.inArray=Ex,t.uniqueArray=Px,t.splitStr=mx,t.boolOrFn=ax,t.hasParent=cx,t.addEventListeners=bx,t.removeEventListeners=xx,t.defaults=wb({},l_,{preset:p_}),t}();function S_(t,e){var r=void 0!==Kv&&mh(t)||t["@@iterator"];if(!r){if(hd(t)||(r=function(t,e){var r;if(!t)return;if("string"==typeof t)return k_(t,e);var n=ud(r=Object.prototype.toString.call(t)).call(r,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return hh(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return k_(t,e)}(t))||e&&t&&"number"==typeof t.length){r&&(t=r);var n=0,o=function(){};return{s:o,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var i,a=!0,u=!1;return{s:function(){r=r.call(t)},n:function(){var t=r.next();return a=t.done,t},e:function(t){u=!0,i=t},f:function(){try{a||null==r.return||r.return()}finally{if(u)throw i}}}}function k_(t,e){(null==e||e>t.length)&&(e=t.length);for(var r=0,n=new Array(e);r<e;r++)n[r]=t[r];return n}var j_=Kv("DELETE");function A_(){var t=P_.apply(void 0,arguments);return D_(t),t}function P_(){for(var t=arguments.length,e=new Array(t),r=0;r<t;r++)e[r]=arguments[r];if(e.length<2)return e[0];var n;if(e.length>2)return P_.apply(void 0,id(n=[A_(e[0],e[1])]).call(n,$v(ud(e).call(e,2))));var o,i=e[0],a=e[1],u=S_(ld(a));try{for(u.s();!(o=u.n()).done;){var s=o.value;Object.prototype.propertyIsEnumerable.call(a,s)&&(a[s]===j_?delete i[s]:null===i[s]||null===a[s]||"object"!==qf(i[s])||"object"!==qf(a[s])||hd(i[s])||hd(a[s])?i[s]=I_(a[s]):i[s]=P_(i[s],a[s]))}}catch(t){u.e(t)}finally{u.f()}return i}function I_(t){return hd(t)?np(t).call(t,(function(t){return I_(t)})):"object"===qf(t)&&null!==t?P_({},t):t}function D_(t){for(var e=0,r=bd(t);e<r.length;e++){var n=r[e];t[n]===j_?delete t[n]:"object"===qf(t[n])&&null!==t[n]&&D_(t[n])}}var L_="undefined"!=typeof window?window.Hammer||O_:function(){return function(){var t=function(){};return{on:t,off:t,destroy:t,emit:t,get:function(){return{set:t}}}}()};function C_(t){var e,r=this;this._cleanupQueue=[],this.active=!1,this._dom={container:t,overlay:document.createElement("div")},this._dom.overlay.classList.add("vis-overlay"),this._dom.container.appendChild(this._dom.overlay),this._cleanupQueue.push((function(){r._dom.overlay.parentNode.removeChild(r._dom.overlay)}));var n=L_(this._dom.overlay);n.on("tap",xl(e=this._onTapOverlay).call(e,this)),this._cleanupQueue.push((function(){n.destroy()}));var o=["tap","doubletap","press","pinch","pan","panstart","panmove","panend"];Fd(o).call(o,(function(t){n.on(t,(function(t){t.srcEvent.stopPropagation()}))})),document&&document.body&&(this._onClick=function(e){(function(t,e){for(;t;){if(t===e)return!0;t=t.parentNode}return!1})(e.target,t)||r.deactivate()},document.body.addEventListener("click",this._onClick),this._cleanupQueue.push((function(){document.body.removeEventListener("click",r._onClick)}))),this._escListener=function(t){("key"in t?"Escape"===t.key:27===t.keyCode)&&r.deactivate()}}gb(C_.prototype),C_.current=null,C_.prototype.destroy=function(){var t,e;this.deactivate();var r,n=S_(Jd(t=Oy(e=this._cleanupQueue).call(e,0)).call(t));try{for(n.s();!(r=n.n()).done;){(0,r.value)()}}catch(t){n.e(t)}finally{n.f()}},C_.prototype.activate=function(){C_.current&&C_.current.deactivate(),C_.current=this,this.active=!0,this._dom.overlay.style.display="none",this._dom.container.classList.add("vis-active"),this.emit("change"),this.emit("activate"),document.body.addEventListener("keydown",this._escListener)},C_.prototype.deactivate=function(){this.active=!1,this._dom.overlay.style.display="block",this._dom.container.classList.remove("vis-active"),document.body.removeEventListener("keydown",this._escListener),this.emit("change"),this.emit("deactivate")},C_.prototype._onTapOverlay=function(t){this.activate(),t.srcEvent.stopPropagation()};var R_={},M_={get exports(){return R_},set exports(t){R_=t}},N_=Mn,F_=Lt,z_=TypeError,U_=function(t){if(N_(t))return t;throw z_(F_(t)+" is not a constructor")},q_=Cr,Y_=m,W_=ll,G_=U_,X_=sr,V_=ut,B_=ni,H_=p,$_=ht("Reflect","construct"),J_=Object.prototype,K_=[].push,Q_=H_((function(){function t(){}return!($_((function(){}),[],t)instanceof t)})),Z_=!H_((function(){$_((function(){}))})),tw=Q_||Z_;q_({target:"Reflect",stat:!0,forced:tw,sham:tw},{construct:function(t,e){G_(t),X_(e);var r=arguments.length<3?t:G_(arguments[2]);if(Z_&&!Q_)return $_(t,e,r);if(t==r){switch(e.length){case 0:return new t;case 1:return new t(e[0]);case 2:return new t(e[0],e[1]);case 3:return new t(e[0],e[1],e[2]);case 4:return new t(e[0],e[1],e[2],e[3])}var n=[null];return Y_(K_,n,e),new(Y_(W_,t,n))}var o=r.prototype,i=B_(V_(o)?o:J_),a=Y_(t,i,e);return V_(a)?a:i}});var ew=st.Reflect.construct;!function(t){t.exports=ew}(M_);var rw=n(R_);function nw(t){if(void 0===t)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return t}var ow={},iw={get exports(){return ow},set exports(t){ow=t}},aw={},uw=Sm;!function(t){t.exports=uw}({get exports(){return aw},set exports(t){aw=t}}),function(t){t.exports=aw}(iw);var sw=n(ow),cw={},fw={get exports(){return cw},set exports(t){cw=t}},lw={},pw={get exports(){return lw},set exports(t){lw=t}};Cr({target:"Object",stat:!0},{setPrototypeOf:hc});var hw=st.Object.setPrototypeOf;!function(t){t.exports=hw}(pw),function(t){t.exports=lw}(fw);var vw=n(cw),dw={},yw={get exports(){return dw},set exports(t){dw=t}},gw={},mw=bl;!function(t){t.exports=mw}({get exports(){return gw},set exports(t){gw=t}}),function(t){t.exports=gw}(yw);var bw=n(dw);function xw(t,e){var r;return xw=vw?bw(r=vw).call(r):function(t,e){return t.__proto__=e,t},xw(t,e)}function _w(t,e){if("function"!=typeof e&&null!==e)throw new TypeError("Super expression must either be null or a function");t.prototype=sw(e&&e.prototype,{constructor:{value:t,writable:!0,configurable:!0}}),Yr(t,"prototype",{writable:!1}),e&&xw(t,e)}function ww(t,e){if(e&&("object"===qf(e)||"function"==typeof e))return e;if(void 0!==e)throw new TypeError("Derived constructors may only return object or undefined");return nw(t)}var Ew={},Tw={get exports(){return Ew},set exports(t){Ew=t}},Ow={},Sw=mg;!function(t){t.exports=Sw}({get exports(){return Ow},set exports(t){Ow=t}}),function(t){t.exports=Ow}(Tw);var kw=n(Ew);function jw(t){var e;return jw=vw?bw(e=kw).call(e):function(t){return t.__proto__||kw(t)},jw(t)}var Aw={},Pw={get exports(){return Aw},set exports(t){Aw=t}},Iw={};!function(t){var e=Wr,r=mf;function n(o){return t.exports=n="function"==typeof e&&"symbol"==typeof r?function(t){return typeof t}:function(t){return t&&"function"==typeof e&&t.constructor===e&&t!==e.prototype?"symbol":typeof t},t.exports.__esModule=!0,t.exports.default=t.exports,n(o)}t.exports=n,t.exports.__esModule=!0,t.exports.default=t.exports}({get exports(){return Iw},set exports(t){Iw=t}});var Dw={},Lw={get exports(){return Dw},set exports(t){Dw=t}},Cw={},Rw=Nd;!function(t){t.exports=Rw}({get exports(){return Cw},set exports(t){Cw=t}}),function(t){t.exports=Cw}(Lw);var Mw={},Nw={get exports(){return Mw},set exports(t){Mw=t}},Fw={},zw={get exports(){return Fw},set exports(t){Fw=t}},Uw=oe,qw=Wh,Yw=R,Ww=nr,Gw=ut,Xw=wr,Vw=Error,Bw=E("".replace),Hw=String(Vw("zxcasd").stack),$w=/\n\s*at [^:]*:[^\n]*/,Jw=$w.test(Hw),Kw=V,Qw=!p((function(){var t=Error("a");return!("stack"in t)||(Object.defineProperty(t,"stack",Kw(1,7)),7!==t.stack)})),Zw=wr,tE=function(t,e){if(Jw&&"string"==typeof t&&!Vw.prepareStackTrace)for(;e--;)t=Bw(t,$w,"");return t},eE=Qw,rE=Error.captureStackTrace,nE=rr,oE=z,iE=sr,aE=Lt,uE=Rp,sE=rn,cE=vt,fE=Hp,lE=qp,pE=Ap,hE=TypeError,vE=function(t,e){this.stopped=t,this.result=e},dE=vE.prototype,yE=function(t,e,r){var n,o,i,a,u,s,c,f=r&&r.that,l=!(!r||!r.AS_ENTRIES),p=!(!r||!r.IS_RECORD),h=!(!r||!r.IS_ITERATOR),v=!(!r||!r.INTERRUPTED),d=nE(e,f),y=function(t){return n&&pE(n,"normal",t),new vE(!0,t)},g=function(t){return l?(iE(t),v?d(t[0],t[1],y):d(t[0],t[1])):v?d(t,y):d(t)};if(p)n=t.iterator;else if(h)n=t;else{if(!(o=lE(t)))throw hE(aE(t)+" is not iterable");if(uE(o)){for(i=0,a=sE(t);a>i;i++)if((u=g(t[i]))&&cE(dE,u))return u;return new vE(!1)}n=fE(t,o)}for(s=p?t.next:n.next;!(c=oE(s,n)).done;){try{u=g(c.value)}catch(t){pE(n,"throw",t)}if("object"==typeof u&&u&&cE(dE,u))return u}return new vE(!1)},gE=fo,mE=Cr,bE=vt,xE=Ys,_E=hc,wE=function(t,e,r){for(var n=qw(e),o=Ww.f,i=Yw.f,a=0;a<n.length;a++){var u=n[a];Uw(t,u)||r&&Uw(r,u)||o(t,u,i(e,u))}},EE=ni,TE=wr,OE=V,SE=function(t,e){Gw(e)&&"cause"in e&&Xw(t,"cause",e.cause)},kE=function(t,e,r,n){eE&&(rE?rE(t,e):Zw(t,"stack",tE(r,n)))},jE=yE,AE=function(t,e){return void 0===t?arguments.length<2?"":e:gE(t)},PE=me("toStringTag"),IE=Error,DE=[].push,LE=function(t,e){var r,n=bE(CE,this);_E?r=_E(IE(),n?xE(this):CE):(r=n?this:EE(CE),TE(r,PE,"Error")),void 0!==e&&TE(r,"message",AE(e)),kE(r,LE,r.stack,1),arguments.length>2&&SE(r,arguments[2]);var o=[];return jE(t,DE,{that:o}),TE(r,"errors",o),r};_E?_E(LE,IE):wE(LE,IE,{name:!0});var CE=LE.prototype=EE(IE.prototype,{constructor:OE(1,LE),message:OE(1,""),name:OE(1,"AggregateError")});mE({global:!0,constructor:!0,arity:2},{AggregateError:LE});var RE,ME,NE,FE,zE=ht,UE=Ei,qE=M,YE=me("species"),WE=function(t){var e=zE(t);qE&&e&&!e[YE]&&UE(e,YE,{configurable:!0,get:function(){return this}})},GE=vt,XE=TypeError,VE=function(t,e){if(GE(e,t))return t;throw XE("Incorrect invocation")},BE=sr,HE=U_,$E=Q,JE=me("species"),KE=function(t,e){var r,n=BE(t).constructor;return void 0===n||$E(r=BE(n)[JE])?e:HE(r)},QE=/(?:ipad|iphone|ipod).*applewebkit/i.test(dt),ZE=l,tT=m,eT=rr,rT=C,nT=oe,oT=p,iT=Uo,aT=qu,uT=De,sT=zm,cT=QE,fT=Dl,lT=ZE.setImmediate,pT=ZE.clearImmediate,hT=ZE.process,vT=ZE.Dispatch,dT=ZE.Function,yT=ZE.MessageChannel,gT=ZE.String,mT=0,bT={},xT="onreadystatechange";oT((function(){RE=ZE.location}));var _T=function(t){if(nT(bT,t)){var e=bT[t];delete bT[t],e()}},wT=function(t){return function(){_T(t)}},ET=function(t){_T(t.data)},TT=function(t){ZE.postMessage(gT(t),RE.protocol+"//"+RE.host)};lT&&pT||(lT=function(t){sT(arguments.length,1);var e=rT(t)?t:dT(t),r=aT(arguments,1);return bT[++mT]=function(){tT(e,void 0,r)},ME(mT),mT},pT=function(t){delete bT[t]},fT?ME=function(t){hT.nextTick(wT(t))}:vT&&vT.now?ME=function(t){vT.now(wT(t))}:yT&&!cT?(FE=(NE=new yT).port2,NE.port1.onmessage=ET,ME=eT(FE.postMessage,FE)):ZE.addEventListener&&rT(ZE.postMessage)&&!ZE.importScripts&&RE&&"file:"!==RE.protocol&&!oT(TT)?(ME=TT,ZE.addEventListener("message",ET,!1)):ME=xT in uT("script")?function(t){iT.appendChild(uT("script"))[xT]=function(){iT.removeChild(this),_T(t)}}:function(t){setTimeout(wT(t),0)});var OT={set:lT,clear:pT},ST=function(){this.head=null,this.tail=null};ST.prototype={add:function(t){var e={item:t,next:null},r=this.tail;r?r.next=e:this.head=e,this.tail=e},get:function(){var t=this.head;if(t)return null===(this.head=t.next)&&(this.tail=null),t.item}};var kT,jT,AT,PT,IT,DT=ST,LT=/ipad|iphone|ipod/i.test(dt)&&"undefined"!=typeof Pebble,CT=/web0s(?!.*chrome)/i.test(dt),RT=l,MT=rr,NT=R.f,FT=OT.set,zT=DT,UT=QE,qT=LT,YT=CT,WT=Dl,GT=RT.MutationObserver||RT.WebKitMutationObserver,XT=RT.document,VT=RT.process,BT=RT.Promise,HT=NT(RT,"queueMicrotask"),$T=HT&&HT.value;if(!$T){var JT=new zT,KT=function(){var t,e;for(WT&&(t=VT.domain)&&t.exit();e=JT.get();)try{e()}catch(t){throw JT.head&&kT(),t}t&&t.enter()};UT||WT||YT||!GT||!XT?!qT&&BT&&BT.resolve?((PT=BT.resolve(void 0)).constructor=BT,IT=MT(PT.then,PT),kT=function(){IT(KT)}):WT?kT=function(){VT.nextTick(KT)}:(FT=MT(FT,RT),kT=function(){FT(KT)}):(jT=!0,AT=XT.createTextNode(""),new GT(KT).observe(AT,{characterData:!0}),kT=function(){AT.data=jT=!jT}),$T=function(t){JT.head||kT(),JT.add(t)}}var QT=$T,ZT=function(t){try{return{error:!1,value:t()}}catch(t){return{error:!0,value:t}}},tO=l.Promise,eO="object"==typeof Deno&&Deno&&"object"==typeof Deno.version,rO=!eO&&!Dl&&"object"==typeof window&&"object"==typeof document,nO=l,oO=tO,iO=C,aO=Qe,uO=wn,sO=me,cO=rO,fO=eO,lO=wt,pO=oO&&oO.prototype,hO=sO("species"),vO=!1,dO=iO(nO.PromiseRejectionEvent),yO=aO("Promise",(function(){var t=uO(oO),e=t!==String(oO);if(!e&&66===lO)return!0;if(!pO.catch||!pO.finally)return!0;if(!lO||lO<51||!/native code/.test(t)){var r=new oO((function(t){t(1)})),n=function(t){t((function(){}),(function(){}))};if((r.constructor={})[hO]=n,!(vO=r.then((function(){}))instanceof n))return!0}return!e&&(cO||fO)&&!dO})),gO={CONSTRUCTOR:yO,REJECTION_EVENT:dO,SUBCLASSING:vO},mO={},bO=Nt,xO=TypeError,_O=function(t){var e,r;this.promise=new t((function(t,n){if(void 0!==e||void 0!==r)throw xO("Bad Promise constructor");e=t,r=n})),this.resolve=bO(e),this.reject=bO(r)};mO.f=function(t){return new _O(t)};var wO,EO,TO=Cr,OO=Dl,SO=l,kO=z,jO=_i,AO=Bi,PO=WE,IO=Nt,DO=C,LO=ut,CO=VE,RO=KE,MO=OT.set,NO=QT,FO=function(t,e){try{1==arguments.length?console.error(t):console.error(t,e)}catch(t){}},zO=ZT,UO=DT,qO=ca,YO=tO,WO=mO,GO="Promise",XO=gO.CONSTRUCTOR,VO=gO.REJECTION_EVENT,BO=qO.getterFor(GO),HO=qO.set,$O=YO&&YO.prototype,JO=YO,KO=$O,QO=SO.TypeError,ZO=SO.document,tS=SO.process,eS=WO.f,rS=eS,nS=!!(ZO&&ZO.createEvent&&SO.dispatchEvent),oS="unhandledrejection",iS=function(t){var e;return!(!LO(t)||!DO(e=t.then))&&e},aS=function(t,e){var r,n,o,i=e.value,a=1==e.state,u=a?t.ok:t.fail,s=t.resolve,c=t.reject,f=t.domain;try{u?(a||(2===e.rejection&&lS(e),e.rejection=1),!0===u?r=i:(f&&f.enter(),r=u(i),f&&(f.exit(),o=!0)),r===t.promise?c(QO("Promise-chain cycle")):(n=iS(r))?kO(n,r,s,c):s(r)):c(i)}catch(t){f&&!o&&f.exit(),c(t)}},uS=function(t,e){t.notified||(t.notified=!0,NO((function(){for(var r,n=t.reactions;r=n.get();)aS(r,t);t.notified=!1,e&&!t.rejection&&cS(t)})))},sS=function(t,e,r){var n,o;nS?((n=ZO.createEvent("Event")).promise=e,n.reason=r,n.initEvent(t,!1,!0),SO.dispatchEvent(n)):n={promise:e,reason:r},!VO&&(o=SO["on"+t])?o(n):t===oS&&FO("Unhandled promise rejection",r)},cS=function(t){kO(MO,SO,(function(){var e,r=t.facade,n=t.value;if(fS(t)&&(e=zO((function(){OO?tS.emit("unhandledRejection",n,r):sS(oS,r,n)})),t.rejection=OO||fS(t)?2:1,e.error))throw e.value}))},fS=function(t){return 1!==t.rejection&&!t.parent},lS=function(t){kO(MO,SO,(function(){var e=t.facade;OO?tS.emit("rejectionHandled",e):sS("rejectionhandled",e,t.value)}))},pS=function(t,e,r){return function(n){t(e,n,r)}},hS=function(t,e,r){t.done||(t.done=!0,r&&(t=r),t.value=e,t.state=2,uS(t,!0))},vS=function(t,e,r){if(!t.done){t.done=!0,r&&(t=r);try{if(t.facade===e)throw QO("Promise can't be resolved itself");var n=iS(e);n?NO((function(){var r={done:!1};try{kO(n,e,pS(vS,r,t),pS(hS,r,t))}catch(e){hS(r,e,t)}})):(t.value=e,t.state=1,uS(t,!1))}catch(e){hS({done:!1},e,t)}}};XO&&(KO=(JO=function(t){CO(this,KO),IO(t),kO(wO,this);var e=BO(this);try{t(pS(vS,e),pS(hS,e))}catch(t){hS(e,t)}}).prototype,(wO=function(t){HO(this,{type:GO,done:!1,notified:!1,parent:!1,reactions:new UO,rejection:!1,state:0,value:void 0})}).prototype=jO(KO,"then",(function(t,e){var r=BO(this),n=eS(RO(this,JO));return r.parent=!0,n.ok=!DO(t)||t,n.fail=DO(e)&&e,n.domain=OO?tS.domain:void 0,0==r.state?r.reactions.add(n):NO((function(){aS(n,r)})),n.promise})),EO=function(){var t=new wO,e=BO(t);this.promise=t,this.resolve=pS(vS,e),this.reject=pS(hS,e)},WO.f=eS=function(t){return t===JO||undefined===t?new EO(t):rS(t)}),TO({global:!0,constructor:!0,wrap:!0,forced:XO},{Promise:JO}),AO(JO,GO,!1,!0),PO(GO);var dS=tO,yS=gO.CONSTRUCTOR||!fh((function(t){dS.all(t).then(void 0,(function(){}))})),gS=z,mS=Nt,bS=mO,xS=ZT,_S=yE;Cr({target:"Promise",stat:!0,forced:yS},{all:function(t){var e=this,r=bS.f(e),n=r.resolve,o=r.reject,i=xS((function(){var r=mS(e.resolve),i=[],a=0,u=1;_S(t,(function(t){var s=a++,c=!1;u++,gS(r,e,t).then((function(t){c||(c=!0,i[s]=t,--u||n(i))}),o)})),--u||n(i)}));return i.error&&o(i.value),r.promise}});var wS=Cr,ES=gO.CONSTRUCTOR;tO&&tO.prototype,wS({target:"Promise",proto:!0,forced:ES,real:!0},{catch:function(t){return this.then(void 0,t)}});var TS=z,OS=Nt,SS=mO,kS=ZT,jS=yE;Cr({target:"Promise",stat:!0,forced:yS},{race:function(t){var e=this,r=SS.f(e),n=r.reject,o=kS((function(){var o=OS(e.resolve);jS(t,(function(t){TS(o,e,t).then(r.resolve,n)}))}));return o.error&&n(o.value),r.promise}});var AS=z,PS=mO;Cr({target:"Promise",stat:!0,forced:gO.CONSTRUCTOR},{reject:function(t){var e=PS.f(this);return AS(e.reject,void 0,t),e.promise}});var IS=sr,DS=ut,LS=mO,CS=function(t,e){if(IS(t),DS(e)&&e.constructor===t)return e;var r=LS.f(t);return(0,r.resolve)(e),r.promise},RS=Cr,MS=tO,NS=gO.CONSTRUCTOR,FS=CS,zS=ht("Promise"),US=!NS;RS({target:"Promise",stat:!0,forced:true},{resolve:function(t){return FS(US&&this===zS?MS:this,t)}});var qS=z,YS=Nt,WS=mO,GS=ZT,XS=yE;Cr({target:"Promise",stat:!0,forced:yS},{allSettled:function(t){var e=this,r=WS.f(e),n=r.resolve,o=r.reject,i=GS((function(){var r=YS(e.resolve),o=[],i=0,a=1;XS(t,(function(t){var u=i++,s=!1;a++,qS(r,e,t).then((function(t){s||(s=!0,o[u]={status:"fulfilled",value:t},--a||n(o))}),(function(t){s||(s=!0,o[u]={status:"rejected",reason:t},--a||n(o))}))})),--a||n(o)}));return i.error&&o(i.value),r.promise}});var VS=z,BS=Nt,HS=ht,$S=mO,JS=ZT,KS=yE,QS="No one promise resolved";Cr({target:"Promise",stat:!0,forced:yS},{any:function(t){var e=this,r=HS("AggregateError"),n=$S.f(e),o=n.resolve,i=n.reject,a=JS((function(){var n=BS(e.resolve),a=[],u=0,s=1,c=!1;KS(t,(function(t){var f=u++,l=!1;s++,VS(n,e,t).then((function(t){l||c||(c=!0,o(t))}),(function(t){l||c||(l=!0,a[f]=t,--s||i(new r(a,QS)))}))})),--s||i(new r(a,QS))}));return a.error&&i(a.value),n.promise}});var ZS=Cr,tk=tO,ek=p,rk=ht,nk=C,ok=KE,ik=CS,ak=tk&&tk.prototype;ZS({target:"Promise",proto:!0,real:!0,forced:!!tk&&ek((function(){ak.finally.call({then:function(){}},(function(){}))}))},{finally:function(t){var e=ok(this,rk("Promise")),r=nk(t);return this.then(r?function(r){return ik(e,t()).then((function(){return r}))}:t,r?function(r){return ik(e,t()).then((function(){throw r}))}:t)}});var uk=st.Promise,sk=mO,ck=ZT;Cr({target:"Promise",stat:!0,forced:!0},{try:function(t){var e=sk.f(this),r=ck(t);return(r.error?e.reject:e.resolve)(r.value),e.promise}});var fk=uk;!function(t){t.exports=fk}(zw),function(t){t.exports=Fw}(Nw);var lk={},pk={get exports(){return lk},set exports(t){lk=t}},hk={},vk=$d;!function(t){t.exports=vk}({get exports(){return hk},set exports(t){hk=t}}),function(t){t.exports=hk}(pk),function(t){var e=Iw.default,r=o,n=Wr,i=ow,a=Ew,u=Dw,s=cw,c=Mw,f=lk,l=yv;function p(){t.exports=p=function(){return o},t.exports.__esModule=!0,t.exports.default=t.exports;var o={},h=Object.prototype,v=h.hasOwnProperty,d=r||function(t,e,r){t[e]=r.value},y="function"==typeof n?n:{},g=y.iterator||"@@iterator",m=y.asyncIterator||"@@asyncIterator",b=y.toStringTag||"@@toStringTag";function x(t,e,n){return r(t,e,{value:n,enumerable:!0,configurable:!0,writable:!0}),t[e]}try{x({},"")}catch(t){x=function(t,e,r){return t[e]=r}}function _(t,e,r,n){var o=e&&e.prototype instanceof T?e:T,a=i(o.prototype),u=new M(n||[]);return d(a,"_invoke",{value:D(t,r,u)}),a}function w(t,e,r){try{return{type:"normal",arg:t.call(e,r)}}catch(t){return{type:"throw",arg:t}}}o.wrap=_;var E={};function T(){}function O(){}function S(){}var k={};x(k,g,(function(){return this}));var j=a&&a(a(N([])));j&&j!==h&&v.call(j,g)&&(k=j);var A=S.prototype=T.prototype=i(k);function P(t){var e;u(e=["next","throw","return"]).call(e,(function(e){x(t,e,(function(t){return this._invoke(e,t)}))}))}function I(t,r){function n(o,i,a,u){var s=w(t[o],t,i);if("throw"!==s.type){var c=s.arg,f=c.value;return f&&"object"==e(f)&&v.call(f,"__await")?r.resolve(f.__await).then((function(t){n("next",t,a,u)}),(function(t){n("throw",t,a,u)})):r.resolve(f).then((function(t){c.value=t,a(c)}),(function(t){return n("throw",t,a,u)}))}u(s.arg)}var o;d(this,"_invoke",{value:function(t,e){function i(){return new r((function(r,o){n(t,e,r,o)}))}return o=o?o.then(i,i):i()}})}function D(t,e,r){var n="suspendedStart";return function(o,i){if("executing"===n)throw new Error("Generator is already running");if("completed"===n){if("throw"===o)throw i;return F()}for(r.method=o,r.arg=i;;){var a=r.delegate;if(a){var u=L(a,r);if(u){if(u===E)continue;return u}}if("next"===r.method)r.sent=r._sent=r.arg;else if("throw"===r.method){if("suspendedStart"===n)throw n="completed",r.arg;r.dispatchException(r.arg)}else"return"===r.method&&r.abrupt("return",r.arg);n="executing";var s=w(t,e,r);if("normal"===s.type){if(n=r.done?"completed":"suspendedYield",s.arg===E)continue;return{value:s.arg,done:r.done}}"throw"===s.type&&(n="completed",r.method="throw",r.arg=s.arg)}}}function L(t,e){var r=e.method,n=t.iterator[r];if(void 0===n)return e.delegate=null,"throw"===r&&t.iterator.return&&(e.method="return",e.arg=void 0,L(t,e),"throw"===e.method)||"return"!==r&&(e.method="throw",e.arg=new TypeError("The iterator does not provide a '"+r+"' method")),E;var o=w(n,t.iterator,e.arg);if("throw"===o.type)return e.method="throw",e.arg=o.arg,e.delegate=null,E;var i=o.arg;return i?i.done?(e[t.resultName]=i.value,e.next=t.nextLoc,"return"!==e.method&&(e.method="next",e.arg=void 0),e.delegate=null,E):i:(e.method="throw",e.arg=new TypeError("iterator result is not an object"),e.delegate=null,E)}function C(t){var e={tryLoc:t[0]};1 in t&&(e.catchLoc=t[1]),2 in t&&(e.finallyLoc=t[2],e.afterLoc=t[3]),this.tryEntries.push(e)}function R(t){var e=t.completion||{};e.type="normal",delete e.arg,t.completion=e}function M(t){this.tryEntries=[{tryLoc:"root"}],u(t).call(t,C,this),this.reset(!0)}function N(t){if(t){var e=t[g];if(e)return e.call(t);if("function"==typeof t.next)return t;if(!isNaN(t.length)){var r=-1,n=function e(){for(;++r<t.length;)if(v.call(t,r))return e.value=t[r],e.done=!1,e;return e.value=void 0,e.done=!0,e};return n.next=n}}return{next:F}}function F(){return{value:void 0,done:!0}}return O.prototype=S,d(A,"constructor",{value:S,configurable:!0}),d(S,"constructor",{value:O,configurable:!0}),O.displayName=x(S,b,"GeneratorFunction"),o.isGeneratorFunction=function(t){var e="function"==typeof t&&t.constructor;return!!e&&(e===O||"GeneratorFunction"===(e.displayName||e.name))},o.mark=function(t){return s?s(t,S):(t.__proto__=S,x(t,b,"GeneratorFunction")),t.prototype=i(A),t},o.awrap=function(t){return{__await:t}},P(I.prototype),x(I.prototype,m,(function(){return this})),o.AsyncIterator=I,o.async=function(t,e,r,n,i){void 0===i&&(i=c);var a=new I(_(t,e,r,n),i);return o.isGeneratorFunction(e)?a:a.next().then((function(t){return t.done?t.value:a.next()}))},P(A),x(A,b,"Generator"),x(A,g,(function(){return this})),x(A,"toString",(function(){return"[object Generator]"})),o.keys=function(t){var e=Object(t),r=[];for(var n in e)r.push(n);return f(r).call(r),function t(){for(;r.length;){var n=r.pop();if(n in e)return t.value=n,t.done=!1,t}return t.done=!0,t}},o.values=N,M.prototype={constructor:M,reset:function(t){var e;if(this.prev=0,this.next=0,this.sent=this._sent=void 0,this.done=!1,this.delegate=null,this.method="next",this.arg=void 0,u(e=this.tryEntries).call(e,R),!t)for(var r in this)"t"===r.charAt(0)&&v.call(this,r)&&!isNaN(+l(r).call(r,1))&&(this[r]=void 0)},stop:function(){this.done=!0;var t=this.tryEntries[0].completion;if("throw"===t.type)throw t.arg;return this.rval},dispatchException:function(t){if(this.done)throw t;var e=this;function r(r,n){return i.type="throw",i.arg=t,e.next=r,n&&(e.method="next",e.arg=void 0),!!n}for(var n=this.tryEntries.length-1;n>=0;--n){var o=this.tryEntries[n],i=o.completion;if("root"===o.tryLoc)return r("end");if(o.tryLoc<=this.prev){var a=v.call(o,"catchLoc"),u=v.call(o,"finallyLoc");if(a&&u){if(this.prev<o.catchLoc)return r(o.catchLoc,!0);if(this.prev<o.finallyLoc)return r(o.finallyLoc)}else if(a){if(this.prev<o.catchLoc)return r(o.catchLoc,!0)}else{if(!u)throw new Error("try statement without catch or finally");if(this.prev<o.finallyLoc)return r(o.finallyLoc)}}}},abrupt:function(t,e){for(var r=this.tryEntries.length-1;r>=0;--r){var n=this.tryEntries[r];if(n.tryLoc<=this.prev&&v.call(n,"finallyLoc")&&this.prev<n.finallyLoc){var o=n;break}}o&&("break"===t||"continue"===t)&&o.tryLoc<=e&&e<=o.finallyLoc&&(o=null);var i=o?o.completion:{};return i.type=t,i.arg=e,o?(this.method="next",this.next=o.finallyLoc,E):this.complete(i)},complete:function(t,e){if("throw"===t.type)throw t.arg;return"break"===t.type||"continue"===t.type?this.next=t.arg:"return"===t.type?(this.rval=this.arg=t.arg,this.method="return",this.next="end"):"normal"===t.type&&e&&(this.next=e),E},finish:function(t){for(var e=this.tryEntries.length-1;e>=0;--e){var r=this.tryEntries[e];if(r.finallyLoc===t)return this.complete(r.completion,r.afterLoc),R(r),E}},catch:function(t){for(var e=this.tryEntries.length-1;e>=0;--e){var r=this.tryEntries[e];if(r.tryLoc===t){var n=r.completion;if("throw"===n.type){var o=n.arg;R(r)}return o}}throw new Error("illegal catch attempt")},delegateYield:function(t,e,r){return this.delegate={iterator:N(t),resultName:e,nextLoc:r},"next"===this.method&&(this.arg=void 0),E}},o}t.exports=p,t.exports.__esModule=!0,t.exports.default=t.exports}(Pw);var dk=Aw(),yk=dk;try{regeneratorRuntime=dk}catch(t){"object"==typeof globalThis?globalThis.regeneratorRuntime=dk:Function("r","regeneratorRuntime = r")(dk)}var gk={},mk={get exports(){return gk},set exports(t){gk=t}},bk={},xk={get exports(){return bk},set exports(t){bk=t}},_k=p((function(){if("function"==typeof ArrayBuffer){var t=new ArrayBuffer(8);Object.isExtensible(t)&&Object.defineProperty(t,"a",{value:8})}})),wk=p,Ek=ut,Tk=k,Ok=_k,Sk=Object.isExtensible,kk=wk((function(){Sk(1)}))||Ok?function(t){return!!Ek(t)&&((!Ok||"ArrayBuffer"!=Tk(t))&&(!Sk||Sk(t)))}:Sk,jk=!p((function(){return Object.isExtensible(Object.preventExtensions({}))})),Ak=Cr,Pk=E,Ik=wo,Dk=ut,Lk=oe,Ck=nr.f,Rk=oi,Mk=ui,Nk=kk,Fk=jk,zk=!1,Uk=ce("meta"),qk=0,Yk=function(t){Ck(t,Uk,{value:{objectID:"O"+qk++,weakData:{}}})},Wk=xk.exports={enable:function(){Wk.enable=function(){},zk=!0;var t=Rk.f,e=Pk([].splice),r={};r[Uk]=1,t(r).length&&(Rk.f=function(r){for(var n=t(r),o=0,i=n.length;o<i;o++)if(n[o]===Uk){e(n,o,1);break}return n},Ak({target:"Object",stat:!0,forced:!0},{getOwnPropertyNames:Mk.f}))},fastKey:function(t,e){if(!Dk(t))return"symbol"==typeof t?t:("string"==typeof t?"S":"P")+t;if(!Lk(t,Uk)){if(!Nk(t))return"F";if(!e)return"E";Yk(t)}return t[Uk].objectID},getWeakData:function(t,e){if(!Lk(t,Uk)){if(!Nk(t))return!0;if(!e)return!1;Yk(t)}return t[Uk].weakData},onFreeze:function(t){return Fk&&zk&&Nk(t)&&!Lk(t,Uk)&&Yk(t),t}};Ik[Uk]=!0;var Gk=Cr,Xk=l,Vk=bk,Bk=p,Hk=wr,$k=yE,Jk=VE,Kk=C,Qk=ut,Zk=Bi,tj=nr.f,ej=ga.forEach,rj=M,nj=ca.set,oj=ca.getterFor,ij=function(t,e,r){var n,o=-1!==t.indexOf("Map"),i=-1!==t.indexOf("Weak"),a=o?"set":"add",u=Xk[t],s=u&&u.prototype,c={};if(rj&&Kk(u)&&(i||s.forEach&&!Bk((function(){(new u).entries().next()})))){var f=(n=e((function(e,r){nj(Jk(e,f),{type:t,collection:new u}),null!=r&&$k(r,e[a],{that:e,AS_ENTRIES:o})}))).prototype,l=oj(t);ej(["add","clear","delete","forEach","get","has","set","keys","values","entries"],(function(t){var e="add"==t||"set"==t;!(t in s)||i&&"clear"==t||Hk(f,t,(function(r,n){var o=l(this).collection;if(!e&&i&&!Qk(r))return"get"==t&&void 0;var a=o[t](0===r?0:r,n);return e?this:a}))})),i||tj(f,"size",{configurable:!0,get:function(){return l(this).collection.size}})}else n=r.getConstructor(e,t,o,a),Vk.enable();return Zk(n,t,!1,!0),c[t]=n,Gk({global:!0,forced:!0},c),i||r.setStrong(n,t,o),n},aj=_i,uj=ni,sj=Ei,cj=function(t,e,r){for(var n in e)r&&r.unsafe&&t[n]?t[n]=e[n]:aj(t,n,e[n],r);return t},fj=rr,lj=VE,pj=Q,hj=yE,vj=jc,dj=Ac,yj=WE,gj=M,mj=bk.fastKey,bj=ca.set,xj=ca.getterFor,_j={getConstructor:function(t,e,r,n){var o=t((function(t,o){lj(t,i),bj(t,{type:e,index:uj(null),first:void 0,last:void 0,size:0}),gj||(t.size=0),pj(o)||hj(o,t[n],{that:t,AS_ENTRIES:r})})),i=o.prototype,a=xj(e),u=function(t,e,r){var n,o,i=a(t),u=s(t,e);return u?u.value=r:(i.last=u={index:o=mj(e,!0),key:e,value:r,previous:n=i.last,next:void 0,removed:!1},i.first||(i.first=u),n&&(n.next=u),gj?i.size++:t.size++,"F"!==o&&(i.index[o]=u)),t},s=function(t,e){var r,n=a(t),o=mj(e);if("F"!==o)return n.index[o];for(r=n.first;r;r=r.next)if(r.key==e)return r};return cj(i,{clear:function(){for(var t=a(this),e=t.index,r=t.first;r;)r.removed=!0,r.previous&&(r.previous=r.previous.next=void 0),delete e[r.index],r=r.next;t.first=t.last=void 0,gj?t.size=0:this.size=0},delete:function(t){var e=this,r=a(e),n=s(e,t);if(n){var o=n.next,i=n.previous;delete r.index[n.index],n.removed=!0,i&&(i.next=o),o&&(o.previous=i),r.first==n&&(r.first=o),r.last==n&&(r.last=i),gj?r.size--:e.size--}return!!n},forEach:function(t){for(var e,r=a(this),n=fj(t,arguments.length>1?arguments[1]:void 0);e=e?e.next:r.first;)for(n(e.value,e.key,this);e&&e.removed;)e=e.previous},has:function(t){return!!s(this,t)}}),cj(i,r?{get:function(t){var e=s(this,t);return e&&e.value},set:function(t,e){return u(this,0===t?0:t,e)}}:{add:function(t){return u(this,t=0===t?0:t,t)}}),gj&&sj(i,"size",{configurable:!0,get:function(){return a(this).size}}),o},setStrong:function(t,e,r){var n=e+" Iterator",o=xj(e),i=xj(n);vj(t,e,(function(t,e){bj(this,{type:n,target:t,state:o(t),kind:e,last:void 0})}),(function(){for(var t=i(this),e=t.kind,r=t.last;r&&r.removed;)r=r.previous;return t.target&&(t.last=r=r?r.next:t.state.first)?dj("keys"==e?r.key:"values"==e?r.value:[r.key,r.value],!1):(t.target=void 0,dj(void 0,!0))}),r?"entries":"values",!r,!0),yj(e)}};ij("Map",(function(t){return function(){return t(this,arguments.length?arguments[0]:void 0)}}),_j);var wj=st.Map;!function(t){t.exports=wj}(mk);var Ej=n(gk),Tj={},Oj={get exports(){return Tj},set exports(t){Tj=t}},Sj=ga.some;Cr({target:"Array",proto:!0,forced:!Il("some")},{some:function(t){return Sj(this,t,arguments.length>1?arguments[1]:void 0)}});var kj=vl("Array").some,jj=vt,Aj=kj,Pj=Array.prototype,Ij=function(t){var e=t.some;return t===Pj||jj(Pj,t)&&e===Pj.some?Aj:e};!function(t){t.exports=Ij}(Oj);var Dj=n(Tj),Lj={},Cj={get exports(){return Lj},set exports(t){Lj=t}},Rj=vl("Array").keys,Mj=mn,Nj=oe,Fj=vt,zj=Rj,Uj=Array.prototype,qj={DOMTokenList:!0,NodeList:!0},Yj=function(t){var e=t.keys;return t===Uj||Fj(Uj,t)&&e===Uj.keys||Nj(qj,Mj(t))?zj:e};!function(t){t.exports=Yj}(Cj);var Wj=n(Lj),Gj={},Xj={get exports(){return Gj},set exports(t){Gj=t}},Vj=hi,Bj=Math.floor,Hj=function(t,e){var r=t.length,n=Bj(r/2);return r<8?$j(t,e):Jj(t,Hj(Vj(t,0,n),e),Hj(Vj(t,n),e),e)},$j=function(t,e){for(var r,n,o=t.length,i=1;i<o;){for(n=i,r=t[i];n&&e(t[n-1],r)>0;)t[n]=t[--n];n!==i++&&(t[n]=r)}return t},Jj=function(t,e,r,n){for(var o=e.length,i=r.length,a=0,u=0;a<o||u<i;)t[a+u]=a<o&&u<i?n(e[a],r[u])<=0?e[a++]:r[u++]:a<o?e[a++]:r[u++];return t},Kj=Hj,Qj=dt.match(/firefox\/(\d+)/i),Zj=!!Qj&&+Qj[1],tA=/MSIE|Trident/.test(dt),eA=dt.match(/AppleWebKit\/(\d+)\./),rA=!!eA&&+eA[1],nA=Cr,oA=E,iA=Nt,aA=ee,uA=rn,sA=ay,cA=fo,fA=p,lA=Kj,pA=Il,hA=Zj,vA=tA,dA=wt,yA=rA,gA=[],mA=oA(gA.sort),bA=oA(gA.push),xA=fA((function(){gA.sort(void 0)})),_A=fA((function(){gA.sort(null)})),wA=pA("sort"),EA=!fA((function(){if(dA)return dA<70;if(!(hA&&hA>3)){if(vA)return!0;if(yA)return yA<603;var t,e,r,n,o="";for(t=65;t<76;t++){switch(e=String.fromCharCode(t),t){case 66:case 69:case 70:case 72:r=3;break;case 68:case 71:r=4;break;default:r=2}for(n=0;n<47;n++)gA.push({k:e+n,v:r})}for(gA.sort((function(t,e){return e.v-t.v})),n=0;n<gA.length;n++)e=gA[n].k.charAt(0),o.charAt(o.length-1)!==e&&(o+=e);return"DGBEFHACIJK"!==o}}));nA({target:"Array",proto:!0,forced:xA||!_A||!wA||!EA},{sort:function(t){void 0!==t&&iA(t);var e=aA(this);if(EA)return void 0===t?mA(e):mA(e,t);var r,n,o=[],i=uA(e);for(n=0;n<i;n++)n in e&&bA(o,e[n]);for(lA(o,function(t){return function(e,r){return void 0===r?-1:void 0===e?1:void 0!==t?+t(e,r)||0:cA(e)>cA(r)?1:-1}}(t)),r=uA(o),n=0;n<r;)e[n]=o[n++];for(;n<i;)sA(e,n++);return e}});var TA=vl("Array").sort,OA=vt,SA=TA,kA=Array.prototype,jA=function(t){var e=t.sort;return t===kA||OA(kA,t)&&e===kA.sort?SA:e};!function(t){t.exports=jA}(Xj);var AA=n(Gj),PA={},IA={get exports(){return PA},set exports(t){PA=t}},DA=vl("Array").values,LA=mn,CA=oe,RA=vt,MA=DA,NA=Array.prototype,FA={DOMTokenList:!0,NodeList:!0},zA=function(t){var e=t.values;return t===NA||RA(NA,t)&&e===NA.values||CA(FA,LA(t))?MA:e};!function(t){t.exports=zA}(IA);var UA=n(PA),qA={};!function(t){t.exports=Ff}({get exports(){return qA},set exports(t){qA=t}});var YA=n(qA),WA={},GA={get exports(){return WA},set exports(t){WA=t}},XA=vl("Array").entries,VA=mn,BA=oe,HA=vt,$A=XA,JA=Array.prototype,KA={DOMTokenList:!0,NodeList:!0},QA=function(t){var e=t.entries;return t===JA||HA(JA,t)&&e===JA.entries||BA(KA,VA(t))?$A:e};!function(t){t.exports=QA}(GA);var ZA=n(WA);let tP;const eP=new Uint8Array(16);function rP(){if(!tP&&(tP="undefined"!=typeof crypto&&crypto.getRandomValues&&crypto.getRandomValues.bind(crypto),!tP))throw new Error("crypto.getRandomValues() not supported. See https://github.com/uuidjs/uuid#getrandomvalues-not-supported");return tP(eP)}const nP=[];for(let t=0;t<256;++t)nP.push((t+256).toString(16).slice(1));var oP={randomUUID:"undefined"!=typeof crypto&&crypto.randomUUID&&crypto.randomUUID.bind(crypto)};function iP(t,e,r){if(oP.randomUUID&&!e&&!t)return oP.randomUUID();const n=(t=t||{}).random||(t.rng||rP)();if(n[6]=15&n[6]|64,n[8]=63&n[8]|128,e){r=r||0;for(let t=0;t<16;++t)e[r+t]=n[t];return e}return function(t,e=0){return(nP[t[e+0]]+nP[t[e+1]]+nP[t[e+2]]+nP[t[e+3]]+"-"+nP[t[e+4]]+nP[t[e+5]]+"-"+nP[t[e+6]]+nP[t[e+7]]+"-"+nP[t[e+8]]+nP[t[e+9]]+"-"+nP[t[e+10]]+nP[t[e+11]]+nP[t[e+12]]+nP[t[e+13]]+nP[t[e+14]]+nP[t[e+15]]).toLowerCase()}(n)}function aP(t){return"string"==typeof t||"number"==typeof t}var uP=function(){function t(r){e(this,t),Kf(this,"delay",void 0),Kf(this,"max",void 0),Kf(this,"_queue",[]),Kf(this,"_timeout",null),Kf(this,"_extended",null),this.delay=null,this.max=1/0,this.setOptions(r)}return Jf(t,[{key:"setOptions",value:function(t){t&&void 0!==t.delay&&(this.delay=t.delay),t&&void 0!==t.max&&(this.max=t.max),this._flushIfNeeded()}},{key:"destroy",value:function(){if(this.flush(),this._extended){for(var t=this._extended.object,e=this._extended.methods,r=0;r<e.length;r++){var n=e[r];n.original?t[n.name]=n.original:delete t[n.name]}this._extended=null}}},{key:"replace",value:function(t,e){var r=this,n=t[e];if(!n)throw new Error("Method "+e+" undefined");t[e]=function(){for(var t=arguments.length,e=new Array(t),o=0;o<t;o++)e[o]=arguments[o];r.queue({args:e,fn:n,context:this})}}},{key:"queue",value:function(t){"function"==typeof t?this._queue.push({fn:t}):this._queue.push(t),this._flushIfNeeded()}},{key:"_flushIfNeeded",value:function(){var t=this;this._queue.length>this.max&&this.flush(),null!=this._timeout&&(clearTimeout(this._timeout),this._timeout=null),this.queue.length>0&&"number"==typeof this.delay&&(this._timeout=nb((function(){t.flush()}),this.delay))}},{key:"flush",value:function(){var t,e;Fd(t=Oy(e=this._queue).call(e,0)).call(t,(function(t){t.fn.apply(t.context||t.fn,t.args||[])}))}}],[{key:"extend",value:function(e,r){var n=new t(r);if(void 0!==e.flush)throw new Error("Target object already has a property flush");e.flush=function(){n.flush()};var o=[{name:"flush",original:void 0}];if(r&&r.replace)for(var i=0;i<r.replace.length;i++){var a=r.replace[i];o.push({name:a,original:e[a]}),n.replace(e,a)}return n._extended={object:e,methods:o},n}}]),t}(),sP=function(){function t(){e(this,t),Kf(this,"_subscribers",{"*":[],add:[],remove:[],update:[]}),Kf(this,"subscribe",t.prototype.on),Kf(this,"unsubscribe",t.prototype.off)}return Jf(t,[{key:"_trigger",value:function(t,e,r){var n,o;if("*"===t)throw new Error("Cannot trigger event *");Fd(n=id(o=[]).call(o,$v(this._subscribers[t]),$v(this._subscribers["*"]))).call(n,(function(n){n(t,e,null!=r?r:null)}))}},{key:"on",value:function(t,e){"function"==typeof e&&this._subscribers[t].push(e)}},{key:"off",value:function(t,e){var r;this._subscribers[t]=Hl(r=this._subscribers[t]).call(r,(function(t){return t!==e}))}}]),t}(),cP={},fP={get exports(){return cP},set exports(t){cP=t}};ij("Set",(function(t){return function(){return t(this,arguments.length?arguments[0]:void 0)}}),_j);var lP=st.Set;!function(t){t.exports=lP}(fP);var pP=n(cP),hP={},vP={get exports(){return hP},set exports(t){hP=t}},dP={},yP=Hp;!function(t){t.exports=yP}({get exports(){return dP},set exports(t){dP=t}}),function(t){t.exports=dP}(vP);var gP,mP=n(hP);function bP(t,e){var r=void 0!==Kv&&mh(t)||t["@@iterator"];if(!r){if(hd(t)||(r=function(t,e){var r;if(!t)return;if("string"==typeof t)return xP(t,e);var n=ud(r=Object.prototype.toString.call(t)).call(r,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return hh(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return xP(t,e)}(t))||e&&t&&"number"==typeof t.length){r&&(t=r);var n=0,o=function(){};return{s:o,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var i,a=!0,u=!1;return{s:function(){r=r.call(t)},n:function(){var t=r.next();return a=t.done,t},e:function(t){u=!0,i=t},f:function(){try{a||null==r.return||r.return()}finally{if(u)throw i}}}}function xP(t,e){(null==e||e>t.length)&&(e=t.length);for(var r=0,n=new Array(e);r<e;r++)n[r]=t[r];return n}gP=YA;var _P=function(){function t(r){e(this,t),Kf(this,"_pairs",void 0),this._pairs=r}return Jf(t,[{key:gP,value:yk.mark((function t(){var e,r,n,o,i;return yk.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=bP(this._pairs),t.prev=1,e.s();case 3:if((r=e.n()).done){t.next=9;break}return n=Hv(r.value,2),o=n[0],i=n[1],t.next=7,[o,i];case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"entries",value:yk.mark((function t(){var e,r,n,o,i;return yk.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=bP(this._pairs),t.prev=1,e.s();case 3:if((r=e.n()).done){t.next=9;break}return n=Hv(r.value,2),o=n[0],i=n[1],t.next=7,[o,i];case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"keys",value:yk.mark((function t(){var e,r,n,o;return yk.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=bP(this._pairs),t.prev=1,e.s();case 3:if((r=e.n()).done){t.next=9;break}return n=Hv(r.value,1),o=n[0],t.next=7,o;case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"values",value:yk.mark((function t(){var e,r,n,o;return yk.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=bP(this._pairs),t.prev=1,e.s();case 3:if((r=e.n()).done){t.next=9;break}return n=Hv(r.value,2),o=n[1],t.next=7,o;case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"toIdArray",value:function(){var t;return np(t=$v(this._pairs)).call(t,(function(t){return t[0]}))}},{key:"toItemArray",value:function(){var t;return np(t=$v(this._pairs)).call(t,(function(t){return t[1]}))}},{key:"toEntryArray",value:function(){return $v(this._pairs)}},{key:"toObjectMap",value:function(){var t,e=km(null),r=bP(this._pairs);try{for(r.s();!(t=r.n()).done;){var n=Hv(t.value,2),o=n[0],i=n[1];e[o]=i}}catch(t){r.e(t)}finally{r.f()}return e}},{key:"toMap",value:function(){return new Ej(this._pairs)}},{key:"toIdSet",value:function(){return new pP(this.toIdArray())}},{key:"toItemSet",value:function(){return new pP(this.toItemArray())}},{key:"cache",value:function(){return new t($v(this._pairs))}},{key:"distinct",value:function(t){var e,r=new pP,n=bP(this._pairs);try{for(n.s();!(e=n.n()).done;){var o=Hv(e.value,2),i=o[0],a=o[1];r.add(t(a,i))}}catch(t){n.e(t)}finally{n.f()}return r}},{key:"filter",value:function(e){var r=this._pairs;return new t(Kf({},YA,yk.mark((function t(){var n,o,i,a,u;return yk.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:n=bP(r),t.prev=1,n.s();case 3:if((o=n.n()).done){t.next=10;break}if(i=Hv(o.value,2),a=i[0],u=i[1],!e(u,a)){t.next=8;break}return t.next=8,[a,u];case 8:t.next=3;break;case 10:t.next=15;break;case 12:t.prev=12,t.t0=t.catch(1),n.e(t.t0);case 15:return t.prev=15,n.f(),t.finish(15);case 18:case"end":return t.stop()}}),t,null,[[1,12,15,18]])}))))}},{key:"forEach",value:function(t){var e,r=bP(this._pairs);try{for(r.s();!(e=r.n()).done;){var n=Hv(e.value,2),o=n[0];t(n[1],o)}}catch(t){r.e(t)}finally{r.f()}}},{key:"map",value:function(e){var r=this._pairs;return new t(Kf({},YA,yk.mark((function t(){var n,o,i,a,u;return yk.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:n=bP(r),t.prev=1,n.s();case 3:if((o=n.n()).done){t.next=9;break}return i=Hv(o.value,2),a=i[0],u=i[1],t.next=7,[a,e(u,a)];case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),n.e(t.t0);case 14:return t.prev=14,n.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,null,[[1,11,14,17]])}))))}},{key:"max",value:function(t){var e=mP(this._pairs),r=e.next();if(r.done)return null;for(var n=r.value[1],o=t(r.value[1],r.value[0]);!(r=e.next()).done;){var i=Hv(r.value,2),a=i[0],u=i[1],s=t(u,a);s>o&&(o=s,n=u)}return n}},{key:"min",value:function(t){var e=mP(this._pairs),r=e.next();if(r.done)return null;for(var n=r.value[1],o=t(r.value[1],r.value[0]);!(r=e.next()).done;){var i=Hv(r.value,2),a=i[0],u=i[1],s=t(u,a);s<o&&(o=s,n=u)}return n}},{key:"reduce",value:function(t,e){var r,n=bP(this._pairs);try{for(n.s();!(r=n.n()).done;){var o=Hv(r.value,2),i=o[0];e=t(e,o[1],i)}}catch(t){n.e(t)}finally{n.f()}return e}},{key:"sort",value:function(e){var r=this;return new t(Kf({},YA,(function(){var t;return mP(AA(t=$v(r._pairs)).call(t,(function(t,r){var n=Hv(t,2),o=n[0],i=n[1],a=Hv(r,2),u=a[0],s=a[1];return e(i,s,o,u)})))})))}}]),t}();function wP(t,e){var r=bd(t);if(wh){var n=wh(t);e&&(n=Hl(n).call(n,(function(e){return Rh(t,e).enumerable}))),r.push.apply(r,n)}return r}function EP(t){for(var e=1;e<arguments.length;e++){var r,n,o=null!=arguments[e]?arguments[e]:{};e%2?Fd(r=wP(Object(o),!0)).call(r,(function(e){Kf(t,e,o[e])})):$h?av(t,$h(o)):Fd(n=wP(Object(o))).call(n,(function(e){sv(t,e,Rh(o,e))}))}return t}function TP(t,e){var r=void 0!==Kv&&mh(t)||t["@@iterator"];if(!r){if(hd(t)||(r=function(t,e){var r;if(!t)return;if("string"==typeof t)return OP(t,e);var n=ud(r=Object.prototype.toString.call(t)).call(r,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return hh(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return OP(t,e)}(t))||e&&t&&"number"==typeof t.length){r&&(t=r);var n=0,o=function(){};return{s:o,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var i,a=!0,u=!1;return{s:function(){r=r.call(t)},n:function(){var t=r.next();return a=t.done,t},e:function(t){u=!0,i=t},f:function(){try{a||null==r.return||r.return()}finally{if(u)throw i}}}}function OP(t,e){(null==e||e>t.length)&&(e=t.length);for(var r=0,n=new Array(e);r<e;r++)n[r]=t[r];return n}function SP(t){var e=function(){if("undefined"==typeof Reflect||!rw)return!1;if(rw.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(rw(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var r,n=jw(t);if(e){var o=jw(this).constructor;r=rw(n,arguments,o)}else r=n.apply(this,arguments);return ww(this,r)}}var kP=function(t){_w(n,t);var r=SP(n);function n(t,o){var i;return e(this,n),Kf(nw(i=r.call(this)),"flush",void 0),Kf(nw(i),"length",void 0),Kf(nw(i),"_options",void 0),Kf(nw(i),"_data",void 0),Kf(nw(i),"_idProp",void 0),Kf(nw(i),"_queue",null),t&&!hd(t)&&(o=t,t=[]),i._options=o||{},i._data=new Ej,i.length=0,i._idProp=i._options.fieldId||"id",t&&t.length&&i.add(t),i.setOptions(o),i}return Jf(n,[{key:"idProp",get:function(){return this._idProp}},{key:"setOptions",value:function(t){t&&void 0!==t.queue&&(!1===t.queue?this._queue&&(this._queue.destroy(),this._queue=null):(this._queue||(this._queue=uP.extend(this,{replace:["add","update","remove"]})),t.queue&&"object"===qf(t.queue)&&this._queue.setOptions(t.queue)))}},{key:"add",value:function(t,e){var r,n=this,o=[];if(hd(t)){var i=np(t).call(t,(function(t){return t[n._idProp]}));if(Dj(i).call(i,(function(t){return n._data.has(t)})))throw new Error("A duplicate id was found in the parameter array.");for(var a=0,u=t.length;a<u;a++)r=this._addItem(t[a]),o.push(r)}else{if(!t||"object"!==qf(t))throw new Error("Unknown dataType");r=this._addItem(t),o.push(r)}return o.length&&this._trigger("add",{items:o},e),o}},{key:"update",value:function(t,e){var r=this,n=[],o=[],i=[],a=[],u=this._idProp,s=function(t){var e=t[u];if(null!=e&&r._data.has(e)){var s=t,c=Wy({},r._data.get(e)),f=r._updateItem(s);o.push(f),a.push(s),i.push(c)}else{var l=r._addItem(t);n.push(l)}};if(hd(t))for(var c=0,f=t.length;c<f;c++)t[c]&&"object"===qf(t[c])?s(t[c]):console.warn("Ignoring input item, which is not an object at index "+c);else{if(!t||"object"!==qf(t))throw new Error("Unknown dataType");s(t)}if(n.length&&this._trigger("add",{items:n},e),o.length){var l={items:o,oldData:i,data:a};this._trigger("update",l,e)}return id(n).call(n,o)}},{key:"updateOnly",value:function(t,e){var r,n=this;hd(t)||(t=[t]);var o=np(r=np(t).call(t,(function(t){var e=n._data.get(t[n._idProp]);if(null==e)throw new Error("Updating non-existent items is not allowed.");return{oldData:e,update:t}}))).call(r,(function(t){var e=t.oldData,r=t.update,o=e[n._idProp],i=function(t){for(var e,r=arguments.length,n=new Array(r>1?r-1:0),o=1;o<r;o++)n[o-1]=arguments[o];return A_.apply(void 0,id(e=[{},t]).call(e,n))}(e,r);return n._data.set(o,i),{id:o,oldData:e,updatedData:i}}));if(o.length){var i={items:np(o).call(o,(function(t){return t.id})),oldData:np(o).call(o,(function(t){return t.oldData})),data:np(o).call(o,(function(t){return t.updatedData}))};return this._trigger("update",i,e),i.items}return[]}},{key:"get",value:function(t,e){var r=void 0,n=void 0,o=void 0;aP(t)?(r=t,o=e):hd(t)?(n=t,o=e):o=t;var i,a=o&&"Object"===o.returnType?"Object":"Array",u=o&&Hl(o),s=[],c=void 0,f=void 0,l=void 0;if(null!=r)(c=this._data.get(r))&&u&&!u(c)&&(c=void 0);else if(null!=n)for(var p=0,h=n.length;p<h;p++)null==(c=this._data.get(n[p]))||u&&!u(c)||s.push(c);else for(var v,d=0,y=(f=$v(Wj(v=this._data).call(v))).length;d<y;d++)l=f[d],null==(c=this._data.get(l))||u&&!u(c)||s.push(c);if(o&&o.order&&null==r&&this._sort(s,o.order),o&&o.fields){var g=o.fields;if(null!=r&&null!=c)c=this._filterFields(c,g);else for(var m=0,b=s.length;m<b;m++)s[m]=this._filterFields(s[m],g)}if("Object"==a){for(var x={},_=0,w=s.length;_<w;_++){var E=s[_];x[E[this._idProp]]=E}return x}return null!=r?null!==(i=c)&&void 0!==i?i:null:s}},{key:"getIds",value:function(t){var e=this._data,r=t&&Hl(t),n=t&&t.order,o=$v(Wj(e).call(e)),i=[];if(r)if(n){for(var a=[],u=0,s=o.length;u<s;u++){var c=o[u],f=this._data.get(c);null!=f&&r(f)&&a.push(f)}this._sort(a,n);for(var l=0,p=a.length;l<p;l++)i.push(a[l][this._idProp])}else for(var h=0,v=o.length;h<v;h++){var d=o[h],y=this._data.get(d);null!=y&&r(y)&&i.push(y[this._idProp])}else if(n){for(var g=[],m=0,b=o.length;m<b;m++){var x=o[m];g.push(e.get(x))}this._sort(g,n);for(var _=0,w=g.length;_<w;_++)i.push(g[_][this._idProp])}else for(var E=0,T=o.length;E<T;E++){var O=o[E],S=e.get(O);null!=S&&i.push(S[this._idProp])}return i}},{key:"getDataSet",value:function(){return this}},{key:"forEach",value:function(t,e){var r=e&&Hl(e),n=this._data,o=$v(Wj(n).call(n));if(e&&e.order)for(var i=this.get(e),a=0,u=i.length;a<u;a++){var s=i[a];t(s,s[this._idProp])}else for(var c=0,f=o.length;c<f;c++){var l=o[c],p=this._data.get(l);null==p||r&&!r(p)||t(p,l)}}},{key:"map",value:function(t,e){for(var r=e&&Hl(e),n=[],o=this._data,i=$v(Wj(o).call(o)),a=0,u=i.length;a<u;a++){var s=i[a],c=this._data.get(s);null==c||r&&!r(c)||n.push(t(c,s))}return e&&e.order&&this._sort(n,e.order),n}},{key:"_filterFields",value:function(t,e){var r;return t?zl(r=hd(e)?e:bd(e)).call(r,(function(e,r){return e[r]=t[r],e}),{}):t}},{key:"_sort",value:function(t,e){if("string"==typeof e){var r=e;AA(t).call(t,(function(t,e){var n=t[r],o=e[r];return n>o?1:n<o?-1:0}))}else{if("function"!=typeof e)throw new TypeError("Order must be a function or a string");AA(t).call(t,e)}}},{key:"remove",value:function(t,e){for(var r=[],n=[],o=hd(t)?t:[t],i=0,a=o.length;i<a;i++){var u=this._remove(o[i]);if(u){var s=u[this._idProp];null!=s&&(r.push(s),n.push(u))}}return r.length&&this._trigger("remove",{items:r,oldData:n},e),r}},{key:"_remove",value:function(t){var e;if(aP(t)?e=t:t&&"object"===qf(t)&&(e=t[this._idProp]),null!=e&&this._data.has(e)){var r=this._data.get(e)||null;return this._data.delete(e),--this.length,r}return null}},{key:"clear",value:function(t){for(var e,r=$v(Wj(e=this._data).call(e)),n=[],o=0,i=r.length;o<i;o++)n.push(this._data.get(r[o]));return this._data.clear(),this.length=0,this._trigger("remove",{items:r,oldData:n},t),r}},{key:"max",value:function(t){var e,r,n=null,o=null,i=TP(UA(e=this._data).call(e));try{for(i.s();!(r=i.n()).done;){var a=r.value,u=a[t];"number"==typeof u&&(null==o||u>o)&&(n=a,o=u)}}catch(t){i.e(t)}finally{i.f()}return n||null}},{key:"min",value:function(t){var e,r,n=null,o=null,i=TP(UA(e=this._data).call(e));try{for(i.s();!(r=i.n()).done;){var a=r.value,u=a[t];"number"==typeof u&&(null==o||u<o)&&(n=a,o=u)}}catch(t){i.e(t)}finally{i.f()}return n||null}},{key:"distinct",value:function(t){for(var e=this._data,r=$v(Wj(e).call(e)),n=[],o=0,i=0,a=r.length;i<a;i++){for(var u=r[i],s=e.get(u)[t],c=!1,f=0;f<o;f++)if(n[f]==s){c=!0;break}c||void 0===s||(n[o]=s,o++)}return n}},{key:"_addItem",value:function(t){var e=function(t,e){return null==t[e]&&(t[e]=iP()),t}(t,this._idProp),r=e[this._idProp];if(this._data.has(r))throw new Error("Cannot add item: item with id "+r+" already exists");return this._data.set(r,e),++this.length,r}},{key:"_updateItem",value:function(t){var e=t[this._idProp];if(null==e)throw new Error("Cannot update item: item has no id (item: "+Cm(t)+")");var r=this._data.get(e);if(!r)throw new Error("Cannot update item: no item with id "+e+" found");return this._data.set(e,EP(EP({},r),t)),e}},{key:"stream",value:function(t){if(t){var e=this._data;return new _P(Kf({},YA,yk.mark((function r(){var n,o,i,a;return yk.wrap((function(r){for(;;)switch(r.prev=r.next){case 0:n=TP(t),r.prev=1,n.s();case 3:if((o=n.n()).done){r.next=11;break}if(i=o.value,null==(a=e.get(i))){r.next=9;break}return r.next=9,[i,a];case 9:r.next=3;break;case 11:r.next=16;break;case 13:r.prev=13,r.t0=r.catch(1),n.e(r.t0);case 16:return r.prev=16,n.f(),r.finish(16);case 19:case"end":return r.stop()}}),r,null,[[1,13,16,19]])}))))}var r;return new _P(Kf({},YA,xl(r=ZA(this._data)).call(r,this._data)))}}]),n}(sP);function jP(t,e){var r=void 0!==Kv&&mh(t)||t["@@iterator"];if(!r){if(hd(t)||(r=function(t,e){var r;if(!t)return;if("string"==typeof t)return AP(t,e);var n=ud(r=Object.prototype.toString.call(t)).call(r,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return hh(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return AP(t,e)}(t))||e&&t&&"number"==typeof t.length){r&&(t=r);var n=0,o=function(){};return{s:o,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var i,a=!0,u=!1;return{s:function(){r=r.call(t)},n:function(){var t=r.next();return a=t.done,t},e:function(t){u=!0,i=t},f:function(){try{a||null==r.return||r.return()}finally{if(u)throw i}}}}function AP(t,e){(null==e||e>t.length)&&(e=t.length);for(var r=0,n=new Array(e);r<e;r++)n[r]=t[r];return n}function PP(t){var e=function(){if("undefined"==typeof Reflect||!rw)return!1;if(rw.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(rw(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var r,n=jw(t);if(e){var o=jw(this).constructor;r=rw(n,arguments,o)}else r=n.apply(this,arguments);return ww(this,r)}}var IP=function(t){_w(n,t);var r=PP(n);function n(t,o){var i,a;return e(this,n),Kf(nw(a=r.call(this)),"length",0),Kf(nw(a),"_listener",void 0),Kf(nw(a),"_data",void 0),Kf(nw(a),"_ids",new pP),Kf(nw(a),"_options",void 0),a._options=o||{},a._listener=xl(i=a._onEvent).call(i,nw(a)),a.setData(t),a}return Jf(n,[{key:"idProp",get:function(){return this.getDataSet().idProp}},{key:"setData",value:function(t){if(this._data){this._data.off&&this._data.off("*",this._listener);var e=this._data.getIds({filter:Hl(this._options)}),r=this._data.get(e);this._ids.clear(),this.length=0,this._trigger("remove",{items:e,oldData:r})}if(null!=t){this._data=t;for(var n=this._data.getIds({filter:Hl(this._options)}),o=0,i=n.length;o<i;o++){var a=n[o];this._ids.add(a)}this.length=n.length,this._trigger("add",{items:n})}else this._data=new kP;this._data.on&&this._data.on("*",this._listener)}},{key:"refresh",value:function(){for(var t=this._data.getIds({filter:Hl(this._options)}),e=$v(this._ids),r={},n=[],o=[],i=[],a=0,u=t.length;a<u;a++){var s=t[a];r[s]=!0,this._ids.has(s)||(n.push(s),this._ids.add(s))}for(var c=0,f=e.length;c<f;c++){var l=e[c],p=this._data.get(l);null==p?console.error("If you see this, report it please."):r[l]||(o.push(l),i.push(p),this._ids.delete(l))}this.length+=n.length-o.length,n.length&&this._trigger("add",{items:n}),o.length&&this._trigger("remove",{items:o,oldData:i})}},{key:"get",value:function(t,e){if(null==this._data)return null;var r,n=null;aP(t)||hd(t)?(n=t,r=e):r=t;var o=Wy({},this._options,r),i=Hl(this._options),a=r&&Hl(r);return i&&a&&(o.filter=function(t){return i(t)&&a(t)}),null==n?this._data.get(o):this._data.get(n,o)}},{key:"getIds",value:function(t){if(this._data.length){var e,r=Hl(this._options),n=null!=t?Hl(t):null;return e=n?r?function(t){return r(t)&&n(t)}:n:r,this._data.getIds({filter:e,order:t&&t.order})}return[]}},{key:"forEach",value:function(t,e){if(this._data){var r,n,o=Hl(this._options),i=e&&Hl(e);n=i?o?function(t){return o(t)&&i(t)}:i:o,Fd(r=this._data).call(r,t,{filter:n,order:e&&e.order})}}},{key:"map",value:function(t,e){if(this._data){var r,n,o=Hl(this._options),i=e&&Hl(e);return n=i?o?function(t){return o(t)&&i(t)}:i:o,np(r=this._data).call(r,t,{filter:n,order:e&&e.order})}return[]}},{key:"getDataSet",value:function(){return this._data.getDataSet()}},{key:"stream",value:function(t){var e;return this._data.stream(t||Kf({},YA,xl(e=Wj(this._ids)).call(e,this._ids)))}},{key:"dispose",value:function(){var t;null!==(t=this._data)&&void 0!==t&&t.off&&this._data.off("*",this._listener);var e,r="This data view has already been disposed of.",o={get:function(){throw new Error(r)},set:function(){throw new Error(r)},configurable:!1},i=jP(ld(n.prototype));try{for(i.s();!(e=i.n()).done;){var a=e.value;sv(this,a,o)}}catch(t){i.e(t)}finally{i.f()}}},{key:"_onEvent",value:function(t,e,r){if(e&&e.items&&this._data){var n=e.items,o=[],i=[],a=[],u=[],s=[],c=[];switch(t){case"add":for(var f=0,l=n.length;f<l;f++){var p=n[f];this.get(p)&&(this._ids.add(p),o.push(p))}break;case"update":for(var h=0,v=n.length;h<v;h++){var d=n[h];this.get(d)?this._ids.has(d)?(i.push(d),s.push(e.data[h]),u.push(e.oldData[h])):(this._ids.add(d),o.push(d)):this._ids.has(d)&&(this._ids.delete(d),a.push(d),c.push(e.oldData[h]))}break;case"remove":for(var y=0,g=n.length;y<g;y++){var m=n[y];this._ids.has(m)&&(this._ids.delete(m),a.push(m),c.push(e.oldData[y]))}}this.length+=o.length-a.length,o.length&&this._trigger("add",{items:o},r),i.length&&this._trigger("update",{items:i,oldData:u,data:s},r),a.length&&this._trigger("remove",{items:a,oldData:c},r)}}}]),n}(sP);function DP(t,e){return"object"===qf(e)&&null!==e&&t===e.idProp&&"function"==typeof e.add&&"function"==typeof e.clear&&"function"==typeof e.distinct&&"function"==typeof Fd(e)&&"function"==typeof e.get&&"function"==typeof e.getDataSet&&"function"==typeof e.getIds&&"number"==typeof e.length&&"function"==typeof np(e)&&"function"==typeof e.max&&"function"==typeof e.min&&"function"==typeof e.off&&"function"==typeof e.on&&"function"==typeof e.remove&&"function"==typeof e.setOptions&&"function"==typeof e.stream&&"function"==typeof e.update&&"function"==typeof e.updateOnly}t.DELETE=j_,t.DataSet=kP,t.DataStream=_P,t.DataView=IP,t.Queue=uP,t.createNewDataPipeFrom=function(t){return new Ep(t)},t.isDataSetLike=DP,t.isDataViewLike=function(t,e){return"object"===qf(e)&&null!==e&&t===e.idProp&&"function"==typeof Fd(e)&&"function"==typeof e.get&&"function"==typeof e.getDataSet&&"function"==typeof e.getIds&&"number"==typeof e.length&&"function"==typeof np(e)&&"function"==typeof e.off&&"function"==typeof e.on&&"function"==typeof e.stream&&DP(t,e.getDataSet())}}));
//# sourceMappingURL=vis-data.min.js.map
