/**
 * vis-network
 * https://visjs.github.io/vis-network/
 *
 * A dynamic, browser-based visualization library.
 *
 * @version 9.1.6
 * @date    2023-03-23T21:33:31.534Z
 *
 * @copyright (c) 2011-2017 Almende B.V, http://almende.com
 * @copyright (c) 2017-2019 visjs contributors, https://github.com/visjs
 *
 * @license
 * vis.js is dual licensed under both
 *
 *   1. The Apache 2.0 License
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *   and
 *
 *   2. The MIT License
 *      http://opensource.org/licenses/MIT
 *
 * vis.js may be distributed under either license.
 */
var t="undefined"!=typeof globalThis?globalThis:"undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self?self:{};function e(t){return t&&t.__esModule&&Object.prototype.hasOwnProperty.call(t,"default")?t.default:t}var i={},o={get exports(){return i},set exports(t){i=t}},n=function(t){return t&&t.Math==Math&&t},r=n("object"==typeof globalThis&&globalThis)||n("object"==typeof window&&window)||n("object"==typeof self&&self)||n("object"==typeof t&&t)||function(){return this}()||Function("return this")(),s=function(t){try{return!!t()}catch(t){return!0}},a=!s((function(){var t=function(){}.bind();return"function"!=typeof t||t.hasOwnProperty("prototype")})),h=a,l=Function.prototype,d=l.apply,c=l.call,u="object"==typeof Reflect&&Reflect.apply||(h?c.bind(d):function(){return c.apply(d,arguments)}),f=a,p=Function.prototype,v=p.call,g=f&&p.bind.bind(v,v),y=f?g:function(t){return function(){return v.apply(t,arguments)}},m=y,b=m({}.toString),w=m("".slice),x=function(t){return w(b(t),8,-1)},k=x,_=y,E=function(t){if("Function"===k(t))return _(t)},O="object"==typeof document&&document.all,C={all:O,IS_HTMLDDA:void 0===O&&void 0!==O},S=C.all,T=C.IS_HTMLDDA?function(t){return"function"==typeof t||t===S}:function(t){return"function"==typeof t},M={},P=!s((function(){return 7!=Object.defineProperty({},1,{get:function(){return 7}})[1]})),D=a,I=Function.prototype.call,B=D?I.bind(I):function(){return I.apply(I,arguments)},N={},z={}.propertyIsEnumerable,F=Object.getOwnPropertyDescriptor,A=F&&!z.call({1:2},1);N.f=A?function(t){var e=F(this,t);return!!e&&e.enumerable}:z;var j,R,L=function(t,e){return{enumerable:!(1&t),configurable:!(2&t),writable:!(4&t),value:e}},H=s,W=x,q=Object,V=y("".split),U=H((function(){return!q("z").propertyIsEnumerable(0)}))?function(t){return"String"==W(t)?V(t,""):q(t)}:q,Y=function(t){return null==t},X=Y,G=TypeError,K=function(t){if(X(t))throw G("Can't call method on "+t);return t},$=U,Z=K,Q=function(t){return $(Z(t))},J=T,tt=C.all,et=C.IS_HTMLDDA?function(t){return"object"==typeof t?null!==t:J(t)||t===tt}:function(t){return"object"==typeof t?null!==t:J(t)},it={},ot=it,nt=r,rt=T,st=function(t){return rt(t)?t:void 0},at=function(t,e){return arguments.length<2?st(ot[t])||st(nt[t]):ot[t]&&ot[t][e]||nt[t]&&nt[t][e]},ht=y({}.isPrototypeOf),lt="undefined"!=typeof navigator&&String(navigator.userAgent)||"",dt=r,ct=lt,ut=dt.process,ft=dt.Deno,pt=ut&&ut.versions||ft&&ft.version,vt=pt&&pt.v8;vt&&(R=(j=vt.split("."))[0]>0&&j[0]<4?1:+(j[0]+j[1])),!R&&ct&&(!(j=ct.match(/Edge\/(\d+)/))||j[1]>=74)&&(j=ct.match(/Chrome\/(\d+)/))&&(R=+j[1]);var gt=R,yt=gt,mt=s,bt=!!Object.getOwnPropertySymbols&&!mt((function(){var t=Symbol();return!String(t)||!(Object(t)instanceof Symbol)||!Symbol.sham&&yt&&yt<41})),wt=bt&&!Symbol.sham&&"symbol"==typeof Symbol.iterator,xt=at,kt=T,_t=ht,Et=Object,Ot=wt?function(t){return"symbol"==typeof t}:function(t){var e=xt("Symbol");return kt(e)&&_t(e.prototype,Et(t))},Ct=String,St=function(t){try{return Ct(t)}catch(t){return"Object"}},Tt=T,Mt=St,Pt=TypeError,Dt=function(t){if(Tt(t))return t;throw Pt(Mt(t)+" is not a function")},It=Dt,Bt=Y,Nt=function(t,e){var i=t[e];return Bt(i)?void 0:It(i)},zt=B,Ft=T,At=et,jt=TypeError,Rt={},Lt={get exports(){return Rt},set exports(t){Rt=t}},Ht=r,Wt=Object.defineProperty,qt=function(t,e){try{Wt(Ht,t,{value:e,configurable:!0,writable:!0})}catch(i){Ht[t]=e}return e},Vt="__core-js_shared__",Ut=r[Vt]||qt(Vt,{}),Yt=Ut;(Lt.exports=function(t,e){return Yt[t]||(Yt[t]=void 0!==e?e:{})})("versions",[]).push({version:"3.29.0",mode:"pure",copyright:"© 2014-2023 Denis Pushkarev (zloirock.ru)",license:"https://github.com/zloirock/core-js/blob/v3.29.0/LICENSE",source:"https://github.com/zloirock/core-js"});var Xt=K,Gt=Object,Kt=function(t){return Gt(Xt(t))},$t=Kt,Zt=y({}.hasOwnProperty),Qt=Object.hasOwn||function(t,e){return Zt($t(t),e)},Jt=y,te=0,ee=Math.random(),ie=Jt(1..toString),oe=function(t){return"Symbol("+(void 0===t?"":t)+")_"+ie(++te+ee,36)},ne=Rt,re=Qt,se=oe,ae=bt,he=wt,le=r.Symbol,de=ne("wks"),ce=he?le.for||le:le&&le.withoutSetter||se,ue=function(t){return re(de,t)||(de[t]=ae&&re(le,t)?le[t]:ce("Symbol."+t)),de[t]},fe=B,pe=et,ve=Ot,ge=Nt,ye=function(t,e){var i,o;if("string"===e&&Ft(i=t.toString)&&!At(o=zt(i,t)))return o;if(Ft(i=t.valueOf)&&!At(o=zt(i,t)))return o;if("string"!==e&&Ft(i=t.toString)&&!At(o=zt(i,t)))return o;throw jt("Can't convert object to primitive value")},me=TypeError,be=ue("toPrimitive"),we=function(t,e){if(!pe(t)||ve(t))return t;var i,o=ge(t,be);if(o){if(void 0===e&&(e="default"),i=fe(o,t,e),!pe(i)||ve(i))return i;throw me("Can't convert object to primitive value")}return void 0===e&&(e="number"),ye(t,e)},xe=Ot,ke=function(t){var e=we(t,"string");return xe(e)?e:e+""},_e=et,Ee=r.document,Oe=_e(Ee)&&_e(Ee.createElement),Ce=function(t){return Oe?Ee.createElement(t):{}},Se=Ce,Te=!P&&!s((function(){return 7!=Object.defineProperty(Se("div"),"a",{get:function(){return 7}}).a})),Me=P,Pe=B,De=N,Ie=L,Be=Q,Ne=ke,ze=Qt,Fe=Te,Ae=Object.getOwnPropertyDescriptor;M.f=Me?Ae:function(t,e){if(t=Be(t),e=Ne(e),Fe)try{return Ae(t,e)}catch(t){}if(ze(t,e))return Ie(!Pe(De.f,t,e),t[e])};var je=s,Re=T,Le=/#|\.prototype\./,He=function(t,e){var i=qe[We(t)];return i==Ue||i!=Ve&&(Re(e)?je(e):!!e)},We=He.normalize=function(t){return String(t).replace(Le,".").toLowerCase()},qe=He.data={},Ve=He.NATIVE="N",Ue=He.POLYFILL="P",Ye=He,Xe=Dt,Ge=a,Ke=E(E.bind),$e=function(t,e){return Xe(t),void 0===e?t:Ge?Ke(t,e):function(){return t.apply(e,arguments)}},Ze={},Qe=P&&s((function(){return 42!=Object.defineProperty((function(){}),"prototype",{value:42,writable:!1}).prototype})),Je=et,ti=String,ei=TypeError,ii=function(t){if(Je(t))return t;throw ei(ti(t)+" is not an object")},oi=P,ni=Te,ri=Qe,si=ii,ai=ke,hi=TypeError,li=Object.defineProperty,di=Object.getOwnPropertyDescriptor,ci="enumerable",ui="configurable",fi="writable";Ze.f=oi?ri?function(t,e,i){if(si(t),e=ai(e),si(i),"function"==typeof t&&"prototype"===e&&"value"in i&&fi in i&&!i[fi]){var o=di(t,e);o&&o[fi]&&(t[e]=i.value,i={configurable:ui in i?i[ui]:o[ui],enumerable:ci in i?i[ci]:o[ci],writable:!1})}return li(t,e,i)}:li:function(t,e,i){if(si(t),e=ai(e),si(i),ni)try{return li(t,e,i)}catch(t){}if("get"in i||"set"in i)throw hi("Accessors not supported");return"value"in i&&(t[e]=i.value),t};var pi=Ze,vi=L,gi=P?function(t,e,i){return pi.f(t,e,vi(1,i))}:function(t,e,i){return t[e]=i,t},yi=r,mi=u,bi=E,wi=T,xi=M.f,ki=Ye,_i=it,Ei=$e,Oi=gi,Ci=Qt,Si=function(t){var e=function(i,o,n){if(this instanceof e){switch(arguments.length){case 0:return new t;case 1:return new t(i);case 2:return new t(i,o)}return new t(i,o,n)}return mi(t,this,arguments)};return e.prototype=t.prototype,e},Ti=function(t,e){var i,o,n,r,s,a,h,l,d,c=t.target,u=t.global,f=t.stat,p=t.proto,v=u?yi:f?yi[c]:(yi[c]||{}).prototype,g=u?_i:_i[c]||Oi(_i,c,{})[c],y=g.prototype;for(r in e)o=!(i=ki(u?r:c+(f?".":"#")+r,t.forced))&&v&&Ci(v,r),a=g[r],o&&(h=t.dontCallGetSet?(d=xi(v,r))&&d.value:v[r]),s=o&&h?h:e[r],o&&typeof a==typeof s||(l=t.bind&&o?Ei(s,yi):t.wrap&&o?Si(s):p&&wi(s)?bi(s):s,(t.sham||s&&s.sham||a&&a.sham)&&Oi(l,"sham",!0),Oi(g,r,l),p&&(Ci(_i,n=c+"Prototype")||Oi(_i,n,{}),Oi(_i[n],r,s),t.real&&y&&(i||!y[r])&&Oi(y,r,s)))},Mi=Math.ceil,Pi=Math.floor,Di=Math.trunc||function(t){var e=+t;return(e>0?Pi:Mi)(e)},Ii=function(t){var e=+t;return e!=e||0===e?0:Di(e)},Bi=Ii,Ni=Math.max,zi=Math.min,Fi=function(t,e){var i=Bi(t);return i<0?Ni(i+e,0):zi(i,e)},Ai=Ii,ji=Math.min,Ri=function(t){return t>0?ji(Ai(t),9007199254740991):0},Li=function(t){return Ri(t.length)},Hi=Q,Wi=Fi,qi=Li,Vi=function(t){return function(e,i,o){var n,r=Hi(e),s=qi(r),a=Wi(o,s);if(t&&i!=i){for(;s>a;)if((n=r[a++])!=n)return!0}else for(;s>a;a++)if((t||a in r)&&r[a]===i)return t||a||0;return!t&&-1}},Ui={includes:Vi(!0),indexOf:Vi(!1)},Yi={},Xi=Qt,Gi=Q,Ki=Ui.indexOf,$i=Yi,Zi=y([].push),Qi=function(t,e){var i,o=Gi(t),n=0,r=[];for(i in o)!Xi($i,i)&&Xi(o,i)&&Zi(r,i);for(;e.length>n;)Xi(o,i=e[n++])&&(~Ki(r,i)||Zi(r,i));return r},Ji=["constructor","hasOwnProperty","isPrototypeOf","propertyIsEnumerable","toLocaleString","toString","valueOf"],to=Qi,eo=Ji,io=Object.keys||function(t){return to(t,eo)},oo={};oo.f=Object.getOwnPropertySymbols;var no=P,ro=y,so=B,ao=s,ho=io,lo=oo,co=N,uo=Kt,fo=U,po=Object.assign,vo=Object.defineProperty,go=ro([].concat),yo=!po||ao((function(){if(no&&1!==po({b:1},po(vo({},"a",{enumerable:!0,get:function(){vo(this,"b",{value:3,enumerable:!1})}}),{b:2})).b)return!0;var t={},e={},i=Symbol(),o="abcdefghijklmnopqrst";return t[i]=7,o.split("").forEach((function(t){e[t]=t})),7!=po({},t)[i]||ho(po({},e)).join("")!=o}))?function(t,e){for(var i=uo(t),o=arguments.length,n=1,r=lo.f,s=co.f;o>n;)for(var a,h=fo(arguments[n++]),l=r?go(ho(h),r(h)):ho(h),d=l.length,c=0;d>c;)a=l[c++],no&&!so(s,h,a)||(i[a]=h[a]);return i}:po,mo=yo;Ti({target:"Object",stat:!0,arity:2,forced:Object.assign!==mo},{assign:mo});var bo=it.Object.assign;o.exports=bo;var wo=e(i),xo={},ko={get exports(){return xo},set exports(t){xo=t}},_o=y([].slice),Eo=y,Oo=Dt,Co=et,So=Qt,To=_o,Mo=a,Po=Function,Do=Eo([].concat),Io=Eo([].join),Bo={},No=function(t,e,i){if(!So(Bo,e)){for(var o=[],n=0;n<e;n++)o[n]="a["+n+"]";Bo[e]=Po("C,a","return new C("+Io(o,",")+")")}return Bo[e](t,i)},zo=Mo?Po.bind:function(t){var e=Oo(this),i=e.prototype,o=To(arguments,1),n=function(){var i=Do(o,To(arguments));return this instanceof n?No(e,i.length,i):e.apply(t,i)};return Co(i)&&(n.prototype=i),n},Fo=zo;Ti({target:"Function",proto:!0,forced:Function.bind!==Fo},{bind:Fo});var Ao=it,jo=function(t){return Ao[t+"Prototype"]},Ro=jo("Function").bind,Lo=ht,Ho=Ro,Wo=Function.prototype,qo=function(t){var e=t.bind;return t===Wo||Lo(Wo,t)&&e===Wo.bind?Ho:e},Vo=qo;ko.exports=Vo;var Uo=e(xo);function Yo(t,e,i,o){t.beginPath(),t.arc(e,i,o,0,2*Math.PI,!1),t.closePath()}function Xo(t,e,i,o,n,r){var s=Math.PI/180;o-2*r<0&&(r=o/2),n-2*r<0&&(r=n/2),t.beginPath(),t.moveTo(e+r,i),t.lineTo(e+o-r,i),t.arc(e+o-r,i+r,r,270*s,360*s,!1),t.lineTo(e+o,i+n-r),t.arc(e+o-r,i+n-r,r,0,90*s,!1),t.lineTo(e+r,i+n),t.arc(e+r,i+n-r,r,90*s,180*s,!1),t.lineTo(e,i+r),t.arc(e+r,i+r,r,180*s,270*s,!1),t.closePath()}function Go(t,e,i,o,n){var r=.5522848,s=o/2*r,a=n/2*r,h=e+o,l=i+n,d=e+o/2,c=i+n/2;t.beginPath(),t.moveTo(e,c),t.bezierCurveTo(e,c-a,d-s,i,d,i),t.bezierCurveTo(d+s,i,h,c-a,h,c),t.bezierCurveTo(h,c+a,d+s,l,d,l),t.bezierCurveTo(d-s,l,e,c+a,e,c),t.closePath()}function Ko(t,e,i,o,n){var r=n*(1/3),s=.5522848,a=o/2*s,h=r/2*s,l=e+o,d=i+r,c=e+o/2,u=i+r/2,f=i+(n-r/2),p=i+n;t.beginPath(),t.moveTo(l,u),t.bezierCurveTo(l,u+h,c+a,d,c,d),t.bezierCurveTo(c-a,d,e,u+h,e,u),t.bezierCurveTo(e,u-h,c-a,i,c,i),t.bezierCurveTo(c+a,i,l,u-h,l,u),t.lineTo(l,f),t.bezierCurveTo(l,f+h,c+a,p,c,p),t.bezierCurveTo(c-a,p,e,f+h,e,f),t.lineTo(e,u)}function $o(t,e,i,o,n,r){t.beginPath(),t.moveTo(e,i);for(var s=r.length,a=o-e,h=n-i,l=h/a,d=Math.sqrt(a*a+h*h),c=0,u=!0,f=0,p=+r[0];d>=.1;)(p=+r[c++%s])>d&&(p=d),f=Math.sqrt(p*p/(1+l*l)),e+=f=a<0?-f:f,i+=l*f,!0===u?t.lineTo(e,i):t.moveTo(e,i),d-=p,u=!u}var Zo={circle:Yo,dashedLine:$o,database:Ko,diamond:function(t,e,i,o){t.beginPath(),t.lineTo(e,i+o),t.lineTo(e+o,i),t.lineTo(e,i-o),t.lineTo(e-o,i),t.closePath()},ellipse:Go,ellipse_vis:Go,hexagon:function(t,e,i,o){t.beginPath();var n=2*Math.PI/6;t.moveTo(e+o,i);for(var r=1;r<6;r++)t.lineTo(e+o*Math.cos(n*r),i+o*Math.sin(n*r));t.closePath()},roundRect:Xo,square:function(t,e,i,o){t.beginPath(),t.rect(e-o,i-o,2*o,2*o),t.closePath()},star:function(t,e,i,o){t.beginPath(),i+=.1*(o*=.82);for(var n=0;n<10;n++){var r=n%2==0?1.3*o:.5*o;t.lineTo(e+r*Math.sin(2*n*Math.PI/10),i-r*Math.cos(2*n*Math.PI/10))}t.closePath()},triangle:function(t,e,i,o){t.beginPath(),i+=.275*(o*=1.15);var n=2*o,r=n/2,s=Math.sqrt(3)/6*n,a=Math.sqrt(n*n-r*r);t.moveTo(e,i-(a-s)),t.lineTo(e+r,i+s),t.lineTo(e-r,i+s),t.lineTo(e,i-(a-s)),t.closePath()},triangleDown:function(t,e,i,o){t.beginPath(),i-=.275*(o*=1.15);var n=2*o,r=n/2,s=Math.sqrt(3)/6*n,a=Math.sqrt(n*n-r*r);t.moveTo(e,i+(a-s)),t.lineTo(e+r,i-s),t.lineTo(e-r,i-s),t.lineTo(e,i+(a-s)),t.closePath()}};var Qo={},Jo={get exports(){return Qo},set exports(t){Qo=t}};!function(t){function e(t){if(t)return function(t){for(var i in e.prototype)t[i]=e.prototype[i];return t}(t)}Jo.exports=e,e.prototype.on=e.prototype.addEventListener=function(t,e){return this._callbacks=this._callbacks||{},(this._callbacks["$"+t]=this._callbacks["$"+t]||[]).push(e),this},e.prototype.once=function(t,e){function i(){this.off(t,i),e.apply(this,arguments)}return i.fn=e,this.on(t,i),this},e.prototype.off=e.prototype.removeListener=e.prototype.removeAllListeners=e.prototype.removeEventListener=function(t,e){if(this._callbacks=this._callbacks||{},0==arguments.length)return this._callbacks={},this;var i,o=this._callbacks["$"+t];if(!o)return this;if(1==arguments.length)return delete this._callbacks["$"+t],this;for(var n=0;n<o.length;n++)if((i=o[n])===e||i.fn===e){o.splice(n,1);break}return 0===o.length&&delete this._callbacks["$"+t],this},e.prototype.emit=function(t){this._callbacks=this._callbacks||{};for(var e=new Array(arguments.length-1),i=this._callbacks["$"+t],o=1;o<arguments.length;o++)e[o-1]=arguments[o];if(i){o=0;for(var n=(i=i.slice(0)).length;o<n;++o)i[o].apply(this,e)}return this},e.prototype.listeners=function(t){return this._callbacks=this._callbacks||{},this._callbacks["$"+t]||[]},e.prototype.hasListeners=function(t){return!!this.listeners(t).length}}();var tn=Qo,en={},on={get exports(){return en},set exports(t){en=t}},nn={};nn[ue("toStringTag")]="z";var rn,sn,an,hn="[object z]"===String(nn),ln=hn,dn=T,cn=x,un=ue("toStringTag"),fn=Object,pn="Arguments"==cn(function(){return arguments}()),vn=ln?cn:function(t){var e,i,o;return void 0===t?"Undefined":null===t?"Null":"string"==typeof(i=function(t,e){try{return t[e]}catch(t){}}(e=fn(t),un))?i:pn?cn(e):"Object"==(o=cn(e))&&dn(e.callee)?"Arguments":o},gn=vn,yn=String,mn=function(t){if("Symbol"===gn(t))throw TypeError("Cannot convert a Symbol value to a string");return yn(t)},bn=y,wn=Ii,xn=mn,kn=K,_n=bn("".charAt),En=bn("".charCodeAt),On=bn("".slice),Cn=function(t){return function(e,i){var o,n,r=xn(kn(e)),s=wn(i),a=r.length;return s<0||s>=a?t?"":void 0:(o=En(r,s))<55296||o>56319||s+1===a||(n=En(r,s+1))<56320||n>57343?t?_n(r,s):o:t?On(r,s,s+2):n-56320+(o-55296<<10)+65536}},Sn={codeAt:Cn(!1),charAt:Cn(!0)},Tn=T,Mn=r.WeakMap,Pn=Tn(Mn)&&/native code/.test(String(Mn)),Dn=oe,In=Rt("keys"),Bn=function(t){return In[t]||(In[t]=Dn(t))},Nn=Pn,zn=r,Fn=et,An=gi,jn=Qt,Rn=Ut,Ln=Bn,Hn=Yi,Wn="Object already initialized",qn=zn.TypeError,Vn=zn.WeakMap;if(Nn||Rn.state){var Un=Rn.state||(Rn.state=new Vn);Un.get=Un.get,Un.has=Un.has,Un.set=Un.set,rn=function(t,e){if(Un.has(t))throw qn(Wn);return e.facade=t,Un.set(t,e),e},sn=function(t){return Un.get(t)||{}},an=function(t){return Un.has(t)}}else{var Yn=Ln("state");Hn[Yn]=!0,rn=function(t,e){if(jn(t,Yn))throw qn(Wn);return e.facade=t,An(t,Yn,e),e},sn=function(t){return jn(t,Yn)?t[Yn]:{}},an=function(t){return jn(t,Yn)}}var Xn={set:rn,get:sn,has:an,enforce:function(t){return an(t)?sn(t):rn(t,{})},getterFor:function(t){return function(e){var i;if(!Fn(e)||(i=sn(e)).type!==t)throw qn("Incompatible receiver, "+t+" required");return i}}},Gn=P,Kn=Qt,$n=Function.prototype,Zn=Gn&&Object.getOwnPropertyDescriptor,Qn=Kn($n,"name"),Jn={EXISTS:Qn,PROPER:Qn&&"something"===function(){}.name,CONFIGURABLE:Qn&&(!Gn||Gn&&Zn($n,"name").configurable)},tr={},er=P,ir=Qe,or=Ze,nr=ii,rr=Q,sr=io;tr.f=er&&!ir?Object.defineProperties:function(t,e){nr(t);for(var i,o=rr(e),n=sr(e),r=n.length,s=0;r>s;)or.f(t,i=n[s++],o[i]);return t};var ar,hr=at("document","documentElement"),lr=ii,dr=tr,cr=Ji,ur=Yi,fr=hr,pr=Ce,vr="prototype",gr="script",yr=Bn("IE_PROTO"),mr=function(){},br=function(t){return"<"+gr+">"+t+"</"+gr+">"},wr=function(t){t.write(br("")),t.close();var e=t.parentWindow.Object;return t=null,e},xr=function(){try{ar=new ActiveXObject("htmlfile")}catch(t){}var t,e,i;xr="undefined"!=typeof document?document.domain&&ar?wr(ar):(e=pr("iframe"),i="java"+gr+":",e.style.display="none",fr.appendChild(e),e.src=String(i),(t=e.contentWindow.document).open(),t.write(br("document.F=Object")),t.close(),t.F):wr(ar);for(var o=cr.length;o--;)delete xr[vr][cr[o]];return xr()};ur[yr]=!0;var kr,_r,Er,Or=Object.create||function(t,e){var i;return null!==t?(mr[vr]=lr(t),i=new mr,mr[vr]=null,i[yr]=t):i=xr(),void 0===e?i:dr.f(i,e)},Cr=!s((function(){function t(){}return t.prototype.constructor=null,Object.getPrototypeOf(new t)!==t.prototype})),Sr=Qt,Tr=T,Mr=Kt,Pr=Cr,Dr=Bn("IE_PROTO"),Ir=Object,Br=Ir.prototype,Nr=Pr?Ir.getPrototypeOf:function(t){var e=Mr(t);if(Sr(e,Dr))return e[Dr];var i=e.constructor;return Tr(i)&&e instanceof i?i.prototype:e instanceof Ir?Br:null},zr=gi,Fr=function(t,e,i,o){return o&&o.enumerable?t[e]=i:zr(t,e,i),t},Ar=s,jr=T,Rr=et,Lr=Or,Hr=Nr,Wr=Fr,qr=ue("iterator"),Vr=!1;[].keys&&("next"in(Er=[].keys())?(_r=Hr(Hr(Er)))!==Object.prototype&&(kr=_r):Vr=!0);var Ur=!Rr(kr)||Ar((function(){var t={};return kr[qr].call(t)!==t}));jr((kr=Ur?{}:Lr(kr))[qr])||Wr(kr,qr,(function(){return this}));var Yr={IteratorPrototype:kr,BUGGY_SAFARI_ITERATORS:Vr},Xr=vn,Gr=hn?{}.toString:function(){return"[object "+Xr(this)+"]"},Kr=hn,$r=Ze.f,Zr=gi,Qr=Qt,Jr=Gr,ts=ue("toStringTag"),es=function(t,e,i,o){if(t){var n=i?t:t.prototype;Qr(n,ts)||$r(n,ts,{configurable:!0,value:e}),o&&!Kr&&Zr(n,"toString",Jr)}},is={},os=Yr.IteratorPrototype,ns=Or,rs=L,ss=es,as=is,hs=function(){return this},ls=y,ds=Dt,cs=T,us=String,fs=TypeError,ps=function(t,e,i){try{return ls(ds(Object.getOwnPropertyDescriptor(t,e)[i]))}catch(t){}},vs=ii,gs=function(t){if("object"==typeof t||cs(t))return t;throw fs("Can't set "+us(t)+" as a prototype")},ys=Object.setPrototypeOf||("__proto__"in{}?function(){var t,e=!1,i={};try{(t=ps(Object.prototype,"__proto__","set"))(i,[]),e=i instanceof Array}catch(t){}return function(i,o){return vs(i),gs(o),e?t(i,o):i.__proto__=o,i}}():void 0),ms=Ti,bs=B,ws=function(t,e,i,o){var n=e+" Iterator";return t.prototype=ns(os,{next:rs(+!o,i)}),ss(t,n,!1,!0),as[n]=hs,t},xs=Nr,ks=es,_s=Fr,Es=is,Os=Jn.PROPER,Cs=Yr.BUGGY_SAFARI_ITERATORS,Ss=ue("iterator"),Ts="keys",Ms="values",Ps="entries",Ds=function(){return this},Is=function(t,e,i,o,n,r,s){ws(i,e,o);var a,h,l,d=function(t){if(t===n&&v)return v;if(!Cs&&t in f)return f[t];switch(t){case Ts:case Ms:case Ps:return function(){return new i(this,t)}}return function(){return new i(this)}},c=e+" Iterator",u=!1,f=t.prototype,p=f[Ss]||f["@@iterator"]||n&&f[n],v=!Cs&&p||d(n),g="Array"==e&&f.entries||p;if(g&&(a=xs(g.call(new t)))!==Object.prototype&&a.next&&(ks(a,c,!0,!0),Es[c]=Ds),Os&&n==Ms&&p&&p.name!==Ms&&(u=!0,v=function(){return bs(p,this)}),n)if(h={values:d(Ms),keys:r?v:d(Ts),entries:d(Ps)},s)for(l in h)(Cs||u||!(l in f))&&_s(f,l,h[l]);else ms({target:e,proto:!0,forced:Cs||u},h);return s&&f[Ss]!==v&&_s(f,Ss,v,{name:n}),Es[e]=v,h},Bs=function(t,e){return{value:t,done:e}},Ns=Sn.charAt,zs=mn,Fs=Xn,As=Is,js=Bs,Rs="String Iterator",Ls=Fs.set,Hs=Fs.getterFor(Rs);As(String,"String",(function(t){Ls(this,{type:Rs,string:zs(t),index:0})}),(function(){var t,e=Hs(this),i=e.string,o=e.index;return o>=i.length?js(void 0,!0):(t=Ns(i,o),e.index+=t.length,js(t,!1))}));var Ws=B,qs=ii,Vs=Nt,Us=function(t,e,i){var o,n;qs(t);try{if(!(o=Vs(t,"return"))){if("throw"===e)throw i;return i}o=Ws(o,t)}catch(t){n=!0,o=t}if("throw"===e)throw i;if(n)throw o;return qs(o),i},Ys=ii,Xs=Us,Gs=is,Ks=ue("iterator"),$s=Array.prototype,Zs=function(t){return void 0!==t&&(Gs.Array===t||$s[Ks]===t)},Qs=T,Js=Ut,ta=y(Function.toString);Qs(Js.inspectSource)||(Js.inspectSource=function(t){return ta(t)});var ea=Js.inspectSource,ia=y,oa=s,na=T,ra=vn,sa=ea,aa=function(){},ha=[],la=at("Reflect","construct"),da=/^\s*(?:class|function)\b/,ca=ia(da.exec),ua=!da.exec(aa),fa=function(t){if(!na(t))return!1;try{return la(aa,ha,t),!0}catch(t){return!1}},pa=function(t){if(!na(t))return!1;switch(ra(t)){case"AsyncFunction":case"GeneratorFunction":case"AsyncGeneratorFunction":return!1}try{return ua||!!ca(da,sa(t))}catch(t){return!0}};pa.sham=!0;var va=!la||oa((function(){var t;return fa(fa.call)||!fa(Object)||!fa((function(){t=!0}))||t}))?pa:fa,ga=ke,ya=Ze,ma=L,ba=function(t,e,i){var o=ga(e);o in t?ya.f(t,o,ma(0,i)):t[o]=i},wa=vn,xa=Nt,ka=Y,_a=is,Ea=ue("iterator"),Oa=function(t){if(!ka(t))return xa(t,Ea)||xa(t,"@@iterator")||_a[wa(t)]},Ca=B,Sa=Dt,Ta=ii,Ma=St,Pa=Oa,Da=TypeError,Ia=function(t,e){var i=arguments.length<2?Pa(t):e;if(Sa(i))return Ta(Ca(i,t));throw Da(Ma(t)+" is not iterable")},Ba=$e,Na=B,za=Kt,Fa=function(t,e,i,o){try{return o?e(Ys(i)[0],i[1]):e(i)}catch(e){Xs(t,"throw",e)}},Aa=Zs,ja=va,Ra=Li,La=ba,Ha=Ia,Wa=Oa,qa=Array,Va=ue("iterator"),Ua=!1;try{var Ya=0,Xa={next:function(){return{done:!!Ya++}},return:function(){Ua=!0}};Xa[Va]=function(){return this},Array.from(Xa,(function(){throw 2}))}catch(t){}var Ga=function(t,e){if(!e&&!Ua)return!1;var i=!1;try{var o={};o[Va]=function(){return{next:function(){return{done:i=!0}}}},t(o)}catch(t){}return i},Ka=function(t){var e=za(t),i=ja(this),o=arguments.length,n=o>1?arguments[1]:void 0,r=void 0!==n;r&&(n=Ba(n,o>2?arguments[2]:void 0));var s,a,h,l,d,c,u=Wa(e),f=0;if(!u||this===qa&&Aa(u))for(s=Ra(e),a=i?new this(s):qa(s);s>f;f++)c=r?n(e[f],f):e[f],La(a,f,c);else for(d=(l=Ha(e,u)).next,a=i?new this:[];!(h=Na(d,l)).done;f++)c=r?Fa(l,n,[h.value,f],!0):h.value,La(a,f,c);return a.length=f,a};Ti({target:"Array",stat:!0,forced:!Ga((function(t){Array.from(t)}))},{from:Ka});var $a=it.Array.from;on.exports=$a;var Za=e(en),Qa={},Ja={get exports(){return Qa},set exports(t){Qa=t}},th={},eh={get exports(){return th},set exports(t){th=t}},ih=Q,oh=is,nh=Xn;Ze.f;var rh=Is,sh=Bs,ah="Array Iterator",hh=nh.set,lh=nh.getterFor(ah);rh(Array,"Array",(function(t,e){hh(this,{type:ah,target:ih(t),index:0,kind:e})}),(function(){var t=lh(this),e=t.target,i=t.kind,o=t.index++;return!e||o>=e.length?(t.target=void 0,sh(void 0,!0)):sh("keys"==i?o:"values"==i?e[o]:[o,e[o]],!1)}),"values"),oh.Arguments=oh.Array;var dh=Oa,ch={CSSRuleList:0,CSSStyleDeclaration:0,CSSValueList:0,ClientRectList:0,DOMRectList:0,DOMStringList:0,DOMTokenList:1,DataTransferItemList:0,FileList:0,HTMLAllCollection:0,HTMLCollection:0,HTMLFormElement:0,HTMLSelectElement:0,MediaList:0,MimeTypeArray:0,NamedNodeMap:0,NodeList:1,PaintRequestList:0,Plugin:0,PluginArray:0,SVGLengthList:0,SVGNumberList:0,SVGPathSegList:0,SVGPointList:0,SVGStringList:0,SVGTransformList:0,SourceBufferList:0,StyleSheetList:0,TextTrackCueList:0,TextTrackList:0,TouchList:0},uh=r,fh=vn,ph=gi,vh=is,gh=ue("toStringTag");for(var yh in ch){var mh=uh[yh],bh=mh&&mh.prototype;bh&&fh(bh)!==gh&&ph(bh,gh,yh),vh[yh]=vh.Array}var wh=dh;eh.exports=wh,Ja.exports=th;var xh=e(Qa),kh={},_h={get exports(){return kh},set exports(t){kh=t}},Eh={},Oh=Qi,Ch=Ji.concat("length","prototype");Eh.f=Object.getOwnPropertyNames||function(t){return Oh(t,Ch)};var Sh={},Th=Fi,Mh=Li,Ph=ba,Dh=Array,Ih=Math.max,Bh=function(t,e,i){for(var o=Mh(t),n=Th(e,o),r=Th(void 0===i?o:i,o),s=Dh(Ih(r-n,0)),a=0;n<r;n++,a++)Ph(s,a,t[n]);return s.length=a,s},Nh=x,zh=Q,Fh=Eh.f,Ah=Bh,jh="object"==typeof window&&window&&Object.getOwnPropertyNames?Object.getOwnPropertyNames(window):[];Sh.f=function(t){return jh&&"Window"==Nh(t)?function(t){try{return Fh(t)}catch(t){return Ah(jh)}}(t):Fh(zh(t))};var Rh=Ze,Lh=function(t,e,i){return Rh.f(t,e,i)},Hh={},Wh=ue;Hh.f=Wh;var qh=it,Vh=Qt,Uh=Hh,Yh=Ze.f,Xh=function(t){var e=qh.Symbol||(qh.Symbol={});Vh(e,t)||Yh(e,t,{value:Uh.f(t)})},Gh=B,Kh=at,$h=ue,Zh=Fr,Qh=function(){var t=Kh("Symbol"),e=t&&t.prototype,i=e&&e.valueOf,o=$h("toPrimitive");e&&!e[o]&&Zh(e,o,(function(t){return Gh(i,this)}),{arity:1})},Jh=x,tl=Array.isArray||function(t){return"Array"==Jh(t)},el=tl,il=va,ol=et,nl=ue("species"),rl=Array,sl=function(t){var e;return el(t)&&(e=t.constructor,(il(e)&&(e===rl||el(e.prototype))||ol(e)&&null===(e=e[nl]))&&(e=void 0)),void 0===e?rl:e},al=function(t,e){return new(sl(t))(0===e?0:e)},hl=$e,ll=U,dl=Kt,cl=Li,ul=al,fl=y([].push),pl=function(t){var e=1==t,i=2==t,o=3==t,n=4==t,r=6==t,s=7==t,a=5==t||r;return function(h,l,d,c){for(var u,f,p=dl(h),v=ll(p),g=hl(l,d),y=cl(v),m=0,b=c||ul,w=e?b(h,y):i||s?b(h,0):void 0;y>m;m++)if((a||m in v)&&(f=g(u=v[m],m,p),t))if(e)w[m]=f;else if(f)switch(t){case 3:return!0;case 5:return u;case 6:return m;case 2:fl(w,u)}else switch(t){case 4:return!1;case 7:fl(w,u)}return r?-1:o||n?n:w}},vl={forEach:pl(0),map:pl(1),filter:pl(2),some:pl(3),every:pl(4),find:pl(5),findIndex:pl(6),filterReject:pl(7)},gl=Ti,yl=r,ml=B,bl=y,wl=P,xl=bt,kl=s,_l=Qt,El=ht,Ol=ii,Cl=Q,Sl=ke,Tl=mn,Ml=L,Pl=Or,Dl=io,Il=Eh,Bl=Sh,Nl=oo,zl=M,Fl=Ze,Al=tr,jl=N,Rl=Fr,Ll=Lh,Hl=Rt,Wl=Yi,ql=oe,Vl=ue,Ul=Hh,Yl=Xh,Xl=Qh,Gl=es,Kl=Xn,$l=vl.forEach,Zl=Bn("hidden"),Ql="Symbol",Jl="prototype",td=Kl.set,ed=Kl.getterFor(Ql),id=Object[Jl],od=yl.Symbol,nd=od&&od[Jl],rd=yl.TypeError,sd=yl.QObject,ad=zl.f,hd=Fl.f,ld=Bl.f,dd=jl.f,cd=bl([].push),ud=Hl("symbols"),fd=Hl("op-symbols"),pd=Hl("wks"),vd=!sd||!sd[Jl]||!sd[Jl].findChild,gd=wl&&kl((function(){return 7!=Pl(hd({},"a",{get:function(){return hd(this,"a",{value:7}).a}})).a}))?function(t,e,i){var o=ad(id,e);o&&delete id[e],hd(t,e,i),o&&t!==id&&hd(id,e,o)}:hd,yd=function(t,e){var i=ud[t]=Pl(nd);return td(i,{type:Ql,tag:t,description:e}),wl||(i.description=e),i},md=function(t,e,i){t===id&&md(fd,e,i),Ol(t);var o=Sl(e);return Ol(i),_l(ud,o)?(i.enumerable?(_l(t,Zl)&&t[Zl][o]&&(t[Zl][o]=!1),i=Pl(i,{enumerable:Ml(0,!1)})):(_l(t,Zl)||hd(t,Zl,Ml(1,{})),t[Zl][o]=!0),gd(t,o,i)):hd(t,o,i)},bd=function(t,e){Ol(t);var i=Cl(e),o=Dl(i).concat(_d(i));return $l(o,(function(e){wl&&!ml(wd,i,e)||md(t,e,i[e])})),t},wd=function(t){var e=Sl(t),i=ml(dd,this,e);return!(this===id&&_l(ud,e)&&!_l(fd,e))&&(!(i||!_l(this,e)||!_l(ud,e)||_l(this,Zl)&&this[Zl][e])||i)},xd=function(t,e){var i=Cl(t),o=Sl(e);if(i!==id||!_l(ud,o)||_l(fd,o)){var n=ad(i,o);return!n||!_l(ud,o)||_l(i,Zl)&&i[Zl][o]||(n.enumerable=!0),n}},kd=function(t){var e=ld(Cl(t)),i=[];return $l(e,(function(t){_l(ud,t)||_l(Wl,t)||cd(i,t)})),i},_d=function(t){var e=t===id,i=ld(e?fd:Cl(t)),o=[];return $l(i,(function(t){!_l(ud,t)||e&&!_l(id,t)||cd(o,ud[t])})),o};xl||(Rl(nd=(od=function(){if(El(nd,this))throw rd("Symbol is not a constructor");var t=arguments.length&&void 0!==arguments[0]?Tl(arguments[0]):void 0,e=ql(t),i=function(t){this===id&&ml(i,fd,t),_l(this,Zl)&&_l(this[Zl],e)&&(this[Zl][e]=!1),gd(this,e,Ml(1,t))};return wl&&vd&&gd(id,e,{configurable:!0,set:i}),yd(e,t)})[Jl],"toString",(function(){return ed(this).tag})),Rl(od,"withoutSetter",(function(t){return yd(ql(t),t)})),jl.f=wd,Fl.f=md,Al.f=bd,zl.f=xd,Il.f=Bl.f=kd,Nl.f=_d,Ul.f=function(t){return yd(Vl(t),t)},wl&&Ll(nd,"description",{configurable:!0,get:function(){return ed(this).description}})),gl({global:!0,constructor:!0,wrap:!0,forced:!xl,sham:!xl},{Symbol:od}),$l(Dl(pd),(function(t){Yl(t)})),gl({target:Ql,stat:!0,forced:!xl},{useSetter:function(){vd=!0},useSimple:function(){vd=!1}}),gl({target:"Object",stat:!0,forced:!xl,sham:!wl},{create:function(t,e){return void 0===e?Pl(t):bd(Pl(t),e)},defineProperty:md,defineProperties:bd,getOwnPropertyDescriptor:xd}),gl({target:"Object",stat:!0,forced:!xl},{getOwnPropertyNames:kd}),Xl(),Gl(od,Ql),Wl[Zl]=!0;var Ed=bt&&!!Symbol.for&&!!Symbol.keyFor,Od=Ti,Cd=at,Sd=Qt,Td=mn,Md=Rt,Pd=Ed,Dd=Md("string-to-symbol-registry"),Id=Md("symbol-to-string-registry");Od({target:"Symbol",stat:!0,forced:!Pd},{for:function(t){var e=Td(t);if(Sd(Dd,e))return Dd[e];var i=Cd("Symbol")(e);return Dd[e]=i,Id[i]=e,i}});var Bd=Ti,Nd=Qt,zd=Ot,Fd=St,Ad=Ed,jd=Rt("symbol-to-string-registry");Bd({target:"Symbol",stat:!0,forced:!Ad},{keyFor:function(t){if(!zd(t))throw TypeError(Fd(t)+" is not a symbol");if(Nd(jd,t))return jd[t]}});var Rd=tl,Ld=T,Hd=x,Wd=mn,qd=y([].push),Vd=Ti,Ud=at,Yd=u,Xd=B,Gd=y,Kd=s,$d=T,Zd=Ot,Qd=_o,Jd=function(t){if(Ld(t))return t;if(Rd(t)){for(var e=t.length,i=[],o=0;o<e;o++){var n=t[o];"string"==typeof n?qd(i,n):"number"!=typeof n&&"Number"!=Hd(n)&&"String"!=Hd(n)||qd(i,Wd(n))}var r=i.length,s=!0;return function(t,e){if(s)return s=!1,e;if(Rd(this))return e;for(var o=0;o<r;o++)if(i[o]===t)return e}}},tc=bt,ec=String,ic=Ud("JSON","stringify"),oc=Gd(/./.exec),nc=Gd("".charAt),rc=Gd("".charCodeAt),sc=Gd("".replace),ac=Gd(1..toString),hc=/[\uD800-\uDFFF]/g,lc=/^[\uD800-\uDBFF]$/,dc=/^[\uDC00-\uDFFF]$/,cc=!tc||Kd((function(){var t=Ud("Symbol")();return"[null]"!=ic([t])||"{}"!=ic({a:t})||"{}"!=ic(Object(t))})),uc=Kd((function(){return'"\\udf06\\ud834"'!==ic("\udf06\ud834")||'"\\udead"'!==ic("\udead")})),fc=function(t,e){var i=Qd(arguments),o=Jd(e);if($d(o)||void 0!==t&&!Zd(t))return i[1]=function(t,e){if($d(o)&&(e=Xd(o,this,ec(t),e)),!Zd(e))return e},Yd(ic,null,i)},pc=function(t,e,i){var o=nc(i,e-1),n=nc(i,e+1);return oc(lc,t)&&!oc(dc,n)||oc(dc,t)&&!oc(lc,o)?"\\u"+ac(rc(t,0),16):t};ic&&Vd({target:"JSON",stat:!0,arity:3,forced:cc||uc},{stringify:function(t,e,i){var o=Qd(arguments),n=Yd(cc?fc:ic,null,o);return uc&&"string"==typeof n?sc(n,hc,pc):n}});var vc=oo,gc=Kt;Ti({target:"Object",stat:!0,forced:!bt||s((function(){vc.f(1)}))},{getOwnPropertySymbols:function(t){var e=vc.f;return e?e(gc(t)):[]}});var yc=it.Object.getOwnPropertySymbols;_h.exports=yc;var mc=e(kh),bc={},wc={get exports(){return bc},set exports(t){bc=t}},xc={},kc={get exports(){return xc},set exports(t){xc=t}},_c=Ti,Ec=s,Oc=Q,Cc=M.f,Sc=P;_c({target:"Object",stat:!0,forced:!Sc||Ec((function(){Cc(1)})),sham:!Sc},{getOwnPropertyDescriptor:function(t,e){return Cc(Oc(t),e)}});var Tc=it.Object,Mc=kc.exports=function(t,e){return Tc.getOwnPropertyDescriptor(t,e)};Tc.getOwnPropertyDescriptor.sham&&(Mc.sham=!0);var Pc=xc;wc.exports=Pc;var Dc=e(bc),Ic={},Bc={get exports(){return Ic},set exports(t){Ic=t}},Nc=at,zc=Eh,Fc=oo,Ac=ii,jc=y([].concat),Rc=Nc("Reflect","ownKeys")||function(t){var e=zc.f(Ac(t)),i=Fc.f;return i?jc(e,i(t)):e},Lc=Rc,Hc=Q,Wc=M,qc=ba;Ti({target:"Object",stat:!0,sham:!P},{getOwnPropertyDescriptors:function(t){for(var e,i,o=Hc(t),n=Wc.f,r=Lc(o),s={},a=0;r.length>a;)void 0!==(i=n(o,e=r[a++]))&&qc(s,e,i);return s}});var Vc=it.Object.getOwnPropertyDescriptors;Bc.exports=Vc;var Uc=e(Ic),Yc={},Xc={get exports(){return Yc},set exports(t){Yc=t}},Gc={},Kc={get exports(){return Gc},set exports(t){Gc=t}},$c=Ti,Zc=P,Qc=tr.f;$c({target:"Object",stat:!0,forced:Object.defineProperties!==Qc,sham:!Zc},{defineProperties:Qc});var Jc=it.Object,tu=Kc.exports=function(t,e){return Jc.defineProperties(t,e)};Jc.defineProperties.sham&&(tu.sham=!0);var eu=Gc;Xc.exports=eu;var iu=e(Yc),ou={},nu={get exports(){return ou},set exports(t){ou=t}},ru={},su={get exports(){return ru},set exports(t){ru=t}},au=Ti,hu=P,lu=Ze.f;au({target:"Object",stat:!0,forced:Object.defineProperty!==lu,sham:!hu},{defineProperty:lu});var du=it.Object,cu=su.exports=function(t,e,i){return du.defineProperty(t,e,i)};du.defineProperty.sham&&(cu.sham=!0);var uu=ru;nu.exports=uu;var fu=e(ou);function pu(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")}var vu={},gu={get exports(){return vu},set exports(t){vu=t}},yu={},mu=uu;({get exports(){return yu},set exports(t){yu=t}}).exports=mu,gu.exports=yu;var bu=e(vu),wu={},xu={get exports(){return wu},set exports(t){wu=t}},ku={},_u={get exports(){return ku},set exports(t){ku=t}},Eu=TypeError,Ou=function(t){if(t>9007199254740991)throw Eu("Maximum allowed index exceeded");return t},Cu=s,Su=gt,Tu=ue("species"),Mu=function(t){return Su>=51||!Cu((function(){var e=[];return(e.constructor={})[Tu]=function(){return{foo:1}},1!==e[t](Boolean).foo}))},Pu=Ti,Du=s,Iu=tl,Bu=et,Nu=Kt,zu=Li,Fu=Ou,Au=ba,ju=al,Ru=Mu,Lu=gt,Hu=ue("isConcatSpreadable"),Wu=Lu>=51||!Du((function(){var t=[];return t[Hu]=!1,t.concat()[0]!==t})),qu=function(t){if(!Bu(t))return!1;var e=t[Hu];return void 0!==e?!!e:Iu(t)};Pu({target:"Array",proto:!0,arity:1,forced:!Wu||!Ru("concat")},{concat:function(t){var e,i,o,n,r,s=Nu(this),a=ju(s,0),h=0;for(e=-1,o=arguments.length;e<o;e++)if(qu(r=-1===e?s:arguments[e]))for(n=zu(r),Fu(h+n),i=0;i<n;i++,h++)i in r&&Au(a,h,r[i]);else Fu(h+1),Au(a,h++,r);return a.length=h,a}}),Xh("asyncIterator"),Xh("hasInstance"),Xh("isConcatSpreadable"),Xh("iterator"),Xh("match"),Xh("matchAll"),Xh("replace"),Xh("search"),Xh("species"),Xh("split");var Vu=Qh;Xh("toPrimitive"),Vu();var Uu=at,Yu=es;Xh("toStringTag"),Yu(Uu("Symbol"),"Symbol"),Xh("unscopables"),es(r.JSON,"JSON",!0);var Xu=it.Symbol;Xh("dispose");var Gu=Xu;Xh("asyncDispose");var Ku=Ti,$u=y,Zu=at("Symbol"),Qu=Zu.keyFor,Ju=$u(Zu.prototype.valueOf);Ku({target:"Symbol",stat:!0},{isRegistered:function(t){try{return void 0!==Qu(Ju(t))}catch(t){return!1}}});for(var tf=Ti,ef=Rt,of=at,nf=y,rf=Ot,sf=ue,af=of("Symbol"),hf=af.isWellKnown,lf=of("Object","getOwnPropertyNames"),df=nf(af.prototype.valueOf),cf=ef("wks"),uf=0,ff=lf(af),pf=ff.length;uf<pf;uf++)try{var vf=ff[uf];rf(af[vf])&&sf(vf)}catch(t){}tf({target:"Symbol",stat:!0,forced:!0},{isWellKnown:function(t){if(hf&&hf(t))return!0;try{for(var e=df(t),i=0,o=lf(cf),n=o.length;i<n;i++)if(cf[o[i]]==e)return!0}catch(t){}return!1}}),Xh("matcher"),Xh("metadataKey"),Xh("observable"),Xh("metadata"),Xh("patternMatch"),Xh("replaceAll");var gf=Gu;_u.exports=gf,xu.exports=ku;var yf=e(wu),mf={},bf={get exports(){return mf},set exports(t){mf=t}},wf={},xf={get exports(){return wf},set exports(t){wf=t}},kf=Hh.f("iterator"),_f=kf;xf.exports=_f,bf.exports=wf;var Ef=e(mf);function Of(t){return Of="function"==typeof yf&&"symbol"==typeof Ef?function(t){return typeof t}:function(t){return t&&"function"==typeof yf&&t.constructor===yf&&t!==yf.prototype?"symbol":typeof t},Of(t)}var Cf={},Sf={get exports(){return Cf},set exports(t){Cf=t}},Tf={},Mf={get exports(){return Tf},set exports(t){Tf=t}},Pf=Hh.f("toPrimitive");Mf.exports=Pf,Sf.exports=Tf;var Df=e(Cf);function If(t){var e=function(t,e){if("object"!==Of(t)||null===t)return t;var i=t[Df];if(void 0!==i){var o=i.call(t,e||"default");if("object"!==Of(o))return o;throw new TypeError("@@toPrimitive must return a primitive value.")}return("string"===e?String:Number)(t)}(t,"string");return"symbol"===Of(e)?e:String(e)}function Bf(t,e){for(var i=0;i<e.length;i++){var o=e[i];o.enumerable=o.enumerable||!1,o.configurable=!0,"value"in o&&(o.writable=!0),bu(t,If(o.key),o)}}function Nf(t,e,i){return e&&Bf(t.prototype,e),i&&Bf(t,i),bu(t,"prototype",{writable:!1}),t}function zf(t,e,i){return(e=If(e))in t?bu(t,e,{value:i,enumerable:!0,configurable:!0,writable:!0}):t[e]=i,t}var Ff={},Af={get exports(){return Ff},set exports(t){Ff=t}},jf={},Rf={get exports(){return jf},set exports(t){jf=t}};Ti({target:"Array",stat:!0},{isArray:tl});var Lf=it.Array.isArray,Hf=Lf;Rf.exports=Hf,Af.exports=jf;var Wf=e(Ff);var qf={},Vf={get exports(){return qf},set exports(t){qf=t}},Uf={},Yf={get exports(){return Uf},set exports(t){Uf=t}},Xf=Ti,Gf=tl,Kf=va,$f=et,Zf=Fi,Qf=Li,Jf=Q,tp=ba,ep=ue,ip=_o,op=Mu("slice"),np=ep("species"),rp=Array,sp=Math.max;Xf({target:"Array",proto:!0,forced:!op},{slice:function(t,e){var i,o,n,r=Jf(this),s=Qf(r),a=Zf(t,s),h=Zf(void 0===e?s:e,s);if(Gf(r)&&(i=r.constructor,(Kf(i)&&(i===rp||Gf(i.prototype))||$f(i)&&null===(i=i[np]))&&(i=void 0),i===rp||void 0===i))return ip(r,a,h);for(o=new(void 0===i?rp:i)(sp(h-a,0)),n=0;a<h;a++,n++)a in r&&tp(o,n,r[a]);return o.length=n,o}});var ap=jo("Array").slice,hp=ht,lp=ap,dp=Array.prototype,cp=function(t){var e=t.slice;return t===dp||hp(dp,t)&&e===dp.slice?lp:e},up=cp,fp=up;Yf.exports=fp,Vf.exports=Uf;var pp=e(qf),vp={},gp={get exports(){return vp},set exports(t){vp=t}},yp={},mp=$a;({get exports(){return yp},set exports(t){yp=t}}).exports=mp,gp.exports=yp;var bp=e(vp);function wp(t,e){(null==e||e>t.length)&&(e=t.length);for(var i=0,o=new Array(e);i<e;i++)o[i]=t[i];return o}function xp(t,e){var i;if(t){if("string"==typeof t)return wp(t,e);var o=pp(i=Object.prototype.toString.call(t)).call(i,8,-1);return"Object"===o&&t.constructor&&(o=t.constructor.name),"Map"===o||"Set"===o?bp(t):"Arguments"===o||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(o)?wp(t,e):void 0}}function kp(t,e){return function(t){if(Wf(t))return t}(t)||function(t,e){var i=null==t?null:void 0!==yf&&xh(t)||t["@@iterator"];if(null!=i){var o,n,r,s,a=[],h=!0,l=!1;try{if(r=(i=i.call(t)).next,0===e){if(Object(i)!==i)return;h=!1}else for(;!(h=(o=r.call(i)).done)&&(a.push(o.value),a.length!==e);h=!0);}catch(t){l=!0,n=t}finally{try{if(!h&&null!=i.return&&(s=i.return(),Object(s)!==s))return}finally{if(l)throw n}}return a}}(t,e)||xp(t,e)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function _p(t){return function(t){if(Wf(t))return wp(t)}(t)||function(t){if(void 0!==yf&&null!=xh(t)||null!=t["@@iterator"])return bp(t)}(t)||xp(t)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var Ep={};({get exports(){return Ep},set exports(t){Ep=t}}).exports=Xu;var Op=e(Ep),Cp={},Sp={get exports(){return Cp},set exports(t){Cp=t}},Tp=jo("Array").concat,Mp=ht,Pp=Tp,Dp=Array.prototype,Ip=function(t){var e=t.concat;return t===Dp||Mp(Dp,t)&&e===Dp.concat?Pp:e},Bp=Ip;Sp.exports=Bp;var Np=e(Cp),zp={};({get exports(){return zp},set exports(t){zp=t}}).exports=up;var Fp=e(zp),Ap={},jp={get exports(){return Ap},set exports(t){Ap=t}};Ti({target:"Reflect",stat:!0},{ownKeys:Rc});var Rp=it.Reflect.ownKeys;jp.exports=Rp;var Lp=e(Ap),Hp={};({get exports(){return Hp},set exports(t){Hp=t}}).exports=Lf;var Wp=e(Hp),qp={},Vp={get exports(){return qp},set exports(t){qp=t}},Up=vl.map;Ti({target:"Array",proto:!0,forced:!Mu("map")},{map:function(t){return Up(this,t,arguments.length>1?arguments[1]:void 0)}});var Yp=jo("Array").map,Xp=ht,Gp=Yp,Kp=Array.prototype,$p=function(t){var e=t.map;return t===Kp||Xp(Kp,t)&&e===Kp.map?Gp:e},Zp=$p;Vp.exports=Zp;var Qp=e(qp),Jp={},tv={get exports(){return Jp},set exports(t){Jp=t}},ev=Kt,iv=io;Ti({target:"Object",stat:!0,forced:s((function(){iv(1)}))},{keys:function(t){return iv(ev(t))}});var ov=it.Object.keys;tv.exports=ov;var nv=e(Jp),rv={},sv={get exports(){return rv},set exports(t){rv=t}},av=Ti,hv=Date,lv=y(hv.prototype.getTime);av({target:"Date",stat:!0},{now:function(){return lv(new hv)}});var dv=it.Date.now;sv.exports=dv;var cv=e(rv),uv={},fv={get exports(){return uv},set exports(t){uv=t}},pv=s,vv=function(t,e){var i=[][t];return!!i&&pv((function(){i.call(null,e||function(){return 1},1)}))},gv=vl.forEach,yv=vv("forEach")?[].forEach:function(t){return gv(this,t,arguments.length>1?arguments[1]:void 0)};Ti({target:"Array",proto:!0,forced:[].forEach!=yv},{forEach:yv});var mv=jo("Array").forEach,bv=vn,wv=Qt,xv=ht,kv=mv,_v=Array.prototype,Ev={DOMTokenList:!0,NodeList:!0},Ov=function(t){var e=t.forEach;return t===_v||xv(_v,t)&&e===_v.forEach||wv(Ev,bv(t))?kv:e};fv.exports=Ov;var Cv=e(uv),Sv={},Tv={get exports(){return Sv},set exports(t){Sv=t}},Mv=Ti,Pv=tl,Dv=y([].reverse),Iv=[1,2];Mv({target:"Array",proto:!0,forced:String(Iv)===String(Iv.reverse())},{reverse:function(){return Pv(this)&&(this.length=this.length),Dv(this)}});var Bv=jo("Array").reverse,Nv=ht,zv=Bv,Fv=Array.prototype,Av=function(t){var e=t.reverse;return t===Fv||Nv(Fv,t)&&e===Fv.reverse?zv:e},jv=Av;Tv.exports=jv;var Rv=e(Sv),Lv={},Hv={get exports(){return Lv},set exports(t){Lv=t}},Wv=P,qv=tl,Vv=TypeError,Uv=Object.getOwnPropertyDescriptor,Yv=Wv&&!function(){if(void 0!==this)return!0;try{Object.defineProperty([],"length",{writable:!1}).length=1}catch(t){return t instanceof TypeError}}(),Xv=St,Gv=TypeError,Kv=function(t,e){if(!delete t[e])throw Gv("Cannot delete property "+Xv(e)+" of "+Xv(t))},$v=Ti,Zv=Kt,Qv=Fi,Jv=Ii,tg=Li,eg=Yv?function(t,e){if(qv(t)&&!Uv(t,"length").writable)throw Vv("Cannot set read only .length");return t.length=e}:function(t,e){return t.length=e},ig=Ou,og=al,ng=ba,rg=Kv,sg=Mu("splice"),ag=Math.max,hg=Math.min;$v({target:"Array",proto:!0,forced:!sg},{splice:function(t,e){var i,o,n,r,s,a,h=Zv(this),l=tg(h),d=Qv(t,l),c=arguments.length;for(0===c?i=o=0:1===c?(i=0,o=l-d):(i=c-2,o=hg(ag(Jv(e),0),l-d)),ig(l+i-o),n=og(h,o),r=0;r<o;r++)(s=d+r)in h&&ng(n,r,h[s]);if(n.length=o,i<o){for(r=d;r<l-o;r++)a=r+i,(s=r+o)in h?h[a]=h[s]:rg(h,a);for(r=l;r>l-o+i;r--)rg(h,r-1)}else if(i>o)for(r=l-o;r>d;r--)a=r+i-1,(s=r+o-1)in h?h[a]=h[s]:rg(h,a);for(r=0;r<i;r++)h[r+d]=arguments[r+2];return eg(h,l-o+i),n}});var lg=jo("Array").splice,dg=ht,cg=lg,ug=Array.prototype,fg=function(t){var e=t.splice;return t===ug||dg(ug,t)&&e===ug.splice?cg:e},pg=fg;Hv.exports=pg;var vg=e(Lv),gg={},yg={get exports(){return gg},set exports(t){gg=t}},mg=Ui.includes;Ti({target:"Array",proto:!0,forced:s((function(){return!Array(1).includes()}))},{includes:function(t){return mg(this,t,arguments.length>1?arguments[1]:void 0)}});var bg=jo("Array").includes,wg=et,xg=x,kg=ue("match"),_g=function(t){var e;return wg(t)&&(void 0!==(e=t[kg])?!!e:"RegExp"==xg(t))},Eg=TypeError,Og=ue("match"),Cg=Ti,Sg=function(t){if(_g(t))throw Eg("The method doesn't accept regular expressions");return t},Tg=K,Mg=mn,Pg=function(t){var e=/./;try{"/./"[t](e)}catch(i){try{return e[Og]=!1,"/./"[t](e)}catch(t){}}return!1},Dg=y("".indexOf);Cg({target:"String",proto:!0,forced:!Pg("includes")},{includes:function(t){return!!~Dg(Mg(Tg(this)),Mg(Sg(t)),arguments.length>1?arguments[1]:void 0)}});var Ig=jo("String").includes,Bg=ht,Ng=bg,zg=Ig,Fg=Array.prototype,Ag=String.prototype,jg=function(t){var e=t.includes;return t===Fg||Bg(Fg,t)&&e===Fg.includes?Ng:"string"==typeof t||t===Ag||Bg(Ag,t)&&e===Ag.includes?zg:e},Rg=jg;yg.exports=Rg;var Lg=e(gg),Hg={},Wg={get exports(){return Hg},set exports(t){Hg=t}},qg=Kt,Vg=Nr,Ug=Cr;Ti({target:"Object",stat:!0,forced:s((function(){Vg(1)})),sham:!Ug},{getPrototypeOf:function(t){return Vg(qg(t))}});var Yg=it.Object.getPrototypeOf;Wg.exports=Yg;var Xg=e(Hg),Gg={},Kg={get exports(){return Gg},set exports(t){Gg=t}},$g=vl.filter;Ti({target:"Array",proto:!0,forced:!Mu("filter")},{filter:function(t){return $g(this,t,arguments.length>1?arguments[1]:void 0)}});var Zg=jo("Array").filter,Qg=ht,Jg=Zg,ty=Array.prototype,ey=function(t){var e=t.filter;return t===ty||Qg(ty,t)&&e===ty.filter?Jg:e},iy=ey;Kg.exports=iy;var oy=e(Gg),ny={},ry={get exports(){return ny},set exports(t){ny=t}},sy=P,ay=y,hy=io,ly=Q,dy=ay(N.f),cy=ay([].push),uy=function(t){return function(e){for(var i,o=ly(e),n=hy(o),r=n.length,s=0,a=[];r>s;)i=n[s++],sy&&!dy(o,i)||cy(a,t?[i,o[i]]:o[i]);return a}},fy={entries:uy(!0),values:uy(!1)}.values;Ti({target:"Object",stat:!0},{values:function(t){return fy(t)}});var py=it.Object.values;ry.exports=py;var vy=e(ny),gy={},yy={get exports(){return gy},set exports(t){gy=t}},my="\t\n\v\f\r                　\u2028\u2029\ufeff",by=K,wy=mn,xy=my,ky=y("".replace),_y=RegExp("^["+xy+"]+"),Ey=RegExp("(^|[^"+xy+"])["+xy+"]+$"),Oy=function(t){return function(e){var i=wy(by(e));return 1&t&&(i=ky(i,_y,"")),2&t&&(i=ky(i,Ey,"$1")),i}},Cy={start:Oy(1),end:Oy(2),trim:Oy(3)},Sy=r,Ty=s,My=y,Py=mn,Dy=Cy.trim,Iy=my,By=Sy.parseInt,Ny=Sy.Symbol,zy=Ny&&Ny.iterator,Fy=/^[+-]?0x/i,Ay=My(Fy.exec),jy=8!==By(Iy+"08")||22!==By(Iy+"0x16")||zy&&!Ty((function(){By(Object(zy))}))?function(t,e){var i=Dy(Py(t));return By(i,e>>>0||(Ay(Fy,i)?16:10))}:By;Ti({global:!0,forced:parseInt!=jy},{parseInt:jy});var Ry=it.parseInt;yy.exports=Ry;var Ly=e(gy),Hy={},Wy={get exports(){return Hy},set exports(t){Hy=t}},qy=Ti,Vy=Ui.indexOf,Uy=vv,Yy=E([].indexOf),Xy=!!Yy&&1/Yy([1],1,-0)<0;qy({target:"Array",proto:!0,forced:Xy||!Uy("indexOf")},{indexOf:function(t){var e=arguments.length>1?arguments[1]:void 0;return Xy?Yy(this,t,e)||0:Vy(this,t,e)}});var Gy=jo("Array").indexOf,Ky=ht,$y=Gy,Zy=Array.prototype,Qy=function(t){var e=t.indexOf;return t===Zy||Ky(Zy,t)&&e===Zy.indexOf?$y:e},Jy=Qy;Wy.exports=Jy;var tm=e(Hy),em={},im={get exports(){return em},set exports(t){em=t}},om=Jn.PROPER,nm=s,rm=my,sm=Cy.trim;Ti({target:"String",proto:!0,forced:function(t){return nm((function(){return!!rm[t]()||"​᠎"!=="​᠎"[t]()||om&&rm[t].name!==t}))}("trim")},{trim:function(){return sm(this)}});var am=jo("String").trim,hm=ht,lm=am,dm=String.prototype,cm=function(t){var e=t.trim;return"string"==typeof t||t===dm||hm(dm,t)&&e===dm.trim?lm:e},um=cm;im.exports=um;var fm=e(em),pm={},vm={get exports(){return pm},set exports(t){pm=t}};Ti({target:"Object",stat:!0,sham:!P},{create:Or});var gm=it.Object,ym=function(t,e){return gm.create(t,e)};vm.exports=ym;var mm=e(pm),bm={},wm={get exports(){return bm},set exports(t){bm=t}},xm=it,km=u;xm.JSON||(xm.JSON={stringify:JSON.stringify});var _m=function(t,e,i){return km(xm.JSON.stringify,null,arguments)};wm.exports=_m;var Em=e(bm),Om={},Cm={get exports(){return Om},set exports(t){Om=t}},Sm="function"==typeof Bun&&Bun&&"string"==typeof Bun.version,Tm=TypeError,Mm=function(t,e){if(t<e)throw Tm("Not enough arguments");return t},Pm=r,Dm=u,Im=T,Bm=Sm,Nm=lt,zm=_o,Fm=Mm,Am=Pm.Function,jm=/MSIE .\./.test(Nm)||Bm&&function(){var t=Pm.Bun.version.split(".");return t.length<3||0==t[0]&&(t[1]<3||3==t[1]&&0==t[2])}(),Rm=function(t,e){var i=e?2:1;return jm?function(o,n){var r=Fm(arguments.length,1)>i,s=Im(o)?o:Am(o),a=r?zm(arguments,i):[],h=r?function(){Dm(s,this,a)}:s;return e?t(h,n):t(h)}:t},Lm=Ti,Hm=r,Wm=Rm(Hm.setInterval,!0);Lm({global:!0,bind:!0,forced:Hm.setInterval!==Wm},{setInterval:Wm});var qm=Ti,Vm=r,Um=Rm(Vm.setTimeout,!0);qm({global:!0,bind:!0,forced:Vm.setTimeout!==Um},{setTimeout:Um});var Ym=it.setTimeout;Cm.exports=Ym;var Xm=e(Om),Gm={},Km={get exports(){return Gm},set exports(t){Gm=t}},$m=Kt,Zm=Fi,Qm=Li,Jm=function(t){for(var e=$m(this),i=Qm(e),o=arguments.length,n=Zm(o>1?arguments[1]:void 0,i),r=o>2?arguments[2]:void 0,s=void 0===r?i:Zm(r,i);s>n;)e[n++]=t;return e};Ti({target:"Array",proto:!0},{fill:Jm});var tb=jo("Array").fill,eb=ht,ib=tb,ob=Array.prototype,nb=function(t){var e=t.fill;return t===ob||eb(ob,t)&&e===ob.fill?ib:e},rb=nb;Km.exports=rb;var sb,ab=e(Gm);function hb(){return hb=Object.assign||function(t){for(var e=1;e<arguments.length;e++){var i=arguments[e];for(var o in i)Object.prototype.hasOwnProperty.call(i,o)&&(t[o]=i[o])}return t},hb.apply(this,arguments)}function lb(t,e){t.prototype=Object.create(e.prototype),t.prototype.constructor=t,t.__proto__=e}function db(t){if(void 0===t)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return t}sb="function"!=typeof Object.assign?function(t){if(null==t)throw new TypeError("Cannot convert undefined or null to object");for(var e=Object(t),i=1;i<arguments.length;i++){var o=arguments[i];if(null!=o)for(var n in o)o.hasOwnProperty(n)&&(e[n]=o[n])}return e}:Object.assign;var cb,ub=sb,fb=["","webkit","Moz","MS","ms","o"],pb="undefined"==typeof document?{style:{}}:document.createElement("div"),vb="function",gb=Math.round,yb=Math.abs,mb=Date.now;function bb(t,e){for(var i,o,n=e[0].toUpperCase()+e.slice(1),r=0;r<fb.length;){if((o=(i=fb[r])?i+n:e)in t)return o;r++}}cb="undefined"==typeof window?{}:window;var wb=bb(pb.style,"touchAction"),xb=void 0!==wb;var kb="compute",_b="auto",Eb="manipulation",Ob="none",Cb="pan-x",Sb="pan-y",Tb=function(){if(!xb)return!1;var t={},e=cb.CSS&&cb.CSS.supports;return["auto","manipulation","pan-y","pan-x","pan-x pan-y","none"].forEach((function(i){return t[i]=!e||cb.CSS.supports("touch-action",i)})),t}(),Mb="ontouchstart"in cb,Pb=void 0!==bb(cb,"PointerEvent"),Db=Mb&&/mobile|tablet|ip(ad|hone|od)|android/i.test(navigator.userAgent),Ib="touch",Bb="mouse",Nb=25,zb=1,Fb=2,Ab=4,jb=8,Rb=1,Lb=2,Hb=4,Wb=8,qb=16,Vb=Lb|Hb,Ub=Wb|qb,Yb=Vb|Ub,Xb=["x","y"],Gb=["clientX","clientY"];function Kb(t,e,i){var o;if(t)if(t.forEach)t.forEach(e,i);else if(void 0!==t.length)for(o=0;o<t.length;)e.call(i,t[o],o,t),o++;else for(o in t)t.hasOwnProperty(o)&&e.call(i,t[o],o,t)}function $b(t,e){return typeof t===vb?t.apply(e&&e[0]||void 0,e):t}function Zb(t,e){return t.indexOf(e)>-1}var Qb=function(){function t(t,e){this.manager=t,this.set(e)}var e=t.prototype;return e.set=function(t){t===kb&&(t=this.compute()),xb&&this.manager.element.style&&Tb[t]&&(this.manager.element.style[wb]=t),this.actions=t.toLowerCase().trim()},e.update=function(){this.set(this.manager.options.touchAction)},e.compute=function(){var t=[];return Kb(this.manager.recognizers,(function(e){$b(e.options.enable,[e])&&(t=t.concat(e.getTouchAction()))})),function(t){if(Zb(t,Ob))return Ob;var e=Zb(t,Cb),i=Zb(t,Sb);return e&&i?Ob:e||i?e?Cb:Sb:Zb(t,Eb)?Eb:_b}(t.join(" "))},e.preventDefaults=function(t){var e=t.srcEvent,i=t.offsetDirection;if(this.manager.session.prevented)e.preventDefault();else{var o=this.actions,n=Zb(o,Ob)&&!Tb[Ob],r=Zb(o,Sb)&&!Tb[Sb],s=Zb(o,Cb)&&!Tb[Cb];if(n){var a=1===t.pointers.length,h=t.distance<2,l=t.deltaTime<250;if(a&&h&&l)return}if(!s||!r)return n||r&&i&Vb||s&&i&Ub?this.preventSrc(e):void 0}},e.preventSrc=function(t){this.manager.session.prevented=!0,t.preventDefault()},t}();function Jb(t,e){for(;t;){if(t===e)return!0;t=t.parentNode}return!1}function tw(t){var e=t.length;if(1===e)return{x:gb(t[0].clientX),y:gb(t[0].clientY)};for(var i=0,o=0,n=0;n<e;)i+=t[n].clientX,o+=t[n].clientY,n++;return{x:gb(i/e),y:gb(o/e)}}function ew(t){for(var e=[],i=0;i<t.pointers.length;)e[i]={clientX:gb(t.pointers[i].clientX),clientY:gb(t.pointers[i].clientY)},i++;return{timeStamp:mb(),pointers:e,center:tw(e),deltaX:t.deltaX,deltaY:t.deltaY}}function iw(t,e,i){i||(i=Xb);var o=e[i[0]]-t[i[0]],n=e[i[1]]-t[i[1]];return Math.sqrt(o*o+n*n)}function ow(t,e,i){i||(i=Xb);var o=e[i[0]]-t[i[0]],n=e[i[1]]-t[i[1]];return 180*Math.atan2(n,o)/Math.PI}function nw(t,e){return t===e?Rb:yb(t)>=yb(e)?t<0?Lb:Hb:e<0?Wb:qb}function rw(t,e,i){return{x:e/t||0,y:i/t||0}}function sw(t,e){var i=t.session,o=e.pointers,n=o.length;i.firstInput||(i.firstInput=ew(e)),n>1&&!i.firstMultiple?i.firstMultiple=ew(e):1===n&&(i.firstMultiple=!1);var r=i.firstInput,s=i.firstMultiple,a=s?s.center:r.center,h=e.center=tw(o);e.timeStamp=mb(),e.deltaTime=e.timeStamp-r.timeStamp,e.angle=ow(a,h),e.distance=iw(a,h),function(t,e){var i=e.center,o=t.offsetDelta||{},n=t.prevDelta||{},r=t.prevInput||{};e.eventType!==zb&&r.eventType!==Ab||(n=t.prevDelta={x:r.deltaX||0,y:r.deltaY||0},o=t.offsetDelta={x:i.x,y:i.y}),e.deltaX=n.x+(i.x-o.x),e.deltaY=n.y+(i.y-o.y)}(i,e),e.offsetDirection=nw(e.deltaX,e.deltaY);var l,d,c=rw(e.deltaTime,e.deltaX,e.deltaY);e.overallVelocityX=c.x,e.overallVelocityY=c.y,e.overallVelocity=yb(c.x)>yb(c.y)?c.x:c.y,e.scale=s?(l=s.pointers,iw((d=o)[0],d[1],Gb)/iw(l[0],l[1],Gb)):1,e.rotation=s?function(t,e){return ow(e[1],e[0],Gb)+ow(t[1],t[0],Gb)}(s.pointers,o):0,e.maxPointers=i.prevInput?e.pointers.length>i.prevInput.maxPointers?e.pointers.length:i.prevInput.maxPointers:e.pointers.length,function(t,e){var i,o,n,r,s=t.lastInterval||e,a=e.timeStamp-s.timeStamp;if(e.eventType!==jb&&(a>Nb||void 0===s.velocity)){var h=e.deltaX-s.deltaX,l=e.deltaY-s.deltaY,d=rw(a,h,l);o=d.x,n=d.y,i=yb(d.x)>yb(d.y)?d.x:d.y,r=nw(h,l),t.lastInterval=e}else i=s.velocity,o=s.velocityX,n=s.velocityY,r=s.direction;e.velocity=i,e.velocityX=o,e.velocityY=n,e.direction=r}(i,e);var u,f=t.element,p=e.srcEvent;Jb(u=p.composedPath?p.composedPath()[0]:p.path?p.path[0]:p.target,f)&&(f=u),e.target=f}function aw(t,e,i){var o=i.pointers.length,n=i.changedPointers.length,r=e&zb&&o-n==0,s=e&(Ab|jb)&&o-n==0;i.isFirst=!!r,i.isFinal=!!s,r&&(t.session={}),i.eventType=e,sw(t,i),t.emit("hammer.input",i),t.recognize(i),t.session.prevInput=i}function hw(t){return t.trim().split(/\s+/g)}function lw(t,e,i){Kb(hw(e),(function(e){t.addEventListener(e,i,!1)}))}function dw(t,e,i){Kb(hw(e),(function(e){t.removeEventListener(e,i,!1)}))}function cw(t){var e=t.ownerDocument||t;return e.defaultView||e.parentWindow||window}var uw=function(){function t(t,e){var i=this;this.manager=t,this.callback=e,this.element=t.element,this.target=t.options.inputTarget,this.domHandler=function(e){$b(t.options.enable,[t])&&i.handler(e)},this.init()}var e=t.prototype;return e.handler=function(){},e.init=function(){this.evEl&&lw(this.element,this.evEl,this.domHandler),this.evTarget&&lw(this.target,this.evTarget,this.domHandler),this.evWin&&lw(cw(this.element),this.evWin,this.domHandler)},e.destroy=function(){this.evEl&&dw(this.element,this.evEl,this.domHandler),this.evTarget&&dw(this.target,this.evTarget,this.domHandler),this.evWin&&dw(cw(this.element),this.evWin,this.domHandler)},t}();function fw(t,e,i){if(t.indexOf&&!i)return t.indexOf(e);for(var o=0;o<t.length;){if(i&&t[o][i]==e||!i&&t[o]===e)return o;o++}return-1}var pw={pointerdown:zb,pointermove:Fb,pointerup:Ab,pointercancel:jb,pointerout:jb},vw={2:Ib,3:"pen",4:Bb,5:"kinect"},gw="pointerdown",yw="pointermove pointerup pointercancel";cb.MSPointerEvent&&!cb.PointerEvent&&(gw="MSPointerDown",yw="MSPointerMove MSPointerUp MSPointerCancel");var mw=function(t){function e(){var i,o=e.prototype;return o.evEl=gw,o.evWin=yw,(i=t.apply(this,arguments)||this).store=i.manager.session.pointerEvents=[],i}return lb(e,t),e.prototype.handler=function(t){var e=this.store,i=!1,o=t.type.toLowerCase().replace("ms",""),n=pw[o],r=vw[t.pointerType]||t.pointerType,s=r===Ib,a=fw(e,t.pointerId,"pointerId");n&zb&&(0===t.button||s)?a<0&&(e.push(t),a=e.length-1):n&(Ab|jb)&&(i=!0),a<0||(e[a]=t,this.callback(this.manager,n,{pointers:e,changedPointers:[t],pointerType:r,srcEvent:t}),i&&e.splice(a,1))},e}(uw);function bw(t){return Array.prototype.slice.call(t,0)}function ww(t,e,i){for(var o=[],n=[],r=0;r<t.length;){var s=e?t[r][e]:t[r];fw(n,s)<0&&o.push(t[r]),n[r]=s,r++}return i&&(o=e?o.sort((function(t,i){return t[e]>i[e]})):o.sort()),o}var xw={touchstart:zb,touchmove:Fb,touchend:Ab,touchcancel:jb},kw="touchstart touchmove touchend touchcancel",_w=function(t){function e(){var i;return e.prototype.evTarget=kw,(i=t.apply(this,arguments)||this).targetIds={},i}return lb(e,t),e.prototype.handler=function(t){var e=xw[t.type],i=Ew.call(this,t,e);i&&this.callback(this.manager,e,{pointers:i[0],changedPointers:i[1],pointerType:Ib,srcEvent:t})},e}(uw);function Ew(t,e){var i,o,n=bw(t.touches),r=this.targetIds;if(e&(zb|Fb)&&1===n.length)return r[n[0].identifier]=!0,[n,n];var s=bw(t.changedTouches),a=[],h=this.target;if(o=n.filter((function(t){return Jb(t.target,h)})),e===zb)for(i=0;i<o.length;)r[o[i].identifier]=!0,i++;for(i=0;i<s.length;)r[s[i].identifier]&&a.push(s[i]),e&(Ab|jb)&&delete r[s[i].identifier],i++;return a.length?[ww(o.concat(a),"identifier",!0),a]:void 0}var Ow={mousedown:zb,mousemove:Fb,mouseup:Ab},Cw="mousedown",Sw="mousemove mouseup",Tw=function(t){function e(){var i,o=e.prototype;return o.evEl=Cw,o.evWin=Sw,(i=t.apply(this,arguments)||this).pressed=!1,i}return lb(e,t),e.prototype.handler=function(t){var e=Ow[t.type];e&zb&&0===t.button&&(this.pressed=!0),e&Fb&&1!==t.which&&(e=Ab),this.pressed&&(e&Ab&&(this.pressed=!1),this.callback(this.manager,e,{pointers:[t],changedPointers:[t],pointerType:Bb,srcEvent:t}))},e}(uw),Mw=2500,Pw=25;function Dw(t){var e=t.changedPointers[0];if(e.identifier===this.primaryTouch){var i={x:e.clientX,y:e.clientY},o=this.lastTouches;this.lastTouches.push(i);setTimeout((function(){var t=o.indexOf(i);t>-1&&o.splice(t,1)}),Mw)}}function Iw(t,e){t&zb?(this.primaryTouch=e.changedPointers[0].identifier,Dw.call(this,e)):t&(Ab|jb)&&Dw.call(this,e)}function Bw(t){for(var e=t.srcEvent.clientX,i=t.srcEvent.clientY,o=0;o<this.lastTouches.length;o++){var n=this.lastTouches[o],r=Math.abs(e-n.x),s=Math.abs(i-n.y);if(r<=Pw&&s<=Pw)return!0}return!1}var Nw=function(){return function(t){function e(e,i){var o;return(o=t.call(this,e,i)||this).handler=function(t,e,i){var n=i.pointerType===Ib,r=i.pointerType===Bb;if(!(r&&i.sourceCapabilities&&i.sourceCapabilities.firesTouchEvents)){if(n)Iw.call(db(db(o)),e,i);else if(r&&Bw.call(db(db(o)),i))return;o.callback(t,e,i)}},o.touch=new _w(o.manager,o.handler),o.mouse=new Tw(o.manager,o.handler),o.primaryTouch=null,o.lastTouches=[],o}return lb(e,t),e.prototype.destroy=function(){this.touch.destroy(),this.mouse.destroy()},e}(uw)}();function zw(t,e,i){return!!Array.isArray(t)&&(Kb(t,i[e],i),!0)}var Fw=1,Aw=2,jw=4,Rw=8,Lw=Rw,Hw=16,Ww=32,qw=1;function Vw(t,e){var i=e.manager;return i?i.get(t):t}function Uw(t){return t&Hw?"cancel":t&Rw?"end":t&jw?"move":t&Aw?"start":""}var Yw=function(){function t(t){void 0===t&&(t={}),this.options=hb({enable:!0},t),this.id=qw++,this.manager=null,this.state=Fw,this.simultaneous={},this.requireFail=[]}var e=t.prototype;return e.set=function(t){return ub(this.options,t),this.manager&&this.manager.touchAction.update(),this},e.recognizeWith=function(t){if(zw(t,"recognizeWith",this))return this;var e=this.simultaneous;return e[(t=Vw(t,this)).id]||(e[t.id]=t,t.recognizeWith(this)),this},e.dropRecognizeWith=function(t){return zw(t,"dropRecognizeWith",this)||(t=Vw(t,this),delete this.simultaneous[t.id]),this},e.requireFailure=function(t){if(zw(t,"requireFailure",this))return this;var e=this.requireFail;return-1===fw(e,t=Vw(t,this))&&(e.push(t),t.requireFailure(this)),this},e.dropRequireFailure=function(t){if(zw(t,"dropRequireFailure",this))return this;t=Vw(t,this);var e=fw(this.requireFail,t);return e>-1&&this.requireFail.splice(e,1),this},e.hasRequireFailures=function(){return this.requireFail.length>0},e.canRecognizeWith=function(t){return!!this.simultaneous[t.id]},e.emit=function(t){var e=this,i=this.state;function o(i){e.manager.emit(i,t)}i<Rw&&o(e.options.event+Uw(i)),o(e.options.event),t.additionalEvent&&o(t.additionalEvent),i>=Rw&&o(e.options.event+Uw(i))},e.tryEmit=function(t){if(this.canEmit())return this.emit(t);this.state=Ww},e.canEmit=function(){for(var t=0;t<this.requireFail.length;){if(!(this.requireFail[t].state&(Ww|Fw)))return!1;t++}return!0},e.recognize=function(t){var e=ub({},t);if(!$b(this.options.enable,[this,e]))return this.reset(),void(this.state=Ww);this.state&(Lw|Hw|Ww)&&(this.state=Fw),this.state=this.process(e),this.state&(Aw|jw|Rw|Hw)&&this.tryEmit(e)},e.process=function(t){},e.getTouchAction=function(){},e.reset=function(){},t}(),Xw=function(t){function e(e){var i;return void 0===e&&(e={}),(i=t.call(this,hb({event:"tap",pointers:1,taps:1,interval:300,time:250,threshold:9,posThreshold:10},e))||this).pTime=!1,i.pCenter=!1,i._timer=null,i._input=null,i.count=0,i}lb(e,t);var i=e.prototype;return i.getTouchAction=function(){return[Eb]},i.process=function(t){var e=this,i=this.options,o=t.pointers.length===i.pointers,n=t.distance<i.threshold,r=t.deltaTime<i.time;if(this.reset(),t.eventType&zb&&0===this.count)return this.failTimeout();if(n&&r&&o){if(t.eventType!==Ab)return this.failTimeout();var s=!this.pTime||t.timeStamp-this.pTime<i.interval,a=!this.pCenter||iw(this.pCenter,t.center)<i.posThreshold;if(this.pTime=t.timeStamp,this.pCenter=t.center,a&&s?this.count+=1:this.count=1,this._input=t,0===this.count%i.taps)return this.hasRequireFailures()?(this._timer=setTimeout((function(){e.state=Lw,e.tryEmit()}),i.interval),Aw):Lw}return Ww},i.failTimeout=function(){var t=this;return this._timer=setTimeout((function(){t.state=Ww}),this.options.interval),Ww},i.reset=function(){clearTimeout(this._timer)},i.emit=function(){this.state===Lw&&(this._input.tapCount=this.count,this.manager.emit(this.options.event,this._input))},e}(Yw),Gw=function(t){function e(e){return void 0===e&&(e={}),t.call(this,hb({pointers:1},e))||this}lb(e,t);var i=e.prototype;return i.attrTest=function(t){var e=this.options.pointers;return 0===e||t.pointers.length===e},i.process=function(t){var e=this.state,i=t.eventType,o=e&(Aw|jw),n=this.attrTest(t);return o&&(i&jb||!n)?e|Hw:o||n?i&Ab?e|Rw:e&Aw?e|jw:Aw:Ww},e}(Yw);function Kw(t){return t===qb?"down":t===Wb?"up":t===Lb?"left":t===Hb?"right":""}var $w=function(t){function e(e){var i;return void 0===e&&(e={}),(i=t.call(this,hb({event:"pan",threshold:10,pointers:1,direction:Yb},e))||this).pX=null,i.pY=null,i}lb(e,t);var i=e.prototype;return i.getTouchAction=function(){var t=this.options.direction,e=[];return t&Vb&&e.push(Sb),t&Ub&&e.push(Cb),e},i.directionTest=function(t){var e=this.options,i=!0,o=t.distance,n=t.direction,r=t.deltaX,s=t.deltaY;return n&e.direction||(e.direction&Vb?(n=0===r?Rb:r<0?Lb:Hb,i=r!==this.pX,o=Math.abs(t.deltaX)):(n=0===s?Rb:s<0?Wb:qb,i=s!==this.pY,o=Math.abs(t.deltaY))),t.direction=n,i&&o>e.threshold&&n&e.direction},i.attrTest=function(t){return Gw.prototype.attrTest.call(this,t)&&(this.state&Aw||!(this.state&Aw)&&this.directionTest(t))},i.emit=function(e){this.pX=e.deltaX,this.pY=e.deltaY;var i=Kw(e.direction);i&&(e.additionalEvent=this.options.event+i),t.prototype.emit.call(this,e)},e}(Gw),Zw=function(t){function e(e){return void 0===e&&(e={}),t.call(this,hb({event:"swipe",threshold:10,velocity:.3,direction:Vb|Ub,pointers:1},e))||this}lb(e,t);var i=e.prototype;return i.getTouchAction=function(){return $w.prototype.getTouchAction.call(this)},i.attrTest=function(e){var i,o=this.options.direction;return o&(Vb|Ub)?i=e.overallVelocity:o&Vb?i=e.overallVelocityX:o&Ub&&(i=e.overallVelocityY),t.prototype.attrTest.call(this,e)&&o&e.offsetDirection&&e.distance>this.options.threshold&&e.maxPointers===this.options.pointers&&yb(i)>this.options.velocity&&e.eventType&Ab},i.emit=function(t){var e=Kw(t.offsetDirection);e&&this.manager.emit(this.options.event+e,t),this.manager.emit(this.options.event,t)},e}(Gw),Qw=function(t){function e(e){return void 0===e&&(e={}),t.call(this,hb({event:"pinch",threshold:0,pointers:2},e))||this}lb(e,t);var i=e.prototype;return i.getTouchAction=function(){return[Ob]},i.attrTest=function(e){return t.prototype.attrTest.call(this,e)&&(Math.abs(e.scale-1)>this.options.threshold||this.state&Aw)},i.emit=function(e){if(1!==e.scale){var i=e.scale<1?"in":"out";e.additionalEvent=this.options.event+i}t.prototype.emit.call(this,e)},e}(Gw),Jw=function(t){function e(e){return void 0===e&&(e={}),t.call(this,hb({event:"rotate",threshold:0,pointers:2},e))||this}lb(e,t);var i=e.prototype;return i.getTouchAction=function(){return[Ob]},i.attrTest=function(e){return t.prototype.attrTest.call(this,e)&&(Math.abs(e.rotation)>this.options.threshold||this.state&Aw)},e}(Gw),tx=function(t){function e(e){var i;return void 0===e&&(e={}),(i=t.call(this,hb({event:"press",pointers:1,time:251,threshold:9},e))||this)._timer=null,i._input=null,i}lb(e,t);var i=e.prototype;return i.getTouchAction=function(){return[_b]},i.process=function(t){var e=this,i=this.options,o=t.pointers.length===i.pointers,n=t.distance<i.threshold,r=t.deltaTime>i.time;if(this._input=t,!n||!o||t.eventType&(Ab|jb)&&!r)this.reset();else if(t.eventType&zb)this.reset(),this._timer=setTimeout((function(){e.state=Lw,e.tryEmit()}),i.time);else if(t.eventType&Ab)return Lw;return Ww},i.reset=function(){clearTimeout(this._timer)},i.emit=function(t){this.state===Lw&&(t&&t.eventType&Ab?this.manager.emit(this.options.event+"up",t):(this._input.timeStamp=mb(),this.manager.emit(this.options.event,this._input)))},e}(Yw),ex={domEvents:!1,touchAction:kb,enable:!0,inputTarget:null,inputClass:null,cssProps:{userSelect:"none",touchSelect:"none",touchCallout:"none",contentZooming:"none",userDrag:"none",tapHighlightColor:"rgba(0,0,0,0)"}},ix=[[Jw,{enable:!1}],[Qw,{enable:!1},["rotate"]],[Zw,{direction:Vb}],[$w,{direction:Vb},["swipe"]],[Xw],[Xw,{event:"doubletap",taps:2},["tap"]],[tx]];function ox(t,e){var i,o=t.element;o.style&&(Kb(t.options.cssProps,(function(n,r){i=bb(o.style,r),e?(t.oldCssProps[i]=o.style[i],o.style[i]=n):o.style[i]=t.oldCssProps[i]||""})),e||(t.oldCssProps={}))}var nx=function(){function t(t,e){var i,o=this;this.options=ub({},ex,e||{}),this.options.inputTarget=this.options.inputTarget||t,this.handlers={},this.session={},this.recognizers=[],this.oldCssProps={},this.element=t,this.input=new((i=this).options.inputClass||(Pb?mw:Db?_w:Mb?Nw:Tw))(i,aw),this.touchAction=new Qb(this,this.options.touchAction),ox(this,!0),Kb(this.options.recognizers,(function(t){var e=o.add(new t[0](t[1]));t[2]&&e.recognizeWith(t[2]),t[3]&&e.requireFailure(t[3])}),this)}var e=t.prototype;return e.set=function(t){return ub(this.options,t),t.touchAction&&this.touchAction.update(),t.inputTarget&&(this.input.destroy(),this.input.target=t.inputTarget,this.input.init()),this},e.stop=function(t){this.session.stopped=t?2:1},e.recognize=function(t){var e=this.session;if(!e.stopped){var i;this.touchAction.preventDefaults(t);var o=this.recognizers,n=e.curRecognizer;(!n||n&&n.state&Lw)&&(e.curRecognizer=null,n=null);for(var r=0;r<o.length;)i=o[r],2===e.stopped||n&&i!==n&&!i.canRecognizeWith(n)?i.reset():i.recognize(t),!n&&i.state&(Aw|jw|Rw)&&(e.curRecognizer=i,n=i),r++}},e.get=function(t){if(t instanceof Yw)return t;for(var e=this.recognizers,i=0;i<e.length;i++)if(e[i].options.event===t)return e[i];return null},e.add=function(t){if(zw(t,"add",this))return this;var e=this.get(t.options.event);return e&&this.remove(e),this.recognizers.push(t),t.manager=this,this.touchAction.update(),t},e.remove=function(t){if(zw(t,"remove",this))return this;var e=this.get(t);if(t){var i=this.recognizers,o=fw(i,e);-1!==o&&(i.splice(o,1),this.touchAction.update())}return this},e.on=function(t,e){if(void 0===t||void 0===e)return this;var i=this.handlers;return Kb(hw(t),(function(t){i[t]=i[t]||[],i[t].push(e)})),this},e.off=function(t,e){if(void 0===t)return this;var i=this.handlers;return Kb(hw(t),(function(t){e?i[t]&&i[t].splice(fw(i[t],e),1):delete i[t]})),this},e.emit=function(t,e){this.options.domEvents&&function(t,e){var i=document.createEvent("Event");i.initEvent(t,!0,!0),i.gesture=e,e.target.dispatchEvent(i)}(t,e);var i=this.handlers[t]&&this.handlers[t].slice();if(i&&i.length){e.type=t,e.preventDefault=function(){e.srcEvent.preventDefault()};for(var o=0;o<i.length;)i[o](e),o++}},e.destroy=function(){this.element&&ox(this,!1),this.handlers={},this.session={},this.input.destroy(),this.element=null},t}(),rx={touchstart:zb,touchmove:Fb,touchend:Ab,touchcancel:jb},sx="touchstart",ax="touchstart touchmove touchend touchcancel",hx=function(t){function e(){var i,o=e.prototype;return o.evTarget=sx,o.evWin=ax,(i=t.apply(this,arguments)||this).started=!1,i}return lb(e,t),e.prototype.handler=function(t){var e=rx[t.type];if(e===zb&&(this.started=!0),this.started){var i=lx.call(this,t,e);e&(Ab|jb)&&i[0].length-i[1].length==0&&(this.started=!1),this.callback(this.manager,e,{pointers:i[0],changedPointers:i[1],pointerType:Ib,srcEvent:t})}},e}(uw);function lx(t,e){var i=bw(t.touches),o=bw(t.changedTouches);return e&(Ab|jb)&&(i=ww(i.concat(o),"identifier",!0)),[i,o]}function dx(t,e,i){var o="DEPRECATED METHOD: "+e+"\n"+i+" AT \n";return function(){var e=new Error("get-stack-trace"),i=e&&e.stack?e.stack.replace(/^[^\(]+?[\n$]/gm,"").replace(/^\s+at\s+/gm,"").replace(/^Object.<anonymous>\s*\(/gm,"{anonymous}()@"):"Unknown Stack Trace",n=window.console&&(window.console.warn||window.console.log);return n&&n.call(window.console,o,i),t.apply(this,arguments)}}var cx=dx((function(t,e,i){for(var o=Object.keys(e),n=0;n<o.length;)(!i||i&&void 0===t[o[n]])&&(t[o[n]]=e[o[n]]),n++;return t}),"extend","Use `assign`."),ux=dx((function(t,e){return cx(t,e,!0)}),"merge","Use `assign`.");function fx(t,e,i){var o,n=e.prototype;(o=t.prototype=Object.create(n)).constructor=t,o._super=n,i&&ub(o,i)}function px(t,e){return function(){return t.apply(e,arguments)}}var vx=function(){var t=function(t,e){return void 0===e&&(e={}),new nx(t,hb({recognizers:ix.concat()},e))};return t.VERSION="2.0.17-rc",t.DIRECTION_ALL=Yb,t.DIRECTION_DOWN=qb,t.DIRECTION_LEFT=Lb,t.DIRECTION_RIGHT=Hb,t.DIRECTION_UP=Wb,t.DIRECTION_HORIZONTAL=Vb,t.DIRECTION_VERTICAL=Ub,t.DIRECTION_NONE=Rb,t.DIRECTION_DOWN=qb,t.INPUT_START=zb,t.INPUT_MOVE=Fb,t.INPUT_END=Ab,t.INPUT_CANCEL=jb,t.STATE_POSSIBLE=Fw,t.STATE_BEGAN=Aw,t.STATE_CHANGED=jw,t.STATE_ENDED=Rw,t.STATE_RECOGNIZED=Lw,t.STATE_CANCELLED=Hw,t.STATE_FAILED=Ww,t.Manager=nx,t.Input=uw,t.TouchAction=Qb,t.TouchInput=_w,t.MouseInput=Tw,t.PointerEventInput=mw,t.TouchMouseInput=Nw,t.SingleTouchInput=hx,t.Recognizer=Yw,t.AttrRecognizer=Gw,t.Tap=Xw,t.Pan=$w,t.Swipe=Zw,t.Pinch=Qw,t.Rotate=Jw,t.Press=tx,t.on=lw,t.off=dw,t.each=Kb,t.merge=ux,t.extend=cx,t.bindFn=px,t.assign=ub,t.inherit=fx,t.bindFn=px,t.prefixed=bb,t.toArray=bw,t.inArray=fw,t.uniqueArray=ww,t.splitStr=hw,t.boolOrFn=$b,t.hasParent=Jb,t.addEventListeners=lw,t.removeEventListeners=dw,t.defaults=ub({},ex,{preset:ix}),t}();vx.defaults;var gx=vx;function yx(t,e){var i=nv(t);if(mc){var o=mc(t);e&&(o=oy(o).call(o,(function(e){return Dc(t,e).enumerable}))),i.push.apply(i,o)}return i}function mx(t){for(var e=1;e<arguments.length;e++){var i,o,n=null!=arguments[e]?arguments[e]:{};e%2?Cv(i=yx(Object(n),!0)).call(i,(function(e){zf(t,e,n[e])})):Uc?iu(t,Uc(n)):Cv(o=yx(Object(n))).call(o,(function(e){fu(t,e,Dc(n,e))}))}return t}function bx(t,e){var i=void 0!==Op&&xh(t)||t["@@iterator"];if(!i){if(Wp(t)||(i=function(t,e){var i;if(!t)return;if("string"==typeof t)return wx(t,e);var o=Fp(i=Object.prototype.toString.call(t)).call(i,8,-1);"Object"===o&&t.constructor&&(o=t.constructor.name);if("Map"===o||"Set"===o)return Za(t);if("Arguments"===o||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(o))return wx(t,e)}(t))||e&&t&&"number"==typeof t.length){i&&(t=i);var o=0,n=function(){};return{s:n,n:function(){return o>=t.length?{done:!0}:{done:!1,value:t[o++]}},e:function(t){throw t},f:n}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var r,s=!0,a=!1;return{s:function(){i=i.call(t)},n:function(){var t=i.next();return s=t.done,t},e:function(t){a=!0,r=t},f:function(){try{s||null==i.return||i.return()}finally{if(a)throw r}}}}function wx(t,e){(null==e||e>t.length)&&(e=t.length);for(var i=0,o=new Array(e);i<e;i++)o[i]=t[i];return o}var xx=Op("DELETE");function kx(t){for(var e,i=arguments.length,o=new Array(i>1?i-1:0),n=1;n<i;n++)o[n-1]=arguments[n];return _x.apply(void 0,Np(e=[{},t]).call(e,o))}function _x(){var t=Ex.apply(void 0,arguments);return Cx(t),t}function Ex(){for(var t=arguments.length,e=new Array(t),i=0;i<t;i++)e[i]=arguments[i];if(e.length<2)return e[0];var o;if(e.length>2)return Ex.apply(void 0,Np(o=[_x(e[0],e[1])]).call(o,_p(Fp(e).call(e,2))));var n,r=e[0],s=e[1],a=bx(Lp(s));try{for(a.s();!(n=a.n()).done;){var h=n.value;Object.prototype.propertyIsEnumerable.call(s,h)&&(s[h]===xx?delete r[h]:null===r[h]||null===s[h]||"object"!==Of(r[h])||"object"!==Of(s[h])||Wp(r[h])||Wp(s[h])?r[h]=Ox(s[h]):r[h]=Ex(r[h],s[h]))}}catch(t){a.e(t)}finally{a.f()}return r}function Ox(t){return Wp(t)?Qp(t).call(t,(function(t){return Ox(t)})):"object"===Of(t)&&null!==t?Ex({},t):t}function Cx(t){for(var e=0,i=nv(t);e<i.length;e++){var o=i[e];t[o]===xx?delete t[o]:"object"===Of(t[o])&&null!==t[o]&&Cx(t[o])}}function Sx(){for(var t=arguments.length,e=new Array(t),i=0;i<t;i++)e[i]=arguments[i];return function(t){var e=function(){for(var t=function(){var t=4022871197;return function(e){for(var i=e.toString(),o=0;o<i.length;o++){var n=.02519603282416938*(t+=i.charCodeAt(o));n-=t=n>>>0,t=(n*=t)>>>0,t+=4294967296*(n-=t)}return 2.3283064365386963e-10*(t>>>0)}}(),e=t(" "),i=t(" "),o=t(" "),n=0;n<arguments.length;n++)(e-=t(n<0||arguments.length<=n?void 0:arguments[n]))<0&&(e+=1),(i-=t(n<0||arguments.length<=n?void 0:arguments[n]))<0&&(i+=1),(o-=t(n<0||arguments.length<=n?void 0:arguments[n]))<0&&(o+=1);return[e,i,o]}(t),i=kp(e,3),o=i[0],n=i[1],r=i[2],s=1,a=function(){var t=2091639*o+2.3283064365386963e-10*s;return o=n,n=r,r=t-(s=0|t)};return a.uint32=function(){return 4294967296*a()},a.fract53=function(){return a()+11102230246251565e-32*(2097152*a()|0)},a.algorithm="Alea",a.seed=t,a.version="0.9",a}(e.length?e:[cv()])}var Tx="undefined"!=typeof window?window.Hammer||gx:function(){return function(){var t=function(){};return{on:t,off:t,destroy:t,emit:t,get:function(){return{set:t}}}}()};function Mx(t){var e,i=this;this._cleanupQueue=[],this.active=!1,this._dom={container:t,overlay:document.createElement("div")},this._dom.overlay.classList.add("vis-overlay"),this._dom.container.appendChild(this._dom.overlay),this._cleanupQueue.push((function(){i._dom.overlay.parentNode.removeChild(i._dom.overlay)}));var o=Tx(this._dom.overlay);o.on("tap",Uo(e=this._onTapOverlay).call(e,this)),this._cleanupQueue.push((function(){o.destroy()}));var n=["tap","doubletap","press","pinch","pan","panstart","panmove","panend"];Cv(n).call(n,(function(t){o.on(t,(function(t){t.srcEvent.stopPropagation()}))})),document&&document.body&&(this._onClick=function(e){(function(t,e){for(;t;){if(t===e)return!0;t=t.parentNode}return!1})(e.target,t)||i.deactivate()},document.body.addEventListener("click",this._onClick),this._cleanupQueue.push((function(){document.body.removeEventListener("click",i._onClick)}))),this._escListener=function(t){("key"in t?"Escape"===t.key:27===t.keyCode)&&i.deactivate()}}tn(Mx.prototype),Mx.current=null,Mx.prototype.destroy=function(){var t,e;this.deactivate();var i,o=bx(Rv(t=vg(e=this._cleanupQueue).call(e,0)).call(t));try{for(o.s();!(i=o.n()).done;){(0,i.value)()}}catch(t){o.e(t)}finally{o.f()}},Mx.prototype.activate=function(){Mx.current&&Mx.current.deactivate(),Mx.current=this,this.active=!0,this._dom.overlay.style.display="none",this._dom.container.classList.add("vis-active"),this.emit("change"),this.emit("activate"),document.body.addEventListener("keydown",this._escListener)},Mx.prototype.deactivate=function(){this.active=!1,this._dom.overlay.style.display="block",this._dom.container.classList.remove("vis-active"),document.body.removeEventListener("keydown",this._escListener),this.emit("change"),this.emit("deactivate")},Mx.prototype._onTapOverlay=function(t){this.activate(),t.srcEvent.stopPropagation()};var Px=/^\/?Date\((-?\d+)/i,Dx=/^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i,Ix=/^#?([a-f\d])([a-f\d])([a-f\d])$/i,Bx=/^rgb\( *(1?\d{1,2}|2[0-4]\d|25[0-5]) *, *(1?\d{1,2}|2[0-4]\d|25[0-5]) *, *(1?\d{1,2}|2[0-4]\d|25[0-5]) *\)$/i,Nx=/^rgba\( *(1?\d{1,2}|2[0-4]\d|25[0-5]) *, *(1?\d{1,2}|2[0-4]\d|25[0-5]) *, *(1?\d{1,2}|2[0-4]\d|25[0-5]) *, *([01]|0?\.\d+) *\)$/i;function zx(t){return t instanceof Number||"number"==typeof t}function Fx(t){if(t)for(;!0===t.hasChildNodes();){var e=t.firstChild;e&&(Fx(e),t.removeChild(e))}}function Ax(t){return t instanceof String||"string"==typeof t}function jx(t){return"object"===Of(t)&&null!==t}function Rx(t,e,i,o){var n=!1;!0===o&&(n=null===e[i]&&void 0!==t[i]),n?delete t[i]:t[i]=e[i]}function Lx(t,e){var i=arguments.length>2&&void 0!==arguments[2]&&arguments[2];for(var o in t)if(void 0!==e[o])if(null===e[o]||"object"!==Of(e[o]))Rx(t,e,o,i);else{var n=t[o],r=e[o];jx(n)&&jx(r)&&Lx(n,r,i)}}var Hx=wo;function Wx(t,e,i){var o=arguments.length>3&&void 0!==arguments[3]&&arguments[3];if(Wp(i))throw new TypeError("Arrays are not supported by deepExtend");for(var n=0;n<t.length;n++){var r=t[n];if(Object.prototype.hasOwnProperty.call(i,r))if(i[r]&&i[r].constructor===Object)void 0===e[r]&&(e[r]={}),e[r].constructor===Object?Vx(e[r],i[r],!1,o):Rx(e,i,r,o);else{if(Wp(i[r]))throw new TypeError("Arrays are not supported by deepExtend");Rx(e,i,r,o)}}return e}function qx(t,e,i){var o=arguments.length>3&&void 0!==arguments[3]&&arguments[3];if(Wp(i))throw new TypeError("Arrays are not supported by deepExtend");for(var n in i)if(Object.prototype.hasOwnProperty.call(i,n)&&!Lg(t).call(t,n))if(i[n]&&i[n].constructor===Object)void 0===e[n]&&(e[n]={}),e[n].constructor===Object?Vx(e[n],i[n]):Rx(e,i,n,o);else if(Wp(i[n])){e[n]=[];for(var r=0;r<i[n].length;r++)e[n].push(i[n][r])}else Rx(e,i,n,o);return e}function Vx(t,e){var i=arguments.length>2&&void 0!==arguments[2]&&arguments[2],o=arguments.length>3&&void 0!==arguments[3]&&arguments[3];for(var n in e)if(Object.prototype.hasOwnProperty.call(e,n)||!0===i)if("object"===Of(e[n])&&null!==e[n]&&Xg(e[n])===Object.prototype)void 0===t[n]?t[n]=Vx({},e[n],i):"object"===Of(t[n])&&null!==t[n]&&Xg(t[n])===Object.prototype?Vx(t[n],e[n],i):Rx(t,e,n,o);else if(Wp(e[n])){var r;t[n]=Fp(r=e[n]).call(r)}else Rx(t,e,n,o);return t}function Ux(t,e){var i;return Np(i=[]).call(i,_p(t),[e])}function Yx(t){return Fp(t).call(t)}function Xx(t){return t.getBoundingClientRect().left}function Gx(t){return t.getBoundingClientRect().top}function Kx(t,e){if(Wp(t))for(var i=t.length,o=0;o<i;o++)e(t[o],o,t);else for(var n in t)Object.prototype.hasOwnProperty.call(t,n)&&e(t[n],n,t)}var $x=vy;function Zx(t,e,i,o){var n;t.addEventListener?(void 0===o&&(o=!1),"mousewheel"===e&&Lg(n=navigator.userAgent).call(n,"Firefox")&&(e="DOMMouseScroll"),t.addEventListener(e,i,o)):t.attachEvent("on"+e,i)}function Qx(t,e,i,o){var n;t.removeEventListener?(void 0===o&&(o=!1),"mousewheel"===e&&Lg(n=navigator.userAgent).call(n,"Firefox")&&(e="DOMMouseScroll"),t.removeEventListener(e,i,o)):t.detachEvent("on"+e,i)}var Jx={asBoolean:function(t,e){return"function"==typeof t&&(t=t()),null!=t?0!=t:e||null},asNumber:function(t,e){return"function"==typeof t&&(t=t()),null!=t?Number(t)||e||null:e||null},asString:function(t,e){return"function"==typeof t&&(t=t()),null!=t?String(t):e||null},asSize:function(t,e){return"function"==typeof t&&(t=t()),Ax(t)?t:zx(t)?t+"px":e||null},asElement:function(t,e){return"function"==typeof t&&(t=t()),t||e||null}};function tk(t){var e;switch(t.length){case 3:case 4:return(e=Ix.exec(t))?{r:Ly(e[1]+e[1],16),g:Ly(e[2]+e[2],16),b:Ly(e[3]+e[3],16)}:null;case 6:case 7:return(e=Dx.exec(t))?{r:Ly(e[1],16),g:Ly(e[2],16),b:Ly(e[3],16)}:null;default:return null}}function ek(t,e){if(Lg(t).call(t,"rgba"))return t;if(Lg(t).call(t,"rgb")){var i=t.substr(tm(t).call(t,"(")+1).replace(")","").split(",");return"rgba("+i[0]+","+i[1]+","+i[2]+","+e+")"}var o=tk(t);return null==o?t:"rgba("+o.r+","+o.g+","+o.b+","+e+")"}function ik(t,e,i){var o;return"#"+Fp(o=((1<<24)+(t<<16)+(e<<8)+i).toString(16)).call(o,1)}function ok(t,e){if(Ax(t)){var i=t;if(dk(i)){var o,n=Qp(o=i.substr(4).substr(0,i.length-5).split(",")).call(o,(function(t){return Ly(t)}));i=ik(n[0],n[1],n[2])}if(!0===lk(i)){var r=hk(i),s={h:r.h,s:.8*r.s,v:Math.min(1,1.02*r.v)},a={h:r.h,s:Math.min(1,1.25*r.s),v:.8*r.v},h=ak(a.h,a.s,a.v),l=ak(s.h,s.s,s.v);return{background:i,border:h,highlight:{background:l,border:h},hover:{background:l,border:h}}}return{background:i,border:i,highlight:{background:i,border:i},hover:{background:i,border:i}}}return e?{background:t.background||e.background,border:t.border||e.border,highlight:Ax(t.highlight)?{border:t.highlight,background:t.highlight}:{background:t.highlight&&t.highlight.background||e.highlight.background,border:t.highlight&&t.highlight.border||e.highlight.border},hover:Ax(t.hover)?{border:t.hover,background:t.hover}:{border:t.hover&&t.hover.border||e.hover.border,background:t.hover&&t.hover.background||e.hover.background}}:{background:t.background||void 0,border:t.border||void 0,highlight:Ax(t.highlight)?{border:t.highlight,background:t.highlight}:{background:t.highlight&&t.highlight.background||void 0,border:t.highlight&&t.highlight.border||void 0},hover:Ax(t.hover)?{border:t.hover,background:t.hover}:{border:t.hover&&t.hover.border||void 0,background:t.hover&&t.hover.background||void 0}}}function nk(t,e,i){t/=255,e/=255,i/=255;var o=Math.min(t,Math.min(e,i)),n=Math.max(t,Math.max(e,i));return o===n?{h:0,s:0,v:o}:{h:60*((t===o?3:i===o?1:5)-(t===o?e-i:i===o?t-e:i-t)/(n-o))/360,s:(n-o)/n,v:n}}var rk={split:function(t){var e,i={};return Cv(e=t.split(";")).call(e,(function(t){if(""!=fm(t).call(t)){var e,o,n=t.split(":"),r=fm(e=n[0]).call(e),s=fm(o=n[1]).call(o);i[r]=s}})),i},join:function(t){var e;return Qp(e=nv(t)).call(e,(function(e){return e+": "+t[e]})).join("; ")}};function sk(t,e,i){var o,n,r,s=Math.floor(6*t),a=6*t-s,h=i*(1-e),l=i*(1-a*e),d=i*(1-(1-a)*e);switch(s%6){case 0:o=i,n=d,r=h;break;case 1:o=l,n=i,r=h;break;case 2:o=h,n=i,r=d;break;case 3:o=h,n=l,r=i;break;case 4:o=d,n=h,r=i;break;case 5:o=i,n=h,r=l}return{r:Math.floor(255*o),g:Math.floor(255*n),b:Math.floor(255*r)}}function ak(t,e,i){var o=sk(t,e,i);return ik(o.r,o.g,o.b)}function hk(t){var e=tk(t);if(!e)throw new TypeError("'".concat(t,"' is not a valid color."));return nk(e.r,e.g,e.b)}function lk(t){return/(^#[0-9A-F]{6}$)|(^#[0-9A-F]{3}$)/i.test(t)}function dk(t){return Bx.test(t)}function ck(t){return Nx.test(t)}function uk(t){if(null===t||"object"!==Of(t))return null;if(t instanceof Element)return t;var e=mm(t);for(var i in t)Object.prototype.hasOwnProperty.call(t,i)&&"object"==Of(t[i])&&(e[i]=uk(t[i]));return e}function fk(t,e,i){var o=arguments.length>3&&void 0!==arguments[3]?arguments[3]:{},n=function(t){return null!=t},r=function(t){return null!==t&&"object"===Of(t)};if(!r(t))throw new Error("Parameter mergeTarget must be an object");if(!r(e))throw new Error("Parameter options must be an object");if(!n(i))throw new Error("Parameter option must have a value");if(!r(o))throw new Error("Parameter globalOptions must be an object");var s=e[i],a=r(o)&&!function(t){for(var e in t)if(Object.prototype.hasOwnProperty.call(t,e))return!1;return!0}(o)?o[i]:void 0,h=a?a.enabled:void 0;if(void 0!==s){if("boolean"==typeof s)return r(t[i])||(t[i]={}),void(t[i].enabled=s);if(null===s&&!r(t[i])){if(!n(a))return;t[i]=mm(a)}if(r(s)){var l=!0;void 0!==s.enabled?l=s.enabled:void 0!==h&&(l=a.enabled),function(t,e,i){r(t[i])||(t[i]={});var o=e[i],n=t[i];for(var s in o)Object.prototype.hasOwnProperty.call(o,s)&&(n[s]=o[s])}(t,e,i),t[i].enabled=l}}}var pk={linear:function(t){return t},easeInQuad:function(t){return t*t},easeOutQuad:function(t){return t*(2-t)},easeInOutQuad:function(t){return t<.5?2*t*t:(4-2*t)*t-1},easeInCubic:function(t){return t*t*t},easeOutCubic:function(t){return--t*t*t+1},easeInOutCubic:function(t){return t<.5?4*t*t*t:(t-1)*(2*t-2)*(2*t-2)+1},easeInQuart:function(t){return t*t*t*t},easeOutQuart:function(t){return 1- --t*t*t*t},easeInOutQuart:function(t){return t<.5?8*t*t*t*t:1-8*--t*t*t*t},easeInQuint:function(t){return t*t*t*t*t},easeOutQuint:function(t){return 1+--t*t*t*t*t},easeInOutQuint:function(t){return t<.5?16*t*t*t*t*t:1+16*--t*t*t*t*t}};function vk(t,e){var i;Wp(e)||(e=[e]);var o,n=bx(t);try{for(n.s();!(o=n.n()).done;){var r=o.value;if(r){i=r[e[0]];for(var s=1;s<e.length;s++)i&&(i=i[e[s]]);if(void 0!==i)break}}}catch(t){n.e(t)}finally{n.f()}return i}var gk={black:"#000000",navy:"#000080",darkblue:"#00008B",mediumblue:"#0000CD",blue:"#0000FF",darkgreen:"#006400",green:"#008000",teal:"#008080",darkcyan:"#008B8B",deepskyblue:"#00BFFF",darkturquoise:"#00CED1",mediumspringgreen:"#00FA9A",lime:"#00FF00",springgreen:"#00FF7F",aqua:"#00FFFF",cyan:"#00FFFF",midnightblue:"#191970",dodgerblue:"#1E90FF",lightseagreen:"#20B2AA",forestgreen:"#228B22",seagreen:"#2E8B57",darkslategray:"#2F4F4F",limegreen:"#32CD32",mediumseagreen:"#3CB371",turquoise:"#40E0D0",royalblue:"#4169E1",steelblue:"#4682B4",darkslateblue:"#483D8B",mediumturquoise:"#48D1CC",indigo:"#4B0082",darkolivegreen:"#556B2F",cadetblue:"#5F9EA0",cornflowerblue:"#6495ED",mediumaquamarine:"#66CDAA",dimgray:"#696969",slateblue:"#6A5ACD",olivedrab:"#6B8E23",slategray:"#708090",lightslategray:"#778899",mediumslateblue:"#7B68EE",lawngreen:"#7CFC00",chartreuse:"#7FFF00",aquamarine:"#7FFFD4",maroon:"#800000",purple:"#800080",olive:"#808000",gray:"#808080",skyblue:"#87CEEB",lightskyblue:"#87CEFA",blueviolet:"#8A2BE2",darkred:"#8B0000",darkmagenta:"#8B008B",saddlebrown:"#8B4513",darkseagreen:"#8FBC8F",lightgreen:"#90EE90",mediumpurple:"#9370D8",darkviolet:"#9400D3",palegreen:"#98FB98",darkorchid:"#9932CC",yellowgreen:"#9ACD32",sienna:"#A0522D",brown:"#A52A2A",darkgray:"#A9A9A9",lightblue:"#ADD8E6",greenyellow:"#ADFF2F",paleturquoise:"#AFEEEE",lightsteelblue:"#B0C4DE",powderblue:"#B0E0E6",firebrick:"#B22222",darkgoldenrod:"#B8860B",mediumorchid:"#BA55D3",rosybrown:"#BC8F8F",darkkhaki:"#BDB76B",silver:"#C0C0C0",mediumvioletred:"#C71585",indianred:"#CD5C5C",peru:"#CD853F",chocolate:"#D2691E",tan:"#D2B48C",lightgrey:"#D3D3D3",palevioletred:"#D87093",thistle:"#D8BFD8",orchid:"#DA70D6",goldenrod:"#DAA520",crimson:"#DC143C",gainsboro:"#DCDCDC",plum:"#DDA0DD",burlywood:"#DEB887",lightcyan:"#E0FFFF",lavender:"#E6E6FA",darksalmon:"#E9967A",violet:"#EE82EE",palegoldenrod:"#EEE8AA",lightcoral:"#F08080",khaki:"#F0E68C",aliceblue:"#F0F8FF",honeydew:"#F0FFF0",azure:"#F0FFFF",sandybrown:"#F4A460",wheat:"#F5DEB3",beige:"#F5F5DC",whitesmoke:"#F5F5F5",mintcream:"#F5FFFA",ghostwhite:"#F8F8FF",salmon:"#FA8072",antiquewhite:"#FAEBD7",linen:"#FAF0E6",lightgoldenrodyellow:"#FAFAD2",oldlace:"#FDF5E6",red:"#FF0000",fuchsia:"#FF00FF",magenta:"#FF00FF",deeppink:"#FF1493",orangered:"#FF4500",tomato:"#FF6347",hotpink:"#FF69B4",coral:"#FF7F50",darkorange:"#FF8C00",lightsalmon:"#FFA07A",orange:"#FFA500",lightpink:"#FFB6C1",pink:"#FFC0CB",gold:"#FFD700",peachpuff:"#FFDAB9",navajowhite:"#FFDEAD",moccasin:"#FFE4B5",bisque:"#FFE4C4",mistyrose:"#FFE4E1",blanchedalmond:"#FFEBCD",papayawhip:"#FFEFD5",lavenderblush:"#FFF0F5",seashell:"#FFF5EE",cornsilk:"#FFF8DC",lemonchiffon:"#FFFACD",floralwhite:"#FFFAF0",snow:"#FFFAFA",yellow:"#FFFF00",lightyellow:"#FFFFE0",ivory:"#FFFFF0",white:"#FFFFFF"},yk=function(){function t(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:1;pu(this,t),this.pixelRatio=e,this.generated=!1,this.centerCoordinates={x:144.5,y:144.5},this.r=289*.49,this.color={r:255,g:255,b:255,a:1},this.hueCircle=void 0,this.initialColor={r:255,g:255,b:255,a:1},this.previousColor=void 0,this.applied=!1,this.updateCallback=function(){},this.closeCallback=function(){},this._create()}return Nf(t,[{key:"insertTo",value:function(t){void 0!==this.hammer&&(this.hammer.destroy(),this.hammer=void 0),this.container=t,this.container.appendChild(this.frame),this._bindHammer(),this._setSize()}},{key:"setUpdateCallback",value:function(t){if("function"!=typeof t)throw new Error("Function attempted to set as colorPicker update callback is not a function.");this.updateCallback=t}},{key:"setCloseCallback",value:function(t){if("function"!=typeof t)throw new Error("Function attempted to set as colorPicker closing callback is not a function.");this.closeCallback=t}},{key:"_isColorString",value:function(t){if("string"==typeof t)return gk[t]}},{key:"setColor",value:function(t){var e=!(arguments.length>1&&void 0!==arguments[1])||arguments[1];if("none"!==t){var i,o=this._isColorString(t);if(void 0!==o&&(t=o),!0===Ax(t)){if(!0===dk(t)){var n=t.substr(4).substr(0,t.length-5).split(",");i={r:n[0],g:n[1],b:n[2],a:1}}else if(!0===ck(t)){var r=t.substr(5).substr(0,t.length-6).split(",");i={r:r[0],g:r[1],b:r[2],a:r[3]}}else if(!0===lk(t)){var s=tk(t);i={r:s.r,g:s.g,b:s.b,a:1}}}else if(t instanceof Object&&void 0!==t.r&&void 0!==t.g&&void 0!==t.b){var a=void 0!==t.a?t.a:"1.0";i={r:t.r,g:t.g,b:t.b,a:a}}if(void 0===i)throw new Error("Unknown color passed to the colorPicker. Supported are strings: rgb, hex, rgba. Object: rgb ({r:r,g:g,b:b,[a:a]}). Supplied: "+Em(t));this._setColor(i,e)}}},{key:"show",value:function(){void 0!==this.closeCallback&&(this.closeCallback(),this.closeCallback=void 0),this.applied=!1,this.frame.style.display="block",this._generateHueCircle()}},{key:"_hide",value:function(){var t=this;!0===(!(arguments.length>0&&void 0!==arguments[0])||arguments[0])&&(this.previousColor=wo({},this.color)),!0===this.applied&&this.updateCallback(this.initialColor),this.frame.style.display="none",Xm((function(){void 0!==t.closeCallback&&(t.closeCallback(),t.closeCallback=void 0)}),0)}},{key:"_save",value:function(){this.updateCallback(this.color),this.applied=!1,this._hide()}},{key:"_apply",value:function(){this.applied=!0,this.updateCallback(this.color),this._updatePicker(this.color)}},{key:"_loadLast",value:function(){void 0!==this.previousColor?this.setColor(this.previousColor,!1):alert("There is no last color to load...")}},{key:"_setColor",value:function(t){!0===(!(arguments.length>1&&void 0!==arguments[1])||arguments[1])&&(this.initialColor=wo({},t)),this.color=t;var e=nk(t.r,t.g,t.b),i=2*Math.PI,o=this.r*e.s,n=this.centerCoordinates.x+o*Math.sin(i*e.h),r=this.centerCoordinates.y+o*Math.cos(i*e.h);this.colorPickerSelector.style.left=n-.5*this.colorPickerSelector.clientWidth+"px",this.colorPickerSelector.style.top=r-.5*this.colorPickerSelector.clientHeight+"px",this._updatePicker(t)}},{key:"_setOpacity",value:function(t){this.color.a=t/100,this._updatePicker(this.color)}},{key:"_setBrightness",value:function(t){var e=nk(this.color.r,this.color.g,this.color.b);e.v=t/100;var i=sk(e.h,e.s,e.v);i.a=this.color.a,this.color=i,this._updatePicker()}},{key:"_updatePicker",value:function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:this.color,e=nk(t.r,t.g,t.b),i=this.colorPickerCanvas.getContext("2d");void 0===this.pixelRation&&(this.pixelRatio=(window.devicePixelRatio||1)/(i.webkitBackingStorePixelRatio||i.mozBackingStorePixelRatio||i.msBackingStorePixelRatio||i.oBackingStorePixelRatio||i.backingStorePixelRatio||1)),i.setTransform(this.pixelRatio,0,0,this.pixelRatio,0,0);var o=this.colorPickerCanvas.clientWidth,n=this.colorPickerCanvas.clientHeight;i.clearRect(0,0,o,n),i.putImageData(this.hueCircle,0,0),i.fillStyle="rgba(0,0,0,"+(1-e.v)+")",i.circle(this.centerCoordinates.x,this.centerCoordinates.y,this.r),ab(i).call(i),this.brightnessRange.value=100*e.v,this.opacityRange.value=100*t.a,this.initialColorDiv.style.backgroundColor="rgba("+this.initialColor.r+","+this.initialColor.g+","+this.initialColor.b+","+this.initialColor.a+")",this.newColorDiv.style.backgroundColor="rgba("+this.color.r+","+this.color.g+","+this.color.b+","+this.color.a+")"}},{key:"_setSize",value:function(){this.colorPickerCanvas.style.width="100%",this.colorPickerCanvas.style.height="100%",this.colorPickerCanvas.width=289*this.pixelRatio,this.colorPickerCanvas.height=289*this.pixelRatio}},{key:"_create",value:function(){var t,e,i,o;if(this.frame=document.createElement("div"),this.frame.className="vis-color-picker",this.colorPickerDiv=document.createElement("div"),this.colorPickerSelector=document.createElement("div"),this.colorPickerSelector.className="vis-selector",this.colorPickerDiv.appendChild(this.colorPickerSelector),this.colorPickerCanvas=document.createElement("canvas"),this.colorPickerDiv.appendChild(this.colorPickerCanvas),this.colorPickerCanvas.getContext){var n=this.colorPickerCanvas.getContext("2d");this.pixelRatio=(window.devicePixelRatio||1)/(n.webkitBackingStorePixelRatio||n.mozBackingStorePixelRatio||n.msBackingStorePixelRatio||n.oBackingStorePixelRatio||n.backingStorePixelRatio||1),this.colorPickerCanvas.getContext("2d").setTransform(this.pixelRatio,0,0,this.pixelRatio,0,0)}else{var r=document.createElement("DIV");r.style.color="red",r.style.fontWeight="bold",r.style.padding="10px",r.innerText="Error: your browser does not support HTML canvas",this.colorPickerCanvas.appendChild(r)}this.colorPickerDiv.className="vis-color",this.opacityDiv=document.createElement("div"),this.opacityDiv.className="vis-opacity",this.brightnessDiv=document.createElement("div"),this.brightnessDiv.className="vis-brightness",this.arrowDiv=document.createElement("div"),this.arrowDiv.className="vis-arrow",this.opacityRange=document.createElement("input");try{this.opacityRange.type="range",this.opacityRange.min="0",this.opacityRange.max="100"}catch(t){}this.opacityRange.value="100",this.opacityRange.className="vis-range",this.brightnessRange=document.createElement("input");try{this.brightnessRange.type="range",this.brightnessRange.min="0",this.brightnessRange.max="100"}catch(t){}this.brightnessRange.value="100",this.brightnessRange.className="vis-range",this.opacityDiv.appendChild(this.opacityRange),this.brightnessDiv.appendChild(this.brightnessRange);var s=this;this.opacityRange.onchange=function(){s._setOpacity(this.value)},this.opacityRange.oninput=function(){s._setOpacity(this.value)},this.brightnessRange.onchange=function(){s._setBrightness(this.value)},this.brightnessRange.oninput=function(){s._setBrightness(this.value)},this.brightnessLabel=document.createElement("div"),this.brightnessLabel.className="vis-label vis-brightness",this.brightnessLabel.innerText="brightness:",this.opacityLabel=document.createElement("div"),this.opacityLabel.className="vis-label vis-opacity",this.opacityLabel.innerText="opacity:",this.newColorDiv=document.createElement("div"),this.newColorDiv.className="vis-new-color",this.newColorDiv.innerText="new",this.initialColorDiv=document.createElement("div"),this.initialColorDiv.className="vis-initial-color",this.initialColorDiv.innerText="initial",this.cancelButton=document.createElement("div"),this.cancelButton.className="vis-button vis-cancel",this.cancelButton.innerText="cancel",this.cancelButton.onclick=Uo(t=this._hide).call(t,this,!1),this.applyButton=document.createElement("div"),this.applyButton.className="vis-button vis-apply",this.applyButton.innerText="apply",this.applyButton.onclick=Uo(e=this._apply).call(e,this),this.saveButton=document.createElement("div"),this.saveButton.className="vis-button vis-save",this.saveButton.innerText="save",this.saveButton.onclick=Uo(i=this._save).call(i,this),this.loadButton=document.createElement("div"),this.loadButton.className="vis-button vis-load",this.loadButton.innerText="load last",this.loadButton.onclick=Uo(o=this._loadLast).call(o,this),this.frame.appendChild(this.colorPickerDiv),this.frame.appendChild(this.arrowDiv),this.frame.appendChild(this.brightnessLabel),this.frame.appendChild(this.brightnessDiv),this.frame.appendChild(this.opacityLabel),this.frame.appendChild(this.opacityDiv),this.frame.appendChild(this.newColorDiv),this.frame.appendChild(this.initialColorDiv),this.frame.appendChild(this.cancelButton),this.frame.appendChild(this.applyButton),this.frame.appendChild(this.saveButton),this.frame.appendChild(this.loadButton)}},{key:"_bindHammer",value:function(){var t=this;this.drag={},this.pinch={},this.hammer=new Tx(this.colorPickerCanvas),this.hammer.get("pinch").set({enable:!0}),this.hammer.on("hammer.input",(function(e){e.isFirst&&t._moveSelector(e)})),this.hammer.on("tap",(function(e){t._moveSelector(e)})),this.hammer.on("panstart",(function(e){t._moveSelector(e)})),this.hammer.on("panmove",(function(e){t._moveSelector(e)})),this.hammer.on("panend",(function(e){t._moveSelector(e)}))}},{key:"_generateHueCircle",value:function(){if(!1===this.generated){var t=this.colorPickerCanvas.getContext("2d");void 0===this.pixelRation&&(this.pixelRatio=(window.devicePixelRatio||1)/(t.webkitBackingStorePixelRatio||t.mozBackingStorePixelRatio||t.msBackingStorePixelRatio||t.oBackingStorePixelRatio||t.backingStorePixelRatio||1)),t.setTransform(this.pixelRatio,0,0,this.pixelRatio,0,0);var e,i,o,n,r=this.colorPickerCanvas.clientWidth,s=this.colorPickerCanvas.clientHeight;t.clearRect(0,0,r,s),this.centerCoordinates={x:.5*r,y:.5*s},this.r=.49*r;var a,h=2*Math.PI/360,l=1/this.r;for(o=0;o<360;o++)for(n=0;n<this.r;n++)e=this.centerCoordinates.x+n*Math.sin(h*o),i=this.centerCoordinates.y+n*Math.cos(h*o),a=sk(.002777777777777778*o,n*l,1),t.fillStyle="rgb("+a.r+","+a.g+","+a.b+")",t.fillRect(e-.5,i-.5,2,2);t.strokeStyle="rgba(0,0,0,1)",t.circle(this.centerCoordinates.x,this.centerCoordinates.y,this.r),t.stroke(),this.hueCircle=t.getImageData(0,0,r,s)}this.generated=!0}},{key:"_moveSelector",value:function(t){var e=this.colorPickerDiv.getBoundingClientRect(),i=t.center.x-e.left,o=t.center.y-e.top,n=.5*this.colorPickerDiv.clientHeight,r=.5*this.colorPickerDiv.clientWidth,s=i-r,a=o-n,h=Math.atan2(s,a),l=.98*Math.min(Math.sqrt(s*s+a*a),r),d=Math.cos(h)*l+n,c=Math.sin(h)*l+r;this.colorPickerSelector.style.top=d-.5*this.colorPickerSelector.clientHeight+"px",this.colorPickerSelector.style.left=c-.5*this.colorPickerSelector.clientWidth+"px";var u=h/(2*Math.PI);u=u<0?u+1:u;var f=l/this.r,p=nk(this.color.r,this.color.g,this.color.b);p.h=u,p.s=f;var v=sk(p.h,p.s,p.v);v.a=this.color.a,this.color=v,this.initialColorDiv.style.backgroundColor="rgba("+this.initialColor.r+","+this.initialColor.g+","+this.initialColor.b+","+this.initialColor.a+")",this.newColorDiv.style.backgroundColor="rgba("+this.color.r+","+this.color.g+","+this.color.b+","+this.color.a+")"}}]),t}();function mk(){for(var t=arguments.length,e=new Array(t),i=0;i<t;i++)e[i]=arguments[i];if(e.length<1)throw new TypeError("Invalid arguments.");if(1===e.length)return document.createTextNode(e[0]);var o=document.createElement(e[0]);return o.appendChild(mk.apply(void 0,_p(Fp(e).call(e,1)))),o}var bk,wk=function(){function t(e,i,o){var n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:1,r=arguments.length>4&&void 0!==arguments[4]?arguments[4]:function(){return!1};pu(this,t),this.parent=e,this.changedOptions=[],this.container=i,this.allowCreation=!1,this.hideOption=r,this.options={},this.initialized=!1,this.popupCounter=0,this.defaultOptions={enabled:!1,filter:!0,container:void 0,showButton:!0},wo(this.options,this.defaultOptions),this.configureOptions=o,this.moduleOptions={},this.domElements=[],this.popupDiv={},this.popupLimit=5,this.popupHistory={},this.colorPicker=new yk(n),this.wrapper=void 0}return Nf(t,[{key:"setOptions",value:function(t){if(void 0!==t){this.popupHistory={},this._removePopup();var e=!0;if("string"==typeof t)this.options.filter=t;else if(Wp(t))this.options.filter=t.join();else if("object"===Of(t)){if(null==t)throw new TypeError("options cannot be null");void 0!==t.container&&(this.options.container=t.container),void 0!==oy(t)&&(this.options.filter=oy(t)),void 0!==t.showButton&&(this.options.showButton=t.showButton),void 0!==t.enabled&&(e=t.enabled)}else"boolean"==typeof t?(this.options.filter=!0,e=t):"function"==typeof t&&(this.options.filter=t,e=!0);!1===oy(this.options)&&(e=!1),this.options.enabled=e}this._clean()}},{key:"setModuleOptions",value:function(t){this.moduleOptions=t,!0===this.options.enabled&&(this._clean(),void 0!==this.options.container&&(this.container=this.options.container),this._create())}},{key:"_create",value:function(){this._clean(),this.changedOptions=[];var t=oy(this.options),e=0,i=!1;for(var o in this.configureOptions)Object.prototype.hasOwnProperty.call(this.configureOptions,o)&&(this.allowCreation=!1,i=!1,"function"==typeof t?i=(i=t(o,[]))||this._handleObject(this.configureOptions[o],[o],!0):!0!==t&&-1===tm(t).call(t,o)||(i=!0),!1!==i&&(this.allowCreation=!0,e>0&&this._makeItem([]),this._makeHeader(o),this._handleObject(this.configureOptions[o],[o])),e++);this._makeButton(),this._push()}},{key:"_push",value:function(){this.wrapper=document.createElement("div"),this.wrapper.className="vis-configuration-wrapper",this.container.appendChild(this.wrapper);for(var t=0;t<this.domElements.length;t++)this.wrapper.appendChild(this.domElements[t]);this._showPopupIfNeeded()}},{key:"_clean",value:function(){for(var t=0;t<this.domElements.length;t++)this.wrapper.removeChild(this.domElements[t]);void 0!==this.wrapper&&(this.container.removeChild(this.wrapper),this.wrapper=void 0),this.domElements=[],this._removePopup()}},{key:"_getValue",value:function(t){for(var e=this.moduleOptions,i=0;i<t.length;i++){if(void 0===e[t[i]]){e=void 0;break}e=e[t[i]]}return e}},{key:"_makeItem",value:function(t){if(!0===this.allowCreation){var e=document.createElement("div");e.className="vis-configuration vis-config-item vis-config-s"+t.length;for(var i=arguments.length,o=new Array(i>1?i-1:0),n=1;n<i;n++)o[n-1]=arguments[n];return Cv(o).call(o,(function(t){e.appendChild(t)})),this.domElements.push(e),this.domElements.length}return 0}},{key:"_makeHeader",value:function(t){var e=document.createElement("div");e.className="vis-configuration vis-config-header",e.innerText=t,this._makeItem([],e)}},{key:"_makeLabel",value:function(t,e){var i=arguments.length>2&&void 0!==arguments[2]&&arguments[2],o=document.createElement("div");if(o.className="vis-configuration vis-config-label vis-config-s"+e.length,!0===i){for(;o.firstChild;)o.removeChild(o.firstChild);o.appendChild(mk("i","b",t))}else o.innerText=t+":";return o}},{key:"_makeDropdown",value:function(t,e,i){var o=document.createElement("select");o.className="vis-configuration vis-config-select";var n=0;void 0!==e&&-1!==tm(t).call(t,e)&&(n=tm(t).call(t,e));for(var r=0;r<t.length;r++){var s=document.createElement("option");s.value=t[r],r===n&&(s.selected="selected"),s.innerText=t[r],o.appendChild(s)}var a=this;o.onchange=function(){a._update(this.value,i)};var h=this._makeLabel(i[i.length-1],i);this._makeItem(i,h,o)}},{key:"_makeRange",value:function(t,e,i){var o=t[0],n=t[1],r=t[2],s=t[3],a=document.createElement("input");a.className="vis-configuration vis-config-range";try{a.type="range",a.min=n,a.max=r}catch(t){}a.step=s;var h="",l=0;if(void 0!==e){var d=1.2;e<0&&e*d<n?(a.min=Math.ceil(e*d),l=a.min,h="range increased"):e/d<n&&(a.min=Math.ceil(e/d),l=a.min,h="range increased"),e*d>r&&1!==r&&(a.max=Math.ceil(e*d),l=a.max,h="range increased"),a.value=e}else a.value=o;var c=document.createElement("input");c.className="vis-configuration vis-config-rangeinput",c.value=a.value;var u=this;a.onchange=function(){c.value=this.value,u._update(Number(this.value),i)},a.oninput=function(){c.value=this.value};var f=this._makeLabel(i[i.length-1],i),p=this._makeItem(i,f,a,c);""!==h&&this.popupHistory[p]!==l&&(this.popupHistory[p]=l,this._setupPopup(h,p))}},{key:"_makeButton",value:function(){var t=this;if(!0===this.options.showButton){var e=document.createElement("div");e.className="vis-configuration vis-config-button",e.innerText="generate options",e.onclick=function(){t._printOptions()},e.onmouseover=function(){e.className="vis-configuration vis-config-button hover"},e.onmouseout=function(){e.className="vis-configuration vis-config-button"},this.optionsContainer=document.createElement("div"),this.optionsContainer.className="vis-configuration vis-config-option-container",this.domElements.push(this.optionsContainer),this.domElements.push(e)}}},{key:"_setupPopup",value:function(t,e){var i=this;if(!0===this.initialized&&!0===this.allowCreation&&this.popupCounter<this.popupLimit){var o=document.createElement("div");o.id="vis-configuration-popup",o.className="vis-configuration-popup",o.innerText=t,o.onclick=function(){i._removePopup()},this.popupCounter+=1,this.popupDiv={html:o,index:e}}}},{key:"_removePopup",value:function(){void 0!==this.popupDiv.html&&(this.popupDiv.html.parentNode.removeChild(this.popupDiv.html),clearTimeout(this.popupDiv.hideTimeout),clearTimeout(this.popupDiv.deleteTimeout),this.popupDiv={})}},{key:"_showPopupIfNeeded",value:function(){var t=this;if(void 0!==this.popupDiv.html){var e=this.domElements[this.popupDiv.index].getBoundingClientRect();this.popupDiv.html.style.left=e.left+"px",this.popupDiv.html.style.top=e.top-30+"px",document.body.appendChild(this.popupDiv.html),this.popupDiv.hideTimeout=Xm((function(){t.popupDiv.html.style.opacity=0}),1500),this.popupDiv.deleteTimeout=Xm((function(){t._removePopup()}),1800)}}},{key:"_makeCheckbox",value:function(t,e,i){var o=document.createElement("input");o.type="checkbox",o.className="vis-configuration vis-config-checkbox",o.checked=t,void 0!==e&&(o.checked=e,e!==t&&("object"===Of(t)?e!==t.enabled&&this.changedOptions.push({path:i,value:e}):this.changedOptions.push({path:i,value:e})));var n=this;o.onchange=function(){n._update(this.checked,i)};var r=this._makeLabel(i[i.length-1],i);this._makeItem(i,r,o)}},{key:"_makeTextInput",value:function(t,e,i){var o=document.createElement("input");o.type="text",o.className="vis-configuration vis-config-text",o.value=e,e!==t&&this.changedOptions.push({path:i,value:e});var n=this;o.onchange=function(){n._update(this.value,i)};var r=this._makeLabel(i[i.length-1],i);this._makeItem(i,r,o)}},{key:"_makeColorField",value:function(t,e,i){var o=this,n=t[1],r=document.createElement("div");"none"!==(e=void 0===e?n:e)?(r.className="vis-configuration vis-config-colorBlock",r.style.backgroundColor=e):r.className="vis-configuration vis-config-colorBlock none",e=void 0===e?n:e,r.onclick=function(){o._showColorPicker(e,r,i)};var s=this._makeLabel(i[i.length-1],i);this._makeItem(i,s,r)}},{key:"_showColorPicker",value:function(t,e,i){var o=this;e.onclick=function(){},this.colorPicker.insertTo(e),this.colorPicker.show(),this.colorPicker.setColor(t),this.colorPicker.setUpdateCallback((function(t){var n="rgba("+t.r+","+t.g+","+t.b+","+t.a+")";e.style.backgroundColor=n,o._update(n,i)})),this.colorPicker.setCloseCallback((function(){e.onclick=function(){o._showColorPicker(t,e,i)}}))}},{key:"_handleObject",value:function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:[],i=arguments.length>2&&void 0!==arguments[2]&&arguments[2],o=!1,n=oy(this.options),r=!1;for(var s in t)if(Object.prototype.hasOwnProperty.call(t,s)){o=!0;var a=t[s],h=Ux(e,s);if("function"==typeof n&&!1===(o=n(s,e))&&!Wp(a)&&"string"!=typeof a&&"boolean"!=typeof a&&a instanceof Object&&(this.allowCreation=!1,o=this._handleObject(a,h,!0),this.allowCreation=!1===i),!1!==o){r=!0;var l=this._getValue(h);if(Wp(a))this._handleArray(a,l,h);else if("string"==typeof a)this._makeTextInput(a,l,h);else if("boolean"==typeof a)this._makeCheckbox(a,l,h);else if(a instanceof Object){if(!this.hideOption(e,s,this.moduleOptions))if(void 0!==a.enabled){var d=Ux(h,"enabled"),c=this._getValue(d);if(!0===c){var u=this._makeLabel(s,h,!0);this._makeItem(h,u),r=this._handleObject(a,h)||r}else this._makeCheckbox(a,c,h)}else{var f=this._makeLabel(s,h,!0);this._makeItem(h,f),r=this._handleObject(a,h)||r}}else console.error("dont know how to handle",a,s,h)}}return r}},{key:"_handleArray",value:function(t,e,i){"string"==typeof t[0]&&"color"===t[0]?(this._makeColorField(t,e,i),t[1]!==e&&this.changedOptions.push({path:i,value:e})):"string"==typeof t[0]?(this._makeDropdown(t,e,i),t[0]!==e&&this.changedOptions.push({path:i,value:e})):"number"==typeof t[0]&&(this._makeRange(t,e,i),t[0]!==e&&this.changedOptions.push({path:i,value:Number(e)}))}},{key:"_update",value:function(t,e){var i=this._constructOptions(t,e);this.parent.body&&this.parent.body.emitter&&this.parent.body.emitter.emit&&this.parent.body.emitter.emit("configChange",i),this.initialized=!0,this.parent.setOptions(i)}},{key:"_constructOptions",value:function(t,e){var i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:{},o=i;t="false"!==(t="true"===t||t)&&t;for(var n=0;n<e.length;n++)"global"!==e[n]&&(void 0===o[e[n]]&&(o[e[n]]={}),n!==e.length-1?o=o[e[n]]:o[e[n]]=t);return i}},{key:"_printOptions",value:function(){for(var t=this.getOptions();this.optionsContainer.firstChild;)this.optionsContainer.removeChild(this.optionsContainer.firstChild);this.optionsContainer.appendChild(mk("pre","const options = "+Em(t,null,2)))}},{key:"getOptions",value:function(){for(var t={},e=0;e<this.changedOptions.length;e++)this._constructOptions(this.changedOptions[e].value,this.changedOptions[e].path,t);return t}}]),t}(),xk=function(){function t(e,i){pu(this,t),this.container=e,this.overflowMethod=i||"cap",this.x=0,this.y=0,this.padding=5,this.hidden=!1,this.frame=document.createElement("div"),this.frame.className="vis-tooltip",this.container.appendChild(this.frame)}return Nf(t,[{key:"setPosition",value:function(t,e){this.x=Ly(t),this.y=Ly(e)}},{key:"setText",value:function(t){if(t instanceof Element){for(;this.frame.firstChild;)this.frame.removeChild(this.frame.firstChild);this.frame.appendChild(t)}else this.frame.innerText=t}},{key:"show",value:function(t){if(void 0===t&&(t=!0),!0===t){var e=this.frame.clientHeight,i=this.frame.clientWidth,o=this.frame.parentNode.clientHeight,n=this.frame.parentNode.clientWidth,r=0,s=0;if("flip"==this.overflowMethod){var a=!1,h=!0;this.y-e<this.padding&&(h=!1),this.x+i>n-this.padding&&(a=!0),r=a?this.x-i:this.x,s=h?this.y-e:this.y}else(s=this.y-e)+e+this.padding>o&&(s=o-e-this.padding),s<this.padding&&(s=this.padding),(r=this.x)+i+this.padding>n&&(r=n-i-this.padding),r<this.padding&&(r=this.padding);this.frame.style.left=r+"px",this.frame.style.top=s+"px",this.frame.style.visibility="visible",this.hidden=!1}else this.hide()}},{key:"hide",value:function(){this.hidden=!0,this.frame.style.left="0",this.frame.style.top="0",this.frame.style.visibility="hidden"}},{key:"destroy",value:function(){this.frame.parentNode.removeChild(this.frame)}}]),t}(),kk=!1,_k="background: #FFeeee; color: #dd0000",Ek=function(){function t(){pu(this,t)}return Nf(t,null,[{key:"validate",value:function(e,i,o){kk=!1,bk=i;var n=i;return void 0!==o&&(n=i[o]),t.parse(e,n,[]),kk}},{key:"parse",value:function(e,i,o){for(var n in e)Object.prototype.hasOwnProperty.call(e,n)&&t.check(n,e,i,o)}},{key:"check",value:function(e,i,o,n){if(void 0!==o[e]||void 0!==o.__any__){var r=e,s=!0;void 0===o[e]&&void 0!==o.__any__&&(r="__any__",s="object"===t.getType(i[e]));var a=o[r];s&&void 0!==a.__type__&&(a=a.__type__),t.checkFields(e,i,o,r,a,n)}else t.getSuggestion(e,o,n)}},{key:"checkFields",value:function(e,i,o,n,r,s){var a=function(i){console.error("%c"+i+t.printLocation(s,e),_k)},h=t.getType(i[e]),l=r[h];void 0!==l?"array"===t.getType(l)&&-1===tm(l).call(l,i[e])?(a('Invalid option detected in "'+e+'". Allowed values are:'+t.print(l)+' not "'+i[e]+'". '),kk=!0):"object"===h&&"__any__"!==n&&(s=Ux(s,e),t.parse(i[e],o[n],s)):void 0===r.any&&(a('Invalid type received for "'+e+'". Expected: '+t.print(nv(r))+". Received ["+h+'] "'+i[e]+'"'),kk=!0)}},{key:"getType",value:function(t){var e=Of(t);return"object"===e?null===t?"null":t instanceof Boolean?"boolean":t instanceof Number?"number":t instanceof String?"string":Wp(t)?"array":t instanceof Date?"date":void 0!==t.nodeType?"dom":!0===t._isAMomentObject?"moment":"object":"number"===e?"number":"boolean"===e?"boolean":"string"===e?"string":void 0===e?"undefined":e}},{key:"getSuggestion",value:function(e,i,o){var n,r=t.findInOptions(e,i,o,!1),s=t.findInOptions(e,bk,[],!0);n=void 0!==r.indexMatch?" in "+t.printLocation(r.path,e,"")+'Perhaps it was incomplete? Did you mean: "'+r.indexMatch+'"?\n\n':s.distance<=4&&r.distance>s.distance?" in "+t.printLocation(r.path,e,"")+"Perhaps it was misplaced? Matching option found at: "+t.printLocation(s.path,s.closestMatch,""):r.distance<=8?'. Did you mean "'+r.closestMatch+'"?'+t.printLocation(r.path,e):". Did you mean one of these: "+t.print(nv(i))+t.printLocation(o,e),console.error('%cUnknown option detected: "'+e+'"'+n,_k),kk=!0}},{key:"findInOptions",value:function(e,i,o){var n=arguments.length>3&&void 0!==arguments[3]&&arguments[3],r=1e9,s="",a=[],h=e.toLowerCase(),l=void 0;for(var d in i){var c=void 0;if(void 0!==i[d].__type__&&!0===n){var u=t.findInOptions(e,i[d],Ux(o,d));r>u.distance&&(s=u.closestMatch,a=u.path,r=u.distance,l=u.indexMatch)}else{var f;-1!==tm(f=d.toLowerCase()).call(f,h)&&(l=d),r>(c=t.levenshteinDistance(e,d))&&(s=d,a=Yx(o),r=c)}}return{closestMatch:s,path:a,distance:r,indexMatch:l}}},{key:"printLocation",value:function(t,e){for(var i="\n\n"+(arguments.length>2&&void 0!==arguments[2]?arguments[2]:"Problem value found at: \n")+"options = {\n",o=0;o<t.length;o++){for(var n=0;n<o+1;n++)i+="  ";i+=t[o]+": {\n"}for(var r=0;r<t.length+1;r++)i+="  ";i+=e+"\n";for(var s=0;s<t.length+1;s++){for(var a=0;a<t.length-s;a++)i+="  ";i+="}\n"}return i+"\n\n"}},{key:"print",value:function(t){return Em(t).replace(/(")|(\[)|(\])|(,"__type__")/g,"").replace(/(,)/g,", ")}},{key:"levenshteinDistance",value:function(t,e){if(0===t.length)return e.length;if(0===e.length)return t.length;var i,o,n=[];for(i=0;i<=e.length;i++)n[i]=[i];for(o=0;o<=t.length;o++)n[0][o]=o;for(i=1;i<=e.length;i++)for(o=1;o<=t.length;o++)e.charAt(i-1)==t.charAt(o-1)?n[i][o]=n[i-1][o-1]:n[i][o]=Math.min(n[i-1][o-1]+1,Math.min(n[i][o-1]+1,n[i-1][o]+1));return n[e.length][t.length]}}]),t}(),Ok=Mx,Ck=yk,Sk=wk,Tk=Tx,Mk=xk,Pk=_k,Dk=Ek,Ik=Object.freeze({__proto__:null,Activator:Ok,Alea:Sx,ColorPicker:Ck,Configurator:Sk,DELETE:xx,HSVToHex:ak,HSVToRGB:sk,Hammer:Tk,Popup:Mk,RGBToHSV:nk,RGBToHex:ik,VALIDATOR_PRINT_STYLE:Pk,Validator:Dk,addClassName:function(t,e){var i=t.className.split(" "),o=e.split(" ");i=Np(i).call(i,oy(o).call(o,(function(t){return!Lg(i).call(i,t)}))),t.className=i.join(" ")},addCssText:function(t,e){var i=rk.split(t.style.cssText),o=rk.split(e),n=mx(mx({},i),o);t.style.cssText=rk.join(n)},addEventListener:Zx,binarySearchCustom:function(t,e,i,o){for(var n=0,r=0,s=t.length-1;r<=s&&n<1e4;){var a=Math.floor((r+s)/2),h=t[a],l=e(void 0===o?h[i]:h[i][o]);if(0==l)return a;-1==l?r=a+1:s=a-1,n++}return-1},binarySearchValue:function(t,e,i,o,n){var r,s,a,h,l=0,d=0,c=t.length-1;for(n=null!=n?n:function(t,e){return t==e?0:t<e?-1:1};d<=c&&l<1e4;){if(h=Math.floor(.5*(c+d)),r=t[Math.max(0,h-1)][i],s=t[h][i],a=t[Math.min(t.length-1,h+1)][i],0==n(s,e))return h;if(n(r,e)<0&&n(s,e)>0)return"before"==o?Math.max(0,h-1):h;if(n(s,e)<0&&n(a,e)>0)return"before"==o?h:Math.min(t.length-1,h+1);n(s,e)<0?d=h+1:c=h-1,l++}return-1},bridgeObject:uk,copyAndExtendArray:Ux,copyArray:Yx,deepExtend:Vx,deepObjectAssign:_x,easingFunctions:pk,equalArray:function(t,e){if(t.length!==e.length)return!1;for(var i=0,o=t.length;i<o;i++)if(t[i]!=e[i])return!1;return!0},extend:Hx,fillIfDefined:Lx,forEach:Kx,getAbsoluteLeft:Xx,getAbsoluteRight:function(t){return t.getBoundingClientRect().right},getAbsoluteTop:Gx,getScrollBarWidth:function(){var t=document.createElement("p");t.style.width="100%",t.style.height="200px";var e=document.createElement("div");e.style.position="absolute",e.style.top="0px",e.style.left="0px",e.style.visibility="hidden",e.style.width="200px",e.style.height="150px",e.style.overflow="hidden",e.appendChild(t),document.body.appendChild(e);var i=t.offsetWidth;e.style.overflow="scroll";var o=t.offsetWidth;return i==o&&(o=e.clientWidth),document.body.removeChild(e),i-o},getTarget:function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:window.event,e=null;return t&&(t.target?e=t.target:t.srcElement&&(e=t.srcElement)),e instanceof Element&&(null==e.nodeType||3!=e.nodeType||(e=e.parentNode)instanceof Element)?e:null},getType:function(t){var e=Of(t);return"object"===e?null===t?"null":t instanceof Boolean?"Boolean":t instanceof Number?"Number":t instanceof String?"String":Wp(t)?"Array":t instanceof Date?"Date":"Object":"number"===e?"Number":"boolean"===e?"Boolean":"string"===e?"String":void 0===e?"undefined":e},hasParent:function(t,e){for(var i=t;i;){if(i===e)return!0;if(!i.parentNode)return!1;i=i.parentNode}return!1},hexToHSV:hk,hexToRGB:tk,insertSort:function(t,e){for(var i=0;i<t.length;i++){var o=t[i],n=void 0;for(n=i;n>0&&e(o,t[n-1])<0;n--)t[n]=t[n-1];t[n]=o}return t},isDate:function(t){if(t instanceof Date)return!0;if(Ax(t)){if(Px.exec(t))return!0;if(!isNaN(Date.parse(t)))return!0}return!1},isNumber:zx,isObject:jx,isString:Ax,isValidHex:lk,isValidRGB:dk,isValidRGBA:ck,mergeOptions:fk,option:Jx,overrideOpacity:ek,parseColor:ok,preventDefault:function(t){t||(t=window.event),t&&(t.preventDefault?t.preventDefault():t.returnValue=!1)},pureDeepObjectAssign:kx,recursiveDOMDelete:Fx,removeClassName:function(t,e){var i=t.className.split(" "),o=e.split(" ");i=oy(i).call(i,(function(t){return!Lg(o).call(o,t)})),t.className=i.join(" ")},removeCssText:function(t,e){var i=rk.split(t.style.cssText),o=rk.split(e);for(var n in o)Object.prototype.hasOwnProperty.call(o,n)&&delete i[n];t.style.cssText=rk.join(i)},removeEventListener:Qx,selectiveBridgeObject:function(t,e){if(null!==e&&"object"===Of(e)){for(var i=mm(e),o=0;o<t.length;o++)Object.prototype.hasOwnProperty.call(e,t[o])&&"object"==Of(e[t[o]])&&(i[t[o]]=uk(e[t[o]]));return i}return null},selectiveDeepExtend:Wx,selectiveExtend:function(t,e){if(!Wp(t))throw new Error("Array with property names expected as first argument");for(var i=arguments.length,o=new Array(i>2?i-2:0),n=2;n<i;n++)o[n-2]=arguments[n];for(var r=0,s=o;r<s.length;r++)for(var a=s[r],h=0;h<t.length;h++){var l=t[h];a&&Object.prototype.hasOwnProperty.call(a,l)&&(e[l]=a[l])}return e},selectiveNotDeepExtend:qx,throttle:function(t){var e=!1;return function(){e||(e=!0,requestAnimationFrame((function(){e=!1,t()})))}},toArray:$x,topMost:vk,updateProperty:function(t,e,i){return t[e]!==i&&(t[e]=i,!0)}});function Bk(t){return jk=t,function(){var t={};Rk=0,void(Lk=jk.charAt(0)),Zk(),"strict"===Hk&&(t.strict=!0,Zk());"graph"!==Hk&&"digraph"!==Hk||(t.type=Hk,Zk());Wk===Fk.IDENTIFIER&&(t.id=Hk,Zk());if("{"!=Hk)throw o_("Angle bracket { expected");if(Zk(),Qk(t),"}"!=Hk)throw o_("Angle bracket } expected");if(Zk(),""!==Hk)throw o_("End of file expected");return Zk(),delete t.node,delete t.edge,delete t.graph,t}()}var Nk={fontsize:"font.size",fontcolor:"font.color",labelfontcolor:"font.color",fontname:"font.face",color:["color.border","color.background"],fillcolor:"color.background",tooltip:"title",labeltooltip:"title"},zk=mm(Nk);zk.color="color.color",zk.style="dashes";var Fk={NULL:0,DELIMITER:1,IDENTIFIER:2,UNKNOWN:3},Ak={"{":!0,"}":!0,"[":!0,"]":!0,";":!0,"=":!0,",":!0,"->":!0,"--":!0},jk="",Rk=0,Lk="",Hk="",Wk=Fk.NULL;function qk(){Rk++,Lk=jk.charAt(Rk)}function Vk(){return jk.charAt(Rk+1)}function Uk(t){var e=t.charCodeAt(0);return e<47?35===e||46===e:e<59?e>47:e<91?e>64:e<96?95===e:e<123&&e>96}function Yk(t,e){if(t||(t={}),e)for(var i in e)e.hasOwnProperty(i)&&(t[i]=e[i]);return t}function Xk(t,e,i){for(var o=e.split("."),n=t;o.length;){var r=o.shift();o.length?(n[r]||(n[r]={}),n=n[r]):n[r]=i}}function Gk(t,e){for(var i,o,n=null,r=[t],s=t;s.parent;)r.push(s.parent),s=s.parent;if(s.nodes)for(i=0,o=s.nodes.length;i<o;i++)if(e.id===s.nodes[i].id){n=s.nodes[i];break}for(n||(n={id:e.id},t.node&&(n.attr=Yk(n.attr,t.node))),i=r.length-1;i>=0;i--){var a,h=r[i];h.nodes||(h.nodes=[]),-1===tm(a=h.nodes).call(a,n)&&h.nodes.push(n)}e.attr&&(n.attr=Yk(n.attr,e.attr))}function Kk(t,e){if(t.edges||(t.edges=[]),t.edges.push(e),t.edge){var i=Yk({},t.edge);e.attr=Yk(i,e.attr)}}function $k(t,e,i,o,n){var r={from:e,to:i,type:o};return t.edge&&(r.attr=Yk({},t.edge)),r.attr=Yk(r.attr||{},n),null!=n&&n.hasOwnProperty("arrows")&&null!=n.arrows&&(r.arrows={to:{enabled:!0,type:n.arrows.type}},n.arrows=null),r}function Zk(){for(Wk=Fk.NULL,Hk="";" "===Lk||"\t"===Lk||"\n"===Lk||"\r"===Lk;)qk();do{var t=!1;if("#"===Lk){for(var e=Rk-1;" "===jk.charAt(e)||"\t"===jk.charAt(e);)e--;if("\n"===jk.charAt(e)||""===jk.charAt(e)){for(;""!=Lk&&"\n"!=Lk;)qk();t=!0}}if("/"===Lk&&"/"===Vk()){for(;""!=Lk&&"\n"!=Lk;)qk();t=!0}if("/"===Lk&&"*"===Vk()){for(;""!=Lk;){if("*"===Lk&&"/"===Vk()){qk(),qk();break}qk()}t=!0}for(;" "===Lk||"\t"===Lk||"\n"===Lk||"\r"===Lk;)qk()}while(t);if(""!==Lk){var i=Lk+Vk();if(Ak[i])return Wk=Fk.DELIMITER,Hk=i,qk(),void qk();if(Ak[Lk])return Wk=Fk.DELIMITER,Hk=Lk,void qk();if(Uk(Lk)||"-"===Lk){for(Hk+=Lk,qk();Uk(Lk);)Hk+=Lk,qk();return"false"===Hk?Hk=!1:"true"===Hk?Hk=!0:isNaN(Number(Hk))||(Hk=Number(Hk)),void(Wk=Fk.IDENTIFIER)}if('"'===Lk){for(qk();""!=Lk&&('"'!=Lk||'"'===Lk&&'"'===Vk());)'"'===Lk?(Hk+=Lk,qk()):"\\"===Lk&&"n"===Vk()?(Hk+="\n",qk()):Hk+=Lk,qk();if('"'!=Lk)throw o_('End of string " expected');return qk(),void(Wk=Fk.IDENTIFIER)}for(Wk=Fk.UNKNOWN;""!=Lk;)Hk+=Lk,qk();throw new SyntaxError('Syntax error in part "'+n_(Hk,30)+'"')}Wk=Fk.DELIMITER}function Qk(t){for(;""!==Hk&&"}"!=Hk;)Jk(t),";"===Hk&&Zk()}function Jk(t){var e=t_(t);if(e)e_(t,e);else{var i=function(t){if("node"===Hk)return Zk(),t.node=i_(),"node";if("edge"===Hk)return Zk(),t.edge=i_(),"edge";if("graph"===Hk)return Zk(),t.graph=i_(),"graph";return null}(t);if(!i){if(Wk!=Fk.IDENTIFIER)throw o_("Identifier expected");var o=Hk;if(Zk(),"="===Hk){if(Zk(),Wk!=Fk.IDENTIFIER)throw o_("Identifier expected");t[o]=Hk,Zk()}else!function(t,e){var i={id:e},o=i_();o&&(i.attr=o);Gk(t,i),e_(t,e)}(t,o)}}}function t_(t){var e=null;if("subgraph"===Hk&&((e={}).type="subgraph",Zk(),Wk===Fk.IDENTIFIER&&(e.id=Hk,Zk())),"{"===Hk){if(Zk(),e||(e={}),e.parent=t,e.node=t.node,e.edge=t.edge,e.graph=t.graph,Qk(e),"}"!=Hk)throw o_("Angle bracket } expected");Zk(),delete e.node,delete e.edge,delete e.graph,delete e.parent,t.subgraphs||(t.subgraphs=[]),t.subgraphs.push(e)}return e}function e_(t,e){for(;"->"===Hk||"--"===Hk;){var i,o=Hk;Zk();var n=t_(t);if(n)i=n;else{if(Wk!=Fk.IDENTIFIER)throw o_("Identifier or subgraph expected");Gk(t,{id:i=Hk}),Zk()}Kk(t,$k(t,e,i,o,i_())),e=i}}function i_(){for(var t,e,i=null,o={dashed:!0,solid:!1,dotted:[1,5]},n={dot:"circle",box:"box",crow:"crow",curve:"curve",icurve:"inv_curve",normal:"triangle",inv:"inv_triangle",diamond:"diamond",tee:"bar",vee:"vee"},r=new Array,s=new Array;"["===Hk;){for(Zk(),i={};""!==Hk&&"]"!=Hk;){if(Wk!=Fk.IDENTIFIER)throw o_("Attribute name expected");var a=Hk;if(Zk(),"="!=Hk)throw o_("Equal sign = expected");if(Zk(),Wk!=Fk.IDENTIFIER)throw o_("Attribute value expected");var h=Hk;"style"===a&&(h=o[h]),"arrowhead"===a&&(a="arrows",h={to:{enabled:!0,type:n[h]}}),"arrowtail"===a&&(a="arrows",h={from:{enabled:!0,type:n[h]}}),r.push({attr:i,name:a,value:h}),s.push(a),Zk(),","==Hk&&Zk()}if("]"!=Hk)throw o_("Bracket ] expected");Zk()}if(Lg(s).call(s,"dir")){var l={arrows:{}};for(t=0;t<r.length;t++)if("arrows"===r[t].name)if(null!=r[t].value.to)l.arrows.to=t;else{if(null==r[t].value.from)throw o_("Invalid value of arrows");l.arrows.from=t}else"dir"===r[t].name&&(l.dir=t);var d,c,u=r[l.dir].value;if(!Lg(s).call(s,"arrows"))if("both"===u)r.push({attr:r[l.dir].attr,name:"arrows",value:{to:{enabled:!0}}}),l.arrows.to=r.length-1,r.push({attr:r[l.dir].attr,name:"arrows",value:{from:{enabled:!0}}}),l.arrows.from=r.length-1;else if("forward"===u)r.push({attr:r[l.dir].attr,name:"arrows",value:{to:{enabled:!0}}}),l.arrows.to=r.length-1;else if("back"===u)r.push({attr:r[l.dir].attr,name:"arrows",value:{from:{enabled:!0}}}),l.arrows.from=r.length-1;else{if("none"!==u)throw o_('Invalid dir type "'+u+'"');r.push({attr:r[l.dir].attr,name:"arrows",value:""}),l.arrows.to=r.length-1}if("both"===u)l.arrows.to&&l.arrows.from?(c=r[l.arrows.to].value.to.type,d=r[l.arrows.from].value.from.type,r[l.arrows.to]={attr:r[l.arrows.to].attr,name:r[l.arrows.to].name,value:{to:{enabled:!0,type:c},from:{enabled:!0,type:d}}},vg(r).call(r,l.arrows.from,1)):l.arrows.to?(c=r[l.arrows.to].value.to.type,d="arrow",r[l.arrows.to]={attr:r[l.arrows.to].attr,name:r[l.arrows.to].name,value:{to:{enabled:!0,type:c},from:{enabled:!0,type:d}}}):l.arrows.from&&(c="arrow",d=r[l.arrows.from].value.from.type,r[l.arrows.from]={attr:r[l.arrows.from].attr,name:r[l.arrows.from].name,value:{to:{enabled:!0,type:c},from:{enabled:!0,type:d}}});else if("back"===u)l.arrows.to&&l.arrows.from?(c="",d=r[l.arrows.from].value.from.type,r[l.arrows.from]={attr:r[l.arrows.from].attr,name:r[l.arrows.from].name,value:{to:{enabled:!0,type:c},from:{enabled:!0,type:d}}}):l.arrows.to?(c="",d="arrow",l.arrows.from=l.arrows.to,r[l.arrows.from]={attr:r[l.arrows.from].attr,name:r[l.arrows.from].name,value:{to:{enabled:!0,type:c},from:{enabled:!0,type:d}}}):l.arrows.from&&(c="",d=r[l.arrows.from].value.from.type,r[l.arrows.to]={attr:r[l.arrows.from].attr,name:r[l.arrows.from].name,value:{to:{enabled:!0,type:c},from:{enabled:!0,type:d}}}),r[l.arrows.from]={attr:r[l.arrows.from].attr,name:r[l.arrows.from].name,value:{from:{enabled:!0,type:r[l.arrows.from].value.from.type}}};else if("none"===u){var f;r[f=l.arrows.to?l.arrows.to:l.arrows.from]={attr:r[f].attr,name:r[f].name,value:""}}else{if("forward"!==u)throw o_('Invalid dir type "'+u+'"');l.arrows.to&&l.arrows.from||l.arrows.to?(c=r[l.arrows.to].value.to.type,d="",r[l.arrows.to]={attr:r[l.arrows.to].attr,name:r[l.arrows.to].name,value:{to:{enabled:!0,type:c},from:{enabled:!0,type:d}}}):l.arrows.from&&(c="arrow",d="",l.arrows.to=l.arrows.from,r[l.arrows.to]={attr:r[l.arrows.to].attr,name:r[l.arrows.to].name,value:{to:{enabled:!0,type:c},from:{enabled:!0,type:d}}}),r[l.arrows.to]={attr:r[l.arrows.to].attr,name:r[l.arrows.to].name,value:{to:{enabled:!0,type:r[l.arrows.to].value.to.type}}}}vg(r).call(r,l.dir,1)}if(Lg(s).call(s,"penwidth")){var p=[];for(e=r.length,t=0;t<e;t++)"width"!==r[t].name&&("penwidth"===r[t].name&&(r[t].name="width"),p.push(r[t]));r=p}for(e=r.length,t=0;t<e;t++)Xk(r[t].attr,r[t].name,r[t].value);return i}function o_(t){return new SyntaxError(t+', got "'+n_(Hk,30)+'" (char '+Rk+")")}function n_(t,e){return t.length<=e?t:t.substr(0,27)+"..."}function r_(t,e,i){for(var o=e.split("."),n=o.pop(),r=t,s=0;s<o.length;s++){var a=o[s];a in r||(r[a]={}),r=r[a]}return r[n]=i,t}function s_(t,e){var i={};for(var o in t)if(t.hasOwnProperty(o)){var n=e[o];Wp(n)?Cv(n).call(n,(function(e){r_(i,e,t[o])})):r_(i,"string"==typeof n?n:o,t[o])}return i}function a_(t){var e,i=Bk(t),o={nodes:[],edges:[],options:{}};i.nodes&&Cv(e=i.nodes).call(e,(function(t){var e={id:t.id,label:String(t.label||t.id)};Yk(e,s_(t.attr,Nk)),e.image&&(e.shape="image"),o.nodes.push(e)}));if(i.edges){var n,r=function(t){var e={from:t.from,to:t.to};return Yk(e,s_(t.attr,zk)),null==e.arrows&&"->"===t.type&&(e.arrows="to"),e};Cv(n=i.edges).call(n,(function(t){var e,i,n,s,a,h,l;(e=t.from instanceof Object?t.from.nodes:{id:t.from},i=t.to instanceof Object?t.to.nodes:{id:t.to},t.from instanceof Object&&t.from.edges)&&Cv(n=t.from.edges).call(n,(function(t){var e=r(t);o.edges.push(e)}));(a=i,h=function(e,i){var n=$k(o,e.id,i.id,t.type,t.attr),s=r(n);o.edges.push(s)},Wp(s=e)?Cv(s).call(s,(function(t){Wp(a)?Cv(a).call(a,(function(e){h(t,e)})):h(t,a)})):Wp(a)?Cv(a).call(a,(function(t){h(s,t)})):h(s,a),t.to instanceof Object&&t.to.edges)&&Cv(l=t.to.edges).call(l,(function(t){var e=r(t);o.edges.push(e)}))}))}return i.attr&&(o.options=i.attr),o}var h_=Object.freeze({__proto__:null,DOTToGraph:a_,parseDOT:Bk});function l_(t,e){var i,o={edges:{inheritColor:!1},nodes:{fixed:!1,parseColor:!1}};null!=e&&(null!=e.fixed&&(o.nodes.fixed=e.fixed),null!=e.parseColor&&(o.nodes.parseColor=e.parseColor),null!=e.inheritColor&&(o.edges.inheritColor=e.inheritColor));var n=t.edges,r=Qp(n).call(n,(function(t){var e={from:t.source,id:t.id,to:t.target};return null!=t.attributes&&(e.attributes=t.attributes),null!=t.label&&(e.label=t.label),null!=t.attributes&&null!=t.attributes.title&&(e.title=t.attributes.title),"Directed"===t.type&&(e.arrows="to"),t.color&&!1===o.edges.inheritColor&&(e.color=t.color),e}));return{nodes:Qp(i=t.nodes).call(i,(function(t){var e={id:t.id,fixed:o.nodes.fixed&&null!=t.x&&null!=t.y};return null!=t.attributes&&(e.attributes=t.attributes),null!=t.label&&(e.label=t.label),null!=t.size&&(e.size=t.size),null!=t.attributes&&null!=t.attributes.title&&(e.title=t.attributes.title),null!=t.title&&(e.title=t.title),null!=t.x&&(e.x=t.x),null!=t.y&&(e.y=t.y),null!=t.color&&(!0===o.nodes.parseColor?e.color=t.color:e.color={background:t.color,border:t.color,highlight:{background:t.color,border:t.color},hover:{background:t.color,border:t.color}}),e})),edges:r}}var d_=Object.freeze({__proto__:null,parseGephi:l_}),c_=Object.freeze({__proto__:null,cn:{addDescription:"单击空白处放置新节点。",addEdge:"添加连接线",addNode:"添加节点",back:"返回",close:"關閉",createEdgeError:"无法将连接线连接到群集。",del:"删除选定",deleteClusterError:"无法删除群集。",edgeDescription:"单击某个节点并将该连接线拖动到另一个节点以连接它们。",edit:"编辑",editClusterError:"无法编辑群集。",editEdge:"编辑连接线",editEdgeDescription:"单击控制节点并将它们拖到节点上连接。",editNode:"编辑节点"},cs:{addDescription:"Kluknutím do prázdného prostoru můžete přidat nový vrchol.",addEdge:"Přidat hranu",addNode:"Přidat vrchol",back:"Zpět",close:"Zavřít",createEdgeError:"Nelze připojit hranu ke shluku.",del:"Smazat výběr",deleteClusterError:"Nelze mazat shluky.",edgeDescription:"Přetažením z jednoho vrcholu do druhého můžete spojit tyto vrcholy novou hranou.",edit:"Upravit",editClusterError:"Nelze upravovat shluky.",editEdge:"Upravit hranu",editEdgeDescription:"Přetažením kontrolního vrcholu hrany ji můžete připojit k jinému vrcholu.",editNode:"Upravit vrchol"},de:{addDescription:"Klicke auf eine freie Stelle, um einen neuen Knoten zu plazieren.",addEdge:"Kante hinzufügen",addNode:"Knoten hinzufügen",back:"Zurück",close:"Schließen",createEdgeError:"Es ist nicht möglich, Kanten mit Clustern zu verbinden.",del:"Lösche Auswahl",deleteClusterError:"Cluster können nicht gelöscht werden.",edgeDescription:"Klicke auf einen Knoten und ziehe die Kante zu einem anderen Knoten, um diese zu verbinden.",edit:"Editieren",editClusterError:"Cluster können nicht editiert werden.",editEdge:"Kante editieren",editEdgeDescription:"Klicke auf die Verbindungspunkte und ziehe diese auf einen Knoten, um sie zu verbinden.",editNode:"Knoten editieren"},en:{addDescription:"Click in an empty space to place a new node.",addEdge:"Add Edge",addNode:"Add Node",back:"Back",close:"Close",createEdgeError:"Cannot link edges to a cluster.",del:"Delete selected",deleteClusterError:"Clusters cannot be deleted.",edgeDescription:"Click on a node and drag the edge to another node to connect them.",edit:"Edit",editClusterError:"Clusters cannot be edited.",editEdge:"Edit Edge",editEdgeDescription:"Click on the control points and drag them to a node to connect to it.",editNode:"Edit Node"},es:{addDescription:"Haga clic en un lugar vacío para colocar un nuevo nodo.",addEdge:"Añadir arista",addNode:"Añadir nodo",back:"Atrás",close:"Cerrar",createEdgeError:"No se puede conectar una arista a un grupo.",del:"Eliminar selección",deleteClusterError:"No es posible eliminar grupos.",edgeDescription:"Haga clic en un nodo y arrastre la arista hacia otro nodo para conectarlos.",edit:"Editar",editClusterError:"No es posible editar grupos.",editEdge:"Editar arista",editEdgeDescription:"Haga clic en un punto de control y arrastrelo a un nodo para conectarlo.",editNode:"Editar nodo"},fr:{addDescription:"Cliquez dans un endroit vide pour placer un nœud.",addEdge:"Ajouter un lien",addNode:"Ajouter un nœud",back:"Retour",close:"Fermer",createEdgeError:"Impossible de créer un lien vers un cluster.",del:"Effacer la sélection",deleteClusterError:"Les clusters ne peuvent pas être effacés.",edgeDescription:"Cliquez sur un nœud et glissez le lien vers un autre nœud pour les connecter.",edit:"Éditer",editClusterError:"Les clusters ne peuvent pas être édités.",editEdge:"Éditer le lien",editEdgeDescription:"Cliquez sur les points de contrôle et glissez-les pour connecter un nœud.",editNode:"Éditer le nœud"},it:{addDescription:"Clicca per aggiungere un nuovo nodo",addEdge:"Aggiungi un vertice",addNode:"Aggiungi un nodo",back:"Indietro",close:"Chiudere",createEdgeError:"Non si possono collegare vertici ad un cluster",del:"Cancella la selezione",deleteClusterError:"I cluster non possono essere cancellati",edgeDescription:"Clicca su un nodo e trascinalo ad un altro nodo per connetterli.",edit:"Modifica",editClusterError:"I clusters non possono essere modificati.",editEdge:"Modifica il vertice",editEdgeDescription:"Clicca sui Punti di controllo e trascinali ad un nodo per connetterli.",editNode:"Modifica il nodo"},nl:{addDescription:"Klik op een leeg gebied om een nieuwe node te maken.",addEdge:"Link toevoegen",addNode:"Node toevoegen",back:"Terug",close:"Sluiten",createEdgeError:"Kan geen link maken naar een cluster.",del:"Selectie verwijderen",deleteClusterError:"Clusters kunnen niet worden verwijderd.",edgeDescription:"Klik op een node en sleep de link naar een andere node om ze te verbinden.",edit:"Wijzigen",editClusterError:"Clusters kunnen niet worden aangepast.",editEdge:"Link wijzigen",editEdgeDescription:"Klik op de verbindingspunten en sleep ze naar een node om daarmee te verbinden.",editNode:"Node wijzigen"},pt:{addDescription:"Clique em um espaço em branco para adicionar um novo nó",addEdge:"Adicionar aresta",addNode:"Adicionar nó",back:"Voltar",close:"Fechar",createEdgeError:"Não foi possível linkar arestas a um cluster.",del:"Remover selecionado",deleteClusterError:"Clusters não puderam ser removidos.",edgeDescription:"Clique em um nó e arraste a aresta até outro nó para conectá-los",edit:"Editar",editClusterError:"Clusters não puderam ser editados.",editEdge:"Editar aresta",editEdgeDescription:"Clique nos pontos de controle e os arraste para um nó para conectá-los",editNode:"Editar nó"},ru:{addDescription:"Кликните в свободное место, чтобы добавить новый узел.",addEdge:"Добавить ребро",addNode:"Добавить узел",back:"Назад",close:"Закрывать",createEdgeError:"Невозможно соединить ребра в кластер.",del:"Удалить выбранное",deleteClusterError:"Кластеры не могут быть удалены",edgeDescription:"Кликните на узел и протяните ребро к другому узлу, чтобы соединить их.",edit:"Редактировать",editClusterError:"Кластеры недоступны для редактирования.",editEdge:"Редактировать ребро",editEdgeDescription:"Кликните на контрольные точки и перетащите их в узел, чтобы подключиться к нему.",editNode:"Редактировать узел"},uk:{addDescription:"Kлікніть на вільне місце, щоб додати новий вузол.",addEdge:"Додати край",addNode:"Додати вузол",back:"Назад",close:"Закрити",createEdgeError:"Не можливо об'єднати краї в групу.",del:"Видалити обране",deleteClusterError:"Групи не можуть бути видалені.",edgeDescription:"Клікніть на вузол і перетягніть край до іншого вузла, щоб їх з'єднати.",edit:"Редагувати",editClusterError:"Групи недоступні для редагування.",editEdge:"Редагувати край",editEdgeDescription:"Клікніть на контрольні точки і перетягніть їх у вузол, щоб підключитися до нього.",editNode:"Редагувати вузол"}});var u_=function(){function t(){pu(this,t),this.NUM_ITERATIONS=4,this.image=new Image,this.canvas=document.createElement("canvas")}return Nf(t,[{key:"init",value:function(){if(!this.initialized()){this.src=this.image.src;var t=this.image.width,e=this.image.height;this.width=t,this.height=e;var i=Math.floor(e/2),o=Math.floor(e/4),n=Math.floor(e/8),r=Math.floor(e/16),s=Math.floor(t/2),a=Math.floor(t/4),h=Math.floor(t/8),l=Math.floor(t/16);this.canvas.width=3*a,this.canvas.height=i,this.coordinates=[[0,0,s,i],[s,0,a,o],[s,o,h,n],[5*h,o,l,r]],this._fillMipMap()}}},{key:"initialized",value:function(){return void 0!==this.coordinates}},{key:"_fillMipMap",value:function(){var t=this.canvas.getContext("2d"),e=this.coordinates[0];t.drawImage(this.image,e[0],e[1],e[2],e[3]);for(var i=1;i<this.NUM_ITERATIONS;i++){var o=this.coordinates[i-1],n=this.coordinates[i];t.drawImage(this.canvas,o[0],o[1],o[2],o[3],n[0],n[1],n[2],n[3])}}},{key:"drawImageAtPosition",value:function(t,e,i,o,n,r){if(this.initialized())if(e>2){e*=.5;for(var s=0;e>2&&s<this.NUM_ITERATIONS;)e*=.5,s+=1;s>=this.NUM_ITERATIONS&&(s=this.NUM_ITERATIONS-1);var a=this.coordinates[s];t.drawImage(this.canvas,a[0],a[1],a[2],a[3],i,o,n,r)}else t.drawImage(this.image,i,o,n,r)}}]),t}(),f_=function(){function t(e){pu(this,t),this.images={},this.imageBroken={},this.callback=e}return Nf(t,[{key:"_tryloadBrokenUrl",value:function(t,e,i){void 0!==t&&void 0!==i&&(void 0!==e?(i.image.onerror=function(){console.error("Could not load brokenImage:",e)},i.image.src=e):console.warn("No broken url image defined"))}},{key:"_redrawWithImage",value:function(t){this.callback&&this.callback(t)}},{key:"load",value:function(t,e){var i=this,o=this.images[t];if(o)return o;var n=new u_;return this.images[t]=n,n.image.onload=function(){i._fixImageCoordinates(n.image),n.init(),i._redrawWithImage(n)},n.image.onerror=function(){console.error("Could not load image:",t),i._tryloadBrokenUrl(t,e,n)},n.image.src=t,n}},{key:"_fixImageCoordinates",value:function(t){0===t.width&&(document.body.appendChild(t),t.width=t.offsetWidth,t.height=t.offsetHeight,document.body.removeChild(t))}}]),t}(),p_={},v_={get exports(){return p_},set exports(t){p_=t}},g_={},y_={get exports(){return g_},set exports(t){g_=t}},m_=s((function(){if("function"==typeof ArrayBuffer){var t=new ArrayBuffer(8);Object.isExtensible(t)&&Object.defineProperty(t,"a",{value:8})}})),b_=s,w_=et,x_=x,k_=m_,__=Object.isExtensible,E_=b_((function(){__(1)}))||k_?function(t){return!!w_(t)&&((!k_||"ArrayBuffer"!=x_(t))&&(!__||__(t)))}:__,O_=!s((function(){return Object.isExtensible(Object.preventExtensions({}))})),C_=Ti,S_=y,T_=Yi,M_=et,P_=Qt,D_=Ze.f,I_=Eh,B_=Sh,N_=E_,z_=O_,F_=!1,A_=oe("meta"),j_=0,R_=function(t){D_(t,A_,{value:{objectID:"O"+j_++,weakData:{}}})},L_=y_.exports={enable:function(){L_.enable=function(){},F_=!0;var t=I_.f,e=S_([].splice),i={};i[A_]=1,t(i).length&&(I_.f=function(i){for(var o=t(i),n=0,r=o.length;n<r;n++)if(o[n]===A_){e(o,n,1);break}return o},C_({target:"Object",stat:!0,forced:!0},{getOwnPropertyNames:B_.f}))},fastKey:function(t,e){if(!M_(t))return"symbol"==typeof t?t:("string"==typeof t?"S":"P")+t;if(!P_(t,A_)){if(!N_(t))return"F";if(!e)return"E";R_(t)}return t[A_].objectID},getWeakData:function(t,e){if(!P_(t,A_)){if(!N_(t))return!0;if(!e)return!1;R_(t)}return t[A_].weakData},onFreeze:function(t){return z_&&F_&&N_(t)&&!P_(t,A_)&&R_(t),t}};T_[A_]=!0;var H_=$e,W_=B,q_=ii,V_=St,U_=Zs,Y_=Li,X_=ht,G_=Ia,K_=Oa,$_=Us,Z_=TypeError,Q_=function(t,e){this.stopped=t,this.result=e},J_=Q_.prototype,tE=function(t,e,i){var o,n,r,s,a,h,l,d=i&&i.that,c=!(!i||!i.AS_ENTRIES),u=!(!i||!i.IS_RECORD),f=!(!i||!i.IS_ITERATOR),p=!(!i||!i.INTERRUPTED),v=H_(e,d),g=function(t){return o&&$_(o,"normal",t),new Q_(!0,t)},y=function(t){return c?(q_(t),p?v(t[0],t[1],g):v(t[0],t[1])):p?v(t,g):v(t)};if(u)o=t.iterator;else if(f)o=t;else{if(!(n=K_(t)))throw Z_(V_(t)+" is not iterable");if(U_(n)){for(r=0,s=Y_(t);s>r;r++)if((a=y(t[r]))&&X_(J_,a))return a;return new Q_(!1)}o=G_(t,n)}for(h=u?t.next:o.next;!(l=W_(h,o)).done;){try{a=y(l.value)}catch(t){$_(o,"throw",t)}if("object"==typeof a&&a&&X_(J_,a))return a}return new Q_(!1)},eE=ht,iE=TypeError,oE=function(t,e){if(eE(e,t))return t;throw iE("Incorrect invocation")},nE=Ti,rE=r,sE=g_,aE=s,hE=gi,lE=tE,dE=oE,cE=T,uE=et,fE=es,pE=Ze.f,vE=vl.forEach,gE=P,yE=Xn.set,mE=Xn.getterFor,bE=function(t,e,i){var o,n=-1!==t.indexOf("Map"),r=-1!==t.indexOf("Weak"),s=n?"set":"add",a=rE[t],h=a&&a.prototype,l={};if(gE&&cE(a)&&(r||h.forEach&&!aE((function(){(new a).entries().next()})))){var d=(o=e((function(e,i){yE(dE(e,d),{type:t,collection:new a}),null!=i&&lE(i,e[s],{that:e,AS_ENTRIES:n})}))).prototype,c=mE(t);vE(["add","clear","delete","forEach","get","has","set","keys","values","entries"],(function(t){var e="add"==t||"set"==t;!(t in h)||r&&"clear"==t||hE(d,t,(function(i,o){var n=c(this).collection;if(!e&&r&&!uE(i))return"get"==t&&void 0;var s=n[t](0===i?0:i,o);return e?this:s}))})),r||pE(d,"size",{configurable:!0,get:function(){return c(this).collection.size}})}else o=i.getConstructor(e,t,n,s),sE.enable();return fE(o,t,!1,!0),l[t]=o,nE({global:!0,forced:!0},l),r||i.setStrong(o,t,n),o},wE=Fr,xE=function(t,e,i){for(var o in e)i&&i.unsafe&&t[o]?t[o]=e[o]:wE(t,o,e[o],i);return t},kE=at,_E=Lh,EE=P,OE=ue("species"),CE=function(t){var e=kE(t);EE&&e&&!e[OE]&&_E(e,OE,{configurable:!0,get:function(){return this}})},SE=Or,TE=Lh,ME=xE,PE=$e,DE=oE,IE=Y,BE=tE,NE=Is,zE=Bs,FE=CE,AE=P,jE=g_.fastKey,RE=Xn.set,LE=Xn.getterFor,HE={getConstructor:function(t,e,i,o){var n=t((function(t,n){DE(t,r),RE(t,{type:e,index:SE(null),first:void 0,last:void 0,size:0}),AE||(t.size=0),IE(n)||BE(n,t[o],{that:t,AS_ENTRIES:i})})),r=n.prototype,s=LE(e),a=function(t,e,i){var o,n,r=s(t),a=h(t,e);return a?a.value=i:(r.last=a={index:n=jE(e,!0),key:e,value:i,previous:o=r.last,next:void 0,removed:!1},r.first||(r.first=a),o&&(o.next=a),AE?r.size++:t.size++,"F"!==n&&(r.index[n]=a)),t},h=function(t,e){var i,o=s(t),n=jE(e);if("F"!==n)return o.index[n];for(i=o.first;i;i=i.next)if(i.key==e)return i};return ME(r,{clear:function(){for(var t=s(this),e=t.index,i=t.first;i;)i.removed=!0,i.previous&&(i.previous=i.previous.next=void 0),delete e[i.index],i=i.next;t.first=t.last=void 0,AE?t.size=0:this.size=0},delete:function(t){var e=this,i=s(e),o=h(e,t);if(o){var n=o.next,r=o.previous;delete i.index[o.index],o.removed=!0,r&&(r.next=n),n&&(n.previous=r),i.first==o&&(i.first=n),i.last==o&&(i.last=r),AE?i.size--:e.size--}return!!o},forEach:function(t){for(var e,i=s(this),o=PE(t,arguments.length>1?arguments[1]:void 0);e=e?e.next:i.first;)for(o(e.value,e.key,this);e&&e.removed;)e=e.previous},has:function(t){return!!h(this,t)}}),ME(r,i?{get:function(t){var e=h(this,t);return e&&e.value},set:function(t,e){return a(this,0===t?0:t,e)}}:{add:function(t){return a(this,t=0===t?0:t,t)}}),AE&&TE(r,"size",{configurable:!0,get:function(){return s(this).size}}),n},setStrong:function(t,e,i){var o=e+" Iterator",n=LE(e),r=LE(o);NE(t,e,(function(t,e){RE(this,{type:o,target:t,state:n(t),kind:e,last:void 0})}),(function(){for(var t=r(this),e=t.kind,i=t.last;i&&i.removed;)i=i.previous;return t.target&&(t.last=i=i?i.next:t.state.first)?zE("keys"==e?i.key:"values"==e?i.value:[i.key,i.value],!1):(t.target=void 0,zE(void 0,!0))}),i?"entries":"values",!i,!0),FE(e)}};bE("Map",(function(t){return function(){return t(this,arguments.length?arguments[0]:void 0)}}),HE);var WE=it.Map;v_.exports=WE;var qE=e(p_),VE=function(){function t(){pu(this,t),this.clear(),this._defaultIndex=0,this._groupIndex=0,this._defaultGroups=[{border:"#2B7CE9",background:"#97C2FC",highlight:{border:"#2B7CE9",background:"#D2E5FF"},hover:{border:"#2B7CE9",background:"#D2E5FF"}},{border:"#FFA500",background:"#FFFF00",highlight:{border:"#FFA500",background:"#FFFFA3"},hover:{border:"#FFA500",background:"#FFFFA3"}},{border:"#FA0A10",background:"#FB7E81",highlight:{border:"#FA0A10",background:"#FFAFB1"},hover:{border:"#FA0A10",background:"#FFAFB1"}},{border:"#41A906",background:"#7BE141",highlight:{border:"#41A906",background:"#A1EC76"},hover:{border:"#41A906",background:"#A1EC76"}},{border:"#E129F0",background:"#EB7DF4",highlight:{border:"#E129F0",background:"#F0B3F5"},hover:{border:"#E129F0",background:"#F0B3F5"}},{border:"#7C29F0",background:"#AD85E4",highlight:{border:"#7C29F0",background:"#D3BDF0"},hover:{border:"#7C29F0",background:"#D3BDF0"}},{border:"#C37F00",background:"#FFA807",highlight:{border:"#C37F00",background:"#FFCA66"},hover:{border:"#C37F00",background:"#FFCA66"}},{border:"#4220FB",background:"#6E6EFD",highlight:{border:"#4220FB",background:"#9B9BFD"},hover:{border:"#4220FB",background:"#9B9BFD"}},{border:"#FD5A77",background:"#FFC0CB",highlight:{border:"#FD5A77",background:"#FFD1D9"},hover:{border:"#FD5A77",background:"#FFD1D9"}},{border:"#4AD63A",background:"#C2FABC",highlight:{border:"#4AD63A",background:"#E6FFE3"},hover:{border:"#4AD63A",background:"#E6FFE3"}},{border:"#990000",background:"#EE0000",highlight:{border:"#BB0000",background:"#FF3333"},hover:{border:"#BB0000",background:"#FF3333"}},{border:"#FF6000",background:"#FF6000",highlight:{border:"#FF6000",background:"#FF6000"},hover:{border:"#FF6000",background:"#FF6000"}},{border:"#97C2FC",background:"#2B7CE9",highlight:{border:"#D2E5FF",background:"#2B7CE9"},hover:{border:"#D2E5FF",background:"#2B7CE9"}},{border:"#399605",background:"#255C03",highlight:{border:"#399605",background:"#255C03"},hover:{border:"#399605",background:"#255C03"}},{border:"#B70054",background:"#FF007E",highlight:{border:"#B70054",background:"#FF007E"},hover:{border:"#B70054",background:"#FF007E"}},{border:"#AD85E4",background:"#7C29F0",highlight:{border:"#D3BDF0",background:"#7C29F0"},hover:{border:"#D3BDF0",background:"#7C29F0"}},{border:"#4557FA",background:"#000EA1",highlight:{border:"#6E6EFD",background:"#000EA1"},hover:{border:"#6E6EFD",background:"#000EA1"}},{border:"#FFC0CB",background:"#FD5A77",highlight:{border:"#FFD1D9",background:"#FD5A77"},hover:{border:"#FFD1D9",background:"#FD5A77"}},{border:"#C2FABC",background:"#74D66A",highlight:{border:"#E6FFE3",background:"#74D66A"},hover:{border:"#E6FFE3",background:"#74D66A"}},{border:"#EE0000",background:"#990000",highlight:{border:"#FF3333",background:"#BB0000"},hover:{border:"#FF3333",background:"#BB0000"}}],this.options={},this.defaultOptions={useDefaultGroups:!0},wo(this.options,this.defaultOptions)}return Nf(t,[{key:"setOptions",value:function(t){var e=["useDefaultGroups"];if(void 0!==t)for(var i in t)if(Object.prototype.hasOwnProperty.call(t,i)&&-1===tm(e).call(e,i)){var o=t[i];this.add(i,o)}}},{key:"clear",value:function(){this._groups=new qE,this._groupNames=[]}},{key:"get",value:function(t){var e=!(arguments.length>1&&void 0!==arguments[1])||arguments[1],i=this._groups.get(t);if(void 0===i&&e)if(!1===this.options.useDefaultGroups&&this._groupNames.length>0){var o=this._groupIndex%this._groupNames.length;++this._groupIndex,(i={}).color=this._groups.get(this._groupNames[o]),this._groups.set(t,i)}else{var n=this._defaultIndex%this._defaultGroups.length;this._defaultIndex++,(i={}).color=this._defaultGroups[n],this._groups.set(t,i)}return i}},{key:"add",value:function(t,e){return this._groups.has(t)||this._groupNames.push(t),this._groups.set(t,e),e}}]),t}(),UE={},YE={get exports(){return UE},set exports(t){UE=t}};Ti({target:"Number",stat:!0},{isNaN:function(t){return t!=t}});var XE=it.Number.isNaN;YE.exports=XE;var GE=e(UE),KE={},$E={get exports(){return KE},set exports(t){KE=t}},ZE=r.isFinite,QE=Number.isFinite||function(t){return"number"==typeof t&&ZE(t)};Ti({target:"Number",stat:!0},{isFinite:QE});var JE=it.Number.isFinite;$E.exports=JE;var tO=e(KE),eO={},iO={get exports(){return eO},set exports(t){eO=t}},oO=vl.some;Ti({target:"Array",proto:!0,forced:!vv("some")},{some:function(t){return oO(this,t,arguments.length>1?arguments[1]:void 0)}});var nO=jo("Array").some,rO=ht,sO=nO,aO=Array.prototype,hO=function(t){var e=t.some;return t===aO||rO(aO,t)&&e===aO.some?sO:e},lO=hO;iO.exports=lO;var dO=e(eO);function cO(t){if(void 0===t)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return t}var uO={},fO={get exports(){return uO},set exports(t){uO=t}},pO={},vO=ym;({get exports(){return pO},set exports(t){pO=t}}).exports=vO,fO.exports=pO;var gO=e(uO),yO={},mO={get exports(){return yO},set exports(t){yO=t}},bO={},wO={get exports(){return bO},set exports(t){bO=t}};Ti({target:"Object",stat:!0},{setPrototypeOf:ys});var xO=it.Object.setPrototypeOf;wO.exports=xO,mO.exports=bO;var kO=e(yO),_O={},EO={get exports(){return _O},set exports(t){_O=t}},OO={},CO=Vo;({get exports(){return OO},set exports(t){OO=t}}).exports=CO,EO.exports=OO;var SO=e(_O);function TO(t,e){var i;return TO=kO?SO(i=kO).call(i):function(t,e){return t.__proto__=e,t},TO(t,e)}function MO(t,e){if("function"!=typeof e&&null!==e)throw new TypeError("Super expression must either be null or a function");t.prototype=gO(e&&e.prototype,{constructor:{value:t,writable:!0,configurable:!0}}),bu(t,"prototype",{writable:!1}),e&&TO(t,e)}function PO(t,e){if(e&&("object"===Of(e)||"function"==typeof e))return e;if(void 0!==e)throw new TypeError("Derived constructors may only return object or undefined");return cO(t)}var DO={},IO={get exports(){return DO},set exports(t){DO=t}},BO={},NO=Yg;({get exports(){return BO},set exports(t){BO=t}}).exports=NO,IO.exports=BO;var zO=e(DO);function FO(t){var e;return FO=kO?SO(e=zO).call(e):function(t){return t.__proto__||zO(t)},FO(t)}var AO={},jO={get exports(){return AO},set exports(t){AO=t}},RO={};!function(t){var e=wu,i=mf;function o(n){return t.exports=o="function"==typeof e&&"symbol"==typeof i?function(t){return typeof t}:function(t){return t&&"function"==typeof e&&t.constructor===e&&t!==e.prototype?"symbol":typeof t},t.exports.__esModule=!0,t.exports.default=t.exports,o(n)}t.exports=o,t.exports.__esModule=!0,t.exports.default=t.exports}({get exports(){return RO},set exports(t){RO=t}});var LO={},HO={get exports(){return LO},set exports(t){LO=t}},WO={},qO=Ov;({get exports(){return WO},set exports(t){WO=t}}).exports=qO,HO.exports=WO;var VO={},UO={get exports(){return VO},set exports(t){VO=t}},YO={},XO={get exports(){return YO},set exports(t){YO=t}},GO=Qt,KO=Rc,$O=M,ZO=Ze,QO=et,JO=gi,tC=Error,eC=y("".replace),iC=String(tC("zxcasd").stack),oC=/\n\s*at [^:]*:[^\n]*/,nC=oC.test(iC),rC=L,sC=!s((function(){var t=Error("a");return!("stack"in t)||(Object.defineProperty(t,"stack",rC(1,7)),7!==t.stack)})),aC=gi,hC=function(t,e){if(nC&&"string"==typeof t&&!tC.prepareStackTrace)for(;e--;)t=eC(t,oC,"");return t},lC=sC,dC=Error.captureStackTrace,cC=mn,uC=Ti,fC=ht,pC=Nr,vC=ys,gC=function(t,e,i){for(var o=KO(e),n=ZO.f,r=$O.f,s=0;s<o.length;s++){var a=o[s];GO(t,a)||i&&GO(i,a)||n(t,a,r(e,a))}},yC=Or,mC=gi,bC=L,wC=function(t,e){QO(e)&&"cause"in e&&JO(t,"cause",e.cause)},xC=function(t,e,i,o){lC&&(dC?dC(t,e):aC(t,"stack",hC(i,o)))},kC=tE,_C=function(t,e){return void 0===t?arguments.length<2?"":e:cC(t)},EC=ue("toStringTag"),OC=Error,CC=[].push,SC=function(t,e){var i,o=fC(TC,this);vC?i=vC(OC(),o?pC(this):TC):(i=o?this:yC(TC),mC(i,EC,"Error")),void 0!==e&&mC(i,"message",_C(e)),xC(i,SC,i.stack,1),arguments.length>2&&wC(i,arguments[2]);var n=[];return kC(t,CC,{that:n}),mC(i,"errors",n),i};vC?vC(SC,OC):gC(SC,OC,{name:!0});var TC=SC.prototype=yC(OC.prototype,{constructor:bC(1,SC),message:bC(1,""),name:bC(1,"AggregateError")});uC({global:!0,constructor:!0,arity:2},{AggregateError:SC});var MC,PC,DC,IC,BC="undefined"!=typeof process&&"process"==x(process),NC=va,zC=St,FC=TypeError,AC=function(t){if(NC(t))return t;throw FC(zC(t)+" is not a constructor")},jC=ii,RC=AC,LC=Y,HC=ue("species"),WC=function(t,e){var i,o=jC(t).constructor;return void 0===o||LC(i=jC(o)[HC])?e:RC(i)},qC=/(?:ipad|iphone|ipod).*applewebkit/i.test(lt),VC=r,UC=u,YC=$e,XC=T,GC=Qt,KC=s,$C=hr,ZC=_o,QC=Ce,JC=Mm,tS=qC,eS=BC,iS=VC.setImmediate,oS=VC.clearImmediate,nS=VC.process,rS=VC.Dispatch,sS=VC.Function,aS=VC.MessageChannel,hS=VC.String,lS=0,dS={},cS="onreadystatechange";KC((function(){MC=VC.location}));var uS=function(t){if(GC(dS,t)){var e=dS[t];delete dS[t],e()}},fS=function(t){return function(){uS(t)}},pS=function(t){uS(t.data)},vS=function(t){VC.postMessage(hS(t),MC.protocol+"//"+MC.host)};iS&&oS||(iS=function(t){JC(arguments.length,1);var e=XC(t)?t:sS(t),i=ZC(arguments,1);return dS[++lS]=function(){UC(e,void 0,i)},PC(lS),lS},oS=function(t){delete dS[t]},eS?PC=function(t){nS.nextTick(fS(t))}:rS&&rS.now?PC=function(t){rS.now(fS(t))}:aS&&!tS?(IC=(DC=new aS).port2,DC.port1.onmessage=pS,PC=YC(IC.postMessage,IC)):VC.addEventListener&&XC(VC.postMessage)&&!VC.importScripts&&MC&&"file:"!==MC.protocol&&!KC(vS)?(PC=vS,VC.addEventListener("message",pS,!1)):PC=cS in QC("script")?function(t){$C.appendChild(QC("script"))[cS]=function(){$C.removeChild(this),uS(t)}}:function(t){setTimeout(fS(t),0)});var gS={set:iS,clear:oS},yS=function(){this.head=null,this.tail=null};yS.prototype={add:function(t){var e={item:t,next:null},i=this.tail;i?i.next=e:this.head=e,this.tail=e},get:function(){var t=this.head;if(t)return null===(this.head=t.next)&&(this.tail=null),t.item}};var mS,bS,wS,xS,kS,_S=yS,ES=/ipad|iphone|ipod/i.test(lt)&&"undefined"!=typeof Pebble,OS=/web0s(?!.*chrome)/i.test(lt),CS=r,SS=$e,TS=M.f,MS=gS.set,PS=_S,DS=qC,IS=ES,BS=OS,NS=BC,zS=CS.MutationObserver||CS.WebKitMutationObserver,FS=CS.document,AS=CS.process,jS=CS.Promise,RS=TS(CS,"queueMicrotask"),LS=RS&&RS.value;if(!LS){var HS=new PS,WS=function(){var t,e;for(NS&&(t=AS.domain)&&t.exit();e=HS.get();)try{e()}catch(t){throw HS.head&&mS(),t}t&&t.enter()};DS||NS||BS||!zS||!FS?!IS&&jS&&jS.resolve?((xS=jS.resolve(void 0)).constructor=jS,kS=SS(xS.then,xS),mS=function(){kS(WS)}):NS?mS=function(){AS.nextTick(WS)}:(MS=SS(MS,CS),mS=function(){MS(WS)}):(bS=!0,wS=FS.createTextNode(""),new zS(WS).observe(wS,{characterData:!0}),mS=function(){wS.data=bS=!bS}),LS=function(t){HS.head||mS(),HS.add(t)}}var qS=LS,VS=function(t){try{return{error:!1,value:t()}}catch(t){return{error:!0,value:t}}},US=r.Promise,YS="object"==typeof Deno&&Deno&&"object"==typeof Deno.version,XS=!YS&&!BC&&"object"==typeof window&&"object"==typeof document,GS=r,KS=US,$S=T,ZS=Ye,QS=ea,JS=ue,tT=XS,eT=YS,iT=gt,oT=KS&&KS.prototype,nT=JS("species"),rT=!1,sT=$S(GS.PromiseRejectionEvent),aT=ZS("Promise",(function(){var t=QS(KS),e=t!==String(KS);if(!e&&66===iT)return!0;if(!oT.catch||!oT.finally)return!0;if(!iT||iT<51||!/native code/.test(t)){var i=new KS((function(t){t(1)})),o=function(t){t((function(){}),(function(){}))};if((i.constructor={})[nT]=o,!(rT=i.then((function(){}))instanceof o))return!0}return!e&&(tT||eT)&&!sT})),hT={CONSTRUCTOR:aT,REJECTION_EVENT:sT,SUBCLASSING:rT},lT={},dT=Dt,cT=TypeError,uT=function(t){var e,i;this.promise=new t((function(t,o){if(void 0!==e||void 0!==i)throw cT("Bad Promise constructor");e=t,i=o})),this.resolve=dT(e),this.reject=dT(i)};lT.f=function(t){return new uT(t)};var fT,pT,vT=Ti,gT=BC,yT=r,mT=B,bT=Fr,wT=es,xT=CE,kT=Dt,_T=T,ET=et,OT=oE,CT=WC,ST=gS.set,TT=qS,MT=function(t,e){try{1==arguments.length?console.error(t):console.error(t,e)}catch(t){}},PT=VS,DT=_S,IT=Xn,BT=US,NT=lT,zT="Promise",FT=hT.CONSTRUCTOR,AT=hT.REJECTION_EVENT,jT=IT.getterFor(zT),RT=IT.set,LT=BT&&BT.prototype,HT=BT,WT=LT,qT=yT.TypeError,VT=yT.document,UT=yT.process,YT=NT.f,XT=YT,GT=!!(VT&&VT.createEvent&&yT.dispatchEvent),KT="unhandledrejection",$T=function(t){var e;return!(!ET(t)||!_T(e=t.then))&&e},ZT=function(t,e){var i,o,n,r=e.value,s=1==e.state,a=s?t.ok:t.fail,h=t.resolve,l=t.reject,d=t.domain;try{a?(s||(2===e.rejection&&iM(e),e.rejection=1),!0===a?i=r:(d&&d.enter(),i=a(r),d&&(d.exit(),n=!0)),i===t.promise?l(qT("Promise-chain cycle")):(o=$T(i))?mT(o,i,h,l):h(i)):l(r)}catch(t){d&&!n&&d.exit(),l(t)}},QT=function(t,e){t.notified||(t.notified=!0,TT((function(){for(var i,o=t.reactions;i=o.get();)ZT(i,t);t.notified=!1,e&&!t.rejection&&tM(t)})))},JT=function(t,e,i){var o,n;GT?((o=VT.createEvent("Event")).promise=e,o.reason=i,o.initEvent(t,!1,!0),yT.dispatchEvent(o)):o={promise:e,reason:i},!AT&&(n=yT["on"+t])?n(o):t===KT&&MT("Unhandled promise rejection",i)},tM=function(t){mT(ST,yT,(function(){var e,i=t.facade,o=t.value;if(eM(t)&&(e=PT((function(){gT?UT.emit("unhandledRejection",o,i):JT(KT,i,o)})),t.rejection=gT||eM(t)?2:1,e.error))throw e.value}))},eM=function(t){return 1!==t.rejection&&!t.parent},iM=function(t){mT(ST,yT,(function(){var e=t.facade;gT?UT.emit("rejectionHandled",e):JT("rejectionhandled",e,t.value)}))},oM=function(t,e,i){return function(o){t(e,o,i)}},nM=function(t,e,i){t.done||(t.done=!0,i&&(t=i),t.value=e,t.state=2,QT(t,!0))},rM=function(t,e,i){if(!t.done){t.done=!0,i&&(t=i);try{if(t.facade===e)throw qT("Promise can't be resolved itself");var o=$T(e);o?TT((function(){var i={done:!1};try{mT(o,e,oM(rM,i,t),oM(nM,i,t))}catch(e){nM(i,e,t)}})):(t.value=e,t.state=1,QT(t,!1))}catch(e){nM({done:!1},e,t)}}};FT&&(WT=(HT=function(t){OT(this,WT),kT(t),mT(fT,this);var e=jT(this);try{t(oM(rM,e),oM(nM,e))}catch(t){nM(e,t)}}).prototype,(fT=function(t){RT(this,{type:zT,done:!1,notified:!1,parent:!1,reactions:new DT,rejection:!1,state:0,value:void 0})}).prototype=bT(WT,"then",(function(t,e){var i=jT(this),o=YT(CT(this,HT));return i.parent=!0,o.ok=!_T(t)||t,o.fail=_T(e)&&e,o.domain=gT?UT.domain:void 0,0==i.state?i.reactions.add(o):TT((function(){ZT(o,i)})),o.promise})),pT=function(){var t=new fT,e=jT(t);this.promise=t,this.resolve=oM(rM,e),this.reject=oM(nM,e)},NT.f=YT=function(t){return t===HT||undefined===t?new pT(t):XT(t)}),vT({global:!0,constructor:!0,wrap:!0,forced:FT},{Promise:HT}),wT(HT,zT,!1,!0),xT(zT);var sM=US,aM=hT.CONSTRUCTOR||!Ga((function(t){sM.all(t).then(void 0,(function(){}))})),hM=B,lM=Dt,dM=lT,cM=VS,uM=tE;Ti({target:"Promise",stat:!0,forced:aM},{all:function(t){var e=this,i=dM.f(e),o=i.resolve,n=i.reject,r=cM((function(){var i=lM(e.resolve),r=[],s=0,a=1;uM(t,(function(t){var h=s++,l=!1;a++,hM(i,e,t).then((function(t){l||(l=!0,r[h]=t,--a||o(r))}),n)})),--a||o(r)}));return r.error&&n(r.value),i.promise}});var fM=Ti,pM=hT.CONSTRUCTOR;US&&US.prototype,fM({target:"Promise",proto:!0,forced:pM,real:!0},{catch:function(t){return this.then(void 0,t)}});var vM=B,gM=Dt,yM=lT,mM=VS,bM=tE;Ti({target:"Promise",stat:!0,forced:aM},{race:function(t){var e=this,i=yM.f(e),o=i.reject,n=mM((function(){var n=gM(e.resolve);bM(t,(function(t){vM(n,e,t).then(i.resolve,o)}))}));return n.error&&o(n.value),i.promise}});var wM=B,xM=lT;Ti({target:"Promise",stat:!0,forced:hT.CONSTRUCTOR},{reject:function(t){var e=xM.f(this);return wM(e.reject,void 0,t),e.promise}});var kM=ii,_M=et,EM=lT,OM=function(t,e){if(kM(t),_M(e)&&e.constructor===t)return e;var i=EM.f(t);return(0,i.resolve)(e),i.promise},CM=Ti,SM=US,TM=hT.CONSTRUCTOR,MM=OM,PM=at("Promise"),DM=!TM;CM({target:"Promise",stat:!0,forced:true},{resolve:function(t){return MM(DM&&this===PM?SM:this,t)}});var IM=B,BM=Dt,NM=lT,zM=VS,FM=tE;Ti({target:"Promise",stat:!0,forced:aM},{allSettled:function(t){var e=this,i=NM.f(e),o=i.resolve,n=i.reject,r=zM((function(){var i=BM(e.resolve),n=[],r=0,s=1;FM(t,(function(t){var a=r++,h=!1;s++,IM(i,e,t).then((function(t){h||(h=!0,n[a]={status:"fulfilled",value:t},--s||o(n))}),(function(t){h||(h=!0,n[a]={status:"rejected",reason:t},--s||o(n))}))})),--s||o(n)}));return r.error&&n(r.value),i.promise}});var AM=B,jM=Dt,RM=at,LM=lT,HM=VS,WM=tE,qM="No one promise resolved";Ti({target:"Promise",stat:!0,forced:aM},{any:function(t){var e=this,i=RM("AggregateError"),o=LM.f(e),n=o.resolve,r=o.reject,s=HM((function(){var o=jM(e.resolve),s=[],a=0,h=1,l=!1;WM(t,(function(t){var d=a++,c=!1;h++,AM(o,e,t).then((function(t){c||l||(l=!0,n(t))}),(function(t){c||l||(c=!0,s[d]=t,--h||r(new i(s,qM)))}))})),--h||r(new i(s,qM))}));return s.error&&r(s.value),o.promise}});var VM=Ti,UM=US,YM=s,XM=at,GM=T,KM=WC,$M=OM,ZM=UM&&UM.prototype;VM({target:"Promise",proto:!0,real:!0,forced:!!UM&&YM((function(){ZM.finally.call({then:function(){}},(function(){}))}))},{finally:function(t){var e=KM(this,XM("Promise")),i=GM(t);return this.then(i?function(i){return $M(e,t()).then((function(){return i}))}:t,i?function(i){return $M(e,t()).then((function(){throw i}))}:t)}});var QM=it.Promise,JM=lT,tP=VS;Ti({target:"Promise",stat:!0,forced:!0},{try:function(t){var e=JM.f(this),i=tP(t);return(i.error?e.reject:e.resolve)(i.value),e.promise}});var eP=QM;XO.exports=eP,UO.exports=YO;var iP={},oP={get exports(){return iP},set exports(t){iP=t}},nP={},rP=jv;({get exports(){return nP},set exports(t){nP=t}}).exports=rP,oP.exports=nP,function(t){var e=RO.default,i=vu,o=wu,n=uO,r=DO,s=LO,a=yO,h=VO,l=iP,d=qf;function c(){t.exports=c=function(){return u},t.exports.__esModule=!0,t.exports.default=t.exports;var u={},f=Object.prototype,p=f.hasOwnProperty,v=i||function(t,e,i){t[e]=i.value},g="function"==typeof o?o:{},y=g.iterator||"@@iterator",m=g.asyncIterator||"@@asyncIterator",b=g.toStringTag||"@@toStringTag";function w(t,e,o){return i(t,e,{value:o,enumerable:!0,configurable:!0,writable:!0}),t[e]}try{w({},"")}catch(t){w=function(t,e,i){return t[e]=i}}function x(t,e,i,o){var r=e&&e.prototype instanceof E?e:E,s=n(r.prototype),a=new F(o||[]);return v(s,"_invoke",{value:I(t,i,a)}),s}function k(t,e,i){try{return{type:"normal",arg:t.call(e,i)}}catch(t){return{type:"throw",arg:t}}}u.wrap=x;var _={};function E(){}function O(){}function C(){}var S={};w(S,y,(function(){return this}));var T=r&&r(r(A([])));T&&T!==f&&p.call(T,y)&&(S=T);var M=C.prototype=E.prototype=n(S);function P(t){var e;s(e=["next","throw","return"]).call(e,(function(e){w(t,e,(function(t){return this._invoke(e,t)}))}))}function D(t,i){function o(n,r,s,a){var h=k(t[n],t,r);if("throw"!==h.type){var l=h.arg,d=l.value;return d&&"object"==e(d)&&p.call(d,"__await")?i.resolve(d.__await).then((function(t){o("next",t,s,a)}),(function(t){o("throw",t,s,a)})):i.resolve(d).then((function(t){l.value=t,s(l)}),(function(t){return o("throw",t,s,a)}))}a(h.arg)}var n;v(this,"_invoke",{value:function(t,e){function r(){return new i((function(i,n){o(t,e,i,n)}))}return n=n?n.then(r,r):r()}})}function I(t,e,i){var o="suspendedStart";return function(n,r){if("executing"===o)throw new Error("Generator is already running");if("completed"===o){if("throw"===n)throw r;return j()}for(i.method=n,i.arg=r;;){var s=i.delegate;if(s){var a=B(s,i);if(a){if(a===_)continue;return a}}if("next"===i.method)i.sent=i._sent=i.arg;else if("throw"===i.method){if("suspendedStart"===o)throw o="completed",i.arg;i.dispatchException(i.arg)}else"return"===i.method&&i.abrupt("return",i.arg);o="executing";var h=k(t,e,i);if("normal"===h.type){if(o=i.done?"completed":"suspendedYield",h.arg===_)continue;return{value:h.arg,done:i.done}}"throw"===h.type&&(o="completed",i.method="throw",i.arg=h.arg)}}}function B(t,e){var i=e.method,o=t.iterator[i];if(void 0===o)return e.delegate=null,"throw"===i&&t.iterator.return&&(e.method="return",e.arg=void 0,B(t,e),"throw"===e.method)||"return"!==i&&(e.method="throw",e.arg=new TypeError("The iterator does not provide a '"+i+"' method")),_;var n=k(o,t.iterator,e.arg);if("throw"===n.type)return e.method="throw",e.arg=n.arg,e.delegate=null,_;var r=n.arg;return r?r.done?(e[t.resultName]=r.value,e.next=t.nextLoc,"return"!==e.method&&(e.method="next",e.arg=void 0),e.delegate=null,_):r:(e.method="throw",e.arg=new TypeError("iterator result is not an object"),e.delegate=null,_)}function N(t){var e={tryLoc:t[0]};1 in t&&(e.catchLoc=t[1]),2 in t&&(e.finallyLoc=t[2],e.afterLoc=t[3]),this.tryEntries.push(e)}function z(t){var e=t.completion||{};e.type="normal",delete e.arg,t.completion=e}function F(t){this.tryEntries=[{tryLoc:"root"}],s(t).call(t,N,this),this.reset(!0)}function A(t){if(t){var e=t[y];if(e)return e.call(t);if("function"==typeof t.next)return t;if(!isNaN(t.length)){var i=-1,o=function e(){for(;++i<t.length;)if(p.call(t,i))return e.value=t[i],e.done=!1,e;return e.value=void 0,e.done=!0,e};return o.next=o}}return{next:j}}function j(){return{value:void 0,done:!0}}return O.prototype=C,v(M,"constructor",{value:C,configurable:!0}),v(C,"constructor",{value:O,configurable:!0}),O.displayName=w(C,b,"GeneratorFunction"),u.isGeneratorFunction=function(t){var e="function"==typeof t&&t.constructor;return!!e&&(e===O||"GeneratorFunction"===(e.displayName||e.name))},u.mark=function(t){return a?a(t,C):(t.__proto__=C,w(t,b,"GeneratorFunction")),t.prototype=n(M),t},u.awrap=function(t){return{__await:t}},P(D.prototype),w(D.prototype,m,(function(){return this})),u.AsyncIterator=D,u.async=function(t,e,i,o,n){void 0===n&&(n=h);var r=new D(x(t,e,i,o),n);return u.isGeneratorFunction(e)?r:r.next().then((function(t){return t.done?t.value:r.next()}))},P(M),w(M,b,"Generator"),w(M,y,(function(){return this})),w(M,"toString",(function(){return"[object Generator]"})),u.keys=function(t){var e=Object(t),i=[];for(var o in e)i.push(o);return l(i).call(i),function t(){for(;i.length;){var o=i.pop();if(o in e)return t.value=o,t.done=!1,t}return t.done=!0,t}},u.values=A,F.prototype={constructor:F,reset:function(t){var e;if(this.prev=0,this.next=0,this.sent=this._sent=void 0,this.done=!1,this.delegate=null,this.method="next",this.arg=void 0,s(e=this.tryEntries).call(e,z),!t)for(var i in this)"t"===i.charAt(0)&&p.call(this,i)&&!isNaN(+d(i).call(i,1))&&(this[i]=void 0)},stop:function(){this.done=!0;var t=this.tryEntries[0].completion;if("throw"===t.type)throw t.arg;return this.rval},dispatchException:function(t){if(this.done)throw t;var e=this;function i(i,o){return r.type="throw",r.arg=t,e.next=i,o&&(e.method="next",e.arg=void 0),!!o}for(var o=this.tryEntries.length-1;o>=0;--o){var n=this.tryEntries[o],r=n.completion;if("root"===n.tryLoc)return i("end");if(n.tryLoc<=this.prev){var s=p.call(n,"catchLoc"),a=p.call(n,"finallyLoc");if(s&&a){if(this.prev<n.catchLoc)return i(n.catchLoc,!0);if(this.prev<n.finallyLoc)return i(n.finallyLoc)}else if(s){if(this.prev<n.catchLoc)return i(n.catchLoc,!0)}else{if(!a)throw new Error("try statement without catch or finally");if(this.prev<n.finallyLoc)return i(n.finallyLoc)}}}},abrupt:function(t,e){for(var i=this.tryEntries.length-1;i>=0;--i){var o=this.tryEntries[i];if(o.tryLoc<=this.prev&&p.call(o,"finallyLoc")&&this.prev<o.finallyLoc){var n=o;break}}n&&("break"===t||"continue"===t)&&n.tryLoc<=e&&e<=n.finallyLoc&&(n=null);var r=n?n.completion:{};return r.type=t,r.arg=e,n?(this.method="next",this.next=n.finallyLoc,_):this.complete(r)},complete:function(t,e){if("throw"===t.type)throw t.arg;return"break"===t.type||"continue"===t.type?this.next=t.arg:"return"===t.type?(this.rval=this.arg=t.arg,this.method="return",this.next="end"):"normal"===t.type&&e&&(this.next=e),_},finish:function(t){for(var e=this.tryEntries.length-1;e>=0;--e){var i=this.tryEntries[e];if(i.finallyLoc===t)return this.complete(i.completion,i.afterLoc),z(i),_}},catch:function(t){for(var e=this.tryEntries.length-1;e>=0;--e){var i=this.tryEntries[e];if(i.tryLoc===t){var o=i.completion;if("throw"===o.type){var n=o.arg;z(i)}return n}}throw new Error("illegal catch attempt")},delegateYield:function(t,e,i){return this.delegate={iterator:A(t),resultName:e,nextLoc:i},"next"===this.method&&(this.arg=void 0),_}},u}t.exports=c,t.exports.__esModule=!0,t.exports.default=t.exports}(jO);var sP=AO(),aP=sP;try{regeneratorRuntime=sP}catch(t){"object"==typeof globalThis?globalThis.regeneratorRuntime=sP:Function("r","regeneratorRuntime = r")(sP)}var hP={},lP={get exports(){return hP},set exports(t){hP=t}},dP=Dt,cP=Kt,uP=U,fP=Li,pP=TypeError,vP=function(t){return function(e,i,o,n){dP(i);var r=cP(e),s=uP(r),a=fP(r),h=t?a-1:0,l=t?-1:1;if(o<2)for(;;){if(h in s){n=s[h],h+=l;break}if(h+=l,t?h<0:a<=h)throw pP("Reduce of empty array with no initial value")}for(;t?h>=0:a>h;h+=l)h in s&&(n=i(n,s[h],h,r));return n}},gP={left:vP(!1),right:vP(!0)}.left;Ti({target:"Array",proto:!0,forced:!BC&&gt>79&&gt<83||!vv("reduce")},{reduce:function(t){var e=arguments.length;return gP(this,t,e,e>1?arguments[1]:void 0)}});var yP=jo("Array").reduce,mP=ht,bP=yP,wP=Array.prototype,xP=function(t){var e=t.reduce;return t===wP||mP(wP,t)&&e===wP.reduce?bP:e},kP=xP;lP.exports=kP;var _P=e(hP),EP={},OP={get exports(){return EP},set exports(t){EP=t}},CP=tl,SP=Li,TP=Ou,MP=$e,PP=function(t,e,i,o,n,r,s,a){for(var h,l,d=n,c=0,u=!!s&&MP(s,a);c<o;)c in i&&(h=u?u(i[c],c,e):i[c],r>0&&CP(h)?(l=SP(h),d=PP(t,e,h,l,d,r-1)-1):(TP(d+1),t[d]=h),d++),c++;return d},DP=PP,IP=Dt,BP=Kt,NP=Li,zP=al;Ti({target:"Array",proto:!0},{flatMap:function(t){var e,i=BP(this),o=NP(i);return IP(t),(e=zP(i,0)).length=DP(e,i,i,o,0,1,t,arguments.length>1?arguments[1]:void 0),e}});var FP=jo("Array").flatMap,AP=ht,jP=FP,RP=Array.prototype,LP=function(t){var e=t.flatMap;return t===RP||AP(RP,t)&&e===RP.flatMap?jP:e},HP=LP;OP.exports=HP;var WP=e(EP),qP={},VP={get exports(){return qP},set exports(t){qP=t}};bE("Set",(function(t){return function(){return t(this,arguments.length?arguments[0]:void 0)}}),HE);var UP=it.Set;VP.exports=UP;var YP=e(qP),XP={};({get exports(){return XP},set exports(t){XP=t}}).exports=kf;var GP=e(XP),KP={},$P={get exports(){return KP},set exports(t){KP=t}},ZP={},QP=Ia;({get exports(){return ZP},set exports(t){ZP=t}}).exports=QP,$P.exports=ZP;var JP=e(KP),tD={},eD={get exports(){return tD},set exports(t){tD=t}},iD=Bh,oD=Math.floor,nD=function(t,e){var i=t.length,o=oD(i/2);return i<8?rD(t,e):sD(t,nD(iD(t,0,o),e),nD(iD(t,o),e),e)},rD=function(t,e){for(var i,o,n=t.length,r=1;r<n;){for(o=r,i=t[r];o&&e(t[o-1],i)>0;)t[o]=t[--o];o!==r++&&(t[o]=i)}return t},sD=function(t,e,i,o){for(var n=e.length,r=i.length,s=0,a=0;s<n||a<r;)t[s+a]=s<n&&a<r?o(e[s],i[a])<=0?e[s++]:i[a++]:s<n?e[s++]:i[a++];return t},aD=nD,hD=lt.match(/firefox\/(\d+)/i),lD=!!hD&&+hD[1],dD=/MSIE|Trident/.test(lt),cD=lt.match(/AppleWebKit\/(\d+)\./),uD=!!cD&&+cD[1],fD=Ti,pD=y,vD=Dt,gD=Kt,yD=Li,mD=Kv,bD=mn,wD=s,xD=aD,kD=vv,_D=lD,ED=dD,OD=gt,CD=uD,SD=[],TD=pD(SD.sort),MD=pD(SD.push),PD=wD((function(){SD.sort(void 0)})),DD=wD((function(){SD.sort(null)})),ID=kD("sort"),BD=!wD((function(){if(OD)return OD<70;if(!(_D&&_D>3)){if(ED)return!0;if(CD)return CD<603;var t,e,i,o,n="";for(t=65;t<76;t++){switch(e=String.fromCharCode(t),t){case 66:case 69:case 70:case 72:i=3;break;case 68:case 71:i=4;break;default:i=2}for(o=0;o<47;o++)SD.push({k:e+o,v:i})}for(SD.sort((function(t,e){return e.v-t.v})),o=0;o<SD.length;o++)e=SD[o].k.charAt(0),n.charAt(n.length-1)!==e&&(n+=e);return"DGBEFHACIJK"!==n}}));fD({target:"Array",proto:!0,forced:PD||!DD||!ID||!BD},{sort:function(t){void 0!==t&&vD(t);var e=gD(this);if(BD)return void 0===t?TD(e):TD(e,t);var i,o,n=[],r=yD(e);for(o=0;o<r;o++)o in e&&MD(n,e[o]);for(xD(n,function(t){return function(e,i){return void 0===i?-1:void 0===e?1:void 0!==t?+t(e,i)||0:bD(e)>bD(i)?1:-1}}(t)),i=yD(n),o=0;o<i;)e[o]=n[o++];for(;o<r;)mD(e,o++);return e}});var ND=jo("Array").sort,zD=ht,FD=ND,AD=Array.prototype,jD=function(t){var e=t.sort;return t===AD||zD(AD,t)&&e===AD.sort?FD:e},RD=jD;eD.exports=RD;var LD=e(tD),HD={},WD={get exports(){return HD},set exports(t){HD=t}},qD=jo("Array").keys,VD=vn,UD=Qt,YD=ht,XD=qD,GD=Array.prototype,KD={DOMTokenList:!0,NodeList:!0},$D=function(t){var e=t.keys;return t===GD||YD(GD,t)&&e===GD.keys||UD(KD,VD(t))?XD:e};WD.exports=$D;var ZD=e(HD),QD={},JD={get exports(){return QD},set exports(t){QD=t}},tI=jo("Array").values,eI=vn,iI=Qt,oI=ht,nI=tI,rI=Array.prototype,sI={DOMTokenList:!0,NodeList:!0},aI=function(t){var e=t.values;return t===rI||oI(rI,t)&&e===rI.values||iI(sI,eI(t))?nI:e};JD.exports=aI;var hI=e(QD),lI={},dI={get exports(){return lI},set exports(t){lI=t}},cI=jo("Array").entries,uI=vn,fI=Qt,pI=ht,vI=cI,gI=Array.prototype,yI={DOMTokenList:!0,NodeList:!0},mI=function(t){var e=t.entries;return t===gI||pI(gI,t)&&e===gI.entries||fI(yI,uI(t))?vI:e};dI.exports=mI;var bI=e(lI),wI={},xI={get exports(){return wI},set exports(t){wI=t}},kI=Ti,_I=u,EI=zo,OI=AC,CI=ii,SI=et,TI=Or,MI=s,PI=at("Reflect","construct"),DI=Object.prototype,II=[].push,BI=MI((function(){function t(){}return!(PI((function(){}),[],t)instanceof t)})),NI=!MI((function(){PI((function(){}))})),zI=BI||NI;kI({target:"Reflect",stat:!0,forced:zI,sham:zI},{construct:function(t,e){OI(t),CI(e);var i=arguments.length<3?t:OI(arguments[2]);if(NI&&!BI)return PI(t,e,i);if(t==i){switch(e.length){case 0:return new t;case 1:return new t(e[0]);case 2:return new t(e[0],e[1]);case 3:return new t(e[0],e[1],e[2]);case 4:return new t(e[0],e[1],e[2],e[3])}var o=[null];return _I(II,o,e),new(_I(EI,t,o))}var n=i.prototype,r=TI(SI(n)?n:DI),s=_I(t,r,e);return SI(s)?s:r}});var FI=it.Reflect.construct;xI.exports=FI;var AI=e(wI);let jI;const RI=new Uint8Array(16);function LI(){if(!jI&&(jI="undefined"!=typeof crypto&&crypto.getRandomValues&&crypto.getRandomValues.bind(crypto),!jI))throw new Error("crypto.getRandomValues() not supported. See https://github.com/uuidjs/uuid#getrandomvalues-not-supported");return jI(RI)}const HI=[];for(let t=0;t<256;++t)HI.push((t+256).toString(16).slice(1));var WI,qI={randomUUID:"undefined"!=typeof crypto&&crypto.randomUUID&&crypto.randomUUID.bind(crypto)};function VI(t,e,i){if(qI.randomUUID&&!e&&!t)return qI.randomUUID();const o=(t=t||{}).random||(t.rng||LI)();if(o[6]=15&o[6]|64,o[8]=63&o[8]|128,e){i=i||0;for(let t=0;t<16;++t)e[i+t]=o[t];return e}return function(t,e=0){return(HI[t[e+0]]+HI[t[e+1]]+HI[t[e+2]]+HI[t[e+3]]+"-"+HI[t[e+4]]+HI[t[e+5]]+"-"+HI[t[e+6]]+HI[t[e+7]]+"-"+HI[t[e+8]]+HI[t[e+9]]+"-"+HI[t[e+10]]+HI[t[e+11]]+HI[t[e+12]]+HI[t[e+13]]+HI[t[e+14]]+HI[t[e+15]]).toLowerCase()}(o)}function UI(t,e){var i=nv(t);if(mc){var o=mc(t);e&&(o=oy(o).call(o,(function(e){return Dc(t,e).enumerable}))),i.push.apply(i,o)}return i}function YI(t){for(var e=1;e<arguments.length;e++){var i,o,n=null!=arguments[e]?arguments[e]:{};e%2?Cv(i=UI(Object(n),!0)).call(i,(function(e){zf(t,e,n[e])})):Uc?iu(t,Uc(n)):Cv(o=UI(Object(n))).call(o,(function(e){fu(t,e,Dc(n,e))}))}return t}function XI(t){var e=function(){if("undefined"==typeof Reflect||!AI)return!1;if(AI.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(AI(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,o=FO(t);if(e){var n=FO(this).constructor;i=AI(o,arguments,n)}else i=o.apply(this,arguments);return PO(this,i)}}function GI(t,e){var i=void 0!==Op&&xh(t)||t["@@iterator"];if(!i){if(Wp(t)||(i=function(t,e){var i;if(!t)return;if("string"==typeof t)return KI(t,e);var o=Fp(i=Object.prototype.toString.call(t)).call(i,8,-1);"Object"===o&&t.constructor&&(o=t.constructor.name);if("Map"===o||"Set"===o)return Za(t);if("Arguments"===o||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(o))return KI(t,e)}(t))||e&&t&&"number"==typeof t.length){i&&(t=i);var o=0,n=function(){};return{s:n,n:function(){return o>=t.length?{done:!0}:{done:!1,value:t[o++]}},e:function(t){throw t},f:n}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var r,s=!0,a=!1;return{s:function(){i=i.call(t)},n:function(){var t=i.next();return s=t.done,t},e:function(t){a=!0,r=t},f:function(){try{s||null==i.return||i.return()}finally{if(a)throw r}}}}function KI(t,e){(null==e||e>t.length)&&(e=t.length);for(var i=0,o=new Array(e);i<e;i++)o[i]=t[i];return o}var $I=function(){function t(e,i,o){var n,r,s;pu(this,t),zf(this,"_source",void 0),zf(this,"_transformers",void 0),zf(this,"_target",void 0),zf(this,"_listeners",{add:Uo(n=this._add).call(n,this),remove:Uo(r=this._remove).call(r,this),update:Uo(s=this._update).call(s,this)}),this._source=e,this._transformers=i,this._target=o}return Nf(t,[{key:"all",value:function(){return this._target.update(this._transformItems(this._source.get())),this}},{key:"start",value:function(){return this._source.on("add",this._listeners.add),this._source.on("remove",this._listeners.remove),this._source.on("update",this._listeners.update),this}},{key:"stop",value:function(){return this._source.off("add",this._listeners.add),this._source.off("remove",this._listeners.remove),this._source.off("update",this._listeners.update),this}},{key:"_transformItems",value:function(t){var e;return _P(e=this._transformers).call(e,(function(t,e){return e(t)}),t)}},{key:"_add",value:function(t,e){null!=e&&this._target.add(this._transformItems(this._source.get(e.items)))}},{key:"_update",value:function(t,e){null!=e&&this._target.update(this._transformItems(this._source.get(e.items)))}},{key:"_remove",value:function(t,e){null!=e&&this._target.remove(this._transformItems(e.oldData))}}]),t}(),ZI=function(){function t(e){pu(this,t),zf(this,"_source",void 0),zf(this,"_transformers",[]),this._source=e}return Nf(t,[{key:"filter",value:function(t){return this._transformers.push((function(e){return oy(e).call(e,t)})),this}},{key:"map",value:function(t){return this._transformers.push((function(e){return Qp(e).call(e,t)})),this}},{key:"flatMap",value:function(t){return this._transformers.push((function(e){return WP(e).call(e,t)})),this}},{key:"to",value:function(t){return new $I(this._source,this._transformers,t)}}]),t}();function QI(t){return"string"==typeof t||"number"==typeof t}var JI=function(){function t(e){pu(this,t),zf(this,"delay",void 0),zf(this,"max",void 0),zf(this,"_queue",[]),zf(this,"_timeout",null),zf(this,"_extended",null),this.delay=null,this.max=1/0,this.setOptions(e)}return Nf(t,[{key:"setOptions",value:function(t){t&&void 0!==t.delay&&(this.delay=t.delay),t&&void 0!==t.max&&(this.max=t.max),this._flushIfNeeded()}},{key:"destroy",value:function(){if(this.flush(),this._extended){for(var t=this._extended.object,e=this._extended.methods,i=0;i<e.length;i++){var o=e[i];o.original?t[o.name]=o.original:delete t[o.name]}this._extended=null}}},{key:"replace",value:function(t,e){var i=this,o=t[e];if(!o)throw new Error("Method "+e+" undefined");t[e]=function(){for(var t=arguments.length,e=new Array(t),n=0;n<t;n++)e[n]=arguments[n];i.queue({args:e,fn:o,context:this})}}},{key:"queue",value:function(t){"function"==typeof t?this._queue.push({fn:t}):this._queue.push(t),this._flushIfNeeded()}},{key:"_flushIfNeeded",value:function(){var t=this;this._queue.length>this.max&&this.flush(),null!=this._timeout&&(clearTimeout(this._timeout),this._timeout=null),this.queue.length>0&&"number"==typeof this.delay&&(this._timeout=Xm((function(){t.flush()}),this.delay))}},{key:"flush",value:function(){var t,e;Cv(t=vg(e=this._queue).call(e,0)).call(t,(function(t){t.fn.apply(t.context||t.fn,t.args||[])}))}}],[{key:"extend",value:function(e,i){var o=new t(i);if(void 0!==e.flush)throw new Error("Target object already has a property flush");e.flush=function(){o.flush()};var n=[{name:"flush",original:void 0}];if(i&&i.replace)for(var r=0;r<i.replace.length;r++){var s=i.replace[r];n.push({name:s,original:e[s]}),o.replace(e,s)}return o._extended={object:e,methods:n},o}}]),t}(),tB=function(){function t(){pu(this,t),zf(this,"_subscribers",{"*":[],add:[],remove:[],update:[]}),zf(this,"subscribe",t.prototype.on),zf(this,"unsubscribe",t.prototype.off)}return Nf(t,[{key:"_trigger",value:function(t,e,i){var o,n;if("*"===t)throw new Error("Cannot trigger event *");Cv(o=Np(n=[]).call(n,_p(this._subscribers[t]),_p(this._subscribers["*"]))).call(o,(function(o){o(t,e,null!=i?i:null)}))}},{key:"on",value:function(t,e){"function"==typeof e&&this._subscribers[t].push(e)}},{key:"off",value:function(t,e){var i;this._subscribers[t]=oy(i=this._subscribers[t]).call(i,(function(t){return t!==e}))}}]),t}();WI=GP;var eB=function(){function t(e){pu(this,t),zf(this,"_pairs",void 0),this._pairs=e}return Nf(t,[{key:WI,value:aP.mark((function t(){var e,i,o,n,r;return aP.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=GI(this._pairs),t.prev=1,e.s();case 3:if((i=e.n()).done){t.next=9;break}return o=kp(i.value,2),n=o[0],r=o[1],t.next=7,[n,r];case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"entries",value:aP.mark((function t(){var e,i,o,n,r;return aP.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=GI(this._pairs),t.prev=1,e.s();case 3:if((i=e.n()).done){t.next=9;break}return o=kp(i.value,2),n=o[0],r=o[1],t.next=7,[n,r];case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"keys",value:aP.mark((function t(){var e,i,o,n;return aP.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=GI(this._pairs),t.prev=1,e.s();case 3:if((i=e.n()).done){t.next=9;break}return o=kp(i.value,1),n=o[0],t.next=7,n;case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"values",value:aP.mark((function t(){var e,i,o,n;return aP.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=GI(this._pairs),t.prev=1,e.s();case 3:if((i=e.n()).done){t.next=9;break}return o=kp(i.value,2),n=o[1],t.next=7,n;case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"toIdArray",value:function(){var t;return Qp(t=_p(this._pairs)).call(t,(function(t){return t[0]}))}},{key:"toItemArray",value:function(){var t;return Qp(t=_p(this._pairs)).call(t,(function(t){return t[1]}))}},{key:"toEntryArray",value:function(){return _p(this._pairs)}},{key:"toObjectMap",value:function(){var t,e=mm(null),i=GI(this._pairs);try{for(i.s();!(t=i.n()).done;){var o=kp(t.value,2),n=o[0],r=o[1];e[n]=r}}catch(t){i.e(t)}finally{i.f()}return e}},{key:"toMap",value:function(){return new qE(this._pairs)}},{key:"toIdSet",value:function(){return new YP(this.toIdArray())}},{key:"toItemSet",value:function(){return new YP(this.toItemArray())}},{key:"cache",value:function(){return new t(_p(this._pairs))}},{key:"distinct",value:function(t){var e,i=new YP,o=GI(this._pairs);try{for(o.s();!(e=o.n()).done;){var n=kp(e.value,2),r=n[0],s=n[1];i.add(t(s,r))}}catch(t){o.e(t)}finally{o.f()}return i}},{key:"filter",value:function(e){var i=this._pairs;return new t(zf({},GP,aP.mark((function t(){var o,n,r,s,a;return aP.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:o=GI(i),t.prev=1,o.s();case 3:if((n=o.n()).done){t.next=10;break}if(r=kp(n.value,2),s=r[0],a=r[1],!e(a,s)){t.next=8;break}return t.next=8,[s,a];case 8:t.next=3;break;case 10:t.next=15;break;case 12:t.prev=12,t.t0=t.catch(1),o.e(t.t0);case 15:return t.prev=15,o.f(),t.finish(15);case 18:case"end":return t.stop()}}),t,null,[[1,12,15,18]])}))))}},{key:"forEach",value:function(t){var e,i=GI(this._pairs);try{for(i.s();!(e=i.n()).done;){var o=kp(e.value,2),n=o[0];t(o[1],n)}}catch(t){i.e(t)}finally{i.f()}}},{key:"map",value:function(e){var i=this._pairs;return new t(zf({},GP,aP.mark((function t(){var o,n,r,s,a;return aP.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:o=GI(i),t.prev=1,o.s();case 3:if((n=o.n()).done){t.next=9;break}return r=kp(n.value,2),s=r[0],a=r[1],t.next=7,[s,e(a,s)];case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),o.e(t.t0);case 14:return t.prev=14,o.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,null,[[1,11,14,17]])}))))}},{key:"max",value:function(t){var e=JP(this._pairs),i=e.next();if(i.done)return null;for(var o=i.value[1],n=t(i.value[1],i.value[0]);!(i=e.next()).done;){var r=kp(i.value,2),s=r[0],a=r[1],h=t(a,s);h>n&&(n=h,o=a)}return o}},{key:"min",value:function(t){var e=JP(this._pairs),i=e.next();if(i.done)return null;for(var o=i.value[1],n=t(i.value[1],i.value[0]);!(i=e.next()).done;){var r=kp(i.value,2),s=r[0],a=r[1],h=t(a,s);h<n&&(n=h,o=a)}return o}},{key:"reduce",value:function(t,e){var i,o=GI(this._pairs);try{for(o.s();!(i=o.n()).done;){var n=kp(i.value,2),r=n[0];e=t(e,n[1],r)}}catch(t){o.e(t)}finally{o.f()}return e}},{key:"sort",value:function(e){var i=this;return new t(zf({},GP,(function(){var t;return JP(LD(t=_p(i._pairs)).call(t,(function(t,i){var o=kp(t,2),n=o[0],r=o[1],s=kp(i,2),a=s[0],h=s[1];return e(r,h,n,a)})))})))}}]),t}();var iB=function(t){MO(i,tB);var e=XI(i);function i(t,o){var n;return pu(this,i),zf(cO(n=e.call(this)),"flush",void 0),zf(cO(n),"length",void 0),zf(cO(n),"_options",void 0),zf(cO(n),"_data",void 0),zf(cO(n),"_idProp",void 0),zf(cO(n),"_queue",null),t&&!Wp(t)&&(o=t,t=[]),n._options=o||{},n._data=new qE,n.length=0,n._idProp=n._options.fieldId||"id",t&&t.length&&n.add(t),n.setOptions(o),n}return Nf(i,[{key:"idProp",get:function(){return this._idProp}},{key:"setOptions",value:function(t){t&&void 0!==t.queue&&(!1===t.queue?this._queue&&(this._queue.destroy(),this._queue=null):(this._queue||(this._queue=JI.extend(this,{replace:["add","update","remove"]})),t.queue&&"object"===Of(t.queue)&&this._queue.setOptions(t.queue)))}},{key:"add",value:function(t,e){var i,o=this,n=[];if(Wp(t)){var r=Qp(t).call(t,(function(t){return t[o._idProp]}));if(dO(r).call(r,(function(t){return o._data.has(t)})))throw new Error("A duplicate id was found in the parameter array.");for(var s=0,a=t.length;s<a;s++)i=this._addItem(t[s]),n.push(i)}else{if(!t||"object"!==Of(t))throw new Error("Unknown dataType");i=this._addItem(t),n.push(i)}return n.length&&this._trigger("add",{items:n},e),n}},{key:"update",value:function(t,e){var i=this,o=[],n=[],r=[],s=[],a=this._idProp,h=function(t){var e=t[a];if(null!=e&&i._data.has(e)){var h=t,l=wo({},i._data.get(e)),d=i._updateItem(h);n.push(d),s.push(h),r.push(l)}else{var c=i._addItem(t);o.push(c)}};if(Wp(t))for(var l=0,d=t.length;l<d;l++)t[l]&&"object"===Of(t[l])?h(t[l]):console.warn("Ignoring input item, which is not an object at index "+l);else{if(!t||"object"!==Of(t))throw new Error("Unknown dataType");h(t)}if(o.length&&this._trigger("add",{items:o},e),n.length){var c={items:n,oldData:r,data:s};this._trigger("update",c,e)}return Np(o).call(o,n)}},{key:"updateOnly",value:function(t,e){var i,o=this;Wp(t)||(t=[t]);var n=Qp(i=Qp(t).call(t,(function(t){var e=o._data.get(t[o._idProp]);if(null==e)throw new Error("Updating non-existent items is not allowed.");return{oldData:e,update:t}}))).call(i,(function(t){var e=t.oldData,i=t.update,n=e[o._idProp],r=kx(e,i);return o._data.set(n,r),{id:n,oldData:e,updatedData:r}}));if(n.length){var r={items:Qp(n).call(n,(function(t){return t.id})),oldData:Qp(n).call(n,(function(t){return t.oldData})),data:Qp(n).call(n,(function(t){return t.updatedData}))};return this._trigger("update",r,e),r.items}return[]}},{key:"get",value:function(t,e){var i=void 0,o=void 0,n=void 0;QI(t)?(i=t,n=e):Wp(t)?(o=t,n=e):n=t;var r,s=n&&"Object"===n.returnType?"Object":"Array",a=n&&oy(n),h=[],l=void 0,d=void 0,c=void 0;if(null!=i)(l=this._data.get(i))&&a&&!a(l)&&(l=void 0);else if(null!=o)for(var u=0,f=o.length;u<f;u++)null==(l=this._data.get(o[u]))||a&&!a(l)||h.push(l);else for(var p,v=0,g=(d=_p(ZD(p=this._data).call(p))).length;v<g;v++)c=d[v],null==(l=this._data.get(c))||a&&!a(l)||h.push(l);if(n&&n.order&&null==i&&this._sort(h,n.order),n&&n.fields){var y=n.fields;if(null!=i&&null!=l)l=this._filterFields(l,y);else for(var m=0,b=h.length;m<b;m++)h[m]=this._filterFields(h[m],y)}if("Object"==s){for(var w={},x=0,k=h.length;x<k;x++){var _=h[x];w[_[this._idProp]]=_}return w}return null!=i?null!==(r=l)&&void 0!==r?r:null:h}},{key:"getIds",value:function(t){var e=this._data,i=t&&oy(t),o=t&&t.order,n=_p(ZD(e).call(e)),r=[];if(i)if(o){for(var s=[],a=0,h=n.length;a<h;a++){var l=n[a],d=this._data.get(l);null!=d&&i(d)&&s.push(d)}this._sort(s,o);for(var c=0,u=s.length;c<u;c++)r.push(s[c][this._idProp])}else for(var f=0,p=n.length;f<p;f++){var v=n[f],g=this._data.get(v);null!=g&&i(g)&&r.push(g[this._idProp])}else if(o){for(var y=[],m=0,b=n.length;m<b;m++){var w=n[m];y.push(e.get(w))}this._sort(y,o);for(var x=0,k=y.length;x<k;x++)r.push(y[x][this._idProp])}else for(var _=0,E=n.length;_<E;_++){var O=n[_],C=e.get(O);null!=C&&r.push(C[this._idProp])}return r}},{key:"getDataSet",value:function(){return this}},{key:"forEach",value:function(t,e){var i=e&&oy(e),o=this._data,n=_p(ZD(o).call(o));if(e&&e.order)for(var r=this.get(e),s=0,a=r.length;s<a;s++){var h=r[s];t(h,h[this._idProp])}else for(var l=0,d=n.length;l<d;l++){var c=n[l],u=this._data.get(c);null==u||i&&!i(u)||t(u,c)}}},{key:"map",value:function(t,e){for(var i=e&&oy(e),o=[],n=this._data,r=_p(ZD(n).call(n)),s=0,a=r.length;s<a;s++){var h=r[s],l=this._data.get(h);null==l||i&&!i(l)||o.push(t(l,h))}return e&&e.order&&this._sort(o,e.order),o}},{key:"_filterFields",value:function(t,e){var i;return t?_P(i=Wp(e)?e:nv(e)).call(i,(function(e,i){return e[i]=t[i],e}),{}):t}},{key:"_sort",value:function(t,e){if("string"==typeof e){var i=e;LD(t).call(t,(function(t,e){var o=t[i],n=e[i];return o>n?1:o<n?-1:0}))}else{if("function"!=typeof e)throw new TypeError("Order must be a function or a string");LD(t).call(t,e)}}},{key:"remove",value:function(t,e){for(var i=[],o=[],n=Wp(t)?t:[t],r=0,s=n.length;r<s;r++){var a=this._remove(n[r]);if(a){var h=a[this._idProp];null!=h&&(i.push(h),o.push(a))}}return i.length&&this._trigger("remove",{items:i,oldData:o},e),i}},{key:"_remove",value:function(t){var e;if(QI(t)?e=t:t&&"object"===Of(t)&&(e=t[this._idProp]),null!=e&&this._data.has(e)){var i=this._data.get(e)||null;return this._data.delete(e),--this.length,i}return null}},{key:"clear",value:function(t){for(var e,i=_p(ZD(e=this._data).call(e)),o=[],n=0,r=i.length;n<r;n++)o.push(this._data.get(i[n]));return this._data.clear(),this.length=0,this._trigger("remove",{items:i,oldData:o},t),i}},{key:"max",value:function(t){var e,i,o=null,n=null,r=GI(hI(e=this._data).call(e));try{for(r.s();!(i=r.n()).done;){var s=i.value,a=s[t];"number"==typeof a&&(null==n||a>n)&&(o=s,n=a)}}catch(t){r.e(t)}finally{r.f()}return o||null}},{key:"min",value:function(t){var e,i,o=null,n=null,r=GI(hI(e=this._data).call(e));try{for(r.s();!(i=r.n()).done;){var s=i.value,a=s[t];"number"==typeof a&&(null==n||a<n)&&(o=s,n=a)}}catch(t){r.e(t)}finally{r.f()}return o||null}},{key:"distinct",value:function(t){for(var e=this._data,i=_p(ZD(e).call(e)),o=[],n=0,r=0,s=i.length;r<s;r++){for(var a=i[r],h=e.get(a)[t],l=!1,d=0;d<n;d++)if(o[d]==h){l=!0;break}l||void 0===h||(o[n]=h,n++)}return o}},{key:"_addItem",value:function(t){var e=function(t,e){return null==t[e]&&(t[e]=VI()),t}(t,this._idProp),i=e[this._idProp];if(this._data.has(i))throw new Error("Cannot add item: item with id "+i+" already exists");return this._data.set(i,e),++this.length,i}},{key:"_updateItem",value:function(t){var e=t[this._idProp];if(null==e)throw new Error("Cannot update item: item has no id (item: "+Em(t)+")");var i=this._data.get(e);if(!i)throw new Error("Cannot update item: no item with id "+e+" found");return this._data.set(e,YI(YI({},i),t)),e}},{key:"stream",value:function(t){if(t){var e=this._data;return new eB(zf({},GP,aP.mark((function i(){var o,n,r,s;return aP.wrap((function(i){for(;;)switch(i.prev=i.next){case 0:o=GI(t),i.prev=1,o.s();case 3:if((n=o.n()).done){i.next=11;break}if(r=n.value,null==(s=e.get(r))){i.next=9;break}return i.next=9,[r,s];case 9:i.next=3;break;case 11:i.next=16;break;case 13:i.prev=13,i.t0=i.catch(1),o.e(i.t0);case 16:return i.prev=16,o.f(),i.finish(16);case 19:case"end":return i.stop()}}),i,null,[[1,13,16,19]])}))))}var i;return new eB(zf({},GP,Uo(i=bI(this._data)).call(i,this._data)))}}]),i}(),oB=function(t){MO(i,tB);var e=XI(i);function i(t,o){var n,r;return pu(this,i),zf(cO(r=e.call(this)),"length",0),zf(cO(r),"_listener",void 0),zf(cO(r),"_data",void 0),zf(cO(r),"_ids",new YP),zf(cO(r),"_options",void 0),r._options=o||{},r._listener=Uo(n=r._onEvent).call(n,cO(r)),r.setData(t),r}return Nf(i,[{key:"idProp",get:function(){return this.getDataSet().idProp}},{key:"setData",value:function(t){if(this._data){this._data.off&&this._data.off("*",this._listener);var e=this._data.getIds({filter:oy(this._options)}),i=this._data.get(e);this._ids.clear(),this.length=0,this._trigger("remove",{items:e,oldData:i})}if(null!=t){this._data=t;for(var o=this._data.getIds({filter:oy(this._options)}),n=0,r=o.length;n<r;n++){var s=o[n];this._ids.add(s)}this.length=o.length,this._trigger("add",{items:o})}else this._data=new iB;this._data.on&&this._data.on("*",this._listener)}},{key:"refresh",value:function(){for(var t=this._data.getIds({filter:oy(this._options)}),e=_p(this._ids),i={},o=[],n=[],r=[],s=0,a=t.length;s<a;s++){var h=t[s];i[h]=!0,this._ids.has(h)||(o.push(h),this._ids.add(h))}for(var l=0,d=e.length;l<d;l++){var c=e[l],u=this._data.get(c);null==u?console.error("If you see this, report it please."):i[c]||(n.push(c),r.push(u),this._ids.delete(c))}this.length+=o.length-n.length,o.length&&this._trigger("add",{items:o}),n.length&&this._trigger("remove",{items:n,oldData:r})}},{key:"get",value:function(t,e){if(null==this._data)return null;var i,o=null;QI(t)||Wp(t)?(o=t,i=e):i=t;var n=wo({},this._options,i),r=oy(this._options),s=i&&oy(i);return r&&s&&(n.filter=function(t){return r(t)&&s(t)}),null==o?this._data.get(n):this._data.get(o,n)}},{key:"getIds",value:function(t){if(this._data.length){var e,i=oy(this._options),o=null!=t?oy(t):null;return e=o?i?function(t){return i(t)&&o(t)}:o:i,this._data.getIds({filter:e,order:t&&t.order})}return[]}},{key:"forEach",value:function(t,e){if(this._data){var i,o,n=oy(this._options),r=e&&oy(e);o=r?n?function(t){return n(t)&&r(t)}:r:n,Cv(i=this._data).call(i,t,{filter:o,order:e&&e.order})}}},{key:"map",value:function(t,e){if(this._data){var i,o,n=oy(this._options),r=e&&oy(e);return o=r?n?function(t){return n(t)&&r(t)}:r:n,Qp(i=this._data).call(i,t,{filter:o,order:e&&e.order})}return[]}},{key:"getDataSet",value:function(){return this._data.getDataSet()}},{key:"stream",value:function(t){var e;return this._data.stream(t||zf({},GP,Uo(e=ZD(this._ids)).call(e,this._ids)))}},{key:"dispose",value:function(){var t;null!==(t=this._data)&&void 0!==t&&t.off&&this._data.off("*",this._listener);var e,o="This data view has already been disposed of.",n={get:function(){throw new Error(o)},set:function(){throw new Error(o)},configurable:!1},r=GI(Lp(i.prototype));try{for(r.s();!(e=r.n()).done;){var s=e.value;fu(this,s,n)}}catch(t){r.e(t)}finally{r.f()}}},{key:"_onEvent",value:function(t,e,i){if(e&&e.items&&this._data){var o=e.items,n=[],r=[],s=[],a=[],h=[],l=[];switch(t){case"add":for(var d=0,c=o.length;d<c;d++){var u=o[d];this.get(u)&&(this._ids.add(u),n.push(u))}break;case"update":for(var f=0,p=o.length;f<p;f++){var v=o[f];this.get(v)?this._ids.has(v)?(r.push(v),h.push(e.data[f]),a.push(e.oldData[f])):(this._ids.add(v),n.push(v)):this._ids.has(v)&&(this._ids.delete(v),s.push(v),l.push(e.oldData[f]))}break;case"remove":for(var g=0,y=o.length;g<y;g++){var m=o[g];this._ids.has(m)&&(this._ids.delete(m),s.push(m),l.push(e.oldData[g]))}}this.length+=n.length-s.length,n.length&&this._trigger("add",{items:n},i),r.length&&this._trigger("update",{items:r,oldData:a,data:h},i),s.length&&this._trigger("remove",{items:s,oldData:l},i)}}}]),i}();function nB(t,e){return"object"===Of(e)&&null!==e&&t===e.idProp&&"function"==typeof e.add&&"function"==typeof e.clear&&"function"==typeof e.distinct&&"function"==typeof Cv(e)&&"function"==typeof e.get&&"function"==typeof e.getDataSet&&"function"==typeof e.getIds&&"number"==typeof e.length&&"function"==typeof Qp(e)&&"function"==typeof e.max&&"function"==typeof e.min&&"function"==typeof e.off&&"function"==typeof e.on&&"function"==typeof e.remove&&"function"==typeof e.setOptions&&"function"==typeof e.stream&&"function"==typeof e.update&&"function"==typeof e.updateOnly}function rB(t,e){return"object"===Of(e)&&null!==e&&t===e.idProp&&"function"==typeof Cv(e)&&"function"==typeof e.get&&"function"==typeof e.getDataSet&&"function"==typeof e.getIds&&"number"==typeof e.length&&"function"==typeof Qp(e)&&"function"==typeof e.off&&"function"==typeof e.on&&"function"==typeof e.stream&&nB(t,e.getDataSet())}var sB=Object.freeze({__proto__:null,DELETE:xx,DataSet:iB,DataStream:eB,DataView:oB,Queue:JI,createNewDataPipeFrom:function(t){return new ZI(t)},isDataSetLike:nB,isDataViewLike:rB}),aB={},hB={get exports(){return aB},set exports(t){aB=t}},lB=r,dB=s,cB=mn,uB=Cy.trim,fB=my,pB=y("".charAt),vB=lB.parseFloat,gB=lB.Symbol,yB=gB&&gB.iterator,mB=1/vB(fB+"-0")!=-1/0||yB&&!dB((function(){vB(Object(yB))}))?function(t){var e=uB(cB(t)),i=vB(e);return 0===i&&"-"==pB(e,0)?-0:i}:vB;Ti({global:!0,forced:parseFloat!=mB},{parseFloat:mB});var bB=it.parseFloat;hB.exports=bB;var wB=e(aB),xB={},kB={get exports(){return xB},set exports(t){xB=t}},_B=Ti,EB=s,OB=Sh.f;_B({target:"Object",stat:!0,forced:EB((function(){return!Object.getOwnPropertyNames(1)}))},{getOwnPropertyNames:OB});var CB=it.Object,SB=function(t){return CB.getOwnPropertyNames(t)},TB=SB;kB.exports=TB;var MB=e(xB);function PB(t,e){var i=["node","edge","label"],o=!0,n=vk(e,"chosen");if("boolean"==typeof n)o=n;else if("object"===Of(n)){if(-1===tm(i).call(i,t))throw new Error("choosify: subOption '"+t+"' should be one of '"+i.join("', '")+"'");var r=vk(e,["chosen",t]);"boolean"!=typeof r&&"function"!=typeof r||(o=r)}return o}function DB(t,e,i){if(t.width<=0||t.height<=0)return!1;if(void 0!==i){var o={x:e.x-i.x,y:e.y-i.y};if(0!==i.angle){var n=-i.angle;e={x:Math.cos(n)*o.x-Math.sin(n)*o.y,y:Math.sin(n)*o.x+Math.cos(n)*o.y}}else e=o}var r=t.x+t.width,s=t.y+t.width;return t.left<e.x&&r>e.x&&t.top<e.y&&s>e.y}function IB(t){return"string"==typeof t&&""!==t}function BB(t,e,i,o){var n=o.x,r=o.y;if("function"==typeof o.distanceToBorder){var s=o.distanceToBorder(t,e),a=Math.sin(e)*s,h=Math.cos(e)*s;h===s?(n+=s,r=o.y):a===s?(n=o.x,r-=s):(n+=h,r-=a)}else o.shape.width>o.shape.height?(n=o.x+.5*o.shape.width,r=o.y-i):(n=o.x+i,r=o.y-.5*o.shape.height);return{x:n,y:r}}var NB=function(){function t(e){pu(this,t),this.measureText=e,this.current=0,this.width=0,this.height=0,this.lines=[]}return Nf(t,[{key:"_add",value:function(t,e){var i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:"normal";void 0===this.lines[t]&&(this.lines[t]={width:0,height:0,blocks:[]});var o=e;void 0!==e&&""!==e||(o=" ");var n=this.measureText(o,i),r=wo({},hI(n));r.text=e,r.width=n.width,r.mod=i,void 0!==e&&""!==e||(r.width=0),this.lines[t].blocks.push(r),this.lines[t].width+=r.width}},{key:"curWidth",value:function(){var t=this.lines[this.current];return void 0===t?0:t.width}},{key:"append",value:function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:"normal";this._add(this.current,t,e)}},{key:"newLine",value:function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:"normal";this._add(this.current,t,e),this.current++}},{key:"determineLineHeights",value:function(){for(var t=0;t<this.lines.length;t++){var e=this.lines[t],i=0;if(void 0!==e.blocks)for(var o=0;o<e.blocks.length;o++){var n=e.blocks[o];i<n.height&&(i=n.height)}e.height=i}}},{key:"determineLabelSize",value:function(){for(var t=0,e=0,i=0;i<this.lines.length;i++){var o=this.lines[i];o.width>t&&(t=o.width),e+=o.height}this.width=t,this.height=e}},{key:"removeEmptyBlocks",value:function(){for(var t=[],e=0;e<this.lines.length;e++){var i=this.lines[e];if(0!==i.blocks.length&&(e!==this.lines.length-1||0!==i.width)){var o={};wo(o,i),o.blocks=[];for(var n=void 0,r=[],s=0;s<i.blocks.length;s++){var a=i.blocks[s];0!==a.width?r.push(a):void 0===n&&(n=a)}0===r.length&&void 0!==n&&r.push(n),o.blocks=r,t.push(o)}}return t}},{key:"finalize",value:function(){this.determineLineHeights(),this.determineLabelSize();var t=this.removeEmptyBlocks();return{width:this.width,height:this.height,lines:t}}}]),t}(),zB={"<b>":/<b>/,"<i>":/<i>/,"<code>":/<code>/,"</b>":/<\/b>/,"</i>":/<\/i>/,"</code>":/<\/code>/,"*":/\*/,_:/_/,"`":/`/,afterBold:/[^*]/,afterItal:/[^_]/,afterMono:/[^`]/},FB=function(){function t(e){pu(this,t),this.text=e,this.bold=!1,this.ital=!1,this.mono=!1,this.spacing=!1,this.position=0,this.buffer="",this.modStack=[],this.blocks=[]}return Nf(t,[{key:"mod",value:function(){return 0===this.modStack.length?"normal":this.modStack[0]}},{key:"modName",value:function(){return 0===this.modStack.length?"normal":"mono"===this.modStack[0]?"mono":this.bold&&this.ital?"boldital":this.bold?"bold":this.ital?"ital":void 0}},{key:"emitBlock",value:function(){this.spacing&&(this.add(" "),this.spacing=!1),this.buffer.length>0&&(this.blocks.push({text:this.buffer,mod:this.modName()}),this.buffer="")}},{key:"add",value:function(t){" "===t&&(this.spacing=!0),this.spacing&&(this.buffer+=" ",this.spacing=!1)," "!=t&&(this.buffer+=t)}},{key:"parseWS",value:function(t){return!!/[ \t]/.test(t)&&(this.mono?this.add(t):this.spacing=!0,!0)}},{key:"setTag",value:function(t){this.emitBlock(),this[t]=!0,this.modStack.unshift(t)}},{key:"unsetTag",value:function(t){this.emitBlock(),this[t]=!1,this.modStack.shift()}},{key:"parseStartTag",value:function(t,e){return!(this.mono||this[t]||!this.match(e))&&(this.setTag(t),!0)}},{key:"match",value:function(t){var e=!(arguments.length>1&&void 0!==arguments[1])||arguments[1],i=kp(this.prepareRegExp(t),2),o=i[0],n=i[1],r=o.test(this.text.substr(this.position,n));return r&&e&&(this.position+=n-1),r}},{key:"parseEndTag",value:function(t,e,i){var o=this.mod()===t;return!(!(o="mono"===t?o&&this.mono:o&&!this.mono)||!this.match(e))&&(void 0!==i?(this.position===this.text.length-1||this.match(i,!1))&&this.unsetTag(t):this.unsetTag(t),!0)}},{key:"replace",value:function(t,e){return!!this.match(t)&&(this.add(e),this.position+=length-1,!0)}},{key:"prepareRegExp",value:function(t){var e,i;if(t instanceof RegExp)i=t,e=1;else{var o=zB[t];i=void 0!==o?o:new RegExp(t),e=t.length}return[i,e]}}]),t}(),AB=function(){function t(e,i,o,n){var r=this;pu(this,t),this.ctx=e,this.parent=i,this.selected=o,this.hover=n;this.lines=new NB((function(t,i){if(void 0===t)return 0;var s=r.parent.getFormattingValues(e,o,n,i),a=0;""!==t&&(a=r.ctx.measureText(t).width);return{width:a,values:s}}))}return Nf(t,[{key:"process",value:function(t){if(!IB(t))return this.lines.finalize();var e=this.parent.fontOptions;t=(t=t.replace(/\r\n/g,"\n")).replace(/\r/g,"\n");var i=String(t).split("\n"),o=i.length;if(e.multi)for(var n=0;n<o;n++){var r=this.splitBlocks(i[n],e.multi);if(void 0!==r)if(0!==r.length){if(e.maxWdt>0)for(var s=0;s<r.length;s++){var a=r[s].mod,h=r[s].text;this.splitStringIntoLines(h,a,!0)}else for(var l=0;l<r.length;l++){var d=r[l].mod,c=r[l].text;this.lines.append(c,d)}this.lines.newLine()}else this.lines.newLine("")}else if(e.maxWdt>0)for(var u=0;u<o;u++)this.splitStringIntoLines(i[u]);else for(var f=0;f<o;f++)this.lines.newLine(i[f]);return this.lines.finalize()}},{key:"decodeMarkupSystem",value:function(t){var e="none";return"markdown"===t||"md"===t?e="markdown":!0!==t&&"html"!==t||(e="html"),e}},{key:"splitHtmlBlocks",value:function(t){for(var e=new FB(t),i=function(t){return!!/&/.test(t)&&(e.replace(e.text,"&lt;","<")||e.replace(e.text,"&amp;","&")||e.add("&"),!0)};e.position<e.text.length;){var o=e.text.charAt(e.position);e.parseWS(o)||/</.test(o)&&(e.parseStartTag("bold","<b>")||e.parseStartTag("ital","<i>")||e.parseStartTag("mono","<code>")||e.parseEndTag("bold","</b>")||e.parseEndTag("ital","</i>")||e.parseEndTag("mono","</code>"))||i(o)||e.add(o),e.position++}return e.emitBlock(),e.blocks}},{key:"splitMarkdownBlocks",value:function(t){for(var e=this,i=new FB(t),o=!0,n=function(t){return!!/\\/.test(t)&&(i.position<e.text.length+1&&(i.position++,t=e.text.charAt(i.position),/ \t/.test(t)?i.spacing=!0:(i.add(t),o=!1)),!0)};i.position<i.text.length;){var r=i.text.charAt(i.position);i.parseWS(r)||n(r)||(o||i.spacing)&&(i.parseStartTag("bold","*")||i.parseStartTag("ital","_")||i.parseStartTag("mono","`"))||i.parseEndTag("bold","*","afterBold")||i.parseEndTag("ital","_","afterItal")||i.parseEndTag("mono","`","afterMono")||(i.add(r),o=!1),i.position++}return i.emitBlock(),i.blocks}},{key:"splitBlocks",value:function(t,e){var i=this.decodeMarkupSystem(e);return"none"===i?[{text:t,mod:"normal"}]:"markdown"===i?this.splitMarkdownBlocks(t):"html"===i?this.splitHtmlBlocks(t):void 0}},{key:"overMaxWidth",value:function(t){var e=this.ctx.measureText(t).width;return this.lines.curWidth()+e>this.parent.fontOptions.maxWdt}},{key:"getLongestFit",value:function(t){for(var e="",i=0;i<t.length;){var o=e+(""===e?"":" ")+t[i];if(this.overMaxWidth(o))break;e=o,i++}return i}},{key:"getLongestFitWord",value:function(t){for(var e=0;e<t.length&&!this.overMaxWidth(Fp(t).call(t,0,e));)e++;return e}},{key:"splitStringIntoLines",value:function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:"normal",i=arguments.length>2&&void 0!==arguments[2]&&arguments[2];this.parent.getFormattingValues(this.ctx,this.selected,this.hover,e);for(var o=(t=(t=t.replace(/^( +)/g,"$1\r")).replace(/([^\r][^ ]*)( +)/g,"$1\r$2\r")).split("\r");o.length>0;){var n=this.getLongestFit(o);if(0===n){var r=o[0],s=this.getLongestFitWord(r);this.lines.newLine(Fp(r).call(r,0,s),e),o[0]=Fp(r).call(r,s)}else{var a=n;" "===o[n-1]?n--:" "===o[a]&&a++;var h=Fp(o).call(o,0,n).join("");n==o.length&&i?this.lines.append(h,e):this.lines.newLine(h,e),o=Fp(o).call(o,a)}}}}]),t}(),jB=["bold","ital","boldital","mono"],RB=function(){function t(e,i){var o=arguments.length>2&&void 0!==arguments[2]&&arguments[2];pu(this,t),this.body=e,this.pointToSelf=!1,this.baseSize=void 0,this.fontOptions={},this.setOptions(i),this.size={top:0,left:0,width:0,height:0,yLine:0},this.isEdgeLabel=o}return Nf(t,[{key:"setOptions",value:function(t){if(this.elementOptions=t,this.initFontOptions(t.font),IB(t.label)?this.labelDirty=!0:t.label=void 0,void 0!==t.font&&null!==t.font)if("string"==typeof t.font)this.baseSize=this.fontOptions.size;else if("object"===Of(t.font)){var e=t.font.size;void 0!==e&&(this.baseSize=e)}}},{key:"initFontOptions",value:function(e){var i=this;Kx(jB,(function(t){i.fontOptions[t]={}})),t.parseFontString(this.fontOptions,e)?this.fontOptions.vadjust=0:Kx(e,(function(t,e){null!=t&&"object"!==Of(t)&&(i.fontOptions[e]=t)}))}},{key:"constrain",value:function(t){var e={constrainWidth:!1,maxWdt:-1,minWdt:-1,constrainHeight:!1,minHgt:-1,valign:"middle"},i=vk(t,"widthConstraint");if("number"==typeof i)e.maxWdt=Number(i),e.minWdt=Number(i);else if("object"===Of(i)){var o=vk(t,["widthConstraint","maximum"]);"number"==typeof o&&(e.maxWdt=Number(o));var n=vk(t,["widthConstraint","minimum"]);"number"==typeof n&&(e.minWdt=Number(n))}var r=vk(t,"heightConstraint");if("number"==typeof r)e.minHgt=Number(r);else if("object"===Of(r)){var s=vk(t,["heightConstraint","minimum"]);"number"==typeof s&&(e.minHgt=Number(s));var a=vk(t,["heightConstraint","valign"]);"string"==typeof a&&("top"!==a&&"bottom"!==a||(e.valign=a))}return e}},{key:"update",value:function(t,e){this.setOptions(t,!0),this.propagateFonts(e),Vx(this.fontOptions,this.constrain(e)),this.fontOptions.chooser=PB("label",e)}},{key:"adjustSizes",value:function(t){var e=t?t.right+t.left:0;this.fontOptions.constrainWidth&&(this.fontOptions.maxWdt-=e,this.fontOptions.minWdt-=e);var i=t?t.top+t.bottom:0;this.fontOptions.constrainHeight&&(this.fontOptions.minHgt-=i)}},{key:"addFontOptionsToPile",value:function(t,e){for(var i=0;i<e.length;++i)this.addFontToPile(t,e[i])}},{key:"addFontToPile",value:function(t,e){if(void 0!==e&&void 0!==e.font&&null!==e.font){var i=e.font;t.push(i)}}},{key:"getBasicOptions",value:function(e){for(var i={},o=0;o<e.length;++o){var n=e[o],r={};t.parseFontString(r,n)&&(n=r),Kx(n,(function(t,e){void 0!==t&&(Object.prototype.hasOwnProperty.call(i,e)||(-1!==tm(jB).call(jB,e)?i[e]={}:i[e]=t))}))}return i}},{key:"getFontOption",value:function(e,i,o){for(var n,r=0;r<e.length;++r){var s=e[r];if(Object.prototype.hasOwnProperty.call(s,i)){if(null==(n=s[i]))continue;var a={};if(t.parseFontString(a,n)&&(n=a),Object.prototype.hasOwnProperty.call(n,o))return n[o]}}if(Object.prototype.hasOwnProperty.call(this.fontOptions,o))return this.fontOptions[o];throw new Error("Did not find value for multi-font for property: '"+o+"'")}},{key:"getFontOptions",value:function(t,e){for(var i={},o=["color","size","face","mod","vadjust"],n=0;n<o.length;++n){var r=o[n];i[r]=this.getFontOption(t,e,r)}return i}},{key:"propagateFonts",value:function(t){var e=this,i=[];this.addFontOptionsToPile(i,t),this.fontOptions=this.getBasicOptions(i);for(var o=function(){var t=jB[n],o=e.fontOptions[t];Kx(e.getFontOptions(i,t),(function(t,e){o[e]=t})),o.size=Number(o.size),o.vadjust=Number(o.vadjust)},n=0;n<jB.length;++n)o()}},{key:"draw",value:function(t,e,i,o,n){var r=arguments.length>5&&void 0!==arguments[5]?arguments[5]:"middle";if(void 0!==this.elementOptions.label){var s=this.fontOptions.size*this.body.view.scale;this.elementOptions.label&&s<this.elementOptions.scaling.label.drawThreshold-1||(s>=this.elementOptions.scaling.label.maxVisible&&(s=Number(this.elementOptions.scaling.label.maxVisible)/this.body.view.scale),this.calculateLabelSize(t,o,n,e,i,r),this._drawBackground(t),this._drawText(t,e,this.size.yLine,r,s))}}},{key:"_drawBackground",value:function(t){if(void 0!==this.fontOptions.background&&"none"!==this.fontOptions.background){t.fillStyle=this.fontOptions.background;var e=this.getSize();t.fillRect(e.left,e.top,e.width,e.height)}}},{key:"_drawText",value:function(t,e,i){var o=arguments.length>3&&void 0!==arguments[3]?arguments[3]:"middle",n=arguments.length>4?arguments[4]:void 0,r=kp(this._setAlignment(t,e,i,o),2);e=r[0],i=r[1],t.textAlign="left",e-=this.size.width/2,this.fontOptions.valign&&this.size.height>this.size.labelHeight&&("top"===this.fontOptions.valign&&(i-=(this.size.height-this.size.labelHeight)/2),"bottom"===this.fontOptions.valign&&(i+=(this.size.height-this.size.labelHeight)/2));for(var s=0;s<this.lineCount;s++){var a=this.lines[s];if(a&&a.blocks){var h=0;this.isEdgeLabel||"center"===this.fontOptions.align?h+=(this.size.width-a.width)/2:"right"===this.fontOptions.align&&(h+=this.size.width-a.width);for(var l=0;l<a.blocks.length;l++){var d=a.blocks[l];t.font=d.font;var c=kp(this._getColor(d.color,n,d.strokeColor),2),u=c[0],f=c[1];d.strokeWidth>0&&(t.lineWidth=d.strokeWidth,t.strokeStyle=f,t.lineJoin="round"),t.fillStyle=u,d.strokeWidth>0&&t.strokeText(d.text,e+h,i+d.vadjust),t.fillText(d.text,e+h,i+d.vadjust),h+=d.width}i+=a.height}}}},{key:"_setAlignment",value:function(t,e,i,o){if(this.isEdgeLabel&&"horizontal"!==this.fontOptions.align&&!1===this.pointToSelf){e=0,i=0;"top"===this.fontOptions.align?(t.textBaseline="alphabetic",i-=4):"bottom"===this.fontOptions.align?(t.textBaseline="hanging",i+=4):t.textBaseline="middle"}else t.textBaseline=o;return[e,i]}},{key:"_getColor",value:function(t,e,i){var o=t||"#000000",n=i||"#ffffff";if(e<=this.elementOptions.scaling.label.drawThreshold){var r=Math.max(0,Math.min(1,1-(this.elementOptions.scaling.label.drawThreshold-e)));o=ek(o,r),n=ek(n,r)}return[o,n]}},{key:"getTextSize",value:function(t){var e=arguments.length>1&&void 0!==arguments[1]&&arguments[1],i=arguments.length>2&&void 0!==arguments[2]&&arguments[2];return this._processLabel(t,e,i),{width:this.size.width,height:this.size.height,lineCount:this.lineCount}}},{key:"getSize",value:function(){var t=this.size.left,e=this.size.top-1;if(this.isEdgeLabel){var i=.5*-this.size.width;switch(this.fontOptions.align){case"middle":t=i,e=.5*-this.size.height;break;case"top":t=i,e=-(this.size.height+2);break;case"bottom":t=i,e=2}}return{left:t,top:e,width:this.size.width,height:this.size.height}}},{key:"calculateLabelSize",value:function(t,e,i){var o=arguments.length>3&&void 0!==arguments[3]?arguments[3]:0,n=arguments.length>4&&void 0!==arguments[4]?arguments[4]:0,r=arguments.length>5&&void 0!==arguments[5]?arguments[5]:"middle";this._processLabel(t,e,i),this.size.left=o-.5*this.size.width,this.size.top=n-.5*this.size.height,this.size.yLine=n+.5*(1-this.lineCount)*this.fontOptions.size,"hanging"===r&&(this.size.top+=.5*this.fontOptions.size,this.size.top+=4,this.size.yLine+=4)}},{key:"getFormattingValues",value:function(t,e,i,o){var n=function(t,e,i){return"normal"===e?"mod"===i?"":t[i]:void 0!==t[e][i]?t[e][i]:t[i]},r={color:n(this.fontOptions,o,"color"),size:n(this.fontOptions,o,"size"),face:n(this.fontOptions,o,"face"),mod:n(this.fontOptions,o,"mod"),vadjust:n(this.fontOptions,o,"vadjust"),strokeWidth:this.fontOptions.strokeWidth,strokeColor:this.fontOptions.strokeColor};(e||i)&&("normal"===o&&!0===this.fontOptions.chooser&&this.elementOptions.labelHighlightBold?r.mod="bold":"function"==typeof this.fontOptions.chooser&&this.fontOptions.chooser(r,this.elementOptions.id,e,i));var s="";return void 0!==r.mod&&""!==r.mod&&(s+=r.mod+" "),s+=r.size+"px "+r.face,t.font=s.replace(/"/g,""),r.font=t.font,r.height=r.size,r}},{key:"differentState",value:function(t,e){return t!==this.selectedState||e!==this.hoverState}},{key:"_processLabelText",value:function(t,e,i,o){return new AB(t,this,e,i).process(o)}},{key:"_processLabel",value:function(t,e,i){if(!1!==this.labelDirty||this.differentState(e,i)){var o=this._processLabelText(t,e,i,this.elementOptions.label);this.fontOptions.minWdt>0&&o.width<this.fontOptions.minWdt&&(o.width=this.fontOptions.minWdt),this.size.labelHeight=o.height,this.fontOptions.minHgt>0&&o.height<this.fontOptions.minHgt&&(o.height=this.fontOptions.minHgt),this.lines=o.lines,this.lineCount=o.lines.length,this.size.width=o.width,this.size.height=o.height,this.selectedState=e,this.hoverState=i,this.labelDirty=!1}}},{key:"visible",value:function(){return 0!==this.size.width&&0!==this.size.height&&void 0!==this.elementOptions.label&&!(this.fontOptions.size*this.body.view.scale<this.elementOptions.scaling.label.drawThreshold-1)}}],[{key:"parseFontString",value:function(t,e){if(!e||"string"!=typeof e)return!1;var i=e.split(" ");return t.size=+i[0].replace("px",""),t.face=i[1],t.color=i[2],!0}}]),t}(),LB=function(){function t(e,i,o){pu(this,t),this.body=i,this.labelModule=o,this.setOptions(e),this.top=void 0,this.left=void 0,this.height=void 0,this.width=void 0,this.radius=void 0,this.margin=void 0,this.refreshNeeded=!0,this.boundingBox={top:0,left:0,right:0,bottom:0}}return Nf(t,[{key:"setOptions",value:function(t){this.options=t}},{key:"_setMargins",value:function(t){this.margin={},this.options.margin&&("object"==Of(this.options.margin)?(this.margin.top=this.options.margin.top,this.margin.right=this.options.margin.right,this.margin.bottom=this.options.margin.bottom,this.margin.left=this.options.margin.left):(this.margin.top=this.options.margin,this.margin.right=this.options.margin,this.margin.bottom=this.options.margin,this.margin.left=this.options.margin)),t.adjustSizes(this.margin)}},{key:"_distanceToBorder",value:function(t,e){var i=this.options.borderWidth;return t&&this.resize(t),Math.min(Math.abs(this.width/2/Math.cos(e)),Math.abs(this.height/2/Math.sin(e)))+i}},{key:"enableShadow",value:function(t,e){e.shadow&&(t.shadowColor=e.shadowColor,t.shadowBlur=e.shadowSize,t.shadowOffsetX=e.shadowX,t.shadowOffsetY=e.shadowY)}},{key:"disableShadow",value:function(t,e){e.shadow&&(t.shadowColor="rgba(0,0,0,0)",t.shadowBlur=0,t.shadowOffsetX=0,t.shadowOffsetY=0)}},{key:"enableBorderDashes",value:function(t,e){if(!1!==e.borderDashes)if(void 0!==t.setLineDash){var i=e.borderDashes;!0===i&&(i=[5,15]),t.setLineDash(i)}else console.warn("setLineDash is not supported in this browser. The dashed borders cannot be used."),this.options.shapeProperties.borderDashes=!1,e.borderDashes=!1}},{key:"disableBorderDashes",value:function(t,e){!1!==e.borderDashes&&(void 0!==t.setLineDash?t.setLineDash([0]):(console.warn("setLineDash is not supported in this browser. The dashed borders cannot be used."),this.options.shapeProperties.borderDashes=!1,e.borderDashes=!1))}},{key:"needsRefresh",value:function(t,e){return!0===this.refreshNeeded?(this.refreshNeeded=!1,!0):void 0===this.width||this.labelModule.differentState(t,e)}},{key:"initContextForDraw",value:function(t,e){var i=e.borderWidth/this.body.view.scale;t.lineWidth=Math.min(this.width,i),t.strokeStyle=e.borderColor,t.fillStyle=e.color}},{key:"performStroke",value:function(t,e){var i=e.borderWidth/this.body.view.scale;t.save(),i>0&&(this.enableBorderDashes(t,e),t.stroke(),this.disableBorderDashes(t,e)),t.restore()}},{key:"performFill",value:function(t,e){t.save(),t.fillStyle=e.color,this.enableShadow(t,e),ab(t).call(t),this.disableShadow(t,e),t.restore(),this.performStroke(t,e)}},{key:"_addBoundingBoxMargin",value:function(t){this.boundingBox.left-=t,this.boundingBox.top-=t,this.boundingBox.bottom+=t,this.boundingBox.right+=t}},{key:"_updateBoundingBox",value:function(t,e,i,o,n){void 0!==i&&this.resize(i,o,n),this.left=t-this.width/2,this.top=e-this.height/2,this.boundingBox.left=this.left,this.boundingBox.top=this.top,this.boundingBox.bottom=this.top+this.height,this.boundingBox.right=this.left+this.width}},{key:"updateBoundingBox",value:function(t,e,i,o,n){this._updateBoundingBox(t,e,i,o,n)}},{key:"getDimensionsFromLabel",value:function(t,e,i){this.textSize=this.labelModule.getTextSize(t,e,i);var o=this.textSize.width,n=this.textSize.height;return 0===o&&(o=14,n=14),{width:o,height:n}}}]),t}();function HB(t){var e=function(){if("undefined"==typeof Reflect||!AI)return!1;if(AI.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(AI(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,o=FO(t);if(e){var n=FO(this).constructor;i=AI(o,arguments,n)}else i=o.apply(this,arguments);return PO(this,i)}}var WB=function(t){MO(i,LB);var e=HB(i);function i(t,o,n){var r;return pu(this,i),(r=e.call(this,t,o,n))._setMargins(n),r}return Nf(i,[{key:"resize",value:function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:this.selected,i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:this.hover;if(this.needsRefresh(e,i)){var o=this.getDimensionsFromLabel(t,e,i);this.width=o.width+this.margin.right+this.margin.left,this.height=o.height+this.margin.top+this.margin.bottom,this.radius=this.width/2}}},{key:"draw",value:function(t,e,i,o,n,r){this.resize(t,o,n),this.left=e-this.width/2,this.top=i-this.height/2,this.initContextForDraw(t,r),Xo(t,this.left,this.top,this.width,this.height,r.borderRadius),this.performFill(t,r),this.updateBoundingBox(e,i,t,o,n),this.labelModule.draw(t,this.left+this.textSize.width/2+this.margin.left,this.top+this.textSize.height/2+this.margin.top,o,n)}},{key:"updateBoundingBox",value:function(t,e,i,o,n){this._updateBoundingBox(t,e,i,o,n);var r=this.options.shapeProperties.borderRadius;this._addBoundingBoxMargin(r)}},{key:"distanceToBorder",value:function(t,e){t&&this.resize(t);var i=this.options.borderWidth;return Math.min(Math.abs(this.width/2/Math.cos(e)),Math.abs(this.height/2/Math.sin(e)))+i}}]),i}();function qB(t){var e=function(){if("undefined"==typeof Reflect||!AI)return!1;if(AI.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(AI(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,o=FO(t);if(e){var n=FO(this).constructor;i=AI(o,arguments,n)}else i=o.apply(this,arguments);return PO(this,i)}}var VB=function(t){MO(i,LB);var e=qB(i);function i(t,o,n){var r;return pu(this,i),(r=e.call(this,t,o,n)).labelOffset=0,r.selected=!1,r}return Nf(i,[{key:"setOptions",value:function(t,e,i){this.options=t,void 0===e&&void 0===i||this.setImages(e,i)}},{key:"setImages",value:function(t,e){e&&this.selected?(this.imageObj=e,this.imageObjAlt=t):(this.imageObj=t,this.imageObjAlt=e)}},{key:"switchImages",value:function(t){var e=t&&!this.selected||!t&&this.selected;if(this.selected=t,void 0!==this.imageObjAlt&&e){var i=this.imageObj;this.imageObj=this.imageObjAlt,this.imageObjAlt=i}}},{key:"_getImagePadding",value:function(){var t={top:0,right:0,bottom:0,left:0};if(this.options.imagePadding){var e=this.options.imagePadding;"object"==Of(e)?(t.top=e.top,t.right=e.right,t.bottom=e.bottom,t.left=e.left):(t.top=e,t.right=e,t.bottom=e,t.left=e)}return t}},{key:"_resizeImage",value:function(){var t,e;if(!1===this.options.shapeProperties.useImageSize){var i=1,o=1;this.imageObj.width&&this.imageObj.height&&(this.imageObj.width>this.imageObj.height?i=this.imageObj.width/this.imageObj.height:o=this.imageObj.height/this.imageObj.width),t=2*this.options.size*i,e=2*this.options.size*o}else{var n=this._getImagePadding();t=this.imageObj.width+n.left+n.right,e=this.imageObj.height+n.top+n.bottom}this.width=t,this.height=e,this.radius=.5*this.width}},{key:"_drawRawCircle",value:function(t,e,i,o){this.initContextForDraw(t,o),Yo(t,e,i,o.size),this.performFill(t,o)}},{key:"_drawImageAtPosition",value:function(t,e){if(0!=this.imageObj.width){t.globalAlpha=void 0!==e.opacity?e.opacity:1,this.enableShadow(t,e);var i=1;!0===this.options.shapeProperties.interpolation&&(i=this.imageObj.width/this.width/this.body.view.scale);var o=this._getImagePadding(),n=this.left+o.left,r=this.top+o.top,s=this.width-o.left-o.right,a=this.height-o.top-o.bottom;this.imageObj.drawImageAtPosition(t,i,n,r,s,a),this.disableShadow(t,e)}}},{key:"_drawImageLabel",value:function(t,e,i,o,n){var r=0;if(void 0!==this.height){r=.5*this.height;var s=this.labelModule.getTextSize(t,o,n);s.lineCount>=1&&(r+=s.height/2)}var a=i+r;this.options.label&&(this.labelOffset=r),this.labelModule.draw(t,e,a,o,n,"hanging")}}]),i}();function UB(t){var e=function(){if("undefined"==typeof Reflect||!AI)return!1;if(AI.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(AI(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,o=FO(t);if(e){var n=FO(this).constructor;i=AI(o,arguments,n)}else i=o.apply(this,arguments);return PO(this,i)}}var YB=function(t){MO(i,VB);var e=UB(i);function i(t,o,n){var r;return pu(this,i),(r=e.call(this,t,o,n))._setMargins(n),r}return Nf(i,[{key:"resize",value:function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:this.selected,i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:this.hover;if(this.needsRefresh(e,i)){var o=this.getDimensionsFromLabel(t,e,i),n=Math.max(o.width+this.margin.right+this.margin.left,o.height+this.margin.top+this.margin.bottom);this.options.size=n/2,this.width=n,this.height=n,this.radius=this.width/2}}},{key:"draw",value:function(t,e,i,o,n,r){this.resize(t,o,n),this.left=e-this.width/2,this.top=i-this.height/2,this._drawRawCircle(t,e,i,r),this.updateBoundingBox(e,i),this.labelModule.draw(t,this.left+this.textSize.width/2+this.margin.left,i,o,n)}},{key:"updateBoundingBox",value:function(t,e){this.boundingBox.top=e-this.options.size,this.boundingBox.left=t-this.options.size,this.boundingBox.right=t+this.options.size,this.boundingBox.bottom=e+this.options.size}},{key:"distanceToBorder",value:function(t){return t&&this.resize(t),.5*this.width}}]),i}();function XB(t){var e=function(){if("undefined"==typeof Reflect||!AI)return!1;if(AI.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(AI(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,o=FO(t);if(e){var n=FO(this).constructor;i=AI(o,arguments,n)}else i=o.apply(this,arguments);return PO(this,i)}}var GB=function(t){MO(i,VB);var e=XB(i);function i(t,o,n,r,s){var a;return pu(this,i),(a=e.call(this,t,o,n)).setImages(r,s),a}return Nf(i,[{key:"resize",value:function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:this.selected,i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:this.hover;if(void 0===this.imageObj.src||void 0===this.imageObj.width||void 0===this.imageObj.height){var o=2*this.options.size;return this.width=o,this.height=o,void(this.radius=.5*this.width)}this.needsRefresh(e,i)&&this._resizeImage()}},{key:"draw",value:function(t,e,i,o,n,r){this.switchImages(o),this.resize();var s=e,a=i;"top-left"===this.options.shapeProperties.coordinateOrigin?(this.left=e,this.top=i,s+=this.width/2,a+=this.height/2):(this.left=e-this.width/2,this.top=i-this.height/2),this._drawRawCircle(t,s,a,r),t.save(),t.clip(),this._drawImageAtPosition(t,r),t.restore(),this._drawImageLabel(t,s,a,o,n),this.updateBoundingBox(e,i)}},{key:"updateBoundingBox",value:function(t,e){"top-left"===this.options.shapeProperties.coordinateOrigin?(this.boundingBox.top=e,this.boundingBox.left=t,this.boundingBox.right=t+2*this.options.size,this.boundingBox.bottom=e+2*this.options.size):(this.boundingBox.top=e-this.options.size,this.boundingBox.left=t-this.options.size,this.boundingBox.right=t+this.options.size,this.boundingBox.bottom=e+this.options.size),this.boundingBox.left=Math.min(this.boundingBox.left,this.labelModule.size.left),this.boundingBox.right=Math.max(this.boundingBox.right,this.labelModule.size.left+this.labelModule.size.width),this.boundingBox.bottom=Math.max(this.boundingBox.bottom,this.boundingBox.bottom+this.labelOffset)}},{key:"distanceToBorder",value:function(t){return t&&this.resize(t),.5*this.width}}]),i}();function KB(t){var e=function(){if("undefined"==typeof Reflect||!AI)return!1;if(AI.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(AI(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,o=FO(t);if(e){var n=FO(this).constructor;i=AI(o,arguments,n)}else i=o.apply(this,arguments);return PO(this,i)}}var $B=function(t){MO(i,LB);var e=KB(i);function i(t,o,n){return pu(this,i),e.call(this,t,o,n)}return Nf(i,[{key:"resize",value:function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:this.selected,i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:this.hover,o=arguments.length>3&&void 0!==arguments[3]?arguments[3]:{size:this.options.size};if(this.needsRefresh(e,i)){var n,r;this.labelModule.getTextSize(t,e,i);var s=2*o.size;this.width=null!==(n=this.customSizeWidth)&&void 0!==n?n:s,this.height=null!==(r=this.customSizeHeight)&&void 0!==r?r:s,this.radius=.5*this.width}}},{key:"_drawShape",value:function(t,e,i,o,n,r,s,a){var h,l=this;return this.resize(t,r,s,a),this.left=o-this.width/2,this.top=n-this.height/2,this.initContextForDraw(t,a),(h=e,Object.prototype.hasOwnProperty.call(Zo,h)?Zo[h]:function(t){for(var e=arguments.length,i=new Array(e>1?e-1:0),o=1;o<e;o++)i[o-1]=arguments[o];CanvasRenderingContext2D.prototype[h].call(t,i)})(t,o,n,a.size),this.performFill(t,a),void 0!==this.options.icon&&void 0!==this.options.icon.code&&(t.font=(r?"bold ":"")+this.height/2+"px "+(this.options.icon.face||"FontAwesome"),t.fillStyle=this.options.icon.color||"black",t.textAlign="center",t.textBaseline="middle",t.fillText(this.options.icon.code,o,n)),{drawExternalLabel:function(){if(void 0!==l.options.label){l.labelModule.calculateLabelSize(t,r,s,o,n,"hanging");var e=n+.5*l.height+.5*l.labelModule.size.height;l.labelModule.draw(t,o,e,r,s,"hanging")}l.updateBoundingBox(o,n)}}}},{key:"updateBoundingBox",value:function(t,e){this.boundingBox.top=e-this.options.size,this.boundingBox.left=t-this.options.size,this.boundingBox.right=t+this.options.size,this.boundingBox.bottom=e+this.options.size,void 0!==this.options.label&&this.labelModule.size.width>0&&(this.boundingBox.left=Math.min(this.boundingBox.left,this.labelModule.size.left),this.boundingBox.right=Math.max(this.boundingBox.right,this.labelModule.size.left+this.labelModule.size.width),this.boundingBox.bottom=Math.max(this.boundingBox.bottom,this.boundingBox.bottom+this.labelModule.size.height))}}]),i}();function ZB(t,e){var i=nv(t);if(mc){var o=mc(t);e&&(o=oy(o).call(o,(function(e){return Dc(t,e).enumerable}))),i.push.apply(i,o)}return i}function QB(t){for(var e=1;e<arguments.length;e++){var i,o,n=null!=arguments[e]?arguments[e]:{};e%2?Cv(i=ZB(Object(n),!0)).call(i,(function(e){zf(t,e,n[e])})):Uc?iu(t,Uc(n)):Cv(o=ZB(Object(n))).call(o,(function(e){fu(t,e,Dc(n,e))}))}return t}function JB(t){var e=function(){if("undefined"==typeof Reflect||!AI)return!1;if(AI.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(AI(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,o=FO(t);if(e){var n=FO(this).constructor;i=AI(o,arguments,n)}else i=o.apply(this,arguments);return PO(this,i)}}var tN=function(t){MO(i,$B);var e=JB(i);function i(t,o,n,r){var s;return pu(this,i),(s=e.call(this,t,o,n,r)).ctxRenderer=r,s}return Nf(i,[{key:"draw",value:function(t,e,i,o,n,r){this.resize(t,o,n,r),this.left=e-this.width/2,this.top=i-this.height/2,t.save();var s=this.ctxRenderer({ctx:t,id:this.options.id,x:e,y:i,state:{selected:o,hover:n},style:QB({},r),label:this.options.label});if(null!=s.drawNode&&s.drawNode(),t.restore(),s.drawExternalLabel){var a=s.drawExternalLabel;s.drawExternalLabel=function(){t.save(),a(),t.restore()}}return s.nodeDimensions&&(this.customSizeWidth=s.nodeDimensions.width,this.customSizeHeight=s.nodeDimensions.height),s}},{key:"distanceToBorder",value:function(t,e){return this._distanceToBorder(t,e)}}]),i}();function eN(t){var e=function(){if("undefined"==typeof Reflect||!AI)return!1;if(AI.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(AI(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,o=FO(t);if(e){var n=FO(this).constructor;i=AI(o,arguments,n)}else i=o.apply(this,arguments);return PO(this,i)}}var iN=function(t){MO(i,LB);var e=eN(i);function i(t,o,n){var r;return pu(this,i),(r=e.call(this,t,o,n))._setMargins(n),r}return Nf(i,[{key:"resize",value:function(t,e,i){if(this.needsRefresh(e,i)){var o=this.getDimensionsFromLabel(t,e,i).width+this.margin.right+this.margin.left;this.width=o,this.height=o,this.radius=this.width/2}}},{key:"draw",value:function(t,e,i,o,n,r){this.resize(t,o,n),this.left=e-this.width/2,this.top=i-this.height/2,this.initContextForDraw(t,r),Ko(t,e-this.width/2,i-this.height/2,this.width,this.height),this.performFill(t,r),this.updateBoundingBox(e,i,t,o,n),this.labelModule.draw(t,this.left+this.textSize.width/2+this.margin.left,this.top+this.textSize.height/2+this.margin.top,o,n)}},{key:"distanceToBorder",value:function(t,e){return this._distanceToBorder(t,e)}}]),i}();function oN(t){var e=function(){if("undefined"==typeof Reflect||!AI)return!1;if(AI.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(AI(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,o=FO(t);if(e){var n=FO(this).constructor;i=AI(o,arguments,n)}else i=o.apply(this,arguments);return PO(this,i)}}var nN=function(t){MO(i,$B);var e=oN(i);function i(t,o,n){return pu(this,i),e.call(this,t,o,n)}return Nf(i,[{key:"draw",value:function(t,e,i,o,n,r){return this._drawShape(t,"diamond",4,e,i,o,n,r)}},{key:"distanceToBorder",value:function(t,e){return this._distanceToBorder(t,e)}}]),i}();function rN(t){var e=function(){if("undefined"==typeof Reflect||!AI)return!1;if(AI.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(AI(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,o=FO(t);if(e){var n=FO(this).constructor;i=AI(o,arguments,n)}else i=o.apply(this,arguments);return PO(this,i)}}var sN=function(t){MO(i,$B);var e=rN(i);function i(t,o,n){return pu(this,i),e.call(this,t,o,n)}return Nf(i,[{key:"draw",value:function(t,e,i,o,n,r){return this._drawShape(t,"circle",2,e,i,o,n,r)}},{key:"distanceToBorder",value:function(t){return t&&this.resize(t),this.options.size}}]),i}();function aN(t){var e=function(){if("undefined"==typeof Reflect||!AI)return!1;if(AI.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(AI(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,o=FO(t);if(e){var n=FO(this).constructor;i=AI(o,arguments,n)}else i=o.apply(this,arguments);return PO(this,i)}}var hN=function(t){MO(i,LB);var e=aN(i);function i(t,o,n){return pu(this,i),e.call(this,t,o,n)}return Nf(i,[{key:"resize",value:function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:this.selected,i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:this.hover;if(this.needsRefresh(e,i)){var o=this.getDimensionsFromLabel(t,e,i);this.height=2*o.height,this.width=o.width+o.height,this.radius=.5*this.width}}},{key:"draw",value:function(t,e,i,o,n,r){this.resize(t,o,n),this.left=e-.5*this.width,this.top=i-.5*this.height,this.initContextForDraw(t,r),Go(t,this.left,this.top,this.width,this.height),this.performFill(t,r),this.updateBoundingBox(e,i,t,o,n),this.labelModule.draw(t,e,i,o,n)}},{key:"distanceToBorder",value:function(t,e){t&&this.resize(t);var i=.5*this.width,o=.5*this.height,n=Math.sin(e)*i,r=Math.cos(e)*o;return i*o/Math.sqrt(n*n+r*r)}}]),i}();function lN(t){var e=function(){if("undefined"==typeof Reflect||!AI)return!1;if(AI.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(AI(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,o=FO(t);if(e){var n=FO(this).constructor;i=AI(o,arguments,n)}else i=o.apply(this,arguments);return PO(this,i)}}var dN=function(t){MO(i,LB);var e=lN(i);function i(t,o,n){var r;return pu(this,i),(r=e.call(this,t,o,n))._setMargins(n),r}return Nf(i,[{key:"resize",value:function(t,e,i){this.needsRefresh(e,i)&&(this.iconSize={width:Number(this.options.icon.size),height:Number(this.options.icon.size)},this.width=this.iconSize.width+this.margin.right+this.margin.left,this.height=this.iconSize.height+this.margin.top+this.margin.bottom,this.radius=.5*this.width)}},{key:"draw",value:function(t,e,i,o,n,r){var s=this;return this.resize(t,o,n),this.options.icon.size=this.options.icon.size||50,this.left=e-this.width/2,this.top=i-this.height/2,this._icon(t,e,i,o,n,r),{drawExternalLabel:function(){if(void 0!==s.options.label){s.labelModule.draw(t,s.left+s.iconSize.width/2+s.margin.left,i+s.height/2+5,o)}s.updateBoundingBox(e,i)}}}},{key:"updateBoundingBox",value:function(t,e){if(this.boundingBox.top=e-.5*this.options.icon.size,this.boundingBox.left=t-.5*this.options.icon.size,this.boundingBox.right=t+.5*this.options.icon.size,this.boundingBox.bottom=e+.5*this.options.icon.size,void 0!==this.options.label&&this.labelModule.size.width>0){this.boundingBox.left=Math.min(this.boundingBox.left,this.labelModule.size.left),this.boundingBox.right=Math.max(this.boundingBox.right,this.labelModule.size.left+this.labelModule.size.width),this.boundingBox.bottom=Math.max(this.boundingBox.bottom,this.boundingBox.bottom+this.labelModule.size.height+5)}}},{key:"_icon",value:function(t,e,i,o,n,r){var s=Number(this.options.icon.size);void 0!==this.options.icon.code?(t.font=[null!=this.options.icon.weight?this.options.icon.weight:o?"bold":"",(null!=this.options.icon.weight&&o?5:0)+s+"px",this.options.icon.face].join(" "),t.fillStyle=this.options.icon.color||"black",t.textAlign="center",t.textBaseline="middle",this.enableShadow(t,r),t.fillText(this.options.icon.code,e,i),this.disableShadow(t,r)):console.error("When using the icon shape, you need to define the code in the icon options object. This can be done per node or globally.")}},{key:"distanceToBorder",value:function(t,e){return this._distanceToBorder(t,e)}}]),i}();function cN(t){var e=function(){if("undefined"==typeof Reflect||!AI)return!1;if(AI.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(AI(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,o=FO(t);if(e){var n=FO(this).constructor;i=AI(o,arguments,n)}else i=o.apply(this,arguments);return PO(this,i)}}var uN=function(t){MO(i,VB);var e=cN(i);function i(t,o,n,r,s){var a;return pu(this,i),(a=e.call(this,t,o,n)).setImages(r,s),a}return Nf(i,[{key:"resize",value:function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:this.selected,i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:this.hover;if(void 0===this.imageObj.src||void 0===this.imageObj.width||void 0===this.imageObj.height){var o=2*this.options.size;return this.width=o,void(this.height=o)}this.needsRefresh(e,i)&&this._resizeImage()}},{key:"draw",value:function(t,e,i,o,n,r){t.save(),this.switchImages(o),this.resize();var s=e,a=i;if("top-left"===this.options.shapeProperties.coordinateOrigin?(this.left=e,this.top=i,s+=this.width/2,a+=this.height/2):(this.left=e-this.width/2,this.top=i-this.height/2),!0===this.options.shapeProperties.useBorderWithImage){var h=this.options.borderWidth,l=this.options.borderWidthSelected||2*this.options.borderWidth,d=(o?l:h)/this.body.view.scale;t.lineWidth=Math.min(this.width,d),t.beginPath();var c=o?this.options.color.highlight.border:n?this.options.color.hover.border:this.options.color.border,u=o?this.options.color.highlight.background:n?this.options.color.hover.background:this.options.color.background;void 0!==r.opacity&&(c=ek(c,r.opacity),u=ek(u,r.opacity)),t.strokeStyle=c,t.fillStyle=u,t.rect(this.left-.5*t.lineWidth,this.top-.5*t.lineWidth,this.width+t.lineWidth,this.height+t.lineWidth),ab(t).call(t),this.performStroke(t,r),t.closePath()}this._drawImageAtPosition(t,r),this._drawImageLabel(t,s,a,o,n),this.updateBoundingBox(e,i),t.restore()}},{key:"updateBoundingBox",value:function(t,e){this.resize(),"top-left"===this.options.shapeProperties.coordinateOrigin?(this.left=t,this.top=e):(this.left=t-this.width/2,this.top=e-this.height/2),this.boundingBox.left=this.left,this.boundingBox.top=this.top,this.boundingBox.bottom=this.top+this.height,this.boundingBox.right=this.left+this.width,void 0!==this.options.label&&this.labelModule.size.width>0&&(this.boundingBox.left=Math.min(this.boundingBox.left,this.labelModule.size.left),this.boundingBox.right=Math.max(this.boundingBox.right,this.labelModule.size.left+this.labelModule.size.width),this.boundingBox.bottom=Math.max(this.boundingBox.bottom,this.boundingBox.bottom+this.labelOffset))}},{key:"distanceToBorder",value:function(t,e){return this._distanceToBorder(t,e)}}]),i}();function fN(t){var e=function(){if("undefined"==typeof Reflect||!AI)return!1;if(AI.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(AI(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,o=FO(t);if(e){var n=FO(this).constructor;i=AI(o,arguments,n)}else i=o.apply(this,arguments);return PO(this,i)}}var pN=function(t){MO(i,$B);var e=fN(i);function i(t,o,n){return pu(this,i),e.call(this,t,o,n)}return Nf(i,[{key:"draw",value:function(t,e,i,o,n,r){return this._drawShape(t,"square",2,e,i,o,n,r)}},{key:"distanceToBorder",value:function(t,e){return this._distanceToBorder(t,e)}}]),i}();function vN(t){var e=function(){if("undefined"==typeof Reflect||!AI)return!1;if(AI.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(AI(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,o=FO(t);if(e){var n=FO(this).constructor;i=AI(o,arguments,n)}else i=o.apply(this,arguments);return PO(this,i)}}var gN=function(t){MO(i,$B);var e=vN(i);function i(t,o,n){return pu(this,i),e.call(this,t,o,n)}return Nf(i,[{key:"draw",value:function(t,e,i,o,n,r){return this._drawShape(t,"hexagon",4,e,i,o,n,r)}},{key:"distanceToBorder",value:function(t,e){return this._distanceToBorder(t,e)}}]),i}();function yN(t){var e=function(){if("undefined"==typeof Reflect||!AI)return!1;if(AI.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(AI(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,o=FO(t);if(e){var n=FO(this).constructor;i=AI(o,arguments,n)}else i=o.apply(this,arguments);return PO(this,i)}}var mN=function(t){MO(i,$B);var e=yN(i);function i(t,o,n){return pu(this,i),e.call(this,t,o,n)}return Nf(i,[{key:"draw",value:function(t,e,i,o,n,r){return this._drawShape(t,"star",4,e,i,o,n,r)}},{key:"distanceToBorder",value:function(t,e){return this._distanceToBorder(t,e)}}]),i}();function bN(t){var e=function(){if("undefined"==typeof Reflect||!AI)return!1;if(AI.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(AI(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,o=FO(t);if(e){var n=FO(this).constructor;i=AI(o,arguments,n)}else i=o.apply(this,arguments);return PO(this,i)}}var wN=function(t){MO(i,LB);var e=bN(i);function i(t,o,n){var r;return pu(this,i),(r=e.call(this,t,o,n))._setMargins(n),r}return Nf(i,[{key:"resize",value:function(t,e,i){this.needsRefresh(e,i)&&(this.textSize=this.labelModule.getTextSize(t,e,i),this.width=this.textSize.width+this.margin.right+this.margin.left,this.height=this.textSize.height+this.margin.top+this.margin.bottom,this.radius=.5*this.width)}},{key:"draw",value:function(t,e,i,o,n,r){this.resize(t,o,n),this.left=e-this.width/2,this.top=i-this.height/2,this.enableShadow(t,r),this.labelModule.draw(t,this.left+this.textSize.width/2+this.margin.left,this.top+this.textSize.height/2+this.margin.top,o,n),this.disableShadow(t,r),this.updateBoundingBox(e,i,t,o,n)}},{key:"distanceToBorder",value:function(t,e){return this._distanceToBorder(t,e)}}]),i}();function xN(t){var e=function(){if("undefined"==typeof Reflect||!AI)return!1;if(AI.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(AI(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,o=FO(t);if(e){var n=FO(this).constructor;i=AI(o,arguments,n)}else i=o.apply(this,arguments);return PO(this,i)}}var kN=function(t){MO(i,$B);var e=xN(i);function i(t,o,n){return pu(this,i),e.call(this,t,o,n)}return Nf(i,[{key:"draw",value:function(t,e,i,o,n,r){return this._drawShape(t,"triangle",3,e,i,o,n,r)}},{key:"distanceToBorder",value:function(t,e){return this._distanceToBorder(t,e)}}]),i}();function _N(t){var e=function(){if("undefined"==typeof Reflect||!AI)return!1;if(AI.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(AI(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,o=FO(t);if(e){var n=FO(this).constructor;i=AI(o,arguments,n)}else i=o.apply(this,arguments);return PO(this,i)}}var EN=function(t){MO(i,$B);var e=_N(i);function i(t,o,n){return pu(this,i),e.call(this,t,o,n)}return Nf(i,[{key:"draw",value:function(t,e,i,o,n,r){return this._drawShape(t,"triangleDown",3,e,i,o,n,r)}},{key:"distanceToBorder",value:function(t,e){return this._distanceToBorder(t,e)}}]),i}();function ON(t,e){var i=nv(t);if(mc){var o=mc(t);e&&(o=oy(o).call(o,(function(e){return Dc(t,e).enumerable}))),i.push.apply(i,o)}return i}function CN(t){for(var e=1;e<arguments.length;e++){var i,o,n=null!=arguments[e]?arguments[e]:{};e%2?Cv(i=ON(Object(n),!0)).call(i,(function(e){zf(t,e,n[e])})):Uc?iu(t,Uc(n)):Cv(o=ON(Object(n))).call(o,(function(e){fu(t,e,Dc(n,e))}))}return t}var SN=function(){function t(e,i,o,n,r,s){pu(this,t),this.options=uk(r),this.globalOptions=r,this.defaultOptions=s,this.body=i,this.edges=[],this.id=void 0,this.imagelist=o,this.grouplist=n,this.x=void 0,this.y=void 0,this.baseSize=this.options.size,this.baseFontSize=this.options.font.size,this.predefinedPosition=!1,this.selected=!1,this.hover=!1,this.labelModule=new RB(this.body,this.options,!1),this.setOptions(e)}return Nf(t,[{key:"attachEdge",value:function(t){var e;-1===tm(e=this.edges).call(e,t)&&this.edges.push(t)}},{key:"detachEdge",value:function(t){var e,i,o=tm(e=this.edges).call(e,t);-1!=o&&vg(i=this.edges).call(i,o,1)}},{key:"setOptions",value:function(e){var i=this.options.shape;if(e){if(void 0!==e.color&&(this._localColor=e.color),void 0!==e.id&&(this.id=e.id),void 0===this.id)throw new Error("Node must have an id");t.checkMass(e,this.id),void 0!==e.x&&(null===e.x?(this.x=void 0,this.predefinedPosition=!1):(this.x=Ly(e.x),this.predefinedPosition=!0)),void 0!==e.y&&(null===e.y?(this.y=void 0,this.predefinedPosition=!1):(this.y=Ly(e.y),this.predefinedPosition=!0)),void 0!==e.size&&(this.baseSize=e.size),void 0!==e.value&&(e.value=wB(e.value)),t.parseOptions(this.options,e,!0,this.globalOptions,this.grouplist);var o=[e,this.options,this.defaultOptions];return this.chooser=PB("node",o),this._load_images(),this.updateLabelModule(e),void 0!==e.opacity&&t.checkOpacity(e.opacity)&&(this.options.opacity=e.opacity),this.updateShape(i),void 0!==e.hidden||void 0!==e.physics}}},{key:"_load_images",value:function(){if(("circularImage"===this.options.shape||"image"===this.options.shape)&&void 0===this.options.image)throw new Error("Option image must be defined for node type '"+this.options.shape+"'");if(void 0!==this.options.image){if(void 0===this.imagelist)throw new Error("Internal Error: No images provided");if("string"==typeof this.options.image)this.imageObj=this.imagelist.load(this.options.image,this.options.brokenImage,this.id);else{if(void 0===this.options.image.unselected)throw new Error("No unselected image provided");this.imageObj=this.imagelist.load(this.options.image.unselected,this.options.brokenImage,this.id),void 0!==this.options.image.selected?this.imageObjAlt=this.imagelist.load(this.options.image.selected,this.options.brokenImage,this.id):this.imageObjAlt=void 0}}}},{key:"getFormattingValues",value:function(){var t={color:this.options.color.background,opacity:this.options.opacity,borderWidth:this.options.borderWidth,borderColor:this.options.color.border,size:this.options.size,borderDashes:this.options.shapeProperties.borderDashes,borderRadius:this.options.shapeProperties.borderRadius,shadow:this.options.shadow.enabled,shadowColor:this.options.shadow.color,shadowSize:this.options.shadow.size,shadowX:this.options.shadow.x,shadowY:this.options.shadow.y};if(this.selected||this.hover?!0===this.chooser?this.selected?(null!=this.options.borderWidthSelected?t.borderWidth=this.options.borderWidthSelected:t.borderWidth*=2,t.color=this.options.color.highlight.background,t.borderColor=this.options.color.highlight.border,t.shadow=this.options.shadow.enabled):this.hover&&(t.color=this.options.color.hover.background,t.borderColor=this.options.color.hover.border,t.shadow=this.options.shadow.enabled):"function"==typeof this.chooser&&(this.chooser(t,this.options.id,this.selected,this.hover),!1===t.shadow&&(t.shadowColor===this.options.shadow.color&&t.shadowSize===this.options.shadow.size&&t.shadowX===this.options.shadow.x&&t.shadowY===this.options.shadow.y||(t.shadow=!0))):t.shadow=this.options.shadow.enabled,void 0!==this.options.opacity){var e=this.options.opacity;t.borderColor=ek(t.borderColor,e),t.color=ek(t.color,e),t.shadowColor=ek(t.shadowColor,e)}return t}},{key:"updateLabelModule",value:function(e){void 0!==this.options.label&&null!==this.options.label||(this.options.label=""),t.updateGroupOptions(this.options,CN(CN({},e),{},{color:e&&e.color||this._localColor||void 0}),this.grouplist);var i=this.grouplist.get(this.options.group,!1),o=[e,this.options,i,this.globalOptions,this.defaultOptions];this.labelModule.update(this.options,o),void 0!==this.labelModule.baseSize&&(this.baseFontSize=this.labelModule.baseSize)}},{key:"updateShape",value:function(t){if(t===this.options.shape&&this.shape)this.shape.setOptions(this.options,this.imageObj,this.imageObjAlt);else switch(this.options.shape){case"box":this.shape=new WB(this.options,this.body,this.labelModule);break;case"circle":this.shape=new YB(this.options,this.body,this.labelModule);break;case"circularImage":this.shape=new GB(this.options,this.body,this.labelModule,this.imageObj,this.imageObjAlt);break;case"custom":this.shape=new tN(this.options,this.body,this.labelModule,this.options.ctxRenderer);break;case"database":this.shape=new iN(this.options,this.body,this.labelModule);break;case"diamond":this.shape=new nN(this.options,this.body,this.labelModule);break;case"dot":this.shape=new sN(this.options,this.body,this.labelModule);break;case"ellipse":default:this.shape=new hN(this.options,this.body,this.labelModule);break;case"icon":this.shape=new dN(this.options,this.body,this.labelModule);break;case"image":this.shape=new uN(this.options,this.body,this.labelModule,this.imageObj,this.imageObjAlt);break;case"square":this.shape=new pN(this.options,this.body,this.labelModule);break;case"hexagon":this.shape=new gN(this.options,this.body,this.labelModule);break;case"star":this.shape=new mN(this.options,this.body,this.labelModule);break;case"text":this.shape=new wN(this.options,this.body,this.labelModule);break;case"triangle":this.shape=new kN(this.options,this.body,this.labelModule);break;case"triangleDown":this.shape=new EN(this.options,this.body,this.labelModule)}this.needsRefresh()}},{key:"select",value:function(){this.selected=!0,this.needsRefresh()}},{key:"unselect",value:function(){this.selected=!1,this.needsRefresh()}},{key:"needsRefresh",value:function(){this.shape.refreshNeeded=!0}},{key:"getTitle",value:function(){return this.options.title}},{key:"distanceToBorder",value:function(t,e){return this.shape.distanceToBorder(t,e)}},{key:"isFixed",value:function(){return this.options.fixed.x&&this.options.fixed.y}},{key:"isSelected",value:function(){return this.selected}},{key:"getValue",value:function(){return this.options.value}},{key:"getLabelSize",value:function(){return this.labelModule.size()}},{key:"setValueRange",value:function(t,e,i){if(void 0!==this.options.value){var o=this.options.scaling.customScalingFunction(t,e,i,this.options.value),n=this.options.scaling.max-this.options.scaling.min;if(!0===this.options.scaling.label.enabled){var r=this.options.scaling.label.max-this.options.scaling.label.min;this.options.font.size=this.options.scaling.label.min+o*r}this.options.size=this.options.scaling.min+o*n}else this.options.size=this.baseSize,this.options.font.size=this.baseFontSize;this.updateLabelModule()}},{key:"draw",value:function(t){var e=this.getFormattingValues();return this.shape.draw(t,this.x,this.y,this.selected,this.hover,e)||{}}},{key:"updateBoundingBox",value:function(t){this.shape.updateBoundingBox(this.x,this.y,t)}},{key:"resize",value:function(t){var e=this.getFormattingValues();this.shape.resize(t,this.selected,this.hover,e)}},{key:"getItemsOnPoint",value:function(t){var e=[];return this.labelModule.visible()&&DB(this.labelModule.getSize(),t)&&e.push({nodeId:this.id,labelId:0}),DB(this.shape.boundingBox,t)&&e.push({nodeId:this.id}),e}},{key:"isOverlappingWith",value:function(t){return this.shape.left<t.right&&this.shape.left+this.shape.width>t.left&&this.shape.top<t.bottom&&this.shape.top+this.shape.height>t.top}},{key:"isBoundingBoxOverlappingWith",value:function(t){return this.shape.boundingBox.left<t.right&&this.shape.boundingBox.right>t.left&&this.shape.boundingBox.top<t.bottom&&this.shape.boundingBox.bottom>t.top}}],[{key:"checkOpacity",value:function(t){return 0<=t&&t<=1}},{key:"checkCoordinateOrigin",value:function(t){return void 0===t||"center"===t||"top-left"===t}},{key:"updateGroupOptions",value:function(e,i,o){var n;if(void 0!==o){var r=e.group;if(void 0!==i&&void 0!==i.group&&r!==i.group)throw new Error("updateGroupOptions: group values in options don't match.");if("number"==typeof r||"string"==typeof r&&""!=r){var s=o.get(r);void 0!==s.opacity&&void 0===i.opacity&&(t.checkOpacity(s.opacity)||(console.error("Invalid option for node opacity. Value must be between 0 and 1, found: "+s.opacity),s.opacity=void 0));var a=oy(n=MB(i)).call(n,(function(t){return null!=i[t]}));a.push("font"),qx(a,e,s),e.color=ok(e.color)}}}},{key:"parseOptions",value:function(e,i){var o=arguments.length>2&&void 0!==arguments[2]&&arguments[2],n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:{},r=arguments.length>4?arguments[4]:void 0;if(qx(["color","fixed","shadow"],e,i,o),t.checkMass(i),void 0!==e.opacity&&(t.checkOpacity(e.opacity)||(console.error("Invalid option for node opacity. Value must be between 0 and 1, found: "+e.opacity),e.opacity=void 0)),void 0!==i.opacity&&(t.checkOpacity(i.opacity)||(console.error("Invalid option for node opacity. Value must be between 0 and 1, found: "+i.opacity),i.opacity=void 0)),i.shapeProperties&&!t.checkCoordinateOrigin(i.shapeProperties.coordinateOrigin)&&console.error("Invalid option for node coordinateOrigin, found: "+i.shapeProperties.coordinateOrigin),fk(e,i,"shadow",n),void 0!==i.color&&null!==i.color){var s=ok(i.color);Lx(e.color,s)}else!0===o&&null===i.color&&(e.color=uk(n.color));void 0!==i.fixed&&null!==i.fixed&&("boolean"==typeof i.fixed?(e.fixed.x=i.fixed,e.fixed.y=i.fixed):(void 0!==i.fixed.x&&"boolean"==typeof i.fixed.x&&(e.fixed.x=i.fixed.x),void 0!==i.fixed.y&&"boolean"==typeof i.fixed.y&&(e.fixed.y=i.fixed.y))),!0===o&&null===i.font&&(e.font=uk(n.font)),t.updateGroupOptions(e,i,r),void 0!==i.scaling&&fk(e.scaling,i.scaling,"label",n.scaling)}},{key:"checkMass",value:function(t,e){if(void 0!==t.mass&&t.mass<=0){var i="";void 0!==e&&(i=" in node id: "+e),console.error("%cNegative or zero mass disallowed"+i+", setting mass to 1.",Pk),t.mass=1}}}]),t}();function TN(t,e){var i=void 0!==Op&&xh(t)||t["@@iterator"];if(!i){if(Wp(t)||(i=function(t,e){var i;if(!t)return;if("string"==typeof t)return MN(t,e);var o=Fp(i=Object.prototype.toString.call(t)).call(i,8,-1);"Object"===o&&t.constructor&&(o=t.constructor.name);if("Map"===o||"Set"===o)return Za(t);if("Arguments"===o||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(o))return MN(t,e)}(t))||e&&t&&"number"==typeof t.length){i&&(t=i);var o=0,n=function(){};return{s:n,n:function(){return o>=t.length?{done:!0}:{done:!1,value:t[o++]}},e:function(t){throw t},f:n}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var r,s=!0,a=!1;return{s:function(){i=i.call(t)},n:function(){var t=i.next();return s=t.done,t},e:function(t){a=!0,r=t},f:function(){try{s||null==i.return||i.return()}finally{if(a)throw r}}}}function MN(t,e){(null==e||e>t.length)&&(e=t.length);for(var i=0,o=new Array(e);i<e;i++)o[i]=t[i];return o}var PN=function(){function t(e,i,o,n){var r,s=this;if(pu(this,t),this.body=e,this.images=i,this.groups=o,this.layoutEngine=n,this.body.functions.createNode=Uo(r=this.create).call(r,this),this.nodesListeners={add:function(t,e){s.add(e.items)},update:function(t,e){s.update(e.items,e.data,e.oldData)},remove:function(t,e){s.remove(e.items)}},this.defaultOptions={borderWidth:1,borderWidthSelected:void 0,brokenImage:void 0,color:{border:"#2B7CE9",background:"#97C2FC",highlight:{border:"#2B7CE9",background:"#D2E5FF"},hover:{border:"#2B7CE9",background:"#D2E5FF"}},opacity:void 0,fixed:{x:!1,y:!1},font:{color:"#343434",size:14,face:"arial",background:"none",strokeWidth:0,strokeColor:"#ffffff",align:"center",vadjust:0,multi:!1,bold:{mod:"bold"},boldital:{mod:"bold italic"},ital:{mod:"italic"},mono:{mod:"",size:15,face:"monospace",vadjust:2}},group:void 0,hidden:!1,icon:{face:"FontAwesome",code:void 0,size:50,color:"#2B7CE9"},image:void 0,imagePadding:{top:0,right:0,bottom:0,left:0},label:void 0,labelHighlightBold:!0,level:void 0,margin:{top:5,right:5,bottom:5,left:5},mass:1,physics:!0,scaling:{min:10,max:30,label:{enabled:!1,min:14,max:30,maxVisible:30,drawThreshold:5},customScalingFunction:function(t,e,i,o){if(e===t)return.5;var n=1/(e-t);return Math.max(0,(o-t)*n)}},shadow:{enabled:!1,color:"rgba(0,0,0,0.5)",size:10,x:5,y:5},shape:"ellipse",shapeProperties:{borderDashes:!1,borderRadius:6,interpolation:!0,useImageSize:!1,useBorderWithImage:!1,coordinateOrigin:"center"},size:25,title:void 0,value:void 0,x:void 0,y:void 0},this.defaultOptions.mass<=0)throw"Internal error: mass in defaultOptions of NodesHandler may not be zero or negative";this.options=uk(this.defaultOptions),this.bindEventListeners()}return Nf(t,[{key:"bindEventListeners",value:function(){var t,e,i=this;this.body.emitter.on("refreshNodes",Uo(t=this.refresh).call(t,this)),this.body.emitter.on("refresh",Uo(e=this.refresh).call(e,this)),this.body.emitter.on("destroy",(function(){Kx(i.nodesListeners,(function(t,e){i.body.data.nodes&&i.body.data.nodes.off(e,t)})),delete i.body.functions.createNode,delete i.nodesListeners.add,delete i.nodesListeners.update,delete i.nodesListeners.remove,delete i.nodesListeners}))}},{key:"setOptions",value:function(t){if(void 0!==t){if(SN.parseOptions(this.options,t),void 0!==t.opacity&&(GE(t.opacity)||!tO(t.opacity)||t.opacity<0||t.opacity>1?console.error("Invalid option for node opacity. Value must be between 0 and 1, found: "+t.opacity):this.options.opacity=t.opacity),void 0!==t.shape)for(var e in this.body.nodes)Object.prototype.hasOwnProperty.call(this.body.nodes,e)&&this.body.nodes[e].updateShape();if(void 0!==t.font||void 0!==t.widthConstraint||void 0!==t.heightConstraint)for(var i=0,o=nv(this.body.nodes);i<o.length;i++){var n=o[i];this.body.nodes[n].updateLabelModule(),this.body.nodes[n].needsRefresh()}if(void 0!==t.size)for(var r in this.body.nodes)Object.prototype.hasOwnProperty.call(this.body.nodes,r)&&this.body.nodes[r].needsRefresh();void 0===t.hidden&&void 0===t.physics||this.body.emitter.emit("_dataChanged")}}},{key:"setData",value:function(t){var e=arguments.length>1&&void 0!==arguments[1]&&arguments[1],i=this.body.data.nodes;if(rB("id",t))this.body.data.nodes=t;else if(Wp(t))this.body.data.nodes=new iB,this.body.data.nodes.add(t);else{if(t)throw new TypeError("Array or DataSet expected");this.body.data.nodes=new iB}if(i&&Kx(this.nodesListeners,(function(t,e){i.off(e,t)})),this.body.nodes={},this.body.data.nodes){var o=this;Kx(this.nodesListeners,(function(t,e){o.body.data.nodes.on(e,t)}));var n=this.body.data.nodes.getIds();this.add(n,!0)}!1===e&&this.body.emitter.emit("_dataChanged")}},{key:"add",value:function(t){for(var e,i=arguments.length>1&&void 0!==arguments[1]&&arguments[1],o=[],n=0;n<t.length;n++){e=t[n];var r=this.body.data.nodes.get(e),s=this.create(r);o.push(s),this.body.nodes[e]=s}this.layoutEngine.positionInitially(o),!1===i&&this.body.emitter.emit("_dataChanged")}},{key:"update",value:function(t,e,i){for(var o=this.body.nodes,n=!1,r=0;r<t.length;r++){var s=t[r],a=o[s],h=e[r];void 0!==a?a.setOptions(h)&&(n=!0):(n=!0,a=this.create(h),o[s]=a)}n||void 0===i||(n=dO(e).call(e,(function(t,e){var o=i[e];return o&&o.level!==t.level}))),!0===n?this.body.emitter.emit("_dataChanged"):this.body.emitter.emit("_dataUpdated")}},{key:"remove",value:function(t){for(var e=this.body.nodes,i=0;i<t.length;i++){delete e[t[i]]}this.body.emitter.emit("_dataChanged")}},{key:"create",value:function(t){return new(arguments.length>1&&void 0!==arguments[1]?arguments[1]:SN)(t,this.body,this.images,this.groups,this.options,this.defaultOptions)}},{key:"refresh",value:function(){var t=this,e=arguments.length>0&&void 0!==arguments[0]&&arguments[0];Kx(this.body.nodes,(function(i,o){var n=t.body.data.nodes.get(o);void 0!==n&&(!0===e&&i.setOptions({x:null,y:null}),i.setOptions({fixed:!1}),i.setOptions(n))}))}},{key:"getPositions",value:function(t){var e={};if(void 0!==t){if(!0===Wp(t)){for(var i=0;i<t.length;i++)if(void 0!==this.body.nodes[t[i]]){var o=this.body.nodes[t[i]];e[t[i]]={x:Math.round(o.x),y:Math.round(o.y)}}}else if(void 0!==this.body.nodes[t]){var n=this.body.nodes[t];e[t]={x:Math.round(n.x),y:Math.round(n.y)}}}else for(var r=0;r<this.body.nodeIndices.length;r++){var s=this.body.nodes[this.body.nodeIndices[r]];e[this.body.nodeIndices[r]]={x:Math.round(s.x),y:Math.round(s.y)}}return e}},{key:"getPosition",value:function(t){if(null==t)throw new TypeError("No id was specified for getPosition method.");if(null==this.body.nodes[t])throw new ReferenceError("NodeId provided for getPosition does not exist. Provided: ".concat(t));return{x:Math.round(this.body.nodes[t].x),y:Math.round(this.body.nodes[t].y)}}},{key:"storePositions",value:function(){var t,e=[],i=this.body.data.nodes.getDataSet(),o=TN(i.get());try{for(o.s();!(t=o.n()).done;){var n=t.value,r=n.id,s=this.body.nodes[r],a=Math.round(s.x),h=Math.round(s.y);n.x===a&&n.y===h||e.push({id:r,x:a,y:h})}}catch(t){o.e(t)}finally{o.f()}i.update(e)}},{key:"getBoundingBox",value:function(t){if(void 0!==this.body.nodes[t])return this.body.nodes[t].shape.boundingBox}},{key:"getConnectedNodes",value:function(t,e){var i=[];if(void 0!==this.body.nodes[t])for(var o=this.body.nodes[t],n={},r=0;r<o.edges.length;r++){var s=o.edges[r];"to"!==e&&s.toId==o.id?void 0===n[s.fromId]&&(i.push(s.fromId),n[s.fromId]=!0):"from"!==e&&s.fromId==o.id&&void 0===n[s.toId]&&(i.push(s.toId),n[s.toId]=!0)}return i}},{key:"getConnectedEdges",value:function(t){var e=[];if(void 0!==this.body.nodes[t])for(var i=this.body.nodes[t],o=0;o<i.edges.length;o++)e.push(i.edges[o].id);else console.error("NodeId provided for getConnectedEdges does not exist. Provided: ",t);return e}},{key:"moveNode",value:function(t,e,i){var o=this;void 0!==this.body.nodes[t]?(this.body.nodes[t].x=Number(e),this.body.nodes[t].y=Number(i),Xm((function(){o.body.emitter.emit("startSimulation")}),0)):console.error("Node id supplied to moveNode does not exist. Provided: ",t)}}]),t}(),DN={},IN={get exports(){return DN},set exports(t){DN=t}},BN={},NN={get exports(){return BN},set exports(t){BN=t}},zN=Qt,FN=B,AN=et,jN=ii,RN=function(t){return void 0!==t&&(zN(t,"value")||zN(t,"writable"))},LN=M,HN=Nr;Ti({target:"Reflect",stat:!0},{get:function t(e,i){var o,n,r=arguments.length<3?e:arguments[2];return jN(e)===r?e[i]:(o=LN.f(e,i))?RN(o)?o.value:void 0===o.get?void 0:FN(o.get,r):AN(n=HN(e))?t(n,i,r):void 0}});var WN=it.Reflect.get;NN.exports=WN,IN.exports=BN;var qN=e(DN),VN={},UN={get exports(){return VN},set exports(t){VN=t}},YN={},XN=Pc;({get exports(){return YN},set exports(t){YN=t}}).exports=XN,UN.exports=YN;var GN=e(VN);function KN(){var t;"undefined"!=typeof Reflect&&qN?KN=SO(t=qN).call(t):KN=function(t,e,i){var o=function(t,e){for(;!Object.prototype.hasOwnProperty.call(t,e)&&null!==(t=FO(t)););return t}(t,e);if(o){var n=GN(o,e);return n.get?n.get.call(arguments.length<3?t:i):n.value}};return KN.apply(this,arguments)}var $N={},ZN={get exports(){return $N},set exports(t){$N=t}},QN=Ti,JN=Math.hypot,tz=Math.abs,ez=Math.sqrt;QN({target:"Math",stat:!0,arity:2,forced:!!JN&&JN(1/0,NaN)!==1/0},{hypot:function(t,e){for(var i,o,n=0,r=0,s=arguments.length,a=0;r<s;)a<(i=tz(arguments[r++]))?(n=n*(o=a/i)*o+1,a=i):n+=i>0?(o=i/a)*o:i;return a===1/0?1/0:a*ez(n)}});var iz=it.Math.hypot;ZN.exports=iz;var oz=e($N);function nz(t){var e=function(){if("undefined"==typeof Reflect||!AI)return!1;if(AI.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(AI(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,o=FO(t);if(e){var n=FO(this).constructor;i=AI(o,arguments,n)}else i=o.apply(this,arguments);return PO(this,i)}}var rz=function(){function t(){pu(this,t)}return Nf(t,null,[{key:"transform",value:function(t,e){Wp(t)||(t=[t]);for(var i=e.point.x,o=e.point.y,n=e.angle,r=e.length,s=0;s<t.length;++s){var a=t[s],h=a.x*Math.cos(n)-a.y*Math.sin(n),l=a.x*Math.sin(n)+a.y*Math.cos(n);a.x=i+r*h,a.y=o+r*l}}},{key:"drawPath",value:function(t,e){t.beginPath(),t.moveTo(e[0].x,e[0].y);for(var i=1;i<e.length;++i)t.lineTo(e[i].x,e[i].y);t.closePath()}}]),t}(),sz=function(t){MO(i,rz);var e=nz(i);function i(){return pu(this,i),e.apply(this,arguments)}return Nf(i,null,[{key:"draw",value:function(t,e){if(e.image){t.save(),t.translate(e.point.x,e.point.y),t.rotate(Math.PI/2+e.angle);var i=null!=e.imageWidth?e.imageWidth:e.image.width,o=null!=e.imageHeight?e.imageHeight:e.image.height;e.image.drawImageAtPosition(t,1,-i/2,0,i,o),t.restore()}return!1}}]),i}(),az=function(t){MO(i,rz);var e=nz(i);function i(){return pu(this,i),e.apply(this,arguments)}return Nf(i,null,[{key:"draw",value:function(t,e){var i=[{x:0,y:0},{x:-1,y:.3},{x:-.9,y:0},{x:-1,y:-.3}];return rz.transform(i,e),rz.drawPath(t,i),!0}}]),i}(),hz=function(){function t(){pu(this,t)}return Nf(t,null,[{key:"draw",value:function(t,e){var i=[{x:-1,y:0},{x:0,y:.3},{x:-.4,y:0},{x:0,y:-.3}];return rz.transform(i,e),rz.drawPath(t,i),!0}}]),t}(),lz=function(){function t(){pu(this,t)}return Nf(t,null,[{key:"draw",value:function(t,e){var i={x:-.4,y:0};rz.transform(i,e),t.strokeStyle=t.fillStyle,t.fillStyle="rgba(0, 0, 0, 0)";var o=Math.PI,n=e.angle-o/2,r=e.angle+o/2;return t.beginPath(),t.arc(i.x,i.y,.4*e.length,n,r,!1),t.stroke(),!0}}]),t}(),dz=function(){function t(){pu(this,t)}return Nf(t,null,[{key:"draw",value:function(t,e){var i={x:-.3,y:0};rz.transform(i,e),t.strokeStyle=t.fillStyle,t.fillStyle="rgba(0, 0, 0, 0)";var o=Math.PI,n=e.angle+o/2,r=e.angle+3*o/2;return t.beginPath(),t.arc(i.x,i.y,.4*e.length,n,r,!1),t.stroke(),!0}}]),t}(),cz=function(){function t(){pu(this,t)}return Nf(t,null,[{key:"draw",value:function(t,e){var i=[{x:.02,y:0},{x:-1,y:.3},{x:-1,y:-.3}];return rz.transform(i,e),rz.drawPath(t,i),!0}}]),t}(),uz=function(){function t(){pu(this,t)}return Nf(t,null,[{key:"draw",value:function(t,e){var i=[{x:0,y:.3},{x:0,y:-.3},{x:-1,y:0}];return rz.transform(i,e),rz.drawPath(t,i),!0}}]),t}(),fz=function(){function t(){pu(this,t)}return Nf(t,null,[{key:"draw",value:function(t,e){var i={x:-.4,y:0};return rz.transform(i,e),Yo(t,i.x,i.y,.4*e.length),!0}}]),t}(),pz=function(){function t(){pu(this,t)}return Nf(t,null,[{key:"draw",value:function(t,e){var i=[{x:0,y:.5},{x:0,y:-.5},{x:-.15,y:-.5},{x:-.15,y:.5}];return rz.transform(i,e),rz.drawPath(t,i),!0}}]),t}(),vz=function(){function t(){pu(this,t)}return Nf(t,null,[{key:"draw",value:function(t,e){var i=[{x:0,y:.3},{x:0,y:-.3},{x:-.6,y:-.3},{x:-.6,y:.3}];return rz.transform(i,e),rz.drawPath(t,i),!0}}]),t}(),gz=function(){function t(){pu(this,t)}return Nf(t,null,[{key:"draw",value:function(t,e){var i=[{x:0,y:0},{x:-.5,y:-.3},{x:-1,y:0},{x:-.5,y:.3}];return rz.transform(i,e),rz.drawPath(t,i),!0}}]),t}(),yz=function(){function t(){pu(this,t)}return Nf(t,null,[{key:"draw",value:function(t,e){var i=[{x:-1,y:.3},{x:-.5,y:0},{x:-1,y:-.3},{x:0,y:0}];return rz.transform(i,e),rz.drawPath(t,i),!0}}]),t}(),mz=function(){function t(){pu(this,t)}return Nf(t,null,[{key:"draw",value:function(t,e){var i;switch(e.type&&(i=e.type.toLowerCase()),i){case"image":return sz.draw(t,e);case"circle":return fz.draw(t,e);case"box":return vz.draw(t,e);case"crow":return hz.draw(t,e);case"curve":return lz.draw(t,e);case"diamond":return gz.draw(t,e);case"inv_curve":return dz.draw(t,e);case"triangle":return cz.draw(t,e);case"inv_triangle":return uz.draw(t,e);case"bar":return pz.draw(t,e);case"vee":return yz.draw(t,e);default:return az.draw(t,e)}}}]),t}();function bz(t,e){var i=nv(t);if(mc){var o=mc(t);e&&(o=oy(o).call(o,(function(e){return Dc(t,e).enumerable}))),i.push.apply(i,o)}return i}function wz(t){for(var e=1;e<arguments.length;e++){var i,o,n=null!=arguments[e]?arguments[e]:{};e%2?Cv(i=bz(Object(n),!0)).call(i,(function(e){zf(t,e,n[e])})):Uc?iu(t,Uc(n)):Cv(o=bz(Object(n))).call(o,(function(e){fu(t,e,Dc(n,e))}))}return t}var xz=function(){function t(e,i,o){pu(this,t),this._body=i,this._labelModule=o,this.color={},this.colorDirty=!0,this.hoverWidth=1.5,this.selectionWidth=2,this.setOptions(e),this.fromPoint=this.from,this.toPoint=this.to}return Nf(t,[{key:"connect",value:function(){this.from=this._body.nodes[this.options.from],this.to=this._body.nodes[this.options.to]}},{key:"cleanup",value:function(){return!1}},{key:"setOptions",value:function(t){this.options=t,this.from=this._body.nodes[this.options.from],this.to=this._body.nodes[this.options.to],this.id=this.options.id}},{key:"drawLine",value:function(t,e,i,o){var n=arguments.length>4&&void 0!==arguments[4]?arguments[4]:this.getViaNode();t.strokeStyle=this.getColor(t,e),t.lineWidth=e.width,!1!==e.dashes?this._drawDashedLine(t,e,n):this._drawLine(t,e,n)}},{key:"_drawLine",value:function(t,e,i,o,n){if(this.from!=this.to)this._line(t,e,i,o,n);else{var r=kp(this._getCircleData(t),3),s=r[0],a=r[1],h=r[2];this._circle(t,e,s,a,h)}}},{key:"_drawDashedLine",value:function(t,e,i,o,n){t.lineCap="round";var r=Wp(e.dashes)?e.dashes:[5,5];if(void 0!==t.setLineDash){if(t.save(),t.setLineDash(r),t.lineDashOffset=0,this.from!=this.to)this._line(t,e,i);else{var s=kp(this._getCircleData(t),3),a=s[0],h=s[1],l=s[2];this._circle(t,e,a,h,l)}t.setLineDash([0]),t.lineDashOffset=0,t.restore()}else{if(this.from!=this.to)$o(t,this.from.x,this.from.y,this.to.x,this.to.y,r);else{var d=kp(this._getCircleData(t),3),c=d[0],u=d[1],f=d[2];this._circle(t,e,c,u,f)}this.enableShadow(t,e),t.stroke(),this.disableShadow(t,e)}}},{key:"findBorderPosition",value:function(t,e,i){return this.from!=this.to?this._findBorderPosition(t,e,i):this._findBorderPositionCircle(t,e,i)}},{key:"findBorderPositions",value:function(t){if(this.from!=this.to)return{from:this._findBorderPosition(this.from,t),to:this._findBorderPosition(this.to,t)};var e,i=kp(Fp(e=this._getCircleData(t)).call(e,0,2),2),o=i[0],n=i[1];return{from:this._findBorderPositionCircle(this.from,t,{x:o,y:n,low:.25,high:.6,direction:-1}),to:this._findBorderPositionCircle(this.from,t,{x:o,y:n,low:.6,high:.8,direction:1})}}},{key:"_getCircleData",value:function(t){var e=this.options.selfReference.size;void 0!==t&&void 0===this.from.shape.width&&this.from.shape.resize(t);var i=BB(t,this.options.selfReference.angle,e,this.from);return[i.x,i.y,e]}},{key:"_pointOnCircle",value:function(t,e,i,o){var n=2*o*Math.PI;return{x:t+i*Math.cos(n),y:e-i*Math.sin(n)}}},{key:"_findBorderPositionCircle",value:function(t,e,i){var o,n=i.x,r=i.y,s=i.low,a=i.high,h=i.direction,l=this.options.selfReference.size,d=.5*(s+a),c=0;!0===this.options.arrowStrikethrough&&(-1===h?c=this.options.endPointOffset.from:1===h&&(c=this.options.endPointOffset.to));var u=0;do{d=.5*(s+a),o=this._pointOnCircle(n,r,l,d);var f=Math.atan2(t.y-o.y,t.x-o.x),p=t.distanceToBorder(e,f)+c-Math.sqrt(Math.pow(o.x-t.x,2)+Math.pow(o.y-t.y,2));if(Math.abs(p)<.05)break;p>0?h>0?s=d:a=d:h>0?a=d:s=d,++u}while(s<=a&&u<10);return wz(wz({},o),{},{t:d})}},{key:"getLineWidth",value:function(t,e){return!0===t?Math.max(this.selectionWidth,.3/this._body.view.scale):!0===e?Math.max(this.hoverWidth,.3/this._body.view.scale):Math.max(this.options.width,.3/this._body.view.scale)}},{key:"getColor",value:function(t,e){if(!1!==e.inheritsColor){if("both"===e.inheritsColor&&this.from.id!==this.to.id){var i=t.createLinearGradient(this.from.x,this.from.y,this.to.x,this.to.y),o=this.from.options.color.highlight.border,n=this.to.options.color.highlight.border;return!1===this.from.selected&&!1===this.to.selected?(o=ek(this.from.options.color.border,e.opacity),n=ek(this.to.options.color.border,e.opacity)):!0===this.from.selected&&!1===this.to.selected?n=this.to.options.color.border:!1===this.from.selected&&!0===this.to.selected&&(o=this.from.options.color.border),i.addColorStop(0,o),i.addColorStop(1,n),i}return"to"===e.inheritsColor?ek(this.to.options.color.border,e.opacity):ek(this.from.options.color.border,e.opacity)}return ek(e.color,e.opacity)}},{key:"_circle",value:function(t,e,i,o,n){this.enableShadow(t,e);var r=0,s=2*Math.PI;if(!this.options.selfReference.renderBehindTheNode){var a=this.options.selfReference.angle,h=this.options.selfReference.angle+Math.PI,l=this._findBorderPositionCircle(this.from,t,{x:i,y:o,low:a,high:h,direction:-1}),d=this._findBorderPositionCircle(this.from,t,{x:i,y:o,low:a,high:h,direction:1});r=Math.atan2(l.y-o,l.x-i),s=Math.atan2(d.y-o,d.x-i)}t.beginPath(),t.arc(i,o,n,r,s,!1),t.stroke(),this.disableShadow(t,e)}},{key:"getDistanceToEdge",value:function(t,e,i,o,n,r){if(this.from!=this.to)return this._getDistanceToEdge(t,e,i,o,n,r);var s=kp(this._getCircleData(void 0),3),a=s[0],h=s[1],l=s[2],d=a-n,c=h-r;return Math.abs(Math.sqrt(d*d+c*c)-l)}},{key:"_getDistanceToLine",value:function(t,e,i,o,n,r){var s=i-t,a=o-e,h=((n-t)*s+(r-e)*a)/(s*s+a*a);h>1?h=1:h<0&&(h=0);var l=t+h*s-n,d=e+h*a-r;return Math.sqrt(l*l+d*d)}},{key:"getArrowData",value:function(t,e,i,o,n,r){var s,a,h,l,d,c,u,f=r.width;"from"===e?(h=this.from,l=this.to,d=r.fromArrowScale<0,c=Math.abs(r.fromArrowScale),u=r.fromArrowType):"to"===e?(h=this.to,l=this.from,d=r.toArrowScale<0,c=Math.abs(r.toArrowScale),u=r.toArrowType):(h=this.to,l=this.from,d=r.middleArrowScale<0,c=Math.abs(r.middleArrowScale),u=r.middleArrowType);var p=15*c+3*f;if(h!=l){var v=p/oz(h.x-l.x,h.y-l.y);if("middle"!==e)if(!0===this.options.smooth.enabled){var g=this._findBorderPosition(h,t,{via:i}),y=this.getPoint(g.t+v*("from"===e?1:-1),i);s=Math.atan2(g.y-y.y,g.x-y.x),a=g}else s=Math.atan2(h.y-l.y,h.x-l.x),a=this._findBorderPosition(h,t);else{var m=(d?-v:v)/2,b=this.getPoint(.5+m,i),w=this.getPoint(.5-m,i);s=Math.atan2(b.y-w.y,b.x-w.x),a=this.getPoint(.5,i)}}else{var x=kp(this._getCircleData(t),3),k=x[0],_=x[1],E=x[2];if("from"===e){var O=this.options.selfReference.angle,C=this.options.selfReference.angle+Math.PI,S=this._findBorderPositionCircle(this.from,t,{x:k,y:_,low:O,high:C,direction:-1});s=-2*S.t*Math.PI+1.5*Math.PI+.1*Math.PI,a=S}else if("to"===e){var T=this.options.selfReference.angle,M=this.options.selfReference.angle+Math.PI,P=this._findBorderPositionCircle(this.from,t,{x:k,y:_,low:T,high:M,direction:1});s=-2*P.t*Math.PI+1.5*Math.PI-1.1*Math.PI,a=P}else{var D=this.options.selfReference.angle/(2*Math.PI);a=this._pointOnCircle(k,_,E,D),s=-2*D*Math.PI+1.5*Math.PI+.1*Math.PI}}return{point:a,core:{x:a.x-.9*p*Math.cos(s),y:a.y-.9*p*Math.sin(s)},angle:s,length:p,type:u}}},{key:"drawArrowHead",value:function(t,e,i,o,n){t.strokeStyle=this.getColor(t,e),t.fillStyle=t.strokeStyle,t.lineWidth=e.width,mz.draw(t,n)&&(this.enableShadow(t,e),ab(t).call(t),this.disableShadow(t,e))}},{key:"enableShadow",value:function(t,e){!0===e.shadow&&(t.shadowColor=e.shadowColor,t.shadowBlur=e.shadowSize,t.shadowOffsetX=e.shadowX,t.shadowOffsetY=e.shadowY)}},{key:"disableShadow",value:function(t,e){!0===e.shadow&&(t.shadowColor="rgba(0,0,0,0)",t.shadowBlur=0,t.shadowOffsetX=0,t.shadowOffsetY=0)}},{key:"drawBackground",value:function(t,e){if(!1!==e.background){var i={strokeStyle:t.strokeStyle,lineWidth:t.lineWidth,dashes:t.dashes};t.strokeStyle=e.backgroundColor,t.lineWidth=e.backgroundSize,this.setStrokeDashed(t,e.backgroundDashes),t.stroke(),t.strokeStyle=i.strokeStyle,t.lineWidth=i.lineWidth,t.dashes=i.dashes,this.setStrokeDashed(t,e.dashes)}}},{key:"setStrokeDashed",value:function(t,e){if(!1!==e)if(void 0!==t.setLineDash){var i=Wp(e)?e:[5,5];t.setLineDash(i)}else console.warn("setLineDash is not supported in this browser. The dashed stroke cannot be used.");else void 0!==t.setLineDash?t.setLineDash([]):console.warn("setLineDash is not supported in this browser. The dashed stroke cannot be used.")}}]),t}();function kz(t,e){var i=nv(t);if(mc){var o=mc(t);e&&(o=oy(o).call(o,(function(e){return Dc(t,e).enumerable}))),i.push.apply(i,o)}return i}function _z(t){for(var e=1;e<arguments.length;e++){var i,o,n=null!=arguments[e]?arguments[e]:{};e%2?Cv(i=kz(Object(n),!0)).call(i,(function(e){zf(t,e,n[e])})):Uc?iu(t,Uc(n)):Cv(o=kz(Object(n))).call(o,(function(e){fu(t,e,Dc(n,e))}))}return t}function Ez(t){var e=function(){if("undefined"==typeof Reflect||!AI)return!1;if(AI.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(AI(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,o=FO(t);if(e){var n=FO(this).constructor;i=AI(o,arguments,n)}else i=o.apply(this,arguments);return PO(this,i)}}var Oz=function(t){MO(i,xz);var e=Ez(i);function i(t,o,n){return pu(this,i),e.call(this,t,o,n)}return Nf(i,[{key:"_findBorderPositionBezier",value:function(t,e){var i,o,n=arguments.length>2&&void 0!==arguments[2]?arguments[2]:this._getViaCoordinates(),r=!1,s=1,a=0,h=this.to,l=this.options.endPointOffset?this.options.endPointOffset.to:0;t.id===this.from.id&&(h=this.from,r=!0,l=this.options.endPointOffset?this.options.endPointOffset.from:0),!1===this.options.arrowStrikethrough&&(l=0);var d=0;do{o=.5*(a+s),i=this.getPoint(o,n);var c=Math.atan2(h.y-i.y,h.x-i.x),u=h.distanceToBorder(e,c)+l-Math.sqrt(Math.pow(i.x-h.x,2)+Math.pow(i.y-h.y,2));if(Math.abs(u)<.2)break;u<0?!1===r?a=o:s=o:!1===r?s=o:a=o,++d}while(a<=s&&d<10);return _z(_z({},i),{},{t:o})}},{key:"_getDistanceToBezierEdge",value:function(t,e,i,o,n,r,s){var a,h,l,d,c,u=1e9,f=t,p=e;for(h=1;h<10;h++)l=.1*h,d=Math.pow(1-l,2)*t+2*l*(1-l)*s.x+Math.pow(l,2)*i,c=Math.pow(1-l,2)*e+2*l*(1-l)*s.y+Math.pow(l,2)*o,h>0&&(u=(a=this._getDistanceToLine(f,p,d,c,n,r))<u?a:u),f=d,p=c;return u}},{key:"_bezierCurve",value:function(t,e,i,o){t.beginPath(),t.moveTo(this.fromPoint.x,this.fromPoint.y),null!=i&&null!=i.x?null!=o&&null!=o.x?t.bezierCurveTo(i.x,i.y,o.x,o.y,this.toPoint.x,this.toPoint.y):t.quadraticCurveTo(i.x,i.y,this.toPoint.x,this.toPoint.y):t.lineTo(this.toPoint.x,this.toPoint.y),this.drawBackground(t,e),this.enableShadow(t,e),t.stroke(),this.disableShadow(t,e)}},{key:"getViaNode",value:function(){return this._getViaCoordinates()}}]),i}();function Cz(t){var e=function(){if("undefined"==typeof Reflect||!AI)return!1;if(AI.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(AI(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,o=FO(t);if(e){var n=FO(this).constructor;i=AI(o,arguments,n)}else i=o.apply(this,arguments);return PO(this,i)}}var Sz=function(t){MO(i,Oz);var e=Cz(i);function i(t,o,n){var r;return pu(this,i),(r=e.call(this,t,o,n)).via=r.via,r._boundFunction=function(){r.positionBezierNode()},r._body.emitter.on("_repositionBezierNodes",r._boundFunction),r}return Nf(i,[{key:"setOptions",value:function(t){KN(FO(i.prototype),"setOptions",this).call(this,t);var e=!1;this.options.physics!==t.physics&&(e=!0),this.options=t,this.id=this.options.id,this.from=this._body.nodes[this.options.from],this.to=this._body.nodes[this.options.to],this.setupSupportNode(),this.connect(),!0===e&&(this.via.setOptions({physics:this.options.physics}),this.positionBezierNode())}},{key:"connect",value:function(){this.from=this._body.nodes[this.options.from],this.to=this._body.nodes[this.options.to],void 0===this.from||void 0===this.to||!1===this.options.physics||this.from.id===this.to.id?this.via.setOptions({physics:!1}):this.via.setOptions({physics:!0})}},{key:"cleanup",value:function(){return this._body.emitter.off("_repositionBezierNodes",this._boundFunction),void 0!==this.via&&(delete this._body.nodes[this.via.id],this.via=void 0,!0)}},{key:"setupSupportNode",value:function(){if(void 0===this.via){var t="edgeId:"+this.id,e=this._body.functions.createNode({id:t,shape:"circle",physics:!0,hidden:!0});this._body.nodes[t]=e,this.via=e,this.via.parentEdgeId=this.id,this.positionBezierNode()}}},{key:"positionBezierNode",value:function(){void 0!==this.via&&void 0!==this.from&&void 0!==this.to?(this.via.x=.5*(this.from.x+this.to.x),this.via.y=.5*(this.from.y+this.to.y)):void 0!==this.via&&(this.via.x=0,this.via.y=0)}},{key:"_line",value:function(t,e,i){this._bezierCurve(t,e,i)}},{key:"_getViaCoordinates",value:function(){return this.via}},{key:"getViaNode",value:function(){return this.via}},{key:"getPoint",value:function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:this.via;if(this.from===this.to){var i=kp(this._getCircleData(),3),o=i[0],n=i[1],r=i[2],s=2*Math.PI*(1-t);return{x:o+r*Math.sin(s),y:n+r-r*(1-Math.cos(s))}}return{x:Math.pow(1-t,2)*this.fromPoint.x+2*t*(1-t)*e.x+Math.pow(t,2)*this.toPoint.x,y:Math.pow(1-t,2)*this.fromPoint.y+2*t*(1-t)*e.y+Math.pow(t,2)*this.toPoint.y}}},{key:"_findBorderPosition",value:function(t,e){return this._findBorderPositionBezier(t,e,this.via)}},{key:"_getDistanceToEdge",value:function(t,e,i,o,n,r){return this._getDistanceToBezierEdge(t,e,i,o,n,r,this.via)}}]),i}();function Tz(t){var e=function(){if("undefined"==typeof Reflect||!AI)return!1;if(AI.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(AI(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,o=FO(t);if(e){var n=FO(this).constructor;i=AI(o,arguments,n)}else i=o.apply(this,arguments);return PO(this,i)}}var Mz=function(t){MO(i,Oz);var e=Tz(i);function i(t,o,n){return pu(this,i),e.call(this,t,o,n)}return Nf(i,[{key:"_line",value:function(t,e,i){this._bezierCurve(t,e,i)}},{key:"getViaNode",value:function(){return this._getViaCoordinates()}},{key:"_getViaCoordinates",value:function(){var t,e,i=this.options.smooth.roundness,o=this.options.smooth.type,n=Math.abs(this.from.x-this.to.x),r=Math.abs(this.from.y-this.to.y);if("discrete"===o||"diagonalCross"===o){var s,a;s=a=n<=r?i*r:i*n,this.from.x>this.to.x&&(s=-s),this.from.y>=this.to.y&&(a=-a);var h=this.from.x+s,l=this.from.y+a;return"discrete"===o&&(n<=r?h=n<i*r?this.from.x:h:l=r<i*n?this.from.y:l),{x:h,y:l}}if("straightCross"===o){var d=(1-i)*n,c=(1-i)*r;return n<=r?(d=0,this.from.y<this.to.y&&(c=-c)):(this.from.x<this.to.x&&(d=-d),c=0),{x:this.to.x+d,y:this.to.y+c}}if("horizontal"===o){var u=(1-i)*n;return this.from.x<this.to.x&&(u=-u),{x:this.to.x+u,y:this.from.y}}if("vertical"===o){var f=(1-i)*r;return this.from.y<this.to.y&&(f=-f),{x:this.from.x,y:this.to.y+f}}if("curvedCW"===o){n=this.to.x-this.from.x,r=this.from.y-this.to.y;var p=Math.sqrt(n*n+r*r),v=Math.PI,g=(Math.atan2(r,n)+(.5*i+.5)*v)%(2*v);return{x:this.from.x+(.5*i+.5)*p*Math.sin(g),y:this.from.y+(.5*i+.5)*p*Math.cos(g)}}if("curvedCCW"===o){n=this.to.x-this.from.x,r=this.from.y-this.to.y;var y=Math.sqrt(n*n+r*r),m=Math.PI,b=(Math.atan2(r,n)+(.5*-i+.5)*m)%(2*m);return{x:this.from.x+(.5*i+.5)*y*Math.sin(b),y:this.from.y+(.5*i+.5)*y*Math.cos(b)}}t=e=n<=r?i*r:i*n,this.from.x>this.to.x&&(t=-t),this.from.y>=this.to.y&&(e=-e);var w=this.from.x+t,x=this.from.y+e;return n<=r?w=this.from.x<=this.to.x?this.to.x<w?this.to.x:w:this.to.x>w?this.to.x:w:x=this.from.y>=this.to.y?this.to.y>x?this.to.y:x:this.to.y<x?this.to.y:x,{x:w,y:x}}},{key:"_findBorderPosition",value:function(t,e){var i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:{};return this._findBorderPositionBezier(t,e,i.via)}},{key:"_getDistanceToEdge",value:function(t,e,i,o,n,r){var s=arguments.length>6&&void 0!==arguments[6]?arguments[6]:this._getViaCoordinates();return this._getDistanceToBezierEdge(t,e,i,o,n,r,s)}},{key:"getPoint",value:function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:this._getViaCoordinates(),i=t;return{x:Math.pow(1-i,2)*this.fromPoint.x+2*i*(1-i)*e.x+Math.pow(i,2)*this.toPoint.x,y:Math.pow(1-i,2)*this.fromPoint.y+2*i*(1-i)*e.y+Math.pow(i,2)*this.toPoint.y}}}]),i}();function Pz(t){var e=function(){if("undefined"==typeof Reflect||!AI)return!1;if(AI.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(AI(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,o=FO(t);if(e){var n=FO(this).constructor;i=AI(o,arguments,n)}else i=o.apply(this,arguments);return PO(this,i)}}var Dz=function(t){MO(i,Oz);var e=Pz(i);function i(t,o,n){return pu(this,i),e.call(this,t,o,n)}return Nf(i,[{key:"_getDistanceToBezierEdge2",value:function(t,e,i,o,n,r,s,a){for(var h=1e9,l=t,d=e,c=[0,0,0,0],u=1;u<10;u++){var f=.1*u;c[0]=Math.pow(1-f,3),c[1]=3*f*Math.pow(1-f,2),c[2]=3*Math.pow(f,2)*(1-f),c[3]=Math.pow(f,3);var p=c[0]*t+c[1]*s.x+c[2]*a.x+c[3]*i,v=c[0]*e+c[1]*s.y+c[2]*a.y+c[3]*o;if(u>0){var g=this._getDistanceToLine(l,d,p,v,n,r);h=g<h?g:h}l=p,d=v}return h}}]),i}();function Iz(t){var e=function(){if("undefined"==typeof Reflect||!AI)return!1;if(AI.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(AI(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,o=FO(t);if(e){var n=FO(this).constructor;i=AI(o,arguments,n)}else i=o.apply(this,arguments);return PO(this,i)}}var Bz=function(t){MO(i,Dz);var e=Iz(i);function i(t,o,n){return pu(this,i),e.call(this,t,o,n)}return Nf(i,[{key:"_line",value:function(t,e,i){var o=i[0],n=i[1];this._bezierCurve(t,e,o,n)}},{key:"_getViaCoordinates",value:function(){var t,e,i,o,n=this.from.x-this.to.x,r=this.from.y-this.to.y,s=this.options.smooth.roundness;return(Math.abs(n)>Math.abs(r)||!0===this.options.smooth.forceDirection||"horizontal"===this.options.smooth.forceDirection)&&"vertical"!==this.options.smooth.forceDirection?(e=this.from.y,o=this.to.y,t=this.from.x-s*n,i=this.to.x+s*n):(e=this.from.y-s*r,o=this.to.y+s*r,t=this.from.x,i=this.to.x),[{x:t,y:e},{x:i,y:o}]}},{key:"getViaNode",value:function(){return this._getViaCoordinates()}},{key:"_findBorderPosition",value:function(t,e){return this._findBorderPositionBezier(t,e)}},{key:"_getDistanceToEdge",value:function(t,e,i,o,n,r){var s=kp(arguments.length>6&&void 0!==arguments[6]?arguments[6]:this._getViaCoordinates(),2),a=s[0],h=s[1];return this._getDistanceToBezierEdge2(t,e,i,o,n,r,a,h)}},{key:"getPoint",value:function(t){var e=kp(arguments.length>1&&void 0!==arguments[1]?arguments[1]:this._getViaCoordinates(),2),i=e[0],o=e[1],n=t,r=[Math.pow(1-n,3),3*n*Math.pow(1-n,2),3*Math.pow(n,2)*(1-n),Math.pow(n,3)];return{x:r[0]*this.fromPoint.x+r[1]*i.x+r[2]*o.x+r[3]*this.toPoint.x,y:r[0]*this.fromPoint.y+r[1]*i.y+r[2]*o.y+r[3]*this.toPoint.y}}}]),i}();function Nz(t){var e=function(){if("undefined"==typeof Reflect||!AI)return!1;if(AI.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(AI(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,o=FO(t);if(e){var n=FO(this).constructor;i=AI(o,arguments,n)}else i=o.apply(this,arguments);return PO(this,i)}}var zz=function(t){MO(i,xz);var e=Nz(i);function i(t,o,n){return pu(this,i),e.call(this,t,o,n)}return Nf(i,[{key:"_line",value:function(t,e){t.beginPath(),t.moveTo(this.fromPoint.x,this.fromPoint.y),t.lineTo(this.toPoint.x,this.toPoint.y),this.enableShadow(t,e),t.stroke(),this.disableShadow(t,e)}},{key:"getViaNode",value:function(){}},{key:"getPoint",value:function(t){return{x:(1-t)*this.fromPoint.x+t*this.toPoint.x,y:(1-t)*this.fromPoint.y+t*this.toPoint.y}}},{key:"_findBorderPosition",value:function(t,e){var i=this.to,o=this.from;t.id===this.from.id&&(i=this.from,o=this.to);var n=Math.atan2(i.y-o.y,i.x-o.x),r=i.x-o.x,s=i.y-o.y,a=Math.sqrt(r*r+s*s),h=(a-t.distanceToBorder(e,n))/a;return{x:(1-h)*o.x+h*i.x,y:(1-h)*o.y+h*i.y,t:0}}},{key:"_getDistanceToEdge",value:function(t,e,i,o,n,r){return this._getDistanceToLine(t,e,i,o,n,r)}}]),i}(),Fz=function(){function t(e,i,o,n,r){if(pu(this,t),void 0===i)throw new Error("No body provided");this.options=uk(n),this.globalOptions=n,this.defaultOptions=r,this.body=i,this.imagelist=o,this.id=void 0,this.fromId=void 0,this.toId=void 0,this.selected=!1,this.hover=!1,this.labelDirty=!0,this.baseWidth=this.options.width,this.baseFontSize=this.options.font.size,this.from=void 0,this.to=void 0,this.edgeType=void 0,this.connected=!1,this.labelModule=new RB(this.body,this.options,!0),this.setOptions(e)}return Nf(t,[{key:"setOptions",value:function(e){if(e){var i=void 0!==e.physics&&this.options.physics!==e.physics||void 0!==e.hidden&&(this.options.hidden||!1)!==(e.hidden||!1)||void 0!==e.from&&this.options.from!==e.from||void 0!==e.to&&this.options.to!==e.to;t.parseOptions(this.options,e,!0,this.globalOptions),void 0!==e.id&&(this.id=e.id),void 0!==e.from&&(this.fromId=e.from),void 0!==e.to&&(this.toId=e.to),void 0!==e.title&&(this.title=e.title),void 0!==e.value&&(e.value=wB(e.value));var o=[e,this.options,this.defaultOptions];return this.chooser=PB("edge",o),this.updateLabelModule(e),i=this.updateEdgeType()||i,this._setInteractionWidths(),this.connect(),i}}},{key:"getFormattingValues",value:function(){var t=!0===this.options.arrows.to||!0===this.options.arrows.to.enabled,e=!0===this.options.arrows.from||!0===this.options.arrows.from.enabled,i=!0===this.options.arrows.middle||!0===this.options.arrows.middle.enabled,o=this.options.color.inherit,n={toArrow:t,toArrowScale:this.options.arrows.to.scaleFactor,toArrowType:this.options.arrows.to.type,toArrowSrc:this.options.arrows.to.src,toArrowImageWidth:this.options.arrows.to.imageWidth,toArrowImageHeight:this.options.arrows.to.imageHeight,middleArrow:i,middleArrowScale:this.options.arrows.middle.scaleFactor,middleArrowType:this.options.arrows.middle.type,middleArrowSrc:this.options.arrows.middle.src,middleArrowImageWidth:this.options.arrows.middle.imageWidth,middleArrowImageHeight:this.options.arrows.middle.imageHeight,fromArrow:e,fromArrowScale:this.options.arrows.from.scaleFactor,fromArrowType:this.options.arrows.from.type,fromArrowSrc:this.options.arrows.from.src,fromArrowImageWidth:this.options.arrows.from.imageWidth,fromArrowImageHeight:this.options.arrows.from.imageHeight,arrowStrikethrough:this.options.arrowStrikethrough,color:o?void 0:this.options.color.color,inheritsColor:o,opacity:this.options.color.opacity,hidden:this.options.hidden,length:this.options.length,shadow:this.options.shadow.enabled,shadowColor:this.options.shadow.color,shadowSize:this.options.shadow.size,shadowX:this.options.shadow.x,shadowY:this.options.shadow.y,dashes:this.options.dashes,width:this.options.width,background:this.options.background.enabled,backgroundColor:this.options.background.color,backgroundSize:this.options.background.size,backgroundDashes:this.options.background.dashes};if(this.selected||this.hover)if(!0===this.chooser){if(this.selected){var r=this.options.selectionWidth;"function"==typeof r?n.width=r(n.width):"number"==typeof r&&(n.width+=r),n.width=Math.max(n.width,.3/this.body.view.scale),n.color=this.options.color.highlight,n.shadow=this.options.shadow.enabled}else if(this.hover){var s=this.options.hoverWidth;"function"==typeof s?n.width=s(n.width):"number"==typeof s&&(n.width+=s),n.width=Math.max(n.width,.3/this.body.view.scale),n.color=this.options.color.hover,n.shadow=this.options.shadow.enabled}}else"function"==typeof this.chooser&&(this.chooser(n,this.options.id,this.selected,this.hover),void 0!==n.color&&(n.inheritsColor=!1),!1===n.shadow&&(n.shadowColor===this.options.shadow.color&&n.shadowSize===this.options.shadow.size&&n.shadowX===this.options.shadow.x&&n.shadowY===this.options.shadow.y||(n.shadow=!0)));else n.shadow=this.options.shadow.enabled,n.width=Math.max(n.width,.3/this.body.view.scale);return n}},{key:"updateLabelModule",value:function(t){var e=[t,this.options,this.globalOptions,this.defaultOptions];this.labelModule.update(this.options,e),void 0!==this.labelModule.baseSize&&(this.baseFontSize=this.labelModule.baseSize)}},{key:"updateEdgeType",value:function(){var t=this.options.smooth,e=!1,i=!0;return void 0!==this.edgeType&&((this.edgeType instanceof Sz&&!0===t.enabled&&"dynamic"===t.type||this.edgeType instanceof Bz&&!0===t.enabled&&"cubicBezier"===t.type||this.edgeType instanceof Mz&&!0===t.enabled&&"dynamic"!==t.type&&"cubicBezier"!==t.type||this.edgeType instanceof zz&&!1===t.type.enabled)&&(i=!1),!0===i&&(e=this.cleanup())),!0===i?!0===t.enabled?"dynamic"===t.type?(e=!0,this.edgeType=new Sz(this.options,this.body,this.labelModule)):"cubicBezier"===t.type?this.edgeType=new Bz(this.options,this.body,this.labelModule):this.edgeType=new Mz(this.options,this.body,this.labelModule):this.edgeType=new zz(this.options,this.body,this.labelModule):this.edgeType.setOptions(this.options),e}},{key:"connect",value:function(){this.disconnect(),this.from=this.body.nodes[this.fromId]||void 0,this.to=this.body.nodes[this.toId]||void 0,this.connected=void 0!==this.from&&void 0!==this.to,!0===this.connected?(this.from.attachEdge(this),this.to.attachEdge(this)):(this.from&&this.from.detachEdge(this),this.to&&this.to.detachEdge(this)),this.edgeType.connect()}},{key:"disconnect",value:function(){this.from&&(this.from.detachEdge(this),this.from=void 0),this.to&&(this.to.detachEdge(this),this.to=void 0),this.connected=!1}},{key:"getTitle",value:function(){return this.title}},{key:"isSelected",value:function(){return this.selected}},{key:"getValue",value:function(){return this.options.value}},{key:"setValueRange",value:function(t,e,i){if(void 0!==this.options.value){var o=this.options.scaling.customScalingFunction(t,e,i,this.options.value),n=this.options.scaling.max-this.options.scaling.min;if(!0===this.options.scaling.label.enabled){var r=this.options.scaling.label.max-this.options.scaling.label.min;this.options.font.size=this.options.scaling.label.min+o*r}this.options.width=this.options.scaling.min+o*n}else this.options.width=this.baseWidth,this.options.font.size=this.baseFontSize;this._setInteractionWidths(),this.updateLabelModule()}},{key:"_setInteractionWidths",value:function(){"function"==typeof this.options.hoverWidth?this.edgeType.hoverWidth=this.options.hoverWidth(this.options.width):this.edgeType.hoverWidth=this.options.hoverWidth+this.options.width,"function"==typeof this.options.selectionWidth?this.edgeType.selectionWidth=this.options.selectionWidth(this.options.width):this.edgeType.selectionWidth=this.options.selectionWidth+this.options.width}},{key:"draw",value:function(t){var e=this.getFormattingValues();if(!e.hidden){var i=this.edgeType.getViaNode();this.edgeType.drawLine(t,e,this.selected,this.hover,i),this.drawLabel(t,i)}}},{key:"drawArrows",value:function(t){var e=this.getFormattingValues();if(!e.hidden){var i=this.edgeType.getViaNode(),o={};this.edgeType.fromPoint=this.edgeType.from,this.edgeType.toPoint=this.edgeType.to,e.fromArrow&&(o.from=this.edgeType.getArrowData(t,"from",i,this.selected,this.hover,e),!1===e.arrowStrikethrough&&(this.edgeType.fromPoint=o.from.core),e.fromArrowSrc&&(o.from.image=this.imagelist.load(e.fromArrowSrc)),e.fromArrowImageWidth&&(o.from.imageWidth=e.fromArrowImageWidth),e.fromArrowImageHeight&&(o.from.imageHeight=e.fromArrowImageHeight)),e.toArrow&&(o.to=this.edgeType.getArrowData(t,"to",i,this.selected,this.hover,e),!1===e.arrowStrikethrough&&(this.edgeType.toPoint=o.to.core),e.toArrowSrc&&(o.to.image=this.imagelist.load(e.toArrowSrc)),e.toArrowImageWidth&&(o.to.imageWidth=e.toArrowImageWidth),e.toArrowImageHeight&&(o.to.imageHeight=e.toArrowImageHeight)),e.middleArrow&&(o.middle=this.edgeType.getArrowData(t,"middle",i,this.selected,this.hover,e),e.middleArrowSrc&&(o.middle.image=this.imagelist.load(e.middleArrowSrc)),e.middleArrowImageWidth&&(o.middle.imageWidth=e.middleArrowImageWidth),e.middleArrowImageHeight&&(o.middle.imageHeight=e.middleArrowImageHeight)),e.fromArrow&&this.edgeType.drawArrowHead(t,e,this.selected,this.hover,o.from),e.middleArrow&&this.edgeType.drawArrowHead(t,e,this.selected,this.hover,o.middle),e.toArrow&&this.edgeType.drawArrowHead(t,e,this.selected,this.hover,o.to)}}},{key:"drawLabel",value:function(t,e){if(void 0!==this.options.label){var i,o=this.from,n=this.to;if(this.labelModule.differentState(this.selected,this.hover)&&this.labelModule.getTextSize(t,this.selected,this.hover),o.id!=n.id){this.labelModule.pointToSelf=!1,i=this.edgeType.getPoint(.5,e),t.save();var r=this._getRotation(t);0!=r.angle&&(t.translate(r.x,r.y),t.rotate(r.angle)),this.labelModule.draw(t,i.x,i.y,this.selected,this.hover),t.restore()}else{this.labelModule.pointToSelf=!0;var s=BB(t,this.options.selfReference.angle,this.options.selfReference.size,o);i=this._pointOnCircle(s.x,s.y,this.options.selfReference.size,this.options.selfReference.angle),this.labelModule.draw(t,i.x,i.y,this.selected,this.hover)}}}},{key:"getItemsOnPoint",value:function(t){var e=[];if(this.labelModule.visible()){var i=this._getRotation();DB(this.labelModule.getSize(),t,i)&&e.push({edgeId:this.id,labelId:0})}var o={left:t.x,top:t.y};return this.isOverlappingWith(o)&&e.push({edgeId:this.id}),e}},{key:"isOverlappingWith",value:function(t){if(this.connected){var e=this.from.x,i=this.from.y,o=this.to.x,n=this.to.y,r=t.left,s=t.top;return this.edgeType.getDistanceToEdge(e,i,o,n,r,s)<10}return!1}},{key:"_getRotation",value:function(t){var e=this.edgeType.getViaNode(),i=this.edgeType.getPoint(.5,e);void 0!==t&&this.labelModule.calculateLabelSize(t,this.selected,this.hover,i.x,i.y);var o={x:i.x,y:this.labelModule.size.yLine,angle:0};if(!this.labelModule.visible())return o;if("horizontal"===this.options.font.align)return o;var n=this.from.y-this.to.y,r=this.from.x-this.to.x,s=Math.atan2(n,r);return(s<-1&&r<0||s>0&&r<0)&&(s+=Math.PI),o.angle=s,o}},{key:"_pointOnCircle",value:function(t,e,i,o){return{x:t+i*Math.cos(o),y:e-i*Math.sin(o)}}},{key:"select",value:function(){this.selected=!0}},{key:"unselect",value:function(){this.selected=!1}},{key:"cleanup",value:function(){return this.edgeType.cleanup()}},{key:"remove",value:function(){this.cleanup(),this.disconnect(),delete this.body.edges[this.id]}},{key:"endPointsValid",value:function(){return void 0!==this.body.nodes[this.fromId]&&void 0!==this.body.nodes[this.toId]}}],[{key:"parseOptions",value:function(t,e){var i=arguments.length>2&&void 0!==arguments[2]&&arguments[2],o=arguments.length>3&&void 0!==arguments[3]?arguments[3]:{},n=arguments.length>4&&void 0!==arguments[4]&&arguments[4];if(Wx(["endPointOffset","arrowStrikethrough","id","from","hidden","hoverWidth","labelHighlightBold","length","line","opacity","physics","scaling","selectionWidth","selfReferenceSize","selfReference","to","title","value","width","font","chosen","widthConstraint"],t,e,i),void 0!==e.endPointOffset&&void 0!==e.endPointOffset.from&&(tO(e.endPointOffset.from)?t.endPointOffset.from=e.endPointOffset.from:(t.endPointOffset.from=void 0!==o.endPointOffset.from?o.endPointOffset.from:0,console.error("endPointOffset.from is not a valid number"))),void 0!==e.endPointOffset&&void 0!==e.endPointOffset.to&&(tO(e.endPointOffset.to)?t.endPointOffset.to=e.endPointOffset.to:(t.endPointOffset.to=void 0!==o.endPointOffset.to?o.endPointOffset.to:0,console.error("endPointOffset.to is not a valid number"))),IB(e.label)?t.label=e.label:IB(t.label)||(t.label=void 0),fk(t,e,"smooth",o),fk(t,e,"shadow",o),fk(t,e,"background",o),void 0!==e.dashes&&null!==e.dashes?t.dashes=e.dashes:!0===i&&null===e.dashes&&(t.dashes=mm(o.dashes)),void 0!==e.scaling&&null!==e.scaling?(void 0!==e.scaling.min&&(t.scaling.min=e.scaling.min),void 0!==e.scaling.max&&(t.scaling.max=e.scaling.max),fk(t.scaling,e.scaling,"label",o.scaling)):!0===i&&null===e.scaling&&(t.scaling=mm(o.scaling)),void 0!==e.arrows&&null!==e.arrows)if("string"==typeof e.arrows){var r=e.arrows.toLowerCase();t.arrows.to.enabled=-1!=tm(r).call(r,"to"),t.arrows.middle.enabled=-1!=tm(r).call(r,"middle"),t.arrows.from.enabled=-1!=tm(r).call(r,"from")}else{if("object"!==Of(e.arrows))throw new Error("The arrow newOptions can only be an object or a string. Refer to the documentation. You used:"+Em(e.arrows));fk(t.arrows,e.arrows,"to",o.arrows),fk(t.arrows,e.arrows,"middle",o.arrows),fk(t.arrows,e.arrows,"from",o.arrows)}else!0===i&&null===e.arrows&&(t.arrows=mm(o.arrows));if(void 0!==e.color&&null!==e.color){var s=Ax(e.color)?{color:e.color,highlight:e.color,hover:e.color,inherit:!1,opacity:1}:e.color,a=t.color;if(n)Vx(a,o.color,!1,i);else for(var h in a)Object.prototype.hasOwnProperty.call(a,h)&&delete a[h];if(Ax(a))a.color=a,a.highlight=a,a.hover=a,a.inherit=!1,void 0===s.opacity&&(a.opacity=1);else{var l=!1;void 0!==s.color&&(a.color=s.color,l=!0),void 0!==s.highlight&&(a.highlight=s.highlight,l=!0),void 0!==s.hover&&(a.hover=s.hover,l=!0),void 0!==s.inherit&&(a.inherit=s.inherit),void 0!==s.opacity&&(a.opacity=Math.min(1,Math.max(0,s.opacity))),!0===l?a.inherit=!1:void 0===a.inherit&&(a.inherit="from")}}else!0===i&&null===e.color&&(t.color=uk(o.color));!0===i&&null===e.font&&(t.font=uk(o.font)),Object.prototype.hasOwnProperty.call(e,"selfReferenceSize")&&(console.warn("The selfReferenceSize property has been deprecated. Please use selfReference property instead. The selfReference can be set like thise selfReference:{size:30, angle:Math.PI / 4}"),t.selfReference.size=e.selfReferenceSize)}}]),t}(),Az=function(){function t(e,i,o){var n,r=this;pu(this,t),this.body=e,this.images=i,this.groups=o,this.body.functions.createEdge=Uo(n=this.create).call(n,this),this.edgesListeners={add:function(t,e){r.add(e.items)},update:function(t,e){r.update(e.items)},remove:function(t,e){r.remove(e.items)}},this.options={},this.defaultOptions={arrows:{to:{enabled:!1,scaleFactor:1,type:"arrow"},middle:{enabled:!1,scaleFactor:1,type:"arrow"},from:{enabled:!1,scaleFactor:1,type:"arrow"}},endPointOffset:{from:0,to:0},arrowStrikethrough:!0,color:{color:"#848484",highlight:"#848484",hover:"#848484",inherit:"from",opacity:1},dashes:!1,font:{color:"#343434",size:14,face:"arial",background:"none",strokeWidth:2,strokeColor:"#ffffff",align:"horizontal",multi:!1,vadjust:0,bold:{mod:"bold"},boldital:{mod:"bold italic"},ital:{mod:"italic"},mono:{mod:"",size:15,face:"courier new",vadjust:2}},hidden:!1,hoverWidth:1.5,label:void 0,labelHighlightBold:!0,length:void 0,physics:!0,scaling:{min:1,max:15,label:{enabled:!0,min:14,max:30,maxVisible:30,drawThreshold:5},customScalingFunction:function(t,e,i,o){if(e===t)return.5;var n=1/(e-t);return Math.max(0,(o-t)*n)}},selectionWidth:1.5,selfReference:{size:20,angle:Math.PI/4,renderBehindTheNode:!0},shadow:{enabled:!1,color:"rgba(0,0,0,0.5)",size:10,x:5,y:5},background:{enabled:!1,color:"rgba(111,111,111,1)",size:10,dashes:!1},smooth:{enabled:!0,type:"dynamic",forceDirection:"none",roundness:.5},title:void 0,width:1,value:void 0},Vx(this.options,this.defaultOptions),this.bindEventListeners()}return Nf(t,[{key:"bindEventListeners",value:function(){var t,e,i=this;this.body.emitter.on("_forceDisableDynamicCurves",(function(t){var e=!(arguments.length>1&&void 0!==arguments[1])||arguments[1];"dynamic"===t&&(t="continuous");var o=!1;for(var n in i.body.edges)if(Object.prototype.hasOwnProperty.call(i.body.edges,n)){var r=i.body.edges[n],s=i.body.data.edges.get(n);if(null!=s){var a=s.smooth;void 0!==a&&!0===a.enabled&&"dynamic"===a.type&&(void 0===t?r.setOptions({smooth:!1}):r.setOptions({smooth:{type:t}}),o=!0)}}!0===e&&!0===o&&i.body.emitter.emit("_dataChanged")})),this.body.emitter.on("_dataUpdated",(function(){i.reconnectEdges()})),this.body.emitter.on("refreshEdges",Uo(t=this.refresh).call(t,this)),this.body.emitter.on("refresh",Uo(e=this.refresh).call(e,this)),this.body.emitter.on("destroy",(function(){Kx(i.edgesListeners,(function(t,e){i.body.data.edges&&i.body.data.edges.off(e,t)})),delete i.body.functions.createEdge,delete i.edgesListeners.add,delete i.edgesListeners.update,delete i.edgesListeners.remove,delete i.edgesListeners}))}},{key:"setOptions",value:function(t){if(void 0!==t){Fz.parseOptions(this.options,t,!0,this.defaultOptions,!0);var e=!1;if(void 0!==t.smooth)for(var i in this.body.edges)Object.prototype.hasOwnProperty.call(this.body.edges,i)&&(e=this.body.edges[i].updateEdgeType()||e);if(void 0!==t.font)for(var o in this.body.edges)Object.prototype.hasOwnProperty.call(this.body.edges,o)&&this.body.edges[o].updateLabelModule();void 0===t.hidden&&void 0===t.physics&&!0!==e||this.body.emitter.emit("_dataChanged")}}},{key:"setData",value:function(t){var e=this,i=arguments.length>1&&void 0!==arguments[1]&&arguments[1],o=this.body.data.edges;if(rB("id",t))this.body.data.edges=t;else if(Wp(t))this.body.data.edges=new iB,this.body.data.edges.add(t);else{if(t)throw new TypeError("Array or DataSet expected");this.body.data.edges=new iB}if(o&&Kx(this.edgesListeners,(function(t,e){o.off(e,t)})),this.body.edges={},this.body.data.edges){Kx(this.edgesListeners,(function(t,i){e.body.data.edges.on(i,t)}));var n=this.body.data.edges.getIds();this.add(n,!0)}this.body.emitter.emit("_adjustEdgesForHierarchicalLayout"),!1===i&&this.body.emitter.emit("_dataChanged")}},{key:"add",value:function(t){for(var e=arguments.length>1&&void 0!==arguments[1]&&arguments[1],i=this.body.edges,o=this.body.data.edges,n=0;n<t.length;n++){var r=t[n],s=i[r];s&&s.disconnect();var a=o.get(r,{showInternalIds:!0});i[r]=this.create(a)}this.body.emitter.emit("_adjustEdgesForHierarchicalLayout"),!1===e&&this.body.emitter.emit("_dataChanged")}},{key:"update",value:function(t){for(var e=this.body.edges,i=this.body.data.edges,o=!1,n=0;n<t.length;n++){var r=t[n],s=i.get(r),a=e[r];void 0!==a?(a.disconnect(),o=a.setOptions(s)||o,a.connect()):(this.body.edges[r]=this.create(s),o=!0)}!0===o?(this.body.emitter.emit("_adjustEdgesForHierarchicalLayout"),this.body.emitter.emit("_dataChanged")):this.body.emitter.emit("_dataUpdated")}},{key:"remove",value:function(t){var e=!(arguments.length>1&&void 0!==arguments[1])||arguments[1];if(0!==t.length){var i=this.body.edges;Kx(t,(function(t){var e=i[t];void 0!==e&&e.remove()})),e&&this.body.emitter.emit("_dataChanged")}}},{key:"refresh",value:function(){var t=this;Kx(this.body.edges,(function(e,i){var o=t.body.data.edges.get(i);void 0!==o&&e.setOptions(o)}))}},{key:"create",value:function(t){return new Fz(t,this.body,this.images,this.options,this.defaultOptions)}},{key:"reconnectEdges",value:function(){var t,e=this.body.nodes,i=this.body.edges;for(t in e)Object.prototype.hasOwnProperty.call(e,t)&&(e[t].edges=[]);for(t in i)if(Object.prototype.hasOwnProperty.call(i,t)){var o=i[t];o.from=null,o.to=null,o.connect()}}},{key:"getConnectedNodes",value:function(t){var e=[];if(void 0!==this.body.edges[t]){var i=this.body.edges[t];void 0!==i.fromId&&e.push(i.fromId),void 0!==i.toId&&e.push(i.toId)}return e}},{key:"_updateState",value:function(){this._addMissingEdges(),this._removeInvalidEdges()}},{key:"_removeInvalidEdges",value:function(){var t=this,e=[];Kx(this.body.edges,(function(i,o){var n=t.body.nodes[i.toId],r=t.body.nodes[i.fromId];void 0!==n&&!0===n.isCluster||void 0!==r&&!0===r.isCluster||void 0!==n&&void 0!==r||e.push(o)})),this.remove(e,!1)}},{key:"_addMissingEdges",value:function(){var t=this.body.data.edges;if(null!=t){var e=this.body.edges,i=[];Cv(t).call(t,(function(t,o){void 0===e[o]&&i.push(o)})),this.add(i,!0)}}}]),t}(),jz=function(){function t(e,i,o){pu(this,t),this.body=e,this.physicsBody=i,this.barnesHutTree,this.setOptions(o),this._rng=Sx("BARNES HUT SOLVER")}return Nf(t,[{key:"setOptions",value:function(t){this.options=t,this.thetaInversed=1/this.options.theta,this.overlapAvoidanceFactor=1-Math.max(0,Math.min(1,this.options.avoidOverlap))}},{key:"solve",value:function(){if(0!==this.options.gravitationalConstant&&this.physicsBody.physicsNodeIndices.length>0){var t,e=this.body.nodes,i=this.physicsBody.physicsNodeIndices,o=i.length,n=this._formBarnesHutTree(e,i);this.barnesHutTree=n;for(var r=0;r<o;r++)(t=e[i[r]]).options.mass>0&&this._getForceContributions(n.root,t)}}},{key:"_getForceContributions",value:function(t,e){this._getForceContribution(t.children.NW,e),this._getForceContribution(t.children.NE,e),this._getForceContribution(t.children.SW,e),this._getForceContribution(t.children.SE,e)}},{key:"_getForceContribution",value:function(t,e){if(t.childrenCount>0){var i=t.centerOfMass.x-e.x,o=t.centerOfMass.y-e.y,n=Math.sqrt(i*i+o*o);n*t.calcSize>this.thetaInversed?this._calculateForces(n,i,o,e,t):4===t.childrenCount?this._getForceContributions(t,e):t.children.data.id!=e.id&&this._calculateForces(n,i,o,e,t)}}},{key:"_calculateForces",value:function(t,e,i,o,n){0===t&&(e=t=.1),this.overlapAvoidanceFactor<1&&o.shape.radius&&(t=Math.max(.1+this.overlapAvoidanceFactor*o.shape.radius,t-o.shape.radius));var r=this.options.gravitationalConstant*n.mass*o.options.mass/Math.pow(t,3),s=e*r,a=i*r;this.physicsBody.forces[o.id].x+=s,this.physicsBody.forces[o.id].y+=a}},{key:"_formBarnesHutTree",value:function(t,e){for(var i,o=e.length,n=t[e[0]].x,r=t[e[0]].y,s=t[e[0]].x,a=t[e[0]].y,h=1;h<o;h++){var l=t[e[h]],d=l.x,c=l.y;l.options.mass>0&&(d<n&&(n=d),d>s&&(s=d),c<r&&(r=c),c>a&&(a=c))}var u=Math.abs(s-n)-Math.abs(a-r);u>0?(r-=.5*u,a+=.5*u):(n+=.5*u,s-=.5*u);var f=Math.max(1e-5,Math.abs(s-n)),p=.5*f,v=.5*(n+s),g=.5*(r+a),y={root:{centerOfMass:{x:0,y:0},mass:0,range:{minX:v-p,maxX:v+p,minY:g-p,maxY:g+p},size:f,calcSize:1/f,children:{data:null},maxWidth:0,level:0,childrenCount:4}};this._splitBranch(y.root);for(var m=0;m<o;m++)(i=t[e[m]]).options.mass>0&&this._placeInTree(y.root,i);return y}},{key:"_updateBranchMass",value:function(t,e){var i=t.centerOfMass,o=t.mass+e.options.mass,n=1/o;i.x=i.x*t.mass+e.x*e.options.mass,i.x*=n,i.y=i.y*t.mass+e.y*e.options.mass,i.y*=n,t.mass=o;var r=Math.max(Math.max(e.height,e.radius),e.width);t.maxWidth=t.maxWidth<r?r:t.maxWidth}},{key:"_placeInTree",value:function(t,e,i){1==i&&void 0!==i||this._updateBranchMass(t,e);var o,n=t.children.NW.range;o=n.maxX>e.x?n.maxY>e.y?"NW":"SW":n.maxY>e.y?"NE":"SE",this._placeInRegion(t,e,o)}},{key:"_placeInRegion",value:function(t,e,i){var o=t.children[i];switch(o.childrenCount){case 0:o.children.data=e,o.childrenCount=1,this._updateBranchMass(o,e);break;case 1:o.children.data.x===e.x&&o.children.data.y===e.y?(e.x+=this._rng(),e.y+=this._rng()):(this._splitBranch(o),this._placeInTree(o,e));break;case 4:this._placeInTree(o,e)}}},{key:"_splitBranch",value:function(t){var e=null;1===t.childrenCount&&(e=t.children.data,t.mass=0,t.centerOfMass.x=0,t.centerOfMass.y=0),t.childrenCount=4,t.children.data=null,this._insertRegion(t,"NW"),this._insertRegion(t,"NE"),this._insertRegion(t,"SW"),this._insertRegion(t,"SE"),null!=e&&this._placeInTree(t,e)}},{key:"_insertRegion",value:function(t,e){var i,o,n,r,s=.5*t.size;switch(e){case"NW":i=t.range.minX,o=t.range.minX+s,n=t.range.minY,r=t.range.minY+s;break;case"NE":i=t.range.minX+s,o=t.range.maxX,n=t.range.minY,r=t.range.minY+s;break;case"SW":i=t.range.minX,o=t.range.minX+s,n=t.range.minY+s,r=t.range.maxY;break;case"SE":i=t.range.minX+s,o=t.range.maxX,n=t.range.minY+s,r=t.range.maxY}t.children[e]={centerOfMass:{x:0,y:0},mass:0,range:{minX:i,maxX:o,minY:n,maxY:r},size:.5*t.size,calcSize:2*t.calcSize,children:{data:null},maxWidth:0,level:t.level+1,childrenCount:0}}},{key:"_debug",value:function(t,e){void 0!==this.barnesHutTree&&(t.lineWidth=1,this._drawBranch(this.barnesHutTree.root,t,e))}},{key:"_drawBranch",value:function(t,e,i){void 0===i&&(i="#FF0000"),4===t.childrenCount&&(this._drawBranch(t.children.NW,e),this._drawBranch(t.children.NE,e),this._drawBranch(t.children.SE,e),this._drawBranch(t.children.SW,e)),e.strokeStyle=i,e.beginPath(),e.moveTo(t.range.minX,t.range.minY),e.lineTo(t.range.maxX,t.range.minY),e.stroke(),e.beginPath(),e.moveTo(t.range.maxX,t.range.minY),e.lineTo(t.range.maxX,t.range.maxY),e.stroke(),e.beginPath(),e.moveTo(t.range.maxX,t.range.maxY),e.lineTo(t.range.minX,t.range.maxY),e.stroke(),e.beginPath(),e.moveTo(t.range.minX,t.range.maxY),e.lineTo(t.range.minX,t.range.minY),e.stroke()}}]),t}(),Rz=function(){function t(e,i,o){pu(this,t),this._rng=Sx("REPULSION SOLVER"),this.body=e,this.physicsBody=i,this.setOptions(o)}return Nf(t,[{key:"setOptions",value:function(t){this.options=t}},{key:"solve",value:function(){for(var t,e,i,o,n,r,s,a,h=this.body.nodes,l=this.physicsBody.physicsNodeIndices,d=this.physicsBody.forces,c=this.options.nodeDistance,u=-2/3/c,f=0;f<l.length-1;f++){s=h[l[f]];for(var p=f+1;p<l.length;p++)t=(a=h[l[p]]).x-s.x,e=a.y-s.y,0===(i=Math.sqrt(t*t+e*e))&&(t=i=.1*this._rng()),i<2*c&&(r=i<.5*c?1:u*i+1.3333333333333333,o=t*(r/=i),n=e*r,d[s.id].x-=o,d[s.id].y-=n,d[a.id].x+=o,d[a.id].y+=n)}}}]),t}(),Lz=function(){function t(e,i,o){pu(this,t),this.body=e,this.physicsBody=i,this.setOptions(o)}return Nf(t,[{key:"setOptions",value:function(t){this.options=t,this.overlapAvoidanceFactor=Math.max(0,Math.min(1,this.options.avoidOverlap||0))}},{key:"solve",value:function(){for(var t=this.body.nodes,e=this.physicsBody.physicsNodeIndices,i=this.physicsBody.forces,o=this.options.nodeDistance,n=0;n<e.length-1;n++)for(var r=t[e[n]],s=n+1;s<e.length;s++){var a=t[e[s]];if(r.level===a.level){var h=o+this.overlapAvoidanceFactor*((r.shape.radius||0)/2+(a.shape.radius||0)/2),l=a.x-r.x,d=a.y-r.y,c=Math.sqrt(l*l+d*d),u=void 0;u=c<h?-Math.pow(.05*c,2)+Math.pow(.05*h,2):0,0!==c&&(u/=c);var f=l*u,p=d*u;i[r.id].x-=f,i[r.id].y-=p,i[a.id].x+=f,i[a.id].y+=p}}}}]),t}(),Hz=function(){function t(e,i,o){pu(this,t),this.body=e,this.physicsBody=i,this.setOptions(o)}return Nf(t,[{key:"setOptions",value:function(t){this.options=t}},{key:"solve",value:function(){for(var t,e,i,o,n,r=this.physicsBody.physicsEdgeIndices,s=this.body.edges,a=0;a<r.length;a++)!0===(e=s[r[a]]).connected&&e.toId!==e.fromId&&void 0!==this.body.nodes[e.toId]&&void 0!==this.body.nodes[e.fromId]&&(void 0!==e.edgeType.via?(t=void 0===e.options.length?this.options.springLength:e.options.length,i=e.to,o=e.edgeType.via,n=e.from,this._calculateSpringForce(i,o,.5*t),this._calculateSpringForce(o,n,.5*t)):(t=void 0===e.options.length?1.5*this.options.springLength:e.options.length,this._calculateSpringForce(e.from,e.to,t)))}},{key:"_calculateSpringForce",value:function(t,e,i){var o=t.x-e.x,n=t.y-e.y,r=Math.max(Math.sqrt(o*o+n*n),.01),s=this.options.springConstant*(i-r)/r,a=o*s,h=n*s;void 0!==this.physicsBody.forces[t.id]&&(this.physicsBody.forces[t.id].x+=a,this.physicsBody.forces[t.id].y+=h),void 0!==this.physicsBody.forces[e.id]&&(this.physicsBody.forces[e.id].x-=a,this.physicsBody.forces[e.id].y-=h)}}]),t}(),Wz=function(){function t(e,i,o){pu(this,t),this.body=e,this.physicsBody=i,this.setOptions(o)}return Nf(t,[{key:"setOptions",value:function(t){this.options=t}},{key:"solve",value:function(){for(var t,e,i,o,n,r,s,a,h,l,d=this.body.edges,c=.5,u=this.physicsBody.physicsEdgeIndices,f=this.physicsBody.physicsNodeIndices,p=this.physicsBody.forces,v=0;v<f.length;v++){var g=f[v];p[g].springFx=0,p[g].springFy=0}for(var y=0;y<u.length;y++)!0===(e=d[u[y]]).connected&&(t=void 0===e.options.length?this.options.springLength:e.options.length,i=e.from.x-e.to.x,o=e.from.y-e.to.y,a=0===(a=Math.sqrt(i*i+o*o))?.01:a,n=i*(s=this.options.springConstant*(t-a)/a),r=o*s,e.to.level!=e.from.level?(void 0!==p[e.toId]&&(p[e.toId].springFx-=n,p[e.toId].springFy-=r),void 0!==p[e.fromId]&&(p[e.fromId].springFx+=n,p[e.fromId].springFy+=r)):(void 0!==p[e.toId]&&(p[e.toId].x-=c*n,p[e.toId].y-=c*r),void 0!==p[e.fromId]&&(p[e.fromId].x+=c*n,p[e.fromId].y+=c*r)));s=1;for(var m=0;m<f.length;m++){var b=f[m];h=Math.min(s,Math.max(-s,p[b].springFx)),l=Math.min(s,Math.max(-s,p[b].springFy)),p[b].x+=h,p[b].y+=l}for(var w=0,x=0,k=0;k<f.length;k++){var _=f[k];w+=p[_].x,x+=p[_].y}for(var E=w/f.length,O=x/f.length,C=0;C<f.length;C++){var S=f[C];p[S].x-=E,p[S].y-=O}}}]),t}(),qz=function(){function t(e,i,o){pu(this,t),this.body=e,this.physicsBody=i,this.setOptions(o)}return Nf(t,[{key:"setOptions",value:function(t){this.options=t}},{key:"solve",value:function(){for(var t,e,i,o,n=this.body.nodes,r=this.physicsBody.physicsNodeIndices,s=this.physicsBody.forces,a=0;a<r.length;a++){t=-(o=n[r[a]]).x,e=-o.y,i=Math.sqrt(t*t+e*e),this._calculateForces(i,t,e,s,o)}}},{key:"_calculateForces",value:function(t,e,i,o,n){var r=0===t?0:this.options.centralGravity/t;o[n.id].x=e*r,o[n.id].y=i*r}}]),t}();function Vz(t){var e=function(){if("undefined"==typeof Reflect||!AI)return!1;if(AI.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(AI(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,o=FO(t);if(e){var n=FO(this).constructor;i=AI(o,arguments,n)}else i=o.apply(this,arguments);return PO(this,i)}}var Uz=function(t){MO(i,jz);var e=Vz(i);function i(t,o,n){var r;return pu(this,i),(r=e.call(this,t,o,n))._rng=Sx("FORCE ATLAS 2 BASED REPULSION SOLVER"),r}return Nf(i,[{key:"_calculateForces",value:function(t,e,i,o,n){0===t&&(e=t=.1*this._rng()),this.overlapAvoidanceFactor<1&&o.shape.radius&&(t=Math.max(.1+this.overlapAvoidanceFactor*o.shape.radius,t-o.shape.radius));var r=o.edges.length+1,s=this.options.gravitationalConstant*n.mass*o.options.mass*r/Math.pow(t,2),a=e*s,h=i*s;this.physicsBody.forces[o.id].x+=a,this.physicsBody.forces[o.id].y+=h}}]),i}();function Yz(t){var e=function(){if("undefined"==typeof Reflect||!AI)return!1;if(AI.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(AI(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,o=FO(t);if(e){var n=FO(this).constructor;i=AI(o,arguments,n)}else i=o.apply(this,arguments);return PO(this,i)}}var Xz=function(t){MO(i,qz);var e=Yz(i);function i(t,o,n){return pu(this,i),e.call(this,t,o,n)}return Nf(i,[{key:"_calculateForces",value:function(t,e,i,o,n){if(t>0){var r=n.edges.length+1,s=this.options.centralGravity*r*n.options.mass;o[n.id].x=e*s,o[n.id].y=i*s}}}]),i}(),Gz=function(){function t(e){pu(this,t),this.body=e,this.physicsBody={physicsNodeIndices:[],physicsEdgeIndices:[],forces:{},velocities:{}},this.physicsEnabled=!0,this.simulationInterval=1e3/60,this.requiresTimeout=!0,this.previousStates={},this.referenceState={},this.freezeCache={},this.renderTimer=void 0,this.adaptiveTimestep=!1,this.adaptiveTimestepEnabled=!1,this.adaptiveCounter=0,this.adaptiveInterval=3,this.stabilized=!1,this.startedStabilization=!1,this.stabilizationIterations=0,this.ready=!1,this.options={},this.defaultOptions={enabled:!0,barnesHut:{theta:.5,gravitationalConstant:-2e3,centralGravity:.3,springLength:95,springConstant:.04,damping:.09,avoidOverlap:0},forceAtlas2Based:{theta:.5,gravitationalConstant:-50,centralGravity:.01,springConstant:.08,springLength:100,damping:.4,avoidOverlap:0},repulsion:{centralGravity:.2,springLength:200,springConstant:.05,nodeDistance:100,damping:.09,avoidOverlap:0},hierarchicalRepulsion:{centralGravity:0,springLength:100,springConstant:.01,nodeDistance:120,damping:.09},maxVelocity:50,minVelocity:.75,solver:"barnesHut",stabilization:{enabled:!0,iterations:1e3,updateInterval:50,onlyDynamicEdges:!1,fit:!0},timestep:.5,adaptiveTimestep:!0,wind:{x:0,y:0}},wo(this.options,this.defaultOptions),this.timestep=.5,this.layoutFailed=!1,this.bindEventListeners()}return Nf(t,[{key:"bindEventListeners",value:function(){var t=this;this.body.emitter.on("initPhysics",(function(){t.initPhysics()})),this.body.emitter.on("_layoutFailed",(function(){t.layoutFailed=!0})),this.body.emitter.on("resetPhysics",(function(){t.stopSimulation(),t.ready=!1})),this.body.emitter.on("disablePhysics",(function(){t.physicsEnabled=!1,t.stopSimulation()})),this.body.emitter.on("restorePhysics",(function(){t.setOptions(t.options),!0===t.ready&&t.startSimulation()})),this.body.emitter.on("startSimulation",(function(){!0===t.ready&&t.startSimulation()})),this.body.emitter.on("stopSimulation",(function(){t.stopSimulation()})),this.body.emitter.on("destroy",(function(){t.stopSimulation(!1),t.body.emitter.off()})),this.body.emitter.on("_dataChanged",(function(){t.updatePhysicsData()}))}},{key:"setOptions",value:function(t){if(void 0!==t)if(!1===t)this.options.enabled=!1,this.physicsEnabled=!1,this.stopSimulation();else if(!0===t)this.options.enabled=!0,this.physicsEnabled=!0,this.startSimulation();else{this.physicsEnabled=!0,qx(["stabilization"],this.options,t),fk(this.options,t,"stabilization"),void 0===t.enabled&&(this.options.enabled=!0),!1===this.options.enabled&&(this.physicsEnabled=!1,this.stopSimulation());var e=this.options.wind;e&&(("number"!=typeof e.x||GE(e.x))&&(e.x=0),("number"!=typeof e.y||GE(e.y))&&(e.y=0)),this.timestep=this.options.timestep}this.init()}},{key:"init",value:function(){var t;"forceAtlas2Based"===this.options.solver?(t=this.options.forceAtlas2Based,this.nodesSolver=new Uz(this.body,this.physicsBody,t),this.edgesSolver=new Hz(this.body,this.physicsBody,t),this.gravitySolver=new Xz(this.body,this.physicsBody,t)):"repulsion"===this.options.solver?(t=this.options.repulsion,this.nodesSolver=new Rz(this.body,this.physicsBody,t),this.edgesSolver=new Hz(this.body,this.physicsBody,t),this.gravitySolver=new qz(this.body,this.physicsBody,t)):"hierarchicalRepulsion"===this.options.solver?(t=this.options.hierarchicalRepulsion,this.nodesSolver=new Lz(this.body,this.physicsBody,t),this.edgesSolver=new Wz(this.body,this.physicsBody,t),this.gravitySolver=new qz(this.body,this.physicsBody,t)):(t=this.options.barnesHut,this.nodesSolver=new jz(this.body,this.physicsBody,t),this.edgesSolver=new Hz(this.body,this.physicsBody,t),this.gravitySolver=new qz(this.body,this.physicsBody,t)),this.modelOptions=t}},{key:"initPhysics",value:function(){!0===this.physicsEnabled&&!0===this.options.enabled?!0===this.options.stabilization.enabled?this.stabilize():(this.stabilized=!1,this.ready=!0,this.body.emitter.emit("fit",{},this.layoutFailed),this.startSimulation()):(this.ready=!0,this.body.emitter.emit("fit"))}},{key:"startSimulation",value:function(){var t;!0===this.physicsEnabled&&!0===this.options.enabled?(this.stabilized=!1,this.adaptiveTimestep=!1,this.body.emitter.emit("_resizeNodes"),void 0===this.viewFunction&&(this.viewFunction=Uo(t=this.simulationStep).call(t,this),this.body.emitter.on("initRedraw",this.viewFunction),this.body.emitter.emit("_startRendering"))):this.body.emitter.emit("_redraw")}},{key:"stopSimulation",value:function(){var t=!(arguments.length>0&&void 0!==arguments[0])||arguments[0];this.stabilized=!0,!0===t&&this._emitStabilized(),void 0!==this.viewFunction&&(this.body.emitter.off("initRedraw",this.viewFunction),this.viewFunction=void 0,!0===t&&this.body.emitter.emit("_stopRendering"))}},{key:"simulationStep",value:function(){var t=cv();this.physicsTick(),(cv()-t<.4*this.simulationInterval||!0===this.runDoubleSpeed)&&!1===this.stabilized&&(this.physicsTick(),this.runDoubleSpeed=!0),!0===this.stabilized&&this.stopSimulation()}},{key:"_emitStabilized",value:function(){var t=this,e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:this.stabilizationIterations;(this.stabilizationIterations>1||!0===this.startedStabilization)&&Xm((function(){t.body.emitter.emit("stabilized",{iterations:e}),t.startedStabilization=!1,t.stabilizationIterations=0}),0)}},{key:"physicsStep",value:function(){this.gravitySolver.solve(),this.nodesSolver.solve(),this.edgesSolver.solve(),this.moveNodes()}},{key:"adjustTimeStep",value:function(){!0===this._evaluateStepQuality()?this.timestep=1.2*this.timestep:this.timestep/1.2<this.options.timestep?this.timestep=this.options.timestep:(this.adaptiveCounter=-1,this.timestep=Math.max(this.options.timestep,this.timestep/1.2))}},{key:"physicsTick",value:function(){if(this._startStabilizing(),!0!==this.stabilized){if(!0===this.adaptiveTimestep&&!0===this.adaptiveTimestepEnabled)this.adaptiveCounter%this.adaptiveInterval==0?(this.timestep=2*this.timestep,this.physicsStep(),this.revert(),this.timestep=.5*this.timestep,this.physicsStep(),this.physicsStep(),this.adjustTimeStep()):this.physicsStep(),this.adaptiveCounter+=1;else this.timestep=this.options.timestep,this.physicsStep();!0===this.stabilized&&this.revert(),this.stabilizationIterations++}}},{key:"updatePhysicsData",value:function(){this.physicsBody.forces={},this.physicsBody.physicsNodeIndices=[],this.physicsBody.physicsEdgeIndices=[];var t=this.body.nodes,e=this.body.edges;for(var i in t)Object.prototype.hasOwnProperty.call(t,i)&&!0===t[i].options.physics&&this.physicsBody.physicsNodeIndices.push(t[i].id);for(var o in e)Object.prototype.hasOwnProperty.call(e,o)&&!0===e[o].options.physics&&this.physicsBody.physicsEdgeIndices.push(e[o].id);for(var n=0;n<this.physicsBody.physicsNodeIndices.length;n++){var r=this.physicsBody.physicsNodeIndices[n];this.physicsBody.forces[r]={x:0,y:0},void 0===this.physicsBody.velocities[r]&&(this.physicsBody.velocities[r]={x:0,y:0})}for(var s in this.physicsBody.velocities)void 0===t[s]&&delete this.physicsBody.velocities[s]}},{key:"revert",value:function(){var t=nv(this.previousStates),e=this.body.nodes,i=this.physicsBody.velocities;this.referenceState={};for(var o=0;o<t.length;o++){var n=t[o];void 0!==e[n]?!0===e[n].options.physics&&(this.referenceState[n]={positions:{x:e[n].x,y:e[n].y}},i[n].x=this.previousStates[n].vx,i[n].y=this.previousStates[n].vy,e[n].x=this.previousStates[n].x,e[n].y=this.previousStates[n].y):delete this.previousStates[n]}}},{key:"_evaluateStepQuality",value:function(){var t,e,i=this.body.nodes,o=this.referenceState;for(var n in this.referenceState)if(Object.prototype.hasOwnProperty.call(this.referenceState,n)&&void 0!==i[n]&&(t=i[n].x-o[n].positions.x,e=i[n].y-o[n].positions.y,Math.sqrt(Math.pow(t,2)+Math.pow(e,2))>.3))return!1;return!0}},{key:"moveNodes",value:function(){for(var t=this.physicsBody.physicsNodeIndices,e=0,i=0,o=0;o<t.length;o++){var n=t[o],r=this._performStep(n);e=Math.max(e,r),i+=r}this.adaptiveTimestepEnabled=i/t.length<5,this.stabilized=e<this.options.minVelocity}},{key:"calculateComponentVelocity",value:function(t,e,i){t+=(e-this.modelOptions.damping*t)/i*this.timestep;var o=this.options.maxVelocity||1e9;return Math.abs(t)>o&&(t=t>0?o:-o),t}},{key:"_performStep",value:function(t){var e=this.body.nodes[t],i=this.physicsBody.forces[t];this.options.wind&&(i.x+=this.options.wind.x,i.y+=this.options.wind.y);var o=this.physicsBody.velocities[t];return this.previousStates[t]={x:e.x,y:e.y,vx:o.x,vy:o.y},!1===e.options.fixed.x?(o.x=this.calculateComponentVelocity(o.x,i.x,e.options.mass),e.x+=o.x*this.timestep):(i.x=0,o.x=0),!1===e.options.fixed.y?(o.y=this.calculateComponentVelocity(o.y,i.y,e.options.mass),e.y+=o.y*this.timestep):(i.y=0,o.y=0),Math.sqrt(Math.pow(o.x,2)+Math.pow(o.y,2))}},{key:"_freezeNodes",value:function(){var t=this.body.nodes;for(var e in t)if(Object.prototype.hasOwnProperty.call(t,e)&&t[e].x&&t[e].y){var i=t[e].options.fixed;this.freezeCache[e]={x:i.x,y:i.y},i.x=!0,i.y=!0}}},{key:"_restoreFrozenNodes",value:function(){var t=this.body.nodes;for(var e in t)Object.prototype.hasOwnProperty.call(t,e)&&void 0!==this.freezeCache[e]&&(t[e].options.fixed.x=this.freezeCache[e].x,t[e].options.fixed.y=this.freezeCache[e].y);this.freezeCache={}}},{key:"stabilize",value:function(){var t=this,e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:this.options.stabilization.iterations;"number"!=typeof e&&(e=this.options.stabilization.iterations,console.error("The stabilize method needs a numeric amount of iterations. Switching to default: ",e)),0!==this.physicsBody.physicsNodeIndices.length?(this.adaptiveTimestep=this.options.adaptiveTimestep,this.body.emitter.emit("_resizeNodes"),this.stopSimulation(),this.stabilized=!1,this.body.emitter.emit("_blockRedraw"),this.targetIterations=e,!0===this.options.stabilization.onlyDynamicEdges&&this._freezeNodes(),this.stabilizationIterations=0,Xm((function(){return t._stabilizationBatch()}),0)):this.ready=!0}},{key:"_startStabilizing",value:function(){return!0!==this.startedStabilization&&(this.body.emitter.emit("startStabilizing"),this.startedStabilization=!0,!0)}},{key:"_stabilizationBatch",value:function(){var t=this,e=function(){return!1===t.stabilized&&t.stabilizationIterations<t.targetIterations},i=function(){t.body.emitter.emit("stabilizationProgress",{iterations:t.stabilizationIterations,total:t.targetIterations})};this._startStabilizing()&&i();for(var o,n=0;e()&&n<this.options.stabilization.updateInterval;)this.physicsTick(),n++;(i(),e())?Xm(Uo(o=this._stabilizationBatch).call(o,this),0):this._finalizeStabilization()}},{key:"_finalizeStabilization",value:function(){this.body.emitter.emit("_allowRedraw"),!0===this.options.stabilization.fit&&this.body.emitter.emit("fit"),!0===this.options.stabilization.onlyDynamicEdges&&this._restoreFrozenNodes(),this.body.emitter.emit("stabilizationIterationsDone"),this.body.emitter.emit("_requestRedraw"),!0===this.stabilized?this._emitStabilized():this.startSimulation(),this.ready=!0}},{key:"_drawForces",value:function(t){for(var e=0;e<this.physicsBody.physicsNodeIndices.length;e++){var i=this.physicsBody.physicsNodeIndices[e],o=this.body.nodes[i],n=this.physicsBody.forces[i],r=Math.sqrt(Math.pow(n.x,2)+Math.pow(n.x,2)),s=Math.min(Math.max(5,r),15),a=3*s,h=ak((180-180*Math.min(1,Math.max(0,.03*r)))/360,1,1),l={x:o.x+20*n.x,y:o.y+20*n.y};t.lineWidth=s,t.strokeStyle=h,t.beginPath(),t.moveTo(o.x,o.y),t.lineTo(l.x,l.y),t.stroke();var d=Math.atan2(n.y,n.x);t.fillStyle=h,mz.draw(t,{type:"arrow",point:l,angle:d,length:a}),ab(t).call(t)}}}]),t}(),Kz=function(){function t(){pu(this,t)}return Nf(t,null,[{key:"getRange",value:function(t){var e,i=arguments.length>1&&void 0!==arguments[1]?arguments[1]:[],o=1e9,n=-1e9,r=1e9,s=-1e9;if(i.length>0)for(var a=0;a<i.length;a++)r>(e=t[i[a]]).shape.boundingBox.left&&(r=e.shape.boundingBox.left),s<e.shape.boundingBox.right&&(s=e.shape.boundingBox.right),o>e.shape.boundingBox.top&&(o=e.shape.boundingBox.top),n<e.shape.boundingBox.bottom&&(n=e.shape.boundingBox.bottom);return 1e9===r&&-1e9===s&&1e9===o&&-1e9===n&&(o=0,n=0,r=0,s=0),{minX:r,maxX:s,minY:o,maxY:n}}},{key:"getRangeCore",value:function(t){var e,i=arguments.length>1&&void 0!==arguments[1]?arguments[1]:[],o=1e9,n=-1e9,r=1e9,s=-1e9;if(i.length>0)for(var a=0;a<i.length;a++)r>(e=t[i[a]]).x&&(r=e.x),s<e.x&&(s=e.x),o>e.y&&(o=e.y),n<e.y&&(n=e.y);return 1e9===r&&-1e9===s&&1e9===o&&-1e9===n&&(o=0,n=0,r=0,s=0),{minX:r,maxX:s,minY:o,maxY:n}}},{key:"findCenter",value:function(t){return{x:.5*(t.maxX+t.minX),y:.5*(t.maxY+t.minY)}}},{key:"cloneOptions",value:function(t,e){var i={};return void 0===e||"node"===e?(Vx(i,t.options,!0),i.x=t.x,i.y=t.y,i.amountOfConnections=t.edges.length):Vx(i,t.options,!0),i}}]),t}();function $z(t){var e=function(){if("undefined"==typeof Reflect||!AI)return!1;if(AI.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(AI(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,o=FO(t);if(e){var n=FO(this).constructor;i=AI(o,arguments,n)}else i=o.apply(this,arguments);return PO(this,i)}}var Zz=function(t){MO(i,SN);var e=$z(i);function i(t,o,n,r,s,a){var h;return pu(this,i),(h=e.call(this,t,o,n,r,s,a)).isCluster=!0,h.containedNodes={},h.containedEdges={},h}return Nf(i,[{key:"_openChildCluster",value:function(t){var e=this,i=this.body.nodes[t];if(void 0===this.containedNodes[t])throw new Error("node with id: "+t+" not in current cluster");if(!i.isCluster)throw new Error("node with id: "+t+" is not a cluster");delete this.containedNodes[t],Kx(i.edges,(function(t){delete e.containedEdges[t.id]})),Kx(i.containedNodes,(function(t,i){e.containedNodes[i]=t})),i.containedNodes={},Kx(i.containedEdges,(function(t,i){e.containedEdges[i]=t})),i.containedEdges={},Kx(i.edges,(function(t){Kx(e.edges,(function(i){var o,n,r=tm(o=i.clusteringEdgeReplacingIds).call(o,t.id);-1!==r&&(Kx(t.clusteringEdgeReplacingIds,(function(t){i.clusteringEdgeReplacingIds.push(t),e.body.edges[t].edgeReplacedById=i.id})),vg(n=i.clusteringEdgeReplacingIds).call(n,r,1))}))})),i.edges=[]}}]),i}(),Qz=function(){function t(e){var i=this;pu(this,t),this.body=e,this.clusteredNodes={},this.clusteredEdges={},this.options={},this.defaultOptions={},wo(this.options,this.defaultOptions),this.body.emitter.on("_resetData",(function(){i.clusteredNodes={},i.clusteredEdges={}}))}return Nf(t,[{key:"clusterByHubsize",value:function(t,e){void 0===t?t=this._getHubSize():"object"===Of(t)&&(e=this._checkOptions(t),t=this._getHubSize());for(var i=[],o=0;o<this.body.nodeIndices.length;o++){var n=this.body.nodes[this.body.nodeIndices[o]];n.edges.length>=t&&i.push(n.id)}for(var r=0;r<i.length;r++)this.clusterByConnection(i[r],e,!0);this.body.emitter.emit("_dataChanged")}},{key:"cluster",value:function(){var t=this,e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{},i=!(arguments.length>1&&void 0!==arguments[1])||arguments[1];if(void 0===e.joinCondition)throw new Error("Cannot call clusterByNodeData without a joinCondition function in the options.");e=this._checkOptions(e);var o={},n={};Kx(this.body.nodes,(function(i,r){i.options&&!0===e.joinCondition(i.options)&&(o[r]=i,Kx(i.edges,(function(e){void 0===t.clusteredEdges[e.id]&&(n[e.id]=e)})))})),this._cluster(o,n,e,i)}},{key:"clusterByEdgeCount",value:function(t,e){var i=this,o=!(arguments.length>2&&void 0!==arguments[2])||arguments[2];e=this._checkOptions(e);for(var n,r,s,a=[],h={},l=function(){var o={},l={},c=i.body.nodeIndices[d],u=i.body.nodes[c];if(void 0===h[c]){s=0,r=[];for(var f=0;f<u.edges.length;f++)n=u.edges[f],void 0===i.clusteredEdges[n.id]&&(n.toId!==n.fromId&&s++,r.push(n));if(s===t){for(var p=function(t){if(void 0===e.joinCondition||null===e.joinCondition)return!0;var i=Kz.cloneOptions(t);return e.joinCondition(i)},v=!0,g=0;g<r.length;g++){n=r[g];var y=i._getConnectedId(n,c);if(!p(u)){v=!1;break}l[n.id]=n,o[c]=u,o[y]=i.body.nodes[y],h[c]=!0}if(nv(o).length>0&&nv(l).length>0&&!0===v){var m=function(){for(var t=0;t<a.length;++t)for(var e in o)if(void 0!==a[t].nodes[e])return a[t]}();if(void 0!==m){for(var b in o)void 0===m.nodes[b]&&(m.nodes[b]=o[b]);for(var w in l)void 0===m.edges[w]&&(m.edges[w]=l[w])}else a.push({nodes:o,edges:l})}}}},d=0;d<this.body.nodeIndices.length;d++)l();for(var c=0;c<a.length;c++)this._cluster(a[c].nodes,a[c].edges,e,!1);!0===o&&this.body.emitter.emit("_dataChanged")}},{key:"clusterOutliers",value:function(t){var e=!(arguments.length>1&&void 0!==arguments[1])||arguments[1];this.clusterByEdgeCount(1,t,e)}},{key:"clusterBridges",value:function(t){var e=!(arguments.length>1&&void 0!==arguments[1])||arguments[1];this.clusterByEdgeCount(2,t,e)}},{key:"clusterByConnection",value:function(t,e){var i,o=!(arguments.length>2&&void 0!==arguments[2])||arguments[2];if(void 0===t)throw new Error("No nodeId supplied to clusterByConnection!");if(void 0===this.body.nodes[t])throw new Error("The nodeId given to clusterByConnection does not exist!");var n=this.body.nodes[t];void 0===(e=this._checkOptions(e,n)).clusterNodeProperties.x&&(e.clusterNodeProperties.x=n.x),void 0===e.clusterNodeProperties.y&&(e.clusterNodeProperties.y=n.y),void 0===e.clusterNodeProperties.fixed&&(e.clusterNodeProperties.fixed={},e.clusterNodeProperties.fixed.x=n.options.fixed.x,e.clusterNodeProperties.fixed.y=n.options.fixed.y);var r={},s={},a=n.id,h=Kz.cloneOptions(n);r[a]=n;for(var l=0;l<n.edges.length;l++){var d=n.edges[l];if(void 0===this.clusteredEdges[d.id]){var c=this._getConnectedId(d,a);if(void 0===this.clusteredNodes[c])if(c!==a)if(void 0===e.joinCondition)s[d.id]=d,r[c]=this.body.nodes[c];else{var u=Kz.cloneOptions(this.body.nodes[c]);!0===e.joinCondition(h,u)&&(s[d.id]=d,r[c]=this.body.nodes[c])}else s[d.id]=d}}var f=Qp(i=nv(r)).call(i,(function(t){return r[t].id}));for(var p in r)if(Object.prototype.hasOwnProperty.call(r,p))for(var v=r[p],g=0;g<v.edges.length;g++){var y=v.edges[g];tm(f).call(f,this._getConnectedId(y,v.id))>-1&&(s[y.id]=y)}this._cluster(r,s,e,o)}},{key:"_createClusterEdges",value:function(t,e,i,o){for(var n,r,s,a,h,l,d=nv(t),c=[],u=0;u<d.length;u++){s=t[r=d[u]];for(var f=0;f<s.edges.length;f++)n=s.edges[f],void 0===this.clusteredEdges[n.id]&&(n.toId==n.fromId?e[n.id]=n:n.toId==r?(a=i.id,l=h=n.fromId):(a=n.toId,h=i.id,l=a),void 0===t[l]&&c.push({edge:n,fromId:h,toId:a}))}for(var p=[],v=function(t){for(var e=0;e<p.length;e++){var i=p[e],o=t.fromId===i.fromId&&t.toId===i.toId,n=t.fromId===i.toId&&t.toId===i.fromId;if(o||n)return i}return null},g=0;g<c.length;g++){var y=c[g],m=y.edge,b=v(y);null===b?(b=this._createClusteredEdge(y.fromId,y.toId,m,o),p.push(b)):b.clusteringEdgeReplacingIds.push(m.id),this.body.edges[m.id].edgeReplacedById=b.id,this._backupEdgeOptions(m),m.setOptions({physics:!1})}}},{key:"_checkOptions",value:function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{};return void 0===t.clusterEdgeProperties&&(t.clusterEdgeProperties={}),void 0===t.clusterNodeProperties&&(t.clusterNodeProperties={}),t}},{key:"_cluster",value:function(t,e,i){var o=!(arguments.length>3&&void 0!==arguments[3])||arguments[3],n=[];for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&void 0!==this.clusteredNodes[r]&&n.push(r);for(var s=0;s<n.length;++s)delete t[n[s]];if(0!=nv(t).length&&(1!=nv(t).length||1==i.clusterNodeProperties.allowSingleNodeCluster)){var a=Vx({},i.clusterNodeProperties);if(void 0!==i.processProperties){var h=[];for(var l in t)if(Object.prototype.hasOwnProperty.call(t,l)){var d=Kz.cloneOptions(t[l]);h.push(d)}var c=[];for(var u in e)if(Object.prototype.hasOwnProperty.call(e,u)&&"clusterEdge:"!==u.substr(0,12)){var f=Kz.cloneOptions(e[u],"edge");c.push(f)}if(!(a=i.processProperties(a,h,c)))throw new Error("The processProperties function does not return properties!")}void 0===a.id&&(a.id="cluster:"+VI());var p=a.id;void 0===a.label&&(a.label="cluster");var v=void 0;void 0===a.x&&(v=this._getClusterPosition(t),a.x=v.x),void 0===a.y&&(void 0===v&&(v=this._getClusterPosition(t)),a.y=v.y),a.id=p;var g=this.body.functions.createNode(a,Zz);g.containedNodes=t,g.containedEdges=e,g.clusterEdgeProperties=i.clusterEdgeProperties,this.body.nodes[a.id]=g,this._clusterEdges(t,e,a,i.clusterEdgeProperties),a.id=void 0,!0===o&&this.body.emitter.emit("_dataChanged")}}},{key:"_backupEdgeOptions",value:function(t){void 0===this.clusteredEdges[t.id]&&(this.clusteredEdges[t.id]={physics:t.options.physics})}},{key:"_restoreEdge",value:function(t){var e=this.clusteredEdges[t.id];void 0!==e&&(t.setOptions({physics:e.physics}),delete this.clusteredEdges[t.id])}},{key:"isCluster",value:function(t){return void 0!==this.body.nodes[t]?!0===this.body.nodes[t].isCluster:(console.error("Node does not exist."),!1)}},{key:"_getClusterPosition",value:function(t){for(var e,i=nv(t),o=t[i[0]].x,n=t[i[0]].x,r=t[i[0]].y,s=t[i[0]].y,a=1;a<i.length;a++)o=(e=t[i[a]]).x<o?e.x:o,n=e.x>n?e.x:n,r=e.y<r?e.y:r,s=e.y>s?e.y:s;return{x:.5*(o+n),y:.5*(r+s)}}},{key:"openCluster",value:function(t,e){var i=!(arguments.length>2&&void 0!==arguments[2])||arguments[2];if(void 0===t)throw new Error("No clusterNodeId supplied to openCluster.");var o=this.body.nodes[t];if(void 0===o)throw new Error("The clusterNodeId supplied to openCluster does not exist.");if(!0!==o.isCluster||void 0===o.containedNodes||void 0===o.containedEdges)throw new Error("The node:"+t+" is not a valid cluster.");var n=this.findNode(t),r=tm(n).call(n,t)-1;if(r>=0){var s=n[r];return this.body.nodes[s]._openChildCluster(t),delete this.body.nodes[t],void(!0===i&&this.body.emitter.emit("_dataChanged"))}var a=o.containedNodes,h=o.containedEdges;if(void 0!==e&&void 0!==e.releaseFunction&&"function"==typeof e.releaseFunction){var l={},d={x:o.x,y:o.y};for(var c in a)if(Object.prototype.hasOwnProperty.call(a,c)){var u=this.body.nodes[c];l[c]={x:u.x,y:u.y}}var f=e.releaseFunction(d,l);for(var p in a)if(Object.prototype.hasOwnProperty.call(a,p)){var v=this.body.nodes[p];void 0!==f[p]&&(v.x=void 0===f[p].x?o.x:f[p].x,v.y=void 0===f[p].y?o.y:f[p].y)}}else Kx(a,(function(t){!1===t.options.fixed.x&&(t.x=o.x),!1===t.options.fixed.y&&(t.y=o.y)}));for(var g in a)if(Object.prototype.hasOwnProperty.call(a,g)){var y=this.body.nodes[g];y.vx=o.vx,y.vy=o.vy,y.setOptions({physics:!0}),delete this.clusteredNodes[g]}for(var m=[],b=0;b<o.edges.length;b++)m.push(o.edges[b]);for(var w=0;w<m.length;w++){for(var x=m[w],k=this._getConnectedId(x,t),_=this.clusteredNodes[k],E=0;E<x.clusteringEdgeReplacingIds.length;E++){var O=x.clusteringEdgeReplacingIds[E],C=this.body.edges[O];if(void 0!==C)if(void 0!==_){var S=this.body.nodes[_.clusterId];S.containedEdges[C.id]=C,delete h[C.id];var T=C.fromId,M=C.toId;C.toId==k?M=_.clusterId:T=_.clusterId,this._createClusteredEdge(T,M,C,S.clusterEdgeProperties,{hidden:!1,physics:!0})}else this._restoreEdge(C)}x.remove()}for(var P in h)Object.prototype.hasOwnProperty.call(h,P)&&this._restoreEdge(h[P]);delete this.body.nodes[t],!0===i&&this.body.emitter.emit("_dataChanged")}},{key:"getNodesInCluster",value:function(t){var e=[];if(!0===this.isCluster(t)){var i=this.body.nodes[t].containedNodes;for(var o in i)Object.prototype.hasOwnProperty.call(i,o)&&e.push(this.body.nodes[o].id)}return e}},{key:"findNode",value:function(t){for(var e,i=[],o=0;void 0!==this.clusteredNodes[t]&&o<100;){if(void 0===(e=this.body.nodes[t]))return[];i.push(e.id),t=this.clusteredNodes[t].clusterId,o++}return void 0===(e=this.body.nodes[t])?[]:(i.push(e.id),Rv(i).call(i),i)}},{key:"updateClusteredNode",value:function(t,e){if(void 0===t)throw new Error("No clusteredNodeId supplied to updateClusteredNode.");if(void 0===e)throw new Error("No newOptions supplied to updateClusteredNode.");if(void 0===this.body.nodes[t])throw new Error("The clusteredNodeId supplied to updateClusteredNode does not exist.");this.body.nodes[t].setOptions(e),this.body.emitter.emit("_dataChanged")}},{key:"updateEdge",value:function(t,e){if(void 0===t)throw new Error("No startEdgeId supplied to updateEdge.");if(void 0===e)throw new Error("No newOptions supplied to updateEdge.");if(void 0===this.body.edges[t])throw new Error("The startEdgeId supplied to updateEdge does not exist.");for(var i=this.getClusteredEdges(t),o=0;o<i.length;o++){this.body.edges[i[o]].setOptions(e)}this.body.emitter.emit("_dataChanged")}},{key:"getClusteredEdges",value:function(t){for(var e=[],i=0;void 0!==t&&void 0!==this.body.edges[t]&&i<100;)e.push(this.body.edges[t].id),t=this.body.edges[t].edgeReplacedById,i++;return Rv(e).call(e),e}},{key:"getBaseEdge",value:function(t){return this.getBaseEdges(t)[0]}},{key:"getBaseEdges",value:function(t){for(var e=[t],i=[],o=[],n=0;e.length>0&&n<100;){var r=e.pop();if(void 0!==r){var s=this.body.edges[r];if(void 0!==s){n++;var a=s.clusteringEdgeReplacingIds;if(void 0===a)o.push(r);else for(var h=0;h<a.length;++h){var l=a[h];-1===tm(e).call(e,a)&&-1===tm(i).call(i,a)&&e.push(l)}i.push(r)}}}return o}},{key:"_getConnectedId",value:function(t,e){return t.toId!=e?t.toId:(t.fromId,t.fromId)}},{key:"_getHubSize",value:function(){for(var t=0,e=0,i=0,o=0,n=0;n<this.body.nodeIndices.length;n++){var r=this.body.nodes[this.body.nodeIndices[n]];r.edges.length>o&&(o=r.edges.length),t+=r.edges.length,e+=Math.pow(r.edges.length,2),i+=1}t/=i;var s=(e/=i)-Math.pow(t,2),a=Math.sqrt(s),h=Math.floor(t+2*a);return h>o&&(h=o),h}},{key:"_createClusteredEdge",value:function(t,e,i,o,n){var r=Kz.cloneOptions(i,"edge");Vx(r,o),r.from=t,r.to=e,r.id="clusterEdge:"+VI(),void 0!==n&&Vx(r,n);var s=this.body.functions.createEdge(r);return s.clusteringEdgeReplacingIds=[i.id],s.connect(),this.body.edges[s.id]=s,s}},{key:"_clusterEdges",value:function(t,e,i,o){if(e instanceof Fz){var n=e,r={};r[n.id]=n,e=r}if(t instanceof SN){var s=t,a={};a[s.id]=s,t=a}if(null==i)throw new Error("_clusterEdges: parameter clusterNode required");for(var h in void 0===o&&(o=i.clusterEdgeProperties),this._createClusterEdges(t,e,i,o),e)if(Object.prototype.hasOwnProperty.call(e,h)&&void 0!==this.body.edges[h]){var l=this.body.edges[h];this._backupEdgeOptions(l),l.setOptions({physics:!1})}for(var d in t)Object.prototype.hasOwnProperty.call(t,d)&&(this.clusteredNodes[d]={clusterId:i.id,node:this.body.nodes[d]},this.body.nodes[d].setOptions({physics:!1}))}},{key:"_getClusterNodeForNode",value:function(t){if(void 0!==t){var e=this.clusteredNodes[t];if(void 0!==e){var i=e.clusterId;if(void 0!==i)return this.body.nodes[i]}}}},{key:"_filter",value:function(t,e){var i=[];return Kx(t,(function(t){e(t)&&i.push(t)})),i}},{key:"_updateState",value:function(){var t,e=this,i=[],o={},n=function(t){Kx(e.body.nodes,(function(e){!0===e.isCluster&&t(e)}))};for(t in this.clusteredNodes){if(Object.prototype.hasOwnProperty.call(this.clusteredNodes,t))void 0===this.body.nodes[t]&&i.push(t)}n((function(t){for(var e=0;e<i.length;e++)delete t.containedNodes[i[e]]}));for(var r=0;r<i.length;r++)delete this.clusteredNodes[i[r]];Kx(this.clusteredEdges,(function(t){var i=e.body.edges[t];void 0!==i&&i.endPointsValid()||(o[t]=t)})),n((function(t){Kx(t.containedEdges,(function(t,e){t.endPointsValid()||o[e]||(o[e]=e)}))})),Kx(this.body.edges,(function(t,i){var n=!0,r=t.clusteringEdgeReplacingIds;if(void 0!==r){var s=0;Kx(r,(function(t){var i=e.body.edges[t];void 0!==i&&i.endPointsValid()&&(s+=1)})),n=s>0}t.endPointsValid()&&n||(o[i]=i)})),n((function(t){Kx(o,(function(i){delete t.containedEdges[i],Kx(t.edges,(function(n,r){n.id!==i?n.clusteringEdgeReplacingIds=e._filter(n.clusteringEdgeReplacingIds,(function(t){return!o[t]})):t.edges[r]=null})),t.edges=e._filter(t.edges,(function(t){return null!==t}))}))})),Kx(o,(function(t){delete e.clusteredEdges[t]})),Kx(o,(function(t){delete e.body.edges[t]})),Kx(nv(this.body.edges),(function(t){var i=e.body.edges[t],o=e._isClusteredNode(i.fromId)||e._isClusteredNode(i.toId);if(o!==e._isClusteredEdge(i.id))if(o){var n=e._getClusterNodeForNode(i.fromId);void 0!==n&&e._clusterEdges(e.body.nodes[i.fromId],i,n);var r=e._getClusterNodeForNode(i.toId);void 0!==r&&e._clusterEdges(e.body.nodes[i.toId],i,r)}else delete e._clusterEdges[t],e._restoreEdge(i)}));for(var s=!1,a=!0,h=function(){var t=[];n((function(e){var i=nv(e.containedNodes).length,o=!0===e.options.allowSingleNodeCluster;(o&&i<1||!o&&i<2)&&t.push(e.id)}));for(var i=0;i<t.length;++i)e.openCluster(t[i],{},!1);a=t.length>0,s=s||a};a;)h();s&&this._updateState()}},{key:"_isClusteredNode",value:function(t){return void 0!==this.clusteredNodes[t]}},{key:"_isClusteredEdge",value:function(t){return void 0!==this.clusteredEdges[t]}}]),t}();var Jz=function(){function t(e,i){var o;pu(this,t),void 0!==window&&(o=window.requestAnimationFrame||window.mozRequestAnimationFrame||window.webkitRequestAnimationFrame||window.msRequestAnimationFrame),window.requestAnimationFrame=void 0===o?function(t){t()}:o,this.body=e,this.canvas=i,this.redrawRequested=!1,this.renderTimer=void 0,this.requiresTimeout=!0,this.renderingActive=!1,this.renderRequests=0,this.allowRedraw=!0,this.dragging=!1,this.zooming=!1,this.options={},this.defaultOptions={hideEdgesOnDrag:!1,hideEdgesOnZoom:!1,hideNodesOnDrag:!1},wo(this.options,this.defaultOptions),this._determineBrowserMethod(),this.bindEventListeners()}return Nf(t,[{key:"bindEventListeners",value:function(){var t,e=this;this.body.emitter.on("dragStart",(function(){e.dragging=!0})),this.body.emitter.on("dragEnd",(function(){e.dragging=!1})),this.body.emitter.on("zoom",(function(){e.zooming=!0,window.clearTimeout(e.zoomTimeoutId),e.zoomTimeoutId=Xm((function(){var t;e.zooming=!1,Uo(t=e._requestRedraw).call(t,e)()}),250)})),this.body.emitter.on("_resizeNodes",(function(){e._resizeNodes()})),this.body.emitter.on("_redraw",(function(){!1===e.renderingActive&&e._redraw()})),this.body.emitter.on("_blockRedraw",(function(){e.allowRedraw=!1})),this.body.emitter.on("_allowRedraw",(function(){e.allowRedraw=!0,e.redrawRequested=!1})),this.body.emitter.on("_requestRedraw",Uo(t=this._requestRedraw).call(t,this)),this.body.emitter.on("_startRendering",(function(){e.renderRequests+=1,e.renderingActive=!0,e._startRendering()})),this.body.emitter.on("_stopRendering",(function(){e.renderRequests-=1,e.renderingActive=e.renderRequests>0,e.renderTimer=void 0})),this.body.emitter.on("destroy",(function(){e.renderRequests=0,e.allowRedraw=!1,e.renderingActive=!1,!0===e.requiresTimeout?clearTimeout(e.renderTimer):window.cancelAnimationFrame(e.renderTimer),e.body.emitter.off()}))}},{key:"setOptions",value:function(t){if(void 0!==t){Wx(["hideEdgesOnDrag","hideEdgesOnZoom","hideNodesOnDrag"],this.options,t)}}},{key:"_requestNextFrame",value:function(t,e){if("undefined"!=typeof window){var i,o=window;return!0===this.requiresTimeout?i=Xm(t,e):o.requestAnimationFrame&&(i=o.requestAnimationFrame(t)),i}}},{key:"_startRendering",value:function(){var t;!0===this.renderingActive&&(void 0===this.renderTimer&&(this.renderTimer=this._requestNextFrame(Uo(t=this._renderStep).call(t,this),this.simulationInterval)))}},{key:"_renderStep",value:function(){!0===this.renderingActive&&(this.renderTimer=void 0,!0===this.requiresTimeout&&this._startRendering(),this._redraw(),!1===this.requiresTimeout&&this._startRendering())}},{key:"redraw",value:function(){this.body.emitter.emit("setSize"),this._redraw()}},{key:"_requestRedraw",value:function(){var t=this;!0!==this.redrawRequested&&!1===this.renderingActive&&!0===this.allowRedraw&&(this.redrawRequested=!0,this._requestNextFrame((function(){t._redraw(!1)}),0))}},{key:"_redraw",value:function(){var t=arguments.length>0&&void 0!==arguments[0]&&arguments[0];if(!0===this.allowRedraw){this.body.emitter.emit("initRedraw"),this.redrawRequested=!1;var e={drawExternalLabels:null};0!==this.canvas.frame.canvas.width&&0!==this.canvas.frame.canvas.height||this.canvas.setSize(),this.canvas.setTransform();var i=this.canvas.getContext(),o=this.canvas.frame.canvas.clientWidth,n=this.canvas.frame.canvas.clientHeight;if(i.clearRect(0,0,o,n),0===this.canvas.frame.clientWidth)return;if(i.save(),i.translate(this.body.view.translation.x,this.body.view.translation.y),i.scale(this.body.view.scale,this.body.view.scale),i.beginPath(),this.body.emitter.emit("beforeDrawing",i),i.closePath(),!1===t&&(!1===this.dragging||!0===this.dragging&&!1===this.options.hideEdgesOnDrag)&&(!1===this.zooming||!0===this.zooming&&!1===this.options.hideEdgesOnZoom)&&this._drawEdges(i),!1===this.dragging||!0===this.dragging&&!1===this.options.hideNodesOnDrag){var r=this._drawNodes(i,t).drawExternalLabels;e.drawExternalLabels=r}!1===t&&(!1===this.dragging||!0===this.dragging&&!1===this.options.hideEdgesOnDrag)&&(!1===this.zooming||!0===this.zooming&&!1===this.options.hideEdgesOnZoom)&&this._drawArrows(i),null!=e.drawExternalLabels&&e.drawExternalLabels(),!1===t&&this._drawSelectionBox(i),i.beginPath(),this.body.emitter.emit("afterDrawing",i),i.closePath(),i.restore(),!0===t&&i.clearRect(0,0,o,n)}}},{key:"_resizeNodes",value:function(){this.canvas.setTransform();var t=this.canvas.getContext();t.save(),t.translate(this.body.view.translation.x,this.body.view.translation.y),t.scale(this.body.view.scale,this.body.view.scale);var e,i=this.body.nodes;for(var o in i)Object.prototype.hasOwnProperty.call(i,o)&&((e=i[o]).resize(t),e.updateBoundingBox(t,e.selected));t.restore()}},{key:"_drawNodes",value:function(t){for(var e,i,o=arguments.length>1&&void 0!==arguments[1]&&arguments[1],n=this.body.nodes,r=this.body.nodeIndices,s=[],a=[],h=this.canvas.DOMtoCanvas({x:-20,y:-20}),l=this.canvas.DOMtoCanvas({x:this.canvas.frame.canvas.clientWidth+20,y:this.canvas.frame.canvas.clientHeight+20}),d={top:h.y,left:h.x,bottom:l.y,right:l.x},c=[],u=0;u<r.length;u++)if((e=n[r[u]]).hover)a.push(r[u]);else if(e.isSelected())s.push(r[u]);else if(!0===o){var f=e.draw(t);null!=f.drawExternalLabel&&c.push(f.drawExternalLabel)}else if(!0===e.isBoundingBoxOverlappingWith(d)){var p=e.draw(t);null!=p.drawExternalLabel&&c.push(p.drawExternalLabel)}else e.updateBoundingBox(t,e.selected);var v=s.length,g=a.length;for(i=0;i<v;i++){var y=(e=n[s[i]]).draw(t);null!=y.drawExternalLabel&&c.push(y.drawExternalLabel)}for(i=0;i<g;i++){var m=(e=n[a[i]]).draw(t);null!=m.drawExternalLabel&&c.push(m.drawExternalLabel)}return{drawExternalLabels:function(){for(var t=0,e=c;t<e.length;t++){(0,e[t])()}}}}},{key:"_drawEdges",value:function(t){for(var e=this.body.edges,i=this.body.edgeIndices,o=0;o<i.length;o++){var n=e[i[o]];!0===n.connected&&n.draw(t)}}},{key:"_drawArrows",value:function(t){for(var e=this.body.edges,i=this.body.edgeIndices,o=0;o<i.length;o++){var n=e[i[o]];!0===n.connected&&n.drawArrows(t)}}},{key:"_determineBrowserMethod",value:function(){if("undefined"!=typeof window){var t=navigator.userAgent.toLowerCase();this.requiresTimeout=!1,(-1!=tm(t).call(t,"msie 9.0")||-1!=tm(t).call(t,"safari")&&tm(t).call(t,"chrome")<=-1)&&(this.requiresTimeout=!0)}else this.requiresTimeout=!0}},{key:"_drawSelectionBox",value:function(t){if(this.body.selectionBox.show){t.beginPath();var e=this.body.selectionBox.position.end.x-this.body.selectionBox.position.start.x,i=this.body.selectionBox.position.end.y-this.body.selectionBox.position.start.y;t.rect(this.body.selectionBox.position.start.x,this.body.selectionBox.position.start.y,e,i),t.fillStyle="rgba(151, 194, 252, 0.2)",t.fillRect(this.body.selectionBox.position.start.x,this.body.selectionBox.position.start.y,e,i),t.strokeStyle="rgba(151, 194, 252, 1)",t.stroke()}else t.closePath()}}]),t}(),tF={},eF=it.setInterval;({get exports(){return tF},set exports(t){tF=t}}).exports=eF;var iF=e(tF);function oF(t,e){e.inputHandler=function(t){t.isFirst&&e(t)},t.on("hammer.input",e.inputHandler)}function nF(t,e){return e.inputHandler=function(t){t.isFinal&&e(t)},t.on("hammer.input",e.inputHandler)}var rF=function(){function t(e){pu(this,t),this.body=e,this.pixelRatio=1,this.cameraState={},this.initialized=!1,this.canvasViewCenter={},this._cleanupCallbacks=[],this.options={},this.defaultOptions={autoResize:!0,height:"100%",width:"100%"},wo(this.options,this.defaultOptions),this.bindEventListeners()}return Nf(t,[{key:"bindEventListeners",value:function(){var t,e=this;this.body.emitter.once("resize",(function(t){0!==t.width&&(e.body.view.translation.x=.5*t.width),0!==t.height&&(e.body.view.translation.y=.5*t.height)})),this.body.emitter.on("setSize",Uo(t=this.setSize).call(t,this)),this.body.emitter.on("destroy",(function(){e.hammerFrame.destroy(),e.hammer.destroy(),e._cleanUp()}))}},{key:"setOptions",value:function(t){var e=this;if(void 0!==t){Wx(["width","height","autoResize"],this.options,t)}if(this._cleanUp(),!0===this.options.autoResize){var i;if(window.ResizeObserver){var o=new ResizeObserver((function(){!0===e.setSize()&&e.body.emitter.emit("_requestRedraw")})),n=this.frame;o.observe(n),this._cleanupCallbacks.push((function(){o.unobserve(n)}))}else{var r=iF((function(){!0===e.setSize()&&e.body.emitter.emit("_requestRedraw")}),1e3);this._cleanupCallbacks.push((function(){clearInterval(r)}))}var s=Uo(i=this._onResize).call(i,this);Zx(window,"resize",s),this._cleanupCallbacks.push((function(){Qx(window,"resize",s)}))}}},{key:"_cleanUp",value:function(){var t,e,i;Cv(t=Rv(e=vg(i=this._cleanupCallbacks).call(i,0)).call(e)).call(t,(function(t){try{t()}catch(t){console.error(t)}}))}},{key:"_onResize",value:function(){this.setSize(),this.body.emitter.emit("_redraw")}},{key:"_getCameraState",value:function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:this.pixelRatio;!0===this.initialized&&(this.cameraState.previousWidth=this.frame.canvas.width/t,this.cameraState.previousHeight=this.frame.canvas.height/t,this.cameraState.scale=this.body.view.scale,this.cameraState.position=this.DOMtoCanvas({x:.5*this.frame.canvas.width/t,y:.5*this.frame.canvas.height/t}))}},{key:"_setCameraState",value:function(){if(void 0!==this.cameraState.scale&&0!==this.frame.canvas.clientWidth&&0!==this.frame.canvas.clientHeight&&0!==this.pixelRatio&&this.cameraState.previousWidth>0&&this.cameraState.previousHeight>0){var t=this.frame.canvas.width/this.pixelRatio/this.cameraState.previousWidth,e=this.frame.canvas.height/this.pixelRatio/this.cameraState.previousHeight,i=this.cameraState.scale;1!=t&&1!=e?i=.5*this.cameraState.scale*(t+e):1!=t?i=this.cameraState.scale*t:1!=e&&(i=this.cameraState.scale*e),this.body.view.scale=i;var o=this.DOMtoCanvas({x:.5*this.frame.canvas.clientWidth,y:.5*this.frame.canvas.clientHeight}),n={x:o.x-this.cameraState.position.x,y:o.y-this.cameraState.position.y};this.body.view.translation.x+=n.x*this.body.view.scale,this.body.view.translation.y+=n.y*this.body.view.scale}}},{key:"_prepareValue",value:function(t){if("number"==typeof t)return t+"px";if("string"==typeof t){if(-1!==tm(t).call(t,"%")||-1!==tm(t).call(t,"px"))return t;if(-1===tm(t).call(t,"%"))return t+"px"}throw new Error("Could not use the value supplied for width or height:"+t)}},{key:"_create",value:function(){for(;this.body.container.hasChildNodes();)this.body.container.removeChild(this.body.container.firstChild);if(this.frame=document.createElement("div"),this.frame.className="vis-network",this.frame.style.position="relative",this.frame.style.overflow="hidden",this.frame.tabIndex=0,this.frame.canvas=document.createElement("canvas"),this.frame.canvas.style.position="relative",this.frame.appendChild(this.frame.canvas),this.frame.canvas.getContext)this._setPixelRatio(),this.setTransform();else{var t=document.createElement("DIV");t.style.color="red",t.style.fontWeight="bold",t.style.padding="10px",t.innerText="Error: your browser does not support HTML canvas",this.frame.canvas.appendChild(t)}this.body.container.appendChild(this.frame),this.body.view.scale=1,this.body.view.translation={x:.5*this.frame.canvas.clientWidth,y:.5*this.frame.canvas.clientHeight},this._bindHammer()}},{key:"_bindHammer",value:function(){var t=this;void 0!==this.hammer&&this.hammer.destroy(),this.drag={},this.pinch={},this.hammer=new Tk(this.frame.canvas),this.hammer.get("pinch").set({enable:!0}),this.hammer.get("pan").set({threshold:5,direction:Tk.DIRECTION_ALL}),oF(this.hammer,(function(e){t.body.eventListeners.onTouch(e)})),this.hammer.on("tap",(function(e){t.body.eventListeners.onTap(e)})),this.hammer.on("doubletap",(function(e){t.body.eventListeners.onDoubleTap(e)})),this.hammer.on("press",(function(e){t.body.eventListeners.onHold(e)})),this.hammer.on("panstart",(function(e){t.body.eventListeners.onDragStart(e)})),this.hammer.on("panmove",(function(e){t.body.eventListeners.onDrag(e)})),this.hammer.on("panend",(function(e){t.body.eventListeners.onDragEnd(e)})),this.hammer.on("pinch",(function(e){t.body.eventListeners.onPinch(e)})),this.frame.canvas.addEventListener("wheel",(function(e){t.body.eventListeners.onMouseWheel(e)})),this.frame.canvas.addEventListener("mousemove",(function(e){t.body.eventListeners.onMouseMove(e)})),this.frame.canvas.addEventListener("contextmenu",(function(e){t.body.eventListeners.onContext(e)})),this.hammerFrame=new Tk(this.frame),nF(this.hammerFrame,(function(e){t.body.eventListeners.onRelease(e)}))}},{key:"setSize",value:function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:this.options.width,e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:this.options.height;t=this._prepareValue(t),e=this._prepareValue(e);var i=!1,o=this.frame.canvas.width,n=this.frame.canvas.height,r=this.pixelRatio;if(this._setPixelRatio(),t!=this.options.width||e!=this.options.height||this.frame.style.width!=t||this.frame.style.height!=e)this._getCameraState(r),this.frame.style.width=t,this.frame.style.height=e,this.frame.canvas.style.width="100%",this.frame.canvas.style.height="100%",this.frame.canvas.width=Math.round(this.frame.canvas.clientWidth*this.pixelRatio),this.frame.canvas.height=Math.round(this.frame.canvas.clientHeight*this.pixelRatio),this.options.width=t,this.options.height=e,this.canvasViewCenter={x:.5*this.frame.clientWidth,y:.5*this.frame.clientHeight},i=!0;else{var s=Math.round(this.frame.canvas.clientWidth*this.pixelRatio),a=Math.round(this.frame.canvas.clientHeight*this.pixelRatio);this.frame.canvas.width===s&&this.frame.canvas.height===a||this._getCameraState(r),this.frame.canvas.width!==s&&(this.frame.canvas.width=s,i=!0),this.frame.canvas.height!==a&&(this.frame.canvas.height=a,i=!0)}return!0===i&&(this.body.emitter.emit("resize",{width:Math.round(this.frame.canvas.width/this.pixelRatio),height:Math.round(this.frame.canvas.height/this.pixelRatio),oldWidth:Math.round(o/this.pixelRatio),oldHeight:Math.round(n/this.pixelRatio)}),this._setCameraState()),this.initialized=!0,i}},{key:"getContext",value:function(){return this.frame.canvas.getContext("2d")}},{key:"_determinePixelRatio",value:function(){var t=this.getContext();if(void 0===t)throw new Error("Could not get canvax context");var e=1;return"undefined"!=typeof window&&(e=window.devicePixelRatio||1),e/(t.webkitBackingStorePixelRatio||t.mozBackingStorePixelRatio||t.msBackingStorePixelRatio||t.oBackingStorePixelRatio||t.backingStorePixelRatio||1)}},{key:"_setPixelRatio",value:function(){this.pixelRatio=this._determinePixelRatio()}},{key:"setTransform",value:function(){var t=this.getContext();if(void 0===t)throw new Error("Could not get canvax context");t.setTransform(this.pixelRatio,0,0,this.pixelRatio,0,0)}},{key:"_XconvertDOMtoCanvas",value:function(t){return(t-this.body.view.translation.x)/this.body.view.scale}},{key:"_XconvertCanvasToDOM",value:function(t){return t*this.body.view.scale+this.body.view.translation.x}},{key:"_YconvertDOMtoCanvas",value:function(t){return(t-this.body.view.translation.y)/this.body.view.scale}},{key:"_YconvertCanvasToDOM",value:function(t){return t*this.body.view.scale+this.body.view.translation.y}},{key:"canvasToDOM",value:function(t){return{x:this._XconvertCanvasToDOM(t.x),y:this._YconvertCanvasToDOM(t.y)}}},{key:"DOMtoCanvas",value:function(t){return{x:this._XconvertDOMtoCanvas(t.x),y:this._YconvertDOMtoCanvas(t.y)}}}]),t}();var sF=function(){function t(e,i){var o,n,r=this;pu(this,t),this.body=e,this.canvas=i,this.animationSpeed=1/this.renderRefreshRate,this.animationEasingFunction="easeInOutQuint",this.easingTime=0,this.sourceScale=0,this.targetScale=0,this.sourceTranslation=0,this.targetTranslation=0,this.lockedOnNodeId=void 0,this.lockedOnNodeOffset=void 0,this.touchTime=0,this.viewFunction=void 0,this.body.emitter.on("fit",Uo(o=this.fit).call(o,this)),this.body.emitter.on("animationFinished",(function(){r.body.emitter.emit("_stopRendering")})),this.body.emitter.on("unlockNode",Uo(n=this.releaseNode).call(n,this))}return Nf(t,[{key:"setOptions",value:function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{};this.options=t}},{key:"fit",value:function(t){var e=arguments.length>1&&void 0!==arguments[1]&&arguments[1];t=function(t,e){var i=wo({nodes:e,minZoomLevel:Number.MIN_VALUE,maxZoomLevel:1},null!=t?t:{});if(!Wp(i.nodes))throw new TypeError("Nodes has to be an array of ids.");if(0===i.nodes.length&&(i.nodes=e),!("number"==typeof i.minZoomLevel&&i.minZoomLevel>0))throw new TypeError("Min zoom level has to be a number higher than zero.");if(!("number"==typeof i.maxZoomLevel&&i.minZoomLevel<=i.maxZoomLevel))throw new TypeError("Max zoom level has to be a number higher than min zoom level.");return i}(t,this.body.nodeIndices);var i,o,n=this.canvas.frame.canvas.clientWidth,r=this.canvas.frame.canvas.clientHeight;if(0===n||0===r)o=1,i=Kz.getRange(this.body.nodes,t.nodes);else if(!0===e){var s=0;for(var a in this.body.nodes){if(Object.prototype.hasOwnProperty.call(this.body.nodes,a))!0===this.body.nodes[a].predefinedPosition&&(s+=1)}if(s>.5*this.body.nodeIndices.length)return void this.fit(t,!1);i=Kz.getRange(this.body.nodes,t.nodes),o=12.662/(this.body.nodeIndices.length+7.4147)+.0964822,o*=Math.min(n/600,r/600)}else{this.body.emitter.emit("_resizeNodes"),i=Kz.getRange(this.body.nodes,t.nodes);var h=n/(1.1*Math.abs(i.maxX-i.minX)),l=r/(1.1*Math.abs(i.maxY-i.minY));o=h<=l?h:l}o>t.maxZoomLevel?o=t.maxZoomLevel:o<t.minZoomLevel&&(o=t.minZoomLevel);var d={position:Kz.findCenter(i),scale:o,animation:t.animation};this.moveTo(d)}},{key:"focus",value:function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{};if(void 0!==this.body.nodes[t]){var i={x:this.body.nodes[t].x,y:this.body.nodes[t].y};e.position=i,e.lockedOnNode=t,this.moveTo(e)}else console.error("Node: "+t+" cannot be found.")}},{key:"moveTo",value:function(t){if(void 0!==t){if(null!=t.offset){if(null!=t.offset.x){if(t.offset.x=+t.offset.x,!tO(t.offset.x))throw new TypeError('The option "offset.x" has to be a finite number.')}else t.offset.x=0;if(null!=t.offset.y){if(t.offset.y=+t.offset.y,!tO(t.offset.y))throw new TypeError('The option "offset.y" has to be a finite number.')}else t.offset.x=0}else t.offset={x:0,y:0};if(null!=t.position){if(null!=t.position.x){if(t.position.x=+t.position.x,!tO(t.position.x))throw new TypeError('The option "position.x" has to be a finite number.')}else t.position.x=0;if(null!=t.position.y){if(t.position.y=+t.position.y,!tO(t.position.y))throw new TypeError('The option "position.y" has to be a finite number.')}else t.position.x=0}else t.position=this.getViewPosition();if(null!=t.scale){if(t.scale=+t.scale,!(t.scale>0))throw new TypeError('The option "scale" has to be a number greater than zero.')}else t.scale=this.body.view.scale;void 0===t.animation&&(t.animation={duration:0}),!1===t.animation&&(t.animation={duration:0}),!0===t.animation&&(t.animation={}),void 0===t.animation.duration&&(t.animation.duration=1e3),void 0===t.animation.easingFunction&&(t.animation.easingFunction="easeInOutQuad"),this.animateView(t)}else t={}}},{key:"animateView",value:function(t){if(void 0!==t){this.animationEasingFunction=t.animation.easingFunction,this.releaseNode(),!0===t.locked&&(this.lockedOnNodeId=t.lockedOnNode,this.lockedOnNodeOffset=t.offset),0!=this.easingTime&&this._transitionRedraw(!0),this.sourceScale=this.body.view.scale,this.sourceTranslation=this.body.view.translation,this.targetScale=t.scale,this.body.view.scale=this.targetScale;var e,i,o=this.canvas.DOMtoCanvas({x:.5*this.canvas.frame.canvas.clientWidth,y:.5*this.canvas.frame.canvas.clientHeight}),n=o.x-t.position.x,r=o.y-t.position.y;if(this.targetTranslation={x:this.sourceTranslation.x+n*this.targetScale+t.offset.x,y:this.sourceTranslation.y+r*this.targetScale+t.offset.y},0===t.animation.duration)if(null!=this.lockedOnNodeId)this.viewFunction=Uo(e=this._lockedRedraw).call(e,this),this.body.emitter.on("initRedraw",this.viewFunction);else this.body.view.scale=this.targetScale,this.body.view.translation=this.targetTranslation,this.body.emitter.emit("_requestRedraw");else this.animationSpeed=1/(60*t.animation.duration*.001)||1/60,this.animationEasingFunction=t.animation.easingFunction,this.viewFunction=Uo(i=this._transitionRedraw).call(i,this),this.body.emitter.on("initRedraw",this.viewFunction),this.body.emitter.emit("_startRendering")}}},{key:"_lockedRedraw",value:function(){var t=this.body.nodes[this.lockedOnNodeId].x,e=this.body.nodes[this.lockedOnNodeId].y,i=this.canvas.DOMtoCanvas({x:.5*this.canvas.frame.canvas.clientWidth,y:.5*this.canvas.frame.canvas.clientHeight}),o=i.x-t,n=i.y-e,r=this.body.view.translation,s={x:r.x+o*this.body.view.scale+this.lockedOnNodeOffset.x,y:r.y+n*this.body.view.scale+this.lockedOnNodeOffset.y};this.body.view.translation=s}},{key:"releaseNode",value:function(){void 0!==this.lockedOnNodeId&&void 0!==this.viewFunction&&(this.body.emitter.off("initRedraw",this.viewFunction),this.lockedOnNodeId=void 0,this.lockedOnNodeOffset=void 0)}},{key:"_transitionRedraw",value:function(){var t=arguments.length>0&&void 0!==arguments[0]&&arguments[0];this.easingTime+=this.animationSpeed,this.easingTime=!0===t?1:this.easingTime;var e=pk[this.animationEasingFunction](this.easingTime);if(this.body.view.scale=this.sourceScale+(this.targetScale-this.sourceScale)*e,this.body.view.translation={x:this.sourceTranslation.x+(this.targetTranslation.x-this.sourceTranslation.x)*e,y:this.sourceTranslation.y+(this.targetTranslation.y-this.sourceTranslation.y)*e},this.easingTime>=1){var i;if(this.body.emitter.off("initRedraw",this.viewFunction),this.easingTime=0,null!=this.lockedOnNodeId)this.viewFunction=Uo(i=this._lockedRedraw).call(i,this),this.body.emitter.on("initRedraw",this.viewFunction);this.body.emitter.emit("animationFinished")}}},{key:"getScale",value:function(){return this.body.view.scale}},{key:"getViewPosition",value:function(){return this.canvas.DOMtoCanvas({x:.5*this.canvas.frame.canvas.clientWidth,y:.5*this.canvas.frame.canvas.clientHeight})}}]),t}();function aF(t){var e,i=t&&t.preventDefault||!1,o=t&&t.container||window,n={},r={keydown:{},keyup:{}},s={};for(e=97;e<=122;e++)s[String.fromCharCode(e)]={code:e-97+65,shift:!1};for(e=65;e<=90;e++)s[String.fromCharCode(e)]={code:e,shift:!0};for(e=0;e<=9;e++)s[""+e]={code:48+e,shift:!1};for(e=1;e<=12;e++)s["F"+e]={code:111+e,shift:!1};for(e=0;e<=9;e++)s["num"+e]={code:96+e,shift:!1};s["num*"]={code:106,shift:!1},s["num+"]={code:107,shift:!1},s["num-"]={code:109,shift:!1},s["num/"]={code:111,shift:!1},s["num."]={code:110,shift:!1},s.left={code:37,shift:!1},s.up={code:38,shift:!1},s.right={code:39,shift:!1},s.down={code:40,shift:!1},s.space={code:32,shift:!1},s.enter={code:13,shift:!1},s.shift={code:16,shift:void 0},s.esc={code:27,shift:!1},s.backspace={code:8,shift:!1},s.tab={code:9,shift:!1},s.ctrl={code:17,shift:!1},s.alt={code:18,shift:!1},s.delete={code:46,shift:!1},s.pageup={code:33,shift:!1},s.pagedown={code:34,shift:!1},s["="]={code:187,shift:!1},s["-"]={code:189,shift:!1},s["]"]={code:221,shift:!1},s["["]={code:219,shift:!1};var a=function(t){l(t,"keydown")},h=function(t){l(t,"keyup")},l=function(t,e){if(void 0!==r[e][t.keyCode]){for(var o=r[e][t.keyCode],n=0;n<o.length;n++)(void 0===o[n].shift||1==o[n].shift&&1==t.shiftKey||0==o[n].shift&&0==t.shiftKey)&&o[n].fn(t);1==i&&t.preventDefault()}};return n.bind=function(t,e,i){if(void 0===i&&(i="keydown"),void 0===s[t])throw new Error("unsupported key: "+t);void 0===r[i][s[t].code]&&(r[i][s[t].code]=[]),r[i][s[t].code].push({fn:e,shift:s[t].shift})},n.bindAll=function(t,e){for(var i in void 0===e&&(e="keydown"),s)s.hasOwnProperty(i)&&n.bind(i,t,e)},n.getKey=function(t){for(var e in s)if(s.hasOwnProperty(e)){if(1==t.shiftKey&&1==s[e].shift&&t.keyCode==s[e].code)return e;if(0==t.shiftKey&&0==s[e].shift&&t.keyCode==s[e].code)return e;if(t.keyCode==s[e].code&&"shift"==e)return e}return"unknown key, currently not supported"},n.unbind=function(t,e,i){if(void 0===i&&(i="keydown"),void 0===s[t])throw new Error("unsupported key: "+t);if(void 0!==e){var o=[],n=r[i][s[t].code];if(void 0!==n)for(var a=0;a<n.length;a++)n[a].fn==e&&n[a].shift==s[t].shift||o.push(r[i][s[t].code][a]);r[i][s[t].code]=o}else r[i][s[t].code]=[]},n.reset=function(){r={keydown:{},keyup:{}}},n.destroy=function(){r={keydown:{},keyup:{}},o.removeEventListener("keydown",a,!0),o.removeEventListener("keyup",h,!0)},o.addEventListener("keydown",a,!0),o.addEventListener("keyup",h,!0),n}var hF=Object.freeze({__proto__:null,default:aF}),lF=function(){function t(e,i){var o=this;pu(this,t),this.body=e,this.canvas=i,this.iconsCreated=!1,this.navigationHammers=[],this.boundFunctions={},this.touchTime=0,this.activated=!1,this.body.emitter.on("activate",(function(){o.activated=!0,o.configureKeyboardBindings()})),this.body.emitter.on("deactivate",(function(){o.activated=!1,o.configureKeyboardBindings()})),this.body.emitter.on("destroy",(function(){void 0!==o.keycharm&&o.keycharm.destroy()})),this.options={}}return Nf(t,[{key:"setOptions",value:function(t){void 0!==t&&(this.options=t,this.create())}},{key:"create",value:function(){!0===this.options.navigationButtons?!1===this.iconsCreated&&this.loadNavigationElements():!0===this.iconsCreated&&this.cleanNavigation(),this.configureKeyboardBindings()}},{key:"cleanNavigation",value:function(){if(0!=this.navigationHammers.length){for(var t=0;t<this.navigationHammers.length;t++)this.navigationHammers[t].destroy();this.navigationHammers=[]}this.navigationDOM&&this.navigationDOM.wrapper&&this.navigationDOM.wrapper.parentNode&&this.navigationDOM.wrapper.parentNode.removeChild(this.navigationDOM.wrapper),this.iconsCreated=!1}},{key:"loadNavigationElements",value:function(){var t=this;this.cleanNavigation(),this.navigationDOM={};var e=["up","down","left","right","zoomIn","zoomOut","zoomExtends"],i=["_moveUp","_moveDown","_moveLeft","_moveRight","_zoomIn","_zoomOut","_fit"];this.navigationDOM.wrapper=document.createElement("div"),this.navigationDOM.wrapper.className="vis-navigation",this.canvas.frame.appendChild(this.navigationDOM.wrapper);for(var o=0;o<e.length;o++){this.navigationDOM[e[o]]=document.createElement("div"),this.navigationDOM[e[o]].className="vis-button vis-"+e[o],this.navigationDOM.wrapper.appendChild(this.navigationDOM[e[o]]);var n,r,s=new Tk(this.navigationDOM[e[o]]);if("_fit"===i[o])oF(s,Uo(n=this._fit).call(n,this));else oF(s,Uo(r=this.bindToRedraw).call(r,this,i[o]));this.navigationHammers.push(s)}var a=new Tk(this.canvas.frame);nF(a,(function(){t._stopMovement()})),this.navigationHammers.push(a),this.iconsCreated=!0}},{key:"bindToRedraw",value:function(t){var e;void 0===this.boundFunctions[t]&&(this.boundFunctions[t]=Uo(e=this[t]).call(e,this),this.body.emitter.on("initRedraw",this.boundFunctions[t]),this.body.emitter.emit("_startRendering"))}},{key:"unbindFromRedraw",value:function(t){void 0!==this.boundFunctions[t]&&(this.body.emitter.off("initRedraw",this.boundFunctions[t]),this.body.emitter.emit("_stopRendering"),delete this.boundFunctions[t])}},{key:"_fit",value:function(){(new Date).valueOf()-this.touchTime>700&&(this.body.emitter.emit("fit",{duration:700}),this.touchTime=(new Date).valueOf())}},{key:"_stopMovement",value:function(){for(var t in this.boundFunctions)Object.prototype.hasOwnProperty.call(this.boundFunctions,t)&&(this.body.emitter.off("initRedraw",this.boundFunctions[t]),this.body.emitter.emit("_stopRendering"));this.boundFunctions={}}},{key:"_moveUp",value:function(){this.body.view.translation.y+=this.options.keyboard.speed.y}},{key:"_moveDown",value:function(){this.body.view.translation.y-=this.options.keyboard.speed.y}},{key:"_moveLeft",value:function(){this.body.view.translation.x+=this.options.keyboard.speed.x}},{key:"_moveRight",value:function(){this.body.view.translation.x-=this.options.keyboard.speed.x}},{key:"_zoomIn",value:function(){var t=this.body.view.scale,e=this.body.view.scale*(1+this.options.keyboard.speed.zoom),i=this.body.view.translation,o=e/t,n=(1-o)*this.canvas.canvasViewCenter.x+i.x*o,r=(1-o)*this.canvas.canvasViewCenter.y+i.y*o;this.body.view.scale=e,this.body.view.translation={x:n,y:r},this.body.emitter.emit("zoom",{direction:"+",scale:this.body.view.scale,pointer:null})}},{key:"_zoomOut",value:function(){var t=this.body.view.scale,e=this.body.view.scale/(1+this.options.keyboard.speed.zoom),i=this.body.view.translation,o=e/t,n=(1-o)*this.canvas.canvasViewCenter.x+i.x*o,r=(1-o)*this.canvas.canvasViewCenter.y+i.y*o;this.body.view.scale=e,this.body.view.translation={x:n,y:r},this.body.emitter.emit("zoom",{direction:"-",scale:this.body.view.scale,pointer:null})}},{key:"configureKeyboardBindings",value:function(){var t,e,i,o,n,r,s,a,h,l,d,c,u,f,p,v,g,y,m,b,w,x,k,_,E=this;(void 0!==this.keycharm&&this.keycharm.destroy(),!0===this.options.keyboard.enabled)&&(!0===this.options.keyboard.bindToWindow?this.keycharm=aF({container:window,preventDefault:!0}):this.keycharm=aF({container:this.canvas.frame,preventDefault:!0}),this.keycharm.reset(),!0===this.activated&&(Uo(t=this.keycharm).call(t,"up",(function(){E.bindToRedraw("_moveUp")}),"keydown"),Uo(e=this.keycharm).call(e,"down",(function(){E.bindToRedraw("_moveDown")}),"keydown"),Uo(i=this.keycharm).call(i,"left",(function(){E.bindToRedraw("_moveLeft")}),"keydown"),Uo(o=this.keycharm).call(o,"right",(function(){E.bindToRedraw("_moveRight")}),"keydown"),Uo(n=this.keycharm).call(n,"=",(function(){E.bindToRedraw("_zoomIn")}),"keydown"),Uo(r=this.keycharm).call(r,"num+",(function(){E.bindToRedraw("_zoomIn")}),"keydown"),Uo(s=this.keycharm).call(s,"num-",(function(){E.bindToRedraw("_zoomOut")}),"keydown"),Uo(a=this.keycharm).call(a,"-",(function(){E.bindToRedraw("_zoomOut")}),"keydown"),Uo(h=this.keycharm).call(h,"[",(function(){E.bindToRedraw("_zoomOut")}),"keydown"),Uo(l=this.keycharm).call(l,"]",(function(){E.bindToRedraw("_zoomIn")}),"keydown"),Uo(d=this.keycharm).call(d,"pageup",(function(){E.bindToRedraw("_zoomIn")}),"keydown"),Uo(c=this.keycharm).call(c,"pagedown",(function(){E.bindToRedraw("_zoomOut")}),"keydown"),Uo(u=this.keycharm).call(u,"up",(function(){E.unbindFromRedraw("_moveUp")}),"keyup"),Uo(f=this.keycharm).call(f,"down",(function(){E.unbindFromRedraw("_moveDown")}),"keyup"),Uo(p=this.keycharm).call(p,"left",(function(){E.unbindFromRedraw("_moveLeft")}),"keyup"),Uo(v=this.keycharm).call(v,"right",(function(){E.unbindFromRedraw("_moveRight")}),"keyup"),Uo(g=this.keycharm).call(g,"=",(function(){E.unbindFromRedraw("_zoomIn")}),"keyup"),Uo(y=this.keycharm).call(y,"num+",(function(){E.unbindFromRedraw("_zoomIn")}),"keyup"),Uo(m=this.keycharm).call(m,"num-",(function(){E.unbindFromRedraw("_zoomOut")}),"keyup"),Uo(b=this.keycharm).call(b,"-",(function(){E.unbindFromRedraw("_zoomOut")}),"keyup"),Uo(w=this.keycharm).call(w,"[",(function(){E.unbindFromRedraw("_zoomOut")}),"keyup"),Uo(x=this.keycharm).call(x,"]",(function(){E.unbindFromRedraw("_zoomIn")}),"keyup"),Uo(k=this.keycharm).call(k,"pageup",(function(){E.unbindFromRedraw("_zoomIn")}),"keyup"),Uo(_=this.keycharm).call(_,"pagedown",(function(){E.unbindFromRedraw("_zoomOut")}),"keyup")))}}]),t}();function dF(t,e){var i=void 0!==Op&&xh(t)||t["@@iterator"];if(!i){if(Wp(t)||(i=function(t,e){var i;if(!t)return;if("string"==typeof t)return cF(t,e);var o=Fp(i=Object.prototype.toString.call(t)).call(i,8,-1);"Object"===o&&t.constructor&&(o=t.constructor.name);if("Map"===o||"Set"===o)return Za(t);if("Arguments"===o||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(o))return cF(t,e)}(t))||e&&t&&"number"==typeof t.length){i&&(t=i);var o=0,n=function(){};return{s:n,n:function(){return o>=t.length?{done:!0}:{done:!1,value:t[o++]}},e:function(t){throw t},f:n}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var r,s=!0,a=!1;return{s:function(){i=i.call(t)},n:function(){var t=i.next();return s=t.done,t},e:function(t){a=!0,r=t},f:function(){try{s||null==i.return||i.return()}finally{if(a)throw r}}}}function cF(t,e){(null==e||e>t.length)&&(e=t.length);for(var i=0,o=new Array(e);i<e;i++)o[i]=t[i];return o}var uF=function(){function t(e,i,o){var n,r,s,a,h,l,d,c,u,f,p,v,g;pu(this,t),this.body=e,this.canvas=i,this.selectionHandler=o,this.navigationHandler=new lF(e,i),this.body.eventListeners.onTap=Uo(n=this.onTap).call(n,this),this.body.eventListeners.onTouch=Uo(r=this.onTouch).call(r,this),this.body.eventListeners.onDoubleTap=Uo(s=this.onDoubleTap).call(s,this),this.body.eventListeners.onHold=Uo(a=this.onHold).call(a,this),this.body.eventListeners.onDragStart=Uo(h=this.onDragStart).call(h,this),this.body.eventListeners.onDrag=Uo(l=this.onDrag).call(l,this),this.body.eventListeners.onDragEnd=Uo(d=this.onDragEnd).call(d,this),this.body.eventListeners.onMouseWheel=Uo(c=this.onMouseWheel).call(c,this),this.body.eventListeners.onPinch=Uo(u=this.onPinch).call(u,this),this.body.eventListeners.onMouseMove=Uo(f=this.onMouseMove).call(f,this),this.body.eventListeners.onRelease=Uo(p=this.onRelease).call(p,this),this.body.eventListeners.onContext=Uo(v=this.onContext).call(v,this),this.touchTime=0,this.drag={},this.pinch={},this.popup=void 0,this.popupObj=void 0,this.popupTimer=void 0,this.body.functions.getPointer=Uo(g=this.getPointer).call(g,this),this.options={},this.defaultOptions={dragNodes:!0,dragView:!0,hover:!1,keyboard:{enabled:!1,speed:{x:10,y:10,zoom:.02},bindToWindow:!0,autoFocus:!0},navigationButtons:!1,tooltipDelay:300,zoomView:!0,zoomSpeed:1},wo(this.options,this.defaultOptions),this.bindEventListeners()}return Nf(t,[{key:"bindEventListeners",value:function(){var t=this;this.body.emitter.on("destroy",(function(){clearTimeout(t.popupTimer),delete t.body.functions.getPointer}))}},{key:"setOptions",value:function(t){if(void 0!==t){qx(["hideEdgesOnDrag","hideEdgesOnZoom","hideNodesOnDrag","keyboard","multiselect","selectable","selectConnectedEdges"],this.options,t),fk(this.options,t,"keyboard"),t.tooltip&&(wo(this.options.tooltip,t.tooltip),t.tooltip.color&&(this.options.tooltip.color=ok(t.tooltip.color)))}this.navigationHandler.setOptions(this.options)}},{key:"getPointer",value:function(t){return{x:t.x-Xx(this.canvas.frame.canvas),y:t.y-Gx(this.canvas.frame.canvas)}}},{key:"onTouch",value:function(t){(new Date).valueOf()-this.touchTime>50&&(this.drag.pointer=this.getPointer(t.center),this.drag.pinched=!1,this.pinch.scale=this.body.view.scale,this.touchTime=(new Date).valueOf())}},{key:"onTap",value:function(t){var e=this.getPointer(t.center),i=this.selectionHandler.options.multiselect&&(t.changedPointers[0].ctrlKey||t.changedPointers[0].metaKey);this.checkSelectionChanges(e,i),this.selectionHandler.commitAndEmit(e,t),this.selectionHandler.generateClickEvent("click",t,e)}},{key:"onDoubleTap",value:function(t){var e=this.getPointer(t.center);this.selectionHandler.generateClickEvent("doubleClick",t,e)}},{key:"onHold",value:function(t){var e=this.getPointer(t.center),i=this.selectionHandler.options.multiselect;this.checkSelectionChanges(e,i),this.selectionHandler.commitAndEmit(e,t),this.selectionHandler.generateClickEvent("click",t,e),this.selectionHandler.generateClickEvent("hold",t,e)}},{key:"onRelease",value:function(t){if((new Date).valueOf()-this.touchTime>10){var e=this.getPointer(t.center);this.selectionHandler.generateClickEvent("release",t,e),this.touchTime=(new Date).valueOf()}}},{key:"onContext",value:function(t){var e=this.getPointer({x:t.clientX,y:t.clientY});this.selectionHandler.generateClickEvent("oncontext",t,e)}},{key:"checkSelectionChanges",value:function(t){!0===(arguments.length>1&&void 0!==arguments[1]&&arguments[1])?this.selectionHandler.selectAdditionalOnPoint(t):this.selectionHandler.selectOnPoint(t)}},{key:"_determineDifference",value:function(t,e){var i=function(t,e){for(var i=[],o=0;o<t.length;o++){var n=t[o];-1===tm(e).call(e,n)&&i.push(n)}return i};return{nodes:i(t.nodes,e.nodes),edges:i(t.edges,e.edges)}}},{key:"onDragStart",value:function(t){if(!this.drag.dragging){void 0===this.drag.pointer&&this.onTouch(t);var e=this.selectionHandler.getNodeAt(this.drag.pointer);if(this.drag.dragging=!0,this.drag.selection=[],this.drag.translation=wo({},this.body.view.translation),this.drag.nodeId=void 0,t.srcEvent.shiftKey){this.body.selectionBox.show=!0;var i=this.getPointer(t.center);this.body.selectionBox.position.start={x:this.canvas._XconvertDOMtoCanvas(i.x),y:this.canvas._YconvertDOMtoCanvas(i.y)},this.body.selectionBox.position.end={x:this.canvas._XconvertDOMtoCanvas(i.x),y:this.canvas._YconvertDOMtoCanvas(i.y)}}else if(void 0!==e&&!0===this.options.dragNodes){this.drag.nodeId=e.id,!1===e.isSelected()&&this.selectionHandler.setSelection({nodes:[e.id]}),this.selectionHandler.generateClickEvent("dragStart",t,this.drag.pointer);var o,n=dF(this.selectionHandler.getSelectedNodes());try{for(n.s();!(o=n.n()).done;){var r=o.value,s={id:r.id,node:r,x:r.x,y:r.y,xFixed:r.options.fixed.x,yFixed:r.options.fixed.y};r.options.fixed.x=!0,r.options.fixed.y=!0,this.drag.selection.push(s)}}catch(t){n.e(t)}finally{n.f()}}else this.selectionHandler.generateClickEvent("dragStart",t,this.drag.pointer,void 0,!0)}}},{key:"onDrag",value:function(t){var e=this;if(!0!==this.drag.pinched){this.body.emitter.emit("unlockNode");var i=this.getPointer(t.center),o=this.drag.selection;if(o&&o.length&&!0===this.options.dragNodes){this.selectionHandler.generateClickEvent("dragging",t,i);var n=i.x-this.drag.pointer.x,r=i.y-this.drag.pointer.y;Cv(o).call(o,(function(t){var i=t.node;!1===t.xFixed&&(i.x=e.canvas._XconvertDOMtoCanvas(e.canvas._XconvertCanvasToDOM(t.x)+n)),!1===t.yFixed&&(i.y=e.canvas._YconvertDOMtoCanvas(e.canvas._YconvertCanvasToDOM(t.y)+r))})),this.body.emitter.emit("startSimulation")}else{if(t.srcEvent.shiftKey){if(this.selectionHandler.generateClickEvent("dragging",t,i,void 0,!0),void 0===this.drag.pointer)return void this.onDragStart(t);this.body.selectionBox.position.end={x:this.canvas._XconvertDOMtoCanvas(i.x),y:this.canvas._YconvertDOMtoCanvas(i.y)},this.body.emitter.emit("_requestRedraw")}if(!0===this.options.dragView&&!t.srcEvent.shiftKey){if(this.selectionHandler.generateClickEvent("dragging",t,i,void 0,!0),void 0===this.drag.pointer)return void this.onDragStart(t);var s=i.x-this.drag.pointer.x,a=i.y-this.drag.pointer.y;this.body.view.translation={x:this.drag.translation.x+s,y:this.drag.translation.y+a},this.body.emitter.emit("_requestRedraw")}}}}},{key:"onDragEnd",value:function(t){var e=this;if(this.drag.dragging=!1,this.body.selectionBox.show){var i;this.body.selectionBox.show=!1;var o=this.body.selectionBox.position,n={minX:Math.min(o.start.x,o.end.x),minY:Math.min(o.start.y,o.end.y),maxX:Math.max(o.start.x,o.end.x),maxY:Math.max(o.start.y,o.end.y)},r=oy(i=this.body.nodeIndices).call(i,(function(t){var i=e.body.nodes[t];return i.x>=n.minX&&i.x<=n.maxX&&i.y>=n.minY&&i.y<=n.maxY}));Cv(r).call(r,(function(t){return e.selectionHandler.selectObject(e.body.nodes[t])}));var s=this.getPointer(t.center);this.selectionHandler.commitAndEmit(s,t),this.selectionHandler.generateClickEvent("dragEnd",t,this.getPointer(t.center),void 0,!0),this.body.emitter.emit("_requestRedraw")}else{var a=this.drag.selection;a&&a.length?(Cv(a).call(a,(function(t){t.node.options.fixed.x=t.xFixed,t.node.options.fixed.y=t.yFixed})),this.selectionHandler.generateClickEvent("dragEnd",t,this.getPointer(t.center)),this.body.emitter.emit("startSimulation")):(this.selectionHandler.generateClickEvent("dragEnd",t,this.getPointer(t.center),void 0,!0),this.body.emitter.emit("_requestRedraw"))}}},{key:"onPinch",value:function(t){var e=this.getPointer(t.center);this.drag.pinched=!0,void 0===this.pinch.scale&&(this.pinch.scale=1);var i=this.pinch.scale*t.scale;this.zoom(i,e)}},{key:"zoom",value:function(t,e){if(!0===this.options.zoomView){var i=this.body.view.scale;t<1e-5&&(t=1e-5),t>10&&(t=10);var o=void 0;void 0!==this.drag&&!0===this.drag.dragging&&(o=this.canvas.DOMtoCanvas(this.drag.pointer));var n=this.body.view.translation,r=t/i,s=(1-r)*e.x+n.x*r,a=(1-r)*e.y+n.y*r;if(this.body.view.scale=t,this.body.view.translation={x:s,y:a},null!=o){var h=this.canvas.canvasToDOM(o);this.drag.pointer.x=h.x,this.drag.pointer.y=h.y}this.body.emitter.emit("_requestRedraw"),i<t?this.body.emitter.emit("zoom",{direction:"+",scale:this.body.view.scale,pointer:e}):this.body.emitter.emit("zoom",{direction:"-",scale:this.body.view.scale,pointer:e})}}},{key:"onMouseWheel",value:function(t){if(!0===this.options.zoomView){if(0!==t.deltaY){var e=this.body.view.scale;e*=1+(t.deltaY<0?1:-1)*(.1*this.options.zoomSpeed);var i=this.getPointer({x:t.clientX,y:t.clientY});this.zoom(e,i)}t.preventDefault()}}},{key:"onMouseMove",value:function(t){var e=this,i=this.getPointer({x:t.clientX,y:t.clientY}),o=!1;void 0!==this.popup&&(!1===this.popup.hidden&&this._checkHidePopup(i),!1===this.popup.hidden&&(o=!0,this.popup.setPosition(i.x+3,i.y-5),this.popup.show())),this.options.keyboard.autoFocus&&!1===this.options.keyboard.bindToWindow&&!0===this.options.keyboard.enabled&&this.canvas.frame.focus(),!1===o&&(void 0!==this.popupTimer&&(clearInterval(this.popupTimer),this.popupTimer=void 0),this.drag.dragging||(this.popupTimer=Xm((function(){return e._checkShowPopup(i)}),this.options.tooltipDelay))),!0===this.options.hover&&this.selectionHandler.hoverObject(t,i)}},{key:"_checkShowPopup",value:function(t){var e=this.canvas._XconvertDOMtoCanvas(t.x),i=this.canvas._YconvertDOMtoCanvas(t.y),o={left:e,top:i,right:e,bottom:i},n=void 0===this.popupObj?void 0:this.popupObj.id,r=!1,s="node";if(void 0===this.popupObj){for(var a,h=this.body.nodeIndices,l=this.body.nodes,d=[],c=0;c<h.length;c++)!0===(a=l[h[c]]).isOverlappingWith(o)&&(r=!0,void 0!==a.getTitle()&&d.push(h[c]));d.length>0&&(this.popupObj=l[d[d.length-1]],r=!0)}if(void 0===this.popupObj&&!1===r){for(var u,f=this.body.edgeIndices,p=this.body.edges,v=[],g=0;g<f.length;g++)!0===(u=p[f[g]]).isOverlappingWith(o)&&!0===u.connected&&void 0!==u.getTitle()&&v.push(f[g]);v.length>0&&(this.popupObj=p[v[v.length-1]],s="edge")}void 0!==this.popupObj?this.popupObj.id!==n&&(void 0===this.popup&&(this.popup=new Mk(this.canvas.frame)),this.popup.popupTargetType=s,this.popup.popupTargetId=this.popupObj.id,this.popup.setPosition(t.x+3,t.y-5),this.popup.setText(this.popupObj.getTitle()),this.popup.show(),this.body.emitter.emit("showPopup",this.popupObj.id)):void 0!==this.popup&&(this.popup.hide(),this.body.emitter.emit("hidePopup"))}},{key:"_checkHidePopup",value:function(t){var e=this.selectionHandler._pointerToPositionObject(t),i=!1;if("node"===this.popup.popupTargetType){if(void 0!==this.body.nodes[this.popup.popupTargetId]&&!0===(i=this.body.nodes[this.popup.popupTargetId].isOverlappingWith(e))){var o=this.selectionHandler.getNodeAt(t);i=void 0!==o&&o.id===this.popup.popupTargetId}}else void 0===this.selectionHandler.getNodeAt(t)&&void 0!==this.body.edges[this.popup.popupTargetId]&&(i=this.body.edges[this.popup.popupTargetId].isOverlappingWith(e));!1===i&&(this.popupObj=void 0,this.popup.hide(),this.body.emitter.emit("hidePopup"))}}]),t}(),fF={},pF={get exports(){return fF},set exports(t){fF=t}},vF=y,gF=xE,yF=g_.getWeakData,mF=oE,bF=ii,wF=Y,xF=et,kF=tE,_F=Qt,EF=Xn.set,OF=Xn.getterFor,CF=vl.find,SF=vl.findIndex,TF=vF([].splice),MF=0,PF=function(t){return t.frozen||(t.frozen=new DF)},DF=function(){this.entries=[]},IF=function(t,e){return CF(t.entries,(function(t){return t[0]===e}))};DF.prototype={get:function(t){var e=IF(this,t);if(e)return e[1]},has:function(t){return!!IF(this,t)},set:function(t,e){var i=IF(this,t);i?i[1]=e:this.entries.push([t,e])},delete:function(t){var e=SF(this.entries,(function(e){return e[0]===t}));return~e&&TF(this.entries,e,1),!!~e}};var BF,NF={getConstructor:function(t,e,i,o){var n=t((function(t,n){mF(t,r),EF(t,{type:e,id:MF++,frozen:void 0}),wF(n)||kF(n,t[o],{that:t,AS_ENTRIES:i})})),r=n.prototype,s=OF(e),a=function(t,e,i){var o=s(t),n=yF(bF(e),!0);return!0===n?PF(o).set(e,i):n[o.id]=i,t};return gF(r,{delete:function(t){var e=s(this);if(!xF(t))return!1;var i=yF(t);return!0===i?PF(e).delete(t):i&&_F(i,e.id)&&delete i[e.id]},has:function(t){var e=s(this);if(!xF(t))return!1;var i=yF(t);return!0===i?PF(e).has(t):i&&_F(i,e.id)}}),gF(r,i?{get:function(t){var e=s(this);if(xF(t)){var i=yF(t);return!0===i?PF(e).get(t):i?i[e.id]:void 0}},set:function(t,e){return a(this,t,e)}}:{add:function(t){return a(this,t,!0)}}),n}},zF=O_,FF=r,AF=y,jF=xE,RF=g_,LF=bE,HF=NF,WF=et,qF=Xn.enforce,VF=s,UF=Pn,YF=Object,XF=Array.isArray,GF=YF.isExtensible,KF=YF.isFrozen,$F=YF.isSealed,ZF=YF.freeze,QF=YF.seal,JF={},tA={},eA=!FF.ActiveXObject&&"ActiveXObject"in FF,iA=function(t){return function(){return t(this,arguments.length?arguments[0]:void 0)}},oA=LF("WeakMap",iA,HF),nA=oA.prototype,rA=AF(nA.set);if(UF)if(eA){BF=HF.getConstructor(iA,"WeakMap",!0),RF.enable();var sA=AF(nA.delete),aA=AF(nA.has),hA=AF(nA.get);jF(nA,{delete:function(t){if(WF(t)&&!GF(t)){var e=qF(this);return e.frozen||(e.frozen=new BF),sA(this,t)||e.frozen.delete(t)}return sA(this,t)},has:function(t){if(WF(t)&&!GF(t)){var e=qF(this);return e.frozen||(e.frozen=new BF),aA(this,t)||e.frozen.has(t)}return aA(this,t)},get:function(t){if(WF(t)&&!GF(t)){var e=qF(this);return e.frozen||(e.frozen=new BF),aA(this,t)?hA(this,t):e.frozen.get(t)}return hA(this,t)},set:function(t,e){if(WF(t)&&!GF(t)){var i=qF(this);i.frozen||(i.frozen=new BF),aA(this,t)?rA(this,t,e):i.frozen.set(t,e)}else rA(this,t,e);return this}})}else zF&&VF((function(){var t=ZF([]);return rA(new oA,t,1),!KF(t)}))&&jF(nA,{set:function(t,e){var i;return XF(t)&&(KF(t)?i=JF:$F(t)&&(i=tA)),rA(this,t,e),i==JF&&ZF(t),i==tA&&QF(t),this}});var lA=it.WeakMap;pF.exports=lA;var dA,cA,uA,fA,pA,vA=e(fF);function gA(t,e,i,o){if("a"===i&&!o)throw new TypeError("Private accessor was defined without a getter");if("function"==typeof e?t!==e||!o:!e.has(t))throw new TypeError("Cannot read private member from an object whose class did not declare it");return"m"===i?o:"a"===i?o.call(t):o?o.value:e.get(t)}function yA(t,e,i,o,n){if("m"===o)throw new TypeError("Private method is not writable");if("a"===o&&!n)throw new TypeError("Private accessor was defined without a setter");if("function"==typeof e?t!==e||!n:!e.has(t))throw new TypeError("Cannot write private member to an object whose class did not declare it");return"a"===o?n.call(t,i):n?n.value=i:e.set(t,i),i}function mA(t,e){var i=void 0!==Op&&xh(t)||t["@@iterator"];if(!i){if(Wp(t)||(i=function(t,e){var i;if(!t)return;if("string"==typeof t)return bA(t,e);var o=Fp(i=Object.prototype.toString.call(t)).call(i,8,-1);"Object"===o&&t.constructor&&(o=t.constructor.name);if("Map"===o||"Set"===o)return Za(t);if("Arguments"===o||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(o))return bA(t,e)}(t))||e&&t&&"number"==typeof t.length){i&&(t=i);var o=0,n=function(){};return{s:n,n:function(){return o>=t.length?{done:!0}:{done:!1,value:t[o++]}},e:function(t){throw t},f:n}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var r,s=!0,a=!1;return{s:function(){i=i.call(t)},n:function(){var t=i.next();return s=t.done,t},e:function(t){a=!0,r=t},f:function(){try{s||null==i.return||i.return()}finally{if(a)throw r}}}}function bA(t,e){(null==e||e>t.length)&&(e=t.length);for(var i=0,o=new Array(e);i<e;i++)o[i]=t[i];return o}function wA(t,e){var i,o=new YP,n=mA(e);try{for(n.s();!(i=n.n()).done;){var r=i.value;t.has(r)||o.add(r)}}catch(t){n.e(t)}finally{n.f()}return o}var xA=function(){function t(){pu(this,t),dA.set(this,new YP),cA.set(this,new YP)}return Nf(t,[{key:"size",get:function(){return gA(this,cA,"f").size}},{key:"add",value:function(){for(var t=arguments.length,e=new Array(t),i=0;i<t;i++)e[i]=arguments[i];for(var o=0,n=e;o<n.length;o++){var r=n[o];gA(this,cA,"f").add(r)}}},{key:"delete",value:function(){for(var t=arguments.length,e=new Array(t),i=0;i<t;i++)e[i]=arguments[i];for(var o=0,n=e;o<n.length;o++){var r=n[o];gA(this,cA,"f").delete(r)}}},{key:"clear",value:function(){gA(this,cA,"f").clear()}},{key:"getSelection",value:function(){return _p(gA(this,cA,"f"))}},{key:"getChanges",value:function(){return{added:_p(wA(gA(this,dA,"f"),gA(this,cA,"f"))),deleted:_p(wA(gA(this,cA,"f"),gA(this,dA,"f"))),previous:_p(new YP(gA(this,dA,"f"))),current:_p(new YP(gA(this,cA,"f")))}}},{key:"commit",value:function(){var t=this.getChanges();yA(this,dA,gA(this,cA,"f"),"f"),yA(this,cA,new YP(gA(this,dA,"f")),"f");var e,i=mA(t.added);try{for(i.s();!(e=i.n()).done;){e.value.select()}}catch(t){i.e(t)}finally{i.f()}var o,n=mA(t.deleted);try{for(n.s();!(o=n.n()).done;){o.value.unselect()}}catch(t){n.e(t)}finally{n.f()}return t}}]),t}();dA=new vA,cA=new vA;var kA=function(){function t(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:function(){};pu(this,t),uA.set(this,new xA),fA.set(this,new xA),pA.set(this,void 0),yA(this,pA,e,"f")}return Nf(t,[{key:"sizeNodes",get:function(){return gA(this,uA,"f").size}},{key:"sizeEdges",get:function(){return gA(this,fA,"f").size}},{key:"getNodes",value:function(){return gA(this,uA,"f").getSelection()}},{key:"getEdges",value:function(){return gA(this,fA,"f").getSelection()}},{key:"addNodes",value:function(){var t;(t=gA(this,uA,"f")).add.apply(t,arguments)}},{key:"addEdges",value:function(){var t;(t=gA(this,fA,"f")).add.apply(t,arguments)}},{key:"deleteNodes",value:function(t){gA(this,uA,"f").delete(t)}},{key:"deleteEdges",value:function(t){gA(this,fA,"f").delete(t)}},{key:"clear",value:function(){gA(this,uA,"f").clear(),gA(this,fA,"f").clear()}},{key:"commit",value:function(){for(var t,e,i={nodes:gA(this,uA,"f").commit(),edges:gA(this,fA,"f").commit()},o=arguments.length,n=new Array(o),r=0;r<o;r++)n[r]=arguments[r];return(t=gA(this,pA,"f")).call.apply(t,Np(e=[this,i]).call(e,n)),i}}]),t}();function _A(t,e){var i=void 0!==Op&&xh(t)||t["@@iterator"];if(!i){if(Wp(t)||(i=function(t,e){var i;if(!t)return;if("string"==typeof t)return EA(t,e);var o=Fp(i=Object.prototype.toString.call(t)).call(i,8,-1);"Object"===o&&t.constructor&&(o=t.constructor.name);if("Map"===o||"Set"===o)return Za(t);if("Arguments"===o||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(o))return EA(t,e)}(t))||e&&t&&"number"==typeof t.length){i&&(t=i);var o=0,n=function(){};return{s:n,n:function(){return o>=t.length?{done:!0}:{done:!1,value:t[o++]}},e:function(t){throw t},f:n}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var r,s=!0,a=!1;return{s:function(){i=i.call(t)},n:function(){var t=i.next();return s=t.done,t},e:function(t){a=!0,r=t},f:function(){try{s||null==i.return||i.return()}finally{if(a)throw r}}}}function EA(t,e){(null==e||e>t.length)&&(e=t.length);for(var i=0,o=new Array(e);i<e;i++)o[i]=t[i];return o}uA=new vA,fA=new vA,pA=new vA;var OA=function(){function t(e,i){var o=this;pu(this,t),this.body=e,this.canvas=i,this._selectionAccumulator=new kA,this.hoverObj={nodes:{},edges:{}},this.options={},this.defaultOptions={multiselect:!1,selectable:!0,selectConnectedEdges:!0,hoverConnectedEdges:!0},wo(this.options,this.defaultOptions),this.body.emitter.on("_dataChanged",(function(){o.updateSelection()}))}return Nf(t,[{key:"setOptions",value:function(t){if(void 0!==t){Wx(["multiselect","hoverConnectedEdges","selectable","selectConnectedEdges"],this.options,t)}}},{key:"selectOnPoint",value:function(t){var e=!1;if(!0===this.options.selectable){var i=this.getNodeAt(t)||this.getEdgeAt(t);this.unselectAll(),void 0!==i&&(e=this.selectObject(i)),this.body.emitter.emit("_requestRedraw")}return e}},{key:"selectAdditionalOnPoint",value:function(t){var e=!1;if(!0===this.options.selectable){var i=this.getNodeAt(t)||this.getEdgeAt(t);void 0!==i&&(e=!0,!0===i.isSelected()?this.deselectObject(i):this.selectObject(i),this.body.emitter.emit("_requestRedraw"))}return e}},{key:"_initBaseEvent",value:function(t,e){var i={};return i.pointer={DOM:{x:e.x,y:e.y},canvas:this.canvas.DOMtoCanvas(e)},i.event=t,i}},{key:"generateClickEvent",value:function(t,e,i,o){var n=arguments.length>4&&void 0!==arguments[4]&&arguments[4],r=this._initBaseEvent(e,i);if(!0===n)r.nodes=[],r.edges=[];else{var s=this.getSelection();r.nodes=s.nodes,r.edges=s.edges}void 0!==o&&(r.previousSelection=o),"click"==t&&(r.items=this.getClickedItems(i)),void 0!==e.controlEdge&&(r.controlEdge=e.controlEdge),this.body.emitter.emit(t,r)}},{key:"selectObject",value:function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:this.options.selectConnectedEdges;if(void 0!==t){if(t instanceof SN){var i;if(!0===e)(i=this._selectionAccumulator).addEdges.apply(i,_p(t.edges));this._selectionAccumulator.addNodes(t)}else this._selectionAccumulator.addEdges(t);return!0}return!1}},{key:"deselectObject",value:function(t){!0===t.isSelected()&&(t.selected=!1,this._removeFromSelection(t))}},{key:"_getAllNodesOverlappingWith",value:function(t){for(var e=[],i=this.body.nodes,o=0;o<this.body.nodeIndices.length;o++){var n=this.body.nodeIndices[o];i[n].isOverlappingWith(t)&&e.push(n)}return e}},{key:"_pointerToPositionObject",value:function(t){var e=this.canvas.DOMtoCanvas(t);return{left:e.x-1,top:e.y+1,right:e.x+1,bottom:e.y-1}}},{key:"getNodeAt",value:function(t){var e=!(arguments.length>1&&void 0!==arguments[1])||arguments[1],i=this._pointerToPositionObject(t),o=this._getAllNodesOverlappingWith(i);return o.length>0?!0===e?this.body.nodes[o[o.length-1]]:o[o.length-1]:void 0}},{key:"_getEdgesOverlappingWith",value:function(t,e){for(var i=this.body.edges,o=0;o<this.body.edgeIndices.length;o++){var n=this.body.edgeIndices[o];i[n].isOverlappingWith(t)&&e.push(n)}}},{key:"_getAllEdgesOverlappingWith",value:function(t){var e=[];return this._getEdgesOverlappingWith(t,e),e}},{key:"getEdgeAt",value:function(t){for(var e=!(arguments.length>1&&void 0!==arguments[1])||arguments[1],i=this.canvas.DOMtoCanvas(t),o=10,n=null,r=this.body.edges,s=0;s<this.body.edgeIndices.length;s++){var a=this.body.edgeIndices[s],h=r[a];if(h.connected){var l=h.from.x,d=h.from.y,c=h.to.x,u=h.to.y,f=h.edgeType.getDistanceToEdge(l,d,c,u,i.x,i.y);f<o&&(n=a,o=f)}}return null!==n?!0===e?this.body.edges[n]:n:void 0}},{key:"_addToHover",value:function(t){t instanceof SN?this.hoverObj.nodes[t.id]=t:this.hoverObj.edges[t.id]=t}},{key:"_removeFromSelection",value:function(t){var e;t instanceof SN?(this._selectionAccumulator.deleteNodes(t),(e=this._selectionAccumulator).deleteEdges.apply(e,_p(t.edges))):this._selectionAccumulator.deleteEdges(t)}},{key:"unselectAll",value:function(){this._selectionAccumulator.clear()}},{key:"getSelectedNodeCount",value:function(){return this._selectionAccumulator.sizeNodes}},{key:"getSelectedEdgeCount",value:function(){return this._selectionAccumulator.sizeEdges}},{key:"_hoverConnectedEdges",value:function(t){for(var e=0;e<t.edges.length;e++){var i=t.edges[e];i.hover=!0,this._addToHover(i)}}},{key:"emitBlurEvent",value:function(t,e,i){var o=this._initBaseEvent(t,e);!0===i.hover&&(i.hover=!1,i instanceof SN?(o.node=i.id,this.body.emitter.emit("blurNode",o)):(o.edge=i.id,this.body.emitter.emit("blurEdge",o)))}},{key:"emitHoverEvent",value:function(t,e,i){var o=this._initBaseEvent(t,e),n=!1;return!1===i.hover&&(i.hover=!0,this._addToHover(i),n=!0,i instanceof SN?(o.node=i.id,this.body.emitter.emit("hoverNode",o)):(o.edge=i.id,this.body.emitter.emit("hoverEdge",o))),n}},{key:"hoverObject",value:function(t,e){var i=this.getNodeAt(e);void 0===i&&(i=this.getEdgeAt(e));var o=!1;for(var n in this.hoverObj.nodes)Object.prototype.hasOwnProperty.call(this.hoverObj.nodes,n)&&(void 0===i||i instanceof SN&&i.id!=n||i instanceof Fz)&&(this.emitBlurEvent(t,e,this.hoverObj.nodes[n]),delete this.hoverObj.nodes[n],o=!0);for(var r in this.hoverObj.edges)Object.prototype.hasOwnProperty.call(this.hoverObj.edges,r)&&(!0===o?(this.hoverObj.edges[r].hover=!1,delete this.hoverObj.edges[r]):(void 0===i||i instanceof Fz&&i.id!=r||i instanceof SN&&!i.hover)&&(this.emitBlurEvent(t,e,this.hoverObj.edges[r]),delete this.hoverObj.edges[r],o=!0));if(void 0!==i){var s=nv(this.hoverObj.edges).length,a=nv(this.hoverObj.nodes).length;(o||i instanceof Fz&&0===s&&0===a||i instanceof SN&&0===s&&0===a)&&(o=this.emitHoverEvent(t,e,i)),i instanceof SN&&!0===this.options.hoverConnectedEdges&&this._hoverConnectedEdges(i)}!0===o&&this.body.emitter.emit("_requestRedraw")}},{key:"commitWithoutEmitting",value:function(){this._selectionAccumulator.commit()}},{key:"commitAndEmit",value:function(t,e){var i=!1,o=this._selectionAccumulator.commit(),n={nodes:o.nodes.previous,edges:o.edges.previous};o.edges.deleted.length>0&&(this.generateClickEvent("deselectEdge",e,t,n),i=!0),o.nodes.deleted.length>0&&(this.generateClickEvent("deselectNode",e,t,n),i=!0),o.nodes.added.length>0&&(this.generateClickEvent("selectNode",e,t),i=!0),o.edges.added.length>0&&(this.generateClickEvent("selectEdge",e,t),i=!0),!0===i&&this.generateClickEvent("select",e,t)}},{key:"getSelection",value:function(){return{nodes:this.getSelectedNodeIds(),edges:this.getSelectedEdgeIds()}}},{key:"getSelectedNodes",value:function(){return this._selectionAccumulator.getNodes()}},{key:"getSelectedEdges",value:function(){return this._selectionAccumulator.getEdges()}},{key:"getSelectedNodeIds",value:function(){var t;return Qp(t=this._selectionAccumulator.getNodes()).call(t,(function(t){return t.id}))}},{key:"getSelectedEdgeIds",value:function(){var t;return Qp(t=this._selectionAccumulator.getEdges()).call(t,(function(t){return t.id}))}},{key:"setSelection",value:function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{};if(!t||!t.nodes&&!t.edges)throw new TypeError("Selection must be an object with nodes and/or edges properties");if((e.unselectAll||void 0===e.unselectAll)&&this.unselectAll(),t.nodes){var i,o=_A(t.nodes);try{for(o.s();!(i=o.n()).done;){var n=i.value,r=this.body.nodes[n];if(!r)throw new RangeError('Node with id "'+n+'" not found');this.selectObject(r,e.highlightEdges)}}catch(t){o.e(t)}finally{o.f()}}if(t.edges){var s,a=_A(t.edges);try{for(a.s();!(s=a.n()).done;){var h=s.value,l=this.body.edges[h];if(!l)throw new RangeError('Edge with id "'+h+'" not found');this.selectObject(l)}}catch(t){a.e(t)}finally{a.f()}}this.body.emitter.emit("_requestRedraw"),this._selectionAccumulator.commit()}},{key:"selectNodes",value:function(t){var e=!(arguments.length>1&&void 0!==arguments[1])||arguments[1];if(!t||void 0===t.length)throw"Selection must be an array with ids";this.setSelection({nodes:t},{highlightEdges:e})}},{key:"selectEdges",value:function(t){if(!t||void 0===t.length)throw"Selection must be an array with ids";this.setSelection({edges:t})}},{key:"updateSelection",value:function(){for(var t in this._selectionAccumulator.getNodes())Object.prototype.hasOwnProperty.call(this.body.nodes,t.id)||this._selectionAccumulator.deleteNodes(t);for(var e in this._selectionAccumulator.getEdges())Object.prototype.hasOwnProperty.call(this.body.edges,e.id)||this._selectionAccumulator.deleteEdges(e)}},{key:"getClickedItems",value:function(t){for(var e=this.canvas.DOMtoCanvas(t),i=[],o=this.body.nodeIndices,n=this.body.nodes,r=o.length-1;r>=0;r--){var s=n[o[r]].getItemsOnPoint(e);i.push.apply(i,s)}for(var a=this.body.edgeIndices,h=this.body.edges,l=a.length-1;l>=0;l--){var d=h[a[l]].getItemsOnPoint(e);i.push.apply(i,d)}return i}}]),t}(),CA={},SA={get exports(){return CA},set exports(t){CA=t}},TA={};!function(t){function e(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")}t.__esModule=!0,t.sort=v;var i=32,o=7,n=256,r=[1,10,100,1e3,1e4,1e5,1e6,1e7,1e8,1e9];function s(t){return t<1e5?t<100?t<10?0:1:t<1e4?t<1e3?2:3:4:t<1e7?t<1e6?5:6:t<1e9?t<1e8?7:8:9}function a(t,e){if(t===e)return 0;if(~~t===t&&~~e===e){if(0===t||0===e)return t<e?-1:1;if(t<0||e<0){if(e>=0)return-1;if(t>=0)return 1;t=-t,e=-e}var i=s(t),o=s(e),n=0;return i<o?(t*=r[o-i-1],e/=10,n=-1):i>o&&(e*=r[i-o-1],t/=10,n=1),t===e?n:t<e?-1:1}var a=String(t),h=String(e);return a===h?0:a<h?-1:1}function h(t){for(var e=0;t>=i;)e|=1&t,t>>=1;return t+e}function l(t,e,i,o){var n=e+1;if(n===i)return 1;if(o(t[n++],t[e])<0){for(;n<i&&o(t[n],t[n-1])<0;)n++;d(t,e,n)}else for(;n<i&&o(t[n],t[n-1])>=0;)n++;return n-e}function d(t,e,i){for(i--;e<i;){var o=t[e];t[e++]=t[i],t[i--]=o}}function c(t,e,i,o,n){for(o===e&&o++;o<i;o++){for(var r=t[o],s=e,a=o;s<a;){var h=s+a>>>1;n(r,t[h])<0?a=h:s=h+1}var l=o-s;switch(l){case 3:t[s+3]=t[s+2];case 2:t[s+2]=t[s+1];case 1:t[s+1]=t[s];break;default:for(;l>0;)t[s+l]=t[s+l-1],l--}t[s]=r}}function u(t,e,i,o,n,r){var s=0,a=0,h=1;if(r(t,e[i+n])>0){for(a=o-n;h<a&&r(t,e[i+n+h])>0;)s=h,(h=1+(h<<1))<=0&&(h=a);h>a&&(h=a),s+=n,h+=n}else{for(a=n+1;h<a&&r(t,e[i+n-h])<=0;)s=h,(h=1+(h<<1))<=0&&(h=a);h>a&&(h=a);var l=s;s=n-h,h=n-l}for(s++;s<h;){var d=s+(h-s>>>1);r(t,e[i+d])>0?s=d+1:h=d}return h}function f(t,e,i,o,n,r){var s=0,a=0,h=1;if(r(t,e[i+n])<0){for(a=n+1;h<a&&r(t,e[i+n-h])<0;)s=h,(h=1+(h<<1))<=0&&(h=a);h>a&&(h=a);var l=s;s=n-h,h=n-l}else{for(a=o-n;h<a&&r(t,e[i+n+h])>=0;)s=h,(h=1+(h<<1))<=0&&(h=a);h>a&&(h=a),s+=n,h+=n}for(s++;s<h;){var d=s+(h-s>>>1);r(t,e[i+d])<0?h=d:s=d+1}return h}var p=function(){function t(i,r){e(this,t),this.array=null,this.compare=null,this.minGallop=o,this.length=0,this.tmpStorageLength=n,this.stackLength=0,this.runStart=null,this.runLength=null,this.stackSize=0,this.array=i,this.compare=r,this.length=i.length,this.length<2*n&&(this.tmpStorageLength=this.length>>>1),this.tmp=new Array(this.tmpStorageLength),this.stackLength=this.length<120?5:this.length<1542?10:this.length<119151?19:40,this.runStart=new Array(this.stackLength),this.runLength=new Array(this.stackLength)}return t.prototype.pushRun=function(t,e){this.runStart[this.stackSize]=t,this.runLength[this.stackSize]=e,this.stackSize+=1},t.prototype.mergeRuns=function(){for(;this.stackSize>1;){var t=this.stackSize-2;if(t>=1&&this.runLength[t-1]<=this.runLength[t]+this.runLength[t+1]||t>=2&&this.runLength[t-2]<=this.runLength[t]+this.runLength[t-1])this.runLength[t-1]<this.runLength[t+1]&&t--;else if(this.runLength[t]>this.runLength[t+1])break;this.mergeAt(t)}},t.prototype.forceMergeRuns=function(){for(;this.stackSize>1;){var t=this.stackSize-2;t>0&&this.runLength[t-1]<this.runLength[t+1]&&t--,this.mergeAt(t)}},t.prototype.mergeAt=function(t){var e=this.compare,i=this.array,o=this.runStart[t],n=this.runLength[t],r=this.runStart[t+1],s=this.runLength[t+1];this.runLength[t]=n+s,t===this.stackSize-3&&(this.runStart[t+1]=this.runStart[t+2],this.runLength[t+1]=this.runLength[t+2]),this.stackSize--;var a=f(i[r],i,o,n,0,e);o+=a,0!=(n-=a)&&0!==(s=u(i[o+n-1],i,r,s,s-1,e))&&(n<=s?this.mergeLow(o,n,r,s):this.mergeHigh(o,n,r,s))},t.prototype.mergeLow=function(t,e,i,n){var r=this.compare,s=this.array,a=this.tmp,h=0;for(h=0;h<e;h++)a[h]=s[t+h];var l=0,d=i,c=t;if(s[c++]=s[d++],0!=--n)if(1!==e){for(var p=this.minGallop;;){var v=0,g=0,y=!1;do{if(r(s[d],a[l])<0){if(s[c++]=s[d++],g++,v=0,0==--n){y=!0;break}}else if(s[c++]=a[l++],v++,g=0,1==--e){y=!0;break}}while((v|g)<p);if(y)break;do{if(0!==(v=f(s[d],a,l,e,0,r))){for(h=0;h<v;h++)s[c+h]=a[l+h];if(c+=v,l+=v,(e-=v)<=1){y=!0;break}}if(s[c++]=s[d++],0==--n){y=!0;break}if(0!==(g=u(a[l],s,d,n,0,r))){for(h=0;h<g;h++)s[c+h]=s[d+h];if(c+=g,d+=g,0==(n-=g)){y=!0;break}}if(s[c++]=a[l++],1==--e){y=!0;break}p--}while(v>=o||g>=o);if(y)break;p<0&&(p=0),p+=2}if(this.minGallop=p,p<1&&(this.minGallop=1),1===e){for(h=0;h<n;h++)s[c+h]=s[d+h];s[c+n]=a[l]}else{if(0===e)throw new Error("mergeLow preconditions were not respected");for(h=0;h<e;h++)s[c+h]=a[l+h]}}else{for(h=0;h<n;h++)s[c+h]=s[d+h];s[c+n]=a[l]}else for(h=0;h<e;h++)s[c+h]=a[l+h]},t.prototype.mergeHigh=function(t,e,i,n){var r=this.compare,s=this.array,a=this.tmp,h=0;for(h=0;h<n;h++)a[h]=s[i+h];var l=t+e-1,d=n-1,c=i+n-1,p=0,v=0;if(s[c--]=s[l--],0!=--e)if(1!==n){for(var g=this.minGallop;;){var y=0,m=0,b=!1;do{if(r(a[d],s[l])<0){if(s[c--]=s[l--],y++,m=0,0==--e){b=!0;break}}else if(s[c--]=a[d--],m++,y=0,1==--n){b=!0;break}}while((y|m)<g);if(b)break;do{if(0!=(y=e-f(a[d],s,t,e,e-1,r))){for(e-=y,v=1+(c-=y),p=1+(l-=y),h=y-1;h>=0;h--)s[v+h]=s[p+h];if(0===e){b=!0;break}}if(s[c--]=a[d--],1==--n){b=!0;break}if(0!=(m=n-u(s[l],a,0,n,n-1,r))){for(n-=m,v=1+(c-=m),p=1+(d-=m),h=0;h<m;h++)s[v+h]=a[p+h];if(n<=1){b=!0;break}}if(s[c--]=s[l--],0==--e){b=!0;break}g--}while(y>=o||m>=o);if(b)break;g<0&&(g=0),g+=2}if(this.minGallop=g,g<1&&(this.minGallop=1),1===n){for(v=1+(c-=e),p=1+(l-=e),h=e-1;h>=0;h--)s[v+h]=s[p+h];s[c]=a[d]}else{if(0===n)throw new Error("mergeHigh preconditions were not respected");for(p=c-(n-1),h=0;h<n;h++)s[p+h]=a[h]}}else{for(v=1+(c-=e),p=1+(l-=e),h=e-1;h>=0;h--)s[v+h]=s[p+h];s[c]=a[d]}else for(p=c-(n-1),h=0;h<n;h++)s[p+h]=a[h]},t}();function v(t,e,o,n){if(!Array.isArray(t))throw new TypeError("Can only sort arrays");e?"function"!=typeof e&&(n=o,o=e,e=a):e=a,o||(o=0),n||(n=t.length);var r=n-o;if(!(r<2)){var s=0;if(r<i)c(t,o,n,o+(s=l(t,o,n,e)),e);else{var d=new p(t,e),u=h(r);do{if((s=l(t,o,n,e))<u){var f=r;f>u&&(f=u),c(t,o,o+f,o+s,e),s=f}d.pushRun(o,s),d.mergeRuns(),r-=s,o+=s}while(0!==r);d.forceMergeRuns()}}}}(TA),SA.exports=TA;var MA=e(CA);function PA(t){var e=function(){if("undefined"==typeof Reflect||!AI)return!1;if(AI.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(AI(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,o=FO(t);if(e){var n=FO(this).constructor;i=AI(o,arguments,n)}else i=o.apply(this,arguments);return PO(this,i)}}var DA=function(){function t(){pu(this,t)}return Nf(t,[{key:"abstract",value:function(){throw new Error("Can't instantiate abstract class!")}},{key:"fake_use",value:function(){}},{key:"curveType",value:function(){return this.abstract()}},{key:"getPosition",value:function(t){return this.fake_use(t),this.abstract()}},{key:"setPosition",value:function(t,e){var i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:void 0;this.fake_use(t,e,i),this.abstract()}},{key:"getTreeSize",value:function(t){return this.fake_use(t),this.abstract()}},{key:"sort",value:function(t){this.fake_use(t),this.abstract()}},{key:"fix",value:function(t,e){this.fake_use(t,e),this.abstract()}},{key:"shift",value:function(t,e){this.fake_use(t,e),this.abstract()}}]),t}(),IA=function(t){MO(i,DA);var e=PA(i);function i(t){var o;return pu(this,i),(o=e.call(this)).layout=t,o}return Nf(i,[{key:"curveType",value:function(){return"horizontal"}},{key:"getPosition",value:function(t){return t.x}},{key:"setPosition",value:function(t,e){var i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:void 0;void 0!==i&&this.layout.hierarchical.addToOrdering(t,i),t.x=e}},{key:"getTreeSize",value:function(t){var e=this.layout.hierarchical.getTreeSize(this.layout.body.nodes,t);return{min:e.min_x,max:e.max_x}}},{key:"sort",value:function(t){CA.sort(t,(function(t,e){return t.x-e.x}))}},{key:"fix",value:function(t,e){t.y=this.layout.options.hierarchical.levelSeparation*e,t.options.fixed.y=!0}},{key:"shift",value:function(t,e){this.layout.body.nodes[t].x+=e}}]),i}(),BA=function(t){MO(i,DA);var e=PA(i);function i(t){var o;return pu(this,i),(o=e.call(this)).layout=t,o}return Nf(i,[{key:"curveType",value:function(){return"vertical"}},{key:"getPosition",value:function(t){return t.y}},{key:"setPosition",value:function(t,e){var i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:void 0;void 0!==i&&this.layout.hierarchical.addToOrdering(t,i),t.y=e}},{key:"getTreeSize",value:function(t){var e=this.layout.hierarchical.getTreeSize(this.layout.body.nodes,t);return{min:e.min_y,max:e.max_y}}},{key:"sort",value:function(t){CA.sort(t,(function(t,e){return t.y-e.y}))}},{key:"fix",value:function(t,e){t.x=this.layout.options.hierarchical.levelSeparation*e,t.options.fixed.x=!0}},{key:"shift",value:function(t,e){this.layout.body.nodes[t].y+=e}}]),i}(),NA={},zA={get exports(){return NA},set exports(t){NA=t}},FA=vl.every;Ti({target:"Array",proto:!0,forced:!vv("every")},{every:function(t){return FA(this,t,arguments.length>1?arguments[1]:void 0)}});var AA=jo("Array").every,jA=ht,RA=AA,LA=Array.prototype,HA=function(t){var e=t.every;return t===LA||jA(LA,t)&&e===LA.every?RA:e},WA=HA;zA.exports=WA;var qA=e(NA);function VA(t,e){var i=void 0!==Op&&xh(t)||t["@@iterator"];if(!i){if(Wp(t)||(i=function(t,e){var i;if(!t)return;if("string"==typeof t)return UA(t,e);var o=Fp(i=Object.prototype.toString.call(t)).call(i,8,-1);"Object"===o&&t.constructor&&(o=t.constructor.name);if("Map"===o||"Set"===o)return Za(t);if("Arguments"===o||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(o))return UA(t,e)}(t))||e&&t&&"number"==typeof t.length){i&&(t=i);var o=0,n=function(){};return{s:n,n:function(){return o>=t.length?{done:!0}:{done:!1,value:t[o++]}},e:function(t){throw t},f:n}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var r,s=!0,a=!1;return{s:function(){i=i.call(t)},n:function(){var t=i.next();return s=t.done,t},e:function(t){a=!0,r=t},f:function(){try{s||null==i.return||i.return()}finally{if(a)throw r}}}}function UA(t,e){(null==e||e>t.length)&&(e=t.length);for(var i=0,o=new Array(e);i<e;i++)o[i]=t[i];return o}function YA(t,e){var i=new YP;return Cv(t).call(t,(function(t){var e;Cv(e=t.edges).call(e,(function(t){t.connected&&i.add(t)}))})),Cv(i).call(i,(function(t){var i=t.from.id,o=t.to.id;null==e[i]&&(e[i]=0),(null==e[o]||e[i]>=e[o])&&(e[o]=e[i]+1)})),e}function XA(t,e,i,o){var n,r,s=mm(null),a=_P(n=_p(hI(o).call(o))).call(n,(function(t,e){return t+1+e.edges.length}),0),h=i+"Id",l="to"===i?1:-1,d=VA(o);try{var c=function(){var n=kp(r.value,2),d=n[0],c=n[1];if(!o.has(d)||!t(c))return"continue";s[d]=0;for(var u,f=[c],p=0,v=function(){var t,n;if(!o.has(d))return"continue";var r=s[u.id]+l;if(Cv(t=oy(n=u.edges).call(n,(function(t){return t.connected&&t.to!==t.from&&t[i]!==u&&o.has(t.toId)&&o.has(t.fromId)}))).call(t,(function(t){var o=t[h],n=s[o];(null==n||e(r,n))&&(s[o]=r,f.push(t[i]))})),p>a)return{v:{v:YA(o,s)}};++p};u=f.pop();){var g=v();if("continue"!==g&&"object"===Of(g))return g.v}};for(d.s();!(r=d.n()).done;){var u=c();if("continue"!==u&&"object"===Of(u))return u.v}}catch(t){d.e(t)}finally{d.f()}return s}var GA=function(){function t(){pu(this,t),this.childrenReference={},this.parentReference={},this.trees={},this.distributionOrdering={},this.levels={},this.distributionIndex={},this.isTree=!1,this.treeIndex=-1}return Nf(t,[{key:"addRelation",value:function(t,e){void 0===this.childrenReference[t]&&(this.childrenReference[t]=[]),this.childrenReference[t].push(e),void 0===this.parentReference[e]&&(this.parentReference[e]=[]),this.parentReference[e].push(t)}},{key:"checkIfTree",value:function(){for(var t in this.parentReference)if(this.parentReference[t].length>1)return void(this.isTree=!1);this.isTree=!0}},{key:"numTrees",value:function(){return this.treeIndex+1}},{key:"setTreeIndex",value:function(t,e){void 0!==e&&void 0===this.trees[t.id]&&(this.trees[t.id]=e,this.treeIndex=Math.max(e,this.treeIndex))}},{key:"ensureLevel",value:function(t){void 0===this.levels[t]&&(this.levels[t]=0)}},{key:"getMaxLevel",value:function(t){var e=this,i={};return function t(o){if(void 0!==i[o])return i[o];var n=e.levels[o];if(e.childrenReference[o]){var r=e.childrenReference[o];if(r.length>0)for(var s=0;s<r.length;s++)n=Math.max(n,t(r[s]))}return i[o]=n,n}(t)}},{key:"levelDownstream",value:function(t,e){void 0===this.levels[e.id]&&(void 0===this.levels[t.id]&&(this.levels[t.id]=0),this.levels[e.id]=this.levels[t.id]+1)}},{key:"setMinLevelToZero",value:function(t){var e=1e9;for(var i in t)Object.prototype.hasOwnProperty.call(t,i)&&void 0!==this.levels[i]&&(e=Math.min(this.levels[i],e));for(var o in t)Object.prototype.hasOwnProperty.call(t,o)&&void 0!==this.levels[o]&&(this.levels[o]-=e)}},{key:"getTreeSize",value:function(t,e){var i=1e9,o=-1e9,n=1e9,r=-1e9;for(var s in this.trees)if(Object.prototype.hasOwnProperty.call(this.trees,s)&&this.trees[s]===e){var a=t[s];i=Math.min(a.x,i),o=Math.max(a.x,o),n=Math.min(a.y,n),r=Math.max(a.y,r)}return{min_x:i,max_x:o,min_y:n,max_y:r}}},{key:"hasSameParent",value:function(t,e){var i=this.parentReference[t.id],o=this.parentReference[e.id];if(void 0===i||void 0===o)return!1;for(var n=0;n<i.length;n++)for(var r=0;r<o.length;r++)if(i[n]==o[r])return!0;return!1}},{key:"inSameSubNetwork",value:function(t,e){return this.trees[t.id]===this.trees[e.id]}},{key:"getLevels",value:function(){return nv(this.distributionOrdering)}},{key:"addToOrdering",value:function(t,e){void 0===this.distributionOrdering[e]&&(this.distributionOrdering[e]=[]);var i=!1,o=this.distributionOrdering[e];for(var n in o)if(o[n]===t){i=!0;break}i||(this.distributionOrdering[e].push(t),this.distributionIndex[t.id]=this.distributionOrdering[e].length-1)}}]),t}(),KA=function(){function t(e){pu(this,t),this.body=e,this._resetRNG(Math.random()+":"+cv()),this.setPhysics=!1,this.options={},this.optionsBackup={physics:{}},this.defaultOptions={randomSeed:void 0,improvedLayout:!0,clusterThreshold:150,hierarchical:{enabled:!1,levelSeparation:150,nodeSpacing:100,treeSpacing:200,blockShifting:!0,edgeMinimization:!0,parentCentralization:!0,direction:"UD",sortMethod:"hubsize"}},wo(this.options,this.defaultOptions),this.bindEventListeners()}return Nf(t,[{key:"bindEventListeners",value:function(){var t=this;this.body.emitter.on("_dataChanged",(function(){t.setupHierarchicalLayout()})),this.body.emitter.on("_dataLoaded",(function(){t.layoutNetwork()})),this.body.emitter.on("_resetHierarchicalLayout",(function(){t.setupHierarchicalLayout()})),this.body.emitter.on("_adjustEdgesForHierarchicalLayout",(function(){if(!0===t.options.hierarchical.enabled){var e=t.direction.curveType();t.body.emitter.emit("_forceDisableDynamicCurves",e,!1)}}))}},{key:"setOptions",value:function(t,e){if(void 0!==t){var i=this.options.hierarchical,o=i.enabled;if(Wx(["randomSeed","improvedLayout","clusterThreshold"],this.options,t),fk(this.options,t,"hierarchical"),void 0!==t.randomSeed&&this._resetRNG(t.randomSeed),!0===i.enabled)return!0===o&&this.body.emitter.emit("refresh",!0),"RL"===i.direction||"DU"===i.direction?i.levelSeparation>0&&(i.levelSeparation*=-1):i.levelSeparation<0&&(i.levelSeparation*=-1),this.setDirectionStrategy(),this.body.emitter.emit("_resetHierarchicalLayout"),this.adaptAllOptionsForHierarchicalLayout(e);if(!0===o)return this.body.emitter.emit("refresh"),Vx(e,this.optionsBackup)}return e}},{key:"_resetRNG",value:function(t){this.initialRandomSeed=t,this._rng=Sx(this.initialRandomSeed)}},{key:"adaptAllOptionsForHierarchicalLayout",value:function(t){if(!0===this.options.hierarchical.enabled){var e=this.optionsBackup.physics;void 0===t.physics||!0===t.physics?(t.physics={enabled:void 0===e.enabled||e.enabled,solver:"hierarchicalRepulsion"},e.enabled=void 0===e.enabled||e.enabled,e.solver=e.solver||"barnesHut"):"object"===Of(t.physics)?(e.enabled=void 0===t.physics.enabled||t.physics.enabled,e.solver=t.physics.solver||"barnesHut",t.physics.solver="hierarchicalRepulsion"):!1!==t.physics&&(e.solver="barnesHut",t.physics={solver:"hierarchicalRepulsion"});var i=this.direction.curveType();if(void 0===t.edges)this.optionsBackup.edges={smooth:{enabled:!0,type:"dynamic"}},t.edges={smooth:!1};else if(void 0===t.edges.smooth)this.optionsBackup.edges={smooth:{enabled:!0,type:"dynamic"}},t.edges.smooth=!1;else if("boolean"==typeof t.edges.smooth)this.optionsBackup.edges={smooth:t.edges.smooth},t.edges.smooth={enabled:t.edges.smooth,type:i};else{var o=t.edges.smooth;void 0!==o.type&&"dynamic"!==o.type&&(i=o.type),this.optionsBackup.edges={smooth:{enabled:void 0===o.enabled||o.enabled,type:void 0===o.type?"dynamic":o.type,roundness:void 0===o.roundness?.5:o.roundness,forceDirection:void 0!==o.forceDirection&&o.forceDirection}},t.edges.smooth={enabled:void 0===o.enabled||o.enabled,type:i,roundness:void 0===o.roundness?.5:o.roundness,forceDirection:void 0!==o.forceDirection&&o.forceDirection}}this.body.emitter.emit("_forceDisableDynamicCurves",i)}return t}},{key:"positionInitially",value:function(t){if(!0!==this.options.hierarchical.enabled){this._resetRNG(this.initialRandomSeed);for(var e=t.length+50,i=0;i<t.length;i++){var o=t[i],n=2*Math.PI*this._rng();void 0===o.x&&(o.x=e*Math.cos(n)),void 0===o.y&&(o.y=e*Math.sin(n))}}}},{key:"layoutNetwork",value:function(){if(!0!==this.options.hierarchical.enabled&&!0===this.options.improvedLayout){for(var t=this.body.nodeIndices,e=0,i=0;i<t.length;i++){!0===this.body.nodes[t[i]].predefinedPosition&&(e+=1)}if(e<.5*t.length){var o=0,n=this.options.clusterThreshold,r={clusterNodeProperties:{shape:"ellipse",label:"",group:"",font:{multi:!1}},clusterEdgeProperties:{label:"",font:{multi:!1},smooth:{enabled:!1}}};if(t.length>n){for(var s=t.length;t.length>n&&o<=10;){o+=1;var a=t.length;if(o%3==0?this.body.modules.clustering.clusterBridges(r):this.body.modules.clustering.clusterOutliers(r),a==t.length&&o%3!=0)return this._declusterAll(),this.body.emitter.emit("_layoutFailed"),void console.info("This network could not be positioned by this version of the improved layout algorithm. Please disable improvedLayout for better performance.")}this.body.modules.kamadaKawai.setOptions({springLength:Math.max(150,2*s)})}o>10&&console.info("The clustering didn't succeed within the amount of interations allowed, progressing with partial result."),this.body.modules.kamadaKawai.solve(t,this.body.edgeIndices,!0),this._shiftToCenter();for(var h=0;h<t.length;h++){var l=this.body.nodes[t[h]];!1===l.predefinedPosition&&(l.x+=70*(.5-this._rng()),l.y+=70*(.5-this._rng()))}this._declusterAll(),this.body.emitter.emit("_repositionBezierNodes")}}}},{key:"_shiftToCenter",value:function(){for(var t=Kz.getRangeCore(this.body.nodes,this.body.nodeIndices),e=Kz.findCenter(t),i=0;i<this.body.nodeIndices.length;i++){var o=this.body.nodes[this.body.nodeIndices[i]];o.x-=e.x,o.y-=e.y}}},{key:"_declusterAll",value:function(){for(var t=!0;!0===t;){t=!1;for(var e=0;e<this.body.nodeIndices.length;e++)!0===this.body.nodes[this.body.nodeIndices[e]].isCluster&&(t=!0,this.body.modules.clustering.openCluster(this.body.nodeIndices[e],{},!1));!0===t&&this.body.emitter.emit("_dataChanged")}}},{key:"getSeed",value:function(){return this.initialRandomSeed}},{key:"setupHierarchicalLayout",value:function(){if(!0===this.options.hierarchical.enabled&&this.body.nodeIndices.length>0){var t,e,i=!1,o=!1;for(e in this.lastNodeOnLevel={},this.hierarchical=new GA,this.body.nodes)Object.prototype.hasOwnProperty.call(this.body.nodes,e)&&(void 0!==(t=this.body.nodes[e]).options.level?(i=!0,this.hierarchical.levels[e]=t.options.level):o=!0);if(!0===o&&!0===i)throw new Error("To use the hierarchical layout, nodes require either no predefined levels or levels have to be defined for all nodes.");if(!0===o){var n=this.options.hierarchical.sortMethod;"hubsize"===n?this._determineLevelsByHubsize():"directed"===n?this._determineLevelsDirected():"custom"===n&&this._determineLevelsCustomCallback()}for(var r in this.body.nodes)Object.prototype.hasOwnProperty.call(this.body.nodes,r)&&this.hierarchical.ensureLevel(r);var s=this._getDistribution();this._generateMap(),this._placeNodesByHierarchy(s),this._condenseHierarchy(),this._shiftToCenter()}}},{key:"_condenseHierarchy",value:function(){var t=this,e=!1,i={},o=function(e,i){var o=t.hierarchical.trees;for(var n in o)Object.prototype.hasOwnProperty.call(o,n)&&o[n]===e&&t.direction.shift(n,i)},n=function(){for(var e=[],i=0;i<t.hierarchical.numTrees();i++)e.push(t.direction.getTreeSize(i));return e},r=function e(i,o){if(!o[i.id]&&(o[i.id]=!0,t.hierarchical.childrenReference[i.id])){var n=t.hierarchical.childrenReference[i.id];if(n.length>0)for(var r=0;r<n.length;r++)e(t.body.nodes[n[r]],o)}},s=function(e){var i=arguments.length>1&&void 0!==arguments[1]?arguments[1]:1e9,o=1e9,n=1e9,r=1e9,s=-1e9;for(var a in e)if(Object.prototype.hasOwnProperty.call(e,a)){var h=t.body.nodes[a],l=t.hierarchical.levels[h.id],d=t.direction.getPosition(h),c=kp(t._getSpaceAroundNode(h,e),2),u=c[0],f=c[1];o=Math.min(u,o),n=Math.min(f,n),l<=i&&(r=Math.min(d,r),s=Math.max(d,s))}return[r,s,o,n]},a=function(e,i){var o=t.hierarchical.getMaxLevel(e.id),n=t.hierarchical.getMaxLevel(i.id);return Math.min(o,n)},h=function(e,i,o){for(var n=t.hierarchical,r=0;r<i.length;r++){var s=i[r],a=n.distributionOrdering[s];if(a.length>1)for(var h=0;h<a.length-1;h++){var l=a[h],d=a[h+1];n.hasSameParent(l,d)&&n.inSameSubNetwork(l,d)&&e(l,d,o)}}},l=function(i,o){var n=arguments.length>2&&void 0!==arguments[2]&&arguments[2],h=t.direction.getPosition(i),l=t.direction.getPosition(o),d=Math.abs(l-h),c=t.options.hierarchical.nodeSpacing;if(d>c){var u={},f={};r(i,u),r(o,f);var p=a(i,o),v=s(u,p),g=s(f,p),y=v[1],m=g[0],b=g[2];if(Math.abs(y-m)>c){var w=y-m+c;w<-b+c&&(w=-b+c),w<0&&(t._shiftBlock(o.id,w),e=!0,!0===n&&t._centerParent(o))}}},d=function(o,n){for(var a=n.id,h=n.edges,l=t.hierarchical.levels[n.id],d=t.options.hierarchical.levelSeparation*t.options.hierarchical.levelSeparation,c={},u=[],f=0;f<h.length;f++){var p=h[f];if(p.toId!=p.fromId){var v=p.toId==a?p.from:p.to;c[h[f].id]=v,t.hierarchical.levels[v.id]<l&&u.push(p)}}var g=function(e,i){for(var o=0,n=0;n<i.length;n++)if(void 0!==c[i[n].id]){var r=t.direction.getPosition(c[i[n].id])-e;o+=r/Math.sqrt(r*r+d)}return o},y=function(e,i){for(var o=0,n=0;n<i.length;n++)if(void 0!==c[i[n].id]){var r=t.direction.getPosition(c[i[n].id])-e;o-=d*Math.pow(r*r+d,-1.5)}return o},m=function(e,i){for(var o=t.direction.getPosition(n),r={},s=0;s<e;s++){var a=g(o,i),h=y(o,i);if(void 0!==r[o-=Math.max(-40,Math.min(40,Math.round(a/h)))])break;r[o]=s}return o},b=m(o,u);!function(o){var a=t.direction.getPosition(n);if(void 0===i[n.id]){var h={};r(n,h),i[n.id]=h}var l=s(i[n.id]),d=l[2],c=l[3],u=o-a,f=0;u>0?f=Math.min(u,c-t.options.hierarchical.nodeSpacing):u<0&&(f=-Math.min(-u,d-t.options.hierarchical.nodeSpacing)),0!=f&&(t._shiftBlock(n.id,f),e=!0)}(b),function(i){var o=t.direction.getPosition(n),r=kp(t._getSpaceAroundNode(n),2),s=r[0],a=r[1],h=i-o,l=o;h>0?l=Math.min(o+(a-t.options.hierarchical.nodeSpacing),i):h<0&&(l=Math.max(o-(s-t.options.hierarchical.nodeSpacing),i)),l!==o&&(t.direction.setPosition(n,l),e=!0)}(b=m(o,h))};!0===this.options.hierarchical.blockShifting&&(function(i){var o=t.hierarchical.getLevels();o=Rv(o).call(o);for(var n=0;n<i&&(e=!1,h(l,o,!0),!0===e);n++);}(5),function(){for(var e in t.body.nodes)Object.prototype.hasOwnProperty.call(t.body.nodes,e)&&t._centerParent(t.body.nodes[e])}()),!0===this.options.hierarchical.edgeMinimization&&function(i){var o=t.hierarchical.getLevels();o=Rv(o).call(o);for(var n=0;n<i;n++){e=!1;for(var r=0;r<o.length;r++)for(var s=o[r],a=t.hierarchical.distributionOrdering[s],h=0;h<a.length;h++)d(1e3,a[h]);if(!0!==e)break}}(20),!0===this.options.hierarchical.parentCentralization&&function(){var e=t.hierarchical.getLevels();e=Rv(e).call(e);for(var i=0;i<e.length;i++)for(var o=e[i],n=t.hierarchical.distributionOrdering[o],r=0;r<n.length;r++)t._centerParent(n[r])}(),function(){for(var e=n(),i=0,r=0;r<e.length-1;r++){i+=e[r].max-e[r+1].min+t.options.hierarchical.treeSpacing,o(r+1,i)}}()}},{key:"_getSpaceAroundNode",value:function(t,e){var i=!0;void 0===e&&(i=!1);var o=this.hierarchical.levels[t.id];if(void 0!==o){var n=this.hierarchical.distributionIndex[t.id],r=this.direction.getPosition(t),s=this.hierarchical.distributionOrdering[o],a=1e9,h=1e9;if(0!==n){var l=s[n-1];if(!0===i&&void 0===e[l.id]||!1===i)a=r-this.direction.getPosition(l)}if(n!=s.length-1){var d=s[n+1];if(!0===i&&void 0===e[d.id]||!1===i){var c=this.direction.getPosition(d);h=Math.min(h,c-r)}}return[a,h]}return[0,0]}},{key:"_centerParent",value:function(t){if(this.hierarchical.parentReference[t.id])for(var e=this.hierarchical.parentReference[t.id],i=0;i<e.length;i++){var o=e[i],n=this.body.nodes[o],r=this.hierarchical.childrenReference[o];if(void 0!==r){var s=this._getCenterPosition(r),a=this.direction.getPosition(n),h=kp(this._getSpaceAroundNode(n),2),l=h[0],d=h[1],c=a-s;(c<0&&Math.abs(c)<d-this.options.hierarchical.nodeSpacing||c>0&&Math.abs(c)<l-this.options.hierarchical.nodeSpacing)&&this.direction.setPosition(n,s)}}}},{key:"_placeNodesByHierarchy",value:function(t){for(var e in this.positionedNodes={},t)if(Object.prototype.hasOwnProperty.call(t,e)){var i,o=nv(t[e]);o=this._indexArrayToNodes(o),LD(i=this.direction).call(i,o);for(var n=0,r=0;r<o.length;r++){var s=o[r];if(void 0===this.positionedNodes[s.id]){var a=this.options.hierarchical.nodeSpacing,h=a*n;n>0&&(h=this.direction.getPosition(o[r-1])+a),this.direction.setPosition(s,h,e),this._validatePositionAndContinue(s,e,h),n++}}}}},{key:"_placeBranchNodes",value:function(t,e){var i,o=this.hierarchical.childrenReference[t];if(void 0!==o){for(var n=[],r=0;r<o.length;r++)n.push(this.body.nodes[o[r]]);LD(i=this.direction).call(i,n);for(var s=0;s<n.length;s++){var a=n[s],h=this.hierarchical.levels[a.id];if(!(h>e&&void 0===this.positionedNodes[a.id]))return;var l=this.options.hierarchical.nodeSpacing,d=void 0;d=0===s?this.direction.getPosition(this.body.nodes[t]):this.direction.getPosition(n[s-1])+l,this.direction.setPosition(a,d,h),this._validatePositionAndContinue(a,h,d)}var c=this._getCenterPosition(n);this.direction.setPosition(this.body.nodes[t],c,e)}}},{key:"_validatePositionAndContinue",value:function(t,e,i){if(this.hierarchical.isTree){if(void 0!==this.lastNodeOnLevel[e]){var o=this.direction.getPosition(this.body.nodes[this.lastNodeOnLevel[e]]);if(i-o<this.options.hierarchical.nodeSpacing){var n=o+this.options.hierarchical.nodeSpacing-i,r=this._findCommonParent(this.lastNodeOnLevel[e],t.id);this._shiftBlock(r.withChild,n)}}this.lastNodeOnLevel[e]=t.id,this.positionedNodes[t.id]=!0,this._placeBranchNodes(t.id,e)}}},{key:"_indexArrayToNodes",value:function(t){for(var e=[],i=0;i<t.length;i++)e.push(this.body.nodes[t[i]]);return e}},{key:"_getDistribution",value:function(){var t,e,i={};for(t in this.body.nodes)if(Object.prototype.hasOwnProperty.call(this.body.nodes,t)){e=this.body.nodes[t];var o=void 0===this.hierarchical.levels[t]?0:this.hierarchical.levels[t];this.direction.fix(e,o),void 0===i[o]&&(i[o]={}),i[o][t]=e}return i}},{key:"_getActiveEdges",value:function(t){var e=this,i=[];return Kx(t.edges,(function(t){var o;-1!==tm(o=e.body.edgeIndices).call(o,t.id)&&i.push(t)})),i}},{key:"_getHubSizes",value:function(){var t=this,e={};Kx(this.body.nodeIndices,(function(i){var o=t.body.nodes[i],n=t._getActiveEdges(o).length;e[n]=!0}));var i=[];return Kx(e,(function(t){i.push(Number(t))})),LD(MA).call(MA,i,(function(t,e){return e-t})),i}},{key:"_determineLevelsByHubsize",value:function(){for(var t=this,e=function(e,i){t.hierarchical.levelDownstream(e,i)},i=this._getHubSizes(),o=function(){var o=i[n];if(0===o)return"break";Kx(t.body.nodeIndices,(function(i){var n=t.body.nodes[i];o===t._getActiveEdges(n).length&&t._crawlNetwork(e,i)}))},n=0;n<i.length;++n){if("break"===o())break}}},{key:"_determineLevelsCustomCallback",value:function(){var t=this;this._crawlNetwork((function(e,i,o){var n=t.hierarchical.levels[e.id];void 0===n&&(n=t.hierarchical.levels[e.id]=1e5);var r=(Kz.cloneOptions(e,"node"),Kz.cloneOptions(i,"node"),void Kz.cloneOptions(o,"edge"));t.hierarchical.levels[i.id]=n+r})),this.hierarchical.setMinLevelToZero(this.body.nodes)}},{key:"_determineLevelsDirected",value:function(){var t,e=this,i=_P(t=this.body.nodeIndices).call(t,(function(t,i){return t.set(i,e.body.nodes[i]),t}),new qE);"roots"===this.options.hierarchical.shakeTowards?this.hierarchical.levels=function(t){return XA((function(e){var i,o;return qA(i=oy(o=e.edges).call(o,(function(e){return t.has(e.toId)}))).call(i,(function(t){return t.from===e}))}),(function(t,e){return e<t}),"to",t)}(i):this.hierarchical.levels=function(t){return XA((function(e){var i,o;return qA(i=oy(o=e.edges).call(o,(function(e){return t.has(e.toId)}))).call(i,(function(t){return t.to===e}))}),(function(t,e){return e>t}),"from",t)}(i),this.hierarchical.setMinLevelToZero(this.body.nodes)}},{key:"_generateMap",value:function(){var t=this;this._crawlNetwork((function(e,i){t.hierarchical.levels[i.id]>t.hierarchical.levels[e.id]&&t.hierarchical.addRelation(e.id,i.id)})),this.hierarchical.checkIfTree()}},{key:"_crawlNetwork",value:function(){var t=this,e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:function(){},i=arguments.length>1?arguments[1]:void 0,o={},n=function i(n,r){if(void 0===o[n.id]){var s;t.hierarchical.setTreeIndex(n,r),o[n.id]=!0;for(var a=t._getActiveEdges(n),h=0;h<a.length;h++){var l=a[h];!0===l.connected&&(s=l.toId==n.id?l.from:l.to,n.id!=s.id&&(e(n,s,l),i(s,r)))}}};if(void 0===i)for(var r=0,s=0;s<this.body.nodeIndices.length;s++){var a=this.body.nodeIndices[s];if(void 0===o[a])n(this.body.nodes[a],r),r+=1}else{var h=this.body.nodes[i];if(void 0===h)return void console.error("Node not found:",i);n(h)}}},{key:"_shiftBlock",value:function(t,e){var i=this,o={};!function t(n){if(!o[n]){o[n]=!0,i.direction.shift(n,e);var r=i.hierarchical.childrenReference[n];if(void 0!==r)for(var s=0;s<r.length;s++)t(r[s])}}(t)}},{key:"_findCommonParent",value:function(t,e){var i=this,o={};return function t(e,o){var n=i.hierarchical.parentReference[o];if(void 0!==n)for(var r=0;r<n.length;r++){var s=n[r];e[s]=!0,t(e,s)}}(o,t),function t(e,o){var n=i.hierarchical.parentReference[o];if(void 0!==n)for(var r=0;r<n.length;r++){var s=n[r];if(void 0!==e[s])return{foundParent:s,withChild:o};var a=t(e,s);if(null!==a.foundParent)return a}return{foundParent:null,withChild:o}}(o,e)}},{key:"setDirectionStrategy",value:function(){var t="UD"===this.options.hierarchical.direction||"DU"===this.options.hierarchical.direction;this.direction=t?new IA(this):new BA(this)}},{key:"_getCenterPosition",value:function(t){for(var e=1e9,i=-1e9,o=0;o<t.length;o++){var n=void 0;if(void 0!==t[o].id)n=t[o];else{var r=t[o];n=this.body.nodes[r]}var s=this.direction.getPosition(n);e=Math.min(e,s),i=Math.max(i,s)}return.5*(e+i)}}]),t}();function $A(t,e){var i=void 0!==Op&&xh(t)||t["@@iterator"];if(!i){if(Wp(t)||(i=function(t,e){var i;if(!t)return;if("string"==typeof t)return ZA(t,e);var o=Fp(i=Object.prototype.toString.call(t)).call(i,8,-1);"Object"===o&&t.constructor&&(o=t.constructor.name);if("Map"===o||"Set"===o)return Za(t);if("Arguments"===o||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(o))return ZA(t,e)}(t))||e&&t&&"number"==typeof t.length){i&&(t=i);var o=0,n=function(){};return{s:n,n:function(){return o>=t.length?{done:!0}:{done:!1,value:t[o++]}},e:function(t){throw t},f:n}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var r,s=!0,a=!1;return{s:function(){i=i.call(t)},n:function(){var t=i.next();return s=t.done,t},e:function(t){a=!0,r=t},f:function(){try{s||null==i.return||i.return()}finally{if(a)throw r}}}}function ZA(t,e){(null==e||e>t.length)&&(e=t.length);for(var i=0,o=new Array(e);i<e;i++)o[i]=t[i];return o}var QA=function(){function t(e,i,o,n){var r,s,a=this;pu(this,t),this.body=e,this.canvas=i,this.selectionHandler=o,this.interactionHandler=n,this.editMode=!1,this.manipulationDiv=void 0,this.editModeDiv=void 0,this.closeDiv=void 0,this._domEventListenerCleanupQueue=[],this.temporaryUIFunctions={},this.temporaryEventFunctions=[],this.touchTime=0,this.temporaryIds={nodes:[],edges:[]},this.guiEnabled=!1,this.inMode=!1,this.selectedControlNode=void 0,this.options={},this.defaultOptions={enabled:!1,initiallyActive:!1,addNode:!0,addEdge:!0,editNode:void 0,editEdge:!0,deleteNode:!0,deleteEdge:!0,controlNodeStyle:{shape:"dot",size:6,color:{background:"#ff0000",border:"#3c3c3c",highlight:{background:"#07f968",border:"#3c3c3c"}},borderWidth:2,borderWidthSelected:2}},wo(this.options,this.defaultOptions),this.body.emitter.on("destroy",(function(){a._clean()})),this.body.emitter.on("_dataChanged",Uo(r=this._restore).call(r,this)),this.body.emitter.on("_resetData",Uo(s=this._restore).call(s,this))}return Nf(t,[{key:"_restore",value:function(){!1!==this.inMode&&(!0===this.options.initiallyActive?this.enableEditMode():this.disableEditMode())}},{key:"setOptions",value:function(t,e,i){void 0!==e&&(void 0!==e.locale?this.options.locale=e.locale:this.options.locale=i.locale,void 0!==e.locales?this.options.locales=e.locales:this.options.locales=i.locales),void 0!==t&&("boolean"==typeof t?this.options.enabled=t:(this.options.enabled=!0,Vx(this.options,t)),!0===this.options.initiallyActive&&(this.editMode=!0),this._setup())}},{key:"toggleEditMode",value:function(){!0===this.editMode?this.disableEditMode():this.enableEditMode()}},{key:"enableEditMode",value:function(){this.editMode=!0,this._clean(),!0===this.guiEnabled&&(this.manipulationDiv.style.display="block",this.closeDiv.style.display="block",this.editModeDiv.style.display="none",this.showManipulatorToolbar())}},{key:"disableEditMode",value:function(){this.editMode=!1,this._clean(),!0===this.guiEnabled&&(this.manipulationDiv.style.display="none",this.closeDiv.style.display="none",this.editModeDiv.style.display="block",this._createEditButton())}},{key:"showManipulatorToolbar",value:function(){if(this._clean(),this.manipulationDOM={},!0===this.guiEnabled){var t,e;this.editMode=!0,this.manipulationDiv.style.display="block",this.closeDiv.style.display="block";var i=this.selectionHandler.getSelectedNodeCount(),o=this.selectionHandler.getSelectedEdgeCount(),n=i+o,r=this.options.locales[this.options.locale],s=!1;!1!==this.options.addNode&&(this._createAddNodeButton(r),s=!0),!1!==this.options.addEdge&&(!0===s?this._createSeperator(1):s=!0,this._createAddEdgeButton(r)),1===i&&"function"==typeof this.options.editNode?(!0===s?this._createSeperator(2):s=!0,this._createEditNodeButton(r)):1===o&&0===i&&!1!==this.options.editEdge&&(!0===s?this._createSeperator(3):s=!0,this._createEditEdgeButton(r)),0!==n&&(i>0&&!1!==this.options.deleteNode||0===i&&!1!==this.options.deleteEdge)&&(!0===s&&this._createSeperator(4),this._createDeleteButton(r)),this._bindElementEvents(this.closeDiv,Uo(t=this.toggleEditMode).call(t,this)),this._temporaryBindEvent("select",Uo(e=this.showManipulatorToolbar).call(e,this))}this.body.emitter.emit("_redraw")}},{key:"addNodeMode",value:function(){var t;if(!0!==this.editMode&&this.enableEditMode(),this._clean(),this.inMode="addNode",!0===this.guiEnabled){var e,i=this.options.locales[this.options.locale];this.manipulationDOM={},this._createBackButton(i),this._createSeperator(),this._createDescription(i.addDescription||this.options.locales.en.addDescription),this._bindElementEvents(this.closeDiv,Uo(e=this.toggleEditMode).call(e,this))}this._temporaryBindEvent("click",Uo(t=this._performAddNode).call(t,this))}},{key:"editNode",value:function(){var t=this;!0!==this.editMode&&this.enableEditMode(),this._clean();var e=this.selectionHandler.getSelectedNodes()[0];if(void 0!==e){if(this.inMode="editNode","function"!=typeof this.options.editNode)throw new Error("No function has been configured to handle the editing of nodes.");if(!0!==e.isCluster){var i=Vx({},e.options,!1);if(i.x=e.x,i.y=e.y,2!==this.options.editNode.length)throw new Error("The function for edit does not support two arguments (data, callback)");this.options.editNode(i,(function(e){null!=e&&"editNode"===t.inMode&&t.body.data.nodes.getDataSet().update(e),t.showManipulatorToolbar()}))}else alert(this.options.locales[this.options.locale].editClusterError||this.options.locales.en.editClusterError)}else this.showManipulatorToolbar()}},{key:"addEdgeMode",value:function(){var t,e,i,o,n;if(!0!==this.editMode&&this.enableEditMode(),this._clean(),this.inMode="addEdge",!0===this.guiEnabled){var r,s=this.options.locales[this.options.locale];this.manipulationDOM={},this._createBackButton(s),this._createSeperator(),this._createDescription(s.edgeDescription||this.options.locales.en.edgeDescription),this._bindElementEvents(this.closeDiv,Uo(r=this.toggleEditMode).call(r,this))}this._temporaryBindUI("onTouch",Uo(t=this._handleConnect).call(t,this)),this._temporaryBindUI("onDragEnd",Uo(e=this._finishConnect).call(e,this)),this._temporaryBindUI("onDrag",Uo(i=this._dragControlNode).call(i,this)),this._temporaryBindUI("onRelease",Uo(o=this._finishConnect).call(o,this)),this._temporaryBindUI("onDragStart",Uo(n=this._dragStartEdge).call(n,this)),this._temporaryBindUI("onHold",(function(){}))}},{key:"editEdgeMode",value:function(){if(!0!==this.editMode&&this.enableEditMode(),this._clean(),this.inMode="editEdge","object"!==Of(this.options.editEdge)||"function"!=typeof this.options.editEdge.editWithoutDrag||(this.edgeBeingEditedId=this.selectionHandler.getSelectedEdgeIds()[0],void 0===this.edgeBeingEditedId)){if(!0===this.guiEnabled){var t,e=this.options.locales[this.options.locale];this.manipulationDOM={},this._createBackButton(e),this._createSeperator(),this._createDescription(e.editEdgeDescription||this.options.locales.en.editEdgeDescription),this._bindElementEvents(this.closeDiv,Uo(t=this.toggleEditMode).call(t,this))}if(this.edgeBeingEditedId=this.selectionHandler.getSelectedEdgeIds()[0],void 0!==this.edgeBeingEditedId){var i,o,n,r,s=this.body.edges[this.edgeBeingEditedId],a=this._getNewTargetNode(s.from.x,s.from.y),h=this._getNewTargetNode(s.to.x,s.to.y);this.temporaryIds.nodes.push(a.id),this.temporaryIds.nodes.push(h.id),this.body.nodes[a.id]=a,this.body.nodeIndices.push(a.id),this.body.nodes[h.id]=h,this.body.nodeIndices.push(h.id),this._temporaryBindUI("onTouch",Uo(i=this._controlNodeTouch).call(i,this)),this._temporaryBindUI("onTap",(function(){})),this._temporaryBindUI("onHold",(function(){})),this._temporaryBindUI("onDragStart",Uo(o=this._controlNodeDragStart).call(o,this)),this._temporaryBindUI("onDrag",Uo(n=this._controlNodeDrag).call(n,this)),this._temporaryBindUI("onDragEnd",Uo(r=this._controlNodeDragEnd).call(r,this)),this._temporaryBindUI("onMouseMove",(function(){})),this._temporaryBindEvent("beforeDrawing",(function(t){var e=s.edgeType.findBorderPositions(t);!1===a.selected&&(a.x=e.from.x,a.y=e.from.y),!1===h.selected&&(h.x=e.to.x,h.y=e.to.y)})),this.body.emitter.emit("_redraw")}else this.showManipulatorToolbar()}else{var l=this.body.edges[this.edgeBeingEditedId];this._performEditEdge(l.from.id,l.to.id)}}},{key:"deleteSelected",value:function(){var t=this;!0!==this.editMode&&this.enableEditMode(),this._clean(),this.inMode="delete";var e=this.selectionHandler.getSelectedNodeIds(),i=this.selectionHandler.getSelectedEdgeIds(),o=void 0;if(e.length>0){for(var n=0;n<e.length;n++)if(!0===this.body.nodes[e[n]].isCluster)return void alert(this.options.locales[this.options.locale].deleteClusterError||this.options.locales.en.deleteClusterError);"function"==typeof this.options.deleteNode&&(o=this.options.deleteNode)}else i.length>0&&"function"==typeof this.options.deleteEdge&&(o=this.options.deleteEdge);if("function"==typeof o){var r={nodes:e,edges:i};if(2!==o.length)throw new Error("The function for delete does not support two arguments (data, callback)");o(r,(function(e){null!=e&&"delete"===t.inMode?(t.body.data.edges.getDataSet().remove(e.edges),t.body.data.nodes.getDataSet().remove(e.nodes),t.body.emitter.emit("startSimulation"),t.showManipulatorToolbar()):(t.body.emitter.emit("startSimulation"),t.showManipulatorToolbar())}))}else this.body.data.edges.getDataSet().remove(i),this.body.data.nodes.getDataSet().remove(e),this.body.emitter.emit("startSimulation"),this.showManipulatorToolbar()}},{key:"_setup",value:function(){!0===this.options.enabled?(this.guiEnabled=!0,this._createWrappers(),!1===this.editMode?this._createEditButton():this.showManipulatorToolbar()):(this._removeManipulationDOM(),this.guiEnabled=!1)}},{key:"_createWrappers",value:function(){var t,e;(void 0===this.manipulationDiv&&(this.manipulationDiv=document.createElement("div"),this.manipulationDiv.className="vis-manipulation",!0===this.editMode?this.manipulationDiv.style.display="block":this.manipulationDiv.style.display="none",this.canvas.frame.appendChild(this.manipulationDiv)),void 0===this.editModeDiv&&(this.editModeDiv=document.createElement("div"),this.editModeDiv.className="vis-edit-mode",!0===this.editMode?this.editModeDiv.style.display="none":this.editModeDiv.style.display="block",this.canvas.frame.appendChild(this.editModeDiv)),void 0===this.closeDiv)&&(this.closeDiv=document.createElement("button"),this.closeDiv.className="vis-close",this.closeDiv.setAttribute("aria-label",null!==(t=null===(e=this.options.locales[this.options.locale])||void 0===e?void 0:e.close)&&void 0!==t?t:this.options.locales.en.close),this.closeDiv.style.display=this.manipulationDiv.style.display,this.canvas.frame.appendChild(this.closeDiv))}},{key:"_getNewTargetNode",value:function(t,e){var i=Vx({},this.options.controlNodeStyle);i.id="targetNode"+VI(),i.hidden=!1,i.physics=!1,i.x=t,i.y=e;var o=this.body.functions.createNode(i);return o.shape.boundingBox={left:t,right:t,top:e,bottom:e},o}},{key:"_createEditButton",value:function(){var t;this._clean(),this.manipulationDOM={},Fx(this.editModeDiv);var e=this.options.locales[this.options.locale],i=this._createButton("editMode","vis-edit vis-edit-mode",e.edit||this.options.locales.en.edit);this.editModeDiv.appendChild(i),this._bindElementEvents(i,Uo(t=this.toggleEditMode).call(t,this))}},{key:"_clean",value:function(){this.inMode=!1,!0===this.guiEnabled&&(Fx(this.editModeDiv),Fx(this.manipulationDiv),this._cleanupDOMEventListeners()),this._cleanupTemporaryNodesAndEdges(),this._unbindTemporaryUIs(),this._unbindTemporaryEvents(),this.body.emitter.emit("restorePhysics")}},{key:"_cleanupDOMEventListeners",value:function(){var t,e,i=$A(vg(t=this._domEventListenerCleanupQueue).call(t,0));try{for(i.s();!(e=i.n()).done;){(0,e.value)()}}catch(t){i.e(t)}finally{i.f()}}},{key:"_removeManipulationDOM",value:function(){this._clean(),Fx(this.manipulationDiv),Fx(this.editModeDiv),Fx(this.closeDiv),this.manipulationDiv&&this.canvas.frame.removeChild(this.manipulationDiv),this.editModeDiv&&this.canvas.frame.removeChild(this.editModeDiv),this.closeDiv&&this.canvas.frame.removeChild(this.closeDiv),this.manipulationDiv=void 0,this.editModeDiv=void 0,this.closeDiv=void 0}},{key:"_createSeperator",value:function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:1;this.manipulationDOM["seperatorLineDiv"+t]=document.createElement("div"),this.manipulationDOM["seperatorLineDiv"+t].className="vis-separator-line",this.manipulationDiv.appendChild(this.manipulationDOM["seperatorLineDiv"+t])}},{key:"_createAddNodeButton",value:function(t){var e,i=this._createButton("addNode","vis-add",t.addNode||this.options.locales.en.addNode);this.manipulationDiv.appendChild(i),this._bindElementEvents(i,Uo(e=this.addNodeMode).call(e,this))}},{key:"_createAddEdgeButton",value:function(t){var e,i=this._createButton("addEdge","vis-connect",t.addEdge||this.options.locales.en.addEdge);this.manipulationDiv.appendChild(i),this._bindElementEvents(i,Uo(e=this.addEdgeMode).call(e,this))}},{key:"_createEditNodeButton",value:function(t){var e,i=this._createButton("editNode","vis-edit",t.editNode||this.options.locales.en.editNode);this.manipulationDiv.appendChild(i),this._bindElementEvents(i,Uo(e=this.editNode).call(e,this))}},{key:"_createEditEdgeButton",value:function(t){var e,i=this._createButton("editEdge","vis-edit",t.editEdge||this.options.locales.en.editEdge);this.manipulationDiv.appendChild(i),this._bindElementEvents(i,Uo(e=this.editEdgeMode).call(e,this))}},{key:"_createDeleteButton",value:function(t){var e,i;i=this.options.rtl?"vis-delete-rtl":"vis-delete";var o=this._createButton("delete",i,t.del||this.options.locales.en.del);this.manipulationDiv.appendChild(o),this._bindElementEvents(o,Uo(e=this.deleteSelected).call(e,this))}},{key:"_createBackButton",value:function(t){var e,i=this._createButton("back","vis-back",t.back||this.options.locales.en.back);this.manipulationDiv.appendChild(i),this._bindElementEvents(i,Uo(e=this.showManipulatorToolbar).call(e,this))}},{key:"_createButton",value:function(t,e,i){var o=arguments.length>3&&void 0!==arguments[3]?arguments[3]:"vis-label";return this.manipulationDOM[t+"Div"]=document.createElement("button"),this.manipulationDOM[t+"Div"].className="vis-button "+e,this.manipulationDOM[t+"Label"]=document.createElement("div"),this.manipulationDOM[t+"Label"].className=o,this.manipulationDOM[t+"Label"].innerText=i,this.manipulationDOM[t+"Div"].appendChild(this.manipulationDOM[t+"Label"]),this.manipulationDOM[t+"Div"]}},{key:"_createDescription",value:function(t){this.manipulationDOM.descriptionLabel=document.createElement("div"),this.manipulationDOM.descriptionLabel.className="vis-none",this.manipulationDOM.descriptionLabel.innerText=t,this.manipulationDiv.appendChild(this.manipulationDOM.descriptionLabel)}},{key:"_temporaryBindEvent",value:function(t,e){this.temporaryEventFunctions.push({event:t,boundFunction:e}),this.body.emitter.on(t,e)}},{key:"_temporaryBindUI",value:function(t,e){if(void 0===this.body.eventListeners[t])throw new Error("This UI function does not exist. Typo? You tried: "+t+" possible are: "+Em(nv(this.body.eventListeners)));this.temporaryUIFunctions[t]=this.body.eventListeners[t],this.body.eventListeners[t]=e}},{key:"_unbindTemporaryUIs",value:function(){for(var t in this.temporaryUIFunctions)Object.prototype.hasOwnProperty.call(this.temporaryUIFunctions,t)&&(this.body.eventListeners[t]=this.temporaryUIFunctions[t],delete this.temporaryUIFunctions[t]);this.temporaryUIFunctions={}}},{key:"_unbindTemporaryEvents",value:function(){for(var t=0;t<this.temporaryEventFunctions.length;t++){var e=this.temporaryEventFunctions[t].event,i=this.temporaryEventFunctions[t].boundFunction;this.body.emitter.off(e,i)}this.temporaryEventFunctions=[]}},{key:"_bindElementEvents",value:function(t,e){var i=new Tk(t,{});oF(i,e),this._domEventListenerCleanupQueue.push((function(){i.destroy()}));var o=function(t){var i=t.keyCode,o=t.key;"Enter"!==o&&" "!==o&&13!==i&&32!==i||e()};t.addEventListener("keyup",o,!1),this._domEventListenerCleanupQueue.push((function(){t.removeEventListener("keyup",o,!1)}))}},{key:"_cleanupTemporaryNodesAndEdges",value:function(){for(var t=0;t<this.temporaryIds.edges.length;t++){var e;this.body.edges[this.temporaryIds.edges[t]].disconnect(),delete this.body.edges[this.temporaryIds.edges[t]];var i,o=tm(e=this.body.edgeIndices).call(e,this.temporaryIds.edges[t]);if(-1!==o)vg(i=this.body.edgeIndices).call(i,o,1)}for(var n=0;n<this.temporaryIds.nodes.length;n++){var r;delete this.body.nodes[this.temporaryIds.nodes[n]];var s,a=tm(r=this.body.nodeIndices).call(r,this.temporaryIds.nodes[n]);if(-1!==a)vg(s=this.body.nodeIndices).call(s,a,1)}this.temporaryIds={nodes:[],edges:[]}}},{key:"_controlNodeTouch",value:function(t){this.selectionHandler.unselectAll(),this.lastTouch=this.body.functions.getPointer(t.center),this.lastTouch.translation=wo({},this.body.view.translation)}},{key:"_controlNodeDragStart",value:function(){var t=this.lastTouch,e=this.selectionHandler._pointerToPositionObject(t),i=this.body.nodes[this.temporaryIds.nodes[0]],o=this.body.nodes[this.temporaryIds.nodes[1]],n=this.body.edges[this.edgeBeingEditedId];this.selectedControlNode=void 0;var r=i.isOverlappingWith(e),s=o.isOverlappingWith(e);!0===r?(this.selectedControlNode=i,n.edgeType.from=i):!0===s&&(this.selectedControlNode=o,n.edgeType.to=o),void 0!==this.selectedControlNode&&this.selectionHandler.selectObject(this.selectedControlNode),this.body.emitter.emit("_redraw")}},{key:"_controlNodeDrag",value:function(t){this.body.emitter.emit("disablePhysics");var e=this.body.functions.getPointer(t.center),i=this.canvas.DOMtoCanvas(e);void 0!==this.selectedControlNode?(this.selectedControlNode.x=i.x,this.selectedControlNode.y=i.y):this.interactionHandler.onDrag(t),this.body.emitter.emit("_redraw")}},{key:"_controlNodeDragEnd",value:function(t){var e=this.body.functions.getPointer(t.center),i=this.selectionHandler._pointerToPositionObject(e),o=this.body.edges[this.edgeBeingEditedId];if(void 0!==this.selectedControlNode){this.selectionHandler.unselectAll();for(var n=this.selectionHandler._getAllNodesOverlappingWith(i),r=void 0,s=n.length-1;s>=0;s--)if(n[s]!==this.selectedControlNode.id){r=this.body.nodes[n[s]];break}if(void 0!==r&&void 0!==this.selectedControlNode)if(!0===r.isCluster)alert(this.options.locales[this.options.locale].createEdgeError||this.options.locales.en.createEdgeError);else{var a=this.body.nodes[this.temporaryIds.nodes[0]];this.selectedControlNode.id===a.id?this._performEditEdge(r.id,o.to.id):this._performEditEdge(o.from.id,r.id)}else o.updateEdgeType(),this.body.emitter.emit("restorePhysics");this.body.emitter.emit("_redraw")}}},{key:"_handleConnect",value:function(t){if((new Date).valueOf()-this.touchTime>100){this.lastTouch=this.body.functions.getPointer(t.center),this.lastTouch.translation=wo({},this.body.view.translation),this.interactionHandler.drag.pointer=this.lastTouch,this.interactionHandler.drag.translation=this.lastTouch.translation;var e=this.lastTouch,i=this.selectionHandler.getNodeAt(e);if(void 0!==i)if(!0===i.isCluster)alert(this.options.locales[this.options.locale].createEdgeError||this.options.locales.en.createEdgeError);else{var o=this._getNewTargetNode(i.x,i.y);this.body.nodes[o.id]=o,this.body.nodeIndices.push(o.id);var n=this.body.functions.createEdge({id:"connectionEdge"+VI(),from:i.id,to:o.id,physics:!1,smooth:{enabled:!0,type:"continuous",roundness:.5}});this.body.edges[n.id]=n,this.body.edgeIndices.push(n.id),this.temporaryIds.nodes.push(o.id),this.temporaryIds.edges.push(n.id)}this.touchTime=(new Date).valueOf()}}},{key:"_dragControlNode",value:function(t){var e=this.body.functions.getPointer(t.center),i=this.selectionHandler._pointerToPositionObject(e),o=void 0;void 0!==this.temporaryIds.edges[0]&&(o=this.body.edges[this.temporaryIds.edges[0]].fromId);for(var n=this.selectionHandler._getAllNodesOverlappingWith(i),r=void 0,s=n.length-1;s>=0;s--){var a;if(-1===tm(a=this.temporaryIds.nodes).call(a,n[s])){r=this.body.nodes[n[s]];break}}if(t.controlEdge={from:o,to:r?r.id:void 0},this.selectionHandler.generateClickEvent("controlNodeDragging",t,e),void 0!==this.temporaryIds.nodes[0]){var h=this.body.nodes[this.temporaryIds.nodes[0]];h.x=this.canvas._XconvertDOMtoCanvas(e.x),h.y=this.canvas._YconvertDOMtoCanvas(e.y),this.body.emitter.emit("_redraw")}else this.interactionHandler.onDrag(t)}},{key:"_finishConnect",value:function(t){var e=this.body.functions.getPointer(t.center),i=this.selectionHandler._pointerToPositionObject(e),o=void 0;void 0!==this.temporaryIds.edges[0]&&(o=this.body.edges[this.temporaryIds.edges[0]].fromId);for(var n=this.selectionHandler._getAllNodesOverlappingWith(i),r=void 0,s=n.length-1;s>=0;s--){var a;if(-1===tm(a=this.temporaryIds.nodes).call(a,n[s])){r=this.body.nodes[n[s]];break}}this._cleanupTemporaryNodesAndEdges(),void 0!==r&&(!0===r.isCluster?alert(this.options.locales[this.options.locale].createEdgeError||this.options.locales.en.createEdgeError):void 0!==this.body.nodes[o]&&void 0!==this.body.nodes[r.id]&&this._performAddEdge(o,r.id)),t.controlEdge={from:o,to:r?r.id:void 0},this.selectionHandler.generateClickEvent("controlNodeDragEnd",t,e),this.body.emitter.emit("_redraw")}},{key:"_dragStartEdge",value:function(t){var e=this.lastTouch;this.selectionHandler.generateClickEvent("dragStart",t,e,void 0,!0)}},{key:"_performAddNode",value:function(t){var e=this,i={id:VI(),x:t.pointer.canvas.x,y:t.pointer.canvas.y,label:"new"};if("function"==typeof this.options.addNode){if(2!==this.options.addNode.length)throw this.showManipulatorToolbar(),new Error("The function for add does not support two arguments (data,callback)");this.options.addNode(i,(function(t){null!=t&&"addNode"===e.inMode&&e.body.data.nodes.getDataSet().add(t),e.showManipulatorToolbar()}))}else this.body.data.nodes.getDataSet().add(i),this.showManipulatorToolbar()}},{key:"_performAddEdge",value:function(t,e){var i=this,o={from:t,to:e};if("function"==typeof this.options.addEdge){if(2!==this.options.addEdge.length)throw new Error("The function for connect does not support two arguments (data,callback)");this.options.addEdge(o,(function(t){null!=t&&"addEdge"===i.inMode&&(i.body.data.edges.getDataSet().add(t),i.selectionHandler.unselectAll(),i.showManipulatorToolbar())}))}else this.body.data.edges.getDataSet().add(o),this.selectionHandler.unselectAll(),this.showManipulatorToolbar()}},{key:"_performEditEdge",value:function(t,e){var i=this,o={id:this.edgeBeingEditedId,from:t,to:e,label:this.body.data.edges.get(this.edgeBeingEditedId).label},n=this.options.editEdge;if("object"===Of(n)&&(n=n.editWithoutDrag),"function"==typeof n){if(2!==n.length)throw new Error("The function for edit does not support two arguments (data, callback)");n(o,(function(t){null==t||"editEdge"!==i.inMode?(i.body.edges[o.id].updateEdgeType(),i.body.emitter.emit("_redraw"),i.showManipulatorToolbar()):(i.body.data.edges.getDataSet().update(t),i.selectionHandler.unselectAll(),i.showManipulatorToolbar())}))}else this.body.data.edges.getDataSet().update(o),this.selectionHandler.unselectAll(),this.showManipulatorToolbar()}}]),t}(),JA="string",tj="boolean",ej="number",ij="array",oj="object",nj=["arrow","bar","box","circle","crow","curve","diamond","image","inv_curve","inv_triangle","triangle","vee"],rj={borderWidth:{number:ej},borderWidthSelected:{number:ej,undefined:"undefined"},brokenImage:{string:JA,undefined:"undefined"},chosen:{label:{boolean:tj,function:"function"},node:{boolean:tj,function:"function"},__type__:{object:oj,boolean:tj}},color:{border:{string:JA},background:{string:JA},highlight:{border:{string:JA},background:{string:JA},__type__:{object:oj,string:JA}},hover:{border:{string:JA},background:{string:JA},__type__:{object:oj,string:JA}},__type__:{object:oj,string:JA}},opacity:{number:ej,undefined:"undefined"},fixed:{x:{boolean:tj},y:{boolean:tj},__type__:{object:oj,boolean:tj}},font:{align:{string:JA},color:{string:JA},size:{number:ej},face:{string:JA},background:{string:JA},strokeWidth:{number:ej},strokeColor:{string:JA},vadjust:{number:ej},multi:{boolean:tj,string:JA},bold:{color:{string:JA},size:{number:ej},face:{string:JA},mod:{string:JA},vadjust:{number:ej},__type__:{object:oj,string:JA}},boldital:{color:{string:JA},size:{number:ej},face:{string:JA},mod:{string:JA},vadjust:{number:ej},__type__:{object:oj,string:JA}},ital:{color:{string:JA},size:{number:ej},face:{string:JA},mod:{string:JA},vadjust:{number:ej},__type__:{object:oj,string:JA}},mono:{color:{string:JA},size:{number:ej},face:{string:JA},mod:{string:JA},vadjust:{number:ej},__type__:{object:oj,string:JA}},__type__:{object:oj,string:JA}},group:{string:JA,number:ej,undefined:"undefined"},heightConstraint:{minimum:{number:ej},valign:{string:JA},__type__:{object:oj,boolean:tj,number:ej}},hidden:{boolean:tj},icon:{face:{string:JA},code:{string:JA},size:{number:ej},color:{string:JA},weight:{string:JA,number:ej},__type__:{object:oj}},id:{string:JA,number:ej},image:{selected:{string:JA,undefined:"undefined"},unselected:{string:JA,undefined:"undefined"},__type__:{object:oj,string:JA}},imagePadding:{top:{number:ej},right:{number:ej},bottom:{number:ej},left:{number:ej},__type__:{object:oj,number:ej}},label:{string:JA,undefined:"undefined"},labelHighlightBold:{boolean:tj},level:{number:ej,undefined:"undefined"},margin:{top:{number:ej},right:{number:ej},bottom:{number:ej},left:{number:ej},__type__:{object:oj,number:ej}},mass:{number:ej},physics:{boolean:tj},scaling:{min:{number:ej},max:{number:ej},label:{enabled:{boolean:tj},min:{number:ej},max:{number:ej},maxVisible:{number:ej},drawThreshold:{number:ej},__type__:{object:oj,boolean:tj}},customScalingFunction:{function:"function"},__type__:{object:oj}},shadow:{enabled:{boolean:tj},color:{string:JA},size:{number:ej},x:{number:ej},y:{number:ej},__type__:{object:oj,boolean:tj}},shape:{string:["custom","ellipse","circle","database","box","text","image","circularImage","diamond","dot","star","triangle","triangleDown","square","icon","hexagon"]},ctxRenderer:{function:"function"},shapeProperties:{borderDashes:{boolean:tj,array:ij},borderRadius:{number:ej},interpolation:{boolean:tj},useImageSize:{boolean:tj},useBorderWithImage:{boolean:tj},coordinateOrigin:{string:["center","top-left"]},__type__:{object:oj}},size:{number:ej},title:{string:JA,dom:"dom",undefined:"undefined"},value:{number:ej,undefined:"undefined"},widthConstraint:{minimum:{number:ej},maximum:{number:ej},__type__:{object:oj,boolean:tj,number:ej}},x:{number:ej},y:{number:ej},__type__:{object:oj}},sj={configure:{enabled:{boolean:tj},filter:{boolean:tj,string:JA,array:ij,function:"function"},container:{dom:"dom"},showButton:{boolean:tj},__type__:{object:oj,boolean:tj,string:JA,array:ij,function:"function"}},edges:{arrows:{to:{enabled:{boolean:tj},scaleFactor:{number:ej},type:{string:nj},imageHeight:{number:ej},imageWidth:{number:ej},src:{string:JA},__type__:{object:oj,boolean:tj}},middle:{enabled:{boolean:tj},scaleFactor:{number:ej},type:{string:nj},imageWidth:{number:ej},imageHeight:{number:ej},src:{string:JA},__type__:{object:oj,boolean:tj}},from:{enabled:{boolean:tj},scaleFactor:{number:ej},type:{string:nj},imageWidth:{number:ej},imageHeight:{number:ej},src:{string:JA},__type__:{object:oj,boolean:tj}},__type__:{string:["from","to","middle"],object:oj}},endPointOffset:{from:{number:ej},to:{number:ej},__type__:{object:oj,number:ej}},arrowStrikethrough:{boolean:tj},background:{enabled:{boolean:tj},color:{string:JA},size:{number:ej},dashes:{boolean:tj,array:ij},__type__:{object:oj,boolean:tj}},chosen:{label:{boolean:tj,function:"function"},edge:{boolean:tj,function:"function"},__type__:{object:oj,boolean:tj}},color:{color:{string:JA},highlight:{string:JA},hover:{string:JA},inherit:{string:["from","to","both"],boolean:tj},opacity:{number:ej},__type__:{object:oj,string:JA}},dashes:{boolean:tj,array:ij},font:{color:{string:JA},size:{number:ej},face:{string:JA},background:{string:JA},strokeWidth:{number:ej},strokeColor:{string:JA},align:{string:["horizontal","top","middle","bottom"]},vadjust:{number:ej},multi:{boolean:tj,string:JA},bold:{color:{string:JA},size:{number:ej},face:{string:JA},mod:{string:JA},vadjust:{number:ej},__type__:{object:oj,string:JA}},boldital:{color:{string:JA},size:{number:ej},face:{string:JA},mod:{string:JA},vadjust:{number:ej},__type__:{object:oj,string:JA}},ital:{color:{string:JA},size:{number:ej},face:{string:JA},mod:{string:JA},vadjust:{number:ej},__type__:{object:oj,string:JA}},mono:{color:{string:JA},size:{number:ej},face:{string:JA},mod:{string:JA},vadjust:{number:ej},__type__:{object:oj,string:JA}},__type__:{object:oj,string:JA}},hidden:{boolean:tj},hoverWidth:{function:"function",number:ej},label:{string:JA,undefined:"undefined"},labelHighlightBold:{boolean:tj},length:{number:ej,undefined:"undefined"},physics:{boolean:tj},scaling:{min:{number:ej},max:{number:ej},label:{enabled:{boolean:tj},min:{number:ej},max:{number:ej},maxVisible:{number:ej},drawThreshold:{number:ej},__type__:{object:oj,boolean:tj}},customScalingFunction:{function:"function"},__type__:{object:oj}},selectionWidth:{function:"function",number:ej},selfReferenceSize:{number:ej},selfReference:{size:{number:ej},angle:{number:ej},renderBehindTheNode:{boolean:tj},__type__:{object:oj}},shadow:{enabled:{boolean:tj},color:{string:JA},size:{number:ej},x:{number:ej},y:{number:ej},__type__:{object:oj,boolean:tj}},smooth:{enabled:{boolean:tj},type:{string:["dynamic","continuous","discrete","diagonalCross","straightCross","horizontal","vertical","curvedCW","curvedCCW","cubicBezier"]},roundness:{number:ej},forceDirection:{string:["horizontal","vertical","none"],boolean:tj},__type__:{object:oj,boolean:tj}},title:{string:JA,undefined:"undefined"},width:{number:ej},widthConstraint:{maximum:{number:ej},__type__:{object:oj,boolean:tj,number:ej}},value:{number:ej,undefined:"undefined"},__type__:{object:oj}},groups:{useDefaultGroups:{boolean:tj},__any__:rj,__type__:{object:oj}},interaction:{dragNodes:{boolean:tj},dragView:{boolean:tj},hideEdgesOnDrag:{boolean:tj},hideEdgesOnZoom:{boolean:tj},hideNodesOnDrag:{boolean:tj},hover:{boolean:tj},keyboard:{enabled:{boolean:tj},speed:{x:{number:ej},y:{number:ej},zoom:{number:ej},__type__:{object:oj}},bindToWindow:{boolean:tj},autoFocus:{boolean:tj},__type__:{object:oj,boolean:tj}},multiselect:{boolean:tj},navigationButtons:{boolean:tj},selectable:{boolean:tj},selectConnectedEdges:{boolean:tj},hoverConnectedEdges:{boolean:tj},tooltipDelay:{number:ej},zoomView:{boolean:tj},zoomSpeed:{number:ej},__type__:{object:oj}},layout:{randomSeed:{undefined:"undefined",number:ej,string:JA},improvedLayout:{boolean:tj},clusterThreshold:{number:ej},hierarchical:{enabled:{boolean:tj},levelSeparation:{number:ej},nodeSpacing:{number:ej},treeSpacing:{number:ej},blockShifting:{boolean:tj},edgeMinimization:{boolean:tj},parentCentralization:{boolean:tj},direction:{string:["UD","DU","LR","RL"]},sortMethod:{string:["hubsize","directed"]},shakeTowards:{string:["leaves","roots"]},__type__:{object:oj,boolean:tj}},__type__:{object:oj}},manipulation:{enabled:{boolean:tj},initiallyActive:{boolean:tj},addNode:{boolean:tj,function:"function"},addEdge:{boolean:tj,function:"function"},editNode:{function:"function"},editEdge:{editWithoutDrag:{function:"function"},__type__:{object:oj,boolean:tj,function:"function"}},deleteNode:{boolean:tj,function:"function"},deleteEdge:{boolean:tj,function:"function"},controlNodeStyle:rj,__type__:{object:oj,boolean:tj}},nodes:rj,physics:{enabled:{boolean:tj},barnesHut:{theta:{number:ej},gravitationalConstant:{number:ej},centralGravity:{number:ej},springLength:{number:ej},springConstant:{number:ej},damping:{number:ej},avoidOverlap:{number:ej},__type__:{object:oj}},forceAtlas2Based:{theta:{number:ej},gravitationalConstant:{number:ej},centralGravity:{number:ej},springLength:{number:ej},springConstant:{number:ej},damping:{number:ej},avoidOverlap:{number:ej},__type__:{object:oj}},repulsion:{centralGravity:{number:ej},springLength:{number:ej},springConstant:{number:ej},nodeDistance:{number:ej},damping:{number:ej},__type__:{object:oj}},hierarchicalRepulsion:{centralGravity:{number:ej},springLength:{number:ej},springConstant:{number:ej},nodeDistance:{number:ej},damping:{number:ej},avoidOverlap:{number:ej},__type__:{object:oj}},maxVelocity:{number:ej},minVelocity:{number:ej},solver:{string:["barnesHut","repulsion","hierarchicalRepulsion","forceAtlas2Based"]},stabilization:{enabled:{boolean:tj},iterations:{number:ej},updateInterval:{number:ej},onlyDynamicEdges:{boolean:tj},fit:{boolean:tj},__type__:{object:oj,boolean:tj}},timestep:{number:ej},adaptiveTimestep:{boolean:tj},wind:{x:{number:ej},y:{number:ej},__type__:{object:oj}},__type__:{object:oj,boolean:tj}},autoResize:{boolean:tj},clickToUse:{boolean:tj},locale:{string:JA},locales:{__any__:{any:"any"},__type__:{object:oj}},height:{string:JA},width:{string:JA},__type__:{object:oj}},aj={nodes:{borderWidth:[1,0,10,1],borderWidthSelected:[2,0,10,1],color:{border:["color","#2B7CE9"],background:["color","#97C2FC"],highlight:{border:["color","#2B7CE9"],background:["color","#D2E5FF"]},hover:{border:["color","#2B7CE9"],background:["color","#D2E5FF"]}},opacity:[0,0,1,.1],fixed:{x:!1,y:!1},font:{color:["color","#343434"],size:[14,0,100,1],face:["arial","verdana","tahoma"],background:["color","none"],strokeWidth:[0,0,50,1],strokeColor:["color","#ffffff"]},hidden:!1,labelHighlightBold:!0,physics:!0,scaling:{min:[10,0,200,1],max:[30,0,200,1],label:{enabled:!1,min:[14,0,200,1],max:[30,0,200,1],maxVisible:[30,0,200,1],drawThreshold:[5,0,20,1]}},shadow:{enabled:!1,color:"rgba(0,0,0,0.5)",size:[10,0,20,1],x:[5,-30,30,1],y:[5,-30,30,1]},shape:["ellipse","box","circle","database","diamond","dot","square","star","text","triangle","triangleDown","hexagon"],shapeProperties:{borderDashes:!1,borderRadius:[6,0,20,1],interpolation:!0,useImageSize:!1},size:[25,0,200,1]},edges:{arrows:{to:{enabled:!1,scaleFactor:[1,0,3,.05],type:"arrow"},middle:{enabled:!1,scaleFactor:[1,0,3,.05],type:"arrow"},from:{enabled:!1,scaleFactor:[1,0,3,.05],type:"arrow"}},endPointOffset:{from:[0,-10,10,1],to:[0,-10,10,1]},arrowStrikethrough:!0,color:{color:["color","#848484"],highlight:["color","#848484"],hover:["color","#848484"],inherit:["from","to","both",!0,!1],opacity:[1,0,1,.05]},dashes:!1,font:{color:["color","#343434"],size:[14,0,100,1],face:["arial","verdana","tahoma"],background:["color","none"],strokeWidth:[2,0,50,1],strokeColor:["color","#ffffff"],align:["horizontal","top","middle","bottom"]},hidden:!1,hoverWidth:[1.5,0,5,.1],labelHighlightBold:!0,physics:!0,scaling:{min:[1,0,100,1],max:[15,0,100,1],label:{enabled:!0,min:[14,0,200,1],max:[30,0,200,1],maxVisible:[30,0,200,1],drawThreshold:[5,0,20,1]}},selectionWidth:[1.5,0,5,.1],selfReferenceSize:[20,0,200,1],selfReference:{size:[20,0,200,1],angle:[Math.PI/2,-6*Math.PI,6*Math.PI,Math.PI/8],renderBehindTheNode:!0},shadow:{enabled:!1,color:"rgba(0,0,0,0.5)",size:[10,0,20,1],x:[5,-30,30,1],y:[5,-30,30,1]},smooth:{enabled:!0,type:["dynamic","continuous","discrete","diagonalCross","straightCross","horizontal","vertical","curvedCW","curvedCCW","cubicBezier"],forceDirection:["horizontal","vertical","none"],roundness:[.5,0,1,.05]},width:[1,0,30,1]},layout:{hierarchical:{enabled:!1,levelSeparation:[150,20,500,5],nodeSpacing:[100,20,500,5],treeSpacing:[200,20,500,5],blockShifting:!0,edgeMinimization:!0,parentCentralization:!0,direction:["UD","DU","LR","RL"],sortMethod:["hubsize","directed"],shakeTowards:["leaves","roots"]}},interaction:{dragNodes:!0,dragView:!0,hideEdgesOnDrag:!1,hideEdgesOnZoom:!1,hideNodesOnDrag:!1,hover:!1,keyboard:{enabled:!1,speed:{x:[10,0,40,1],y:[10,0,40,1],zoom:[.02,0,.1,.005]},bindToWindow:!0,autoFocus:!0},multiselect:!1,navigationButtons:!1,selectable:!0,selectConnectedEdges:!0,hoverConnectedEdges:!0,tooltipDelay:[300,0,1e3,25],zoomView:!0,zoomSpeed:[1,.1,2,.1]},manipulation:{enabled:!1,initiallyActive:!1},physics:{enabled:!0,barnesHut:{theta:[.5,.1,1,.05],gravitationalConstant:[-2e3,-3e4,0,50],centralGravity:[.3,0,10,.05],springLength:[95,0,500,5],springConstant:[.04,0,1.2,.005],damping:[.09,0,1,.01],avoidOverlap:[0,0,1,.01]},forceAtlas2Based:{theta:[.5,.1,1,.05],gravitationalConstant:[-50,-500,0,1],centralGravity:[.01,0,1,.005],springLength:[95,0,500,5],springConstant:[.08,0,1.2,.005],damping:[.4,0,1,.01],avoidOverlap:[0,0,1,.01]},repulsion:{centralGravity:[.2,0,10,.05],springLength:[200,0,500,5],springConstant:[.05,0,1.2,.005],nodeDistance:[100,0,500,5],damping:[.09,0,1,.01]},hierarchicalRepulsion:{centralGravity:[.2,0,10,.05],springLength:[100,0,500,5],springConstant:[.01,0,1.2,.005],nodeDistance:[120,0,500,5],damping:[.09,0,1,.01],avoidOverlap:[0,0,1,.01]},maxVelocity:[50,0,150,1],minVelocity:[.1,.01,.5,.01],solver:["barnesHut","forceAtlas2Based","repulsion","hierarchicalRepulsion"],timestep:[.5,.01,1,.01],wind:{x:[0,-10,10,.1],y:[0,-10,10,.1]}}},hj=function(t,e,i){var o;return!(!Lg(t).call(t,"physics")||!Lg(o=aj.physics.solver).call(o,e)||i.physics.solver===e||"wind"===e)},lj=Object.freeze({__proto__:null,allOptions:sj,configuratorHideOption:hj,configureOptions:aj}),dj=function(){function t(){pu(this,t)}return Nf(t,[{key:"getDistances",value:function(t,e,i){for(var o={},n=t.edges,r=0;r<e.length;r++){var s={};o[e[r]]=s;for(var a=0;a<e.length;a++)s[e[a]]=r==a?0:1e9}for(var h=0;h<i.length;h++){var l=n[i[h]];!0===l.connected&&void 0!==o[l.fromId]&&void 0!==o[l.toId]&&(o[l.fromId][l.toId]=1,o[l.toId][l.fromId]=1)}for(var d=e.length,c=0;c<d;c++)for(var u=e[c],f=o[u],p=0;p<d-1;p++)for(var v=e[p],g=o[v],y=p+1;y<d;y++){var m=e[y],b=o[m],w=Math.min(g[m],g[u]+f[m]);g[m]=w,b[v]=w}return o}}]),t}(),cj=function(){function t(e,i,o){pu(this,t),this.body=e,this.springLength=i,this.springConstant=o,this.distanceSolver=new dj}return Nf(t,[{key:"setOptions",value:function(t){t&&(t.springLength&&(this.springLength=t.springLength),t.springConstant&&(this.springConstant=t.springConstant))}},{key:"solve",value:function(t,e){var i=arguments.length>2&&void 0!==arguments[2]&&arguments[2],o=this.distanceSolver.getDistances(this.body,t,e);this._createL_matrix(o),this._createK_matrix(o),this._createE_matrix();for(var n=0,r=Math.max(1e3,Math.min(10*this.body.nodeIndices.length,6e3)),s=1e9,a=0,h=0,l=0,d=0,c=0;s>.01&&n<r;){n+=1;var u=kp(this._getHighestEnergyNode(i),4);for(a=u[0],s=u[1],h=u[2],l=u[3],d=s,c=0;d>1&&c<5;){c+=1,this._moveNode(a,h,l);var f=kp(this._getEnergy(a),3);d=f[0],h=f[1],l=f[2]}}}},{key:"_getHighestEnergyNode",value:function(t){for(var e=this.body.nodeIndices,i=this.body.nodes,o=0,n=e[0],r=0,s=0,a=0;a<e.length;a++){var h=e[a];if(!0!==i[h].predefinedPosition||!0===i[h].isCluster&&!0===t||!0!==i[h].options.fixed.x||!0!==i[h].options.fixed.y){var l=kp(this._getEnergy(h),3),d=l[0],c=l[1],u=l[2];o<d&&(o=d,n=h,r=c,s=u)}}return[n,o,r,s]}},{key:"_getEnergy",value:function(t){var e=kp(this.E_sums[t],2),i=e[0],o=e[1];return[Math.sqrt(Math.pow(i,2)+Math.pow(o,2)),i,o]}},{key:"_moveNode",value:function(t,e,i){for(var o=this.body.nodeIndices,n=this.body.nodes,r=0,s=0,a=0,h=n[t].x,l=n[t].y,d=this.K_matrix[t],c=this.L_matrix[t],u=0;u<o.length;u++){var f=o[u];if(f!==t){var p=n[f].x,v=n[f].y,g=d[f],y=c[f],m=1/Math.pow(Math.pow(h-p,2)+Math.pow(l-v,2),1.5);r+=g*(1-y*Math.pow(l-v,2)*m),s+=g*(y*(h-p)*(l-v)*m),a+=g*(1-y*Math.pow(h-p,2)*m)}}var b=(e/r+i/s)/(s/r-a/s),w=-(s*b+e)/r;n[t].x+=w,n[t].y+=b,this._updateE_matrix(t)}},{key:"_createL_matrix",value:function(t){var e=this.body.nodeIndices,i=this.springLength;this.L_matrix=[];for(var o=0;o<e.length;o++){this.L_matrix[e[o]]={};for(var n=0;n<e.length;n++)this.L_matrix[e[o]][e[n]]=i*t[e[o]][e[n]]}}},{key:"_createK_matrix",value:function(t){var e=this.body.nodeIndices,i=this.springConstant;this.K_matrix=[];for(var o=0;o<e.length;o++){this.K_matrix[e[o]]={};for(var n=0;n<e.length;n++)this.K_matrix[e[o]][e[n]]=i*Math.pow(t[e[o]][e[n]],-2)}}},{key:"_createE_matrix",value:function(){var t=this.body.nodeIndices,e=this.body.nodes;this.E_matrix={},this.E_sums={};for(var i=0;i<t.length;i++)this.E_matrix[t[i]]=[];for(var o=0;o<t.length;o++){for(var n=t[o],r=e[n].x,s=e[n].y,a=0,h=0,l=o;l<t.length;l++){var d=t[l];if(d!==n){var c=e[d].x,u=e[d].y,f=1/Math.sqrt(Math.pow(r-c,2)+Math.pow(s-u,2));this.E_matrix[n][l]=[this.K_matrix[n][d]*(r-c-this.L_matrix[n][d]*(r-c)*f),this.K_matrix[n][d]*(s-u-this.L_matrix[n][d]*(s-u)*f)],this.E_matrix[d][o]=this.E_matrix[n][l],a+=this.E_matrix[n][l][0],h+=this.E_matrix[n][l][1]}}this.E_sums[n]=[a,h]}}},{key:"_updateE_matrix",value:function(t){for(var e=this.body.nodeIndices,i=this.body.nodes,o=this.E_matrix[t],n=this.K_matrix[t],r=this.L_matrix[t],s=i[t].x,a=i[t].y,h=0,l=0,d=0;d<e.length;d++){var c=e[d];if(c!==t){var u=o[d],f=u[0],p=u[1],v=i[c].x,g=i[c].y,y=1/Math.sqrt(Math.pow(s-v,2)+Math.pow(a-g,2)),m=n[c]*(s-v-r[c]*(s-v)*y),b=n[c]*(a-g-r[c]*(a-g)*y);o[d]=[m,b],h+=m,l+=b;var w=this.E_sums[c];w[0]+=m-f,w[1]+=b-p}}this.E_sums[t]=[h,l]}}]),t}();function uj(t,e,i){var o,n,r,s,a=this;if(!(this instanceof uj))throw new SyntaxError("Constructor must be called with the new operator");this.options={},this.defaultOptions={locale:"en",locales:c_,clickToUse:!1},wo(this.options,this.defaultOptions),this.body={container:t,nodes:{},nodeIndices:[],edges:{},edgeIndices:[],emitter:{on:Uo(o=this.on).call(o,this),off:Uo(n=this.off).call(n,this),emit:Uo(r=this.emit).call(r,this),once:Uo(s=this.once).call(s,this)},eventListeners:{onTap:function(){},onTouch:function(){},onDoubleTap:function(){},onHold:function(){},onDragStart:function(){},onDrag:function(){},onDragEnd:function(){},onMouseWheel:function(){},onPinch:function(){},onMouseMove:function(){},onRelease:function(){},onContext:function(){}},data:{nodes:null,edges:null},functions:{createNode:function(){},createEdge:function(){},getPointer:function(){}},modules:{},view:{scale:1,translation:{x:0,y:0}},selectionBox:{show:!1,position:{start:{x:0,y:0},end:{x:0,y:0}}}},this.bindEventListeners(),this.images=new f_((function(){return a.body.emitter.emit("_requestRedraw")})),this.groups=new VE,this.canvas=new rF(this.body),this.selectionHandler=new OA(this.body,this.canvas),this.interactionHandler=new uF(this.body,this.canvas,this.selectionHandler),this.view=new sF(this.body,this.canvas),this.renderer=new Jz(this.body,this.canvas),this.physics=new Gz(this.body),this.layoutEngine=new KA(this.body),this.clustering=new Qz(this.body),this.manipulation=new QA(this.body,this.canvas,this.selectionHandler,this.interactionHandler),this.nodesHandler=new PN(this.body,this.images,this.groups,this.layoutEngine),this.edgesHandler=new Az(this.body,this.images,this.groups),this.body.modules.kamadaKawai=new cj(this.body,150,.05),this.body.modules.clustering=this.clustering,this.canvas._create(),this.setOptions(i),this.setData(e)}function fj(t){for(var e in t)Object.prototype.hasOwnProperty.call(t,e)&&(t[e].redundant=t[e].used,t[e].used=[])}function pj(t){for(var e in t)if(Object.prototype.hasOwnProperty.call(t,e)&&t[e].redundant){for(var i=0;i<t[e].redundant.length;i++)t[e].redundant[i].parentNode.removeChild(t[e].redundant[i]);t[e].redundant=[]}}function vj(t,e,i){var o;return Object.prototype.hasOwnProperty.call(e,t)?e[t].redundant.length>0?(o=e[t].redundant[0],e[t].redundant.shift()):(o=document.createElementNS("http://www.w3.org/2000/svg",t),i.appendChild(o)):(o=document.createElementNS("http://www.w3.org/2000/svg",t),e[t]={used:[],redundant:[]},i.appendChild(o)),e[t].used.push(o),o}tn(uj.prototype),uj.prototype.setOptions=function(t){var e=this;if(null===t&&(t=void 0),void 0!==t){!0===Dk.validate(t,sj)&&console.error("%cErrors have been found in the supplied options object.",Pk);if(Wx(["locale","locales","clickToUse"],this.options,t),void 0!==t.locale&&(t.locale=function(t,e){try{var i=kp(e.split(/[-_ /]/,2),2),o=i[0],n=i[1],r=null!=o?o.toLowerCase():null,s=null!=n?n.toUpperCase():null;if(r&&s){var a,h=r+"-"+s;if(Object.prototype.hasOwnProperty.call(t,h))return h;console.warn(Np(a="Unknown variant ".concat(s," of language ")).call(a,r,"."))}if(r){var l=r;if(Object.prototype.hasOwnProperty.call(t,l))return l;console.warn("Unknown language ".concat(r))}return console.warn("Unknown locale ".concat(e,", falling back to English.")),"en"}catch(t){return console.error(t),console.warn("Unexpected error while normalizing locale ".concat(e,", falling back to English.")),"en"}}(t.locales||this.options.locales,t.locale)),t=this.layoutEngine.setOptions(t.layout,t),this.canvas.setOptions(t),this.groups.setOptions(t.groups),this.nodesHandler.setOptions(t.nodes),this.edgesHandler.setOptions(t.edges),this.physics.setOptions(t.physics),this.manipulation.setOptions(t.manipulation,t,this.options),this.interactionHandler.setOptions(t.interaction),this.renderer.setOptions(t.interaction),this.selectionHandler.setOptions(t.interaction),void 0!==t.groups&&this.body.emitter.emit("refreshNodes"),"configure"in t&&(this.configurator||(this.configurator=new Sk(this,this.body.container,aj,this.canvas.pixelRatio,hj)),this.configurator.setOptions(t.configure)),this.configurator&&!0===this.configurator.options.enabled){var i={nodes:{},edges:{},layout:{},interaction:{},manipulation:{},physics:{},global:{}};Vx(i.nodes,this.nodesHandler.options),Vx(i.edges,this.edgesHandler.options),Vx(i.layout,this.layoutEngine.options),Vx(i.interaction,this.selectionHandler.options),Vx(i.interaction,this.renderer.options),Vx(i.interaction,this.interactionHandler.options),Vx(i.manipulation,this.manipulation.options),Vx(i.physics,this.physics.options),Vx(i.global,this.canvas.options),Vx(i.global,this.options),this.configurator.setModuleOptions(i)}void 0!==t.clickToUse?!0===t.clickToUse?void 0===this.activator&&(this.activator=new Ok(this.canvas.frame),this.activator.on("change",(function(){e.body.emitter.emit("activate")}))):(void 0!==this.activator&&(this.activator.destroy(),delete this.activator),this.body.emitter.emit("activate")):this.body.emitter.emit("activate"),this.canvas.setSize(),this.body.emitter.emit("startSimulation")}},uj.prototype._updateVisibleIndices=function(){var t=this.body.nodes,e=this.body.edges;for(var i in this.body.nodeIndices=[],this.body.edgeIndices=[],t)Object.prototype.hasOwnProperty.call(t,i)&&(this.clustering._isClusteredNode(i)||!1!==t[i].options.hidden||this.body.nodeIndices.push(t[i].id));for(var o in e)if(Object.prototype.hasOwnProperty.call(e,o)){var n=e[o],r=t[n.fromId],s=t[n.toId],a=void 0!==r&&void 0!==s;!this.clustering._isClusteredEdge(o)&&!1===n.options.hidden&&a&&!1===r.options.hidden&&!1===s.options.hidden&&this.body.edgeIndices.push(n.id)}},uj.prototype.bindEventListeners=function(){var t=this;this.body.emitter.on("_dataChanged",(function(){t.edgesHandler._updateState(),t.body.emitter.emit("_dataUpdated")})),this.body.emitter.on("_dataUpdated",(function(){t.clustering._updateState(),t._updateVisibleIndices(),t._updateValueRange(t.body.nodes),t._updateValueRange(t.body.edges),t.body.emitter.emit("startSimulation"),t.body.emitter.emit("_requestRedraw")}))},uj.prototype.setData=function(t){if(this.body.emitter.emit("resetPhysics"),this.body.emitter.emit("_resetData"),this.selectionHandler.unselectAll(),t&&t.dot&&(t.nodes||t.edges))throw new SyntaxError('Data must contain either parameter "dot" or  parameter pair "nodes" and "edges", but not both.');if(this.setOptions(t&&t.options),t&&t.dot){console.warn("The dot property has been deprecated. Please use the static convertDot method to convert DOT into vis.network format and use the normal data format with nodes and edges. This converter is used like this: var data = vis.network.convertDot(dotString);");var e=a_(t.dot);this.setData(e)}else if(t&&t.gephi){console.warn("The gephi property has been deprecated. Please use the static convertGephi method to convert gephi into vis.network format and use the normal data format with nodes and edges. This converter is used like this: var data = vis.network.convertGephi(gephiJson);");var i=l_(t.gephi);this.setData(i)}else this.nodesHandler.setData(t&&t.nodes,!0),this.edgesHandler.setData(t&&t.edges,!0),this.body.emitter.emit("_dataChanged"),this.body.emitter.emit("_dataLoaded"),this.body.emitter.emit("initPhysics")},uj.prototype.destroy=function(){for(var t in this.body.emitter.emit("destroy"),this.body.emitter.off(),this.off(),delete this.groups,delete this.canvas,delete this.selectionHandler,delete this.interactionHandler,delete this.view,delete this.renderer,delete this.physics,delete this.layoutEngine,delete this.clustering,delete this.manipulation,delete this.nodesHandler,delete this.edgesHandler,delete this.configurator,delete this.images,this.body.nodes)Object.prototype.hasOwnProperty.call(this.body.nodes,t)&&delete this.body.nodes[t];for(var e in this.body.edges)Object.prototype.hasOwnProperty.call(this.body.edges,e)&&delete this.body.edges[e];Fx(this.body.container)},uj.prototype._updateValueRange=function(t){var e,i=void 0,o=void 0,n=0;for(e in t)if(Object.prototype.hasOwnProperty.call(t,e)){var r=t[e].getValue();void 0!==r&&(i=void 0===i?r:Math.min(r,i),o=void 0===o?r:Math.max(r,o),n+=r)}if(void 0!==i&&void 0!==o)for(e in t)Object.prototype.hasOwnProperty.call(t,e)&&t[e].setValueRange(i,o,n)},uj.prototype.isActive=function(){return!this.activator||this.activator.active},uj.prototype.setSize=function(){return this.canvas.setSize.apply(this.canvas,arguments)},uj.prototype.canvasToDOM=function(){return this.canvas.canvasToDOM.apply(this.canvas,arguments)},uj.prototype.DOMtoCanvas=function(){return this.canvas.DOMtoCanvas.apply(this.canvas,arguments)},uj.prototype.findNode=function(){return this.clustering.findNode.apply(this.clustering,arguments)},uj.prototype.isCluster=function(){return this.clustering.isCluster.apply(this.clustering,arguments)},uj.prototype.openCluster=function(){return this.clustering.openCluster.apply(this.clustering,arguments)},uj.prototype.cluster=function(){return this.clustering.cluster.apply(this.clustering,arguments)},uj.prototype.getNodesInCluster=function(){return this.clustering.getNodesInCluster.apply(this.clustering,arguments)},uj.prototype.clusterByConnection=function(){return this.clustering.clusterByConnection.apply(this.clustering,arguments)},uj.prototype.clusterByHubsize=function(){return this.clustering.clusterByHubsize.apply(this.clustering,arguments)},uj.prototype.updateClusteredNode=function(){return this.clustering.updateClusteredNode.apply(this.clustering,arguments)},uj.prototype.getClusteredEdges=function(){return this.clustering.getClusteredEdges.apply(this.clustering,arguments)},uj.prototype.getBaseEdge=function(){return this.clustering.getBaseEdge.apply(this.clustering,arguments)},uj.prototype.getBaseEdges=function(){return this.clustering.getBaseEdges.apply(this.clustering,arguments)},uj.prototype.updateEdge=function(){return this.clustering.updateEdge.apply(this.clustering,arguments)},uj.prototype.clusterOutliers=function(){return this.clustering.clusterOutliers.apply(this.clustering,arguments)},uj.prototype.getSeed=function(){return this.layoutEngine.getSeed.apply(this.layoutEngine,arguments)},uj.prototype.enableEditMode=function(){return this.manipulation.enableEditMode.apply(this.manipulation,arguments)},uj.prototype.disableEditMode=function(){return this.manipulation.disableEditMode.apply(this.manipulation,arguments)},uj.prototype.addNodeMode=function(){return this.manipulation.addNodeMode.apply(this.manipulation,arguments)},uj.prototype.editNode=function(){return this.manipulation.editNode.apply(this.manipulation,arguments)},uj.prototype.editNodeMode=function(){return console.warn("Deprecated: Please use editNode instead of editNodeMode."),this.manipulation.editNode.apply(this.manipulation,arguments)},uj.prototype.addEdgeMode=function(){return this.manipulation.addEdgeMode.apply(this.manipulation,arguments)},uj.prototype.editEdgeMode=function(){return this.manipulation.editEdgeMode.apply(this.manipulation,arguments)},uj.prototype.deleteSelected=function(){return this.manipulation.deleteSelected.apply(this.manipulation,arguments)},uj.prototype.getPositions=function(){return this.nodesHandler.getPositions.apply(this.nodesHandler,arguments)},uj.prototype.getPosition=function(){return this.nodesHandler.getPosition.apply(this.nodesHandler,arguments)},uj.prototype.storePositions=function(){return this.nodesHandler.storePositions.apply(this.nodesHandler,arguments)},uj.prototype.moveNode=function(){return this.nodesHandler.moveNode.apply(this.nodesHandler,arguments)},uj.prototype.getBoundingBox=function(){return this.nodesHandler.getBoundingBox.apply(this.nodesHandler,arguments)},uj.prototype.getConnectedNodes=function(t){return void 0!==this.body.nodes[t]?this.nodesHandler.getConnectedNodes.apply(this.nodesHandler,arguments):this.edgesHandler.getConnectedNodes.apply(this.edgesHandler,arguments)},uj.prototype.getConnectedEdges=function(){return this.nodesHandler.getConnectedEdges.apply(this.nodesHandler,arguments)},uj.prototype.startSimulation=function(){return this.physics.startSimulation.apply(this.physics,arguments)},uj.prototype.stopSimulation=function(){return this.physics.stopSimulation.apply(this.physics,arguments)},uj.prototype.stabilize=function(){return this.physics.stabilize.apply(this.physics,arguments)},uj.prototype.getSelection=function(){return this.selectionHandler.getSelection.apply(this.selectionHandler,arguments)},uj.prototype.setSelection=function(){return this.selectionHandler.setSelection.apply(this.selectionHandler,arguments)},uj.prototype.getSelectedNodes=function(){return this.selectionHandler.getSelectedNodeIds.apply(this.selectionHandler,arguments)},uj.prototype.getSelectedEdges=function(){return this.selectionHandler.getSelectedEdgeIds.apply(this.selectionHandler,arguments)},uj.prototype.getNodeAt=function(){var t=this.selectionHandler.getNodeAt.apply(this.selectionHandler,arguments);return void 0!==t&&void 0!==t.id?t.id:t},uj.prototype.getEdgeAt=function(){var t=this.selectionHandler.getEdgeAt.apply(this.selectionHandler,arguments);return void 0!==t&&void 0!==t.id?t.id:t},uj.prototype.selectNodes=function(){return this.selectionHandler.selectNodes.apply(this.selectionHandler,arguments)},uj.prototype.selectEdges=function(){return this.selectionHandler.selectEdges.apply(this.selectionHandler,arguments)},uj.prototype.unselectAll=function(){this.selectionHandler.unselectAll.apply(this.selectionHandler,arguments),this.selectionHandler.commitWithoutEmitting.apply(this.selectionHandler),this.redraw()},uj.prototype.redraw=function(){return this.renderer.redraw.apply(this.renderer,arguments)},uj.prototype.getScale=function(){return this.view.getScale.apply(this.view,arguments)},uj.prototype.getViewPosition=function(){return this.view.getViewPosition.apply(this.view,arguments)},uj.prototype.fit=function(){return this.view.fit.apply(this.view,arguments)},uj.prototype.moveTo=function(){return this.view.moveTo.apply(this.view,arguments)},uj.prototype.focus=function(){return this.view.focus.apply(this.view,arguments)},uj.prototype.releaseNode=function(){return this.view.releaseNode.apply(this.view,arguments)},uj.prototype.getOptionsFromConfigurator=function(){var t={};return this.configurator&&(t=this.configurator.getOptions.apply(this.configurator)),t};var gj=Object.freeze({__proto__:null,cleanupElements:pj,drawBar:function(t,e,i,o,n,r,s,a){if(0!=o){o<0&&(e-=o*=-1);var h=vj("rect",r,s);h.setAttributeNS(null,"x",t-.5*i),h.setAttributeNS(null,"y",e),h.setAttributeNS(null,"width",i),h.setAttributeNS(null,"height",o),h.setAttributeNS(null,"class",n),a&&h.setAttributeNS(null,"style",a)}},drawPoint:function(t,e,i,o,n,r){var s;if("circle"==i.style?((s=vj("circle",o,n)).setAttributeNS(null,"cx",t),s.setAttributeNS(null,"cy",e),s.setAttributeNS(null,"r",.5*i.size)):((s=vj("rect",o,n)).setAttributeNS(null,"x",t-.5*i.size),s.setAttributeNS(null,"y",e-.5*i.size),s.setAttributeNS(null,"width",i.size),s.setAttributeNS(null,"height",i.size)),void 0!==i.styles&&s.setAttributeNS(null,"style",i.styles),s.setAttributeNS(null,"class",i.className+" vis-point"),r){var a=vj("text",o,n);r.xOffset&&(t+=r.xOffset),r.yOffset&&(e+=r.yOffset),r.content&&(a.textContent=r.content),r.className&&a.setAttributeNS(null,"class",r.className+" vis-label"),a.setAttributeNS(null,"x",t),a.setAttributeNS(null,"y",e)}return s},getDOMElement:function(t,e,i,o){var n;return Object.prototype.hasOwnProperty.call(e,t)?e[t].redundant.length>0?(n=e[t].redundant[0],e[t].redundant.shift()):(n=document.createElement(t),void 0!==o?i.insertBefore(n,o):i.appendChild(n)):(n=document.createElement(t),e[t]={used:[],redundant:[]},void 0!==o?i.insertBefore(n,o):i.appendChild(n)),e[t].used.push(n),n},getSVGElement:vj,prepareElements:fj,resetElements:function(t){fj(t),pj(t),fj(t)}}),yj={Images:f_,dotparser:h_,gephiParser:d_,allOptions:lj,convertDot:a_,convertGephi:l_},mj=Object.freeze({__proto__:null,DOMutil:gj,DataSet:iB,DataView:oB,Hammer:Tk,Network:uj,Queue:JI,data:sB,keycharm:hF,network:yj,util:Ik});export{gj as DOMutil,iB as DataSet,oB as DataView,Tk as Hammer,uj as Network,JI as Queue,sB as data,mj as default,hF as keycharm,yj as network,Ik as util};
//# sourceMappingURL=vis-network.esm.min.js.map
