/**
 * vis-network
 * https://visjs.github.io/vis-network/
 *
 * A dynamic, browser-based visualization library.
 *
 * @version 9.1.6
 * @date    2023-03-23T21:33:31.534Z
 *
 * @copyright (c) 2011-2017 Almende B.V, http://almende.com
 * @copyright (c) 2017-2019 visjs contributors, https://github.com/visjs
 *
 * @license
 * vis.js is dual licensed under both
 *
 *   1. The Apache 2.0 License
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *   and
 *
 *   2. The MIT License
 *      http://opensource.org/licenses/MIT
 *
 * vis.js may be distributed under either license.
 */
!function(t,e){"object"==typeof exports&&"undefined"!=typeof module?e(exports):"function"==typeof define&&define.amd?define(["exports"],e):e((t="undefined"!=typeof globalThis?globalThis:t||self).vis=t.vis||{})}(this,(function(t){"use strict";var e="undefined"!=typeof globalThis?globalThis:"undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self?self:{};function i(t){return t&&t.__esModule&&Object.prototype.hasOwnProperty.call(t,"default")?t.default:t}var n={},o={get exports(){return n},set exports(t){n=t}},r=function(t){return t&&t.Math==Math&&t},s=r("object"==typeof globalThis&&globalThis)||r("object"==typeof window&&window)||r("object"==typeof self&&self)||r("object"==typeof e&&e)||function(){return this}()||Function("return this")(),a=function(t){try{return!!t()}catch(t){return!0}},h=!a((function(){var t=function(){}.bind();return"function"!=typeof t||t.hasOwnProperty("prototype")})),l=h,d=Function.prototype,c=d.apply,u=d.call,f="object"==typeof Reflect&&Reflect.apply||(l?u.bind(c):function(){return u.apply(c,arguments)}),p=h,v=Function.prototype,g=v.call,y=p&&v.bind.bind(g,g),m=p?y:function(t){return function(){return g.apply(t,arguments)}},b=m,w=b({}.toString),x=b("".slice),k=function(t){return x(w(t),8,-1)},_=k,E=m,O=function(t){if("Function"===_(t))return E(t)},C="object"==typeof document&&document.all,S={all:C,IS_HTMLDDA:void 0===C&&void 0!==C},T=S.all,M=S.IS_HTMLDDA?function(t){return"function"==typeof t||t===T}:function(t){return"function"==typeof t},P={},D=!a((function(){return 7!=Object.defineProperty({},1,{get:function(){return 7}})[1]})),I=h,B=Function.prototype.call,N=I?B.bind(B):function(){return B.apply(B,arguments)},z={},F={}.propertyIsEnumerable,A=Object.getOwnPropertyDescriptor,j=A&&!F.call({1:2},1);z.f=j?function(t){var e=A(this,t);return!!e&&e.enumerable}:F;var R,L,H=function(t,e){return{enumerable:!(1&t),configurable:!(2&t),writable:!(4&t),value:e}},W=a,q=k,V=Object,U=m("".split),Y=W((function(){return!V("z").propertyIsEnumerable(0)}))?function(t){return"String"==q(t)?U(t,""):V(t)}:V,X=function(t){return null==t},G=X,K=TypeError,$=function(t){if(G(t))throw K("Can't call method on "+t);return t},Z=Y,Q=$,J=function(t){return Z(Q(t))},tt=M,et=S.all,it=S.IS_HTMLDDA?function(t){return"object"==typeof t?null!==t:tt(t)||t===et}:function(t){return"object"==typeof t?null!==t:tt(t)},nt={},ot=nt,rt=s,st=M,at=function(t){return st(t)?t:void 0},ht=function(t,e){return arguments.length<2?at(ot[t])||at(rt[t]):ot[t]&&ot[t][e]||rt[t]&&rt[t][e]},lt=m({}.isPrototypeOf),dt="undefined"!=typeof navigator&&String(navigator.userAgent)||"",ct=s,ut=dt,ft=ct.process,pt=ct.Deno,vt=ft&&ft.versions||pt&&pt.version,gt=vt&&vt.v8;gt&&(L=(R=gt.split("."))[0]>0&&R[0]<4?1:+(R[0]+R[1])),!L&&ut&&(!(R=ut.match(/Edge\/(\d+)/))||R[1]>=74)&&(R=ut.match(/Chrome\/(\d+)/))&&(L=+R[1]);var yt=L,mt=yt,bt=a,wt=!!Object.getOwnPropertySymbols&&!bt((function(){var t=Symbol();return!String(t)||!(Object(t)instanceof Symbol)||!Symbol.sham&&mt&&mt<41})),xt=wt&&!Symbol.sham&&"symbol"==typeof Symbol.iterator,kt=ht,_t=M,Et=lt,Ot=Object,Ct=xt?function(t){return"symbol"==typeof t}:function(t){var e=kt("Symbol");return _t(e)&&Et(e.prototype,Ot(t))},St=String,Tt=function(t){try{return St(t)}catch(t){return"Object"}},Mt=M,Pt=Tt,Dt=TypeError,It=function(t){if(Mt(t))return t;throw Dt(Pt(t)+" is not a function")},Bt=It,Nt=X,zt=function(t,e){var i=t[e];return Nt(i)?void 0:Bt(i)},Ft=N,At=M,jt=it,Rt=TypeError,Lt={},Ht={get exports(){return Lt},set exports(t){Lt=t}},Wt=s,qt=Object.defineProperty,Vt=function(t,e){try{qt(Wt,t,{value:e,configurable:!0,writable:!0})}catch(i){Wt[t]=e}return e},Ut="__core-js_shared__",Yt=s[Ut]||Vt(Ut,{}),Xt=Yt;(Ht.exports=function(t,e){return Xt[t]||(Xt[t]=void 0!==e?e:{})})("versions",[]).push({version:"3.29.0",mode:"pure",copyright:"© 2014-2023 Denis Pushkarev (zloirock.ru)",license:"https://github.com/zloirock/core-js/blob/v3.29.0/LICENSE",source:"https://github.com/zloirock/core-js"});var Gt=$,Kt=Object,$t=function(t){return Kt(Gt(t))},Zt=$t,Qt=m({}.hasOwnProperty),Jt=Object.hasOwn||function(t,e){return Qt(Zt(t),e)},te=m,ee=0,ie=Math.random(),ne=te(1..toString),oe=function(t){return"Symbol("+(void 0===t?"":t)+")_"+ne(++ee+ie,36)},re=Lt,se=Jt,ae=oe,he=wt,le=xt,de=s.Symbol,ce=re("wks"),ue=le?de.for||de:de&&de.withoutSetter||ae,fe=function(t){return se(ce,t)||(ce[t]=he&&se(de,t)?de[t]:ue("Symbol."+t)),ce[t]},pe=N,ve=it,ge=Ct,ye=zt,me=function(t,e){var i,n;if("string"===e&&At(i=t.toString)&&!jt(n=Ft(i,t)))return n;if(At(i=t.valueOf)&&!jt(n=Ft(i,t)))return n;if("string"!==e&&At(i=t.toString)&&!jt(n=Ft(i,t)))return n;throw Rt("Can't convert object to primitive value")},be=TypeError,we=fe("toPrimitive"),xe=function(t,e){if(!ve(t)||ge(t))return t;var i,n=ye(t,we);if(n){if(void 0===e&&(e="default"),i=pe(n,t,e),!ve(i)||ge(i))return i;throw be("Can't convert object to primitive value")}return void 0===e&&(e="number"),me(t,e)},ke=Ct,_e=function(t){var e=xe(t,"string");return ke(e)?e:e+""},Ee=it,Oe=s.document,Ce=Ee(Oe)&&Ee(Oe.createElement),Se=function(t){return Ce?Oe.createElement(t):{}},Te=Se,Me=!D&&!a((function(){return 7!=Object.defineProperty(Te("div"),"a",{get:function(){return 7}}).a})),Pe=D,De=N,Ie=z,Be=H,Ne=J,ze=_e,Fe=Jt,Ae=Me,je=Object.getOwnPropertyDescriptor;P.f=Pe?je:function(t,e){if(t=Ne(t),e=ze(e),Ae)try{return je(t,e)}catch(t){}if(Fe(t,e))return Be(!De(Ie.f,t,e),t[e])};var Re=a,Le=M,He=/#|\.prototype\./,We=function(t,e){var i=Ve[qe(t)];return i==Ye||i!=Ue&&(Le(e)?Re(e):!!e)},qe=We.normalize=function(t){return String(t).replace(He,".").toLowerCase()},Ve=We.data={},Ue=We.NATIVE="N",Ye=We.POLYFILL="P",Xe=We,Ge=It,Ke=h,$e=O(O.bind),Ze=function(t,e){return Ge(t),void 0===e?t:Ke?$e(t,e):function(){return t.apply(e,arguments)}},Qe={},Je=D&&a((function(){return 42!=Object.defineProperty((function(){}),"prototype",{value:42,writable:!1}).prototype})),ti=it,ei=String,ii=TypeError,ni=function(t){if(ti(t))return t;throw ii(ei(t)+" is not an object")},oi=D,ri=Me,si=Je,ai=ni,hi=_e,li=TypeError,di=Object.defineProperty,ci=Object.getOwnPropertyDescriptor,ui="enumerable",fi="configurable",pi="writable";Qe.f=oi?si?function(t,e,i){if(ai(t),e=hi(e),ai(i),"function"==typeof t&&"prototype"===e&&"value"in i&&pi in i&&!i[pi]){var n=ci(t,e);n&&n[pi]&&(t[e]=i.value,i={configurable:fi in i?i[fi]:n[fi],enumerable:ui in i?i[ui]:n[ui],writable:!1})}return di(t,e,i)}:di:function(t,e,i){if(ai(t),e=hi(e),ai(i),ri)try{return di(t,e,i)}catch(t){}if("get"in i||"set"in i)throw li("Accessors not supported");return"value"in i&&(t[e]=i.value),t};var vi=Qe,gi=H,yi=D?function(t,e,i){return vi.f(t,e,gi(1,i))}:function(t,e,i){return t[e]=i,t},mi=s,bi=f,wi=O,xi=M,ki=P.f,_i=Xe,Ei=nt,Oi=Ze,Ci=yi,Si=Jt,Ti=function(t){var e=function(i,n,o){if(this instanceof e){switch(arguments.length){case 0:return new t;case 1:return new t(i);case 2:return new t(i,n)}return new t(i,n,o)}return bi(t,this,arguments)};return e.prototype=t.prototype,e},Mi=function(t,e){var i,n,o,r,s,a,h,l,d,c=t.target,u=t.global,f=t.stat,p=t.proto,v=u?mi:f?mi[c]:(mi[c]||{}).prototype,g=u?Ei:Ei[c]||Ci(Ei,c,{})[c],y=g.prototype;for(r in e)n=!(i=_i(u?r:c+(f?".":"#")+r,t.forced))&&v&&Si(v,r),a=g[r],n&&(h=t.dontCallGetSet?(d=ki(v,r))&&d.value:v[r]),s=n&&h?h:e[r],n&&typeof a==typeof s||(l=t.bind&&n?Oi(s,mi):t.wrap&&n?Ti(s):p&&xi(s)?wi(s):s,(t.sham||s&&s.sham||a&&a.sham)&&Ci(l,"sham",!0),Ci(g,r,l),p&&(Si(Ei,o=c+"Prototype")||Ci(Ei,o,{}),Ci(Ei[o],r,s),t.real&&y&&(i||!y[r])&&Ci(y,r,s)))},Pi=Math.ceil,Di=Math.floor,Ii=Math.trunc||function(t){var e=+t;return(e>0?Di:Pi)(e)},Bi=function(t){var e=+t;return e!=e||0===e?0:Ii(e)},Ni=Bi,zi=Math.max,Fi=Math.min,Ai=function(t,e){var i=Ni(t);return i<0?zi(i+e,0):Fi(i,e)},ji=Bi,Ri=Math.min,Li=function(t){return t>0?Ri(ji(t),9007199254740991):0},Hi=function(t){return Li(t.length)},Wi=J,qi=Ai,Vi=Hi,Ui=function(t){return function(e,i,n){var o,r=Wi(e),s=Vi(r),a=qi(n,s);if(t&&i!=i){for(;s>a;)if((o=r[a++])!=o)return!0}else for(;s>a;a++)if((t||a in r)&&r[a]===i)return t||a||0;return!t&&-1}},Yi={includes:Ui(!0),indexOf:Ui(!1)},Xi={},Gi=Jt,Ki=J,$i=Yi.indexOf,Zi=Xi,Qi=m([].push),Ji=function(t,e){var i,n=Ki(t),o=0,r=[];for(i in n)!Gi(Zi,i)&&Gi(n,i)&&Qi(r,i);for(;e.length>o;)Gi(n,i=e[o++])&&(~$i(r,i)||Qi(r,i));return r},tn=["constructor","hasOwnProperty","isPrototypeOf","propertyIsEnumerable","toLocaleString","toString","valueOf"],en=Ji,nn=tn,on=Object.keys||function(t){return en(t,nn)},rn={};rn.f=Object.getOwnPropertySymbols;var sn=D,an=m,hn=N,ln=a,dn=on,cn=rn,un=z,fn=$t,pn=Y,vn=Object.assign,gn=Object.defineProperty,yn=an([].concat),mn=!vn||ln((function(){if(sn&&1!==vn({b:1},vn(gn({},"a",{enumerable:!0,get:function(){gn(this,"b",{value:3,enumerable:!1})}}),{b:2})).b)return!0;var t={},e={},i=Symbol(),n="abcdefghijklmnopqrst";return t[i]=7,n.split("").forEach((function(t){e[t]=t})),7!=vn({},t)[i]||dn(vn({},e)).join("")!=n}))?function(t,e){for(var i=fn(t),n=arguments.length,o=1,r=cn.f,s=un.f;n>o;)for(var a,h=pn(arguments[o++]),l=r?yn(dn(h),r(h)):dn(h),d=l.length,c=0;d>c;)a=l[c++],sn&&!hn(s,h,a)||(i[a]=h[a]);return i}:vn,bn=mn;Mi({target:"Object",stat:!0,arity:2,forced:Object.assign!==bn},{assign:bn});var wn=nt.Object.assign;!function(t){t.exports=wn}(o);var xn=i(n),kn={},_n={get exports(){return kn},set exports(t){kn=t}},En=m([].slice),On=m,Cn=It,Sn=it,Tn=Jt,Mn=En,Pn=h,Dn=Function,In=On([].concat),Bn=On([].join),Nn={},zn=function(t,e,i){if(!Tn(Nn,e)){for(var n=[],o=0;o<e;o++)n[o]="a["+o+"]";Nn[e]=Dn("C,a","return new C("+Bn(n,",")+")")}return Nn[e](t,i)},Fn=Pn?Dn.bind:function(t){var e=Cn(this),i=e.prototype,n=Mn(arguments,1),o=function(){var i=In(n,Mn(arguments));return this instanceof o?zn(e,i.length,i):e.apply(t,i)};return Sn(i)&&(o.prototype=i),o},An=Fn;Mi({target:"Function",proto:!0,forced:Function.bind!==An},{bind:An});var jn=nt,Rn=function(t){return jn[t+"Prototype"]},Ln=Rn("Function").bind,Hn=lt,Wn=Ln,qn=Function.prototype,Vn=function(t){var e=t.bind;return t===qn||Hn(qn,t)&&e===qn.bind?Wn:e},Un=Vn;!function(t){t.exports=Un}(_n);var Yn=i(kn);function Xn(t,e,i,n){t.beginPath(),t.arc(e,i,n,0,2*Math.PI,!1),t.closePath()}function Gn(t,e,i,n,o,r){var s=Math.PI/180;n-2*r<0&&(r=n/2),o-2*r<0&&(r=o/2),t.beginPath(),t.moveTo(e+r,i),t.lineTo(e+n-r,i),t.arc(e+n-r,i+r,r,270*s,360*s,!1),t.lineTo(e+n,i+o-r),t.arc(e+n-r,i+o-r,r,0,90*s,!1),t.lineTo(e+r,i+o),t.arc(e+r,i+o-r,r,90*s,180*s,!1),t.lineTo(e,i+r),t.arc(e+r,i+r,r,180*s,270*s,!1),t.closePath()}function Kn(t,e,i,n,o){var r=.5522848,s=n/2*r,a=o/2*r,h=e+n,l=i+o,d=e+n/2,c=i+o/2;t.beginPath(),t.moveTo(e,c),t.bezierCurveTo(e,c-a,d-s,i,d,i),t.bezierCurveTo(d+s,i,h,c-a,h,c),t.bezierCurveTo(h,c+a,d+s,l,d,l),t.bezierCurveTo(d-s,l,e,c+a,e,c),t.closePath()}function $n(t,e,i,n,o){var r=o*(1/3),s=.5522848,a=n/2*s,h=r/2*s,l=e+n,d=i+r,c=e+n/2,u=i+r/2,f=i+(o-r/2),p=i+o;t.beginPath(),t.moveTo(l,u),t.bezierCurveTo(l,u+h,c+a,d,c,d),t.bezierCurveTo(c-a,d,e,u+h,e,u),t.bezierCurveTo(e,u-h,c-a,i,c,i),t.bezierCurveTo(c+a,i,l,u-h,l,u),t.lineTo(l,f),t.bezierCurveTo(l,f+h,c+a,p,c,p),t.bezierCurveTo(c-a,p,e,f+h,e,f),t.lineTo(e,u)}function Zn(t,e,i,n,o,r){t.beginPath(),t.moveTo(e,i);for(var s=r.length,a=n-e,h=o-i,l=h/a,d=Math.sqrt(a*a+h*h),c=0,u=!0,f=0,p=+r[0];d>=.1;)(p=+r[c++%s])>d&&(p=d),f=Math.sqrt(p*p/(1+l*l)),e+=f=a<0?-f:f,i+=l*f,!0===u?t.lineTo(e,i):t.moveTo(e,i),d-=p,u=!u}var Qn={circle:Xn,dashedLine:Zn,database:$n,diamond:function(t,e,i,n){t.beginPath(),t.lineTo(e,i+n),t.lineTo(e+n,i),t.lineTo(e,i-n),t.lineTo(e-n,i),t.closePath()},ellipse:Kn,ellipse_vis:Kn,hexagon:function(t,e,i,n){t.beginPath();var o=2*Math.PI/6;t.moveTo(e+n,i);for(var r=1;r<6;r++)t.lineTo(e+n*Math.cos(o*r),i+n*Math.sin(o*r));t.closePath()},roundRect:Gn,square:function(t,e,i,n){t.beginPath(),t.rect(e-n,i-n,2*n,2*n),t.closePath()},star:function(t,e,i,n){t.beginPath(),i+=.1*(n*=.82);for(var o=0;o<10;o++){var r=o%2==0?1.3*n:.5*n;t.lineTo(e+r*Math.sin(2*o*Math.PI/10),i-r*Math.cos(2*o*Math.PI/10))}t.closePath()},triangle:function(t,e,i,n){t.beginPath(),i+=.275*(n*=1.15);var o=2*n,r=o/2,s=Math.sqrt(3)/6*o,a=Math.sqrt(o*o-r*r);t.moveTo(e,i-(a-s)),t.lineTo(e+r,i+s),t.lineTo(e-r,i+s),t.lineTo(e,i-(a-s)),t.closePath()},triangleDown:function(t,e,i,n){t.beginPath(),i-=.275*(n*=1.15);var o=2*n,r=o/2,s=Math.sqrt(3)/6*o,a=Math.sqrt(o*o-r*r);t.moveTo(e,i+(a-s)),t.lineTo(e+r,i-s),t.lineTo(e-r,i-s),t.lineTo(e,i+(a-s)),t.closePath()}};var Jn={};!function(t){function e(t){if(t)return function(t){for(var i in e.prototype)t[i]=e.prototype[i];return t}(t)}t.exports=e,e.prototype.on=e.prototype.addEventListener=function(t,e){return this._callbacks=this._callbacks||{},(this._callbacks["$"+t]=this._callbacks["$"+t]||[]).push(e),this},e.prototype.once=function(t,e){function i(){this.off(t,i),e.apply(this,arguments)}return i.fn=e,this.on(t,i),this},e.prototype.off=e.prototype.removeListener=e.prototype.removeAllListeners=e.prototype.removeEventListener=function(t,e){if(this._callbacks=this._callbacks||{},0==arguments.length)return this._callbacks={},this;var i,n=this._callbacks["$"+t];if(!n)return this;if(1==arguments.length)return delete this._callbacks["$"+t],this;for(var o=0;o<n.length;o++)if((i=n[o])===e||i.fn===e){n.splice(o,1);break}return 0===n.length&&delete this._callbacks["$"+t],this},e.prototype.emit=function(t){this._callbacks=this._callbacks||{};for(var e=new Array(arguments.length-1),i=this._callbacks["$"+t],n=1;n<arguments.length;n++)e[n-1]=arguments[n];if(i){n=0;for(var o=(i=i.slice(0)).length;n<o;++n)i[n].apply(this,e)}return this},e.prototype.listeners=function(t){return this._callbacks=this._callbacks||{},this._callbacks["$"+t]||[]},e.prototype.hasListeners=function(t){return!!this.listeners(t).length}}({get exports(){return Jn},set exports(t){Jn=t}});var to=Jn,eo={},io={get exports(){return eo},set exports(t){eo=t}},no={};no[fe("toStringTag")]="z";var oo,ro,so,ao="[object z]"===String(no),ho=ao,lo=M,co=k,uo=fe("toStringTag"),fo=Object,po="Arguments"==co(function(){return arguments}()),vo=ho?co:function(t){var e,i,n;return void 0===t?"Undefined":null===t?"Null":"string"==typeof(i=function(t,e){try{return t[e]}catch(t){}}(e=fo(t),uo))?i:po?co(e):"Object"==(n=co(e))&&lo(e.callee)?"Arguments":n},go=vo,yo=String,mo=function(t){if("Symbol"===go(t))throw TypeError("Cannot convert a Symbol value to a string");return yo(t)},bo=m,wo=Bi,xo=mo,ko=$,_o=bo("".charAt),Eo=bo("".charCodeAt),Oo=bo("".slice),Co=function(t){return function(e,i){var n,o,r=xo(ko(e)),s=wo(i),a=r.length;return s<0||s>=a?t?"":void 0:(n=Eo(r,s))<55296||n>56319||s+1===a||(o=Eo(r,s+1))<56320||o>57343?t?_o(r,s):n:t?Oo(r,s,s+2):o-56320+(n-55296<<10)+65536}},So={codeAt:Co(!1),charAt:Co(!0)},To=M,Mo=s.WeakMap,Po=To(Mo)&&/native code/.test(String(Mo)),Do=oe,Io=Lt("keys"),Bo=function(t){return Io[t]||(Io[t]=Do(t))},No=Po,zo=s,Fo=it,Ao=yi,jo=Jt,Ro=Yt,Lo=Bo,Ho=Xi,Wo="Object already initialized",qo=zo.TypeError,Vo=zo.WeakMap;if(No||Ro.state){var Uo=Ro.state||(Ro.state=new Vo);Uo.get=Uo.get,Uo.has=Uo.has,Uo.set=Uo.set,oo=function(t,e){if(Uo.has(t))throw qo(Wo);return e.facade=t,Uo.set(t,e),e},ro=function(t){return Uo.get(t)||{}},so=function(t){return Uo.has(t)}}else{var Yo=Lo("state");Ho[Yo]=!0,oo=function(t,e){if(jo(t,Yo))throw qo(Wo);return e.facade=t,Ao(t,Yo,e),e},ro=function(t){return jo(t,Yo)?t[Yo]:{}},so=function(t){return jo(t,Yo)}}var Xo={set:oo,get:ro,has:so,enforce:function(t){return so(t)?ro(t):oo(t,{})},getterFor:function(t){return function(e){var i;if(!Fo(e)||(i=ro(e)).type!==t)throw qo("Incompatible receiver, "+t+" required");return i}}},Go=D,Ko=Jt,$o=Function.prototype,Zo=Go&&Object.getOwnPropertyDescriptor,Qo=Ko($o,"name"),Jo={EXISTS:Qo,PROPER:Qo&&"something"===function(){}.name,CONFIGURABLE:Qo&&(!Go||Go&&Zo($o,"name").configurable)},tr={},er=D,ir=Je,nr=Qe,or=ni,rr=J,sr=on;tr.f=er&&!ir?Object.defineProperties:function(t,e){or(t);for(var i,n=rr(e),o=sr(e),r=o.length,s=0;r>s;)nr.f(t,i=o[s++],n[i]);return t};var ar,hr=ht("document","documentElement"),lr=ni,dr=tr,cr=tn,ur=Xi,fr=hr,pr=Se,vr="prototype",gr="script",yr=Bo("IE_PROTO"),mr=function(){},br=function(t){return"<"+gr+">"+t+"</"+gr+">"},wr=function(t){t.write(br("")),t.close();var e=t.parentWindow.Object;return t=null,e},xr=function(){try{ar=new ActiveXObject("htmlfile")}catch(t){}var t,e,i;xr="undefined"!=typeof document?document.domain&&ar?wr(ar):(e=pr("iframe"),i="java"+gr+":",e.style.display="none",fr.appendChild(e),e.src=String(i),(t=e.contentWindow.document).open(),t.write(br("document.F=Object")),t.close(),t.F):wr(ar);for(var n=cr.length;n--;)delete xr[vr][cr[n]];return xr()};ur[yr]=!0;var kr,_r,Er,Or=Object.create||function(t,e){var i;return null!==t?(mr[vr]=lr(t),i=new mr,mr[vr]=null,i[yr]=t):i=xr(),void 0===e?i:dr.f(i,e)},Cr=!a((function(){function t(){}return t.prototype.constructor=null,Object.getPrototypeOf(new t)!==t.prototype})),Sr=Jt,Tr=M,Mr=$t,Pr=Cr,Dr=Bo("IE_PROTO"),Ir=Object,Br=Ir.prototype,Nr=Pr?Ir.getPrototypeOf:function(t){var e=Mr(t);if(Sr(e,Dr))return e[Dr];var i=e.constructor;return Tr(i)&&e instanceof i?i.prototype:e instanceof Ir?Br:null},zr=yi,Fr=function(t,e,i,n){return n&&n.enumerable?t[e]=i:zr(t,e,i),t},Ar=a,jr=M,Rr=it,Lr=Or,Hr=Nr,Wr=Fr,qr=fe("iterator"),Vr=!1;[].keys&&("next"in(Er=[].keys())?(_r=Hr(Hr(Er)))!==Object.prototype&&(kr=_r):Vr=!0);var Ur=!Rr(kr)||Ar((function(){var t={};return kr[qr].call(t)!==t}));jr((kr=Ur?{}:Lr(kr))[qr])||Wr(kr,qr,(function(){return this}));var Yr={IteratorPrototype:kr,BUGGY_SAFARI_ITERATORS:Vr},Xr=vo,Gr=ao?{}.toString:function(){return"[object "+Xr(this)+"]"},Kr=ao,$r=Qe.f,Zr=yi,Qr=Jt,Jr=Gr,ts=fe("toStringTag"),es=function(t,e,i,n){if(t){var o=i?t:t.prototype;Qr(o,ts)||$r(o,ts,{configurable:!0,value:e}),n&&!Kr&&Zr(o,"toString",Jr)}},is={},ns=Yr.IteratorPrototype,os=Or,rs=H,ss=es,as=is,hs=function(){return this},ls=m,ds=It,cs=M,us=String,fs=TypeError,ps=function(t,e,i){try{return ls(ds(Object.getOwnPropertyDescriptor(t,e)[i]))}catch(t){}},vs=ni,gs=function(t){if("object"==typeof t||cs(t))return t;throw fs("Can't set "+us(t)+" as a prototype")},ys=Object.setPrototypeOf||("__proto__"in{}?function(){var t,e=!1,i={};try{(t=ps(Object.prototype,"__proto__","set"))(i,[]),e=i instanceof Array}catch(t){}return function(i,n){return vs(i),gs(n),e?t(i,n):i.__proto__=n,i}}():void 0),ms=Mi,bs=N,ws=function(t,e,i,n){var o=e+" Iterator";return t.prototype=os(ns,{next:rs(+!n,i)}),ss(t,o,!1,!0),as[o]=hs,t},xs=Nr,ks=es,_s=Fr,Es=is,Os=Jo.PROPER,Cs=Yr.BUGGY_SAFARI_ITERATORS,Ss=fe("iterator"),Ts="keys",Ms="values",Ps="entries",Ds=function(){return this},Is=function(t,e,i,n,o,r,s){ws(i,e,n);var a,h,l,d=function(t){if(t===o&&v)return v;if(!Cs&&t in f)return f[t];switch(t){case Ts:case Ms:case Ps:return function(){return new i(this,t)}}return function(){return new i(this)}},c=e+" Iterator",u=!1,f=t.prototype,p=f[Ss]||f["@@iterator"]||o&&f[o],v=!Cs&&p||d(o),g="Array"==e&&f.entries||p;if(g&&(a=xs(g.call(new t)))!==Object.prototype&&a.next&&(ks(a,c,!0,!0),Es[c]=Ds),Os&&o==Ms&&p&&p.name!==Ms&&(u=!0,v=function(){return bs(p,this)}),o)if(h={values:d(Ms),keys:r?v:d(Ts),entries:d(Ps)},s)for(l in h)(Cs||u||!(l in f))&&_s(f,l,h[l]);else ms({target:e,proto:!0,forced:Cs||u},h);return s&&f[Ss]!==v&&_s(f,Ss,v,{name:o}),Es[e]=v,h},Bs=function(t,e){return{value:t,done:e}},Ns=So.charAt,zs=mo,Fs=Xo,As=Is,js=Bs,Rs="String Iterator",Ls=Fs.set,Hs=Fs.getterFor(Rs);As(String,"String",(function(t){Ls(this,{type:Rs,string:zs(t),index:0})}),(function(){var t,e=Hs(this),i=e.string,n=e.index;return n>=i.length?js(void 0,!0):(t=Ns(i,n),e.index+=t.length,js(t,!1))}));var Ws=N,qs=ni,Vs=zt,Us=function(t,e,i){var n,o;qs(t);try{if(!(n=Vs(t,"return"))){if("throw"===e)throw i;return i}n=Ws(n,t)}catch(t){o=!0,n=t}if("throw"===e)throw i;if(o)throw n;return qs(n),i},Ys=ni,Xs=Us,Gs=is,Ks=fe("iterator"),$s=Array.prototype,Zs=function(t){return void 0!==t&&(Gs.Array===t||$s[Ks]===t)},Qs=M,Js=Yt,ta=m(Function.toString);Qs(Js.inspectSource)||(Js.inspectSource=function(t){return ta(t)});var ea=Js.inspectSource,ia=m,na=a,oa=M,ra=vo,sa=ea,aa=function(){},ha=[],la=ht("Reflect","construct"),da=/^\s*(?:class|function)\b/,ca=ia(da.exec),ua=!da.exec(aa),fa=function(t){if(!oa(t))return!1;try{return la(aa,ha,t),!0}catch(t){return!1}},pa=function(t){if(!oa(t))return!1;switch(ra(t)){case"AsyncFunction":case"GeneratorFunction":case"AsyncGeneratorFunction":return!1}try{return ua||!!ca(da,sa(t))}catch(t){return!0}};pa.sham=!0;var va=!la||na((function(){var t;return fa(fa.call)||!fa(Object)||!fa((function(){t=!0}))||t}))?pa:fa,ga=_e,ya=Qe,ma=H,ba=function(t,e,i){var n=ga(e);n in t?ya.f(t,n,ma(0,i)):t[n]=i},wa=vo,xa=zt,ka=X,_a=is,Ea=fe("iterator"),Oa=function(t){if(!ka(t))return xa(t,Ea)||xa(t,"@@iterator")||_a[wa(t)]},Ca=N,Sa=It,Ta=ni,Ma=Tt,Pa=Oa,Da=TypeError,Ia=function(t,e){var i=arguments.length<2?Pa(t):e;if(Sa(i))return Ta(Ca(i,t));throw Da(Ma(t)+" is not iterable")},Ba=Ze,Na=N,za=$t,Fa=function(t,e,i,n){try{return n?e(Ys(i)[0],i[1]):e(i)}catch(e){Xs(t,"throw",e)}},Aa=Zs,ja=va,Ra=Hi,La=ba,Ha=Ia,Wa=Oa,qa=Array,Va=fe("iterator"),Ua=!1;try{var Ya=0,Xa={next:function(){return{done:!!Ya++}},return:function(){Ua=!0}};Xa[Va]=function(){return this},Array.from(Xa,(function(){throw 2}))}catch(t){}var Ga=function(t,e){if(!e&&!Ua)return!1;var i=!1;try{var n={};n[Va]=function(){return{next:function(){return{done:i=!0}}}},t(n)}catch(t){}return i},Ka=function(t){var e=za(t),i=ja(this),n=arguments.length,o=n>1?arguments[1]:void 0,r=void 0!==o;r&&(o=Ba(o,n>2?arguments[2]:void 0));var s,a,h,l,d,c,u=Wa(e),f=0;if(!u||this===qa&&Aa(u))for(s=Ra(e),a=i?new this(s):qa(s);s>f;f++)c=r?o(e[f],f):e[f],La(a,f,c);else for(d=(l=Ha(e,u)).next,a=i?new this:[];!(h=Na(d,l)).done;f++)c=r?Fa(l,o,[h.value,f],!0):h.value,La(a,f,c);return a.length=f,a};Mi({target:"Array",stat:!0,forced:!Ga((function(t){Array.from(t)}))},{from:Ka});var $a=nt.Array.from;!function(t){t.exports=$a}(io);var Za=i(eo),Qa={},Ja={get exports(){return Qa},set exports(t){Qa=t}},th={},eh={get exports(){return th},set exports(t){th=t}},ih=J,nh=is,oh=Xo;Qe.f;var rh=Is,sh=Bs,ah="Array Iterator",hh=oh.set,lh=oh.getterFor(ah);rh(Array,"Array",(function(t,e){hh(this,{type:ah,target:ih(t),index:0,kind:e})}),(function(){var t=lh(this),e=t.target,i=t.kind,n=t.index++;return!e||n>=e.length?(t.target=void 0,sh(void 0,!0)):sh("keys"==i?n:"values"==i?e[n]:[n,e[n]],!1)}),"values"),nh.Arguments=nh.Array;var dh=Oa,ch={CSSRuleList:0,CSSStyleDeclaration:0,CSSValueList:0,ClientRectList:0,DOMRectList:0,DOMStringList:0,DOMTokenList:1,DataTransferItemList:0,FileList:0,HTMLAllCollection:0,HTMLCollection:0,HTMLFormElement:0,HTMLSelectElement:0,MediaList:0,MimeTypeArray:0,NamedNodeMap:0,NodeList:1,PaintRequestList:0,Plugin:0,PluginArray:0,SVGLengthList:0,SVGNumberList:0,SVGPathSegList:0,SVGPointList:0,SVGStringList:0,SVGTransformList:0,SourceBufferList:0,StyleSheetList:0,TextTrackCueList:0,TextTrackList:0,TouchList:0},uh=s,fh=vo,ph=yi,vh=is,gh=fe("toStringTag");for(var yh in ch){var mh=uh[yh],bh=mh&&mh.prototype;bh&&fh(bh)!==gh&&ph(bh,gh,yh),vh[yh]=vh.Array}var wh=dh;!function(t){t.exports=wh}(eh),function(t){t.exports=th}(Ja);var xh=i(Qa),kh={},_h={get exports(){return kh},set exports(t){kh=t}},Eh={},Oh=Ji,Ch=tn.concat("length","prototype");Eh.f=Object.getOwnPropertyNames||function(t){return Oh(t,Ch)};var Sh={},Th=Ai,Mh=Hi,Ph=ba,Dh=Array,Ih=Math.max,Bh=function(t,e,i){for(var n=Mh(t),o=Th(e,n),r=Th(void 0===i?n:i,n),s=Dh(Ih(r-o,0)),a=0;o<r;o++,a++)Ph(s,a,t[o]);return s.length=a,s},Nh=k,zh=J,Fh=Eh.f,Ah=Bh,jh="object"==typeof window&&window&&Object.getOwnPropertyNames?Object.getOwnPropertyNames(window):[];Sh.f=function(t){return jh&&"Window"==Nh(t)?function(t){try{return Fh(t)}catch(t){return Ah(jh)}}(t):Fh(zh(t))};var Rh=Qe,Lh=function(t,e,i){return Rh.f(t,e,i)},Hh={},Wh=fe;Hh.f=Wh;var qh=nt,Vh=Jt,Uh=Hh,Yh=Qe.f,Xh=function(t){var e=qh.Symbol||(qh.Symbol={});Vh(e,t)||Yh(e,t,{value:Uh.f(t)})},Gh=N,Kh=ht,$h=fe,Zh=Fr,Qh=function(){var t=Kh("Symbol"),e=t&&t.prototype,i=e&&e.valueOf,n=$h("toPrimitive");e&&!e[n]&&Zh(e,n,(function(t){return Gh(i,this)}),{arity:1})},Jh=k,tl=Array.isArray||function(t){return"Array"==Jh(t)},el=tl,il=va,nl=it,ol=fe("species"),rl=Array,sl=function(t){var e;return el(t)&&(e=t.constructor,(il(e)&&(e===rl||el(e.prototype))||nl(e)&&null===(e=e[ol]))&&(e=void 0)),void 0===e?rl:e},al=function(t,e){return new(sl(t))(0===e?0:e)},hl=Ze,ll=Y,dl=$t,cl=Hi,ul=al,fl=m([].push),pl=function(t){var e=1==t,i=2==t,n=3==t,o=4==t,r=6==t,s=7==t,a=5==t||r;return function(h,l,d,c){for(var u,f,p=dl(h),v=ll(p),g=hl(l,d),y=cl(v),m=0,b=c||ul,w=e?b(h,y):i||s?b(h,0):void 0;y>m;m++)if((a||m in v)&&(f=g(u=v[m],m,p),t))if(e)w[m]=f;else if(f)switch(t){case 3:return!0;case 5:return u;case 6:return m;case 2:fl(w,u)}else switch(t){case 4:return!1;case 7:fl(w,u)}return r?-1:n||o?o:w}},vl={forEach:pl(0),map:pl(1),filter:pl(2),some:pl(3),every:pl(4),find:pl(5),findIndex:pl(6),filterReject:pl(7)},gl=Mi,yl=s,ml=N,bl=m,wl=D,xl=wt,kl=a,_l=Jt,El=lt,Ol=ni,Cl=J,Sl=_e,Tl=mo,Ml=H,Pl=Or,Dl=on,Il=Eh,Bl=Sh,Nl=rn,zl=P,Fl=Qe,Al=tr,jl=z,Rl=Fr,Ll=Lh,Hl=Lt,Wl=Xi,ql=oe,Vl=fe,Ul=Hh,Yl=Xh,Xl=Qh,Gl=es,Kl=Xo,$l=vl.forEach,Zl=Bo("hidden"),Ql="Symbol",Jl="prototype",td=Kl.set,ed=Kl.getterFor(Ql),id=Object[Jl],nd=yl.Symbol,od=nd&&nd[Jl],rd=yl.TypeError,sd=yl.QObject,ad=zl.f,hd=Fl.f,ld=Bl.f,dd=jl.f,cd=bl([].push),ud=Hl("symbols"),fd=Hl("op-symbols"),pd=Hl("wks"),vd=!sd||!sd[Jl]||!sd[Jl].findChild,gd=wl&&kl((function(){return 7!=Pl(hd({},"a",{get:function(){return hd(this,"a",{value:7}).a}})).a}))?function(t,e,i){var n=ad(id,e);n&&delete id[e],hd(t,e,i),n&&t!==id&&hd(id,e,n)}:hd,yd=function(t,e){var i=ud[t]=Pl(od);return td(i,{type:Ql,tag:t,description:e}),wl||(i.description=e),i},md=function(t,e,i){t===id&&md(fd,e,i),Ol(t);var n=Sl(e);return Ol(i),_l(ud,n)?(i.enumerable?(_l(t,Zl)&&t[Zl][n]&&(t[Zl][n]=!1),i=Pl(i,{enumerable:Ml(0,!1)})):(_l(t,Zl)||hd(t,Zl,Ml(1,{})),t[Zl][n]=!0),gd(t,n,i)):hd(t,n,i)},bd=function(t,e){Ol(t);var i=Cl(e),n=Dl(i).concat(_d(i));return $l(n,(function(e){wl&&!ml(wd,i,e)||md(t,e,i[e])})),t},wd=function(t){var e=Sl(t),i=ml(dd,this,e);return!(this===id&&_l(ud,e)&&!_l(fd,e))&&(!(i||!_l(this,e)||!_l(ud,e)||_l(this,Zl)&&this[Zl][e])||i)},xd=function(t,e){var i=Cl(t),n=Sl(e);if(i!==id||!_l(ud,n)||_l(fd,n)){var o=ad(i,n);return!o||!_l(ud,n)||_l(i,Zl)&&i[Zl][n]||(o.enumerable=!0),o}},kd=function(t){var e=ld(Cl(t)),i=[];return $l(e,(function(t){_l(ud,t)||_l(Wl,t)||cd(i,t)})),i},_d=function(t){var e=t===id,i=ld(e?fd:Cl(t)),n=[];return $l(i,(function(t){!_l(ud,t)||e&&!_l(id,t)||cd(n,ud[t])})),n};xl||(nd=function(){if(El(od,this))throw rd("Symbol is not a constructor");var t=arguments.length&&void 0!==arguments[0]?Tl(arguments[0]):void 0,e=ql(t),i=function(t){this===id&&ml(i,fd,t),_l(this,Zl)&&_l(this[Zl],e)&&(this[Zl][e]=!1),gd(this,e,Ml(1,t))};return wl&&vd&&gd(id,e,{configurable:!0,set:i}),yd(e,t)},Rl(od=nd[Jl],"toString",(function(){return ed(this).tag})),Rl(nd,"withoutSetter",(function(t){return yd(ql(t),t)})),jl.f=wd,Fl.f=md,Al.f=bd,zl.f=xd,Il.f=Bl.f=kd,Nl.f=_d,Ul.f=function(t){return yd(Vl(t),t)},wl&&Ll(od,"description",{configurable:!0,get:function(){return ed(this).description}})),gl({global:!0,constructor:!0,wrap:!0,forced:!xl,sham:!xl},{Symbol:nd}),$l(Dl(pd),(function(t){Yl(t)})),gl({target:Ql,stat:!0,forced:!xl},{useSetter:function(){vd=!0},useSimple:function(){vd=!1}}),gl({target:"Object",stat:!0,forced:!xl,sham:!wl},{create:function(t,e){return void 0===e?Pl(t):bd(Pl(t),e)},defineProperty:md,defineProperties:bd,getOwnPropertyDescriptor:xd}),gl({target:"Object",stat:!0,forced:!xl},{getOwnPropertyNames:kd}),Xl(),Gl(nd,Ql),Wl[Zl]=!0;var Ed=wt&&!!Symbol.for&&!!Symbol.keyFor,Od=Mi,Cd=ht,Sd=Jt,Td=mo,Md=Lt,Pd=Ed,Dd=Md("string-to-symbol-registry"),Id=Md("symbol-to-string-registry");Od({target:"Symbol",stat:!0,forced:!Pd},{for:function(t){var e=Td(t);if(Sd(Dd,e))return Dd[e];var i=Cd("Symbol")(e);return Dd[e]=i,Id[i]=e,i}});var Bd=Mi,Nd=Jt,zd=Ct,Fd=Tt,Ad=Ed,jd=Lt("symbol-to-string-registry");Bd({target:"Symbol",stat:!0,forced:!Ad},{keyFor:function(t){if(!zd(t))throw TypeError(Fd(t)+" is not a symbol");if(Nd(jd,t))return jd[t]}});var Rd=tl,Ld=M,Hd=k,Wd=mo,qd=m([].push),Vd=Mi,Ud=ht,Yd=f,Xd=N,Gd=m,Kd=a,$d=M,Zd=Ct,Qd=En,Jd=function(t){if(Ld(t))return t;if(Rd(t)){for(var e=t.length,i=[],n=0;n<e;n++){var o=t[n];"string"==typeof o?qd(i,o):"number"!=typeof o&&"Number"!=Hd(o)&&"String"!=Hd(o)||qd(i,Wd(o))}var r=i.length,s=!0;return function(t,e){if(s)return s=!1,e;if(Rd(this))return e;for(var n=0;n<r;n++)if(i[n]===t)return e}}},tc=wt,ec=String,ic=Ud("JSON","stringify"),nc=Gd(/./.exec),oc=Gd("".charAt),rc=Gd("".charCodeAt),sc=Gd("".replace),ac=Gd(1..toString),hc=/[\uD800-\uDFFF]/g,lc=/^[\uD800-\uDBFF]$/,dc=/^[\uDC00-\uDFFF]$/,cc=!tc||Kd((function(){var t=Ud("Symbol")();return"[null]"!=ic([t])||"{}"!=ic({a:t})||"{}"!=ic(Object(t))})),uc=Kd((function(){return'"\\udf06\\ud834"'!==ic("\udf06\ud834")||'"\\udead"'!==ic("\udead")})),fc=function(t,e){var i=Qd(arguments),n=Jd(e);if($d(n)||void 0!==t&&!Zd(t))return i[1]=function(t,e){if($d(n)&&(e=Xd(n,this,ec(t),e)),!Zd(e))return e},Yd(ic,null,i)},pc=function(t,e,i){var n=oc(i,e-1),o=oc(i,e+1);return nc(lc,t)&&!nc(dc,o)||nc(dc,t)&&!nc(lc,n)?"\\u"+ac(rc(t,0),16):t};ic&&Vd({target:"JSON",stat:!0,arity:3,forced:cc||uc},{stringify:function(t,e,i){var n=Qd(arguments),o=Yd(cc?fc:ic,null,n);return uc&&"string"==typeof o?sc(o,hc,pc):o}});var vc=rn,gc=$t;Mi({target:"Object",stat:!0,forced:!wt||a((function(){vc.f(1)}))},{getOwnPropertySymbols:function(t){var e=vc.f;return e?e(gc(t)):[]}});var yc=nt.Object.getOwnPropertySymbols;!function(t){t.exports=yc}(_h);var mc=i(kh),bc={},wc={get exports(){return bc},set exports(t){bc=t}},xc={},kc={get exports(){return xc},set exports(t){xc=t}},_c=Mi,Ec=a,Oc=J,Cc=P.f,Sc=D;_c({target:"Object",stat:!0,forced:!Sc||Ec((function(){Cc(1)})),sham:!Sc},{getOwnPropertyDescriptor:function(t,e){return Cc(Oc(t),e)}});var Tc=nt.Object,Mc=kc.exports=function(t,e){return Tc.getOwnPropertyDescriptor(t,e)};Tc.getOwnPropertyDescriptor.sham&&(Mc.sham=!0);var Pc=xc;!function(t){t.exports=Pc}(wc);var Dc=i(bc),Ic={},Bc={get exports(){return Ic},set exports(t){Ic=t}},Nc=ht,zc=Eh,Fc=rn,Ac=ni,jc=m([].concat),Rc=Nc("Reflect","ownKeys")||function(t){var e=zc.f(Ac(t)),i=Fc.f;return i?jc(e,i(t)):e},Lc=Rc,Hc=J,Wc=P,qc=ba;Mi({target:"Object",stat:!0,sham:!D},{getOwnPropertyDescriptors:function(t){for(var e,i,n=Hc(t),o=Wc.f,r=Lc(n),s={},a=0;r.length>a;)void 0!==(i=o(n,e=r[a++]))&&qc(s,e,i);return s}});var Vc=nt.Object.getOwnPropertyDescriptors;!function(t){t.exports=Vc}(Bc);var Uc=i(Ic),Yc={},Xc={get exports(){return Yc},set exports(t){Yc=t}},Gc={},Kc={get exports(){return Gc},set exports(t){Gc=t}},$c=Mi,Zc=D,Qc=tr.f;$c({target:"Object",stat:!0,forced:Object.defineProperties!==Qc,sham:!Zc},{defineProperties:Qc});var Jc=nt.Object,tu=Kc.exports=function(t,e){return Jc.defineProperties(t,e)};Jc.defineProperties.sham&&(tu.sham=!0);var eu=Gc;!function(t){t.exports=eu}(Xc);var iu=i(Yc),nu={},ou={get exports(){return nu},set exports(t){nu=t}},ru={},su={get exports(){return ru},set exports(t){ru=t}},au=Mi,hu=D,lu=Qe.f;au({target:"Object",stat:!0,forced:Object.defineProperty!==lu,sham:!hu},{defineProperty:lu});var du=nt.Object,cu=su.exports=function(t,e,i){return du.defineProperty(t,e,i)};du.defineProperty.sham&&(cu.sham=!0);var uu=ru;!function(t){t.exports=uu}(ou);var fu=i(nu);function pu(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")}var vu={},gu={get exports(){return vu},set exports(t){vu=t}},yu={},mu=uu;!function(t){t.exports=mu}({get exports(){return yu},set exports(t){yu=t}}),function(t){t.exports=yu}(gu);var bu=i(vu),wu={},xu={get exports(){return wu},set exports(t){wu=t}},ku={},_u={get exports(){return ku},set exports(t){ku=t}},Eu=TypeError,Ou=function(t){if(t>9007199254740991)throw Eu("Maximum allowed index exceeded");return t},Cu=a,Su=yt,Tu=fe("species"),Mu=function(t){return Su>=51||!Cu((function(){var e=[];return(e.constructor={})[Tu]=function(){return{foo:1}},1!==e[t](Boolean).foo}))},Pu=Mi,Du=a,Iu=tl,Bu=it,Nu=$t,zu=Hi,Fu=Ou,Au=ba,ju=al,Ru=Mu,Lu=yt,Hu=fe("isConcatSpreadable"),Wu=Lu>=51||!Du((function(){var t=[];return t[Hu]=!1,t.concat()[0]!==t})),qu=function(t){if(!Bu(t))return!1;var e=t[Hu];return void 0!==e?!!e:Iu(t)};Pu({target:"Array",proto:!0,arity:1,forced:!Wu||!Ru("concat")},{concat:function(t){var e,i,n,o,r,s=Nu(this),a=ju(s,0),h=0;for(e=-1,n=arguments.length;e<n;e++)if(qu(r=-1===e?s:arguments[e]))for(o=zu(r),Fu(h+o),i=0;i<o;i++,h++)i in r&&Au(a,h,r[i]);else Fu(h+1),Au(a,h++,r);return a.length=h,a}}),Xh("asyncIterator"),Xh("hasInstance"),Xh("isConcatSpreadable"),Xh("iterator"),Xh("match"),Xh("matchAll"),Xh("replace"),Xh("search"),Xh("species"),Xh("split");var Vu=Qh;Xh("toPrimitive"),Vu();var Uu=ht,Yu=es;Xh("toStringTag"),Yu(Uu("Symbol"),"Symbol"),Xh("unscopables"),es(s.JSON,"JSON",!0);var Xu=nt.Symbol;Xh("dispose");var Gu=Xu;Xh("asyncDispose");var Ku=Mi,$u=m,Zu=ht("Symbol"),Qu=Zu.keyFor,Ju=$u(Zu.prototype.valueOf);Ku({target:"Symbol",stat:!0},{isRegistered:function(t){try{return void 0!==Qu(Ju(t))}catch(t){return!1}}});for(var tf=Mi,ef=Lt,nf=ht,of=m,rf=Ct,sf=fe,af=nf("Symbol"),hf=af.isWellKnown,lf=nf("Object","getOwnPropertyNames"),df=of(af.prototype.valueOf),cf=ef("wks"),uf=0,ff=lf(af),pf=ff.length;uf<pf;uf++)try{var vf=ff[uf];rf(af[vf])&&sf(vf)}catch(t){}tf({target:"Symbol",stat:!0,forced:!0},{isWellKnown:function(t){if(hf&&hf(t))return!0;try{for(var e=df(t),i=0,n=lf(cf),o=n.length;i<o;i++)if(cf[n[i]]==e)return!0}catch(t){}return!1}}),Xh("matcher"),Xh("metadataKey"),Xh("observable"),Xh("metadata"),Xh("patternMatch"),Xh("replaceAll");var gf=Gu;!function(t){t.exports=gf}(_u),function(t){t.exports=ku}(xu);var yf=i(wu),mf={},bf={get exports(){return mf},set exports(t){mf=t}},wf={},xf={get exports(){return wf},set exports(t){wf=t}},kf=Hh.f("iterator"),_f=kf;!function(t){t.exports=_f}(xf),function(t){t.exports=wf}(bf);var Ef=i(mf);function Of(t){return Of="function"==typeof yf&&"symbol"==typeof Ef?function(t){return typeof t}:function(t){return t&&"function"==typeof yf&&t.constructor===yf&&t!==yf.prototype?"symbol":typeof t},Of(t)}var Cf={},Sf={get exports(){return Cf},set exports(t){Cf=t}},Tf={},Mf={get exports(){return Tf},set exports(t){Tf=t}},Pf=Hh.f("toPrimitive");!function(t){t.exports=Pf}(Mf),function(t){t.exports=Tf}(Sf);var Df=i(Cf);function If(t){var e=function(t,e){if("object"!==Of(t)||null===t)return t;var i=t[Df];if(void 0!==i){var n=i.call(t,e||"default");if("object"!==Of(n))return n;throw new TypeError("@@toPrimitive must return a primitive value.")}return("string"===e?String:Number)(t)}(t,"string");return"symbol"===Of(e)?e:String(e)}function Bf(t,e){for(var i=0;i<e.length;i++){var n=e[i];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),bu(t,If(n.key),n)}}function Nf(t,e,i){return e&&Bf(t.prototype,e),i&&Bf(t,i),bu(t,"prototype",{writable:!1}),t}function zf(t,e,i){return(e=If(e))in t?bu(t,e,{value:i,enumerable:!0,configurable:!0,writable:!0}):t[e]=i,t}var Ff={},Af={get exports(){return Ff},set exports(t){Ff=t}},jf={},Rf={get exports(){return jf},set exports(t){jf=t}};Mi({target:"Array",stat:!0},{isArray:tl});var Lf=nt.Array.isArray,Hf=Lf;!function(t){t.exports=Hf}(Rf),function(t){t.exports=jf}(Af);var Wf=i(Ff);var qf={},Vf={get exports(){return qf},set exports(t){qf=t}},Uf={},Yf={get exports(){return Uf},set exports(t){Uf=t}},Xf=Mi,Gf=tl,Kf=va,$f=it,Zf=Ai,Qf=Hi,Jf=J,tp=ba,ep=fe,ip=En,np=Mu("slice"),op=ep("species"),rp=Array,sp=Math.max;Xf({target:"Array",proto:!0,forced:!np},{slice:function(t,e){var i,n,o,r=Jf(this),s=Qf(r),a=Zf(t,s),h=Zf(void 0===e?s:e,s);if(Gf(r)&&(i=r.constructor,(Kf(i)&&(i===rp||Gf(i.prototype))||$f(i)&&null===(i=i[op]))&&(i=void 0),i===rp||void 0===i))return ip(r,a,h);for(n=new(void 0===i?rp:i)(sp(h-a,0)),o=0;a<h;a++,o++)a in r&&tp(n,o,r[a]);return n.length=o,n}});var ap=Rn("Array").slice,hp=lt,lp=ap,dp=Array.prototype,cp=function(t){var e=t.slice;return t===dp||hp(dp,t)&&e===dp.slice?lp:e},up=cp,fp=up;!function(t){t.exports=fp}(Yf),function(t){t.exports=Uf}(Vf);var pp=i(qf),vp={},gp={get exports(){return vp},set exports(t){vp=t}},yp={},mp=$a;!function(t){t.exports=mp}({get exports(){return yp},set exports(t){yp=t}}),function(t){t.exports=yp}(gp);var bp=i(vp);function wp(t,e){(null==e||e>t.length)&&(e=t.length);for(var i=0,n=new Array(e);i<e;i++)n[i]=t[i];return n}function xp(t,e){var i;if(t){if("string"==typeof t)return wp(t,e);var n=pp(i=Object.prototype.toString.call(t)).call(i,8,-1);return"Object"===n&&t.constructor&&(n=t.constructor.name),"Map"===n||"Set"===n?bp(t):"Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)?wp(t,e):void 0}}function kp(t,e){return function(t){if(Wf(t))return t}(t)||function(t,e){var i=null==t?null:void 0!==yf&&xh(t)||t["@@iterator"];if(null!=i){var n,o,r,s,a=[],h=!0,l=!1;try{if(r=(i=i.call(t)).next,0===e){if(Object(i)!==i)return;h=!1}else for(;!(h=(n=r.call(i)).done)&&(a.push(n.value),a.length!==e);h=!0);}catch(t){l=!0,o=t}finally{try{if(!h&&null!=i.return&&(s=i.return(),Object(s)!==s))return}finally{if(l)throw o}}return a}}(t,e)||xp(t,e)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function _p(t){return function(t){if(Wf(t))return wp(t)}(t)||function(t){if(void 0!==yf&&null!=xh(t)||null!=t["@@iterator"])return bp(t)}(t)||xp(t)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var Ep={};!function(t){t.exports=Xu}({get exports(){return Ep},set exports(t){Ep=t}});var Op=i(Ep),Cp={},Sp={get exports(){return Cp},set exports(t){Cp=t}},Tp=Rn("Array").concat,Mp=lt,Pp=Tp,Dp=Array.prototype,Ip=function(t){var e=t.concat;return t===Dp||Mp(Dp,t)&&e===Dp.concat?Pp:e},Bp=Ip;!function(t){t.exports=Bp}(Sp);var Np=i(Cp),zp={};!function(t){t.exports=up}({get exports(){return zp},set exports(t){zp=t}});var Fp=i(zp),Ap={},jp={get exports(){return Ap},set exports(t){Ap=t}};Mi({target:"Reflect",stat:!0},{ownKeys:Rc});var Rp=nt.Reflect.ownKeys;!function(t){t.exports=Rp}(jp);var Lp=i(Ap),Hp={};!function(t){t.exports=Lf}({get exports(){return Hp},set exports(t){Hp=t}});var Wp=i(Hp),qp={},Vp={get exports(){return qp},set exports(t){qp=t}},Up=vl.map;Mi({target:"Array",proto:!0,forced:!Mu("map")},{map:function(t){return Up(this,t,arguments.length>1?arguments[1]:void 0)}});var Yp=Rn("Array").map,Xp=lt,Gp=Yp,Kp=Array.prototype,$p=function(t){var e=t.map;return t===Kp||Xp(Kp,t)&&e===Kp.map?Gp:e},Zp=$p;!function(t){t.exports=Zp}(Vp);var Qp=i(qp),Jp={},tv={get exports(){return Jp},set exports(t){Jp=t}},ev=$t,iv=on;Mi({target:"Object",stat:!0,forced:a((function(){iv(1)}))},{keys:function(t){return iv(ev(t))}});var nv=nt.Object.keys;!function(t){t.exports=nv}(tv);var ov=i(Jp),rv={},sv={get exports(){return rv},set exports(t){rv=t}},av=Mi,hv=Date,lv=m(hv.prototype.getTime);av({target:"Date",stat:!0},{now:function(){return lv(new hv)}});var dv=nt.Date.now;!function(t){t.exports=dv}(sv);var cv=i(rv),uv={},fv={get exports(){return uv},set exports(t){uv=t}},pv=a,vv=function(t,e){var i=[][t];return!!i&&pv((function(){i.call(null,e||function(){return 1},1)}))},gv=vl.forEach,yv=vv("forEach")?[].forEach:function(t){return gv(this,t,arguments.length>1?arguments[1]:void 0)};Mi({target:"Array",proto:!0,forced:[].forEach!=yv},{forEach:yv});var mv=Rn("Array").forEach,bv=vo,wv=Jt,xv=lt,kv=mv,_v=Array.prototype,Ev={DOMTokenList:!0,NodeList:!0},Ov=function(t){var e=t.forEach;return t===_v||xv(_v,t)&&e===_v.forEach||wv(Ev,bv(t))?kv:e};!function(t){t.exports=Ov}(fv);var Cv=i(uv),Sv={},Tv={get exports(){return Sv},set exports(t){Sv=t}},Mv=Mi,Pv=tl,Dv=m([].reverse),Iv=[1,2];Mv({target:"Array",proto:!0,forced:String(Iv)===String(Iv.reverse())},{reverse:function(){return Pv(this)&&(this.length=this.length),Dv(this)}});var Bv=Rn("Array").reverse,Nv=lt,zv=Bv,Fv=Array.prototype,Av=function(t){var e=t.reverse;return t===Fv||Nv(Fv,t)&&e===Fv.reverse?zv:e},jv=Av;!function(t){t.exports=jv}(Tv);var Rv=i(Sv),Lv={},Hv={get exports(){return Lv},set exports(t){Lv=t}},Wv=D,qv=tl,Vv=TypeError,Uv=Object.getOwnPropertyDescriptor,Yv=Wv&&!function(){if(void 0!==this)return!0;try{Object.defineProperty([],"length",{writable:!1}).length=1}catch(t){return t instanceof TypeError}}(),Xv=Tt,Gv=TypeError,Kv=function(t,e){if(!delete t[e])throw Gv("Cannot delete property "+Xv(e)+" of "+Xv(t))},$v=Mi,Zv=$t,Qv=Ai,Jv=Bi,tg=Hi,eg=Yv?function(t,e){if(qv(t)&&!Uv(t,"length").writable)throw Vv("Cannot set read only .length");return t.length=e}:function(t,e){return t.length=e},ig=Ou,ng=al,og=ba,rg=Kv,sg=Mu("splice"),ag=Math.max,hg=Math.min;$v({target:"Array",proto:!0,forced:!sg},{splice:function(t,e){var i,n,o,r,s,a,h=Zv(this),l=tg(h),d=Qv(t,l),c=arguments.length;for(0===c?i=n=0:1===c?(i=0,n=l-d):(i=c-2,n=hg(ag(Jv(e),0),l-d)),ig(l+i-n),o=ng(h,n),r=0;r<n;r++)(s=d+r)in h&&og(o,r,h[s]);if(o.length=n,i<n){for(r=d;r<l-n;r++)a=r+i,(s=r+n)in h?h[a]=h[s]:rg(h,a);for(r=l;r>l-n+i;r--)rg(h,r-1)}else if(i>n)for(r=l-n;r>d;r--)a=r+i-1,(s=r+n-1)in h?h[a]=h[s]:rg(h,a);for(r=0;r<i;r++)h[r+d]=arguments[r+2];return eg(h,l-n+i),o}});var lg=Rn("Array").splice,dg=lt,cg=lg,ug=Array.prototype,fg=function(t){var e=t.splice;return t===ug||dg(ug,t)&&e===ug.splice?cg:e},pg=fg;!function(t){t.exports=pg}(Hv);var vg=i(Lv),gg={},yg={get exports(){return gg},set exports(t){gg=t}},mg=Yi.includes;Mi({target:"Array",proto:!0,forced:a((function(){return!Array(1).includes()}))},{includes:function(t){return mg(this,t,arguments.length>1?arguments[1]:void 0)}});var bg=Rn("Array").includes,wg=it,xg=k,kg=fe("match"),_g=function(t){var e;return wg(t)&&(void 0!==(e=t[kg])?!!e:"RegExp"==xg(t))},Eg=TypeError,Og=fe("match"),Cg=Mi,Sg=function(t){if(_g(t))throw Eg("The method doesn't accept regular expressions");return t},Tg=$,Mg=mo,Pg=function(t){var e=/./;try{"/./"[t](e)}catch(i){try{return e[Og]=!1,"/./"[t](e)}catch(t){}}return!1},Dg=m("".indexOf);Cg({target:"String",proto:!0,forced:!Pg("includes")},{includes:function(t){return!!~Dg(Mg(Tg(this)),Mg(Sg(t)),arguments.length>1?arguments[1]:void 0)}});var Ig=Rn("String").includes,Bg=lt,Ng=bg,zg=Ig,Fg=Array.prototype,Ag=String.prototype,jg=function(t){var e=t.includes;return t===Fg||Bg(Fg,t)&&e===Fg.includes?Ng:"string"==typeof t||t===Ag||Bg(Ag,t)&&e===Ag.includes?zg:e},Rg=jg;!function(t){t.exports=Rg}(yg);var Lg=i(gg),Hg={},Wg={get exports(){return Hg},set exports(t){Hg=t}},qg=$t,Vg=Nr,Ug=Cr;Mi({target:"Object",stat:!0,forced:a((function(){Vg(1)})),sham:!Ug},{getPrototypeOf:function(t){return Vg(qg(t))}});var Yg=nt.Object.getPrototypeOf;!function(t){t.exports=Yg}(Wg);var Xg=i(Hg),Gg={},Kg={get exports(){return Gg},set exports(t){Gg=t}},$g=vl.filter;Mi({target:"Array",proto:!0,forced:!Mu("filter")},{filter:function(t){return $g(this,t,arguments.length>1?arguments[1]:void 0)}});var Zg=Rn("Array").filter,Qg=lt,Jg=Zg,ty=Array.prototype,ey=function(t){var e=t.filter;return t===ty||Qg(ty,t)&&e===ty.filter?Jg:e},iy=ey;!function(t){t.exports=iy}(Kg);var ny=i(Gg),oy={},ry={get exports(){return oy},set exports(t){oy=t}},sy=D,ay=m,hy=on,ly=J,dy=ay(z.f),cy=ay([].push),uy=function(t){return function(e){for(var i,n=ly(e),o=hy(n),r=o.length,s=0,a=[];r>s;)i=o[s++],sy&&!dy(n,i)||cy(a,t?[i,n[i]]:n[i]);return a}},fy={entries:uy(!0),values:uy(!1)}.values;Mi({target:"Object",stat:!0},{values:function(t){return fy(t)}});var py=nt.Object.values;!function(t){t.exports=py}(ry);var vy=i(oy),gy={},yy={get exports(){return gy},set exports(t){gy=t}},my="\t\n\v\f\r                　\u2028\u2029\ufeff",by=$,wy=mo,xy=my,ky=m("".replace),_y=RegExp("^["+xy+"]+"),Ey=RegExp("(^|[^"+xy+"])["+xy+"]+$"),Oy=function(t){return function(e){var i=wy(by(e));return 1&t&&(i=ky(i,_y,"")),2&t&&(i=ky(i,Ey,"$1")),i}},Cy={start:Oy(1),end:Oy(2),trim:Oy(3)},Sy=s,Ty=a,My=m,Py=mo,Dy=Cy.trim,Iy=my,By=Sy.parseInt,Ny=Sy.Symbol,zy=Ny&&Ny.iterator,Fy=/^[+-]?0x/i,Ay=My(Fy.exec),jy=8!==By(Iy+"08")||22!==By(Iy+"0x16")||zy&&!Ty((function(){By(Object(zy))}))?function(t,e){var i=Dy(Py(t));return By(i,e>>>0||(Ay(Fy,i)?16:10))}:By;Mi({global:!0,forced:parseInt!=jy},{parseInt:jy});var Ry=nt.parseInt;!function(t){t.exports=Ry}(yy);var Ly=i(gy),Hy={},Wy={get exports(){return Hy},set exports(t){Hy=t}},qy=Mi,Vy=Yi.indexOf,Uy=vv,Yy=O([].indexOf),Xy=!!Yy&&1/Yy([1],1,-0)<0;qy({target:"Array",proto:!0,forced:Xy||!Uy("indexOf")},{indexOf:function(t){var e=arguments.length>1?arguments[1]:void 0;return Xy?Yy(this,t,e)||0:Vy(this,t,e)}});var Gy=Rn("Array").indexOf,Ky=lt,$y=Gy,Zy=Array.prototype,Qy=function(t){var e=t.indexOf;return t===Zy||Ky(Zy,t)&&e===Zy.indexOf?$y:e},Jy=Qy;!function(t){t.exports=Jy}(Wy);var tm=i(Hy),em={},im={get exports(){return em},set exports(t){em=t}},nm=Jo.PROPER,om=a,rm=my,sm=Cy.trim;Mi({target:"String",proto:!0,forced:function(t){return om((function(){return!!rm[t]()||"​᠎"!=="​᠎"[t]()||nm&&rm[t].name!==t}))}("trim")},{trim:function(){return sm(this)}});var am=Rn("String").trim,hm=lt,lm=am,dm=String.prototype,cm=function(t){var e=t.trim;return"string"==typeof t||t===dm||hm(dm,t)&&e===dm.trim?lm:e},um=cm;!function(t){t.exports=um}(im);var fm=i(em),pm={},vm={get exports(){return pm},set exports(t){pm=t}};Mi({target:"Object",stat:!0,sham:!D},{create:Or});var gm=nt.Object,ym=function(t,e){return gm.create(t,e)};!function(t){t.exports=ym}(vm);var mm=i(pm),bm={},wm={get exports(){return bm},set exports(t){bm=t}},xm=nt,km=f;xm.JSON||(xm.JSON={stringify:JSON.stringify});var _m=function(t,e,i){return km(xm.JSON.stringify,null,arguments)},Em=_m;!function(t){t.exports=Em}(wm);var Om=i(bm),Cm={},Sm={get exports(){return Cm},set exports(t){Cm=t}},Tm="function"==typeof Bun&&Bun&&"string"==typeof Bun.version,Mm=TypeError,Pm=function(t,e){if(t<e)throw Mm("Not enough arguments");return t},Dm=s,Im=f,Bm=M,Nm=Tm,zm=dt,Fm=En,Am=Pm,jm=Dm.Function,Rm=/MSIE .\./.test(zm)||Nm&&function(){var t=Dm.Bun.version.split(".");return t.length<3||0==t[0]&&(t[1]<3||3==t[1]&&0==t[2])}(),Lm=function(t,e){var i=e?2:1;return Rm?function(n,o){var r=Am(arguments.length,1)>i,s=Bm(n)?n:jm(n),a=r?Fm(arguments,i):[],h=r?function(){Im(s,this,a)}:s;return e?t(h,o):t(h)}:t},Hm=Mi,Wm=s,qm=Lm(Wm.setInterval,!0);Hm({global:!0,bind:!0,forced:Wm.setInterval!==qm},{setInterval:qm});var Vm=Mi,Um=s,Ym=Lm(Um.setTimeout,!0);Vm({global:!0,bind:!0,forced:Um.setTimeout!==Ym},{setTimeout:Ym});var Xm=nt.setTimeout;!function(t){t.exports=Xm}(Sm);var Gm=i(Cm),Km={},$m={get exports(){return Km},set exports(t){Km=t}},Zm=$t,Qm=Ai,Jm=Hi,tb=function(t){for(var e=Zm(this),i=Jm(e),n=arguments.length,o=Qm(n>1?arguments[1]:void 0,i),r=n>2?arguments[2]:void 0,s=void 0===r?i:Qm(r,i);s>o;)e[o++]=t;return e};Mi({target:"Array",proto:!0},{fill:tb});var eb=Rn("Array").fill,ib=lt,nb=eb,ob=Array.prototype,rb=function(t){var e=t.fill;return t===ob||ib(ob,t)&&e===ob.fill?nb:e},sb=rb;!function(t){t.exports=sb}($m);var ab,hb=i(Km);function lb(){return lb=Object.assign||function(t){for(var e=1;e<arguments.length;e++){var i=arguments[e];for(var n in i)Object.prototype.hasOwnProperty.call(i,n)&&(t[n]=i[n])}return t},lb.apply(this,arguments)}function db(t,e){t.prototype=Object.create(e.prototype),t.prototype.constructor=t,t.__proto__=e}function cb(t){if(void 0===t)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return t}ab="function"!=typeof Object.assign?function(t){if(null==t)throw new TypeError("Cannot convert undefined or null to object");for(var e=Object(t),i=1;i<arguments.length;i++){var n=arguments[i];if(null!=n)for(var o in n)n.hasOwnProperty(o)&&(e[o]=n[o])}return e}:Object.assign;var ub,fb=ab,pb=["","webkit","Moz","MS","ms","o"],vb="undefined"==typeof document?{style:{}}:document.createElement("div"),gb="function",yb=Math.round,mb=Math.abs,bb=Date.now;function wb(t,e){for(var i,n,o=e[0].toUpperCase()+e.slice(1),r=0;r<pb.length;){if((n=(i=pb[r])?i+o:e)in t)return n;r++}}ub="undefined"==typeof window?{}:window;var xb=wb(vb.style,"touchAction"),kb=void 0!==xb;var _b="compute",Eb="auto",Ob="manipulation",Cb="none",Sb="pan-x",Tb="pan-y",Mb=function(){if(!kb)return!1;var t={},e=ub.CSS&&ub.CSS.supports;return["auto","manipulation","pan-y","pan-x","pan-x pan-y","none"].forEach((function(i){return t[i]=!e||ub.CSS.supports("touch-action",i)})),t}(),Pb="ontouchstart"in ub,Db=void 0!==wb(ub,"PointerEvent"),Ib=Pb&&/mobile|tablet|ip(ad|hone|od)|android/i.test(navigator.userAgent),Bb="touch",Nb="mouse",zb=25,Fb=1,Ab=2,jb=4,Rb=8,Lb=1,Hb=2,Wb=4,qb=8,Vb=16,Ub=Hb|Wb,Yb=qb|Vb,Xb=Ub|Yb,Gb=["x","y"],Kb=["clientX","clientY"];function $b(t,e,i){var n;if(t)if(t.forEach)t.forEach(e,i);else if(void 0!==t.length)for(n=0;n<t.length;)e.call(i,t[n],n,t),n++;else for(n in t)t.hasOwnProperty(n)&&e.call(i,t[n],n,t)}function Zb(t,e){return typeof t===gb?t.apply(e&&e[0]||void 0,e):t}function Qb(t,e){return t.indexOf(e)>-1}var Jb=function(){function t(t,e){this.manager=t,this.set(e)}var e=t.prototype;return e.set=function(t){t===_b&&(t=this.compute()),kb&&this.manager.element.style&&Mb[t]&&(this.manager.element.style[xb]=t),this.actions=t.toLowerCase().trim()},e.update=function(){this.set(this.manager.options.touchAction)},e.compute=function(){var t=[];return $b(this.manager.recognizers,(function(e){Zb(e.options.enable,[e])&&(t=t.concat(e.getTouchAction()))})),function(t){if(Qb(t,Cb))return Cb;var e=Qb(t,Sb),i=Qb(t,Tb);return e&&i?Cb:e||i?e?Sb:Tb:Qb(t,Ob)?Ob:Eb}(t.join(" "))},e.preventDefaults=function(t){var e=t.srcEvent,i=t.offsetDirection;if(this.manager.session.prevented)e.preventDefault();else{var n=this.actions,o=Qb(n,Cb)&&!Mb[Cb],r=Qb(n,Tb)&&!Mb[Tb],s=Qb(n,Sb)&&!Mb[Sb];if(o){var a=1===t.pointers.length,h=t.distance<2,l=t.deltaTime<250;if(a&&h&&l)return}if(!s||!r)return o||r&&i&Ub||s&&i&Yb?this.preventSrc(e):void 0}},e.preventSrc=function(t){this.manager.session.prevented=!0,t.preventDefault()},t}();function tw(t,e){for(;t;){if(t===e)return!0;t=t.parentNode}return!1}function ew(t){var e=t.length;if(1===e)return{x:yb(t[0].clientX),y:yb(t[0].clientY)};for(var i=0,n=0,o=0;o<e;)i+=t[o].clientX,n+=t[o].clientY,o++;return{x:yb(i/e),y:yb(n/e)}}function iw(t){for(var e=[],i=0;i<t.pointers.length;)e[i]={clientX:yb(t.pointers[i].clientX),clientY:yb(t.pointers[i].clientY)},i++;return{timeStamp:bb(),pointers:e,center:ew(e),deltaX:t.deltaX,deltaY:t.deltaY}}function nw(t,e,i){i||(i=Gb);var n=e[i[0]]-t[i[0]],o=e[i[1]]-t[i[1]];return Math.sqrt(n*n+o*o)}function ow(t,e,i){i||(i=Gb);var n=e[i[0]]-t[i[0]],o=e[i[1]]-t[i[1]];return 180*Math.atan2(o,n)/Math.PI}function rw(t,e){return t===e?Lb:mb(t)>=mb(e)?t<0?Hb:Wb:e<0?qb:Vb}function sw(t,e,i){return{x:e/t||0,y:i/t||0}}function aw(t,e){var i=t.session,n=e.pointers,o=n.length;i.firstInput||(i.firstInput=iw(e)),o>1&&!i.firstMultiple?i.firstMultiple=iw(e):1===o&&(i.firstMultiple=!1);var r=i.firstInput,s=i.firstMultiple,a=s?s.center:r.center,h=e.center=ew(n);e.timeStamp=bb(),e.deltaTime=e.timeStamp-r.timeStamp,e.angle=ow(a,h),e.distance=nw(a,h),function(t,e){var i=e.center,n=t.offsetDelta||{},o=t.prevDelta||{},r=t.prevInput||{};e.eventType!==Fb&&r.eventType!==jb||(o=t.prevDelta={x:r.deltaX||0,y:r.deltaY||0},n=t.offsetDelta={x:i.x,y:i.y}),e.deltaX=o.x+(i.x-n.x),e.deltaY=o.y+(i.y-n.y)}(i,e),e.offsetDirection=rw(e.deltaX,e.deltaY);var l,d,c=sw(e.deltaTime,e.deltaX,e.deltaY);e.overallVelocityX=c.x,e.overallVelocityY=c.y,e.overallVelocity=mb(c.x)>mb(c.y)?c.x:c.y,e.scale=s?(l=s.pointers,nw((d=n)[0],d[1],Kb)/nw(l[0],l[1],Kb)):1,e.rotation=s?function(t,e){return ow(e[1],e[0],Kb)+ow(t[1],t[0],Kb)}(s.pointers,n):0,e.maxPointers=i.prevInput?e.pointers.length>i.prevInput.maxPointers?e.pointers.length:i.prevInput.maxPointers:e.pointers.length,function(t,e){var i,n,o,r,s=t.lastInterval||e,a=e.timeStamp-s.timeStamp;if(e.eventType!==Rb&&(a>zb||void 0===s.velocity)){var h=e.deltaX-s.deltaX,l=e.deltaY-s.deltaY,d=sw(a,h,l);n=d.x,o=d.y,i=mb(d.x)>mb(d.y)?d.x:d.y,r=rw(h,l),t.lastInterval=e}else i=s.velocity,n=s.velocityX,o=s.velocityY,r=s.direction;e.velocity=i,e.velocityX=n,e.velocityY=o,e.direction=r}(i,e);var u,f=t.element,p=e.srcEvent;tw(u=p.composedPath?p.composedPath()[0]:p.path?p.path[0]:p.target,f)&&(f=u),e.target=f}function hw(t,e,i){var n=i.pointers.length,o=i.changedPointers.length,r=e&Fb&&n-o==0,s=e&(jb|Rb)&&n-o==0;i.isFirst=!!r,i.isFinal=!!s,r&&(t.session={}),i.eventType=e,aw(t,i),t.emit("hammer.input",i),t.recognize(i),t.session.prevInput=i}function lw(t){return t.trim().split(/\s+/g)}function dw(t,e,i){$b(lw(e),(function(e){t.addEventListener(e,i,!1)}))}function cw(t,e,i){$b(lw(e),(function(e){t.removeEventListener(e,i,!1)}))}function uw(t){var e=t.ownerDocument||t;return e.defaultView||e.parentWindow||window}var fw=function(){function t(t,e){var i=this;this.manager=t,this.callback=e,this.element=t.element,this.target=t.options.inputTarget,this.domHandler=function(e){Zb(t.options.enable,[t])&&i.handler(e)},this.init()}var e=t.prototype;return e.handler=function(){},e.init=function(){this.evEl&&dw(this.element,this.evEl,this.domHandler),this.evTarget&&dw(this.target,this.evTarget,this.domHandler),this.evWin&&dw(uw(this.element),this.evWin,this.domHandler)},e.destroy=function(){this.evEl&&cw(this.element,this.evEl,this.domHandler),this.evTarget&&cw(this.target,this.evTarget,this.domHandler),this.evWin&&cw(uw(this.element),this.evWin,this.domHandler)},t}();function pw(t,e,i){if(t.indexOf&&!i)return t.indexOf(e);for(var n=0;n<t.length;){if(i&&t[n][i]==e||!i&&t[n]===e)return n;n++}return-1}var vw={pointerdown:Fb,pointermove:Ab,pointerup:jb,pointercancel:Rb,pointerout:Rb},gw={2:Bb,3:"pen",4:Nb,5:"kinect"},yw="pointerdown",mw="pointermove pointerup pointercancel";ub.MSPointerEvent&&!ub.PointerEvent&&(yw="MSPointerDown",mw="MSPointerMove MSPointerUp MSPointerCancel");var bw=function(t){function e(){var i,n=e.prototype;return n.evEl=yw,n.evWin=mw,(i=t.apply(this,arguments)||this).store=i.manager.session.pointerEvents=[],i}return db(e,t),e.prototype.handler=function(t){var e=this.store,i=!1,n=t.type.toLowerCase().replace("ms",""),o=vw[n],r=gw[t.pointerType]||t.pointerType,s=r===Bb,a=pw(e,t.pointerId,"pointerId");o&Fb&&(0===t.button||s)?a<0&&(e.push(t),a=e.length-1):o&(jb|Rb)&&(i=!0),a<0||(e[a]=t,this.callback(this.manager,o,{pointers:e,changedPointers:[t],pointerType:r,srcEvent:t}),i&&e.splice(a,1))},e}(fw);function ww(t){return Array.prototype.slice.call(t,0)}function xw(t,e,i){for(var n=[],o=[],r=0;r<t.length;){var s=e?t[r][e]:t[r];pw(o,s)<0&&n.push(t[r]),o[r]=s,r++}return i&&(n=e?n.sort((function(t,i){return t[e]>i[e]})):n.sort()),n}var kw={touchstart:Fb,touchmove:Ab,touchend:jb,touchcancel:Rb},_w="touchstart touchmove touchend touchcancel",Ew=function(t){function e(){var i;return e.prototype.evTarget=_w,(i=t.apply(this,arguments)||this).targetIds={},i}return db(e,t),e.prototype.handler=function(t){var e=kw[t.type],i=Ow.call(this,t,e);i&&this.callback(this.manager,e,{pointers:i[0],changedPointers:i[1],pointerType:Bb,srcEvent:t})},e}(fw);function Ow(t,e){var i,n,o=ww(t.touches),r=this.targetIds;if(e&(Fb|Ab)&&1===o.length)return r[o[0].identifier]=!0,[o,o];var s=ww(t.changedTouches),a=[],h=this.target;if(n=o.filter((function(t){return tw(t.target,h)})),e===Fb)for(i=0;i<n.length;)r[n[i].identifier]=!0,i++;for(i=0;i<s.length;)r[s[i].identifier]&&a.push(s[i]),e&(jb|Rb)&&delete r[s[i].identifier],i++;return a.length?[xw(n.concat(a),"identifier",!0),a]:void 0}var Cw={mousedown:Fb,mousemove:Ab,mouseup:jb},Sw="mousedown",Tw="mousemove mouseup",Mw=function(t){function e(){var i,n=e.prototype;return n.evEl=Sw,n.evWin=Tw,(i=t.apply(this,arguments)||this).pressed=!1,i}return db(e,t),e.prototype.handler=function(t){var e=Cw[t.type];e&Fb&&0===t.button&&(this.pressed=!0),e&Ab&&1!==t.which&&(e=jb),this.pressed&&(e&jb&&(this.pressed=!1),this.callback(this.manager,e,{pointers:[t],changedPointers:[t],pointerType:Nb,srcEvent:t}))},e}(fw),Pw=2500,Dw=25;function Iw(t){var e=t.changedPointers[0];if(e.identifier===this.primaryTouch){var i={x:e.clientX,y:e.clientY},n=this.lastTouches;this.lastTouches.push(i);setTimeout((function(){var t=n.indexOf(i);t>-1&&n.splice(t,1)}),Pw)}}function Bw(t,e){t&Fb?(this.primaryTouch=e.changedPointers[0].identifier,Iw.call(this,e)):t&(jb|Rb)&&Iw.call(this,e)}function Nw(t){for(var e=t.srcEvent.clientX,i=t.srcEvent.clientY,n=0;n<this.lastTouches.length;n++){var o=this.lastTouches[n],r=Math.abs(e-o.x),s=Math.abs(i-o.y);if(r<=Dw&&s<=Dw)return!0}return!1}var zw=function(){return function(t){function e(e,i){var n;return(n=t.call(this,e,i)||this).handler=function(t,e,i){var o=i.pointerType===Bb,r=i.pointerType===Nb;if(!(r&&i.sourceCapabilities&&i.sourceCapabilities.firesTouchEvents)){if(o)Bw.call(cb(cb(n)),e,i);else if(r&&Nw.call(cb(cb(n)),i))return;n.callback(t,e,i)}},n.touch=new Ew(n.manager,n.handler),n.mouse=new Mw(n.manager,n.handler),n.primaryTouch=null,n.lastTouches=[],n}return db(e,t),e.prototype.destroy=function(){this.touch.destroy(),this.mouse.destroy()},e}(fw)}();function Fw(t,e,i){return!!Array.isArray(t)&&($b(t,i[e],i),!0)}var Aw=1,jw=2,Rw=4,Lw=8,Hw=Lw,Ww=16,qw=32,Vw=1;function Uw(t,e){var i=e.manager;return i?i.get(t):t}function Yw(t){return t&Ww?"cancel":t&Lw?"end":t&Rw?"move":t&jw?"start":""}var Xw=function(){function t(t){void 0===t&&(t={}),this.options=lb({enable:!0},t),this.id=Vw++,this.manager=null,this.state=Aw,this.simultaneous={},this.requireFail=[]}var e=t.prototype;return e.set=function(t){return fb(this.options,t),this.manager&&this.manager.touchAction.update(),this},e.recognizeWith=function(t){if(Fw(t,"recognizeWith",this))return this;var e=this.simultaneous;return e[(t=Uw(t,this)).id]||(e[t.id]=t,t.recognizeWith(this)),this},e.dropRecognizeWith=function(t){return Fw(t,"dropRecognizeWith",this)||(t=Uw(t,this),delete this.simultaneous[t.id]),this},e.requireFailure=function(t){if(Fw(t,"requireFailure",this))return this;var e=this.requireFail;return-1===pw(e,t=Uw(t,this))&&(e.push(t),t.requireFailure(this)),this},e.dropRequireFailure=function(t){if(Fw(t,"dropRequireFailure",this))return this;t=Uw(t,this);var e=pw(this.requireFail,t);return e>-1&&this.requireFail.splice(e,1),this},e.hasRequireFailures=function(){return this.requireFail.length>0},e.canRecognizeWith=function(t){return!!this.simultaneous[t.id]},e.emit=function(t){var e=this,i=this.state;function n(i){e.manager.emit(i,t)}i<Lw&&n(e.options.event+Yw(i)),n(e.options.event),t.additionalEvent&&n(t.additionalEvent),i>=Lw&&n(e.options.event+Yw(i))},e.tryEmit=function(t){if(this.canEmit())return this.emit(t);this.state=qw},e.canEmit=function(){for(var t=0;t<this.requireFail.length;){if(!(this.requireFail[t].state&(qw|Aw)))return!1;t++}return!0},e.recognize=function(t){var e=fb({},t);if(!Zb(this.options.enable,[this,e]))return this.reset(),void(this.state=qw);this.state&(Hw|Ww|qw)&&(this.state=Aw),this.state=this.process(e),this.state&(jw|Rw|Lw|Ww)&&this.tryEmit(e)},e.process=function(t){},e.getTouchAction=function(){},e.reset=function(){},t}(),Gw=function(t){function e(e){var i;return void 0===e&&(e={}),(i=t.call(this,lb({event:"tap",pointers:1,taps:1,interval:300,time:250,threshold:9,posThreshold:10},e))||this).pTime=!1,i.pCenter=!1,i._timer=null,i._input=null,i.count=0,i}db(e,t);var i=e.prototype;return i.getTouchAction=function(){return[Ob]},i.process=function(t){var e=this,i=this.options,n=t.pointers.length===i.pointers,o=t.distance<i.threshold,r=t.deltaTime<i.time;if(this.reset(),t.eventType&Fb&&0===this.count)return this.failTimeout();if(o&&r&&n){if(t.eventType!==jb)return this.failTimeout();var s=!this.pTime||t.timeStamp-this.pTime<i.interval,a=!this.pCenter||nw(this.pCenter,t.center)<i.posThreshold;if(this.pTime=t.timeStamp,this.pCenter=t.center,a&&s?this.count+=1:this.count=1,this._input=t,0===this.count%i.taps)return this.hasRequireFailures()?(this._timer=setTimeout((function(){e.state=Hw,e.tryEmit()}),i.interval),jw):Hw}return qw},i.failTimeout=function(){var t=this;return this._timer=setTimeout((function(){t.state=qw}),this.options.interval),qw},i.reset=function(){clearTimeout(this._timer)},i.emit=function(){this.state===Hw&&(this._input.tapCount=this.count,this.manager.emit(this.options.event,this._input))},e}(Xw),Kw=function(t){function e(e){return void 0===e&&(e={}),t.call(this,lb({pointers:1},e))||this}db(e,t);var i=e.prototype;return i.attrTest=function(t){var e=this.options.pointers;return 0===e||t.pointers.length===e},i.process=function(t){var e=this.state,i=t.eventType,n=e&(jw|Rw),o=this.attrTest(t);return n&&(i&Rb||!o)?e|Ww:n||o?i&jb?e|Lw:e&jw?e|Rw:jw:qw},e}(Xw);function $w(t){return t===Vb?"down":t===qb?"up":t===Hb?"left":t===Wb?"right":""}var Zw=function(t){function e(e){var i;return void 0===e&&(e={}),(i=t.call(this,lb({event:"pan",threshold:10,pointers:1,direction:Xb},e))||this).pX=null,i.pY=null,i}db(e,t);var i=e.prototype;return i.getTouchAction=function(){var t=this.options.direction,e=[];return t&Ub&&e.push(Tb),t&Yb&&e.push(Sb),e},i.directionTest=function(t){var e=this.options,i=!0,n=t.distance,o=t.direction,r=t.deltaX,s=t.deltaY;return o&e.direction||(e.direction&Ub?(o=0===r?Lb:r<0?Hb:Wb,i=r!==this.pX,n=Math.abs(t.deltaX)):(o=0===s?Lb:s<0?qb:Vb,i=s!==this.pY,n=Math.abs(t.deltaY))),t.direction=o,i&&n>e.threshold&&o&e.direction},i.attrTest=function(t){return Kw.prototype.attrTest.call(this,t)&&(this.state&jw||!(this.state&jw)&&this.directionTest(t))},i.emit=function(e){this.pX=e.deltaX,this.pY=e.deltaY;var i=$w(e.direction);i&&(e.additionalEvent=this.options.event+i),t.prototype.emit.call(this,e)},e}(Kw),Qw=function(t){function e(e){return void 0===e&&(e={}),t.call(this,lb({event:"swipe",threshold:10,velocity:.3,direction:Ub|Yb,pointers:1},e))||this}db(e,t);var i=e.prototype;return i.getTouchAction=function(){return Zw.prototype.getTouchAction.call(this)},i.attrTest=function(e){var i,n=this.options.direction;return n&(Ub|Yb)?i=e.overallVelocity:n&Ub?i=e.overallVelocityX:n&Yb&&(i=e.overallVelocityY),t.prototype.attrTest.call(this,e)&&n&e.offsetDirection&&e.distance>this.options.threshold&&e.maxPointers===this.options.pointers&&mb(i)>this.options.velocity&&e.eventType&jb},i.emit=function(t){var e=$w(t.offsetDirection);e&&this.manager.emit(this.options.event+e,t),this.manager.emit(this.options.event,t)},e}(Kw),Jw=function(t){function e(e){return void 0===e&&(e={}),t.call(this,lb({event:"pinch",threshold:0,pointers:2},e))||this}db(e,t);var i=e.prototype;return i.getTouchAction=function(){return[Cb]},i.attrTest=function(e){return t.prototype.attrTest.call(this,e)&&(Math.abs(e.scale-1)>this.options.threshold||this.state&jw)},i.emit=function(e){if(1!==e.scale){var i=e.scale<1?"in":"out";e.additionalEvent=this.options.event+i}t.prototype.emit.call(this,e)},e}(Kw),tx=function(t){function e(e){return void 0===e&&(e={}),t.call(this,lb({event:"rotate",threshold:0,pointers:2},e))||this}db(e,t);var i=e.prototype;return i.getTouchAction=function(){return[Cb]},i.attrTest=function(e){return t.prototype.attrTest.call(this,e)&&(Math.abs(e.rotation)>this.options.threshold||this.state&jw)},e}(Kw),ex=function(t){function e(e){var i;return void 0===e&&(e={}),(i=t.call(this,lb({event:"press",pointers:1,time:251,threshold:9},e))||this)._timer=null,i._input=null,i}db(e,t);var i=e.prototype;return i.getTouchAction=function(){return[Eb]},i.process=function(t){var e=this,i=this.options,n=t.pointers.length===i.pointers,o=t.distance<i.threshold,r=t.deltaTime>i.time;if(this._input=t,!o||!n||t.eventType&(jb|Rb)&&!r)this.reset();else if(t.eventType&Fb)this.reset(),this._timer=setTimeout((function(){e.state=Hw,e.tryEmit()}),i.time);else if(t.eventType&jb)return Hw;return qw},i.reset=function(){clearTimeout(this._timer)},i.emit=function(t){this.state===Hw&&(t&&t.eventType&jb?this.manager.emit(this.options.event+"up",t):(this._input.timeStamp=bb(),this.manager.emit(this.options.event,this._input)))},e}(Xw),ix={domEvents:!1,touchAction:_b,enable:!0,inputTarget:null,inputClass:null,cssProps:{userSelect:"none",touchSelect:"none",touchCallout:"none",contentZooming:"none",userDrag:"none",tapHighlightColor:"rgba(0,0,0,0)"}},nx=[[tx,{enable:!1}],[Jw,{enable:!1},["rotate"]],[Qw,{direction:Ub}],[Zw,{direction:Ub},["swipe"]],[Gw],[Gw,{event:"doubletap",taps:2},["tap"]],[ex]];function ox(t,e){var i,n=t.element;n.style&&($b(t.options.cssProps,(function(o,r){i=wb(n.style,r),e?(t.oldCssProps[i]=n.style[i],n.style[i]=o):n.style[i]=t.oldCssProps[i]||""})),e||(t.oldCssProps={}))}var rx=function(){function t(t,e){var i,n=this;this.options=fb({},ix,e||{}),this.options.inputTarget=this.options.inputTarget||t,this.handlers={},this.session={},this.recognizers=[],this.oldCssProps={},this.element=t,this.input=new((i=this).options.inputClass||(Db?bw:Ib?Ew:Pb?zw:Mw))(i,hw),this.touchAction=new Jb(this,this.options.touchAction),ox(this,!0),$b(this.options.recognizers,(function(t){var e=n.add(new t[0](t[1]));t[2]&&e.recognizeWith(t[2]),t[3]&&e.requireFailure(t[3])}),this)}var e=t.prototype;return e.set=function(t){return fb(this.options,t),t.touchAction&&this.touchAction.update(),t.inputTarget&&(this.input.destroy(),this.input.target=t.inputTarget,this.input.init()),this},e.stop=function(t){this.session.stopped=t?2:1},e.recognize=function(t){var e=this.session;if(!e.stopped){var i;this.touchAction.preventDefaults(t);var n=this.recognizers,o=e.curRecognizer;(!o||o&&o.state&Hw)&&(e.curRecognizer=null,o=null);for(var r=0;r<n.length;)i=n[r],2===e.stopped||o&&i!==o&&!i.canRecognizeWith(o)?i.reset():i.recognize(t),!o&&i.state&(jw|Rw|Lw)&&(e.curRecognizer=i,o=i),r++}},e.get=function(t){if(t instanceof Xw)return t;for(var e=this.recognizers,i=0;i<e.length;i++)if(e[i].options.event===t)return e[i];return null},e.add=function(t){if(Fw(t,"add",this))return this;var e=this.get(t.options.event);return e&&this.remove(e),this.recognizers.push(t),t.manager=this,this.touchAction.update(),t},e.remove=function(t){if(Fw(t,"remove",this))return this;var e=this.get(t);if(t){var i=this.recognizers,n=pw(i,e);-1!==n&&(i.splice(n,1),this.touchAction.update())}return this},e.on=function(t,e){if(void 0===t||void 0===e)return this;var i=this.handlers;return $b(lw(t),(function(t){i[t]=i[t]||[],i[t].push(e)})),this},e.off=function(t,e){if(void 0===t)return this;var i=this.handlers;return $b(lw(t),(function(t){e?i[t]&&i[t].splice(pw(i[t],e),1):delete i[t]})),this},e.emit=function(t,e){this.options.domEvents&&function(t,e){var i=document.createEvent("Event");i.initEvent(t,!0,!0),i.gesture=e,e.target.dispatchEvent(i)}(t,e);var i=this.handlers[t]&&this.handlers[t].slice();if(i&&i.length){e.type=t,e.preventDefault=function(){e.srcEvent.preventDefault()};for(var n=0;n<i.length;)i[n](e),n++}},e.destroy=function(){this.element&&ox(this,!1),this.handlers={},this.session={},this.input.destroy(),this.element=null},t}(),sx={touchstart:Fb,touchmove:Ab,touchend:jb,touchcancel:Rb},ax="touchstart",hx="touchstart touchmove touchend touchcancel",lx=function(t){function e(){var i,n=e.prototype;return n.evTarget=ax,n.evWin=hx,(i=t.apply(this,arguments)||this).started=!1,i}return db(e,t),e.prototype.handler=function(t){var e=sx[t.type];if(e===Fb&&(this.started=!0),this.started){var i=dx.call(this,t,e);e&(jb|Rb)&&i[0].length-i[1].length==0&&(this.started=!1),this.callback(this.manager,e,{pointers:i[0],changedPointers:i[1],pointerType:Bb,srcEvent:t})}},e}(fw);function dx(t,e){var i=ww(t.touches),n=ww(t.changedTouches);return e&(jb|Rb)&&(i=xw(i.concat(n),"identifier",!0)),[i,n]}function cx(t,e,i){var n="DEPRECATED METHOD: "+e+"\n"+i+" AT \n";return function(){var e=new Error("get-stack-trace"),i=e&&e.stack?e.stack.replace(/^[^\(]+?[\n$]/gm,"").replace(/^\s+at\s+/gm,"").replace(/^Object.<anonymous>\s*\(/gm,"{anonymous}()@"):"Unknown Stack Trace",o=window.console&&(window.console.warn||window.console.log);return o&&o.call(window.console,n,i),t.apply(this,arguments)}}var ux=cx((function(t,e,i){for(var n=Object.keys(e),o=0;o<n.length;)(!i||i&&void 0===t[n[o]])&&(t[n[o]]=e[n[o]]),o++;return t}),"extend","Use `assign`."),fx=cx((function(t,e){return ux(t,e,!0)}),"merge","Use `assign`.");function px(t,e,i){var n,o=e.prototype;(n=t.prototype=Object.create(o)).constructor=t,n._super=o,i&&fb(n,i)}function vx(t,e){return function(){return t.apply(e,arguments)}}var gx=function(){var t=function(t,e){return void 0===e&&(e={}),new rx(t,lb({recognizers:nx.concat()},e))};return t.VERSION="2.0.17-rc",t.DIRECTION_ALL=Xb,t.DIRECTION_DOWN=Vb,t.DIRECTION_LEFT=Hb,t.DIRECTION_RIGHT=Wb,t.DIRECTION_UP=qb,t.DIRECTION_HORIZONTAL=Ub,t.DIRECTION_VERTICAL=Yb,t.DIRECTION_NONE=Lb,t.DIRECTION_DOWN=Vb,t.INPUT_START=Fb,t.INPUT_MOVE=Ab,t.INPUT_END=jb,t.INPUT_CANCEL=Rb,t.STATE_POSSIBLE=Aw,t.STATE_BEGAN=jw,t.STATE_CHANGED=Rw,t.STATE_ENDED=Lw,t.STATE_RECOGNIZED=Hw,t.STATE_CANCELLED=Ww,t.STATE_FAILED=qw,t.Manager=rx,t.Input=fw,t.TouchAction=Jb,t.TouchInput=Ew,t.MouseInput=Mw,t.PointerEventInput=bw,t.TouchMouseInput=zw,t.SingleTouchInput=lx,t.Recognizer=Xw,t.AttrRecognizer=Kw,t.Tap=Gw,t.Pan=Zw,t.Swipe=Qw,t.Pinch=Jw,t.Rotate=tx,t.Press=ex,t.on=dw,t.off=cw,t.each=$b,t.merge=fx,t.extend=ux,t.bindFn=vx,t.assign=fb,t.inherit=px,t.bindFn=vx,t.prefixed=wb,t.toArray=ww,t.inArray=pw,t.uniqueArray=xw,t.splitStr=lw,t.boolOrFn=Zb,t.hasParent=tw,t.addEventListeners=dw,t.removeEventListeners=cw,t.defaults=fb({},ix,{preset:nx}),t}();gx.defaults;var yx=gx;function mx(t,e){var i=ov(t);if(mc){var n=mc(t);e&&(n=ny(n).call(n,(function(e){return Dc(t,e).enumerable}))),i.push.apply(i,n)}return i}function bx(t){for(var e=1;e<arguments.length;e++){var i,n,o=null!=arguments[e]?arguments[e]:{};e%2?Cv(i=mx(Object(o),!0)).call(i,(function(e){zf(t,e,o[e])})):Uc?iu(t,Uc(o)):Cv(n=mx(Object(o))).call(n,(function(e){fu(t,e,Dc(o,e))}))}return t}function wx(t,e){var i=void 0!==Op&&xh(t)||t["@@iterator"];if(!i){if(Wp(t)||(i=function(t,e){var i;if(!t)return;if("string"==typeof t)return xx(t,e);var n=Fp(i=Object.prototype.toString.call(t)).call(i,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return Za(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return xx(t,e)}(t))||e&&t&&"number"==typeof t.length){i&&(t=i);var n=0,o=function(){};return{s:o,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var r,s=!0,a=!1;return{s:function(){i=i.call(t)},n:function(){var t=i.next();return s=t.done,t},e:function(t){a=!0,r=t},f:function(){try{s||null==i.return||i.return()}finally{if(a)throw r}}}}function xx(t,e){(null==e||e>t.length)&&(e=t.length);for(var i=0,n=new Array(e);i<e;i++)n[i]=t[i];return n}var kx=Op("DELETE");function _x(t){for(var e,i=arguments.length,n=new Array(i>1?i-1:0),o=1;o<i;o++)n[o-1]=arguments[o];return Ex.apply(void 0,Np(e=[{},t]).call(e,n))}function Ex(){var t=Ox.apply(void 0,arguments);return Sx(t),t}function Ox(){for(var t=arguments.length,e=new Array(t),i=0;i<t;i++)e[i]=arguments[i];if(e.length<2)return e[0];var n;if(e.length>2)return Ox.apply(void 0,Np(n=[Ex(e[0],e[1])]).call(n,_p(Fp(e).call(e,2))));var o,r=e[0],s=e[1],a=wx(Lp(s));try{for(a.s();!(o=a.n()).done;){var h=o.value;Object.prototype.propertyIsEnumerable.call(s,h)&&(s[h]===kx?delete r[h]:null===r[h]||null===s[h]||"object"!==Of(r[h])||"object"!==Of(s[h])||Wp(r[h])||Wp(s[h])?r[h]=Cx(s[h]):r[h]=Ox(r[h],s[h]))}}catch(t){a.e(t)}finally{a.f()}return r}function Cx(t){return Wp(t)?Qp(t).call(t,(function(t){return Cx(t)})):"object"===Of(t)&&null!==t?Ox({},t):t}function Sx(t){for(var e=0,i=ov(t);e<i.length;e++){var n=i[e];t[n]===kx?delete t[n]:"object"===Of(t[n])&&null!==t[n]&&Sx(t[n])}}function Tx(){for(var t=arguments.length,e=new Array(t),i=0;i<t;i++)e[i]=arguments[i];return function(t){var e=function(){for(var t=function(){var t=4022871197;return function(e){for(var i=e.toString(),n=0;n<i.length;n++){var o=.02519603282416938*(t+=i.charCodeAt(n));o-=t=o>>>0,t=(o*=t)>>>0,t+=4294967296*(o-=t)}return 2.3283064365386963e-10*(t>>>0)}}(),e=t(" "),i=t(" "),n=t(" "),o=0;o<arguments.length;o++)(e-=t(o<0||arguments.length<=o?void 0:arguments[o]))<0&&(e+=1),(i-=t(o<0||arguments.length<=o?void 0:arguments[o]))<0&&(i+=1),(n-=t(o<0||arguments.length<=o?void 0:arguments[o]))<0&&(n+=1);return[e,i,n]}(t),i=kp(e,3),n=i[0],o=i[1],r=i[2],s=1,a=function(){var t=2091639*n+2.3283064365386963e-10*s;return n=o,o=r,r=t-(s=0|t)};return a.uint32=function(){return 4294967296*a()},a.fract53=function(){return a()+11102230246251565e-32*(2097152*a()|0)},a.algorithm="Alea",a.seed=t,a.version="0.9",a}(e.length?e:[cv()])}var Mx="undefined"!=typeof window?window.Hammer||yx:function(){return function(){var t=function(){};return{on:t,off:t,destroy:t,emit:t,get:function(){return{set:t}}}}()};function Px(t){var e,i=this;this._cleanupQueue=[],this.active=!1,this._dom={container:t,overlay:document.createElement("div")},this._dom.overlay.classList.add("vis-overlay"),this._dom.container.appendChild(this._dom.overlay),this._cleanupQueue.push((function(){i._dom.overlay.parentNode.removeChild(i._dom.overlay)}));var n=Mx(this._dom.overlay);n.on("tap",Yn(e=this._onTapOverlay).call(e,this)),this._cleanupQueue.push((function(){n.destroy()}));var o=["tap","doubletap","press","pinch","pan","panstart","panmove","panend"];Cv(o).call(o,(function(t){n.on(t,(function(t){t.srcEvent.stopPropagation()}))})),document&&document.body&&(this._onClick=function(e){(function(t,e){for(;t;){if(t===e)return!0;t=t.parentNode}return!1})(e.target,t)||i.deactivate()},document.body.addEventListener("click",this._onClick),this._cleanupQueue.push((function(){document.body.removeEventListener("click",i._onClick)}))),this._escListener=function(t){("key"in t?"Escape"===t.key:27===t.keyCode)&&i.deactivate()}}to(Px.prototype),Px.current=null,Px.prototype.destroy=function(){var t,e;this.deactivate();var i,n=wx(Rv(t=vg(e=this._cleanupQueue).call(e,0)).call(t));try{for(n.s();!(i=n.n()).done;){(0,i.value)()}}catch(t){n.e(t)}finally{n.f()}},Px.prototype.activate=function(){Px.current&&Px.current.deactivate(),Px.current=this,this.active=!0,this._dom.overlay.style.display="none",this._dom.container.classList.add("vis-active"),this.emit("change"),this.emit("activate"),document.body.addEventListener("keydown",this._escListener)},Px.prototype.deactivate=function(){this.active=!1,this._dom.overlay.style.display="block",this._dom.container.classList.remove("vis-active"),document.body.removeEventListener("keydown",this._escListener),this.emit("change"),this.emit("deactivate")},Px.prototype._onTapOverlay=function(t){this.activate(),t.srcEvent.stopPropagation()};var Dx=/^\/?Date\((-?\d+)/i,Ix=/^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i,Bx=/^#?([a-f\d])([a-f\d])([a-f\d])$/i,Nx=/^rgb\( *(1?\d{1,2}|2[0-4]\d|25[0-5]) *, *(1?\d{1,2}|2[0-4]\d|25[0-5]) *, *(1?\d{1,2}|2[0-4]\d|25[0-5]) *\)$/i,zx=/^rgba\( *(1?\d{1,2}|2[0-4]\d|25[0-5]) *, *(1?\d{1,2}|2[0-4]\d|25[0-5]) *, *(1?\d{1,2}|2[0-4]\d|25[0-5]) *, *([01]|0?\.\d+) *\)$/i;function Fx(t){return t instanceof Number||"number"==typeof t}function Ax(t){if(t)for(;!0===t.hasChildNodes();){var e=t.firstChild;e&&(Ax(e),t.removeChild(e))}}function jx(t){return t instanceof String||"string"==typeof t}function Rx(t){return"object"===Of(t)&&null!==t}function Lx(t,e,i,n){var o=!1;!0===n&&(o=null===e[i]&&void 0!==t[i]),o?delete t[i]:t[i]=e[i]}function Hx(t,e){var i=arguments.length>2&&void 0!==arguments[2]&&arguments[2];for(var n in t)if(void 0!==e[n])if(null===e[n]||"object"!==Of(e[n]))Lx(t,e,n,i);else{var o=t[n],r=e[n];Rx(o)&&Rx(r)&&Hx(o,r,i)}}var Wx=xn;function qx(t,e,i){var n=arguments.length>3&&void 0!==arguments[3]&&arguments[3];if(Wp(i))throw new TypeError("Arrays are not supported by deepExtend");for(var o=0;o<t.length;o++){var r=t[o];if(Object.prototype.hasOwnProperty.call(i,r))if(i[r]&&i[r].constructor===Object)void 0===e[r]&&(e[r]={}),e[r].constructor===Object?Ux(e[r],i[r],!1,n):Lx(e,i,r,n);else{if(Wp(i[r]))throw new TypeError("Arrays are not supported by deepExtend");Lx(e,i,r,n)}}return e}function Vx(t,e,i){var n=arguments.length>3&&void 0!==arguments[3]&&arguments[3];if(Wp(i))throw new TypeError("Arrays are not supported by deepExtend");for(var o in i)if(Object.prototype.hasOwnProperty.call(i,o)&&!Lg(t).call(t,o))if(i[o]&&i[o].constructor===Object)void 0===e[o]&&(e[o]={}),e[o].constructor===Object?Ux(e[o],i[o]):Lx(e,i,o,n);else if(Wp(i[o])){e[o]=[];for(var r=0;r<i[o].length;r++)e[o].push(i[o][r])}else Lx(e,i,o,n);return e}function Ux(t,e){var i=arguments.length>2&&void 0!==arguments[2]&&arguments[2],n=arguments.length>3&&void 0!==arguments[3]&&arguments[3];for(var o in e)if(Object.prototype.hasOwnProperty.call(e,o)||!0===i)if("object"===Of(e[o])&&null!==e[o]&&Xg(e[o])===Object.prototype)void 0===t[o]?t[o]=Ux({},e[o],i):"object"===Of(t[o])&&null!==t[o]&&Xg(t[o])===Object.prototype?Ux(t[o],e[o],i):Lx(t,e,o,n);else if(Wp(e[o])){var r;t[o]=Fp(r=e[o]).call(r)}else Lx(t,e,o,n);return t}function Yx(t,e){var i;return Np(i=[]).call(i,_p(t),[e])}function Xx(t){return Fp(t).call(t)}function Gx(t){return t.getBoundingClientRect().left}function Kx(t){return t.getBoundingClientRect().top}function $x(t,e){if(Wp(t))for(var i=t.length,n=0;n<i;n++)e(t[n],n,t);else for(var o in t)Object.prototype.hasOwnProperty.call(t,o)&&e(t[o],o,t)}var Zx=vy;function Qx(t,e,i,n){var o;t.addEventListener?(void 0===n&&(n=!1),"mousewheel"===e&&Lg(o=navigator.userAgent).call(o,"Firefox")&&(e="DOMMouseScroll"),t.addEventListener(e,i,n)):t.attachEvent("on"+e,i)}function Jx(t,e,i,n){var o;t.removeEventListener?(void 0===n&&(n=!1),"mousewheel"===e&&Lg(o=navigator.userAgent).call(o,"Firefox")&&(e="DOMMouseScroll"),t.removeEventListener(e,i,n)):t.detachEvent("on"+e,i)}var tk={asBoolean:function(t,e){return"function"==typeof t&&(t=t()),null!=t?0!=t:e||null},asNumber:function(t,e){return"function"==typeof t&&(t=t()),null!=t?Number(t)||e||null:e||null},asString:function(t,e){return"function"==typeof t&&(t=t()),null!=t?String(t):e||null},asSize:function(t,e){return"function"==typeof t&&(t=t()),jx(t)?t:Fx(t)?t+"px":e||null},asElement:function(t,e){return"function"==typeof t&&(t=t()),t||e||null}};function ek(t){var e;switch(t.length){case 3:case 4:return(e=Bx.exec(t))?{r:Ly(e[1]+e[1],16),g:Ly(e[2]+e[2],16),b:Ly(e[3]+e[3],16)}:null;case 6:case 7:return(e=Ix.exec(t))?{r:Ly(e[1],16),g:Ly(e[2],16),b:Ly(e[3],16)}:null;default:return null}}function ik(t,e){if(Lg(t).call(t,"rgba"))return t;if(Lg(t).call(t,"rgb")){var i=t.substr(tm(t).call(t,"(")+1).replace(")","").split(",");return"rgba("+i[0]+","+i[1]+","+i[2]+","+e+")"}var n=ek(t);return null==n?t:"rgba("+n.r+","+n.g+","+n.b+","+e+")"}function nk(t,e,i){var n;return"#"+Fp(n=((1<<24)+(t<<16)+(e<<8)+i).toString(16)).call(n,1)}function ok(t,e){if(jx(t)){var i=t;if(ck(i)){var n,o=Qp(n=i.substr(4).substr(0,i.length-5).split(",")).call(n,(function(t){return Ly(t)}));i=nk(o[0],o[1],o[2])}if(!0===dk(i)){var r=lk(i),s={h:r.h,s:.8*r.s,v:Math.min(1,1.02*r.v)},a={h:r.h,s:Math.min(1,1.25*r.s),v:.8*r.v},h=hk(a.h,a.s,a.v),l=hk(s.h,s.s,s.v);return{background:i,border:h,highlight:{background:l,border:h},hover:{background:l,border:h}}}return{background:i,border:i,highlight:{background:i,border:i},hover:{background:i,border:i}}}return e?{background:t.background||e.background,border:t.border||e.border,highlight:jx(t.highlight)?{border:t.highlight,background:t.highlight}:{background:t.highlight&&t.highlight.background||e.highlight.background,border:t.highlight&&t.highlight.border||e.highlight.border},hover:jx(t.hover)?{border:t.hover,background:t.hover}:{border:t.hover&&t.hover.border||e.hover.border,background:t.hover&&t.hover.background||e.hover.background}}:{background:t.background||void 0,border:t.border||void 0,highlight:jx(t.highlight)?{border:t.highlight,background:t.highlight}:{background:t.highlight&&t.highlight.background||void 0,border:t.highlight&&t.highlight.border||void 0},hover:jx(t.hover)?{border:t.hover,background:t.hover}:{border:t.hover&&t.hover.border||void 0,background:t.hover&&t.hover.background||void 0}}}function rk(t,e,i){t/=255,e/=255,i/=255;var n=Math.min(t,Math.min(e,i)),o=Math.max(t,Math.max(e,i));return n===o?{h:0,s:0,v:n}:{h:60*((t===n?3:i===n?1:5)-(t===n?e-i:i===n?t-e:i-t)/(o-n))/360,s:(o-n)/o,v:o}}var sk={split:function(t){var e,i={};return Cv(e=t.split(";")).call(e,(function(t){if(""!=fm(t).call(t)){var e,n,o=t.split(":"),r=fm(e=o[0]).call(e),s=fm(n=o[1]).call(n);i[r]=s}})),i},join:function(t){var e;return Qp(e=ov(t)).call(e,(function(e){return e+": "+t[e]})).join("; ")}};function ak(t,e,i){var n,o,r,s=Math.floor(6*t),a=6*t-s,h=i*(1-e),l=i*(1-a*e),d=i*(1-(1-a)*e);switch(s%6){case 0:n=i,o=d,r=h;break;case 1:n=l,o=i,r=h;break;case 2:n=h,o=i,r=d;break;case 3:n=h,o=l,r=i;break;case 4:n=d,o=h,r=i;break;case 5:n=i,o=h,r=l}return{r:Math.floor(255*n),g:Math.floor(255*o),b:Math.floor(255*r)}}function hk(t,e,i){var n=ak(t,e,i);return nk(n.r,n.g,n.b)}function lk(t){var e=ek(t);if(!e)throw new TypeError("'".concat(t,"' is not a valid color."));return rk(e.r,e.g,e.b)}function dk(t){return/(^#[0-9A-F]{6}$)|(^#[0-9A-F]{3}$)/i.test(t)}function ck(t){return Nx.test(t)}function uk(t){return zx.test(t)}function fk(t){if(null===t||"object"!==Of(t))return null;if(t instanceof Element)return t;var e=mm(t);for(var i in t)Object.prototype.hasOwnProperty.call(t,i)&&"object"==Of(t[i])&&(e[i]=fk(t[i]));return e}function pk(t,e,i){var n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:{},o=function(t){return null!=t},r=function(t){return null!==t&&"object"===Of(t)};if(!r(t))throw new Error("Parameter mergeTarget must be an object");if(!r(e))throw new Error("Parameter options must be an object");if(!o(i))throw new Error("Parameter option must have a value");if(!r(n))throw new Error("Parameter globalOptions must be an object");var s=e[i],a=r(n)&&!function(t){for(var e in t)if(Object.prototype.hasOwnProperty.call(t,e))return!1;return!0}(n)?n[i]:void 0,h=a?a.enabled:void 0;if(void 0!==s){if("boolean"==typeof s)return r(t[i])||(t[i]={}),void(t[i].enabled=s);if(null===s&&!r(t[i])){if(!o(a))return;t[i]=mm(a)}if(r(s)){var l=!0;void 0!==s.enabled?l=s.enabled:void 0!==h&&(l=a.enabled),function(t,e,i){r(t[i])||(t[i]={});var n=e[i],o=t[i];for(var s in n)Object.prototype.hasOwnProperty.call(n,s)&&(o[s]=n[s])}(t,e,i),t[i].enabled=l}}}var vk={linear:function(t){return t},easeInQuad:function(t){return t*t},easeOutQuad:function(t){return t*(2-t)},easeInOutQuad:function(t){return t<.5?2*t*t:(4-2*t)*t-1},easeInCubic:function(t){return t*t*t},easeOutCubic:function(t){return--t*t*t+1},easeInOutCubic:function(t){return t<.5?4*t*t*t:(t-1)*(2*t-2)*(2*t-2)+1},easeInQuart:function(t){return t*t*t*t},easeOutQuart:function(t){return 1- --t*t*t*t},easeInOutQuart:function(t){return t<.5?8*t*t*t*t:1-8*--t*t*t*t},easeInQuint:function(t){return t*t*t*t*t},easeOutQuint:function(t){return 1+--t*t*t*t*t},easeInOutQuint:function(t){return t<.5?16*t*t*t*t*t:1+16*--t*t*t*t*t}};function gk(t,e){var i;Wp(e)||(e=[e]);var n,o=wx(t);try{for(o.s();!(n=o.n()).done;){var r=n.value;if(r){i=r[e[0]];for(var s=1;s<e.length;s++)i&&(i=i[e[s]]);if(void 0!==i)break}}}catch(t){o.e(t)}finally{o.f()}return i}var yk={black:"#000000",navy:"#000080",darkblue:"#00008B",mediumblue:"#0000CD",blue:"#0000FF",darkgreen:"#006400",green:"#008000",teal:"#008080",darkcyan:"#008B8B",deepskyblue:"#00BFFF",darkturquoise:"#00CED1",mediumspringgreen:"#00FA9A",lime:"#00FF00",springgreen:"#00FF7F",aqua:"#00FFFF",cyan:"#00FFFF",midnightblue:"#191970",dodgerblue:"#1E90FF",lightseagreen:"#20B2AA",forestgreen:"#228B22",seagreen:"#2E8B57",darkslategray:"#2F4F4F",limegreen:"#32CD32",mediumseagreen:"#3CB371",turquoise:"#40E0D0",royalblue:"#4169E1",steelblue:"#4682B4",darkslateblue:"#483D8B",mediumturquoise:"#48D1CC",indigo:"#4B0082",darkolivegreen:"#556B2F",cadetblue:"#5F9EA0",cornflowerblue:"#6495ED",mediumaquamarine:"#66CDAA",dimgray:"#696969",slateblue:"#6A5ACD",olivedrab:"#6B8E23",slategray:"#708090",lightslategray:"#778899",mediumslateblue:"#7B68EE",lawngreen:"#7CFC00",chartreuse:"#7FFF00",aquamarine:"#7FFFD4",maroon:"#800000",purple:"#800080",olive:"#808000",gray:"#808080",skyblue:"#87CEEB",lightskyblue:"#87CEFA",blueviolet:"#8A2BE2",darkred:"#8B0000",darkmagenta:"#8B008B",saddlebrown:"#8B4513",darkseagreen:"#8FBC8F",lightgreen:"#90EE90",mediumpurple:"#9370D8",darkviolet:"#9400D3",palegreen:"#98FB98",darkorchid:"#9932CC",yellowgreen:"#9ACD32",sienna:"#A0522D",brown:"#A52A2A",darkgray:"#A9A9A9",lightblue:"#ADD8E6",greenyellow:"#ADFF2F",paleturquoise:"#AFEEEE",lightsteelblue:"#B0C4DE",powderblue:"#B0E0E6",firebrick:"#B22222",darkgoldenrod:"#B8860B",mediumorchid:"#BA55D3",rosybrown:"#BC8F8F",darkkhaki:"#BDB76B",silver:"#C0C0C0",mediumvioletred:"#C71585",indianred:"#CD5C5C",peru:"#CD853F",chocolate:"#D2691E",tan:"#D2B48C",lightgrey:"#D3D3D3",palevioletred:"#D87093",thistle:"#D8BFD8",orchid:"#DA70D6",goldenrod:"#DAA520",crimson:"#DC143C",gainsboro:"#DCDCDC",plum:"#DDA0DD",burlywood:"#DEB887",lightcyan:"#E0FFFF",lavender:"#E6E6FA",darksalmon:"#E9967A",violet:"#EE82EE",palegoldenrod:"#EEE8AA",lightcoral:"#F08080",khaki:"#F0E68C",aliceblue:"#F0F8FF",honeydew:"#F0FFF0",azure:"#F0FFFF",sandybrown:"#F4A460",wheat:"#F5DEB3",beige:"#F5F5DC",whitesmoke:"#F5F5F5",mintcream:"#F5FFFA",ghostwhite:"#F8F8FF",salmon:"#FA8072",antiquewhite:"#FAEBD7",linen:"#FAF0E6",lightgoldenrodyellow:"#FAFAD2",oldlace:"#FDF5E6",red:"#FF0000",fuchsia:"#FF00FF",magenta:"#FF00FF",deeppink:"#FF1493",orangered:"#FF4500",tomato:"#FF6347",hotpink:"#FF69B4",coral:"#FF7F50",darkorange:"#FF8C00",lightsalmon:"#FFA07A",orange:"#FFA500",lightpink:"#FFB6C1",pink:"#FFC0CB",gold:"#FFD700",peachpuff:"#FFDAB9",navajowhite:"#FFDEAD",moccasin:"#FFE4B5",bisque:"#FFE4C4",mistyrose:"#FFE4E1",blanchedalmond:"#FFEBCD",papayawhip:"#FFEFD5",lavenderblush:"#FFF0F5",seashell:"#FFF5EE",cornsilk:"#FFF8DC",lemonchiffon:"#FFFACD",floralwhite:"#FFFAF0",snow:"#FFFAFA",yellow:"#FFFF00",lightyellow:"#FFFFE0",ivory:"#FFFFF0",white:"#FFFFFF"},mk=function(){function t(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:1;pu(this,t),this.pixelRatio=e,this.generated=!1,this.centerCoordinates={x:144.5,y:144.5},this.r=289*.49,this.color={r:255,g:255,b:255,a:1},this.hueCircle=void 0,this.initialColor={r:255,g:255,b:255,a:1},this.previousColor=void 0,this.applied=!1,this.updateCallback=function(){},this.closeCallback=function(){},this._create()}return Nf(t,[{key:"insertTo",value:function(t){void 0!==this.hammer&&(this.hammer.destroy(),this.hammer=void 0),this.container=t,this.container.appendChild(this.frame),this._bindHammer(),this._setSize()}},{key:"setUpdateCallback",value:function(t){if("function"!=typeof t)throw new Error("Function attempted to set as colorPicker update callback is not a function.");this.updateCallback=t}},{key:"setCloseCallback",value:function(t){if("function"!=typeof t)throw new Error("Function attempted to set as colorPicker closing callback is not a function.");this.closeCallback=t}},{key:"_isColorString",value:function(t){if("string"==typeof t)return yk[t]}},{key:"setColor",value:function(t){var e=!(arguments.length>1&&void 0!==arguments[1])||arguments[1];if("none"!==t){var i,n=this._isColorString(t);if(void 0!==n&&(t=n),!0===jx(t)){if(!0===ck(t)){var o=t.substr(4).substr(0,t.length-5).split(",");i={r:o[0],g:o[1],b:o[2],a:1}}else if(!0===uk(t)){var r=t.substr(5).substr(0,t.length-6).split(",");i={r:r[0],g:r[1],b:r[2],a:r[3]}}else if(!0===dk(t)){var s=ek(t);i={r:s.r,g:s.g,b:s.b,a:1}}}else if(t instanceof Object&&void 0!==t.r&&void 0!==t.g&&void 0!==t.b){var a=void 0!==t.a?t.a:"1.0";i={r:t.r,g:t.g,b:t.b,a:a}}if(void 0===i)throw new Error("Unknown color passed to the colorPicker. Supported are strings: rgb, hex, rgba. Object: rgb ({r:r,g:g,b:b,[a:a]}). Supplied: "+Om(t));this._setColor(i,e)}}},{key:"show",value:function(){void 0!==this.closeCallback&&(this.closeCallback(),this.closeCallback=void 0),this.applied=!1,this.frame.style.display="block",this._generateHueCircle()}},{key:"_hide",value:function(){var t=this;!0===(!(arguments.length>0&&void 0!==arguments[0])||arguments[0])&&(this.previousColor=xn({},this.color)),!0===this.applied&&this.updateCallback(this.initialColor),this.frame.style.display="none",Gm((function(){void 0!==t.closeCallback&&(t.closeCallback(),t.closeCallback=void 0)}),0)}},{key:"_save",value:function(){this.updateCallback(this.color),this.applied=!1,this._hide()}},{key:"_apply",value:function(){this.applied=!0,this.updateCallback(this.color),this._updatePicker(this.color)}},{key:"_loadLast",value:function(){void 0!==this.previousColor?this.setColor(this.previousColor,!1):alert("There is no last color to load...")}},{key:"_setColor",value:function(t){!0===(!(arguments.length>1&&void 0!==arguments[1])||arguments[1])&&(this.initialColor=xn({},t)),this.color=t;var e=rk(t.r,t.g,t.b),i=2*Math.PI,n=this.r*e.s,o=this.centerCoordinates.x+n*Math.sin(i*e.h),r=this.centerCoordinates.y+n*Math.cos(i*e.h);this.colorPickerSelector.style.left=o-.5*this.colorPickerSelector.clientWidth+"px",this.colorPickerSelector.style.top=r-.5*this.colorPickerSelector.clientHeight+"px",this._updatePicker(t)}},{key:"_setOpacity",value:function(t){this.color.a=t/100,this._updatePicker(this.color)}},{key:"_setBrightness",value:function(t){var e=rk(this.color.r,this.color.g,this.color.b);e.v=t/100;var i=ak(e.h,e.s,e.v);i.a=this.color.a,this.color=i,this._updatePicker()}},{key:"_updatePicker",value:function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:this.color,e=rk(t.r,t.g,t.b),i=this.colorPickerCanvas.getContext("2d");void 0===this.pixelRation&&(this.pixelRatio=(window.devicePixelRatio||1)/(i.webkitBackingStorePixelRatio||i.mozBackingStorePixelRatio||i.msBackingStorePixelRatio||i.oBackingStorePixelRatio||i.backingStorePixelRatio||1)),i.setTransform(this.pixelRatio,0,0,this.pixelRatio,0,0);var n=this.colorPickerCanvas.clientWidth,o=this.colorPickerCanvas.clientHeight;i.clearRect(0,0,n,o),i.putImageData(this.hueCircle,0,0),i.fillStyle="rgba(0,0,0,"+(1-e.v)+")",i.circle(this.centerCoordinates.x,this.centerCoordinates.y,this.r),hb(i).call(i),this.brightnessRange.value=100*e.v,this.opacityRange.value=100*t.a,this.initialColorDiv.style.backgroundColor="rgba("+this.initialColor.r+","+this.initialColor.g+","+this.initialColor.b+","+this.initialColor.a+")",this.newColorDiv.style.backgroundColor="rgba("+this.color.r+","+this.color.g+","+this.color.b+","+this.color.a+")"}},{key:"_setSize",value:function(){this.colorPickerCanvas.style.width="100%",this.colorPickerCanvas.style.height="100%",this.colorPickerCanvas.width=289*this.pixelRatio,this.colorPickerCanvas.height=289*this.pixelRatio}},{key:"_create",value:function(){var t,e,i,n;if(this.frame=document.createElement("div"),this.frame.className="vis-color-picker",this.colorPickerDiv=document.createElement("div"),this.colorPickerSelector=document.createElement("div"),this.colorPickerSelector.className="vis-selector",this.colorPickerDiv.appendChild(this.colorPickerSelector),this.colorPickerCanvas=document.createElement("canvas"),this.colorPickerDiv.appendChild(this.colorPickerCanvas),this.colorPickerCanvas.getContext){var o=this.colorPickerCanvas.getContext("2d");this.pixelRatio=(window.devicePixelRatio||1)/(o.webkitBackingStorePixelRatio||o.mozBackingStorePixelRatio||o.msBackingStorePixelRatio||o.oBackingStorePixelRatio||o.backingStorePixelRatio||1),this.colorPickerCanvas.getContext("2d").setTransform(this.pixelRatio,0,0,this.pixelRatio,0,0)}else{var r=document.createElement("DIV");r.style.color="red",r.style.fontWeight="bold",r.style.padding="10px",r.innerText="Error: your browser does not support HTML canvas",this.colorPickerCanvas.appendChild(r)}this.colorPickerDiv.className="vis-color",this.opacityDiv=document.createElement("div"),this.opacityDiv.className="vis-opacity",this.brightnessDiv=document.createElement("div"),this.brightnessDiv.className="vis-brightness",this.arrowDiv=document.createElement("div"),this.arrowDiv.className="vis-arrow",this.opacityRange=document.createElement("input");try{this.opacityRange.type="range",this.opacityRange.min="0",this.opacityRange.max="100"}catch(t){}this.opacityRange.value="100",this.opacityRange.className="vis-range",this.brightnessRange=document.createElement("input");try{this.brightnessRange.type="range",this.brightnessRange.min="0",this.brightnessRange.max="100"}catch(t){}this.brightnessRange.value="100",this.brightnessRange.className="vis-range",this.opacityDiv.appendChild(this.opacityRange),this.brightnessDiv.appendChild(this.brightnessRange);var s=this;this.opacityRange.onchange=function(){s._setOpacity(this.value)},this.opacityRange.oninput=function(){s._setOpacity(this.value)},this.brightnessRange.onchange=function(){s._setBrightness(this.value)},this.brightnessRange.oninput=function(){s._setBrightness(this.value)},this.brightnessLabel=document.createElement("div"),this.brightnessLabel.className="vis-label vis-brightness",this.brightnessLabel.innerText="brightness:",this.opacityLabel=document.createElement("div"),this.opacityLabel.className="vis-label vis-opacity",this.opacityLabel.innerText="opacity:",this.newColorDiv=document.createElement("div"),this.newColorDiv.className="vis-new-color",this.newColorDiv.innerText="new",this.initialColorDiv=document.createElement("div"),this.initialColorDiv.className="vis-initial-color",this.initialColorDiv.innerText="initial",this.cancelButton=document.createElement("div"),this.cancelButton.className="vis-button vis-cancel",this.cancelButton.innerText="cancel",this.cancelButton.onclick=Yn(t=this._hide).call(t,this,!1),this.applyButton=document.createElement("div"),this.applyButton.className="vis-button vis-apply",this.applyButton.innerText="apply",this.applyButton.onclick=Yn(e=this._apply).call(e,this),this.saveButton=document.createElement("div"),this.saveButton.className="vis-button vis-save",this.saveButton.innerText="save",this.saveButton.onclick=Yn(i=this._save).call(i,this),this.loadButton=document.createElement("div"),this.loadButton.className="vis-button vis-load",this.loadButton.innerText="load last",this.loadButton.onclick=Yn(n=this._loadLast).call(n,this),this.frame.appendChild(this.colorPickerDiv),this.frame.appendChild(this.arrowDiv),this.frame.appendChild(this.brightnessLabel),this.frame.appendChild(this.brightnessDiv),this.frame.appendChild(this.opacityLabel),this.frame.appendChild(this.opacityDiv),this.frame.appendChild(this.newColorDiv),this.frame.appendChild(this.initialColorDiv),this.frame.appendChild(this.cancelButton),this.frame.appendChild(this.applyButton),this.frame.appendChild(this.saveButton),this.frame.appendChild(this.loadButton)}},{key:"_bindHammer",value:function(){var t=this;this.drag={},this.pinch={},this.hammer=new Mx(this.colorPickerCanvas),this.hammer.get("pinch").set({enable:!0}),this.hammer.on("hammer.input",(function(e){e.isFirst&&t._moveSelector(e)})),this.hammer.on("tap",(function(e){t._moveSelector(e)})),this.hammer.on("panstart",(function(e){t._moveSelector(e)})),this.hammer.on("panmove",(function(e){t._moveSelector(e)})),this.hammer.on("panend",(function(e){t._moveSelector(e)}))}},{key:"_generateHueCircle",value:function(){if(!1===this.generated){var t=this.colorPickerCanvas.getContext("2d");void 0===this.pixelRation&&(this.pixelRatio=(window.devicePixelRatio||1)/(t.webkitBackingStorePixelRatio||t.mozBackingStorePixelRatio||t.msBackingStorePixelRatio||t.oBackingStorePixelRatio||t.backingStorePixelRatio||1)),t.setTransform(this.pixelRatio,0,0,this.pixelRatio,0,0);var e,i,n,o,r=this.colorPickerCanvas.clientWidth,s=this.colorPickerCanvas.clientHeight;t.clearRect(0,0,r,s),this.centerCoordinates={x:.5*r,y:.5*s},this.r=.49*r;var a,h=2*Math.PI/360,l=1/this.r;for(n=0;n<360;n++)for(o=0;o<this.r;o++)e=this.centerCoordinates.x+o*Math.sin(h*n),i=this.centerCoordinates.y+o*Math.cos(h*n),a=ak(.002777777777777778*n,o*l,1),t.fillStyle="rgb("+a.r+","+a.g+","+a.b+")",t.fillRect(e-.5,i-.5,2,2);t.strokeStyle="rgba(0,0,0,1)",t.circle(this.centerCoordinates.x,this.centerCoordinates.y,this.r),t.stroke(),this.hueCircle=t.getImageData(0,0,r,s)}this.generated=!0}},{key:"_moveSelector",value:function(t){var e=this.colorPickerDiv.getBoundingClientRect(),i=t.center.x-e.left,n=t.center.y-e.top,o=.5*this.colorPickerDiv.clientHeight,r=.5*this.colorPickerDiv.clientWidth,s=i-r,a=n-o,h=Math.atan2(s,a),l=.98*Math.min(Math.sqrt(s*s+a*a),r),d=Math.cos(h)*l+o,c=Math.sin(h)*l+r;this.colorPickerSelector.style.top=d-.5*this.colorPickerSelector.clientHeight+"px",this.colorPickerSelector.style.left=c-.5*this.colorPickerSelector.clientWidth+"px";var u=h/(2*Math.PI);u=u<0?u+1:u;var f=l/this.r,p=rk(this.color.r,this.color.g,this.color.b);p.h=u,p.s=f;var v=ak(p.h,p.s,p.v);v.a=this.color.a,this.color=v,this.initialColorDiv.style.backgroundColor="rgba("+this.initialColor.r+","+this.initialColor.g+","+this.initialColor.b+","+this.initialColor.a+")",this.newColorDiv.style.backgroundColor="rgba("+this.color.r+","+this.color.g+","+this.color.b+","+this.color.a+")"}}]),t}();function bk(){for(var t=arguments.length,e=new Array(t),i=0;i<t;i++)e[i]=arguments[i];if(e.length<1)throw new TypeError("Invalid arguments.");if(1===e.length)return document.createTextNode(e[0]);var n=document.createElement(e[0]);return n.appendChild(bk.apply(void 0,_p(Fp(e).call(e,1)))),n}var wk,xk=function(){function t(e,i,n){var o=arguments.length>3&&void 0!==arguments[3]?arguments[3]:1,r=arguments.length>4&&void 0!==arguments[4]?arguments[4]:function(){return!1};pu(this,t),this.parent=e,this.changedOptions=[],this.container=i,this.allowCreation=!1,this.hideOption=r,this.options={},this.initialized=!1,this.popupCounter=0,this.defaultOptions={enabled:!1,filter:!0,container:void 0,showButton:!0},xn(this.options,this.defaultOptions),this.configureOptions=n,this.moduleOptions={},this.domElements=[],this.popupDiv={},this.popupLimit=5,this.popupHistory={},this.colorPicker=new mk(o),this.wrapper=void 0}return Nf(t,[{key:"setOptions",value:function(t){if(void 0!==t){this.popupHistory={},this._removePopup();var e=!0;if("string"==typeof t)this.options.filter=t;else if(Wp(t))this.options.filter=t.join();else if("object"===Of(t)){if(null==t)throw new TypeError("options cannot be null");void 0!==t.container&&(this.options.container=t.container),void 0!==ny(t)&&(this.options.filter=ny(t)),void 0!==t.showButton&&(this.options.showButton=t.showButton),void 0!==t.enabled&&(e=t.enabled)}else"boolean"==typeof t?(this.options.filter=!0,e=t):"function"==typeof t&&(this.options.filter=t,e=!0);!1===ny(this.options)&&(e=!1),this.options.enabled=e}this._clean()}},{key:"setModuleOptions",value:function(t){this.moduleOptions=t,!0===this.options.enabled&&(this._clean(),void 0!==this.options.container&&(this.container=this.options.container),this._create())}},{key:"_create",value:function(){this._clean(),this.changedOptions=[];var t=ny(this.options),e=0,i=!1;for(var n in this.configureOptions)Object.prototype.hasOwnProperty.call(this.configureOptions,n)&&(this.allowCreation=!1,i=!1,"function"==typeof t?i=(i=t(n,[]))||this._handleObject(this.configureOptions[n],[n],!0):!0!==t&&-1===tm(t).call(t,n)||(i=!0),!1!==i&&(this.allowCreation=!0,e>0&&this._makeItem([]),this._makeHeader(n),this._handleObject(this.configureOptions[n],[n])),e++);this._makeButton(),this._push()}},{key:"_push",value:function(){this.wrapper=document.createElement("div"),this.wrapper.className="vis-configuration-wrapper",this.container.appendChild(this.wrapper);for(var t=0;t<this.domElements.length;t++)this.wrapper.appendChild(this.domElements[t]);this._showPopupIfNeeded()}},{key:"_clean",value:function(){for(var t=0;t<this.domElements.length;t++)this.wrapper.removeChild(this.domElements[t]);void 0!==this.wrapper&&(this.container.removeChild(this.wrapper),this.wrapper=void 0),this.domElements=[],this._removePopup()}},{key:"_getValue",value:function(t){for(var e=this.moduleOptions,i=0;i<t.length;i++){if(void 0===e[t[i]]){e=void 0;break}e=e[t[i]]}return e}},{key:"_makeItem",value:function(t){if(!0===this.allowCreation){var e=document.createElement("div");e.className="vis-configuration vis-config-item vis-config-s"+t.length;for(var i=arguments.length,n=new Array(i>1?i-1:0),o=1;o<i;o++)n[o-1]=arguments[o];return Cv(n).call(n,(function(t){e.appendChild(t)})),this.domElements.push(e),this.domElements.length}return 0}},{key:"_makeHeader",value:function(t){var e=document.createElement("div");e.className="vis-configuration vis-config-header",e.innerText=t,this._makeItem([],e)}},{key:"_makeLabel",value:function(t,e){var i=arguments.length>2&&void 0!==arguments[2]&&arguments[2],n=document.createElement("div");if(n.className="vis-configuration vis-config-label vis-config-s"+e.length,!0===i){for(;n.firstChild;)n.removeChild(n.firstChild);n.appendChild(bk("i","b",t))}else n.innerText=t+":";return n}},{key:"_makeDropdown",value:function(t,e,i){var n=document.createElement("select");n.className="vis-configuration vis-config-select";var o=0;void 0!==e&&-1!==tm(t).call(t,e)&&(o=tm(t).call(t,e));for(var r=0;r<t.length;r++){var s=document.createElement("option");s.value=t[r],r===o&&(s.selected="selected"),s.innerText=t[r],n.appendChild(s)}var a=this;n.onchange=function(){a._update(this.value,i)};var h=this._makeLabel(i[i.length-1],i);this._makeItem(i,h,n)}},{key:"_makeRange",value:function(t,e,i){var n=t[0],o=t[1],r=t[2],s=t[3],a=document.createElement("input");a.className="vis-configuration vis-config-range";try{a.type="range",a.min=o,a.max=r}catch(t){}a.step=s;var h="",l=0;if(void 0!==e){var d=1.2;e<0&&e*d<o?(a.min=Math.ceil(e*d),l=a.min,h="range increased"):e/d<o&&(a.min=Math.ceil(e/d),l=a.min,h="range increased"),e*d>r&&1!==r&&(a.max=Math.ceil(e*d),l=a.max,h="range increased"),a.value=e}else a.value=n;var c=document.createElement("input");c.className="vis-configuration vis-config-rangeinput",c.value=a.value;var u=this;a.onchange=function(){c.value=this.value,u._update(Number(this.value),i)},a.oninput=function(){c.value=this.value};var f=this._makeLabel(i[i.length-1],i),p=this._makeItem(i,f,a,c);""!==h&&this.popupHistory[p]!==l&&(this.popupHistory[p]=l,this._setupPopup(h,p))}},{key:"_makeButton",value:function(){var t=this;if(!0===this.options.showButton){var e=document.createElement("div");e.className="vis-configuration vis-config-button",e.innerText="generate options",e.onclick=function(){t._printOptions()},e.onmouseover=function(){e.className="vis-configuration vis-config-button hover"},e.onmouseout=function(){e.className="vis-configuration vis-config-button"},this.optionsContainer=document.createElement("div"),this.optionsContainer.className="vis-configuration vis-config-option-container",this.domElements.push(this.optionsContainer),this.domElements.push(e)}}},{key:"_setupPopup",value:function(t,e){var i=this;if(!0===this.initialized&&!0===this.allowCreation&&this.popupCounter<this.popupLimit){var n=document.createElement("div");n.id="vis-configuration-popup",n.className="vis-configuration-popup",n.innerText=t,n.onclick=function(){i._removePopup()},this.popupCounter+=1,this.popupDiv={html:n,index:e}}}},{key:"_removePopup",value:function(){void 0!==this.popupDiv.html&&(this.popupDiv.html.parentNode.removeChild(this.popupDiv.html),clearTimeout(this.popupDiv.hideTimeout),clearTimeout(this.popupDiv.deleteTimeout),this.popupDiv={})}},{key:"_showPopupIfNeeded",value:function(){var t=this;if(void 0!==this.popupDiv.html){var e=this.domElements[this.popupDiv.index].getBoundingClientRect();this.popupDiv.html.style.left=e.left+"px",this.popupDiv.html.style.top=e.top-30+"px",document.body.appendChild(this.popupDiv.html),this.popupDiv.hideTimeout=Gm((function(){t.popupDiv.html.style.opacity=0}),1500),this.popupDiv.deleteTimeout=Gm((function(){t._removePopup()}),1800)}}},{key:"_makeCheckbox",value:function(t,e,i){var n=document.createElement("input");n.type="checkbox",n.className="vis-configuration vis-config-checkbox",n.checked=t,void 0!==e&&(n.checked=e,e!==t&&("object"===Of(t)?e!==t.enabled&&this.changedOptions.push({path:i,value:e}):this.changedOptions.push({path:i,value:e})));var o=this;n.onchange=function(){o._update(this.checked,i)};var r=this._makeLabel(i[i.length-1],i);this._makeItem(i,r,n)}},{key:"_makeTextInput",value:function(t,e,i){var n=document.createElement("input");n.type="text",n.className="vis-configuration vis-config-text",n.value=e,e!==t&&this.changedOptions.push({path:i,value:e});var o=this;n.onchange=function(){o._update(this.value,i)};var r=this._makeLabel(i[i.length-1],i);this._makeItem(i,r,n)}},{key:"_makeColorField",value:function(t,e,i){var n=this,o=t[1],r=document.createElement("div");"none"!==(e=void 0===e?o:e)?(r.className="vis-configuration vis-config-colorBlock",r.style.backgroundColor=e):r.className="vis-configuration vis-config-colorBlock none",e=void 0===e?o:e,r.onclick=function(){n._showColorPicker(e,r,i)};var s=this._makeLabel(i[i.length-1],i);this._makeItem(i,s,r)}},{key:"_showColorPicker",value:function(t,e,i){var n=this;e.onclick=function(){},this.colorPicker.insertTo(e),this.colorPicker.show(),this.colorPicker.setColor(t),this.colorPicker.setUpdateCallback((function(t){var o="rgba("+t.r+","+t.g+","+t.b+","+t.a+")";e.style.backgroundColor=o,n._update(o,i)})),this.colorPicker.setCloseCallback((function(){e.onclick=function(){n._showColorPicker(t,e,i)}}))}},{key:"_handleObject",value:function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:[],i=arguments.length>2&&void 0!==arguments[2]&&arguments[2],n=!1,o=ny(this.options),r=!1;for(var s in t)if(Object.prototype.hasOwnProperty.call(t,s)){n=!0;var a=t[s],h=Yx(e,s);if("function"==typeof o&&!1===(n=o(s,e))&&!Wp(a)&&"string"!=typeof a&&"boolean"!=typeof a&&a instanceof Object&&(this.allowCreation=!1,n=this._handleObject(a,h,!0),this.allowCreation=!1===i),!1!==n){r=!0;var l=this._getValue(h);if(Wp(a))this._handleArray(a,l,h);else if("string"==typeof a)this._makeTextInput(a,l,h);else if("boolean"==typeof a)this._makeCheckbox(a,l,h);else if(a instanceof Object){if(!this.hideOption(e,s,this.moduleOptions))if(void 0!==a.enabled){var d=Yx(h,"enabled"),c=this._getValue(d);if(!0===c){var u=this._makeLabel(s,h,!0);this._makeItem(h,u),r=this._handleObject(a,h)||r}else this._makeCheckbox(a,c,h)}else{var f=this._makeLabel(s,h,!0);this._makeItem(h,f),r=this._handleObject(a,h)||r}}else console.error("dont know how to handle",a,s,h)}}return r}},{key:"_handleArray",value:function(t,e,i){"string"==typeof t[0]&&"color"===t[0]?(this._makeColorField(t,e,i),t[1]!==e&&this.changedOptions.push({path:i,value:e})):"string"==typeof t[0]?(this._makeDropdown(t,e,i),t[0]!==e&&this.changedOptions.push({path:i,value:e})):"number"==typeof t[0]&&(this._makeRange(t,e,i),t[0]!==e&&this.changedOptions.push({path:i,value:Number(e)}))}},{key:"_update",value:function(t,e){var i=this._constructOptions(t,e);this.parent.body&&this.parent.body.emitter&&this.parent.body.emitter.emit&&this.parent.body.emitter.emit("configChange",i),this.initialized=!0,this.parent.setOptions(i)}},{key:"_constructOptions",value:function(t,e){var i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:{},n=i;t="false"!==(t="true"===t||t)&&t;for(var o=0;o<e.length;o++)"global"!==e[o]&&(void 0===n[e[o]]&&(n[e[o]]={}),o!==e.length-1?n=n[e[o]]:n[e[o]]=t);return i}},{key:"_printOptions",value:function(){for(var t=this.getOptions();this.optionsContainer.firstChild;)this.optionsContainer.removeChild(this.optionsContainer.firstChild);this.optionsContainer.appendChild(bk("pre","const options = "+Om(t,null,2)))}},{key:"getOptions",value:function(){for(var t={},e=0;e<this.changedOptions.length;e++)this._constructOptions(this.changedOptions[e].value,this.changedOptions[e].path,t);return t}}]),t}(),kk=function(){function t(e,i){pu(this,t),this.container=e,this.overflowMethod=i||"cap",this.x=0,this.y=0,this.padding=5,this.hidden=!1,this.frame=document.createElement("div"),this.frame.className="vis-tooltip",this.container.appendChild(this.frame)}return Nf(t,[{key:"setPosition",value:function(t,e){this.x=Ly(t),this.y=Ly(e)}},{key:"setText",value:function(t){if(t instanceof Element){for(;this.frame.firstChild;)this.frame.removeChild(this.frame.firstChild);this.frame.appendChild(t)}else this.frame.innerText=t}},{key:"show",value:function(t){if(void 0===t&&(t=!0),!0===t){var e=this.frame.clientHeight,i=this.frame.clientWidth,n=this.frame.parentNode.clientHeight,o=this.frame.parentNode.clientWidth,r=0,s=0;if("flip"==this.overflowMethod){var a=!1,h=!0;this.y-e<this.padding&&(h=!1),this.x+i>o-this.padding&&(a=!0),r=a?this.x-i:this.x,s=h?this.y-e:this.y}else(s=this.y-e)+e+this.padding>n&&(s=n-e-this.padding),s<this.padding&&(s=this.padding),(r=this.x)+i+this.padding>o&&(r=o-i-this.padding),r<this.padding&&(r=this.padding);this.frame.style.left=r+"px",this.frame.style.top=s+"px",this.frame.style.visibility="visible",this.hidden=!1}else this.hide()}},{key:"hide",value:function(){this.hidden=!0,this.frame.style.left="0",this.frame.style.top="0",this.frame.style.visibility="hidden"}},{key:"destroy",value:function(){this.frame.parentNode.removeChild(this.frame)}}]),t}(),_k=!1,Ek="background: #FFeeee; color: #dd0000",Ok=function(){function t(){pu(this,t)}return Nf(t,null,[{key:"validate",value:function(e,i,n){_k=!1,wk=i;var o=i;return void 0!==n&&(o=i[n]),t.parse(e,o,[]),_k}},{key:"parse",value:function(e,i,n){for(var o in e)Object.prototype.hasOwnProperty.call(e,o)&&t.check(o,e,i,n)}},{key:"check",value:function(e,i,n,o){if(void 0!==n[e]||void 0!==n.__any__){var r=e,s=!0;void 0===n[e]&&void 0!==n.__any__&&(r="__any__",s="object"===t.getType(i[e]));var a=n[r];s&&void 0!==a.__type__&&(a=a.__type__),t.checkFields(e,i,n,r,a,o)}else t.getSuggestion(e,n,o)}},{key:"checkFields",value:function(e,i,n,o,r,s){var a=function(i){console.error("%c"+i+t.printLocation(s,e),Ek)},h=t.getType(i[e]),l=r[h];void 0!==l?"array"===t.getType(l)&&-1===tm(l).call(l,i[e])?(a('Invalid option detected in "'+e+'". Allowed values are:'+t.print(l)+' not "'+i[e]+'". '),_k=!0):"object"===h&&"__any__"!==o&&(s=Yx(s,e),t.parse(i[e],n[o],s)):void 0===r.any&&(a('Invalid type received for "'+e+'". Expected: '+t.print(ov(r))+". Received ["+h+'] "'+i[e]+'"'),_k=!0)}},{key:"getType",value:function(t){var e=Of(t);return"object"===e?null===t?"null":t instanceof Boolean?"boolean":t instanceof Number?"number":t instanceof String?"string":Wp(t)?"array":t instanceof Date?"date":void 0!==t.nodeType?"dom":!0===t._isAMomentObject?"moment":"object":"number"===e?"number":"boolean"===e?"boolean":"string"===e?"string":void 0===e?"undefined":e}},{key:"getSuggestion",value:function(e,i,n){var o,r=t.findInOptions(e,i,n,!1),s=t.findInOptions(e,wk,[],!0);o=void 0!==r.indexMatch?" in "+t.printLocation(r.path,e,"")+'Perhaps it was incomplete? Did you mean: "'+r.indexMatch+'"?\n\n':s.distance<=4&&r.distance>s.distance?" in "+t.printLocation(r.path,e,"")+"Perhaps it was misplaced? Matching option found at: "+t.printLocation(s.path,s.closestMatch,""):r.distance<=8?'. Did you mean "'+r.closestMatch+'"?'+t.printLocation(r.path,e):". Did you mean one of these: "+t.print(ov(i))+t.printLocation(n,e),console.error('%cUnknown option detected: "'+e+'"'+o,Ek),_k=!0}},{key:"findInOptions",value:function(e,i,n){var o=arguments.length>3&&void 0!==arguments[3]&&arguments[3],r=1e9,s="",a=[],h=e.toLowerCase(),l=void 0;for(var d in i){var c=void 0;if(void 0!==i[d].__type__&&!0===o){var u=t.findInOptions(e,i[d],Yx(n,d));r>u.distance&&(s=u.closestMatch,a=u.path,r=u.distance,l=u.indexMatch)}else{var f;-1!==tm(f=d.toLowerCase()).call(f,h)&&(l=d),r>(c=t.levenshteinDistance(e,d))&&(s=d,a=Xx(n),r=c)}}return{closestMatch:s,path:a,distance:r,indexMatch:l}}},{key:"printLocation",value:function(t,e){for(var i="\n\n"+(arguments.length>2&&void 0!==arguments[2]?arguments[2]:"Problem value found at: \n")+"options = {\n",n=0;n<t.length;n++){for(var o=0;o<n+1;o++)i+="  ";i+=t[n]+": {\n"}for(var r=0;r<t.length+1;r++)i+="  ";i+=e+"\n";for(var s=0;s<t.length+1;s++){for(var a=0;a<t.length-s;a++)i+="  ";i+="}\n"}return i+"\n\n"}},{key:"print",value:function(t){return Om(t).replace(/(")|(\[)|(\])|(,"__type__")/g,"").replace(/(,)/g,", ")}},{key:"levenshteinDistance",value:function(t,e){if(0===t.length)return e.length;if(0===e.length)return t.length;var i,n,o=[];for(i=0;i<=e.length;i++)o[i]=[i];for(n=0;n<=t.length;n++)o[0][n]=n;for(i=1;i<=e.length;i++)for(n=1;n<=t.length;n++)e.charAt(i-1)==t.charAt(n-1)?o[i][n]=o[i-1][n-1]:o[i][n]=Math.min(o[i-1][n-1]+1,Math.min(o[i][n-1]+1,o[i-1][n]+1));return o[e.length][t.length]}}]),t}(),Ck=Px,Sk=mk,Tk=xk,Mk=Mx,Pk=kk,Dk=Ek,Ik=Ok,Bk=Object.freeze({__proto__:null,Activator:Ck,Alea:Tx,ColorPicker:Sk,Configurator:Tk,DELETE:kx,HSVToHex:hk,HSVToRGB:ak,Hammer:Mk,Popup:Pk,RGBToHSV:rk,RGBToHex:nk,VALIDATOR_PRINT_STYLE:Dk,Validator:Ik,addClassName:function(t,e){var i=t.className.split(" "),n=e.split(" ");i=Np(i).call(i,ny(n).call(n,(function(t){return!Lg(i).call(i,t)}))),t.className=i.join(" ")},addCssText:function(t,e){var i=sk.split(t.style.cssText),n=sk.split(e),o=bx(bx({},i),n);t.style.cssText=sk.join(o)},addEventListener:Qx,binarySearchCustom:function(t,e,i,n){for(var o=0,r=0,s=t.length-1;r<=s&&o<1e4;){var a=Math.floor((r+s)/2),h=t[a],l=e(void 0===n?h[i]:h[i][n]);if(0==l)return a;-1==l?r=a+1:s=a-1,o++}return-1},binarySearchValue:function(t,e,i,n,o){var r,s,a,h,l=0,d=0,c=t.length-1;for(o=null!=o?o:function(t,e){return t==e?0:t<e?-1:1};d<=c&&l<1e4;){if(h=Math.floor(.5*(c+d)),r=t[Math.max(0,h-1)][i],s=t[h][i],a=t[Math.min(t.length-1,h+1)][i],0==o(s,e))return h;if(o(r,e)<0&&o(s,e)>0)return"before"==n?Math.max(0,h-1):h;if(o(s,e)<0&&o(a,e)>0)return"before"==n?h:Math.min(t.length-1,h+1);o(s,e)<0?d=h+1:c=h-1,l++}return-1},bridgeObject:fk,copyAndExtendArray:Yx,copyArray:Xx,deepExtend:Ux,deepObjectAssign:Ex,easingFunctions:vk,equalArray:function(t,e){if(t.length!==e.length)return!1;for(var i=0,n=t.length;i<n;i++)if(t[i]!=e[i])return!1;return!0},extend:Wx,fillIfDefined:Hx,forEach:$x,getAbsoluteLeft:Gx,getAbsoluteRight:function(t){return t.getBoundingClientRect().right},getAbsoluteTop:Kx,getScrollBarWidth:function(){var t=document.createElement("p");t.style.width="100%",t.style.height="200px";var e=document.createElement("div");e.style.position="absolute",e.style.top="0px",e.style.left="0px",e.style.visibility="hidden",e.style.width="200px",e.style.height="150px",e.style.overflow="hidden",e.appendChild(t),document.body.appendChild(e);var i=t.offsetWidth;e.style.overflow="scroll";var n=t.offsetWidth;return i==n&&(n=e.clientWidth),document.body.removeChild(e),i-n},getTarget:function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:window.event,e=null;return t&&(t.target?e=t.target:t.srcElement&&(e=t.srcElement)),e instanceof Element&&(null==e.nodeType||3!=e.nodeType||(e=e.parentNode)instanceof Element)?e:null},getType:function(t){var e=Of(t);return"object"===e?null===t?"null":t instanceof Boolean?"Boolean":t instanceof Number?"Number":t instanceof String?"String":Wp(t)?"Array":t instanceof Date?"Date":"Object":"number"===e?"Number":"boolean"===e?"Boolean":"string"===e?"String":void 0===e?"undefined":e},hasParent:function(t,e){for(var i=t;i;){if(i===e)return!0;if(!i.parentNode)return!1;i=i.parentNode}return!1},hexToHSV:lk,hexToRGB:ek,insertSort:function(t,e){for(var i=0;i<t.length;i++){var n=t[i],o=void 0;for(o=i;o>0&&e(n,t[o-1])<0;o--)t[o]=t[o-1];t[o]=n}return t},isDate:function(t){if(t instanceof Date)return!0;if(jx(t)){if(Dx.exec(t))return!0;if(!isNaN(Date.parse(t)))return!0}return!1},isNumber:Fx,isObject:Rx,isString:jx,isValidHex:dk,isValidRGB:ck,isValidRGBA:uk,mergeOptions:pk,option:tk,overrideOpacity:ik,parseColor:ok,preventDefault:function(t){t||(t=window.event),t&&(t.preventDefault?t.preventDefault():t.returnValue=!1)},pureDeepObjectAssign:_x,recursiveDOMDelete:Ax,removeClassName:function(t,e){var i=t.className.split(" "),n=e.split(" ");i=ny(i).call(i,(function(t){return!Lg(n).call(n,t)})),t.className=i.join(" ")},removeCssText:function(t,e){var i=sk.split(t.style.cssText),n=sk.split(e);for(var o in n)Object.prototype.hasOwnProperty.call(n,o)&&delete i[o];t.style.cssText=sk.join(i)},removeEventListener:Jx,selectiveBridgeObject:function(t,e){if(null!==e&&"object"===Of(e)){for(var i=mm(e),n=0;n<t.length;n++)Object.prototype.hasOwnProperty.call(e,t[n])&&"object"==Of(e[t[n]])&&(i[t[n]]=fk(e[t[n]]));return i}return null},selectiveDeepExtend:qx,selectiveExtend:function(t,e){if(!Wp(t))throw new Error("Array with property names expected as first argument");for(var i=arguments.length,n=new Array(i>2?i-2:0),o=2;o<i;o++)n[o-2]=arguments[o];for(var r=0,s=n;r<s.length;r++)for(var a=s[r],h=0;h<t.length;h++){var l=t[h];a&&Object.prototype.hasOwnProperty.call(a,l)&&(e[l]=a[l])}return e},selectiveNotDeepExtend:Vx,throttle:function(t){var e=!1;return function(){e||(e=!0,requestAnimationFrame((function(){e=!1,t()})))}},toArray:Zx,topMost:gk,updateProperty:function(t,e,i){return t[e]!==i&&(t[e]=i,!0)}});function Nk(t){return Rk=t,function(){var t={};Lk=0,void(Hk=Rk.charAt(0)),Qk(),"strict"===Wk&&(t.strict=!0,Qk());"graph"!==Wk&&"digraph"!==Wk||(t.type=Wk,Qk());qk===Ak.IDENTIFIER&&(t.id=Wk,Qk());if("{"!=Wk)throw o_("Angle bracket { expected");if(Qk(),Jk(t),"}"!=Wk)throw o_("Angle bracket } expected");if(Qk(),""!==Wk)throw o_("End of file expected");return Qk(),delete t.node,delete t.edge,delete t.graph,t}()}var zk={fontsize:"font.size",fontcolor:"font.color",labelfontcolor:"font.color",fontname:"font.face",color:["color.border","color.background"],fillcolor:"color.background",tooltip:"title",labeltooltip:"title"},Fk=mm(zk);Fk.color="color.color",Fk.style="dashes";var Ak={NULL:0,DELIMITER:1,IDENTIFIER:2,UNKNOWN:3},jk={"{":!0,"}":!0,"[":!0,"]":!0,";":!0,"=":!0,",":!0,"->":!0,"--":!0},Rk="",Lk=0,Hk="",Wk="",qk=Ak.NULL;function Vk(){Lk++,Hk=Rk.charAt(Lk)}function Uk(){return Rk.charAt(Lk+1)}function Yk(t){var e=t.charCodeAt(0);return e<47?35===e||46===e:e<59?e>47:e<91?e>64:e<96?95===e:e<123&&e>96}function Xk(t,e){if(t||(t={}),e)for(var i in e)e.hasOwnProperty(i)&&(t[i]=e[i]);return t}function Gk(t,e,i){for(var n=e.split("."),o=t;n.length;){var r=n.shift();n.length?(o[r]||(o[r]={}),o=o[r]):o[r]=i}}function Kk(t,e){for(var i,n,o=null,r=[t],s=t;s.parent;)r.push(s.parent),s=s.parent;if(s.nodes)for(i=0,n=s.nodes.length;i<n;i++)if(e.id===s.nodes[i].id){o=s.nodes[i];break}for(o||(o={id:e.id},t.node&&(o.attr=Xk(o.attr,t.node))),i=r.length-1;i>=0;i--){var a,h=r[i];h.nodes||(h.nodes=[]),-1===tm(a=h.nodes).call(a,o)&&h.nodes.push(o)}e.attr&&(o.attr=Xk(o.attr,e.attr))}function $k(t,e){if(t.edges||(t.edges=[]),t.edges.push(e),t.edge){var i=Xk({},t.edge);e.attr=Xk(i,e.attr)}}function Zk(t,e,i,n,o){var r={from:e,to:i,type:n};return t.edge&&(r.attr=Xk({},t.edge)),r.attr=Xk(r.attr||{},o),null!=o&&o.hasOwnProperty("arrows")&&null!=o.arrows&&(r.arrows={to:{enabled:!0,type:o.arrows.type}},o.arrows=null),r}function Qk(){for(qk=Ak.NULL,Wk="";" "===Hk||"\t"===Hk||"\n"===Hk||"\r"===Hk;)Vk();do{var t=!1;if("#"===Hk){for(var e=Lk-1;" "===Rk.charAt(e)||"\t"===Rk.charAt(e);)e--;if("\n"===Rk.charAt(e)||""===Rk.charAt(e)){for(;""!=Hk&&"\n"!=Hk;)Vk();t=!0}}if("/"===Hk&&"/"===Uk()){for(;""!=Hk&&"\n"!=Hk;)Vk();t=!0}if("/"===Hk&&"*"===Uk()){for(;""!=Hk;){if("*"===Hk&&"/"===Uk()){Vk(),Vk();break}Vk()}t=!0}for(;" "===Hk||"\t"===Hk||"\n"===Hk||"\r"===Hk;)Vk()}while(t);if(""!==Hk){var i=Hk+Uk();if(jk[i])return qk=Ak.DELIMITER,Wk=i,Vk(),void Vk();if(jk[Hk])return qk=Ak.DELIMITER,Wk=Hk,void Vk();if(Yk(Hk)||"-"===Hk){for(Wk+=Hk,Vk();Yk(Hk);)Wk+=Hk,Vk();return"false"===Wk?Wk=!1:"true"===Wk?Wk=!0:isNaN(Number(Wk))||(Wk=Number(Wk)),void(qk=Ak.IDENTIFIER)}if('"'===Hk){for(Vk();""!=Hk&&('"'!=Hk||'"'===Hk&&'"'===Uk());)'"'===Hk?(Wk+=Hk,Vk()):"\\"===Hk&&"n"===Uk()?(Wk+="\n",Vk()):Wk+=Hk,Vk();if('"'!=Hk)throw o_('End of string " expected');return Vk(),void(qk=Ak.IDENTIFIER)}for(qk=Ak.UNKNOWN;""!=Hk;)Wk+=Hk,Vk();throw new SyntaxError('Syntax error in part "'+r_(Wk,30)+'"')}qk=Ak.DELIMITER}function Jk(t){for(;""!==Wk&&"}"!=Wk;)t_(t),";"===Wk&&Qk()}function t_(t){var e=e_(t);if(e)i_(t,e);else{var i=function(t){if("node"===Wk)return Qk(),t.node=n_(),"node";if("edge"===Wk)return Qk(),t.edge=n_(),"edge";if("graph"===Wk)return Qk(),t.graph=n_(),"graph";return null}(t);if(!i){if(qk!=Ak.IDENTIFIER)throw o_("Identifier expected");var n=Wk;if(Qk(),"="===Wk){if(Qk(),qk!=Ak.IDENTIFIER)throw o_("Identifier expected");t[n]=Wk,Qk()}else!function(t,e){var i={id:e},n=n_();n&&(i.attr=n);Kk(t,i),i_(t,e)}(t,n)}}}function e_(t){var e=null;if("subgraph"===Wk&&((e={}).type="subgraph",Qk(),qk===Ak.IDENTIFIER&&(e.id=Wk,Qk())),"{"===Wk){if(Qk(),e||(e={}),e.parent=t,e.node=t.node,e.edge=t.edge,e.graph=t.graph,Jk(e),"}"!=Wk)throw o_("Angle bracket } expected");Qk(),delete e.node,delete e.edge,delete e.graph,delete e.parent,t.subgraphs||(t.subgraphs=[]),t.subgraphs.push(e)}return e}function i_(t,e){for(;"->"===Wk||"--"===Wk;){var i,n=Wk;Qk();var o=e_(t);if(o)i=o;else{if(qk!=Ak.IDENTIFIER)throw o_("Identifier or subgraph expected");Kk(t,{id:i=Wk}),Qk()}$k(t,Zk(t,e,i,n,n_())),e=i}}function n_(){for(var t,e,i=null,n={dashed:!0,solid:!1,dotted:[1,5]},o={dot:"circle",box:"box",crow:"crow",curve:"curve",icurve:"inv_curve",normal:"triangle",inv:"inv_triangle",diamond:"diamond",tee:"bar",vee:"vee"},r=new Array,s=new Array;"["===Wk;){for(Qk(),i={};""!==Wk&&"]"!=Wk;){if(qk!=Ak.IDENTIFIER)throw o_("Attribute name expected");var a=Wk;if(Qk(),"="!=Wk)throw o_("Equal sign = expected");if(Qk(),qk!=Ak.IDENTIFIER)throw o_("Attribute value expected");var h=Wk;"style"===a&&(h=n[h]),"arrowhead"===a&&(a="arrows",h={to:{enabled:!0,type:o[h]}}),"arrowtail"===a&&(a="arrows",h={from:{enabled:!0,type:o[h]}}),r.push({attr:i,name:a,value:h}),s.push(a),Qk(),","==Wk&&Qk()}if("]"!=Wk)throw o_("Bracket ] expected");Qk()}if(Lg(s).call(s,"dir")){var l={arrows:{}};for(t=0;t<r.length;t++)if("arrows"===r[t].name)if(null!=r[t].value.to)l.arrows.to=t;else{if(null==r[t].value.from)throw o_("Invalid value of arrows");l.arrows.from=t}else"dir"===r[t].name&&(l.dir=t);var d,c,u=r[l.dir].value;if(!Lg(s).call(s,"arrows"))if("both"===u)r.push({attr:r[l.dir].attr,name:"arrows",value:{to:{enabled:!0}}}),l.arrows.to=r.length-1,r.push({attr:r[l.dir].attr,name:"arrows",value:{from:{enabled:!0}}}),l.arrows.from=r.length-1;else if("forward"===u)r.push({attr:r[l.dir].attr,name:"arrows",value:{to:{enabled:!0}}}),l.arrows.to=r.length-1;else if("back"===u)r.push({attr:r[l.dir].attr,name:"arrows",value:{from:{enabled:!0}}}),l.arrows.from=r.length-1;else{if("none"!==u)throw o_('Invalid dir type "'+u+'"');r.push({attr:r[l.dir].attr,name:"arrows",value:""}),l.arrows.to=r.length-1}if("both"===u)l.arrows.to&&l.arrows.from?(c=r[l.arrows.to].value.to.type,d=r[l.arrows.from].value.from.type,r[l.arrows.to]={attr:r[l.arrows.to].attr,name:r[l.arrows.to].name,value:{to:{enabled:!0,type:c},from:{enabled:!0,type:d}}},vg(r).call(r,l.arrows.from,1)):l.arrows.to?(c=r[l.arrows.to].value.to.type,d="arrow",r[l.arrows.to]={attr:r[l.arrows.to].attr,name:r[l.arrows.to].name,value:{to:{enabled:!0,type:c},from:{enabled:!0,type:d}}}):l.arrows.from&&(c="arrow",d=r[l.arrows.from].value.from.type,r[l.arrows.from]={attr:r[l.arrows.from].attr,name:r[l.arrows.from].name,value:{to:{enabled:!0,type:c},from:{enabled:!0,type:d}}});else if("back"===u)l.arrows.to&&l.arrows.from?(c="",d=r[l.arrows.from].value.from.type,r[l.arrows.from]={attr:r[l.arrows.from].attr,name:r[l.arrows.from].name,value:{to:{enabled:!0,type:c},from:{enabled:!0,type:d}}}):l.arrows.to?(c="",d="arrow",l.arrows.from=l.arrows.to,r[l.arrows.from]={attr:r[l.arrows.from].attr,name:r[l.arrows.from].name,value:{to:{enabled:!0,type:c},from:{enabled:!0,type:d}}}):l.arrows.from&&(c="",d=r[l.arrows.from].value.from.type,r[l.arrows.to]={attr:r[l.arrows.from].attr,name:r[l.arrows.from].name,value:{to:{enabled:!0,type:c},from:{enabled:!0,type:d}}}),r[l.arrows.from]={attr:r[l.arrows.from].attr,name:r[l.arrows.from].name,value:{from:{enabled:!0,type:r[l.arrows.from].value.from.type}}};else if("none"===u){var f;r[f=l.arrows.to?l.arrows.to:l.arrows.from]={attr:r[f].attr,name:r[f].name,value:""}}else{if("forward"!==u)throw o_('Invalid dir type "'+u+'"');l.arrows.to&&l.arrows.from||l.arrows.to?(c=r[l.arrows.to].value.to.type,d="",r[l.arrows.to]={attr:r[l.arrows.to].attr,name:r[l.arrows.to].name,value:{to:{enabled:!0,type:c},from:{enabled:!0,type:d}}}):l.arrows.from&&(c="arrow",d="",l.arrows.to=l.arrows.from,r[l.arrows.to]={attr:r[l.arrows.to].attr,name:r[l.arrows.to].name,value:{to:{enabled:!0,type:c},from:{enabled:!0,type:d}}}),r[l.arrows.to]={attr:r[l.arrows.to].attr,name:r[l.arrows.to].name,value:{to:{enabled:!0,type:r[l.arrows.to].value.to.type}}}}vg(r).call(r,l.dir,1)}if(Lg(s).call(s,"penwidth")){var p=[];for(e=r.length,t=0;t<e;t++)"width"!==r[t].name&&("penwidth"===r[t].name&&(r[t].name="width"),p.push(r[t]));r=p}for(e=r.length,t=0;t<e;t++)Gk(r[t].attr,r[t].name,r[t].value);return i}function o_(t){return new SyntaxError(t+', got "'+r_(Wk,30)+'" (char '+Lk+")")}function r_(t,e){return t.length<=e?t:t.substr(0,27)+"..."}function s_(t,e,i){for(var n=e.split("."),o=n.pop(),r=t,s=0;s<n.length;s++){var a=n[s];a in r||(r[a]={}),r=r[a]}return r[o]=i,t}function a_(t,e){var i={};for(var n in t)if(t.hasOwnProperty(n)){var o=e[n];Wp(o)?Cv(o).call(o,(function(e){s_(i,e,t[n])})):s_(i,"string"==typeof o?o:n,t[n])}return i}function h_(t){var e,i=Nk(t),n={nodes:[],edges:[],options:{}};i.nodes&&Cv(e=i.nodes).call(e,(function(t){var e={id:t.id,label:String(t.label||t.id)};Xk(e,a_(t.attr,zk)),e.image&&(e.shape="image"),n.nodes.push(e)}));if(i.edges){var o,r=function(t){var e={from:t.from,to:t.to};return Xk(e,a_(t.attr,Fk)),null==e.arrows&&"->"===t.type&&(e.arrows="to"),e};Cv(o=i.edges).call(o,(function(t){var e,i,o,s,a,h,l;(e=t.from instanceof Object?t.from.nodes:{id:t.from},i=t.to instanceof Object?t.to.nodes:{id:t.to},t.from instanceof Object&&t.from.edges)&&Cv(o=t.from.edges).call(o,(function(t){var e=r(t);n.edges.push(e)}));(a=i,h=function(e,i){var o=Zk(n,e.id,i.id,t.type,t.attr),s=r(o);n.edges.push(s)},Wp(s=e)?Cv(s).call(s,(function(t){Wp(a)?Cv(a).call(a,(function(e){h(t,e)})):h(t,a)})):Wp(a)?Cv(a).call(a,(function(t){h(s,t)})):h(s,a),t.to instanceof Object&&t.to.edges)&&Cv(l=t.to.edges).call(l,(function(t){var e=r(t);n.edges.push(e)}))}))}return i.attr&&(n.options=i.attr),n}var l_=Object.freeze({__proto__:null,DOTToGraph:h_,parseDOT:Nk});function d_(t,e){var i,n={edges:{inheritColor:!1},nodes:{fixed:!1,parseColor:!1}};null!=e&&(null!=e.fixed&&(n.nodes.fixed=e.fixed),null!=e.parseColor&&(n.nodes.parseColor=e.parseColor),null!=e.inheritColor&&(n.edges.inheritColor=e.inheritColor));var o=t.edges,r=Qp(o).call(o,(function(t){var e={from:t.source,id:t.id,to:t.target};return null!=t.attributes&&(e.attributes=t.attributes),null!=t.label&&(e.label=t.label),null!=t.attributes&&null!=t.attributes.title&&(e.title=t.attributes.title),"Directed"===t.type&&(e.arrows="to"),t.color&&!1===n.edges.inheritColor&&(e.color=t.color),e}));return{nodes:Qp(i=t.nodes).call(i,(function(t){var e={id:t.id,fixed:n.nodes.fixed&&null!=t.x&&null!=t.y};return null!=t.attributes&&(e.attributes=t.attributes),null!=t.label&&(e.label=t.label),null!=t.size&&(e.size=t.size),null!=t.attributes&&null!=t.attributes.title&&(e.title=t.attributes.title),null!=t.title&&(e.title=t.title),null!=t.x&&(e.x=t.x),null!=t.y&&(e.y=t.y),null!=t.color&&(!0===n.nodes.parseColor?e.color=t.color:e.color={background:t.color,border:t.color,highlight:{background:t.color,border:t.color},hover:{background:t.color,border:t.color}}),e})),edges:r}}var c_=Object.freeze({__proto__:null,parseGephi:d_}),u_=Object.freeze({__proto__:null,cn:{addDescription:"单击空白处放置新节点。",addEdge:"添加连接线",addNode:"添加节点",back:"返回",close:"關閉",createEdgeError:"无法将连接线连接到群集。",del:"删除选定",deleteClusterError:"无法删除群集。",edgeDescription:"单击某个节点并将该连接线拖动到另一个节点以连接它们。",edit:"编辑",editClusterError:"无法编辑群集。",editEdge:"编辑连接线",editEdgeDescription:"单击控制节点并将它们拖到节点上连接。",editNode:"编辑节点"},cs:{addDescription:"Kluknutím do prázdného prostoru můžete přidat nový vrchol.",addEdge:"Přidat hranu",addNode:"Přidat vrchol",back:"Zpět",close:"Zavřít",createEdgeError:"Nelze připojit hranu ke shluku.",del:"Smazat výběr",deleteClusterError:"Nelze mazat shluky.",edgeDescription:"Přetažením z jednoho vrcholu do druhého můžete spojit tyto vrcholy novou hranou.",edit:"Upravit",editClusterError:"Nelze upravovat shluky.",editEdge:"Upravit hranu",editEdgeDescription:"Přetažením kontrolního vrcholu hrany ji můžete připojit k jinému vrcholu.",editNode:"Upravit vrchol"},de:{addDescription:"Klicke auf eine freie Stelle, um einen neuen Knoten zu plazieren.",addEdge:"Kante hinzufügen",addNode:"Knoten hinzufügen",back:"Zurück",close:"Schließen",createEdgeError:"Es ist nicht möglich, Kanten mit Clustern zu verbinden.",del:"Lösche Auswahl",deleteClusterError:"Cluster können nicht gelöscht werden.",edgeDescription:"Klicke auf einen Knoten und ziehe die Kante zu einem anderen Knoten, um diese zu verbinden.",edit:"Editieren",editClusterError:"Cluster können nicht editiert werden.",editEdge:"Kante editieren",editEdgeDescription:"Klicke auf die Verbindungspunkte und ziehe diese auf einen Knoten, um sie zu verbinden.",editNode:"Knoten editieren"},en:{addDescription:"Click in an empty space to place a new node.",addEdge:"Add Edge",addNode:"Add Node",back:"Back",close:"Close",createEdgeError:"Cannot link edges to a cluster.",del:"Delete selected",deleteClusterError:"Clusters cannot be deleted.",edgeDescription:"Click on a node and drag the edge to another node to connect them.",edit:"Edit",editClusterError:"Clusters cannot be edited.",editEdge:"Edit Edge",editEdgeDescription:"Click on the control points and drag them to a node to connect to it.",editNode:"Edit Node"},es:{addDescription:"Haga clic en un lugar vacío para colocar un nuevo nodo.",addEdge:"Añadir arista",addNode:"Añadir nodo",back:"Atrás",close:"Cerrar",createEdgeError:"No se puede conectar una arista a un grupo.",del:"Eliminar selección",deleteClusterError:"No es posible eliminar grupos.",edgeDescription:"Haga clic en un nodo y arrastre la arista hacia otro nodo para conectarlos.",edit:"Editar",editClusterError:"No es posible editar grupos.",editEdge:"Editar arista",editEdgeDescription:"Haga clic en un punto de control y arrastrelo a un nodo para conectarlo.",editNode:"Editar nodo"},fr:{addDescription:"Cliquez dans un endroit vide pour placer un nœud.",addEdge:"Ajouter un lien",addNode:"Ajouter un nœud",back:"Retour",close:"Fermer",createEdgeError:"Impossible de créer un lien vers un cluster.",del:"Effacer la sélection",deleteClusterError:"Les clusters ne peuvent pas être effacés.",edgeDescription:"Cliquez sur un nœud et glissez le lien vers un autre nœud pour les connecter.",edit:"Éditer",editClusterError:"Les clusters ne peuvent pas être édités.",editEdge:"Éditer le lien",editEdgeDescription:"Cliquez sur les points de contrôle et glissez-les pour connecter un nœud.",editNode:"Éditer le nœud"},it:{addDescription:"Clicca per aggiungere un nuovo nodo",addEdge:"Aggiungi un vertice",addNode:"Aggiungi un nodo",back:"Indietro",close:"Chiudere",createEdgeError:"Non si possono collegare vertici ad un cluster",del:"Cancella la selezione",deleteClusterError:"I cluster non possono essere cancellati",edgeDescription:"Clicca su un nodo e trascinalo ad un altro nodo per connetterli.",edit:"Modifica",editClusterError:"I clusters non possono essere modificati.",editEdge:"Modifica il vertice",editEdgeDescription:"Clicca sui Punti di controllo e trascinali ad un nodo per connetterli.",editNode:"Modifica il nodo"},nl:{addDescription:"Klik op een leeg gebied om een nieuwe node te maken.",addEdge:"Link toevoegen",addNode:"Node toevoegen",back:"Terug",close:"Sluiten",createEdgeError:"Kan geen link maken naar een cluster.",del:"Selectie verwijderen",deleteClusterError:"Clusters kunnen niet worden verwijderd.",edgeDescription:"Klik op een node en sleep de link naar een andere node om ze te verbinden.",edit:"Wijzigen",editClusterError:"Clusters kunnen niet worden aangepast.",editEdge:"Link wijzigen",editEdgeDescription:"Klik op de verbindingspunten en sleep ze naar een node om daarmee te verbinden.",editNode:"Node wijzigen"},pt:{addDescription:"Clique em um espaço em branco para adicionar um novo nó",addEdge:"Adicionar aresta",addNode:"Adicionar nó",back:"Voltar",close:"Fechar",createEdgeError:"Não foi possível linkar arestas a um cluster.",del:"Remover selecionado",deleteClusterError:"Clusters não puderam ser removidos.",edgeDescription:"Clique em um nó e arraste a aresta até outro nó para conectá-los",edit:"Editar",editClusterError:"Clusters não puderam ser editados.",editEdge:"Editar aresta",editEdgeDescription:"Clique nos pontos de controle e os arraste para um nó para conectá-los",editNode:"Editar nó"},ru:{addDescription:"Кликните в свободное место, чтобы добавить новый узел.",addEdge:"Добавить ребро",addNode:"Добавить узел",back:"Назад",close:"Закрывать",createEdgeError:"Невозможно соединить ребра в кластер.",del:"Удалить выбранное",deleteClusterError:"Кластеры не могут быть удалены",edgeDescription:"Кликните на узел и протяните ребро к другому узлу, чтобы соединить их.",edit:"Редактировать",editClusterError:"Кластеры недоступны для редактирования.",editEdge:"Редактировать ребро",editEdgeDescription:"Кликните на контрольные точки и перетащите их в узел, чтобы подключиться к нему.",editNode:"Редактировать узел"},uk:{addDescription:"Kлікніть на вільне місце, щоб додати новий вузол.",addEdge:"Додати край",addNode:"Додати вузол",back:"Назад",close:"Закрити",createEdgeError:"Не можливо об'єднати краї в групу.",del:"Видалити обране",deleteClusterError:"Групи не можуть бути видалені.",edgeDescription:"Клікніть на вузол і перетягніть край до іншого вузла, щоб їх з'єднати.",edit:"Редагувати",editClusterError:"Групи недоступні для редагування.",editEdge:"Редагувати край",editEdgeDescription:"Клікніть на контрольні точки і перетягніть їх у вузол, щоб підключитися до нього.",editNode:"Редагувати вузол"}});var f_=function(){function t(){pu(this,t),this.NUM_ITERATIONS=4,this.image=new Image,this.canvas=document.createElement("canvas")}return Nf(t,[{key:"init",value:function(){if(!this.initialized()){this.src=this.image.src;var t=this.image.width,e=this.image.height;this.width=t,this.height=e;var i=Math.floor(e/2),n=Math.floor(e/4),o=Math.floor(e/8),r=Math.floor(e/16),s=Math.floor(t/2),a=Math.floor(t/4),h=Math.floor(t/8),l=Math.floor(t/16);this.canvas.width=3*a,this.canvas.height=i,this.coordinates=[[0,0,s,i],[s,0,a,n],[s,n,h,o],[5*h,n,l,r]],this._fillMipMap()}}},{key:"initialized",value:function(){return void 0!==this.coordinates}},{key:"_fillMipMap",value:function(){var t=this.canvas.getContext("2d"),e=this.coordinates[0];t.drawImage(this.image,e[0],e[1],e[2],e[3]);for(var i=1;i<this.NUM_ITERATIONS;i++){var n=this.coordinates[i-1],o=this.coordinates[i];t.drawImage(this.canvas,n[0],n[1],n[2],n[3],o[0],o[1],o[2],o[3])}}},{key:"drawImageAtPosition",value:function(t,e,i,n,o,r){if(this.initialized())if(e>2){e*=.5;for(var s=0;e>2&&s<this.NUM_ITERATIONS;)e*=.5,s+=1;s>=this.NUM_ITERATIONS&&(s=this.NUM_ITERATIONS-1);var a=this.coordinates[s];t.drawImage(this.canvas,a[0],a[1],a[2],a[3],i,n,o,r)}else t.drawImage(this.image,i,n,o,r)}}]),t}(),p_=function(){function t(e){pu(this,t),this.images={},this.imageBroken={},this.callback=e}return Nf(t,[{key:"_tryloadBrokenUrl",value:function(t,e,i){void 0!==t&&void 0!==i&&(void 0!==e?(i.image.onerror=function(){console.error("Could not load brokenImage:",e)},i.image.src=e):console.warn("No broken url image defined"))}},{key:"_redrawWithImage",value:function(t){this.callback&&this.callback(t)}},{key:"load",value:function(t,e){var i=this,n=this.images[t];if(n)return n;var o=new f_;return this.images[t]=o,o.image.onload=function(){i._fixImageCoordinates(o.image),o.init(),i._redrawWithImage(o)},o.image.onerror=function(){console.error("Could not load image:",t),i._tryloadBrokenUrl(t,e,o)},o.image.src=t,o}},{key:"_fixImageCoordinates",value:function(t){0===t.width&&(document.body.appendChild(t),t.width=t.offsetWidth,t.height=t.offsetHeight,document.body.removeChild(t))}}]),t}(),v_={},g_={get exports(){return v_},set exports(t){v_=t}},y_={},m_={get exports(){return y_},set exports(t){y_=t}},b_=a((function(){if("function"==typeof ArrayBuffer){var t=new ArrayBuffer(8);Object.isExtensible(t)&&Object.defineProperty(t,"a",{value:8})}})),w_=a,x_=it,k_=k,__=b_,E_=Object.isExtensible,O_=w_((function(){E_(1)}))||__?function(t){return!!x_(t)&&((!__||"ArrayBuffer"!=k_(t))&&(!E_||E_(t)))}:E_,C_=!a((function(){return Object.isExtensible(Object.preventExtensions({}))})),S_=Mi,T_=m,M_=Xi,P_=it,D_=Jt,I_=Qe.f,B_=Eh,N_=Sh,z_=O_,F_=C_,A_=!1,j_=oe("meta"),R_=0,L_=function(t){I_(t,j_,{value:{objectID:"O"+R_++,weakData:{}}})},H_=m_.exports={enable:function(){H_.enable=function(){},A_=!0;var t=B_.f,e=T_([].splice),i={};i[j_]=1,t(i).length&&(B_.f=function(i){for(var n=t(i),o=0,r=n.length;o<r;o++)if(n[o]===j_){e(n,o,1);break}return n},S_({target:"Object",stat:!0,forced:!0},{getOwnPropertyNames:N_.f}))},fastKey:function(t,e){if(!P_(t))return"symbol"==typeof t?t:("string"==typeof t?"S":"P")+t;if(!D_(t,j_)){if(!z_(t))return"F";if(!e)return"E";L_(t)}return t[j_].objectID},getWeakData:function(t,e){if(!D_(t,j_)){if(!z_(t))return!0;if(!e)return!1;L_(t)}return t[j_].weakData},onFreeze:function(t){return F_&&A_&&z_(t)&&!D_(t,j_)&&L_(t),t}};M_[j_]=!0;var W_=Ze,q_=N,V_=ni,U_=Tt,Y_=Zs,X_=Hi,G_=lt,K_=Ia,$_=Oa,Z_=Us,Q_=TypeError,J_=function(t,e){this.stopped=t,this.result=e},tE=J_.prototype,eE=function(t,e,i){var n,o,r,s,a,h,l,d=i&&i.that,c=!(!i||!i.AS_ENTRIES),u=!(!i||!i.IS_RECORD),f=!(!i||!i.IS_ITERATOR),p=!(!i||!i.INTERRUPTED),v=W_(e,d),g=function(t){return n&&Z_(n,"normal",t),new J_(!0,t)},y=function(t){return c?(V_(t),p?v(t[0],t[1],g):v(t[0],t[1])):p?v(t,g):v(t)};if(u)n=t.iterator;else if(f)n=t;else{if(!(o=$_(t)))throw Q_(U_(t)+" is not iterable");if(Y_(o)){for(r=0,s=X_(t);s>r;r++)if((a=y(t[r]))&&G_(tE,a))return a;return new J_(!1)}n=K_(t,o)}for(h=u?t.next:n.next;!(l=q_(h,n)).done;){try{a=y(l.value)}catch(t){Z_(n,"throw",t)}if("object"==typeof a&&a&&G_(tE,a))return a}return new J_(!1)},iE=lt,nE=TypeError,oE=function(t,e){if(iE(e,t))return t;throw nE("Incorrect invocation")},rE=Mi,sE=s,aE=y_,hE=a,lE=yi,dE=eE,cE=oE,uE=M,fE=it,pE=es,vE=Qe.f,gE=vl.forEach,yE=D,mE=Xo.set,bE=Xo.getterFor,wE=function(t,e,i){var n,o=-1!==t.indexOf("Map"),r=-1!==t.indexOf("Weak"),s=o?"set":"add",a=sE[t],h=a&&a.prototype,l={};if(yE&&uE(a)&&(r||h.forEach&&!hE((function(){(new a).entries().next()})))){var d=(n=e((function(e,i){mE(cE(e,d),{type:t,collection:new a}),null!=i&&dE(i,e[s],{that:e,AS_ENTRIES:o})}))).prototype,c=bE(t);gE(["add","clear","delete","forEach","get","has","set","keys","values","entries"],(function(t){var e="add"==t||"set"==t;!(t in h)||r&&"clear"==t||lE(d,t,(function(i,n){var o=c(this).collection;if(!e&&r&&!fE(i))return"get"==t&&void 0;var s=o[t](0===i?0:i,n);return e?this:s}))})),r||vE(d,"size",{configurable:!0,get:function(){return c(this).collection.size}})}else n=i.getConstructor(e,t,o,s),aE.enable();return pE(n,t,!1,!0),l[t]=n,rE({global:!0,forced:!0},l),r||i.setStrong(n,t,o),n},xE=Fr,kE=function(t,e,i){for(var n in e)i&&i.unsafe&&t[n]?t[n]=e[n]:xE(t,n,e[n],i);return t},_E=ht,EE=Lh,OE=D,CE=fe("species"),SE=function(t){var e=_E(t);OE&&e&&!e[CE]&&EE(e,CE,{configurable:!0,get:function(){return this}})},TE=Or,ME=Lh,PE=kE,DE=Ze,IE=oE,BE=X,NE=eE,zE=Is,FE=Bs,AE=SE,jE=D,RE=y_.fastKey,LE=Xo.set,HE=Xo.getterFor,WE={getConstructor:function(t,e,i,n){var o=t((function(t,o){IE(t,r),LE(t,{type:e,index:TE(null),first:void 0,last:void 0,size:0}),jE||(t.size=0),BE(o)||NE(o,t[n],{that:t,AS_ENTRIES:i})})),r=o.prototype,s=HE(e),a=function(t,e,i){var n,o,r=s(t),a=h(t,e);return a?a.value=i:(r.last=a={index:o=RE(e,!0),key:e,value:i,previous:n=r.last,next:void 0,removed:!1},r.first||(r.first=a),n&&(n.next=a),jE?r.size++:t.size++,"F"!==o&&(r.index[o]=a)),t},h=function(t,e){var i,n=s(t),o=RE(e);if("F"!==o)return n.index[o];for(i=n.first;i;i=i.next)if(i.key==e)return i};return PE(r,{clear:function(){for(var t=s(this),e=t.index,i=t.first;i;)i.removed=!0,i.previous&&(i.previous=i.previous.next=void 0),delete e[i.index],i=i.next;t.first=t.last=void 0,jE?t.size=0:this.size=0},delete:function(t){var e=this,i=s(e),n=h(e,t);if(n){var o=n.next,r=n.previous;delete i.index[n.index],n.removed=!0,r&&(r.next=o),o&&(o.previous=r),i.first==n&&(i.first=o),i.last==n&&(i.last=r),jE?i.size--:e.size--}return!!n},forEach:function(t){for(var e,i=s(this),n=DE(t,arguments.length>1?arguments[1]:void 0);e=e?e.next:i.first;)for(n(e.value,e.key,this);e&&e.removed;)e=e.previous},has:function(t){return!!h(this,t)}}),PE(r,i?{get:function(t){var e=h(this,t);return e&&e.value},set:function(t,e){return a(this,0===t?0:t,e)}}:{add:function(t){return a(this,t=0===t?0:t,t)}}),jE&&ME(r,"size",{configurable:!0,get:function(){return s(this).size}}),o},setStrong:function(t,e,i){var n=e+" Iterator",o=HE(e),r=HE(n);zE(t,e,(function(t,e){LE(this,{type:n,target:t,state:o(t),kind:e,last:void 0})}),(function(){for(var t=r(this),e=t.kind,i=t.last;i&&i.removed;)i=i.previous;return t.target&&(t.last=i=i?i.next:t.state.first)?FE("keys"==e?i.key:"values"==e?i.value:[i.key,i.value],!1):(t.target=void 0,FE(void 0,!0))}),i?"entries":"values",!i,!0),AE(e)}};wE("Map",(function(t){return function(){return t(this,arguments.length?arguments[0]:void 0)}}),WE);var qE=nt.Map;!function(t){t.exports=qE}(g_);var VE=i(v_),UE=function(){function t(){pu(this,t),this.clear(),this._defaultIndex=0,this._groupIndex=0,this._defaultGroups=[{border:"#2B7CE9",background:"#97C2FC",highlight:{border:"#2B7CE9",background:"#D2E5FF"},hover:{border:"#2B7CE9",background:"#D2E5FF"}},{border:"#FFA500",background:"#FFFF00",highlight:{border:"#FFA500",background:"#FFFFA3"},hover:{border:"#FFA500",background:"#FFFFA3"}},{border:"#FA0A10",background:"#FB7E81",highlight:{border:"#FA0A10",background:"#FFAFB1"},hover:{border:"#FA0A10",background:"#FFAFB1"}},{border:"#41A906",background:"#7BE141",highlight:{border:"#41A906",background:"#A1EC76"},hover:{border:"#41A906",background:"#A1EC76"}},{border:"#E129F0",background:"#EB7DF4",highlight:{border:"#E129F0",background:"#F0B3F5"},hover:{border:"#E129F0",background:"#F0B3F5"}},{border:"#7C29F0",background:"#AD85E4",highlight:{border:"#7C29F0",background:"#D3BDF0"},hover:{border:"#7C29F0",background:"#D3BDF0"}},{border:"#C37F00",background:"#FFA807",highlight:{border:"#C37F00",background:"#FFCA66"},hover:{border:"#C37F00",background:"#FFCA66"}},{border:"#4220FB",background:"#6E6EFD",highlight:{border:"#4220FB",background:"#9B9BFD"},hover:{border:"#4220FB",background:"#9B9BFD"}},{border:"#FD5A77",background:"#FFC0CB",highlight:{border:"#FD5A77",background:"#FFD1D9"},hover:{border:"#FD5A77",background:"#FFD1D9"}},{border:"#4AD63A",background:"#C2FABC",highlight:{border:"#4AD63A",background:"#E6FFE3"},hover:{border:"#4AD63A",background:"#E6FFE3"}},{border:"#990000",background:"#EE0000",highlight:{border:"#BB0000",background:"#FF3333"},hover:{border:"#BB0000",background:"#FF3333"}},{border:"#FF6000",background:"#FF6000",highlight:{border:"#FF6000",background:"#FF6000"},hover:{border:"#FF6000",background:"#FF6000"}},{border:"#97C2FC",background:"#2B7CE9",highlight:{border:"#D2E5FF",background:"#2B7CE9"},hover:{border:"#D2E5FF",background:"#2B7CE9"}},{border:"#399605",background:"#255C03",highlight:{border:"#399605",background:"#255C03"},hover:{border:"#399605",background:"#255C03"}},{border:"#B70054",background:"#FF007E",highlight:{border:"#B70054",background:"#FF007E"},hover:{border:"#B70054",background:"#FF007E"}},{border:"#AD85E4",background:"#7C29F0",highlight:{border:"#D3BDF0",background:"#7C29F0"},hover:{border:"#D3BDF0",background:"#7C29F0"}},{border:"#4557FA",background:"#000EA1",highlight:{border:"#6E6EFD",background:"#000EA1"},hover:{border:"#6E6EFD",background:"#000EA1"}},{border:"#FFC0CB",background:"#FD5A77",highlight:{border:"#FFD1D9",background:"#FD5A77"},hover:{border:"#FFD1D9",background:"#FD5A77"}},{border:"#C2FABC",background:"#74D66A",highlight:{border:"#E6FFE3",background:"#74D66A"},hover:{border:"#E6FFE3",background:"#74D66A"}},{border:"#EE0000",background:"#990000",highlight:{border:"#FF3333",background:"#BB0000"},hover:{border:"#FF3333",background:"#BB0000"}}],this.options={},this.defaultOptions={useDefaultGroups:!0},xn(this.options,this.defaultOptions)}return Nf(t,[{key:"setOptions",value:function(t){var e=["useDefaultGroups"];if(void 0!==t)for(var i in t)if(Object.prototype.hasOwnProperty.call(t,i)&&-1===tm(e).call(e,i)){var n=t[i];this.add(i,n)}}},{key:"clear",value:function(){this._groups=new VE,this._groupNames=[]}},{key:"get",value:function(t){var e=!(arguments.length>1&&void 0!==arguments[1])||arguments[1],i=this._groups.get(t);if(void 0===i&&e)if(!1===this.options.useDefaultGroups&&this._groupNames.length>0){var n=this._groupIndex%this._groupNames.length;++this._groupIndex,(i={}).color=this._groups.get(this._groupNames[n]),this._groups.set(t,i)}else{var o=this._defaultIndex%this._defaultGroups.length;this._defaultIndex++,(i={}).color=this._defaultGroups[o],this._groups.set(t,i)}return i}},{key:"add",value:function(t,e){return this._groups.has(t)||this._groupNames.push(t),this._groups.set(t,e),e}}]),t}(),YE={},XE={get exports(){return YE},set exports(t){YE=t}};Mi({target:"Number",stat:!0},{isNaN:function(t){return t!=t}});var GE=nt.Number.isNaN;!function(t){t.exports=GE}(XE);var KE=i(YE),$E={},ZE={get exports(){return $E},set exports(t){$E=t}},QE=s.isFinite,JE=Number.isFinite||function(t){return"number"==typeof t&&QE(t)};Mi({target:"Number",stat:!0},{isFinite:JE});var tO=nt.Number.isFinite;!function(t){t.exports=tO}(ZE);var eO=i($E),iO={},nO={get exports(){return iO},set exports(t){iO=t}},oO=vl.some;Mi({target:"Array",proto:!0,forced:!vv("some")},{some:function(t){return oO(this,t,arguments.length>1?arguments[1]:void 0)}});var rO=Rn("Array").some,sO=lt,aO=rO,hO=Array.prototype,lO=function(t){var e=t.some;return t===hO||sO(hO,t)&&e===hO.some?aO:e},dO=lO;!function(t){t.exports=dO}(nO);var cO=i(iO);function uO(t){if(void 0===t)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return t}var fO={},pO={get exports(){return fO},set exports(t){fO=t}},vO={},gO=ym;!function(t){t.exports=gO}({get exports(){return vO},set exports(t){vO=t}}),function(t){t.exports=vO}(pO);var yO=i(fO),mO={},bO={get exports(){return mO},set exports(t){mO=t}},wO={},xO={get exports(){return wO},set exports(t){wO=t}};Mi({target:"Object",stat:!0},{setPrototypeOf:ys});var kO=nt.Object.setPrototypeOf;!function(t){t.exports=kO}(xO),function(t){t.exports=wO}(bO);var _O=i(mO),EO={},OO={get exports(){return EO},set exports(t){EO=t}},CO={},SO=Un;!function(t){t.exports=SO}({get exports(){return CO},set exports(t){CO=t}}),function(t){t.exports=CO}(OO);var TO=i(EO);function MO(t,e){var i;return MO=_O?TO(i=_O).call(i):function(t,e){return t.__proto__=e,t},MO(t,e)}function PO(t,e){if("function"!=typeof e&&null!==e)throw new TypeError("Super expression must either be null or a function");t.prototype=yO(e&&e.prototype,{constructor:{value:t,writable:!0,configurable:!0}}),bu(t,"prototype",{writable:!1}),e&&MO(t,e)}function DO(t,e){if(e&&("object"===Of(e)||"function"==typeof e))return e;if(void 0!==e)throw new TypeError("Derived constructors may only return object or undefined");return uO(t)}var IO={},BO={get exports(){return IO},set exports(t){IO=t}},NO={},zO=Yg;!function(t){t.exports=zO}({get exports(){return NO},set exports(t){NO=t}}),function(t){t.exports=NO}(BO);var FO=i(IO);function AO(t){var e;return AO=_O?TO(e=FO).call(e):function(t){return t.__proto__||FO(t)},AO(t)}var jO={},RO={get exports(){return jO},set exports(t){jO=t}},LO={};!function(t){var e=wu,i=mf;function n(o){return t.exports=n="function"==typeof e&&"symbol"==typeof i?function(t){return typeof t}:function(t){return t&&"function"==typeof e&&t.constructor===e&&t!==e.prototype?"symbol":typeof t},t.exports.__esModule=!0,t.exports.default=t.exports,n(o)}t.exports=n,t.exports.__esModule=!0,t.exports.default=t.exports}({get exports(){return LO},set exports(t){LO=t}});var HO={},WO={get exports(){return HO},set exports(t){HO=t}},qO={},VO=Ov;!function(t){t.exports=VO}({get exports(){return qO},set exports(t){qO=t}}),function(t){t.exports=qO}(WO);var UO={},YO={get exports(){return UO},set exports(t){UO=t}},XO={},GO={get exports(){return XO},set exports(t){XO=t}},KO=Jt,$O=Rc,ZO=P,QO=Qe,JO=it,tC=yi,eC=Error,iC=m("".replace),nC=String(eC("zxcasd").stack),oC=/\n\s*at [^:]*:[^\n]*/,rC=oC.test(nC),sC=H,aC=!a((function(){var t=Error("a");return!("stack"in t)||(Object.defineProperty(t,"stack",sC(1,7)),7!==t.stack)})),hC=yi,lC=function(t,e){if(rC&&"string"==typeof t&&!eC.prepareStackTrace)for(;e--;)t=iC(t,oC,"");return t},dC=aC,cC=Error.captureStackTrace,uC=mo,fC=Mi,pC=lt,vC=Nr,gC=ys,yC=function(t,e,i){for(var n=$O(e),o=QO.f,r=ZO.f,s=0;s<n.length;s++){var a=n[s];KO(t,a)||i&&KO(i,a)||o(t,a,r(e,a))}},mC=Or,bC=yi,wC=H,xC=function(t,e){JO(e)&&"cause"in e&&tC(t,"cause",e.cause)},kC=function(t,e,i,n){dC&&(cC?cC(t,e):hC(t,"stack",lC(i,n)))},_C=eE,EC=function(t,e){return void 0===t?arguments.length<2?"":e:uC(t)},OC=fe("toStringTag"),CC=Error,SC=[].push,TC=function(t,e){var i,n=pC(MC,this);gC?i=gC(CC(),n?vC(this):MC):(i=n?this:mC(MC),bC(i,OC,"Error")),void 0!==e&&bC(i,"message",EC(e)),kC(i,TC,i.stack,1),arguments.length>2&&xC(i,arguments[2]);var o=[];return _C(t,SC,{that:o}),bC(i,"errors",o),i};gC?gC(TC,CC):yC(TC,CC,{name:!0});var MC=TC.prototype=mC(CC.prototype,{constructor:wC(1,TC),message:wC(1,""),name:wC(1,"AggregateError")});fC({global:!0,constructor:!0,arity:2},{AggregateError:TC});var PC,DC,IC,BC,NC="undefined"!=typeof process&&"process"==k(process),zC=va,FC=Tt,AC=TypeError,jC=function(t){if(zC(t))return t;throw AC(FC(t)+" is not a constructor")},RC=ni,LC=jC,HC=X,WC=fe("species"),qC=function(t,e){var i,n=RC(t).constructor;return void 0===n||HC(i=RC(n)[WC])?e:LC(i)},VC=/(?:ipad|iphone|ipod).*applewebkit/i.test(dt),UC=s,YC=f,XC=Ze,GC=M,KC=Jt,$C=a,ZC=hr,QC=En,JC=Se,tS=Pm,eS=VC,iS=NC,nS=UC.setImmediate,oS=UC.clearImmediate,rS=UC.process,sS=UC.Dispatch,aS=UC.Function,hS=UC.MessageChannel,lS=UC.String,dS=0,cS={},uS="onreadystatechange";$C((function(){PC=UC.location}));var fS=function(t){if(KC(cS,t)){var e=cS[t];delete cS[t],e()}},pS=function(t){return function(){fS(t)}},vS=function(t){fS(t.data)},gS=function(t){UC.postMessage(lS(t),PC.protocol+"//"+PC.host)};nS&&oS||(nS=function(t){tS(arguments.length,1);var e=GC(t)?t:aS(t),i=QC(arguments,1);return cS[++dS]=function(){YC(e,void 0,i)},DC(dS),dS},oS=function(t){delete cS[t]},iS?DC=function(t){rS.nextTick(pS(t))}:sS&&sS.now?DC=function(t){sS.now(pS(t))}:hS&&!eS?(BC=(IC=new hS).port2,IC.port1.onmessage=vS,DC=XC(BC.postMessage,BC)):UC.addEventListener&&GC(UC.postMessage)&&!UC.importScripts&&PC&&"file:"!==PC.protocol&&!$C(gS)?(DC=gS,UC.addEventListener("message",vS,!1)):DC=uS in JC("script")?function(t){ZC.appendChild(JC("script"))[uS]=function(){ZC.removeChild(this),fS(t)}}:function(t){setTimeout(pS(t),0)});var yS={set:nS,clear:oS},mS=function(){this.head=null,this.tail=null};mS.prototype={add:function(t){var e={item:t,next:null},i=this.tail;i?i.next=e:this.head=e,this.tail=e},get:function(){var t=this.head;if(t)return null===(this.head=t.next)&&(this.tail=null),t.item}};var bS,wS,xS,kS,_S,ES=mS,OS=/ipad|iphone|ipod/i.test(dt)&&"undefined"!=typeof Pebble,CS=/web0s(?!.*chrome)/i.test(dt),SS=s,TS=Ze,MS=P.f,PS=yS.set,DS=ES,IS=VC,BS=OS,NS=CS,zS=NC,FS=SS.MutationObserver||SS.WebKitMutationObserver,AS=SS.document,jS=SS.process,RS=SS.Promise,LS=MS(SS,"queueMicrotask"),HS=LS&&LS.value;if(!HS){var WS=new DS,qS=function(){var t,e;for(zS&&(t=jS.domain)&&t.exit();e=WS.get();)try{e()}catch(t){throw WS.head&&bS(),t}t&&t.enter()};IS||zS||NS||!FS||!AS?!BS&&RS&&RS.resolve?((kS=RS.resolve(void 0)).constructor=RS,_S=TS(kS.then,kS),bS=function(){_S(qS)}):zS?bS=function(){jS.nextTick(qS)}:(PS=TS(PS,SS),bS=function(){PS(qS)}):(wS=!0,xS=AS.createTextNode(""),new FS(qS).observe(xS,{characterData:!0}),bS=function(){xS.data=wS=!wS}),HS=function(t){WS.head||bS(),WS.add(t)}}var VS=HS,US=function(t){try{return{error:!1,value:t()}}catch(t){return{error:!0,value:t}}},YS=s.Promise,XS="object"==typeof Deno&&Deno&&"object"==typeof Deno.version,GS=!XS&&!NC&&"object"==typeof window&&"object"==typeof document,KS=s,$S=YS,ZS=M,QS=Xe,JS=ea,tT=fe,eT=GS,iT=XS,nT=yt,oT=$S&&$S.prototype,rT=tT("species"),sT=!1,aT=ZS(KS.PromiseRejectionEvent),hT=QS("Promise",(function(){var t=JS($S),e=t!==String($S);if(!e&&66===nT)return!0;if(!oT.catch||!oT.finally)return!0;if(!nT||nT<51||!/native code/.test(t)){var i=new $S((function(t){t(1)})),n=function(t){t((function(){}),(function(){}))};if((i.constructor={})[rT]=n,!(sT=i.then((function(){}))instanceof n))return!0}return!e&&(eT||iT)&&!aT})),lT={CONSTRUCTOR:hT,REJECTION_EVENT:aT,SUBCLASSING:sT},dT={},cT=It,uT=TypeError,fT=function(t){var e,i;this.promise=new t((function(t,n){if(void 0!==e||void 0!==i)throw uT("Bad Promise constructor");e=t,i=n})),this.resolve=cT(e),this.reject=cT(i)};dT.f=function(t){return new fT(t)};var pT,vT,gT=Mi,yT=NC,mT=s,bT=N,wT=Fr,xT=es,kT=SE,_T=It,ET=M,OT=it,CT=oE,ST=qC,TT=yS.set,MT=VS,PT=function(t,e){try{1==arguments.length?console.error(t):console.error(t,e)}catch(t){}},DT=US,IT=ES,BT=Xo,NT=YS,zT=dT,FT="Promise",AT=lT.CONSTRUCTOR,jT=lT.REJECTION_EVENT,RT=BT.getterFor(FT),LT=BT.set,HT=NT&&NT.prototype,WT=NT,qT=HT,VT=mT.TypeError,UT=mT.document,YT=mT.process,XT=zT.f,GT=XT,KT=!!(UT&&UT.createEvent&&mT.dispatchEvent),$T="unhandledrejection",ZT=function(t){var e;return!(!OT(t)||!ET(e=t.then))&&e},QT=function(t,e){var i,n,o,r=e.value,s=1==e.state,a=s?t.ok:t.fail,h=t.resolve,l=t.reject,d=t.domain;try{a?(s||(2===e.rejection&&nM(e),e.rejection=1),!0===a?i=r:(d&&d.enter(),i=a(r),d&&(d.exit(),o=!0)),i===t.promise?l(VT("Promise-chain cycle")):(n=ZT(i))?bT(n,i,h,l):h(i)):l(r)}catch(t){d&&!o&&d.exit(),l(t)}},JT=function(t,e){t.notified||(t.notified=!0,MT((function(){for(var i,n=t.reactions;i=n.get();)QT(i,t);t.notified=!1,e&&!t.rejection&&eM(t)})))},tM=function(t,e,i){var n,o;KT?((n=UT.createEvent("Event")).promise=e,n.reason=i,n.initEvent(t,!1,!0),mT.dispatchEvent(n)):n={promise:e,reason:i},!jT&&(o=mT["on"+t])?o(n):t===$T&&PT("Unhandled promise rejection",i)},eM=function(t){bT(TT,mT,(function(){var e,i=t.facade,n=t.value;if(iM(t)&&(e=DT((function(){yT?YT.emit("unhandledRejection",n,i):tM($T,i,n)})),t.rejection=yT||iM(t)?2:1,e.error))throw e.value}))},iM=function(t){return 1!==t.rejection&&!t.parent},nM=function(t){bT(TT,mT,(function(){var e=t.facade;yT?YT.emit("rejectionHandled",e):tM("rejectionhandled",e,t.value)}))},oM=function(t,e,i){return function(n){t(e,n,i)}},rM=function(t,e,i){t.done||(t.done=!0,i&&(t=i),t.value=e,t.state=2,JT(t,!0))},sM=function(t,e,i){if(!t.done){t.done=!0,i&&(t=i);try{if(t.facade===e)throw VT("Promise can't be resolved itself");var n=ZT(e);n?MT((function(){var i={done:!1};try{bT(n,e,oM(sM,i,t),oM(rM,i,t))}catch(e){rM(i,e,t)}})):(t.value=e,t.state=1,JT(t,!1))}catch(e){rM({done:!1},e,t)}}};AT&&(qT=(WT=function(t){CT(this,qT),_T(t),bT(pT,this);var e=RT(this);try{t(oM(sM,e),oM(rM,e))}catch(t){rM(e,t)}}).prototype,(pT=function(t){LT(this,{type:FT,done:!1,notified:!1,parent:!1,reactions:new IT,rejection:!1,state:0,value:void 0})}).prototype=wT(qT,"then",(function(t,e){var i=RT(this),n=XT(ST(this,WT));return i.parent=!0,n.ok=!ET(t)||t,n.fail=ET(e)&&e,n.domain=yT?YT.domain:void 0,0==i.state?i.reactions.add(n):MT((function(){QT(n,i)})),n.promise})),vT=function(){var t=new pT,e=RT(t);this.promise=t,this.resolve=oM(sM,e),this.reject=oM(rM,e)},zT.f=XT=function(t){return t===WT||undefined===t?new vT(t):GT(t)}),gT({global:!0,constructor:!0,wrap:!0,forced:AT},{Promise:WT}),xT(WT,FT,!1,!0),kT(FT);var aM=YS,hM=lT.CONSTRUCTOR||!Ga((function(t){aM.all(t).then(void 0,(function(){}))})),lM=N,dM=It,cM=dT,uM=US,fM=eE;Mi({target:"Promise",stat:!0,forced:hM},{all:function(t){var e=this,i=cM.f(e),n=i.resolve,o=i.reject,r=uM((function(){var i=dM(e.resolve),r=[],s=0,a=1;fM(t,(function(t){var h=s++,l=!1;a++,lM(i,e,t).then((function(t){l||(l=!0,r[h]=t,--a||n(r))}),o)})),--a||n(r)}));return r.error&&o(r.value),i.promise}});var pM=Mi,vM=lT.CONSTRUCTOR;YS&&YS.prototype,pM({target:"Promise",proto:!0,forced:vM,real:!0},{catch:function(t){return this.then(void 0,t)}});var gM=N,yM=It,mM=dT,bM=US,wM=eE;Mi({target:"Promise",stat:!0,forced:hM},{race:function(t){var e=this,i=mM.f(e),n=i.reject,o=bM((function(){var o=yM(e.resolve);wM(t,(function(t){gM(o,e,t).then(i.resolve,n)}))}));return o.error&&n(o.value),i.promise}});var xM=N,kM=dT;Mi({target:"Promise",stat:!0,forced:lT.CONSTRUCTOR},{reject:function(t){var e=kM.f(this);return xM(e.reject,void 0,t),e.promise}});var _M=ni,EM=it,OM=dT,CM=function(t,e){if(_M(t),EM(e)&&e.constructor===t)return e;var i=OM.f(t);return(0,i.resolve)(e),i.promise},SM=Mi,TM=YS,MM=lT.CONSTRUCTOR,PM=CM,DM=ht("Promise"),IM=!MM;SM({target:"Promise",stat:!0,forced:true},{resolve:function(t){return PM(IM&&this===DM?TM:this,t)}});var BM=N,NM=It,zM=dT,FM=US,AM=eE;Mi({target:"Promise",stat:!0,forced:hM},{allSettled:function(t){var e=this,i=zM.f(e),n=i.resolve,o=i.reject,r=FM((function(){var i=NM(e.resolve),o=[],r=0,s=1;AM(t,(function(t){var a=r++,h=!1;s++,BM(i,e,t).then((function(t){h||(h=!0,o[a]={status:"fulfilled",value:t},--s||n(o))}),(function(t){h||(h=!0,o[a]={status:"rejected",reason:t},--s||n(o))}))})),--s||n(o)}));return r.error&&o(r.value),i.promise}});var jM=N,RM=It,LM=ht,HM=dT,WM=US,qM=eE,VM="No one promise resolved";Mi({target:"Promise",stat:!0,forced:hM},{any:function(t){var e=this,i=LM("AggregateError"),n=HM.f(e),o=n.resolve,r=n.reject,s=WM((function(){var n=RM(e.resolve),s=[],a=0,h=1,l=!1;qM(t,(function(t){var d=a++,c=!1;h++,jM(n,e,t).then((function(t){c||l||(l=!0,o(t))}),(function(t){c||l||(c=!0,s[d]=t,--h||r(new i(s,VM)))}))})),--h||r(new i(s,VM))}));return s.error&&r(s.value),n.promise}});var UM=Mi,YM=YS,XM=a,GM=ht,KM=M,$M=qC,ZM=CM,QM=YM&&YM.prototype;UM({target:"Promise",proto:!0,real:!0,forced:!!YM&&XM((function(){QM.finally.call({then:function(){}},(function(){}))}))},{finally:function(t){var e=$M(this,GM("Promise")),i=KM(t);return this.then(i?function(i){return ZM(e,t()).then((function(){return i}))}:t,i?function(i){return ZM(e,t()).then((function(){throw i}))}:t)}});var JM=nt.Promise,tP=dT,eP=US;Mi({target:"Promise",stat:!0,forced:!0},{try:function(t){var e=tP.f(this),i=eP(t);return(i.error?e.reject:e.resolve)(i.value),e.promise}});var iP=JM;!function(t){t.exports=iP}(GO),function(t){t.exports=XO}(YO);var nP={},oP={get exports(){return nP},set exports(t){nP=t}},rP={},sP=jv;!function(t){t.exports=sP}({get exports(){return rP},set exports(t){rP=t}}),function(t){t.exports=rP}(oP),function(t){var e=LO.default,i=vu,n=wu,o=fO,r=IO,s=HO,a=mO,h=UO,l=nP,d=qf;function c(){t.exports=c=function(){return u},t.exports.__esModule=!0,t.exports.default=t.exports;var u={},f=Object.prototype,p=f.hasOwnProperty,v=i||function(t,e,i){t[e]=i.value},g="function"==typeof n?n:{},y=g.iterator||"@@iterator",m=g.asyncIterator||"@@asyncIterator",b=g.toStringTag||"@@toStringTag";function w(t,e,n){return i(t,e,{value:n,enumerable:!0,configurable:!0,writable:!0}),t[e]}try{w({},"")}catch(t){w=function(t,e,i){return t[e]=i}}function x(t,e,i,n){var r=e&&e.prototype instanceof E?e:E,s=o(r.prototype),a=new F(n||[]);return v(s,"_invoke",{value:I(t,i,a)}),s}function k(t,e,i){try{return{type:"normal",arg:t.call(e,i)}}catch(t){return{type:"throw",arg:t}}}u.wrap=x;var _={};function E(){}function O(){}function C(){}var S={};w(S,y,(function(){return this}));var T=r&&r(r(A([])));T&&T!==f&&p.call(T,y)&&(S=T);var M=C.prototype=E.prototype=o(S);function P(t){var e;s(e=["next","throw","return"]).call(e,(function(e){w(t,e,(function(t){return this._invoke(e,t)}))}))}function D(t,i){function n(o,r,s,a){var h=k(t[o],t,r);if("throw"!==h.type){var l=h.arg,d=l.value;return d&&"object"==e(d)&&p.call(d,"__await")?i.resolve(d.__await).then((function(t){n("next",t,s,a)}),(function(t){n("throw",t,s,a)})):i.resolve(d).then((function(t){l.value=t,s(l)}),(function(t){return n("throw",t,s,a)}))}a(h.arg)}var o;v(this,"_invoke",{value:function(t,e){function r(){return new i((function(i,o){n(t,e,i,o)}))}return o=o?o.then(r,r):r()}})}function I(t,e,i){var n="suspendedStart";return function(o,r){if("executing"===n)throw new Error("Generator is already running");if("completed"===n){if("throw"===o)throw r;return j()}for(i.method=o,i.arg=r;;){var s=i.delegate;if(s){var a=B(s,i);if(a){if(a===_)continue;return a}}if("next"===i.method)i.sent=i._sent=i.arg;else if("throw"===i.method){if("suspendedStart"===n)throw n="completed",i.arg;i.dispatchException(i.arg)}else"return"===i.method&&i.abrupt("return",i.arg);n="executing";var h=k(t,e,i);if("normal"===h.type){if(n=i.done?"completed":"suspendedYield",h.arg===_)continue;return{value:h.arg,done:i.done}}"throw"===h.type&&(n="completed",i.method="throw",i.arg=h.arg)}}}function B(t,e){var i=e.method,n=t.iterator[i];if(void 0===n)return e.delegate=null,"throw"===i&&t.iterator.return&&(e.method="return",e.arg=void 0,B(t,e),"throw"===e.method)||"return"!==i&&(e.method="throw",e.arg=new TypeError("The iterator does not provide a '"+i+"' method")),_;var o=k(n,t.iterator,e.arg);if("throw"===o.type)return e.method="throw",e.arg=o.arg,e.delegate=null,_;var r=o.arg;return r?r.done?(e[t.resultName]=r.value,e.next=t.nextLoc,"return"!==e.method&&(e.method="next",e.arg=void 0),e.delegate=null,_):r:(e.method="throw",e.arg=new TypeError("iterator result is not an object"),e.delegate=null,_)}function N(t){var e={tryLoc:t[0]};1 in t&&(e.catchLoc=t[1]),2 in t&&(e.finallyLoc=t[2],e.afterLoc=t[3]),this.tryEntries.push(e)}function z(t){var e=t.completion||{};e.type="normal",delete e.arg,t.completion=e}function F(t){this.tryEntries=[{tryLoc:"root"}],s(t).call(t,N,this),this.reset(!0)}function A(t){if(t){var e=t[y];if(e)return e.call(t);if("function"==typeof t.next)return t;if(!isNaN(t.length)){var i=-1,n=function e(){for(;++i<t.length;)if(p.call(t,i))return e.value=t[i],e.done=!1,e;return e.value=void 0,e.done=!0,e};return n.next=n}}return{next:j}}function j(){return{value:void 0,done:!0}}return O.prototype=C,v(M,"constructor",{value:C,configurable:!0}),v(C,"constructor",{value:O,configurable:!0}),O.displayName=w(C,b,"GeneratorFunction"),u.isGeneratorFunction=function(t){var e="function"==typeof t&&t.constructor;return!!e&&(e===O||"GeneratorFunction"===(e.displayName||e.name))},u.mark=function(t){return a?a(t,C):(t.__proto__=C,w(t,b,"GeneratorFunction")),t.prototype=o(M),t},u.awrap=function(t){return{__await:t}},P(D.prototype),w(D.prototype,m,(function(){return this})),u.AsyncIterator=D,u.async=function(t,e,i,n,o){void 0===o&&(o=h);var r=new D(x(t,e,i,n),o);return u.isGeneratorFunction(e)?r:r.next().then((function(t){return t.done?t.value:r.next()}))},P(M),w(M,b,"Generator"),w(M,y,(function(){return this})),w(M,"toString",(function(){return"[object Generator]"})),u.keys=function(t){var e=Object(t),i=[];for(var n in e)i.push(n);return l(i).call(i),function t(){for(;i.length;){var n=i.pop();if(n in e)return t.value=n,t.done=!1,t}return t.done=!0,t}},u.values=A,F.prototype={constructor:F,reset:function(t){var e;if(this.prev=0,this.next=0,this.sent=this._sent=void 0,this.done=!1,this.delegate=null,this.method="next",this.arg=void 0,s(e=this.tryEntries).call(e,z),!t)for(var i in this)"t"===i.charAt(0)&&p.call(this,i)&&!isNaN(+d(i).call(i,1))&&(this[i]=void 0)},stop:function(){this.done=!0;var t=this.tryEntries[0].completion;if("throw"===t.type)throw t.arg;return this.rval},dispatchException:function(t){if(this.done)throw t;var e=this;function i(i,n){return r.type="throw",r.arg=t,e.next=i,n&&(e.method="next",e.arg=void 0),!!n}for(var n=this.tryEntries.length-1;n>=0;--n){var o=this.tryEntries[n],r=o.completion;if("root"===o.tryLoc)return i("end");if(o.tryLoc<=this.prev){var s=p.call(o,"catchLoc"),a=p.call(o,"finallyLoc");if(s&&a){if(this.prev<o.catchLoc)return i(o.catchLoc,!0);if(this.prev<o.finallyLoc)return i(o.finallyLoc)}else if(s){if(this.prev<o.catchLoc)return i(o.catchLoc,!0)}else{if(!a)throw new Error("try statement without catch or finally");if(this.prev<o.finallyLoc)return i(o.finallyLoc)}}}},abrupt:function(t,e){for(var i=this.tryEntries.length-1;i>=0;--i){var n=this.tryEntries[i];if(n.tryLoc<=this.prev&&p.call(n,"finallyLoc")&&this.prev<n.finallyLoc){var o=n;break}}o&&("break"===t||"continue"===t)&&o.tryLoc<=e&&e<=o.finallyLoc&&(o=null);var r=o?o.completion:{};return r.type=t,r.arg=e,o?(this.method="next",this.next=o.finallyLoc,_):this.complete(r)},complete:function(t,e){if("throw"===t.type)throw t.arg;return"break"===t.type||"continue"===t.type?this.next=t.arg:"return"===t.type?(this.rval=this.arg=t.arg,this.method="return",this.next="end"):"normal"===t.type&&e&&(this.next=e),_},finish:function(t){for(var e=this.tryEntries.length-1;e>=0;--e){var i=this.tryEntries[e];if(i.finallyLoc===t)return this.complete(i.completion,i.afterLoc),z(i),_}},catch:function(t){for(var e=this.tryEntries.length-1;e>=0;--e){var i=this.tryEntries[e];if(i.tryLoc===t){var n=i.completion;if("throw"===n.type){var o=n.arg;z(i)}return o}}throw new Error("illegal catch attempt")},delegateYield:function(t,e,i){return this.delegate={iterator:A(t),resultName:e,nextLoc:i},"next"===this.method&&(this.arg=void 0),_}},u}t.exports=c,t.exports.__esModule=!0,t.exports.default=t.exports}(RO);var aP=jO(),hP=aP;try{regeneratorRuntime=aP}catch(t){"object"==typeof globalThis?globalThis.regeneratorRuntime=aP:Function("r","regeneratorRuntime = r")(aP)}var lP={},dP={get exports(){return lP},set exports(t){lP=t}},cP=It,uP=$t,fP=Y,pP=Hi,vP=TypeError,gP=function(t){return function(e,i,n,o){cP(i);var r=uP(e),s=fP(r),a=pP(r),h=t?a-1:0,l=t?-1:1;if(n<2)for(;;){if(h in s){o=s[h],h+=l;break}if(h+=l,t?h<0:a<=h)throw vP("Reduce of empty array with no initial value")}for(;t?h>=0:a>h;h+=l)h in s&&(o=i(o,s[h],h,r));return o}},yP={left:gP(!1),right:gP(!0)}.left;Mi({target:"Array",proto:!0,forced:!NC&&yt>79&&yt<83||!vv("reduce")},{reduce:function(t){var e=arguments.length;return yP(this,t,e,e>1?arguments[1]:void 0)}});var mP=Rn("Array").reduce,bP=lt,wP=mP,xP=Array.prototype,kP=function(t){var e=t.reduce;return t===xP||bP(xP,t)&&e===xP.reduce?wP:e},_P=kP;!function(t){t.exports=_P}(dP);var EP=i(lP),OP={},CP={get exports(){return OP},set exports(t){OP=t}},SP=tl,TP=Hi,MP=Ou,PP=Ze,DP=function(t,e,i,n,o,r,s,a){for(var h,l,d=o,c=0,u=!!s&&PP(s,a);c<n;)c in i&&(h=u?u(i[c],c,e):i[c],r>0&&SP(h)?(l=TP(h),d=DP(t,e,h,l,d,r-1)-1):(MP(d+1),t[d]=h),d++),c++;return d},IP=DP,BP=It,NP=$t,zP=Hi,FP=al;Mi({target:"Array",proto:!0},{flatMap:function(t){var e,i=NP(this),n=zP(i);return BP(t),(e=FP(i,0)).length=IP(e,i,i,n,0,1,t,arguments.length>1?arguments[1]:void 0),e}});var AP=Rn("Array").flatMap,jP=lt,RP=AP,LP=Array.prototype,HP=function(t){var e=t.flatMap;return t===LP||jP(LP,t)&&e===LP.flatMap?RP:e},WP=HP;!function(t){t.exports=WP}(CP);var qP=i(OP),VP={},UP={get exports(){return VP},set exports(t){VP=t}};wE("Set",(function(t){return function(){return t(this,arguments.length?arguments[0]:void 0)}}),WE);var YP=nt.Set;!function(t){t.exports=YP}(UP);var XP=i(VP),GP={};!function(t){t.exports=kf}({get exports(){return GP},set exports(t){GP=t}});var KP=i(GP),$P={},ZP={get exports(){return $P},set exports(t){$P=t}},QP={},JP=Ia;!function(t){t.exports=JP}({get exports(){return QP},set exports(t){QP=t}}),function(t){t.exports=QP}(ZP);var tD=i($P),eD={},iD={get exports(){return eD},set exports(t){eD=t}},nD=Bh,oD=Math.floor,rD=function(t,e){var i=t.length,n=oD(i/2);return i<8?sD(t,e):aD(t,rD(nD(t,0,n),e),rD(nD(t,n),e),e)},sD=function(t,e){for(var i,n,o=t.length,r=1;r<o;){for(n=r,i=t[r];n&&e(t[n-1],i)>0;)t[n]=t[--n];n!==r++&&(t[n]=i)}return t},aD=function(t,e,i,n){for(var o=e.length,r=i.length,s=0,a=0;s<o||a<r;)t[s+a]=s<o&&a<r?n(e[s],i[a])<=0?e[s++]:i[a++]:s<o?e[s++]:i[a++];return t},hD=rD,lD=dt.match(/firefox\/(\d+)/i),dD=!!lD&&+lD[1],cD=/MSIE|Trident/.test(dt),uD=dt.match(/AppleWebKit\/(\d+)\./),fD=!!uD&&+uD[1],pD=Mi,vD=m,gD=It,yD=$t,mD=Hi,bD=Kv,wD=mo,xD=a,kD=hD,_D=vv,ED=dD,OD=cD,CD=yt,SD=fD,TD=[],MD=vD(TD.sort),PD=vD(TD.push),DD=xD((function(){TD.sort(void 0)})),ID=xD((function(){TD.sort(null)})),BD=_D("sort"),ND=!xD((function(){if(CD)return CD<70;if(!(ED&&ED>3)){if(OD)return!0;if(SD)return SD<603;var t,e,i,n,o="";for(t=65;t<76;t++){switch(e=String.fromCharCode(t),t){case 66:case 69:case 70:case 72:i=3;break;case 68:case 71:i=4;break;default:i=2}for(n=0;n<47;n++)TD.push({k:e+n,v:i})}for(TD.sort((function(t,e){return e.v-t.v})),n=0;n<TD.length;n++)e=TD[n].k.charAt(0),o.charAt(o.length-1)!==e&&(o+=e);return"DGBEFHACIJK"!==o}}));pD({target:"Array",proto:!0,forced:DD||!ID||!BD||!ND},{sort:function(t){void 0!==t&&gD(t);var e=yD(this);if(ND)return void 0===t?MD(e):MD(e,t);var i,n,o=[],r=mD(e);for(n=0;n<r;n++)n in e&&PD(o,e[n]);for(kD(o,function(t){return function(e,i){return void 0===i?-1:void 0===e?1:void 0!==t?+t(e,i)||0:wD(e)>wD(i)?1:-1}}(t)),i=mD(o),n=0;n<i;)e[n]=o[n++];for(;n<r;)bD(e,n++);return e}});var zD=Rn("Array").sort,FD=lt,AD=zD,jD=Array.prototype,RD=function(t){var e=t.sort;return t===jD||FD(jD,t)&&e===jD.sort?AD:e},LD=RD;!function(t){t.exports=LD}(iD);var HD=i(eD),WD={},qD={get exports(){return WD},set exports(t){WD=t}},VD=Rn("Array").keys,UD=vo,YD=Jt,XD=lt,GD=VD,KD=Array.prototype,$D={DOMTokenList:!0,NodeList:!0},ZD=function(t){var e=t.keys;return t===KD||XD(KD,t)&&e===KD.keys||YD($D,UD(t))?GD:e};!function(t){t.exports=ZD}(qD);var QD=i(WD),JD={},tI={get exports(){return JD},set exports(t){JD=t}},eI=Rn("Array").values,iI=vo,nI=Jt,oI=lt,rI=eI,sI=Array.prototype,aI={DOMTokenList:!0,NodeList:!0},hI=function(t){var e=t.values;return t===sI||oI(sI,t)&&e===sI.values||nI(aI,iI(t))?rI:e};!function(t){t.exports=hI}(tI);var lI=i(JD),dI={},cI={get exports(){return dI},set exports(t){dI=t}},uI=Rn("Array").entries,fI=vo,pI=Jt,vI=lt,gI=uI,yI=Array.prototype,mI={DOMTokenList:!0,NodeList:!0},bI=function(t){var e=t.entries;return t===yI||vI(yI,t)&&e===yI.entries||pI(mI,fI(t))?gI:e};!function(t){t.exports=bI}(cI);var wI=i(dI),xI={},kI={get exports(){return xI},set exports(t){xI=t}},_I=Mi,EI=f,OI=Fn,CI=jC,SI=ni,TI=it,MI=Or,PI=a,DI=ht("Reflect","construct"),II=Object.prototype,BI=[].push,NI=PI((function(){function t(){}return!(DI((function(){}),[],t)instanceof t)})),zI=!PI((function(){DI((function(){}))})),FI=NI||zI;_I({target:"Reflect",stat:!0,forced:FI,sham:FI},{construct:function(t,e){CI(t),SI(e);var i=arguments.length<3?t:CI(arguments[2]);if(zI&&!NI)return DI(t,e,i);if(t==i){switch(e.length){case 0:return new t;case 1:return new t(e[0]);case 2:return new t(e[0],e[1]);case 3:return new t(e[0],e[1],e[2]);case 4:return new t(e[0],e[1],e[2],e[3])}var n=[null];return EI(BI,n,e),new(EI(OI,t,n))}var o=i.prototype,r=MI(TI(o)?o:II),s=EI(t,r,e);return TI(s)?s:r}});var AI=nt.Reflect.construct;!function(t){t.exports=AI}(kI);var jI=i(xI);let RI;const LI=new Uint8Array(16);function HI(){if(!RI&&(RI="undefined"!=typeof crypto&&crypto.getRandomValues&&crypto.getRandomValues.bind(crypto),!RI))throw new Error("crypto.getRandomValues() not supported. See https://github.com/uuidjs/uuid#getrandomvalues-not-supported");return RI(LI)}const WI=[];for(let t=0;t<256;++t)WI.push((t+256).toString(16).slice(1));var qI,VI={randomUUID:"undefined"!=typeof crypto&&crypto.randomUUID&&crypto.randomUUID.bind(crypto)};function UI(t,e,i){if(VI.randomUUID&&!e&&!t)return VI.randomUUID();const n=(t=t||{}).random||(t.rng||HI)();if(n[6]=15&n[6]|64,n[8]=63&n[8]|128,e){i=i||0;for(let t=0;t<16;++t)e[i+t]=n[t];return e}return function(t,e=0){return(WI[t[e+0]]+WI[t[e+1]]+WI[t[e+2]]+WI[t[e+3]]+"-"+WI[t[e+4]]+WI[t[e+5]]+"-"+WI[t[e+6]]+WI[t[e+7]]+"-"+WI[t[e+8]]+WI[t[e+9]]+"-"+WI[t[e+10]]+WI[t[e+11]]+WI[t[e+12]]+WI[t[e+13]]+WI[t[e+14]]+WI[t[e+15]]).toLowerCase()}(n)}function YI(t,e){var i=ov(t);if(mc){var n=mc(t);e&&(n=ny(n).call(n,(function(e){return Dc(t,e).enumerable}))),i.push.apply(i,n)}return i}function XI(t){for(var e=1;e<arguments.length;e++){var i,n,o=null!=arguments[e]?arguments[e]:{};e%2?Cv(i=YI(Object(o),!0)).call(i,(function(e){zf(t,e,o[e])})):Uc?iu(t,Uc(o)):Cv(n=YI(Object(o))).call(n,(function(e){fu(t,e,Dc(o,e))}))}return t}function GI(t){var e=function(){if("undefined"==typeof Reflect||!jI)return!1;if(jI.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(jI(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=AO(t);if(e){var o=AO(this).constructor;i=jI(n,arguments,o)}else i=n.apply(this,arguments);return DO(this,i)}}function KI(t,e){var i=void 0!==Op&&xh(t)||t["@@iterator"];if(!i){if(Wp(t)||(i=function(t,e){var i;if(!t)return;if("string"==typeof t)return $I(t,e);var n=Fp(i=Object.prototype.toString.call(t)).call(i,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return Za(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return $I(t,e)}(t))||e&&t&&"number"==typeof t.length){i&&(t=i);var n=0,o=function(){};return{s:o,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var r,s=!0,a=!1;return{s:function(){i=i.call(t)},n:function(){var t=i.next();return s=t.done,t},e:function(t){a=!0,r=t},f:function(){try{s||null==i.return||i.return()}finally{if(a)throw r}}}}function $I(t,e){(null==e||e>t.length)&&(e=t.length);for(var i=0,n=new Array(e);i<e;i++)n[i]=t[i];return n}var ZI=function(){function t(e,i,n){var o,r,s;pu(this,t),zf(this,"_source",void 0),zf(this,"_transformers",void 0),zf(this,"_target",void 0),zf(this,"_listeners",{add:Yn(o=this._add).call(o,this),remove:Yn(r=this._remove).call(r,this),update:Yn(s=this._update).call(s,this)}),this._source=e,this._transformers=i,this._target=n}return Nf(t,[{key:"all",value:function(){return this._target.update(this._transformItems(this._source.get())),this}},{key:"start",value:function(){return this._source.on("add",this._listeners.add),this._source.on("remove",this._listeners.remove),this._source.on("update",this._listeners.update),this}},{key:"stop",value:function(){return this._source.off("add",this._listeners.add),this._source.off("remove",this._listeners.remove),this._source.off("update",this._listeners.update),this}},{key:"_transformItems",value:function(t){var e;return EP(e=this._transformers).call(e,(function(t,e){return e(t)}),t)}},{key:"_add",value:function(t,e){null!=e&&this._target.add(this._transformItems(this._source.get(e.items)))}},{key:"_update",value:function(t,e){null!=e&&this._target.update(this._transformItems(this._source.get(e.items)))}},{key:"_remove",value:function(t,e){null!=e&&this._target.remove(this._transformItems(e.oldData))}}]),t}(),QI=function(){function t(e){pu(this,t),zf(this,"_source",void 0),zf(this,"_transformers",[]),this._source=e}return Nf(t,[{key:"filter",value:function(t){return this._transformers.push((function(e){return ny(e).call(e,t)})),this}},{key:"map",value:function(t){return this._transformers.push((function(e){return Qp(e).call(e,t)})),this}},{key:"flatMap",value:function(t){return this._transformers.push((function(e){return qP(e).call(e,t)})),this}},{key:"to",value:function(t){return new ZI(this._source,this._transformers,t)}}]),t}();function JI(t){return"string"==typeof t||"number"==typeof t}var tB=function(){function t(e){pu(this,t),zf(this,"delay",void 0),zf(this,"max",void 0),zf(this,"_queue",[]),zf(this,"_timeout",null),zf(this,"_extended",null),this.delay=null,this.max=1/0,this.setOptions(e)}return Nf(t,[{key:"setOptions",value:function(t){t&&void 0!==t.delay&&(this.delay=t.delay),t&&void 0!==t.max&&(this.max=t.max),this._flushIfNeeded()}},{key:"destroy",value:function(){if(this.flush(),this._extended){for(var t=this._extended.object,e=this._extended.methods,i=0;i<e.length;i++){var n=e[i];n.original?t[n.name]=n.original:delete t[n.name]}this._extended=null}}},{key:"replace",value:function(t,e){var i=this,n=t[e];if(!n)throw new Error("Method "+e+" undefined");t[e]=function(){for(var t=arguments.length,e=new Array(t),o=0;o<t;o++)e[o]=arguments[o];i.queue({args:e,fn:n,context:this})}}},{key:"queue",value:function(t){"function"==typeof t?this._queue.push({fn:t}):this._queue.push(t),this._flushIfNeeded()}},{key:"_flushIfNeeded",value:function(){var t=this;this._queue.length>this.max&&this.flush(),null!=this._timeout&&(clearTimeout(this._timeout),this._timeout=null),this.queue.length>0&&"number"==typeof this.delay&&(this._timeout=Gm((function(){t.flush()}),this.delay))}},{key:"flush",value:function(){var t,e;Cv(t=vg(e=this._queue).call(e,0)).call(t,(function(t){t.fn.apply(t.context||t.fn,t.args||[])}))}}],[{key:"extend",value:function(e,i){var n=new t(i);if(void 0!==e.flush)throw new Error("Target object already has a property flush");e.flush=function(){n.flush()};var o=[{name:"flush",original:void 0}];if(i&&i.replace)for(var r=0;r<i.replace.length;r++){var s=i.replace[r];o.push({name:s,original:e[s]}),n.replace(e,s)}return n._extended={object:e,methods:o},n}}]),t}(),eB=function(){function t(){pu(this,t),zf(this,"_subscribers",{"*":[],add:[],remove:[],update:[]}),zf(this,"subscribe",t.prototype.on),zf(this,"unsubscribe",t.prototype.off)}return Nf(t,[{key:"_trigger",value:function(t,e,i){var n,o;if("*"===t)throw new Error("Cannot trigger event *");Cv(n=Np(o=[]).call(o,_p(this._subscribers[t]),_p(this._subscribers["*"]))).call(n,(function(n){n(t,e,null!=i?i:null)}))}},{key:"on",value:function(t,e){"function"==typeof e&&this._subscribers[t].push(e)}},{key:"off",value:function(t,e){var i;this._subscribers[t]=ny(i=this._subscribers[t]).call(i,(function(t){return t!==e}))}}]),t}();qI=KP;var iB=function(){function t(e){pu(this,t),zf(this,"_pairs",void 0),this._pairs=e}return Nf(t,[{key:qI,value:hP.mark((function t(){var e,i,n,o,r;return hP.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=KI(this._pairs),t.prev=1,e.s();case 3:if((i=e.n()).done){t.next=9;break}return n=kp(i.value,2),o=n[0],r=n[1],t.next=7,[o,r];case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"entries",value:hP.mark((function t(){var e,i,n,o,r;return hP.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=KI(this._pairs),t.prev=1,e.s();case 3:if((i=e.n()).done){t.next=9;break}return n=kp(i.value,2),o=n[0],r=n[1],t.next=7,[o,r];case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"keys",value:hP.mark((function t(){var e,i,n,o;return hP.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=KI(this._pairs),t.prev=1,e.s();case 3:if((i=e.n()).done){t.next=9;break}return n=kp(i.value,1),o=n[0],t.next=7,o;case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"values",value:hP.mark((function t(){var e,i,n,o;return hP.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=KI(this._pairs),t.prev=1,e.s();case 3:if((i=e.n()).done){t.next=9;break}return n=kp(i.value,2),o=n[1],t.next=7,o;case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"toIdArray",value:function(){var t;return Qp(t=_p(this._pairs)).call(t,(function(t){return t[0]}))}},{key:"toItemArray",value:function(){var t;return Qp(t=_p(this._pairs)).call(t,(function(t){return t[1]}))}},{key:"toEntryArray",value:function(){return _p(this._pairs)}},{key:"toObjectMap",value:function(){var t,e=mm(null),i=KI(this._pairs);try{for(i.s();!(t=i.n()).done;){var n=kp(t.value,2),o=n[0],r=n[1];e[o]=r}}catch(t){i.e(t)}finally{i.f()}return e}},{key:"toMap",value:function(){return new VE(this._pairs)}},{key:"toIdSet",value:function(){return new XP(this.toIdArray())}},{key:"toItemSet",value:function(){return new XP(this.toItemArray())}},{key:"cache",value:function(){return new t(_p(this._pairs))}},{key:"distinct",value:function(t){var e,i=new XP,n=KI(this._pairs);try{for(n.s();!(e=n.n()).done;){var o=kp(e.value,2),r=o[0],s=o[1];i.add(t(s,r))}}catch(t){n.e(t)}finally{n.f()}return i}},{key:"filter",value:function(e){var i=this._pairs;return new t(zf({},KP,hP.mark((function t(){var n,o,r,s,a;return hP.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:n=KI(i),t.prev=1,n.s();case 3:if((o=n.n()).done){t.next=10;break}if(r=kp(o.value,2),s=r[0],a=r[1],!e(a,s)){t.next=8;break}return t.next=8,[s,a];case 8:t.next=3;break;case 10:t.next=15;break;case 12:t.prev=12,t.t0=t.catch(1),n.e(t.t0);case 15:return t.prev=15,n.f(),t.finish(15);case 18:case"end":return t.stop()}}),t,null,[[1,12,15,18]])}))))}},{key:"forEach",value:function(t){var e,i=KI(this._pairs);try{for(i.s();!(e=i.n()).done;){var n=kp(e.value,2),o=n[0];t(n[1],o)}}catch(t){i.e(t)}finally{i.f()}}},{key:"map",value:function(e){var i=this._pairs;return new t(zf({},KP,hP.mark((function t(){var n,o,r,s,a;return hP.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:n=KI(i),t.prev=1,n.s();case 3:if((o=n.n()).done){t.next=9;break}return r=kp(o.value,2),s=r[0],a=r[1],t.next=7,[s,e(a,s)];case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),n.e(t.t0);case 14:return t.prev=14,n.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,null,[[1,11,14,17]])}))))}},{key:"max",value:function(t){var e=tD(this._pairs),i=e.next();if(i.done)return null;for(var n=i.value[1],o=t(i.value[1],i.value[0]);!(i=e.next()).done;){var r=kp(i.value,2),s=r[0],a=r[1],h=t(a,s);h>o&&(o=h,n=a)}return n}},{key:"min",value:function(t){var e=tD(this._pairs),i=e.next();if(i.done)return null;for(var n=i.value[1],o=t(i.value[1],i.value[0]);!(i=e.next()).done;){var r=kp(i.value,2),s=r[0],a=r[1],h=t(a,s);h<o&&(o=h,n=a)}return n}},{key:"reduce",value:function(t,e){var i,n=KI(this._pairs);try{for(n.s();!(i=n.n()).done;){var o=kp(i.value,2),r=o[0];e=t(e,o[1],r)}}catch(t){n.e(t)}finally{n.f()}return e}},{key:"sort",value:function(e){var i=this;return new t(zf({},KP,(function(){var t;return tD(HD(t=_p(i._pairs)).call(t,(function(t,i){var n=kp(t,2),o=n[0],r=n[1],s=kp(i,2),a=s[0],h=s[1];return e(r,h,o,a)})))})))}}]),t}();var nB=function(t){PO(i,t);var e=GI(i);function i(t,n){var o;return pu(this,i),zf(uO(o=e.call(this)),"flush",void 0),zf(uO(o),"length",void 0),zf(uO(o),"_options",void 0),zf(uO(o),"_data",void 0),zf(uO(o),"_idProp",void 0),zf(uO(o),"_queue",null),t&&!Wp(t)&&(n=t,t=[]),o._options=n||{},o._data=new VE,o.length=0,o._idProp=o._options.fieldId||"id",t&&t.length&&o.add(t),o.setOptions(n),o}return Nf(i,[{key:"idProp",get:function(){return this._idProp}},{key:"setOptions",value:function(t){t&&void 0!==t.queue&&(!1===t.queue?this._queue&&(this._queue.destroy(),this._queue=null):(this._queue||(this._queue=tB.extend(this,{replace:["add","update","remove"]})),t.queue&&"object"===Of(t.queue)&&this._queue.setOptions(t.queue)))}},{key:"add",value:function(t,e){var i,n=this,o=[];if(Wp(t)){var r=Qp(t).call(t,(function(t){return t[n._idProp]}));if(cO(r).call(r,(function(t){return n._data.has(t)})))throw new Error("A duplicate id was found in the parameter array.");for(var s=0,a=t.length;s<a;s++)i=this._addItem(t[s]),o.push(i)}else{if(!t||"object"!==Of(t))throw new Error("Unknown dataType");i=this._addItem(t),o.push(i)}return o.length&&this._trigger("add",{items:o},e),o}},{key:"update",value:function(t,e){var i=this,n=[],o=[],r=[],s=[],a=this._idProp,h=function(t){var e=t[a];if(null!=e&&i._data.has(e)){var h=t,l=xn({},i._data.get(e)),d=i._updateItem(h);o.push(d),s.push(h),r.push(l)}else{var c=i._addItem(t);n.push(c)}};if(Wp(t))for(var l=0,d=t.length;l<d;l++)t[l]&&"object"===Of(t[l])?h(t[l]):console.warn("Ignoring input item, which is not an object at index "+l);else{if(!t||"object"!==Of(t))throw new Error("Unknown dataType");h(t)}if(n.length&&this._trigger("add",{items:n},e),o.length){var c={items:o,oldData:r,data:s};this._trigger("update",c,e)}return Np(n).call(n,o)}},{key:"updateOnly",value:function(t,e){var i,n=this;Wp(t)||(t=[t]);var o=Qp(i=Qp(t).call(t,(function(t){var e=n._data.get(t[n._idProp]);if(null==e)throw new Error("Updating non-existent items is not allowed.");return{oldData:e,update:t}}))).call(i,(function(t){var e=t.oldData,i=t.update,o=e[n._idProp],r=_x(e,i);return n._data.set(o,r),{id:o,oldData:e,updatedData:r}}));if(o.length){var r={items:Qp(o).call(o,(function(t){return t.id})),oldData:Qp(o).call(o,(function(t){return t.oldData})),data:Qp(o).call(o,(function(t){return t.updatedData}))};return this._trigger("update",r,e),r.items}return[]}},{key:"get",value:function(t,e){var i=void 0,n=void 0,o=void 0;JI(t)?(i=t,o=e):Wp(t)?(n=t,o=e):o=t;var r,s=o&&"Object"===o.returnType?"Object":"Array",a=o&&ny(o),h=[],l=void 0,d=void 0,c=void 0;if(null!=i)(l=this._data.get(i))&&a&&!a(l)&&(l=void 0);else if(null!=n)for(var u=0,f=n.length;u<f;u++)null==(l=this._data.get(n[u]))||a&&!a(l)||h.push(l);else for(var p,v=0,g=(d=_p(QD(p=this._data).call(p))).length;v<g;v++)c=d[v],null==(l=this._data.get(c))||a&&!a(l)||h.push(l);if(o&&o.order&&null==i&&this._sort(h,o.order),o&&o.fields){var y=o.fields;if(null!=i&&null!=l)l=this._filterFields(l,y);else for(var m=0,b=h.length;m<b;m++)h[m]=this._filterFields(h[m],y)}if("Object"==s){for(var w={},x=0,k=h.length;x<k;x++){var _=h[x];w[_[this._idProp]]=_}return w}return null!=i?null!==(r=l)&&void 0!==r?r:null:h}},{key:"getIds",value:function(t){var e=this._data,i=t&&ny(t),n=t&&t.order,o=_p(QD(e).call(e)),r=[];if(i)if(n){for(var s=[],a=0,h=o.length;a<h;a++){var l=o[a],d=this._data.get(l);null!=d&&i(d)&&s.push(d)}this._sort(s,n);for(var c=0,u=s.length;c<u;c++)r.push(s[c][this._idProp])}else for(var f=0,p=o.length;f<p;f++){var v=o[f],g=this._data.get(v);null!=g&&i(g)&&r.push(g[this._idProp])}else if(n){for(var y=[],m=0,b=o.length;m<b;m++){var w=o[m];y.push(e.get(w))}this._sort(y,n);for(var x=0,k=y.length;x<k;x++)r.push(y[x][this._idProp])}else for(var _=0,E=o.length;_<E;_++){var O=o[_],C=e.get(O);null!=C&&r.push(C[this._idProp])}return r}},{key:"getDataSet",value:function(){return this}},{key:"forEach",value:function(t,e){var i=e&&ny(e),n=this._data,o=_p(QD(n).call(n));if(e&&e.order)for(var r=this.get(e),s=0,a=r.length;s<a;s++){var h=r[s];t(h,h[this._idProp])}else for(var l=0,d=o.length;l<d;l++){var c=o[l],u=this._data.get(c);null==u||i&&!i(u)||t(u,c)}}},{key:"map",value:function(t,e){for(var i=e&&ny(e),n=[],o=this._data,r=_p(QD(o).call(o)),s=0,a=r.length;s<a;s++){var h=r[s],l=this._data.get(h);null==l||i&&!i(l)||n.push(t(l,h))}return e&&e.order&&this._sort(n,e.order),n}},{key:"_filterFields",value:function(t,e){var i;return t?EP(i=Wp(e)?e:ov(e)).call(i,(function(e,i){return e[i]=t[i],e}),{}):t}},{key:"_sort",value:function(t,e){if("string"==typeof e){var i=e;HD(t).call(t,(function(t,e){var n=t[i],o=e[i];return n>o?1:n<o?-1:0}))}else{if("function"!=typeof e)throw new TypeError("Order must be a function or a string");HD(t).call(t,e)}}},{key:"remove",value:function(t,e){for(var i=[],n=[],o=Wp(t)?t:[t],r=0,s=o.length;r<s;r++){var a=this._remove(o[r]);if(a){var h=a[this._idProp];null!=h&&(i.push(h),n.push(a))}}return i.length&&this._trigger("remove",{items:i,oldData:n},e),i}},{key:"_remove",value:function(t){var e;if(JI(t)?e=t:t&&"object"===Of(t)&&(e=t[this._idProp]),null!=e&&this._data.has(e)){var i=this._data.get(e)||null;return this._data.delete(e),--this.length,i}return null}},{key:"clear",value:function(t){for(var e,i=_p(QD(e=this._data).call(e)),n=[],o=0,r=i.length;o<r;o++)n.push(this._data.get(i[o]));return this._data.clear(),this.length=0,this._trigger("remove",{items:i,oldData:n},t),i}},{key:"max",value:function(t){var e,i,n=null,o=null,r=KI(lI(e=this._data).call(e));try{for(r.s();!(i=r.n()).done;){var s=i.value,a=s[t];"number"==typeof a&&(null==o||a>o)&&(n=s,o=a)}}catch(t){r.e(t)}finally{r.f()}return n||null}},{key:"min",value:function(t){var e,i,n=null,o=null,r=KI(lI(e=this._data).call(e));try{for(r.s();!(i=r.n()).done;){var s=i.value,a=s[t];"number"==typeof a&&(null==o||a<o)&&(n=s,o=a)}}catch(t){r.e(t)}finally{r.f()}return n||null}},{key:"distinct",value:function(t){for(var e=this._data,i=_p(QD(e).call(e)),n=[],o=0,r=0,s=i.length;r<s;r++){for(var a=i[r],h=e.get(a)[t],l=!1,d=0;d<o;d++)if(n[d]==h){l=!0;break}l||void 0===h||(n[o]=h,o++)}return n}},{key:"_addItem",value:function(t){var e=function(t,e){return null==t[e]&&(t[e]=UI()),t}(t,this._idProp),i=e[this._idProp];if(this._data.has(i))throw new Error("Cannot add item: item with id "+i+" already exists");return this._data.set(i,e),++this.length,i}},{key:"_updateItem",value:function(t){var e=t[this._idProp];if(null==e)throw new Error("Cannot update item: item has no id (item: "+Om(t)+")");var i=this._data.get(e);if(!i)throw new Error("Cannot update item: no item with id "+e+" found");return this._data.set(e,XI(XI({},i),t)),e}},{key:"stream",value:function(t){if(t){var e=this._data;return new iB(zf({},KP,hP.mark((function i(){var n,o,r,s;return hP.wrap((function(i){for(;;)switch(i.prev=i.next){case 0:n=KI(t),i.prev=1,n.s();case 3:if((o=n.n()).done){i.next=11;break}if(r=o.value,null==(s=e.get(r))){i.next=9;break}return i.next=9,[r,s];case 9:i.next=3;break;case 11:i.next=16;break;case 13:i.prev=13,i.t0=i.catch(1),n.e(i.t0);case 16:return i.prev=16,n.f(),i.finish(16);case 19:case"end":return i.stop()}}),i,null,[[1,13,16,19]])}))))}var i;return new iB(zf({},KP,Yn(i=wI(this._data)).call(i,this._data)))}}]),i}(eB),oB=function(t){PO(i,t);var e=GI(i);function i(t,n){var o,r;return pu(this,i),zf(uO(r=e.call(this)),"length",0),zf(uO(r),"_listener",void 0),zf(uO(r),"_data",void 0),zf(uO(r),"_ids",new XP),zf(uO(r),"_options",void 0),r._options=n||{},r._listener=Yn(o=r._onEvent).call(o,uO(r)),r.setData(t),r}return Nf(i,[{key:"idProp",get:function(){return this.getDataSet().idProp}},{key:"setData",value:function(t){if(this._data){this._data.off&&this._data.off("*",this._listener);var e=this._data.getIds({filter:ny(this._options)}),i=this._data.get(e);this._ids.clear(),this.length=0,this._trigger("remove",{items:e,oldData:i})}if(null!=t){this._data=t;for(var n=this._data.getIds({filter:ny(this._options)}),o=0,r=n.length;o<r;o++){var s=n[o];this._ids.add(s)}this.length=n.length,this._trigger("add",{items:n})}else this._data=new nB;this._data.on&&this._data.on("*",this._listener)}},{key:"refresh",value:function(){for(var t=this._data.getIds({filter:ny(this._options)}),e=_p(this._ids),i={},n=[],o=[],r=[],s=0,a=t.length;s<a;s++){var h=t[s];i[h]=!0,this._ids.has(h)||(n.push(h),this._ids.add(h))}for(var l=0,d=e.length;l<d;l++){var c=e[l],u=this._data.get(c);null==u?console.error("If you see this, report it please."):i[c]||(o.push(c),r.push(u),this._ids.delete(c))}this.length+=n.length-o.length,n.length&&this._trigger("add",{items:n}),o.length&&this._trigger("remove",{items:o,oldData:r})}},{key:"get",value:function(t,e){if(null==this._data)return null;var i,n=null;JI(t)||Wp(t)?(n=t,i=e):i=t;var o=xn({},this._options,i),r=ny(this._options),s=i&&ny(i);return r&&s&&(o.filter=function(t){return r(t)&&s(t)}),null==n?this._data.get(o):this._data.get(n,o)}},{key:"getIds",value:function(t){if(this._data.length){var e,i=ny(this._options),n=null!=t?ny(t):null;return e=n?i?function(t){return i(t)&&n(t)}:n:i,this._data.getIds({filter:e,order:t&&t.order})}return[]}},{key:"forEach",value:function(t,e){if(this._data){var i,n,o=ny(this._options),r=e&&ny(e);n=r?o?function(t){return o(t)&&r(t)}:r:o,Cv(i=this._data).call(i,t,{filter:n,order:e&&e.order})}}},{key:"map",value:function(t,e){if(this._data){var i,n,o=ny(this._options),r=e&&ny(e);return n=r?o?function(t){return o(t)&&r(t)}:r:o,Qp(i=this._data).call(i,t,{filter:n,order:e&&e.order})}return[]}},{key:"getDataSet",value:function(){return this._data.getDataSet()}},{key:"stream",value:function(t){var e;return this._data.stream(t||zf({},KP,Yn(e=QD(this._ids)).call(e,this._ids)))}},{key:"dispose",value:function(){var t;null!==(t=this._data)&&void 0!==t&&t.off&&this._data.off("*",this._listener);var e,n="This data view has already been disposed of.",o={get:function(){throw new Error(n)},set:function(){throw new Error(n)},configurable:!1},r=KI(Lp(i.prototype));try{for(r.s();!(e=r.n()).done;){var s=e.value;fu(this,s,o)}}catch(t){r.e(t)}finally{r.f()}}},{key:"_onEvent",value:function(t,e,i){if(e&&e.items&&this._data){var n=e.items,o=[],r=[],s=[],a=[],h=[],l=[];switch(t){case"add":for(var d=0,c=n.length;d<c;d++){var u=n[d];this.get(u)&&(this._ids.add(u),o.push(u))}break;case"update":for(var f=0,p=n.length;f<p;f++){var v=n[f];this.get(v)?this._ids.has(v)?(r.push(v),h.push(e.data[f]),a.push(e.oldData[f])):(this._ids.add(v),o.push(v)):this._ids.has(v)&&(this._ids.delete(v),s.push(v),l.push(e.oldData[f]))}break;case"remove":for(var g=0,y=n.length;g<y;g++){var m=n[g];this._ids.has(m)&&(this._ids.delete(m),s.push(m),l.push(e.oldData[g]))}}this.length+=o.length-s.length,o.length&&this._trigger("add",{items:o},i),r.length&&this._trigger("update",{items:r,oldData:a,data:h},i),s.length&&this._trigger("remove",{items:s,oldData:l},i)}}}]),i}(eB);function rB(t,e){return"object"===Of(e)&&null!==e&&t===e.idProp&&"function"==typeof e.add&&"function"==typeof e.clear&&"function"==typeof e.distinct&&"function"==typeof Cv(e)&&"function"==typeof e.get&&"function"==typeof e.getDataSet&&"function"==typeof e.getIds&&"number"==typeof e.length&&"function"==typeof Qp(e)&&"function"==typeof e.max&&"function"==typeof e.min&&"function"==typeof e.off&&"function"==typeof e.on&&"function"==typeof e.remove&&"function"==typeof e.setOptions&&"function"==typeof e.stream&&"function"==typeof e.update&&"function"==typeof e.updateOnly}function sB(t,e){return"object"===Of(e)&&null!==e&&t===e.idProp&&"function"==typeof Cv(e)&&"function"==typeof e.get&&"function"==typeof e.getDataSet&&"function"==typeof e.getIds&&"number"==typeof e.length&&"function"==typeof Qp(e)&&"function"==typeof e.off&&"function"==typeof e.on&&"function"==typeof e.stream&&rB(t,e.getDataSet())}var aB=Object.freeze({__proto__:null,DELETE:kx,DataSet:nB,DataStream:iB,DataView:oB,Queue:tB,createNewDataPipeFrom:function(t){return new QI(t)},isDataSetLike:rB,isDataViewLike:sB}),hB={},lB={get exports(){return hB},set exports(t){hB=t}},dB=s,cB=a,uB=mo,fB=Cy.trim,pB=my,vB=m("".charAt),gB=dB.parseFloat,yB=dB.Symbol,mB=yB&&yB.iterator,bB=1/gB(pB+"-0")!=-1/0||mB&&!cB((function(){gB(Object(mB))}))?function(t){var e=fB(uB(t)),i=gB(e);return 0===i&&"-"==vB(e,0)?-0:i}:gB;Mi({global:!0,forced:parseFloat!=bB},{parseFloat:bB});var wB=nt.parseFloat;!function(t){t.exports=wB}(lB);var xB=i(hB),kB={},_B={get exports(){return kB},set exports(t){kB=t}},EB=Mi,OB=a,CB=Sh.f;EB({target:"Object",stat:!0,forced:OB((function(){return!Object.getOwnPropertyNames(1)}))},{getOwnPropertyNames:CB});var SB=nt.Object,TB=function(t){return SB.getOwnPropertyNames(t)},MB=TB;!function(t){t.exports=MB}(_B);var PB=i(kB);function DB(t,e){var i=["node","edge","label"],n=!0,o=gk(e,"chosen");if("boolean"==typeof o)n=o;else if("object"===Of(o)){if(-1===tm(i).call(i,t))throw new Error("choosify: subOption '"+t+"' should be one of '"+i.join("', '")+"'");var r=gk(e,["chosen",t]);"boolean"!=typeof r&&"function"!=typeof r||(n=r)}return n}function IB(t,e,i){if(t.width<=0||t.height<=0)return!1;if(void 0!==i){var n={x:e.x-i.x,y:e.y-i.y};if(0!==i.angle){var o=-i.angle;e={x:Math.cos(o)*n.x-Math.sin(o)*n.y,y:Math.sin(o)*n.x+Math.cos(o)*n.y}}else e=n}var r=t.x+t.width,s=t.y+t.width;return t.left<e.x&&r>e.x&&t.top<e.y&&s>e.y}function BB(t){return"string"==typeof t&&""!==t}function NB(t,e,i,n){var o=n.x,r=n.y;if("function"==typeof n.distanceToBorder){var s=n.distanceToBorder(t,e),a=Math.sin(e)*s,h=Math.cos(e)*s;h===s?(o+=s,r=n.y):a===s?(o=n.x,r-=s):(o+=h,r-=a)}else n.shape.width>n.shape.height?(o=n.x+.5*n.shape.width,r=n.y-i):(o=n.x+i,r=n.y-.5*n.shape.height);return{x:o,y:r}}var zB=function(){function t(e){pu(this,t),this.measureText=e,this.current=0,this.width=0,this.height=0,this.lines=[]}return Nf(t,[{key:"_add",value:function(t,e){var i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:"normal";void 0===this.lines[t]&&(this.lines[t]={width:0,height:0,blocks:[]});var n=e;void 0!==e&&""!==e||(n=" ");var o=this.measureText(n,i),r=xn({},lI(o));r.text=e,r.width=o.width,r.mod=i,void 0!==e&&""!==e||(r.width=0),this.lines[t].blocks.push(r),this.lines[t].width+=r.width}},{key:"curWidth",value:function(){var t=this.lines[this.current];return void 0===t?0:t.width}},{key:"append",value:function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:"normal";this._add(this.current,t,e)}},{key:"newLine",value:function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:"normal";this._add(this.current,t,e),this.current++}},{key:"determineLineHeights",value:function(){for(var t=0;t<this.lines.length;t++){var e=this.lines[t],i=0;if(void 0!==e.blocks)for(var n=0;n<e.blocks.length;n++){var o=e.blocks[n];i<o.height&&(i=o.height)}e.height=i}}},{key:"determineLabelSize",value:function(){for(var t=0,e=0,i=0;i<this.lines.length;i++){var n=this.lines[i];n.width>t&&(t=n.width),e+=n.height}this.width=t,this.height=e}},{key:"removeEmptyBlocks",value:function(){for(var t=[],e=0;e<this.lines.length;e++){var i=this.lines[e];if(0!==i.blocks.length&&(e!==this.lines.length-1||0!==i.width)){var n={};xn(n,i),n.blocks=[];for(var o=void 0,r=[],s=0;s<i.blocks.length;s++){var a=i.blocks[s];0!==a.width?r.push(a):void 0===o&&(o=a)}0===r.length&&void 0!==o&&r.push(o),n.blocks=r,t.push(n)}}return t}},{key:"finalize",value:function(){this.determineLineHeights(),this.determineLabelSize();var t=this.removeEmptyBlocks();return{width:this.width,height:this.height,lines:t}}}]),t}(),FB={"<b>":/<b>/,"<i>":/<i>/,"<code>":/<code>/,"</b>":/<\/b>/,"</i>":/<\/i>/,"</code>":/<\/code>/,"*":/\*/,_:/_/,"`":/`/,afterBold:/[^*]/,afterItal:/[^_]/,afterMono:/[^`]/},AB=function(){function t(e){pu(this,t),this.text=e,this.bold=!1,this.ital=!1,this.mono=!1,this.spacing=!1,this.position=0,this.buffer="",this.modStack=[],this.blocks=[]}return Nf(t,[{key:"mod",value:function(){return 0===this.modStack.length?"normal":this.modStack[0]}},{key:"modName",value:function(){return 0===this.modStack.length?"normal":"mono"===this.modStack[0]?"mono":this.bold&&this.ital?"boldital":this.bold?"bold":this.ital?"ital":void 0}},{key:"emitBlock",value:function(){this.spacing&&(this.add(" "),this.spacing=!1),this.buffer.length>0&&(this.blocks.push({text:this.buffer,mod:this.modName()}),this.buffer="")}},{key:"add",value:function(t){" "===t&&(this.spacing=!0),this.spacing&&(this.buffer+=" ",this.spacing=!1)," "!=t&&(this.buffer+=t)}},{key:"parseWS",value:function(t){return!!/[ \t]/.test(t)&&(this.mono?this.add(t):this.spacing=!0,!0)}},{key:"setTag",value:function(t){this.emitBlock(),this[t]=!0,this.modStack.unshift(t)}},{key:"unsetTag",value:function(t){this.emitBlock(),this[t]=!1,this.modStack.shift()}},{key:"parseStartTag",value:function(t,e){return!(this.mono||this[t]||!this.match(e))&&(this.setTag(t),!0)}},{key:"match",value:function(t){var e=!(arguments.length>1&&void 0!==arguments[1])||arguments[1],i=kp(this.prepareRegExp(t),2),n=i[0],o=i[1],r=n.test(this.text.substr(this.position,o));return r&&e&&(this.position+=o-1),r}},{key:"parseEndTag",value:function(t,e,i){var n=this.mod()===t;return!(!(n="mono"===t?n&&this.mono:n&&!this.mono)||!this.match(e))&&(void 0!==i?(this.position===this.text.length-1||this.match(i,!1))&&this.unsetTag(t):this.unsetTag(t),!0)}},{key:"replace",value:function(t,e){return!!this.match(t)&&(this.add(e),this.position+=length-1,!0)}},{key:"prepareRegExp",value:function(t){var e,i;if(t instanceof RegExp)i=t,e=1;else{var n=FB[t];i=void 0!==n?n:new RegExp(t),e=t.length}return[i,e]}}]),t}(),jB=function(){function t(e,i,n,o){var r=this;pu(this,t),this.ctx=e,this.parent=i,this.selected=n,this.hover=o;this.lines=new zB((function(t,i){if(void 0===t)return 0;var s=r.parent.getFormattingValues(e,n,o,i),a=0;""!==t&&(a=r.ctx.measureText(t).width);return{width:a,values:s}}))}return Nf(t,[{key:"process",value:function(t){if(!BB(t))return this.lines.finalize();var e=this.parent.fontOptions;t=(t=t.replace(/\r\n/g,"\n")).replace(/\r/g,"\n");var i=String(t).split("\n"),n=i.length;if(e.multi)for(var o=0;o<n;o++){var r=this.splitBlocks(i[o],e.multi);if(void 0!==r)if(0!==r.length){if(e.maxWdt>0)for(var s=0;s<r.length;s++){var a=r[s].mod,h=r[s].text;this.splitStringIntoLines(h,a,!0)}else for(var l=0;l<r.length;l++){var d=r[l].mod,c=r[l].text;this.lines.append(c,d)}this.lines.newLine()}else this.lines.newLine("")}else if(e.maxWdt>0)for(var u=0;u<n;u++)this.splitStringIntoLines(i[u]);else for(var f=0;f<n;f++)this.lines.newLine(i[f]);return this.lines.finalize()}},{key:"decodeMarkupSystem",value:function(t){var e="none";return"markdown"===t||"md"===t?e="markdown":!0!==t&&"html"!==t||(e="html"),e}},{key:"splitHtmlBlocks",value:function(t){for(var e=new AB(t),i=function(t){return!!/&/.test(t)&&(e.replace(e.text,"&lt;","<")||e.replace(e.text,"&amp;","&")||e.add("&"),!0)};e.position<e.text.length;){var n=e.text.charAt(e.position);e.parseWS(n)||/</.test(n)&&(e.parseStartTag("bold","<b>")||e.parseStartTag("ital","<i>")||e.parseStartTag("mono","<code>")||e.parseEndTag("bold","</b>")||e.parseEndTag("ital","</i>")||e.parseEndTag("mono","</code>"))||i(n)||e.add(n),e.position++}return e.emitBlock(),e.blocks}},{key:"splitMarkdownBlocks",value:function(t){for(var e=this,i=new AB(t),n=!0,o=function(t){return!!/\\/.test(t)&&(i.position<e.text.length+1&&(i.position++,t=e.text.charAt(i.position),/ \t/.test(t)?i.spacing=!0:(i.add(t),n=!1)),!0)};i.position<i.text.length;){var r=i.text.charAt(i.position);i.parseWS(r)||o(r)||(n||i.spacing)&&(i.parseStartTag("bold","*")||i.parseStartTag("ital","_")||i.parseStartTag("mono","`"))||i.parseEndTag("bold","*","afterBold")||i.parseEndTag("ital","_","afterItal")||i.parseEndTag("mono","`","afterMono")||(i.add(r),n=!1),i.position++}return i.emitBlock(),i.blocks}},{key:"splitBlocks",value:function(t,e){var i=this.decodeMarkupSystem(e);return"none"===i?[{text:t,mod:"normal"}]:"markdown"===i?this.splitMarkdownBlocks(t):"html"===i?this.splitHtmlBlocks(t):void 0}},{key:"overMaxWidth",value:function(t){var e=this.ctx.measureText(t).width;return this.lines.curWidth()+e>this.parent.fontOptions.maxWdt}},{key:"getLongestFit",value:function(t){for(var e="",i=0;i<t.length;){var n=e+(""===e?"":" ")+t[i];if(this.overMaxWidth(n))break;e=n,i++}return i}},{key:"getLongestFitWord",value:function(t){for(var e=0;e<t.length&&!this.overMaxWidth(Fp(t).call(t,0,e));)e++;return e}},{key:"splitStringIntoLines",value:function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:"normal",i=arguments.length>2&&void 0!==arguments[2]&&arguments[2];this.parent.getFormattingValues(this.ctx,this.selected,this.hover,e);for(var n=(t=(t=t.replace(/^( +)/g,"$1\r")).replace(/([^\r][^ ]*)( +)/g,"$1\r$2\r")).split("\r");n.length>0;){var o=this.getLongestFit(n);if(0===o){var r=n[0],s=this.getLongestFitWord(r);this.lines.newLine(Fp(r).call(r,0,s),e),n[0]=Fp(r).call(r,s)}else{var a=o;" "===n[o-1]?o--:" "===n[a]&&a++;var h=Fp(n).call(n,0,o).join("");o==n.length&&i?this.lines.append(h,e):this.lines.newLine(h,e),n=Fp(n).call(n,a)}}}}]),t}(),RB=["bold","ital","boldital","mono"],LB=function(){function t(e,i){var n=arguments.length>2&&void 0!==arguments[2]&&arguments[2];pu(this,t),this.body=e,this.pointToSelf=!1,this.baseSize=void 0,this.fontOptions={},this.setOptions(i),this.size={top:0,left:0,width:0,height:0,yLine:0},this.isEdgeLabel=n}return Nf(t,[{key:"setOptions",value:function(t){if(this.elementOptions=t,this.initFontOptions(t.font),BB(t.label)?this.labelDirty=!0:t.label=void 0,void 0!==t.font&&null!==t.font)if("string"==typeof t.font)this.baseSize=this.fontOptions.size;else if("object"===Of(t.font)){var e=t.font.size;void 0!==e&&(this.baseSize=e)}}},{key:"initFontOptions",value:function(e){var i=this;$x(RB,(function(t){i.fontOptions[t]={}})),t.parseFontString(this.fontOptions,e)?this.fontOptions.vadjust=0:$x(e,(function(t,e){null!=t&&"object"!==Of(t)&&(i.fontOptions[e]=t)}))}},{key:"constrain",value:function(t){var e={constrainWidth:!1,maxWdt:-1,minWdt:-1,constrainHeight:!1,minHgt:-1,valign:"middle"},i=gk(t,"widthConstraint");if("number"==typeof i)e.maxWdt=Number(i),e.minWdt=Number(i);else if("object"===Of(i)){var n=gk(t,["widthConstraint","maximum"]);"number"==typeof n&&(e.maxWdt=Number(n));var o=gk(t,["widthConstraint","minimum"]);"number"==typeof o&&(e.minWdt=Number(o))}var r=gk(t,"heightConstraint");if("number"==typeof r)e.minHgt=Number(r);else if("object"===Of(r)){var s=gk(t,["heightConstraint","minimum"]);"number"==typeof s&&(e.minHgt=Number(s));var a=gk(t,["heightConstraint","valign"]);"string"==typeof a&&("top"!==a&&"bottom"!==a||(e.valign=a))}return e}},{key:"update",value:function(t,e){this.setOptions(t,!0),this.propagateFonts(e),Ux(this.fontOptions,this.constrain(e)),this.fontOptions.chooser=DB("label",e)}},{key:"adjustSizes",value:function(t){var e=t?t.right+t.left:0;this.fontOptions.constrainWidth&&(this.fontOptions.maxWdt-=e,this.fontOptions.minWdt-=e);var i=t?t.top+t.bottom:0;this.fontOptions.constrainHeight&&(this.fontOptions.minHgt-=i)}},{key:"addFontOptionsToPile",value:function(t,e){for(var i=0;i<e.length;++i)this.addFontToPile(t,e[i])}},{key:"addFontToPile",value:function(t,e){if(void 0!==e&&void 0!==e.font&&null!==e.font){var i=e.font;t.push(i)}}},{key:"getBasicOptions",value:function(e){for(var i={},n=0;n<e.length;++n){var o=e[n],r={};t.parseFontString(r,o)&&(o=r),$x(o,(function(t,e){void 0!==t&&(Object.prototype.hasOwnProperty.call(i,e)||(-1!==tm(RB).call(RB,e)?i[e]={}:i[e]=t))}))}return i}},{key:"getFontOption",value:function(e,i,n){for(var o,r=0;r<e.length;++r){var s=e[r];if(Object.prototype.hasOwnProperty.call(s,i)){if(null==(o=s[i]))continue;var a={};if(t.parseFontString(a,o)&&(o=a),Object.prototype.hasOwnProperty.call(o,n))return o[n]}}if(Object.prototype.hasOwnProperty.call(this.fontOptions,n))return this.fontOptions[n];throw new Error("Did not find value for multi-font for property: '"+n+"'")}},{key:"getFontOptions",value:function(t,e){for(var i={},n=["color","size","face","mod","vadjust"],o=0;o<n.length;++o){var r=n[o];i[r]=this.getFontOption(t,e,r)}return i}},{key:"propagateFonts",value:function(t){var e=this,i=[];this.addFontOptionsToPile(i,t),this.fontOptions=this.getBasicOptions(i);for(var n=function(){var t=RB[o],n=e.fontOptions[t];$x(e.getFontOptions(i,t),(function(t,e){n[e]=t})),n.size=Number(n.size),n.vadjust=Number(n.vadjust)},o=0;o<RB.length;++o)n()}},{key:"draw",value:function(t,e,i,n,o){var r=arguments.length>5&&void 0!==arguments[5]?arguments[5]:"middle";if(void 0!==this.elementOptions.label){var s=this.fontOptions.size*this.body.view.scale;this.elementOptions.label&&s<this.elementOptions.scaling.label.drawThreshold-1||(s>=this.elementOptions.scaling.label.maxVisible&&(s=Number(this.elementOptions.scaling.label.maxVisible)/this.body.view.scale),this.calculateLabelSize(t,n,o,e,i,r),this._drawBackground(t),this._drawText(t,e,this.size.yLine,r,s))}}},{key:"_drawBackground",value:function(t){if(void 0!==this.fontOptions.background&&"none"!==this.fontOptions.background){t.fillStyle=this.fontOptions.background;var e=this.getSize();t.fillRect(e.left,e.top,e.width,e.height)}}},{key:"_drawText",value:function(t,e,i){var n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:"middle",o=arguments.length>4?arguments[4]:void 0,r=kp(this._setAlignment(t,e,i,n),2);e=r[0],i=r[1],t.textAlign="left",e-=this.size.width/2,this.fontOptions.valign&&this.size.height>this.size.labelHeight&&("top"===this.fontOptions.valign&&(i-=(this.size.height-this.size.labelHeight)/2),"bottom"===this.fontOptions.valign&&(i+=(this.size.height-this.size.labelHeight)/2));for(var s=0;s<this.lineCount;s++){var a=this.lines[s];if(a&&a.blocks){var h=0;this.isEdgeLabel||"center"===this.fontOptions.align?h+=(this.size.width-a.width)/2:"right"===this.fontOptions.align&&(h+=this.size.width-a.width);for(var l=0;l<a.blocks.length;l++){var d=a.blocks[l];t.font=d.font;var c=kp(this._getColor(d.color,o,d.strokeColor),2),u=c[0],f=c[1];d.strokeWidth>0&&(t.lineWidth=d.strokeWidth,t.strokeStyle=f,t.lineJoin="round"),t.fillStyle=u,d.strokeWidth>0&&t.strokeText(d.text,e+h,i+d.vadjust),t.fillText(d.text,e+h,i+d.vadjust),h+=d.width}i+=a.height}}}},{key:"_setAlignment",value:function(t,e,i,n){if(this.isEdgeLabel&&"horizontal"!==this.fontOptions.align&&!1===this.pointToSelf){e=0,i=0;"top"===this.fontOptions.align?(t.textBaseline="alphabetic",i-=4):"bottom"===this.fontOptions.align?(t.textBaseline="hanging",i+=4):t.textBaseline="middle"}else t.textBaseline=n;return[e,i]}},{key:"_getColor",value:function(t,e,i){var n=t||"#000000",o=i||"#ffffff";if(e<=this.elementOptions.scaling.label.drawThreshold){var r=Math.max(0,Math.min(1,1-(this.elementOptions.scaling.label.drawThreshold-e)));n=ik(n,r),o=ik(o,r)}return[n,o]}},{key:"getTextSize",value:function(t){var e=arguments.length>1&&void 0!==arguments[1]&&arguments[1],i=arguments.length>2&&void 0!==arguments[2]&&arguments[2];return this._processLabel(t,e,i),{width:this.size.width,height:this.size.height,lineCount:this.lineCount}}},{key:"getSize",value:function(){var t=this.size.left,e=this.size.top-1;if(this.isEdgeLabel){var i=.5*-this.size.width;switch(this.fontOptions.align){case"middle":t=i,e=.5*-this.size.height;break;case"top":t=i,e=-(this.size.height+2);break;case"bottom":t=i,e=2}}return{left:t,top:e,width:this.size.width,height:this.size.height}}},{key:"calculateLabelSize",value:function(t,e,i){var n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:0,o=arguments.length>4&&void 0!==arguments[4]?arguments[4]:0,r=arguments.length>5&&void 0!==arguments[5]?arguments[5]:"middle";this._processLabel(t,e,i),this.size.left=n-.5*this.size.width,this.size.top=o-.5*this.size.height,this.size.yLine=o+.5*(1-this.lineCount)*this.fontOptions.size,"hanging"===r&&(this.size.top+=.5*this.fontOptions.size,this.size.top+=4,this.size.yLine+=4)}},{key:"getFormattingValues",value:function(t,e,i,n){var o=function(t,e,i){return"normal"===e?"mod"===i?"":t[i]:void 0!==t[e][i]?t[e][i]:t[i]},r={color:o(this.fontOptions,n,"color"),size:o(this.fontOptions,n,"size"),face:o(this.fontOptions,n,"face"),mod:o(this.fontOptions,n,"mod"),vadjust:o(this.fontOptions,n,"vadjust"),strokeWidth:this.fontOptions.strokeWidth,strokeColor:this.fontOptions.strokeColor};(e||i)&&("normal"===n&&!0===this.fontOptions.chooser&&this.elementOptions.labelHighlightBold?r.mod="bold":"function"==typeof this.fontOptions.chooser&&this.fontOptions.chooser(r,this.elementOptions.id,e,i));var s="";return void 0!==r.mod&&""!==r.mod&&(s+=r.mod+" "),s+=r.size+"px "+r.face,t.font=s.replace(/"/g,""),r.font=t.font,r.height=r.size,r}},{key:"differentState",value:function(t,e){return t!==this.selectedState||e!==this.hoverState}},{key:"_processLabelText",value:function(t,e,i,n){return new jB(t,this,e,i).process(n)}},{key:"_processLabel",value:function(t,e,i){if(!1!==this.labelDirty||this.differentState(e,i)){var n=this._processLabelText(t,e,i,this.elementOptions.label);this.fontOptions.minWdt>0&&n.width<this.fontOptions.minWdt&&(n.width=this.fontOptions.minWdt),this.size.labelHeight=n.height,this.fontOptions.minHgt>0&&n.height<this.fontOptions.minHgt&&(n.height=this.fontOptions.minHgt),this.lines=n.lines,this.lineCount=n.lines.length,this.size.width=n.width,this.size.height=n.height,this.selectedState=e,this.hoverState=i,this.labelDirty=!1}}},{key:"visible",value:function(){return 0!==this.size.width&&0!==this.size.height&&void 0!==this.elementOptions.label&&!(this.fontOptions.size*this.body.view.scale<this.elementOptions.scaling.label.drawThreshold-1)}}],[{key:"parseFontString",value:function(t,e){if(!e||"string"!=typeof e)return!1;var i=e.split(" ");return t.size=+i[0].replace("px",""),t.face=i[1],t.color=i[2],!0}}]),t}(),HB=function(){function t(e,i,n){pu(this,t),this.body=i,this.labelModule=n,this.setOptions(e),this.top=void 0,this.left=void 0,this.height=void 0,this.width=void 0,this.radius=void 0,this.margin=void 0,this.refreshNeeded=!0,this.boundingBox={top:0,left:0,right:0,bottom:0}}return Nf(t,[{key:"setOptions",value:function(t){this.options=t}},{key:"_setMargins",value:function(t){this.margin={},this.options.margin&&("object"==Of(this.options.margin)?(this.margin.top=this.options.margin.top,this.margin.right=this.options.margin.right,this.margin.bottom=this.options.margin.bottom,this.margin.left=this.options.margin.left):(this.margin.top=this.options.margin,this.margin.right=this.options.margin,this.margin.bottom=this.options.margin,this.margin.left=this.options.margin)),t.adjustSizes(this.margin)}},{key:"_distanceToBorder",value:function(t,e){var i=this.options.borderWidth;return t&&this.resize(t),Math.min(Math.abs(this.width/2/Math.cos(e)),Math.abs(this.height/2/Math.sin(e)))+i}},{key:"enableShadow",value:function(t,e){e.shadow&&(t.shadowColor=e.shadowColor,t.shadowBlur=e.shadowSize,t.shadowOffsetX=e.shadowX,t.shadowOffsetY=e.shadowY)}},{key:"disableShadow",value:function(t,e){e.shadow&&(t.shadowColor="rgba(0,0,0,0)",t.shadowBlur=0,t.shadowOffsetX=0,t.shadowOffsetY=0)}},{key:"enableBorderDashes",value:function(t,e){if(!1!==e.borderDashes)if(void 0!==t.setLineDash){var i=e.borderDashes;!0===i&&(i=[5,15]),t.setLineDash(i)}else console.warn("setLineDash is not supported in this browser. The dashed borders cannot be used."),this.options.shapeProperties.borderDashes=!1,e.borderDashes=!1}},{key:"disableBorderDashes",value:function(t,e){!1!==e.borderDashes&&(void 0!==t.setLineDash?t.setLineDash([0]):(console.warn("setLineDash is not supported in this browser. The dashed borders cannot be used."),this.options.shapeProperties.borderDashes=!1,e.borderDashes=!1))}},{key:"needsRefresh",value:function(t,e){return!0===this.refreshNeeded?(this.refreshNeeded=!1,!0):void 0===this.width||this.labelModule.differentState(t,e)}},{key:"initContextForDraw",value:function(t,e){var i=e.borderWidth/this.body.view.scale;t.lineWidth=Math.min(this.width,i),t.strokeStyle=e.borderColor,t.fillStyle=e.color}},{key:"performStroke",value:function(t,e){var i=e.borderWidth/this.body.view.scale;t.save(),i>0&&(this.enableBorderDashes(t,e),t.stroke(),this.disableBorderDashes(t,e)),t.restore()}},{key:"performFill",value:function(t,e){t.save(),t.fillStyle=e.color,this.enableShadow(t,e),hb(t).call(t),this.disableShadow(t,e),t.restore(),this.performStroke(t,e)}},{key:"_addBoundingBoxMargin",value:function(t){this.boundingBox.left-=t,this.boundingBox.top-=t,this.boundingBox.bottom+=t,this.boundingBox.right+=t}},{key:"_updateBoundingBox",value:function(t,e,i,n,o){void 0!==i&&this.resize(i,n,o),this.left=t-this.width/2,this.top=e-this.height/2,this.boundingBox.left=this.left,this.boundingBox.top=this.top,this.boundingBox.bottom=this.top+this.height,this.boundingBox.right=this.left+this.width}},{key:"updateBoundingBox",value:function(t,e,i,n,o){this._updateBoundingBox(t,e,i,n,o)}},{key:"getDimensionsFromLabel",value:function(t,e,i){this.textSize=this.labelModule.getTextSize(t,e,i);var n=this.textSize.width,o=this.textSize.height;return 0===n&&(n=14,o=14),{width:n,height:o}}}]),t}();function WB(t){var e=function(){if("undefined"==typeof Reflect||!jI)return!1;if(jI.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(jI(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=AO(t);if(e){var o=AO(this).constructor;i=jI(n,arguments,o)}else i=n.apply(this,arguments);return DO(this,i)}}var qB=function(t){PO(i,t);var e=WB(i);function i(t,n,o){var r;return pu(this,i),(r=e.call(this,t,n,o))._setMargins(o),r}return Nf(i,[{key:"resize",value:function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:this.selected,i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:this.hover;if(this.needsRefresh(e,i)){var n=this.getDimensionsFromLabel(t,e,i);this.width=n.width+this.margin.right+this.margin.left,this.height=n.height+this.margin.top+this.margin.bottom,this.radius=this.width/2}}},{key:"draw",value:function(t,e,i,n,o,r){this.resize(t,n,o),this.left=e-this.width/2,this.top=i-this.height/2,this.initContextForDraw(t,r),Gn(t,this.left,this.top,this.width,this.height,r.borderRadius),this.performFill(t,r),this.updateBoundingBox(e,i,t,n,o),this.labelModule.draw(t,this.left+this.textSize.width/2+this.margin.left,this.top+this.textSize.height/2+this.margin.top,n,o)}},{key:"updateBoundingBox",value:function(t,e,i,n,o){this._updateBoundingBox(t,e,i,n,o);var r=this.options.shapeProperties.borderRadius;this._addBoundingBoxMargin(r)}},{key:"distanceToBorder",value:function(t,e){t&&this.resize(t);var i=this.options.borderWidth;return Math.min(Math.abs(this.width/2/Math.cos(e)),Math.abs(this.height/2/Math.sin(e)))+i}}]),i}(HB);function VB(t){var e=function(){if("undefined"==typeof Reflect||!jI)return!1;if(jI.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(jI(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=AO(t);if(e){var o=AO(this).constructor;i=jI(n,arguments,o)}else i=n.apply(this,arguments);return DO(this,i)}}var UB=function(t){PO(i,t);var e=VB(i);function i(t,n,o){var r;return pu(this,i),(r=e.call(this,t,n,o)).labelOffset=0,r.selected=!1,r}return Nf(i,[{key:"setOptions",value:function(t,e,i){this.options=t,void 0===e&&void 0===i||this.setImages(e,i)}},{key:"setImages",value:function(t,e){e&&this.selected?(this.imageObj=e,this.imageObjAlt=t):(this.imageObj=t,this.imageObjAlt=e)}},{key:"switchImages",value:function(t){var e=t&&!this.selected||!t&&this.selected;if(this.selected=t,void 0!==this.imageObjAlt&&e){var i=this.imageObj;this.imageObj=this.imageObjAlt,this.imageObjAlt=i}}},{key:"_getImagePadding",value:function(){var t={top:0,right:0,bottom:0,left:0};if(this.options.imagePadding){var e=this.options.imagePadding;"object"==Of(e)?(t.top=e.top,t.right=e.right,t.bottom=e.bottom,t.left=e.left):(t.top=e,t.right=e,t.bottom=e,t.left=e)}return t}},{key:"_resizeImage",value:function(){var t,e;if(!1===this.options.shapeProperties.useImageSize){var i=1,n=1;this.imageObj.width&&this.imageObj.height&&(this.imageObj.width>this.imageObj.height?i=this.imageObj.width/this.imageObj.height:n=this.imageObj.height/this.imageObj.width),t=2*this.options.size*i,e=2*this.options.size*n}else{var o=this._getImagePadding();t=this.imageObj.width+o.left+o.right,e=this.imageObj.height+o.top+o.bottom}this.width=t,this.height=e,this.radius=.5*this.width}},{key:"_drawRawCircle",value:function(t,e,i,n){this.initContextForDraw(t,n),Xn(t,e,i,n.size),this.performFill(t,n)}},{key:"_drawImageAtPosition",value:function(t,e){if(0!=this.imageObj.width){t.globalAlpha=void 0!==e.opacity?e.opacity:1,this.enableShadow(t,e);var i=1;!0===this.options.shapeProperties.interpolation&&(i=this.imageObj.width/this.width/this.body.view.scale);var n=this._getImagePadding(),o=this.left+n.left,r=this.top+n.top,s=this.width-n.left-n.right,a=this.height-n.top-n.bottom;this.imageObj.drawImageAtPosition(t,i,o,r,s,a),this.disableShadow(t,e)}}},{key:"_drawImageLabel",value:function(t,e,i,n,o){var r=0;if(void 0!==this.height){r=.5*this.height;var s=this.labelModule.getTextSize(t,n,o);s.lineCount>=1&&(r+=s.height/2)}var a=i+r;this.options.label&&(this.labelOffset=r),this.labelModule.draw(t,e,a,n,o,"hanging")}}]),i}(HB);function YB(t){var e=function(){if("undefined"==typeof Reflect||!jI)return!1;if(jI.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(jI(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=AO(t);if(e){var o=AO(this).constructor;i=jI(n,arguments,o)}else i=n.apply(this,arguments);return DO(this,i)}}var XB=function(t){PO(i,t);var e=YB(i);function i(t,n,o){var r;return pu(this,i),(r=e.call(this,t,n,o))._setMargins(o),r}return Nf(i,[{key:"resize",value:function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:this.selected,i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:this.hover;if(this.needsRefresh(e,i)){var n=this.getDimensionsFromLabel(t,e,i),o=Math.max(n.width+this.margin.right+this.margin.left,n.height+this.margin.top+this.margin.bottom);this.options.size=o/2,this.width=o,this.height=o,this.radius=this.width/2}}},{key:"draw",value:function(t,e,i,n,o,r){this.resize(t,n,o),this.left=e-this.width/2,this.top=i-this.height/2,this._drawRawCircle(t,e,i,r),this.updateBoundingBox(e,i),this.labelModule.draw(t,this.left+this.textSize.width/2+this.margin.left,i,n,o)}},{key:"updateBoundingBox",value:function(t,e){this.boundingBox.top=e-this.options.size,this.boundingBox.left=t-this.options.size,this.boundingBox.right=t+this.options.size,this.boundingBox.bottom=e+this.options.size}},{key:"distanceToBorder",value:function(t){return t&&this.resize(t),.5*this.width}}]),i}(UB);function GB(t){var e=function(){if("undefined"==typeof Reflect||!jI)return!1;if(jI.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(jI(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=AO(t);if(e){var o=AO(this).constructor;i=jI(n,arguments,o)}else i=n.apply(this,arguments);return DO(this,i)}}var KB=function(t){PO(i,t);var e=GB(i);function i(t,n,o,r,s){var a;return pu(this,i),(a=e.call(this,t,n,o)).setImages(r,s),a}return Nf(i,[{key:"resize",value:function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:this.selected,i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:this.hover;if(void 0===this.imageObj.src||void 0===this.imageObj.width||void 0===this.imageObj.height){var n=2*this.options.size;return this.width=n,this.height=n,void(this.radius=.5*this.width)}this.needsRefresh(e,i)&&this._resizeImage()}},{key:"draw",value:function(t,e,i,n,o,r){this.switchImages(n),this.resize();var s=e,a=i;"top-left"===this.options.shapeProperties.coordinateOrigin?(this.left=e,this.top=i,s+=this.width/2,a+=this.height/2):(this.left=e-this.width/2,this.top=i-this.height/2),this._drawRawCircle(t,s,a,r),t.save(),t.clip(),this._drawImageAtPosition(t,r),t.restore(),this._drawImageLabel(t,s,a,n,o),this.updateBoundingBox(e,i)}},{key:"updateBoundingBox",value:function(t,e){"top-left"===this.options.shapeProperties.coordinateOrigin?(this.boundingBox.top=e,this.boundingBox.left=t,this.boundingBox.right=t+2*this.options.size,this.boundingBox.bottom=e+2*this.options.size):(this.boundingBox.top=e-this.options.size,this.boundingBox.left=t-this.options.size,this.boundingBox.right=t+this.options.size,this.boundingBox.bottom=e+this.options.size),this.boundingBox.left=Math.min(this.boundingBox.left,this.labelModule.size.left),this.boundingBox.right=Math.max(this.boundingBox.right,this.labelModule.size.left+this.labelModule.size.width),this.boundingBox.bottom=Math.max(this.boundingBox.bottom,this.boundingBox.bottom+this.labelOffset)}},{key:"distanceToBorder",value:function(t){return t&&this.resize(t),.5*this.width}}]),i}(UB);function $B(t){var e=function(){if("undefined"==typeof Reflect||!jI)return!1;if(jI.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(jI(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=AO(t);if(e){var o=AO(this).constructor;i=jI(n,arguments,o)}else i=n.apply(this,arguments);return DO(this,i)}}var ZB=function(t){PO(i,t);var e=$B(i);function i(t,n,o){return pu(this,i),e.call(this,t,n,o)}return Nf(i,[{key:"resize",value:function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:this.selected,i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:this.hover,n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:{size:this.options.size};if(this.needsRefresh(e,i)){var o,r;this.labelModule.getTextSize(t,e,i);var s=2*n.size;this.width=null!==(o=this.customSizeWidth)&&void 0!==o?o:s,this.height=null!==(r=this.customSizeHeight)&&void 0!==r?r:s,this.radius=.5*this.width}}},{key:"_drawShape",value:function(t,e,i,n,o,r,s,a){var h,l=this;return this.resize(t,r,s,a),this.left=n-this.width/2,this.top=o-this.height/2,this.initContextForDraw(t,a),(h=e,Object.prototype.hasOwnProperty.call(Qn,h)?Qn[h]:function(t){for(var e=arguments.length,i=new Array(e>1?e-1:0),n=1;n<e;n++)i[n-1]=arguments[n];CanvasRenderingContext2D.prototype[h].call(t,i)})(t,n,o,a.size),this.performFill(t,a),void 0!==this.options.icon&&void 0!==this.options.icon.code&&(t.font=(r?"bold ":"")+this.height/2+"px "+(this.options.icon.face||"FontAwesome"),t.fillStyle=this.options.icon.color||"black",t.textAlign="center",t.textBaseline="middle",t.fillText(this.options.icon.code,n,o)),{drawExternalLabel:function(){if(void 0!==l.options.label){l.labelModule.calculateLabelSize(t,r,s,n,o,"hanging");var e=o+.5*l.height+.5*l.labelModule.size.height;l.labelModule.draw(t,n,e,r,s,"hanging")}l.updateBoundingBox(n,o)}}}},{key:"updateBoundingBox",value:function(t,e){this.boundingBox.top=e-this.options.size,this.boundingBox.left=t-this.options.size,this.boundingBox.right=t+this.options.size,this.boundingBox.bottom=e+this.options.size,void 0!==this.options.label&&this.labelModule.size.width>0&&(this.boundingBox.left=Math.min(this.boundingBox.left,this.labelModule.size.left),this.boundingBox.right=Math.max(this.boundingBox.right,this.labelModule.size.left+this.labelModule.size.width),this.boundingBox.bottom=Math.max(this.boundingBox.bottom,this.boundingBox.bottom+this.labelModule.size.height))}}]),i}(HB);function QB(t,e){var i=ov(t);if(mc){var n=mc(t);e&&(n=ny(n).call(n,(function(e){return Dc(t,e).enumerable}))),i.push.apply(i,n)}return i}function JB(t){for(var e=1;e<arguments.length;e++){var i,n,o=null!=arguments[e]?arguments[e]:{};e%2?Cv(i=QB(Object(o),!0)).call(i,(function(e){zf(t,e,o[e])})):Uc?iu(t,Uc(o)):Cv(n=QB(Object(o))).call(n,(function(e){fu(t,e,Dc(o,e))}))}return t}function tN(t){var e=function(){if("undefined"==typeof Reflect||!jI)return!1;if(jI.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(jI(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=AO(t);if(e){var o=AO(this).constructor;i=jI(n,arguments,o)}else i=n.apply(this,arguments);return DO(this,i)}}var eN=function(t){PO(i,t);var e=tN(i);function i(t,n,o,r){var s;return pu(this,i),(s=e.call(this,t,n,o,r)).ctxRenderer=r,s}return Nf(i,[{key:"draw",value:function(t,e,i,n,o,r){this.resize(t,n,o,r),this.left=e-this.width/2,this.top=i-this.height/2,t.save();var s=this.ctxRenderer({ctx:t,id:this.options.id,x:e,y:i,state:{selected:n,hover:o},style:JB({},r),label:this.options.label});if(null!=s.drawNode&&s.drawNode(),t.restore(),s.drawExternalLabel){var a=s.drawExternalLabel;s.drawExternalLabel=function(){t.save(),a(),t.restore()}}return s.nodeDimensions&&(this.customSizeWidth=s.nodeDimensions.width,this.customSizeHeight=s.nodeDimensions.height),s}},{key:"distanceToBorder",value:function(t,e){return this._distanceToBorder(t,e)}}]),i}(ZB);function iN(t){var e=function(){if("undefined"==typeof Reflect||!jI)return!1;if(jI.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(jI(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=AO(t);if(e){var o=AO(this).constructor;i=jI(n,arguments,o)}else i=n.apply(this,arguments);return DO(this,i)}}var nN=function(t){PO(i,t);var e=iN(i);function i(t,n,o){var r;return pu(this,i),(r=e.call(this,t,n,o))._setMargins(o),r}return Nf(i,[{key:"resize",value:function(t,e,i){if(this.needsRefresh(e,i)){var n=this.getDimensionsFromLabel(t,e,i).width+this.margin.right+this.margin.left;this.width=n,this.height=n,this.radius=this.width/2}}},{key:"draw",value:function(t,e,i,n,o,r){this.resize(t,n,o),this.left=e-this.width/2,this.top=i-this.height/2,this.initContextForDraw(t,r),$n(t,e-this.width/2,i-this.height/2,this.width,this.height),this.performFill(t,r),this.updateBoundingBox(e,i,t,n,o),this.labelModule.draw(t,this.left+this.textSize.width/2+this.margin.left,this.top+this.textSize.height/2+this.margin.top,n,o)}},{key:"distanceToBorder",value:function(t,e){return this._distanceToBorder(t,e)}}]),i}(HB);function oN(t){var e=function(){if("undefined"==typeof Reflect||!jI)return!1;if(jI.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(jI(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=AO(t);if(e){var o=AO(this).constructor;i=jI(n,arguments,o)}else i=n.apply(this,arguments);return DO(this,i)}}var rN=function(t){PO(i,t);var e=oN(i);function i(t,n,o){return pu(this,i),e.call(this,t,n,o)}return Nf(i,[{key:"draw",value:function(t,e,i,n,o,r){return this._drawShape(t,"diamond",4,e,i,n,o,r)}},{key:"distanceToBorder",value:function(t,e){return this._distanceToBorder(t,e)}}]),i}(ZB);function sN(t){var e=function(){if("undefined"==typeof Reflect||!jI)return!1;if(jI.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(jI(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=AO(t);if(e){var o=AO(this).constructor;i=jI(n,arguments,o)}else i=n.apply(this,arguments);return DO(this,i)}}var aN=function(t){PO(i,t);var e=sN(i);function i(t,n,o){return pu(this,i),e.call(this,t,n,o)}return Nf(i,[{key:"draw",value:function(t,e,i,n,o,r){return this._drawShape(t,"circle",2,e,i,n,o,r)}},{key:"distanceToBorder",value:function(t){return t&&this.resize(t),this.options.size}}]),i}(ZB);function hN(t){var e=function(){if("undefined"==typeof Reflect||!jI)return!1;if(jI.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(jI(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=AO(t);if(e){var o=AO(this).constructor;i=jI(n,arguments,o)}else i=n.apply(this,arguments);return DO(this,i)}}var lN=function(t){PO(i,t);var e=hN(i);function i(t,n,o){return pu(this,i),e.call(this,t,n,o)}return Nf(i,[{key:"resize",value:function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:this.selected,i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:this.hover;if(this.needsRefresh(e,i)){var n=this.getDimensionsFromLabel(t,e,i);this.height=2*n.height,this.width=n.width+n.height,this.radius=.5*this.width}}},{key:"draw",value:function(t,e,i,n,o,r){this.resize(t,n,o),this.left=e-.5*this.width,this.top=i-.5*this.height,this.initContextForDraw(t,r),Kn(t,this.left,this.top,this.width,this.height),this.performFill(t,r),this.updateBoundingBox(e,i,t,n,o),this.labelModule.draw(t,e,i,n,o)}},{key:"distanceToBorder",value:function(t,e){t&&this.resize(t);var i=.5*this.width,n=.5*this.height,o=Math.sin(e)*i,r=Math.cos(e)*n;return i*n/Math.sqrt(o*o+r*r)}}]),i}(HB);function dN(t){var e=function(){if("undefined"==typeof Reflect||!jI)return!1;if(jI.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(jI(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=AO(t);if(e){var o=AO(this).constructor;i=jI(n,arguments,o)}else i=n.apply(this,arguments);return DO(this,i)}}var cN=function(t){PO(i,t);var e=dN(i);function i(t,n,o){var r;return pu(this,i),(r=e.call(this,t,n,o))._setMargins(o),r}return Nf(i,[{key:"resize",value:function(t,e,i){this.needsRefresh(e,i)&&(this.iconSize={width:Number(this.options.icon.size),height:Number(this.options.icon.size)},this.width=this.iconSize.width+this.margin.right+this.margin.left,this.height=this.iconSize.height+this.margin.top+this.margin.bottom,this.radius=.5*this.width)}},{key:"draw",value:function(t,e,i,n,o,r){var s=this;return this.resize(t,n,o),this.options.icon.size=this.options.icon.size||50,this.left=e-this.width/2,this.top=i-this.height/2,this._icon(t,e,i,n,o,r),{drawExternalLabel:function(){if(void 0!==s.options.label){s.labelModule.draw(t,s.left+s.iconSize.width/2+s.margin.left,i+s.height/2+5,n)}s.updateBoundingBox(e,i)}}}},{key:"updateBoundingBox",value:function(t,e){if(this.boundingBox.top=e-.5*this.options.icon.size,this.boundingBox.left=t-.5*this.options.icon.size,this.boundingBox.right=t+.5*this.options.icon.size,this.boundingBox.bottom=e+.5*this.options.icon.size,void 0!==this.options.label&&this.labelModule.size.width>0){this.boundingBox.left=Math.min(this.boundingBox.left,this.labelModule.size.left),this.boundingBox.right=Math.max(this.boundingBox.right,this.labelModule.size.left+this.labelModule.size.width),this.boundingBox.bottom=Math.max(this.boundingBox.bottom,this.boundingBox.bottom+this.labelModule.size.height+5)}}},{key:"_icon",value:function(t,e,i,n,o,r){var s=Number(this.options.icon.size);void 0!==this.options.icon.code?(t.font=[null!=this.options.icon.weight?this.options.icon.weight:n?"bold":"",(null!=this.options.icon.weight&&n?5:0)+s+"px",this.options.icon.face].join(" "),t.fillStyle=this.options.icon.color||"black",t.textAlign="center",t.textBaseline="middle",this.enableShadow(t,r),t.fillText(this.options.icon.code,e,i),this.disableShadow(t,r)):console.error("When using the icon shape, you need to define the code in the icon options object. This can be done per node or globally.")}},{key:"distanceToBorder",value:function(t,e){return this._distanceToBorder(t,e)}}]),i}(HB);function uN(t){var e=function(){if("undefined"==typeof Reflect||!jI)return!1;if(jI.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(jI(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=AO(t);if(e){var o=AO(this).constructor;i=jI(n,arguments,o)}else i=n.apply(this,arguments);return DO(this,i)}}var fN=function(t){PO(i,t);var e=uN(i);function i(t,n,o,r,s){var a;return pu(this,i),(a=e.call(this,t,n,o)).setImages(r,s),a}return Nf(i,[{key:"resize",value:function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:this.selected,i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:this.hover;if(void 0===this.imageObj.src||void 0===this.imageObj.width||void 0===this.imageObj.height){var n=2*this.options.size;return this.width=n,void(this.height=n)}this.needsRefresh(e,i)&&this._resizeImage()}},{key:"draw",value:function(t,e,i,n,o,r){t.save(),this.switchImages(n),this.resize();var s=e,a=i;if("top-left"===this.options.shapeProperties.coordinateOrigin?(this.left=e,this.top=i,s+=this.width/2,a+=this.height/2):(this.left=e-this.width/2,this.top=i-this.height/2),!0===this.options.shapeProperties.useBorderWithImage){var h=this.options.borderWidth,l=this.options.borderWidthSelected||2*this.options.borderWidth,d=(n?l:h)/this.body.view.scale;t.lineWidth=Math.min(this.width,d),t.beginPath();var c=n?this.options.color.highlight.border:o?this.options.color.hover.border:this.options.color.border,u=n?this.options.color.highlight.background:o?this.options.color.hover.background:this.options.color.background;void 0!==r.opacity&&(c=ik(c,r.opacity),u=ik(u,r.opacity)),t.strokeStyle=c,t.fillStyle=u,t.rect(this.left-.5*t.lineWidth,this.top-.5*t.lineWidth,this.width+t.lineWidth,this.height+t.lineWidth),hb(t).call(t),this.performStroke(t,r),t.closePath()}this._drawImageAtPosition(t,r),this._drawImageLabel(t,s,a,n,o),this.updateBoundingBox(e,i),t.restore()}},{key:"updateBoundingBox",value:function(t,e){this.resize(),"top-left"===this.options.shapeProperties.coordinateOrigin?(this.left=t,this.top=e):(this.left=t-this.width/2,this.top=e-this.height/2),this.boundingBox.left=this.left,this.boundingBox.top=this.top,this.boundingBox.bottom=this.top+this.height,this.boundingBox.right=this.left+this.width,void 0!==this.options.label&&this.labelModule.size.width>0&&(this.boundingBox.left=Math.min(this.boundingBox.left,this.labelModule.size.left),this.boundingBox.right=Math.max(this.boundingBox.right,this.labelModule.size.left+this.labelModule.size.width),this.boundingBox.bottom=Math.max(this.boundingBox.bottom,this.boundingBox.bottom+this.labelOffset))}},{key:"distanceToBorder",value:function(t,e){return this._distanceToBorder(t,e)}}]),i}(UB);function pN(t){var e=function(){if("undefined"==typeof Reflect||!jI)return!1;if(jI.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(jI(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=AO(t);if(e){var o=AO(this).constructor;i=jI(n,arguments,o)}else i=n.apply(this,arguments);return DO(this,i)}}var vN=function(t){PO(i,t);var e=pN(i);function i(t,n,o){return pu(this,i),e.call(this,t,n,o)}return Nf(i,[{key:"draw",value:function(t,e,i,n,o,r){return this._drawShape(t,"square",2,e,i,n,o,r)}},{key:"distanceToBorder",value:function(t,e){return this._distanceToBorder(t,e)}}]),i}(ZB);function gN(t){var e=function(){if("undefined"==typeof Reflect||!jI)return!1;if(jI.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(jI(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=AO(t);if(e){var o=AO(this).constructor;i=jI(n,arguments,o)}else i=n.apply(this,arguments);return DO(this,i)}}var yN=function(t){PO(i,t);var e=gN(i);function i(t,n,o){return pu(this,i),e.call(this,t,n,o)}return Nf(i,[{key:"draw",value:function(t,e,i,n,o,r){return this._drawShape(t,"hexagon",4,e,i,n,o,r)}},{key:"distanceToBorder",value:function(t,e){return this._distanceToBorder(t,e)}}]),i}(ZB);function mN(t){var e=function(){if("undefined"==typeof Reflect||!jI)return!1;if(jI.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(jI(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=AO(t);if(e){var o=AO(this).constructor;i=jI(n,arguments,o)}else i=n.apply(this,arguments);return DO(this,i)}}var bN=function(t){PO(i,t);var e=mN(i);function i(t,n,o){return pu(this,i),e.call(this,t,n,o)}return Nf(i,[{key:"draw",value:function(t,e,i,n,o,r){return this._drawShape(t,"star",4,e,i,n,o,r)}},{key:"distanceToBorder",value:function(t,e){return this._distanceToBorder(t,e)}}]),i}(ZB);function wN(t){var e=function(){if("undefined"==typeof Reflect||!jI)return!1;if(jI.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(jI(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=AO(t);if(e){var o=AO(this).constructor;i=jI(n,arguments,o)}else i=n.apply(this,arguments);return DO(this,i)}}var xN=function(t){PO(i,t);var e=wN(i);function i(t,n,o){var r;return pu(this,i),(r=e.call(this,t,n,o))._setMargins(o),r}return Nf(i,[{key:"resize",value:function(t,e,i){this.needsRefresh(e,i)&&(this.textSize=this.labelModule.getTextSize(t,e,i),this.width=this.textSize.width+this.margin.right+this.margin.left,this.height=this.textSize.height+this.margin.top+this.margin.bottom,this.radius=.5*this.width)}},{key:"draw",value:function(t,e,i,n,o,r){this.resize(t,n,o),this.left=e-this.width/2,this.top=i-this.height/2,this.enableShadow(t,r),this.labelModule.draw(t,this.left+this.textSize.width/2+this.margin.left,this.top+this.textSize.height/2+this.margin.top,n,o),this.disableShadow(t,r),this.updateBoundingBox(e,i,t,n,o)}},{key:"distanceToBorder",value:function(t,e){return this._distanceToBorder(t,e)}}]),i}(HB);function kN(t){var e=function(){if("undefined"==typeof Reflect||!jI)return!1;if(jI.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(jI(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=AO(t);if(e){var o=AO(this).constructor;i=jI(n,arguments,o)}else i=n.apply(this,arguments);return DO(this,i)}}var _N=function(t){PO(i,t);var e=kN(i);function i(t,n,o){return pu(this,i),e.call(this,t,n,o)}return Nf(i,[{key:"draw",value:function(t,e,i,n,o,r){return this._drawShape(t,"triangle",3,e,i,n,o,r)}},{key:"distanceToBorder",value:function(t,e){return this._distanceToBorder(t,e)}}]),i}(ZB);function EN(t){var e=function(){if("undefined"==typeof Reflect||!jI)return!1;if(jI.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(jI(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=AO(t);if(e){var o=AO(this).constructor;i=jI(n,arguments,o)}else i=n.apply(this,arguments);return DO(this,i)}}var ON=function(t){PO(i,t);var e=EN(i);function i(t,n,o){return pu(this,i),e.call(this,t,n,o)}return Nf(i,[{key:"draw",value:function(t,e,i,n,o,r){return this._drawShape(t,"triangleDown",3,e,i,n,o,r)}},{key:"distanceToBorder",value:function(t,e){return this._distanceToBorder(t,e)}}]),i}(ZB);function CN(t,e){var i=ov(t);if(mc){var n=mc(t);e&&(n=ny(n).call(n,(function(e){return Dc(t,e).enumerable}))),i.push.apply(i,n)}return i}function SN(t){for(var e=1;e<arguments.length;e++){var i,n,o=null!=arguments[e]?arguments[e]:{};e%2?Cv(i=CN(Object(o),!0)).call(i,(function(e){zf(t,e,o[e])})):Uc?iu(t,Uc(o)):Cv(n=CN(Object(o))).call(n,(function(e){fu(t,e,Dc(o,e))}))}return t}var TN=function(){function t(e,i,n,o,r,s){pu(this,t),this.options=fk(r),this.globalOptions=r,this.defaultOptions=s,this.body=i,this.edges=[],this.id=void 0,this.imagelist=n,this.grouplist=o,this.x=void 0,this.y=void 0,this.baseSize=this.options.size,this.baseFontSize=this.options.font.size,this.predefinedPosition=!1,this.selected=!1,this.hover=!1,this.labelModule=new LB(this.body,this.options,!1),this.setOptions(e)}return Nf(t,[{key:"attachEdge",value:function(t){var e;-1===tm(e=this.edges).call(e,t)&&this.edges.push(t)}},{key:"detachEdge",value:function(t){var e,i,n=tm(e=this.edges).call(e,t);-1!=n&&vg(i=this.edges).call(i,n,1)}},{key:"setOptions",value:function(e){var i=this.options.shape;if(e){if(void 0!==e.color&&(this._localColor=e.color),void 0!==e.id&&(this.id=e.id),void 0===this.id)throw new Error("Node must have an id");t.checkMass(e,this.id),void 0!==e.x&&(null===e.x?(this.x=void 0,this.predefinedPosition=!1):(this.x=Ly(e.x),this.predefinedPosition=!0)),void 0!==e.y&&(null===e.y?(this.y=void 0,this.predefinedPosition=!1):(this.y=Ly(e.y),this.predefinedPosition=!0)),void 0!==e.size&&(this.baseSize=e.size),void 0!==e.value&&(e.value=xB(e.value)),t.parseOptions(this.options,e,!0,this.globalOptions,this.grouplist);var n=[e,this.options,this.defaultOptions];return this.chooser=DB("node",n),this._load_images(),this.updateLabelModule(e),void 0!==e.opacity&&t.checkOpacity(e.opacity)&&(this.options.opacity=e.opacity),this.updateShape(i),void 0!==e.hidden||void 0!==e.physics}}},{key:"_load_images",value:function(){if(("circularImage"===this.options.shape||"image"===this.options.shape)&&void 0===this.options.image)throw new Error("Option image must be defined for node type '"+this.options.shape+"'");if(void 0!==this.options.image){if(void 0===this.imagelist)throw new Error("Internal Error: No images provided");if("string"==typeof this.options.image)this.imageObj=this.imagelist.load(this.options.image,this.options.brokenImage,this.id);else{if(void 0===this.options.image.unselected)throw new Error("No unselected image provided");this.imageObj=this.imagelist.load(this.options.image.unselected,this.options.brokenImage,this.id),void 0!==this.options.image.selected?this.imageObjAlt=this.imagelist.load(this.options.image.selected,this.options.brokenImage,this.id):this.imageObjAlt=void 0}}}},{key:"getFormattingValues",value:function(){var t={color:this.options.color.background,opacity:this.options.opacity,borderWidth:this.options.borderWidth,borderColor:this.options.color.border,size:this.options.size,borderDashes:this.options.shapeProperties.borderDashes,borderRadius:this.options.shapeProperties.borderRadius,shadow:this.options.shadow.enabled,shadowColor:this.options.shadow.color,shadowSize:this.options.shadow.size,shadowX:this.options.shadow.x,shadowY:this.options.shadow.y};if(this.selected||this.hover?!0===this.chooser?this.selected?(null!=this.options.borderWidthSelected?t.borderWidth=this.options.borderWidthSelected:t.borderWidth*=2,t.color=this.options.color.highlight.background,t.borderColor=this.options.color.highlight.border,t.shadow=this.options.shadow.enabled):this.hover&&(t.color=this.options.color.hover.background,t.borderColor=this.options.color.hover.border,t.shadow=this.options.shadow.enabled):"function"==typeof this.chooser&&(this.chooser(t,this.options.id,this.selected,this.hover),!1===t.shadow&&(t.shadowColor===this.options.shadow.color&&t.shadowSize===this.options.shadow.size&&t.shadowX===this.options.shadow.x&&t.shadowY===this.options.shadow.y||(t.shadow=!0))):t.shadow=this.options.shadow.enabled,void 0!==this.options.opacity){var e=this.options.opacity;t.borderColor=ik(t.borderColor,e),t.color=ik(t.color,e),t.shadowColor=ik(t.shadowColor,e)}return t}},{key:"updateLabelModule",value:function(e){void 0!==this.options.label&&null!==this.options.label||(this.options.label=""),t.updateGroupOptions(this.options,SN(SN({},e),{},{color:e&&e.color||this._localColor||void 0}),this.grouplist);var i=this.grouplist.get(this.options.group,!1),n=[e,this.options,i,this.globalOptions,this.defaultOptions];this.labelModule.update(this.options,n),void 0!==this.labelModule.baseSize&&(this.baseFontSize=this.labelModule.baseSize)}},{key:"updateShape",value:function(t){if(t===this.options.shape&&this.shape)this.shape.setOptions(this.options,this.imageObj,this.imageObjAlt);else switch(this.options.shape){case"box":this.shape=new qB(this.options,this.body,this.labelModule);break;case"circle":this.shape=new XB(this.options,this.body,this.labelModule);break;case"circularImage":this.shape=new KB(this.options,this.body,this.labelModule,this.imageObj,this.imageObjAlt);break;case"custom":this.shape=new eN(this.options,this.body,this.labelModule,this.options.ctxRenderer);break;case"database":this.shape=new nN(this.options,this.body,this.labelModule);break;case"diamond":this.shape=new rN(this.options,this.body,this.labelModule);break;case"dot":this.shape=new aN(this.options,this.body,this.labelModule);break;case"ellipse":default:this.shape=new lN(this.options,this.body,this.labelModule);break;case"icon":this.shape=new cN(this.options,this.body,this.labelModule);break;case"image":this.shape=new fN(this.options,this.body,this.labelModule,this.imageObj,this.imageObjAlt);break;case"square":this.shape=new vN(this.options,this.body,this.labelModule);break;case"hexagon":this.shape=new yN(this.options,this.body,this.labelModule);break;case"star":this.shape=new bN(this.options,this.body,this.labelModule);break;case"text":this.shape=new xN(this.options,this.body,this.labelModule);break;case"triangle":this.shape=new _N(this.options,this.body,this.labelModule);break;case"triangleDown":this.shape=new ON(this.options,this.body,this.labelModule)}this.needsRefresh()}},{key:"select",value:function(){this.selected=!0,this.needsRefresh()}},{key:"unselect",value:function(){this.selected=!1,this.needsRefresh()}},{key:"needsRefresh",value:function(){this.shape.refreshNeeded=!0}},{key:"getTitle",value:function(){return this.options.title}},{key:"distanceToBorder",value:function(t,e){return this.shape.distanceToBorder(t,e)}},{key:"isFixed",value:function(){return this.options.fixed.x&&this.options.fixed.y}},{key:"isSelected",value:function(){return this.selected}},{key:"getValue",value:function(){return this.options.value}},{key:"getLabelSize",value:function(){return this.labelModule.size()}},{key:"setValueRange",value:function(t,e,i){if(void 0!==this.options.value){var n=this.options.scaling.customScalingFunction(t,e,i,this.options.value),o=this.options.scaling.max-this.options.scaling.min;if(!0===this.options.scaling.label.enabled){var r=this.options.scaling.label.max-this.options.scaling.label.min;this.options.font.size=this.options.scaling.label.min+n*r}this.options.size=this.options.scaling.min+n*o}else this.options.size=this.baseSize,this.options.font.size=this.baseFontSize;this.updateLabelModule()}},{key:"draw",value:function(t){var e=this.getFormattingValues();return this.shape.draw(t,this.x,this.y,this.selected,this.hover,e)||{}}},{key:"updateBoundingBox",value:function(t){this.shape.updateBoundingBox(this.x,this.y,t)}},{key:"resize",value:function(t){var e=this.getFormattingValues();this.shape.resize(t,this.selected,this.hover,e)}},{key:"getItemsOnPoint",value:function(t){var e=[];return this.labelModule.visible()&&IB(this.labelModule.getSize(),t)&&e.push({nodeId:this.id,labelId:0}),IB(this.shape.boundingBox,t)&&e.push({nodeId:this.id}),e}},{key:"isOverlappingWith",value:function(t){return this.shape.left<t.right&&this.shape.left+this.shape.width>t.left&&this.shape.top<t.bottom&&this.shape.top+this.shape.height>t.top}},{key:"isBoundingBoxOverlappingWith",value:function(t){return this.shape.boundingBox.left<t.right&&this.shape.boundingBox.right>t.left&&this.shape.boundingBox.top<t.bottom&&this.shape.boundingBox.bottom>t.top}}],[{key:"checkOpacity",value:function(t){return 0<=t&&t<=1}},{key:"checkCoordinateOrigin",value:function(t){return void 0===t||"center"===t||"top-left"===t}},{key:"updateGroupOptions",value:function(e,i,n){var o;if(void 0!==n){var r=e.group;if(void 0!==i&&void 0!==i.group&&r!==i.group)throw new Error("updateGroupOptions: group values in options don't match.");if("number"==typeof r||"string"==typeof r&&""!=r){var s=n.get(r);void 0!==s.opacity&&void 0===i.opacity&&(t.checkOpacity(s.opacity)||(console.error("Invalid option for node opacity. Value must be between 0 and 1, found: "+s.opacity),s.opacity=void 0));var a=ny(o=PB(i)).call(o,(function(t){return null!=i[t]}));a.push("font"),Vx(a,e,s),e.color=ok(e.color)}}}},{key:"parseOptions",value:function(e,i){var n=arguments.length>2&&void 0!==arguments[2]&&arguments[2],o=arguments.length>3&&void 0!==arguments[3]?arguments[3]:{},r=arguments.length>4?arguments[4]:void 0;if(Vx(["color","fixed","shadow"],e,i,n),t.checkMass(i),void 0!==e.opacity&&(t.checkOpacity(e.opacity)||(console.error("Invalid option for node opacity. Value must be between 0 and 1, found: "+e.opacity),e.opacity=void 0)),void 0!==i.opacity&&(t.checkOpacity(i.opacity)||(console.error("Invalid option for node opacity. Value must be between 0 and 1, found: "+i.opacity),i.opacity=void 0)),i.shapeProperties&&!t.checkCoordinateOrigin(i.shapeProperties.coordinateOrigin)&&console.error("Invalid option for node coordinateOrigin, found: "+i.shapeProperties.coordinateOrigin),pk(e,i,"shadow",o),void 0!==i.color&&null!==i.color){var s=ok(i.color);Hx(e.color,s)}else!0===n&&null===i.color&&(e.color=fk(o.color));void 0!==i.fixed&&null!==i.fixed&&("boolean"==typeof i.fixed?(e.fixed.x=i.fixed,e.fixed.y=i.fixed):(void 0!==i.fixed.x&&"boolean"==typeof i.fixed.x&&(e.fixed.x=i.fixed.x),void 0!==i.fixed.y&&"boolean"==typeof i.fixed.y&&(e.fixed.y=i.fixed.y))),!0===n&&null===i.font&&(e.font=fk(o.font)),t.updateGroupOptions(e,i,r),void 0!==i.scaling&&pk(e.scaling,i.scaling,"label",o.scaling)}},{key:"checkMass",value:function(t,e){if(void 0!==t.mass&&t.mass<=0){var i="";void 0!==e&&(i=" in node id: "+e),console.error("%cNegative or zero mass disallowed"+i+", setting mass to 1.",Dk),t.mass=1}}}]),t}();function MN(t,e){var i=void 0!==Op&&xh(t)||t["@@iterator"];if(!i){if(Wp(t)||(i=function(t,e){var i;if(!t)return;if("string"==typeof t)return PN(t,e);var n=Fp(i=Object.prototype.toString.call(t)).call(i,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return Za(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return PN(t,e)}(t))||e&&t&&"number"==typeof t.length){i&&(t=i);var n=0,o=function(){};return{s:o,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var r,s=!0,a=!1;return{s:function(){i=i.call(t)},n:function(){var t=i.next();return s=t.done,t},e:function(t){a=!0,r=t},f:function(){try{s||null==i.return||i.return()}finally{if(a)throw r}}}}function PN(t,e){(null==e||e>t.length)&&(e=t.length);for(var i=0,n=new Array(e);i<e;i++)n[i]=t[i];return n}var DN=function(){function t(e,i,n,o){var r,s=this;if(pu(this,t),this.body=e,this.images=i,this.groups=n,this.layoutEngine=o,this.body.functions.createNode=Yn(r=this.create).call(r,this),this.nodesListeners={add:function(t,e){s.add(e.items)},update:function(t,e){s.update(e.items,e.data,e.oldData)},remove:function(t,e){s.remove(e.items)}},this.defaultOptions={borderWidth:1,borderWidthSelected:void 0,brokenImage:void 0,color:{border:"#2B7CE9",background:"#97C2FC",highlight:{border:"#2B7CE9",background:"#D2E5FF"},hover:{border:"#2B7CE9",background:"#D2E5FF"}},opacity:void 0,fixed:{x:!1,y:!1},font:{color:"#343434",size:14,face:"arial",background:"none",strokeWidth:0,strokeColor:"#ffffff",align:"center",vadjust:0,multi:!1,bold:{mod:"bold"},boldital:{mod:"bold italic"},ital:{mod:"italic"},mono:{mod:"",size:15,face:"monospace",vadjust:2}},group:void 0,hidden:!1,icon:{face:"FontAwesome",code:void 0,size:50,color:"#2B7CE9"},image:void 0,imagePadding:{top:0,right:0,bottom:0,left:0},label:void 0,labelHighlightBold:!0,level:void 0,margin:{top:5,right:5,bottom:5,left:5},mass:1,physics:!0,scaling:{min:10,max:30,label:{enabled:!1,min:14,max:30,maxVisible:30,drawThreshold:5},customScalingFunction:function(t,e,i,n){if(e===t)return.5;var o=1/(e-t);return Math.max(0,(n-t)*o)}},shadow:{enabled:!1,color:"rgba(0,0,0,0.5)",size:10,x:5,y:5},shape:"ellipse",shapeProperties:{borderDashes:!1,borderRadius:6,interpolation:!0,useImageSize:!1,useBorderWithImage:!1,coordinateOrigin:"center"},size:25,title:void 0,value:void 0,x:void 0,y:void 0},this.defaultOptions.mass<=0)throw"Internal error: mass in defaultOptions of NodesHandler may not be zero or negative";this.options=fk(this.defaultOptions),this.bindEventListeners()}return Nf(t,[{key:"bindEventListeners",value:function(){var t,e,i=this;this.body.emitter.on("refreshNodes",Yn(t=this.refresh).call(t,this)),this.body.emitter.on("refresh",Yn(e=this.refresh).call(e,this)),this.body.emitter.on("destroy",(function(){$x(i.nodesListeners,(function(t,e){i.body.data.nodes&&i.body.data.nodes.off(e,t)})),delete i.body.functions.createNode,delete i.nodesListeners.add,delete i.nodesListeners.update,delete i.nodesListeners.remove,delete i.nodesListeners}))}},{key:"setOptions",value:function(t){if(void 0!==t){if(TN.parseOptions(this.options,t),void 0!==t.opacity&&(KE(t.opacity)||!eO(t.opacity)||t.opacity<0||t.opacity>1?console.error("Invalid option for node opacity. Value must be between 0 and 1, found: "+t.opacity):this.options.opacity=t.opacity),void 0!==t.shape)for(var e in this.body.nodes)Object.prototype.hasOwnProperty.call(this.body.nodes,e)&&this.body.nodes[e].updateShape();if(void 0!==t.font||void 0!==t.widthConstraint||void 0!==t.heightConstraint)for(var i=0,n=ov(this.body.nodes);i<n.length;i++){var o=n[i];this.body.nodes[o].updateLabelModule(),this.body.nodes[o].needsRefresh()}if(void 0!==t.size)for(var r in this.body.nodes)Object.prototype.hasOwnProperty.call(this.body.nodes,r)&&this.body.nodes[r].needsRefresh();void 0===t.hidden&&void 0===t.physics||this.body.emitter.emit("_dataChanged")}}},{key:"setData",value:function(t){var e=arguments.length>1&&void 0!==arguments[1]&&arguments[1],i=this.body.data.nodes;if(sB("id",t))this.body.data.nodes=t;else if(Wp(t))this.body.data.nodes=new nB,this.body.data.nodes.add(t);else{if(t)throw new TypeError("Array or DataSet expected");this.body.data.nodes=new nB}if(i&&$x(this.nodesListeners,(function(t,e){i.off(e,t)})),this.body.nodes={},this.body.data.nodes){var n=this;$x(this.nodesListeners,(function(t,e){n.body.data.nodes.on(e,t)}));var o=this.body.data.nodes.getIds();this.add(o,!0)}!1===e&&this.body.emitter.emit("_dataChanged")}},{key:"add",value:function(t){for(var e,i=arguments.length>1&&void 0!==arguments[1]&&arguments[1],n=[],o=0;o<t.length;o++){e=t[o];var r=this.body.data.nodes.get(e),s=this.create(r);n.push(s),this.body.nodes[e]=s}this.layoutEngine.positionInitially(n),!1===i&&this.body.emitter.emit("_dataChanged")}},{key:"update",value:function(t,e,i){for(var n=this.body.nodes,o=!1,r=0;r<t.length;r++){var s=t[r],a=n[s],h=e[r];void 0!==a?a.setOptions(h)&&(o=!0):(o=!0,a=this.create(h),n[s]=a)}o||void 0===i||(o=cO(e).call(e,(function(t,e){var n=i[e];return n&&n.level!==t.level}))),!0===o?this.body.emitter.emit("_dataChanged"):this.body.emitter.emit("_dataUpdated")}},{key:"remove",value:function(t){for(var e=this.body.nodes,i=0;i<t.length;i++){delete e[t[i]]}this.body.emitter.emit("_dataChanged")}},{key:"create",value:function(t){return new(arguments.length>1&&void 0!==arguments[1]?arguments[1]:TN)(t,this.body,this.images,this.groups,this.options,this.defaultOptions)}},{key:"refresh",value:function(){var t=this,e=arguments.length>0&&void 0!==arguments[0]&&arguments[0];$x(this.body.nodes,(function(i,n){var o=t.body.data.nodes.get(n);void 0!==o&&(!0===e&&i.setOptions({x:null,y:null}),i.setOptions({fixed:!1}),i.setOptions(o))}))}},{key:"getPositions",value:function(t){var e={};if(void 0!==t){if(!0===Wp(t)){for(var i=0;i<t.length;i++)if(void 0!==this.body.nodes[t[i]]){var n=this.body.nodes[t[i]];e[t[i]]={x:Math.round(n.x),y:Math.round(n.y)}}}else if(void 0!==this.body.nodes[t]){var o=this.body.nodes[t];e[t]={x:Math.round(o.x),y:Math.round(o.y)}}}else for(var r=0;r<this.body.nodeIndices.length;r++){var s=this.body.nodes[this.body.nodeIndices[r]];e[this.body.nodeIndices[r]]={x:Math.round(s.x),y:Math.round(s.y)}}return e}},{key:"getPosition",value:function(t){if(null==t)throw new TypeError("No id was specified for getPosition method.");if(null==this.body.nodes[t])throw new ReferenceError("NodeId provided for getPosition does not exist. Provided: ".concat(t));return{x:Math.round(this.body.nodes[t].x),y:Math.round(this.body.nodes[t].y)}}},{key:"storePositions",value:function(){var t,e=[],i=this.body.data.nodes.getDataSet(),n=MN(i.get());try{for(n.s();!(t=n.n()).done;){var o=t.value,r=o.id,s=this.body.nodes[r],a=Math.round(s.x),h=Math.round(s.y);o.x===a&&o.y===h||e.push({id:r,x:a,y:h})}}catch(t){n.e(t)}finally{n.f()}i.update(e)}},{key:"getBoundingBox",value:function(t){if(void 0!==this.body.nodes[t])return this.body.nodes[t].shape.boundingBox}},{key:"getConnectedNodes",value:function(t,e){var i=[];if(void 0!==this.body.nodes[t])for(var n=this.body.nodes[t],o={},r=0;r<n.edges.length;r++){var s=n.edges[r];"to"!==e&&s.toId==n.id?void 0===o[s.fromId]&&(i.push(s.fromId),o[s.fromId]=!0):"from"!==e&&s.fromId==n.id&&void 0===o[s.toId]&&(i.push(s.toId),o[s.toId]=!0)}return i}},{key:"getConnectedEdges",value:function(t){var e=[];if(void 0!==this.body.nodes[t])for(var i=this.body.nodes[t],n=0;n<i.edges.length;n++)e.push(i.edges[n].id);else console.error("NodeId provided for getConnectedEdges does not exist. Provided: ",t);return e}},{key:"moveNode",value:function(t,e,i){var n=this;void 0!==this.body.nodes[t]?(this.body.nodes[t].x=Number(e),this.body.nodes[t].y=Number(i),Gm((function(){n.body.emitter.emit("startSimulation")}),0)):console.error("Node id supplied to moveNode does not exist. Provided: ",t)}}]),t}(),IN={},BN={get exports(){return IN},set exports(t){IN=t}},NN={},zN={get exports(){return NN},set exports(t){NN=t}},FN=Jt,AN=N,jN=it,RN=ni,LN=function(t){return void 0!==t&&(FN(t,"value")||FN(t,"writable"))},HN=P,WN=Nr;Mi({target:"Reflect",stat:!0},{get:function t(e,i){var n,o,r=arguments.length<3?e:arguments[2];return RN(e)===r?e[i]:(n=HN.f(e,i))?LN(n)?n.value:void 0===n.get?void 0:AN(n.get,r):jN(o=WN(e))?t(o,i,r):void 0}});var qN=nt.Reflect.get;!function(t){t.exports=qN}(zN),function(t){t.exports=NN}(BN);var VN=i(IN),UN={},YN={get exports(){return UN},set exports(t){UN=t}},XN={},GN=Pc;!function(t){t.exports=GN}({get exports(){return XN},set exports(t){XN=t}}),function(t){t.exports=XN}(YN);var KN=i(UN);function $N(){var t;"undefined"!=typeof Reflect&&VN?$N=TO(t=VN).call(t):$N=function(t,e,i){var n=function(t,e){for(;!Object.prototype.hasOwnProperty.call(t,e)&&null!==(t=AO(t)););return t}(t,e);if(n){var o=KN(n,e);return o.get?o.get.call(arguments.length<3?t:i):o.value}};return $N.apply(this,arguments)}var ZN={},QN={get exports(){return ZN},set exports(t){ZN=t}},JN=Mi,tz=Math.hypot,ez=Math.abs,iz=Math.sqrt;JN({target:"Math",stat:!0,arity:2,forced:!!tz&&tz(1/0,NaN)!==1/0},{hypot:function(t,e){for(var i,n,o=0,r=0,s=arguments.length,a=0;r<s;)a<(i=ez(arguments[r++]))?(o=o*(n=a/i)*n+1,a=i):o+=i>0?(n=i/a)*n:i;return a===1/0?1/0:a*iz(o)}});var nz=nt.Math.hypot;!function(t){t.exports=nz}(QN);var oz=i(ZN);function rz(t){var e=function(){if("undefined"==typeof Reflect||!jI)return!1;if(jI.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(jI(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=AO(t);if(e){var o=AO(this).constructor;i=jI(n,arguments,o)}else i=n.apply(this,arguments);return DO(this,i)}}var sz=function(){function t(){pu(this,t)}return Nf(t,null,[{key:"transform",value:function(t,e){Wp(t)||(t=[t]);for(var i=e.point.x,n=e.point.y,o=e.angle,r=e.length,s=0;s<t.length;++s){var a=t[s],h=a.x*Math.cos(o)-a.y*Math.sin(o),l=a.x*Math.sin(o)+a.y*Math.cos(o);a.x=i+r*h,a.y=n+r*l}}},{key:"drawPath",value:function(t,e){t.beginPath(),t.moveTo(e[0].x,e[0].y);for(var i=1;i<e.length;++i)t.lineTo(e[i].x,e[i].y);t.closePath()}}]),t}(),az=function(t){PO(i,t);var e=rz(i);function i(){return pu(this,i),e.apply(this,arguments)}return Nf(i,null,[{key:"draw",value:function(t,e){if(e.image){t.save(),t.translate(e.point.x,e.point.y),t.rotate(Math.PI/2+e.angle);var i=null!=e.imageWidth?e.imageWidth:e.image.width,n=null!=e.imageHeight?e.imageHeight:e.image.height;e.image.drawImageAtPosition(t,1,-i/2,0,i,n),t.restore()}return!1}}]),i}(sz),hz=function(t){PO(i,t);var e=rz(i);function i(){return pu(this,i),e.apply(this,arguments)}return Nf(i,null,[{key:"draw",value:function(t,e){var i=[{x:0,y:0},{x:-1,y:.3},{x:-.9,y:0},{x:-1,y:-.3}];return sz.transform(i,e),sz.drawPath(t,i),!0}}]),i}(sz),lz=function(){function t(){pu(this,t)}return Nf(t,null,[{key:"draw",value:function(t,e){var i=[{x:-1,y:0},{x:0,y:.3},{x:-.4,y:0},{x:0,y:-.3}];return sz.transform(i,e),sz.drawPath(t,i),!0}}]),t}(),dz=function(){function t(){pu(this,t)}return Nf(t,null,[{key:"draw",value:function(t,e){var i={x:-.4,y:0};sz.transform(i,e),t.strokeStyle=t.fillStyle,t.fillStyle="rgba(0, 0, 0, 0)";var n=Math.PI,o=e.angle-n/2,r=e.angle+n/2;return t.beginPath(),t.arc(i.x,i.y,.4*e.length,o,r,!1),t.stroke(),!0}}]),t}(),cz=function(){function t(){pu(this,t)}return Nf(t,null,[{key:"draw",value:function(t,e){var i={x:-.3,y:0};sz.transform(i,e),t.strokeStyle=t.fillStyle,t.fillStyle="rgba(0, 0, 0, 0)";var n=Math.PI,o=e.angle+n/2,r=e.angle+3*n/2;return t.beginPath(),t.arc(i.x,i.y,.4*e.length,o,r,!1),t.stroke(),!0}}]),t}(),uz=function(){function t(){pu(this,t)}return Nf(t,null,[{key:"draw",value:function(t,e){var i=[{x:.02,y:0},{x:-1,y:.3},{x:-1,y:-.3}];return sz.transform(i,e),sz.drawPath(t,i),!0}}]),t}(),fz=function(){function t(){pu(this,t)}return Nf(t,null,[{key:"draw",value:function(t,e){var i=[{x:0,y:.3},{x:0,y:-.3},{x:-1,y:0}];return sz.transform(i,e),sz.drawPath(t,i),!0}}]),t}(),pz=function(){function t(){pu(this,t)}return Nf(t,null,[{key:"draw",value:function(t,e){var i={x:-.4,y:0};return sz.transform(i,e),Xn(t,i.x,i.y,.4*e.length),!0}}]),t}(),vz=function(){function t(){pu(this,t)}return Nf(t,null,[{key:"draw",value:function(t,e){var i=[{x:0,y:.5},{x:0,y:-.5},{x:-.15,y:-.5},{x:-.15,y:.5}];return sz.transform(i,e),sz.drawPath(t,i),!0}}]),t}(),gz=function(){function t(){pu(this,t)}return Nf(t,null,[{key:"draw",value:function(t,e){var i=[{x:0,y:.3},{x:0,y:-.3},{x:-.6,y:-.3},{x:-.6,y:.3}];return sz.transform(i,e),sz.drawPath(t,i),!0}}]),t}(),yz=function(){function t(){pu(this,t)}return Nf(t,null,[{key:"draw",value:function(t,e){var i=[{x:0,y:0},{x:-.5,y:-.3},{x:-1,y:0},{x:-.5,y:.3}];return sz.transform(i,e),sz.drawPath(t,i),!0}}]),t}(),mz=function(){function t(){pu(this,t)}return Nf(t,null,[{key:"draw",value:function(t,e){var i=[{x:-1,y:.3},{x:-.5,y:0},{x:-1,y:-.3},{x:0,y:0}];return sz.transform(i,e),sz.drawPath(t,i),!0}}]),t}(),bz=function(){function t(){pu(this,t)}return Nf(t,null,[{key:"draw",value:function(t,e){var i;switch(e.type&&(i=e.type.toLowerCase()),i){case"image":return az.draw(t,e);case"circle":return pz.draw(t,e);case"box":return gz.draw(t,e);case"crow":return lz.draw(t,e);case"curve":return dz.draw(t,e);case"diamond":return yz.draw(t,e);case"inv_curve":return cz.draw(t,e);case"triangle":return uz.draw(t,e);case"inv_triangle":return fz.draw(t,e);case"bar":return vz.draw(t,e);case"vee":return mz.draw(t,e);default:return hz.draw(t,e)}}}]),t}();function wz(t,e){var i=ov(t);if(mc){var n=mc(t);e&&(n=ny(n).call(n,(function(e){return Dc(t,e).enumerable}))),i.push.apply(i,n)}return i}function xz(t){for(var e=1;e<arguments.length;e++){var i,n,o=null!=arguments[e]?arguments[e]:{};e%2?Cv(i=wz(Object(o),!0)).call(i,(function(e){zf(t,e,o[e])})):Uc?iu(t,Uc(o)):Cv(n=wz(Object(o))).call(n,(function(e){fu(t,e,Dc(o,e))}))}return t}var kz=function(){function t(e,i,n){pu(this,t),this._body=i,this._labelModule=n,this.color={},this.colorDirty=!0,this.hoverWidth=1.5,this.selectionWidth=2,this.setOptions(e),this.fromPoint=this.from,this.toPoint=this.to}return Nf(t,[{key:"connect",value:function(){this.from=this._body.nodes[this.options.from],this.to=this._body.nodes[this.options.to]}},{key:"cleanup",value:function(){return!1}},{key:"setOptions",value:function(t){this.options=t,this.from=this._body.nodes[this.options.from],this.to=this._body.nodes[this.options.to],this.id=this.options.id}},{key:"drawLine",value:function(t,e,i,n){var o=arguments.length>4&&void 0!==arguments[4]?arguments[4]:this.getViaNode();t.strokeStyle=this.getColor(t,e),t.lineWidth=e.width,!1!==e.dashes?this._drawDashedLine(t,e,o):this._drawLine(t,e,o)}},{key:"_drawLine",value:function(t,e,i,n,o){if(this.from!=this.to)this._line(t,e,i,n,o);else{var r=kp(this._getCircleData(t),3),s=r[0],a=r[1],h=r[2];this._circle(t,e,s,a,h)}}},{key:"_drawDashedLine",value:function(t,e,i,n,o){t.lineCap="round";var r=Wp(e.dashes)?e.dashes:[5,5];if(void 0!==t.setLineDash){if(t.save(),t.setLineDash(r),t.lineDashOffset=0,this.from!=this.to)this._line(t,e,i);else{var s=kp(this._getCircleData(t),3),a=s[0],h=s[1],l=s[2];this._circle(t,e,a,h,l)}t.setLineDash([0]),t.lineDashOffset=0,t.restore()}else{if(this.from!=this.to)Zn(t,this.from.x,this.from.y,this.to.x,this.to.y,r);else{var d=kp(this._getCircleData(t),3),c=d[0],u=d[1],f=d[2];this._circle(t,e,c,u,f)}this.enableShadow(t,e),t.stroke(),this.disableShadow(t,e)}}},{key:"findBorderPosition",value:function(t,e,i){return this.from!=this.to?this._findBorderPosition(t,e,i):this._findBorderPositionCircle(t,e,i)}},{key:"findBorderPositions",value:function(t){if(this.from!=this.to)return{from:this._findBorderPosition(this.from,t),to:this._findBorderPosition(this.to,t)};var e,i=kp(Fp(e=this._getCircleData(t)).call(e,0,2),2),n=i[0],o=i[1];return{from:this._findBorderPositionCircle(this.from,t,{x:n,y:o,low:.25,high:.6,direction:-1}),to:this._findBorderPositionCircle(this.from,t,{x:n,y:o,low:.6,high:.8,direction:1})}}},{key:"_getCircleData",value:function(t){var e=this.options.selfReference.size;void 0!==t&&void 0===this.from.shape.width&&this.from.shape.resize(t);var i=NB(t,this.options.selfReference.angle,e,this.from);return[i.x,i.y,e]}},{key:"_pointOnCircle",value:function(t,e,i,n){var o=2*n*Math.PI;return{x:t+i*Math.cos(o),y:e-i*Math.sin(o)}}},{key:"_findBorderPositionCircle",value:function(t,e,i){var n,o=i.x,r=i.y,s=i.low,a=i.high,h=i.direction,l=this.options.selfReference.size,d=.5*(s+a),c=0;!0===this.options.arrowStrikethrough&&(-1===h?c=this.options.endPointOffset.from:1===h&&(c=this.options.endPointOffset.to));var u=0;do{d=.5*(s+a),n=this._pointOnCircle(o,r,l,d);var f=Math.atan2(t.y-n.y,t.x-n.x),p=t.distanceToBorder(e,f)+c-Math.sqrt(Math.pow(n.x-t.x,2)+Math.pow(n.y-t.y,2));if(Math.abs(p)<.05)break;p>0?h>0?s=d:a=d:h>0?a=d:s=d,++u}while(s<=a&&u<10);return xz(xz({},n),{},{t:d})}},{key:"getLineWidth",value:function(t,e){return!0===t?Math.max(this.selectionWidth,.3/this._body.view.scale):!0===e?Math.max(this.hoverWidth,.3/this._body.view.scale):Math.max(this.options.width,.3/this._body.view.scale)}},{key:"getColor",value:function(t,e){if(!1!==e.inheritsColor){if("both"===e.inheritsColor&&this.from.id!==this.to.id){var i=t.createLinearGradient(this.from.x,this.from.y,this.to.x,this.to.y),n=this.from.options.color.highlight.border,o=this.to.options.color.highlight.border;return!1===this.from.selected&&!1===this.to.selected?(n=ik(this.from.options.color.border,e.opacity),o=ik(this.to.options.color.border,e.opacity)):!0===this.from.selected&&!1===this.to.selected?o=this.to.options.color.border:!1===this.from.selected&&!0===this.to.selected&&(n=this.from.options.color.border),i.addColorStop(0,n),i.addColorStop(1,o),i}return"to"===e.inheritsColor?ik(this.to.options.color.border,e.opacity):ik(this.from.options.color.border,e.opacity)}return ik(e.color,e.opacity)}},{key:"_circle",value:function(t,e,i,n,o){this.enableShadow(t,e);var r=0,s=2*Math.PI;if(!this.options.selfReference.renderBehindTheNode){var a=this.options.selfReference.angle,h=this.options.selfReference.angle+Math.PI,l=this._findBorderPositionCircle(this.from,t,{x:i,y:n,low:a,high:h,direction:-1}),d=this._findBorderPositionCircle(this.from,t,{x:i,y:n,low:a,high:h,direction:1});r=Math.atan2(l.y-n,l.x-i),s=Math.atan2(d.y-n,d.x-i)}t.beginPath(),t.arc(i,n,o,r,s,!1),t.stroke(),this.disableShadow(t,e)}},{key:"getDistanceToEdge",value:function(t,e,i,n,o,r){if(this.from!=this.to)return this._getDistanceToEdge(t,e,i,n,o,r);var s=kp(this._getCircleData(void 0),3),a=s[0],h=s[1],l=s[2],d=a-o,c=h-r;return Math.abs(Math.sqrt(d*d+c*c)-l)}},{key:"_getDistanceToLine",value:function(t,e,i,n,o,r){var s=i-t,a=n-e,h=((o-t)*s+(r-e)*a)/(s*s+a*a);h>1?h=1:h<0&&(h=0);var l=t+h*s-o,d=e+h*a-r;return Math.sqrt(l*l+d*d)}},{key:"getArrowData",value:function(t,e,i,n,o,r){var s,a,h,l,d,c,u,f=r.width;"from"===e?(h=this.from,l=this.to,d=r.fromArrowScale<0,c=Math.abs(r.fromArrowScale),u=r.fromArrowType):"to"===e?(h=this.to,l=this.from,d=r.toArrowScale<0,c=Math.abs(r.toArrowScale),u=r.toArrowType):(h=this.to,l=this.from,d=r.middleArrowScale<0,c=Math.abs(r.middleArrowScale),u=r.middleArrowType);var p=15*c+3*f;if(h!=l){var v=p/oz(h.x-l.x,h.y-l.y);if("middle"!==e)if(!0===this.options.smooth.enabled){var g=this._findBorderPosition(h,t,{via:i}),y=this.getPoint(g.t+v*("from"===e?1:-1),i);s=Math.atan2(g.y-y.y,g.x-y.x),a=g}else s=Math.atan2(h.y-l.y,h.x-l.x),a=this._findBorderPosition(h,t);else{var m=(d?-v:v)/2,b=this.getPoint(.5+m,i),w=this.getPoint(.5-m,i);s=Math.atan2(b.y-w.y,b.x-w.x),a=this.getPoint(.5,i)}}else{var x=kp(this._getCircleData(t),3),k=x[0],_=x[1],E=x[2];if("from"===e){var O=this.options.selfReference.angle,C=this.options.selfReference.angle+Math.PI,S=this._findBorderPositionCircle(this.from,t,{x:k,y:_,low:O,high:C,direction:-1});s=-2*S.t*Math.PI+1.5*Math.PI+.1*Math.PI,a=S}else if("to"===e){var T=this.options.selfReference.angle,M=this.options.selfReference.angle+Math.PI,P=this._findBorderPositionCircle(this.from,t,{x:k,y:_,low:T,high:M,direction:1});s=-2*P.t*Math.PI+1.5*Math.PI-1.1*Math.PI,a=P}else{var D=this.options.selfReference.angle/(2*Math.PI);a=this._pointOnCircle(k,_,E,D),s=-2*D*Math.PI+1.5*Math.PI+.1*Math.PI}}return{point:a,core:{x:a.x-.9*p*Math.cos(s),y:a.y-.9*p*Math.sin(s)},angle:s,length:p,type:u}}},{key:"drawArrowHead",value:function(t,e,i,n,o){t.strokeStyle=this.getColor(t,e),t.fillStyle=t.strokeStyle,t.lineWidth=e.width,bz.draw(t,o)&&(this.enableShadow(t,e),hb(t).call(t),this.disableShadow(t,e))}},{key:"enableShadow",value:function(t,e){!0===e.shadow&&(t.shadowColor=e.shadowColor,t.shadowBlur=e.shadowSize,t.shadowOffsetX=e.shadowX,t.shadowOffsetY=e.shadowY)}},{key:"disableShadow",value:function(t,e){!0===e.shadow&&(t.shadowColor="rgba(0,0,0,0)",t.shadowBlur=0,t.shadowOffsetX=0,t.shadowOffsetY=0)}},{key:"drawBackground",value:function(t,e){if(!1!==e.background){var i={strokeStyle:t.strokeStyle,lineWidth:t.lineWidth,dashes:t.dashes};t.strokeStyle=e.backgroundColor,t.lineWidth=e.backgroundSize,this.setStrokeDashed(t,e.backgroundDashes),t.stroke(),t.strokeStyle=i.strokeStyle,t.lineWidth=i.lineWidth,t.dashes=i.dashes,this.setStrokeDashed(t,e.dashes)}}},{key:"setStrokeDashed",value:function(t,e){if(!1!==e)if(void 0!==t.setLineDash){var i=Wp(e)?e:[5,5];t.setLineDash(i)}else console.warn("setLineDash is not supported in this browser. The dashed stroke cannot be used.");else void 0!==t.setLineDash?t.setLineDash([]):console.warn("setLineDash is not supported in this browser. The dashed stroke cannot be used.")}}]),t}();function _z(t,e){var i=ov(t);if(mc){var n=mc(t);e&&(n=ny(n).call(n,(function(e){return Dc(t,e).enumerable}))),i.push.apply(i,n)}return i}function Ez(t){for(var e=1;e<arguments.length;e++){var i,n,o=null!=arguments[e]?arguments[e]:{};e%2?Cv(i=_z(Object(o),!0)).call(i,(function(e){zf(t,e,o[e])})):Uc?iu(t,Uc(o)):Cv(n=_z(Object(o))).call(n,(function(e){fu(t,e,Dc(o,e))}))}return t}function Oz(t){var e=function(){if("undefined"==typeof Reflect||!jI)return!1;if(jI.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(jI(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=AO(t);if(e){var o=AO(this).constructor;i=jI(n,arguments,o)}else i=n.apply(this,arguments);return DO(this,i)}}var Cz=function(t){PO(i,t);var e=Oz(i);function i(t,n,o){return pu(this,i),e.call(this,t,n,o)}return Nf(i,[{key:"_findBorderPositionBezier",value:function(t,e){var i,n,o=arguments.length>2&&void 0!==arguments[2]?arguments[2]:this._getViaCoordinates(),r=!1,s=1,a=0,h=this.to,l=this.options.endPointOffset?this.options.endPointOffset.to:0;t.id===this.from.id&&(h=this.from,r=!0,l=this.options.endPointOffset?this.options.endPointOffset.from:0),!1===this.options.arrowStrikethrough&&(l=0);var d=0;do{n=.5*(a+s),i=this.getPoint(n,o);var c=Math.atan2(h.y-i.y,h.x-i.x),u=h.distanceToBorder(e,c)+l-Math.sqrt(Math.pow(i.x-h.x,2)+Math.pow(i.y-h.y,2));if(Math.abs(u)<.2)break;u<0?!1===r?a=n:s=n:!1===r?s=n:a=n,++d}while(a<=s&&d<10);return Ez(Ez({},i),{},{t:n})}},{key:"_getDistanceToBezierEdge",value:function(t,e,i,n,o,r,s){var a,h,l,d,c,u=1e9,f=t,p=e;for(h=1;h<10;h++)l=.1*h,d=Math.pow(1-l,2)*t+2*l*(1-l)*s.x+Math.pow(l,2)*i,c=Math.pow(1-l,2)*e+2*l*(1-l)*s.y+Math.pow(l,2)*n,h>0&&(u=(a=this._getDistanceToLine(f,p,d,c,o,r))<u?a:u),f=d,p=c;return u}},{key:"_bezierCurve",value:function(t,e,i,n){t.beginPath(),t.moveTo(this.fromPoint.x,this.fromPoint.y),null!=i&&null!=i.x?null!=n&&null!=n.x?t.bezierCurveTo(i.x,i.y,n.x,n.y,this.toPoint.x,this.toPoint.y):t.quadraticCurveTo(i.x,i.y,this.toPoint.x,this.toPoint.y):t.lineTo(this.toPoint.x,this.toPoint.y),this.drawBackground(t,e),this.enableShadow(t,e),t.stroke(),this.disableShadow(t,e)}},{key:"getViaNode",value:function(){return this._getViaCoordinates()}}]),i}(kz);function Sz(t){var e=function(){if("undefined"==typeof Reflect||!jI)return!1;if(jI.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(jI(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=AO(t);if(e){var o=AO(this).constructor;i=jI(n,arguments,o)}else i=n.apply(this,arguments);return DO(this,i)}}var Tz=function(t){PO(i,t);var e=Sz(i);function i(t,n,o){var r;return pu(this,i),(r=e.call(this,t,n,o)).via=r.via,r._boundFunction=function(){r.positionBezierNode()},r._body.emitter.on("_repositionBezierNodes",r._boundFunction),r}return Nf(i,[{key:"setOptions",value:function(t){$N(AO(i.prototype),"setOptions",this).call(this,t);var e=!1;this.options.physics!==t.physics&&(e=!0),this.options=t,this.id=this.options.id,this.from=this._body.nodes[this.options.from],this.to=this._body.nodes[this.options.to],this.setupSupportNode(),this.connect(),!0===e&&(this.via.setOptions({physics:this.options.physics}),this.positionBezierNode())}},{key:"connect",value:function(){this.from=this._body.nodes[this.options.from],this.to=this._body.nodes[this.options.to],void 0===this.from||void 0===this.to||!1===this.options.physics||this.from.id===this.to.id?this.via.setOptions({physics:!1}):this.via.setOptions({physics:!0})}},{key:"cleanup",value:function(){return this._body.emitter.off("_repositionBezierNodes",this._boundFunction),void 0!==this.via&&(delete this._body.nodes[this.via.id],this.via=void 0,!0)}},{key:"setupSupportNode",value:function(){if(void 0===this.via){var t="edgeId:"+this.id,e=this._body.functions.createNode({id:t,shape:"circle",physics:!0,hidden:!0});this._body.nodes[t]=e,this.via=e,this.via.parentEdgeId=this.id,this.positionBezierNode()}}},{key:"positionBezierNode",value:function(){void 0!==this.via&&void 0!==this.from&&void 0!==this.to?(this.via.x=.5*(this.from.x+this.to.x),this.via.y=.5*(this.from.y+this.to.y)):void 0!==this.via&&(this.via.x=0,this.via.y=0)}},{key:"_line",value:function(t,e,i){this._bezierCurve(t,e,i)}},{key:"_getViaCoordinates",value:function(){return this.via}},{key:"getViaNode",value:function(){return this.via}},{key:"getPoint",value:function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:this.via;if(this.from===this.to){var i=kp(this._getCircleData(),3),n=i[0],o=i[1],r=i[2],s=2*Math.PI*(1-t);return{x:n+r*Math.sin(s),y:o+r-r*(1-Math.cos(s))}}return{x:Math.pow(1-t,2)*this.fromPoint.x+2*t*(1-t)*e.x+Math.pow(t,2)*this.toPoint.x,y:Math.pow(1-t,2)*this.fromPoint.y+2*t*(1-t)*e.y+Math.pow(t,2)*this.toPoint.y}}},{key:"_findBorderPosition",value:function(t,e){return this._findBorderPositionBezier(t,e,this.via)}},{key:"_getDistanceToEdge",value:function(t,e,i,n,o,r){return this._getDistanceToBezierEdge(t,e,i,n,o,r,this.via)}}]),i}(Cz);function Mz(t){var e=function(){if("undefined"==typeof Reflect||!jI)return!1;if(jI.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(jI(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=AO(t);if(e){var o=AO(this).constructor;i=jI(n,arguments,o)}else i=n.apply(this,arguments);return DO(this,i)}}var Pz=function(t){PO(i,t);var e=Mz(i);function i(t,n,o){return pu(this,i),e.call(this,t,n,o)}return Nf(i,[{key:"_line",value:function(t,e,i){this._bezierCurve(t,e,i)}},{key:"getViaNode",value:function(){return this._getViaCoordinates()}},{key:"_getViaCoordinates",value:function(){var t,e,i=this.options.smooth.roundness,n=this.options.smooth.type,o=Math.abs(this.from.x-this.to.x),r=Math.abs(this.from.y-this.to.y);if("discrete"===n||"diagonalCross"===n){var s,a;s=a=o<=r?i*r:i*o,this.from.x>this.to.x&&(s=-s),this.from.y>=this.to.y&&(a=-a);var h=this.from.x+s,l=this.from.y+a;return"discrete"===n&&(o<=r?h=o<i*r?this.from.x:h:l=r<i*o?this.from.y:l),{x:h,y:l}}if("straightCross"===n){var d=(1-i)*o,c=(1-i)*r;return o<=r?(d=0,this.from.y<this.to.y&&(c=-c)):(this.from.x<this.to.x&&(d=-d),c=0),{x:this.to.x+d,y:this.to.y+c}}if("horizontal"===n){var u=(1-i)*o;return this.from.x<this.to.x&&(u=-u),{x:this.to.x+u,y:this.from.y}}if("vertical"===n){var f=(1-i)*r;return this.from.y<this.to.y&&(f=-f),{x:this.from.x,y:this.to.y+f}}if("curvedCW"===n){o=this.to.x-this.from.x,r=this.from.y-this.to.y;var p=Math.sqrt(o*o+r*r),v=Math.PI,g=(Math.atan2(r,o)+(.5*i+.5)*v)%(2*v);return{x:this.from.x+(.5*i+.5)*p*Math.sin(g),y:this.from.y+(.5*i+.5)*p*Math.cos(g)}}if("curvedCCW"===n){o=this.to.x-this.from.x,r=this.from.y-this.to.y;var y=Math.sqrt(o*o+r*r),m=Math.PI,b=(Math.atan2(r,o)+(.5*-i+.5)*m)%(2*m);return{x:this.from.x+(.5*i+.5)*y*Math.sin(b),y:this.from.y+(.5*i+.5)*y*Math.cos(b)}}t=e=o<=r?i*r:i*o,this.from.x>this.to.x&&(t=-t),this.from.y>=this.to.y&&(e=-e);var w=this.from.x+t,x=this.from.y+e;return o<=r?w=this.from.x<=this.to.x?this.to.x<w?this.to.x:w:this.to.x>w?this.to.x:w:x=this.from.y>=this.to.y?this.to.y>x?this.to.y:x:this.to.y<x?this.to.y:x,{x:w,y:x}}},{key:"_findBorderPosition",value:function(t,e){var i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:{};return this._findBorderPositionBezier(t,e,i.via)}},{key:"_getDistanceToEdge",value:function(t,e,i,n,o,r){var s=arguments.length>6&&void 0!==arguments[6]?arguments[6]:this._getViaCoordinates();return this._getDistanceToBezierEdge(t,e,i,n,o,r,s)}},{key:"getPoint",value:function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:this._getViaCoordinates(),i=t;return{x:Math.pow(1-i,2)*this.fromPoint.x+2*i*(1-i)*e.x+Math.pow(i,2)*this.toPoint.x,y:Math.pow(1-i,2)*this.fromPoint.y+2*i*(1-i)*e.y+Math.pow(i,2)*this.toPoint.y}}}]),i}(Cz);function Dz(t){var e=function(){if("undefined"==typeof Reflect||!jI)return!1;if(jI.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(jI(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=AO(t);if(e){var o=AO(this).constructor;i=jI(n,arguments,o)}else i=n.apply(this,arguments);return DO(this,i)}}var Iz=function(t){PO(i,t);var e=Dz(i);function i(t,n,o){return pu(this,i),e.call(this,t,n,o)}return Nf(i,[{key:"_getDistanceToBezierEdge2",value:function(t,e,i,n,o,r,s,a){for(var h=1e9,l=t,d=e,c=[0,0,0,0],u=1;u<10;u++){var f=.1*u;c[0]=Math.pow(1-f,3),c[1]=3*f*Math.pow(1-f,2),c[2]=3*Math.pow(f,2)*(1-f),c[3]=Math.pow(f,3);var p=c[0]*t+c[1]*s.x+c[2]*a.x+c[3]*i,v=c[0]*e+c[1]*s.y+c[2]*a.y+c[3]*n;if(u>0){var g=this._getDistanceToLine(l,d,p,v,o,r);h=g<h?g:h}l=p,d=v}return h}}]),i}(Cz);function Bz(t){var e=function(){if("undefined"==typeof Reflect||!jI)return!1;if(jI.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(jI(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=AO(t);if(e){var o=AO(this).constructor;i=jI(n,arguments,o)}else i=n.apply(this,arguments);return DO(this,i)}}var Nz=function(t){PO(i,t);var e=Bz(i);function i(t,n,o){return pu(this,i),e.call(this,t,n,o)}return Nf(i,[{key:"_line",value:function(t,e,i){var n=i[0],o=i[1];this._bezierCurve(t,e,n,o)}},{key:"_getViaCoordinates",value:function(){var t,e,i,n,o=this.from.x-this.to.x,r=this.from.y-this.to.y,s=this.options.smooth.roundness;return(Math.abs(o)>Math.abs(r)||!0===this.options.smooth.forceDirection||"horizontal"===this.options.smooth.forceDirection)&&"vertical"!==this.options.smooth.forceDirection?(e=this.from.y,n=this.to.y,t=this.from.x-s*o,i=this.to.x+s*o):(e=this.from.y-s*r,n=this.to.y+s*r,t=this.from.x,i=this.to.x),[{x:t,y:e},{x:i,y:n}]}},{key:"getViaNode",value:function(){return this._getViaCoordinates()}},{key:"_findBorderPosition",value:function(t,e){return this._findBorderPositionBezier(t,e)}},{key:"_getDistanceToEdge",value:function(t,e,i,n,o,r){var s=kp(arguments.length>6&&void 0!==arguments[6]?arguments[6]:this._getViaCoordinates(),2),a=s[0],h=s[1];return this._getDistanceToBezierEdge2(t,e,i,n,o,r,a,h)}},{key:"getPoint",value:function(t){var e=kp(arguments.length>1&&void 0!==arguments[1]?arguments[1]:this._getViaCoordinates(),2),i=e[0],n=e[1],o=t,r=[Math.pow(1-o,3),3*o*Math.pow(1-o,2),3*Math.pow(o,2)*(1-o),Math.pow(o,3)];return{x:r[0]*this.fromPoint.x+r[1]*i.x+r[2]*n.x+r[3]*this.toPoint.x,y:r[0]*this.fromPoint.y+r[1]*i.y+r[2]*n.y+r[3]*this.toPoint.y}}}]),i}(Iz);function zz(t){var e=function(){if("undefined"==typeof Reflect||!jI)return!1;if(jI.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(jI(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=AO(t);if(e){var o=AO(this).constructor;i=jI(n,arguments,o)}else i=n.apply(this,arguments);return DO(this,i)}}var Fz=function(t){PO(i,t);var e=zz(i);function i(t,n,o){return pu(this,i),e.call(this,t,n,o)}return Nf(i,[{key:"_line",value:function(t,e){t.beginPath(),t.moveTo(this.fromPoint.x,this.fromPoint.y),t.lineTo(this.toPoint.x,this.toPoint.y),this.enableShadow(t,e),t.stroke(),this.disableShadow(t,e)}},{key:"getViaNode",value:function(){}},{key:"getPoint",value:function(t){return{x:(1-t)*this.fromPoint.x+t*this.toPoint.x,y:(1-t)*this.fromPoint.y+t*this.toPoint.y}}},{key:"_findBorderPosition",value:function(t,e){var i=this.to,n=this.from;t.id===this.from.id&&(i=this.from,n=this.to);var o=Math.atan2(i.y-n.y,i.x-n.x),r=i.x-n.x,s=i.y-n.y,a=Math.sqrt(r*r+s*s),h=(a-t.distanceToBorder(e,o))/a;return{x:(1-h)*n.x+h*i.x,y:(1-h)*n.y+h*i.y,t:0}}},{key:"_getDistanceToEdge",value:function(t,e,i,n,o,r){return this._getDistanceToLine(t,e,i,n,o,r)}}]),i}(kz),Az=function(){function t(e,i,n,o,r){if(pu(this,t),void 0===i)throw new Error("No body provided");this.options=fk(o),this.globalOptions=o,this.defaultOptions=r,this.body=i,this.imagelist=n,this.id=void 0,this.fromId=void 0,this.toId=void 0,this.selected=!1,this.hover=!1,this.labelDirty=!0,this.baseWidth=this.options.width,this.baseFontSize=this.options.font.size,this.from=void 0,this.to=void 0,this.edgeType=void 0,this.connected=!1,this.labelModule=new LB(this.body,this.options,!0),this.setOptions(e)}return Nf(t,[{key:"setOptions",value:function(e){if(e){var i=void 0!==e.physics&&this.options.physics!==e.physics||void 0!==e.hidden&&(this.options.hidden||!1)!==(e.hidden||!1)||void 0!==e.from&&this.options.from!==e.from||void 0!==e.to&&this.options.to!==e.to;t.parseOptions(this.options,e,!0,this.globalOptions),void 0!==e.id&&(this.id=e.id),void 0!==e.from&&(this.fromId=e.from),void 0!==e.to&&(this.toId=e.to),void 0!==e.title&&(this.title=e.title),void 0!==e.value&&(e.value=xB(e.value));var n=[e,this.options,this.defaultOptions];return this.chooser=DB("edge",n),this.updateLabelModule(e),i=this.updateEdgeType()||i,this._setInteractionWidths(),this.connect(),i}}},{key:"getFormattingValues",value:function(){var t=!0===this.options.arrows.to||!0===this.options.arrows.to.enabled,e=!0===this.options.arrows.from||!0===this.options.arrows.from.enabled,i=!0===this.options.arrows.middle||!0===this.options.arrows.middle.enabled,n=this.options.color.inherit,o={toArrow:t,toArrowScale:this.options.arrows.to.scaleFactor,toArrowType:this.options.arrows.to.type,toArrowSrc:this.options.arrows.to.src,toArrowImageWidth:this.options.arrows.to.imageWidth,toArrowImageHeight:this.options.arrows.to.imageHeight,middleArrow:i,middleArrowScale:this.options.arrows.middle.scaleFactor,middleArrowType:this.options.arrows.middle.type,middleArrowSrc:this.options.arrows.middle.src,middleArrowImageWidth:this.options.arrows.middle.imageWidth,middleArrowImageHeight:this.options.arrows.middle.imageHeight,fromArrow:e,fromArrowScale:this.options.arrows.from.scaleFactor,fromArrowType:this.options.arrows.from.type,fromArrowSrc:this.options.arrows.from.src,fromArrowImageWidth:this.options.arrows.from.imageWidth,fromArrowImageHeight:this.options.arrows.from.imageHeight,arrowStrikethrough:this.options.arrowStrikethrough,color:n?void 0:this.options.color.color,inheritsColor:n,opacity:this.options.color.opacity,hidden:this.options.hidden,length:this.options.length,shadow:this.options.shadow.enabled,shadowColor:this.options.shadow.color,shadowSize:this.options.shadow.size,shadowX:this.options.shadow.x,shadowY:this.options.shadow.y,dashes:this.options.dashes,width:this.options.width,background:this.options.background.enabled,backgroundColor:this.options.background.color,backgroundSize:this.options.background.size,backgroundDashes:this.options.background.dashes};if(this.selected||this.hover)if(!0===this.chooser){if(this.selected){var r=this.options.selectionWidth;"function"==typeof r?o.width=r(o.width):"number"==typeof r&&(o.width+=r),o.width=Math.max(o.width,.3/this.body.view.scale),o.color=this.options.color.highlight,o.shadow=this.options.shadow.enabled}else if(this.hover){var s=this.options.hoverWidth;"function"==typeof s?o.width=s(o.width):"number"==typeof s&&(o.width+=s),o.width=Math.max(o.width,.3/this.body.view.scale),o.color=this.options.color.hover,o.shadow=this.options.shadow.enabled}}else"function"==typeof this.chooser&&(this.chooser(o,this.options.id,this.selected,this.hover),void 0!==o.color&&(o.inheritsColor=!1),!1===o.shadow&&(o.shadowColor===this.options.shadow.color&&o.shadowSize===this.options.shadow.size&&o.shadowX===this.options.shadow.x&&o.shadowY===this.options.shadow.y||(o.shadow=!0)));else o.shadow=this.options.shadow.enabled,o.width=Math.max(o.width,.3/this.body.view.scale);return o}},{key:"updateLabelModule",value:function(t){var e=[t,this.options,this.globalOptions,this.defaultOptions];this.labelModule.update(this.options,e),void 0!==this.labelModule.baseSize&&(this.baseFontSize=this.labelModule.baseSize)}},{key:"updateEdgeType",value:function(){var t=this.options.smooth,e=!1,i=!0;return void 0!==this.edgeType&&((this.edgeType instanceof Tz&&!0===t.enabled&&"dynamic"===t.type||this.edgeType instanceof Nz&&!0===t.enabled&&"cubicBezier"===t.type||this.edgeType instanceof Pz&&!0===t.enabled&&"dynamic"!==t.type&&"cubicBezier"!==t.type||this.edgeType instanceof Fz&&!1===t.type.enabled)&&(i=!1),!0===i&&(e=this.cleanup())),!0===i?!0===t.enabled?"dynamic"===t.type?(e=!0,this.edgeType=new Tz(this.options,this.body,this.labelModule)):"cubicBezier"===t.type?this.edgeType=new Nz(this.options,this.body,this.labelModule):this.edgeType=new Pz(this.options,this.body,this.labelModule):this.edgeType=new Fz(this.options,this.body,this.labelModule):this.edgeType.setOptions(this.options),e}},{key:"connect",value:function(){this.disconnect(),this.from=this.body.nodes[this.fromId]||void 0,this.to=this.body.nodes[this.toId]||void 0,this.connected=void 0!==this.from&&void 0!==this.to,!0===this.connected?(this.from.attachEdge(this),this.to.attachEdge(this)):(this.from&&this.from.detachEdge(this),this.to&&this.to.detachEdge(this)),this.edgeType.connect()}},{key:"disconnect",value:function(){this.from&&(this.from.detachEdge(this),this.from=void 0),this.to&&(this.to.detachEdge(this),this.to=void 0),this.connected=!1}},{key:"getTitle",value:function(){return this.title}},{key:"isSelected",value:function(){return this.selected}},{key:"getValue",value:function(){return this.options.value}},{key:"setValueRange",value:function(t,e,i){if(void 0!==this.options.value){var n=this.options.scaling.customScalingFunction(t,e,i,this.options.value),o=this.options.scaling.max-this.options.scaling.min;if(!0===this.options.scaling.label.enabled){var r=this.options.scaling.label.max-this.options.scaling.label.min;this.options.font.size=this.options.scaling.label.min+n*r}this.options.width=this.options.scaling.min+n*o}else this.options.width=this.baseWidth,this.options.font.size=this.baseFontSize;this._setInteractionWidths(),this.updateLabelModule()}},{key:"_setInteractionWidths",value:function(){"function"==typeof this.options.hoverWidth?this.edgeType.hoverWidth=this.options.hoverWidth(this.options.width):this.edgeType.hoverWidth=this.options.hoverWidth+this.options.width,"function"==typeof this.options.selectionWidth?this.edgeType.selectionWidth=this.options.selectionWidth(this.options.width):this.edgeType.selectionWidth=this.options.selectionWidth+this.options.width}},{key:"draw",value:function(t){var e=this.getFormattingValues();if(!e.hidden){var i=this.edgeType.getViaNode();this.edgeType.drawLine(t,e,this.selected,this.hover,i),this.drawLabel(t,i)}}},{key:"drawArrows",value:function(t){var e=this.getFormattingValues();if(!e.hidden){var i=this.edgeType.getViaNode(),n={};this.edgeType.fromPoint=this.edgeType.from,this.edgeType.toPoint=this.edgeType.to,e.fromArrow&&(n.from=this.edgeType.getArrowData(t,"from",i,this.selected,this.hover,e),!1===e.arrowStrikethrough&&(this.edgeType.fromPoint=n.from.core),e.fromArrowSrc&&(n.from.image=this.imagelist.load(e.fromArrowSrc)),e.fromArrowImageWidth&&(n.from.imageWidth=e.fromArrowImageWidth),e.fromArrowImageHeight&&(n.from.imageHeight=e.fromArrowImageHeight)),e.toArrow&&(n.to=this.edgeType.getArrowData(t,"to",i,this.selected,this.hover,e),!1===e.arrowStrikethrough&&(this.edgeType.toPoint=n.to.core),e.toArrowSrc&&(n.to.image=this.imagelist.load(e.toArrowSrc)),e.toArrowImageWidth&&(n.to.imageWidth=e.toArrowImageWidth),e.toArrowImageHeight&&(n.to.imageHeight=e.toArrowImageHeight)),e.middleArrow&&(n.middle=this.edgeType.getArrowData(t,"middle",i,this.selected,this.hover,e),e.middleArrowSrc&&(n.middle.image=this.imagelist.load(e.middleArrowSrc)),e.middleArrowImageWidth&&(n.middle.imageWidth=e.middleArrowImageWidth),e.middleArrowImageHeight&&(n.middle.imageHeight=e.middleArrowImageHeight)),e.fromArrow&&this.edgeType.drawArrowHead(t,e,this.selected,this.hover,n.from),e.middleArrow&&this.edgeType.drawArrowHead(t,e,this.selected,this.hover,n.middle),e.toArrow&&this.edgeType.drawArrowHead(t,e,this.selected,this.hover,n.to)}}},{key:"drawLabel",value:function(t,e){if(void 0!==this.options.label){var i,n=this.from,o=this.to;if(this.labelModule.differentState(this.selected,this.hover)&&this.labelModule.getTextSize(t,this.selected,this.hover),n.id!=o.id){this.labelModule.pointToSelf=!1,i=this.edgeType.getPoint(.5,e),t.save();var r=this._getRotation(t);0!=r.angle&&(t.translate(r.x,r.y),t.rotate(r.angle)),this.labelModule.draw(t,i.x,i.y,this.selected,this.hover),t.restore()}else{this.labelModule.pointToSelf=!0;var s=NB(t,this.options.selfReference.angle,this.options.selfReference.size,n);i=this._pointOnCircle(s.x,s.y,this.options.selfReference.size,this.options.selfReference.angle),this.labelModule.draw(t,i.x,i.y,this.selected,this.hover)}}}},{key:"getItemsOnPoint",value:function(t){var e=[];if(this.labelModule.visible()){var i=this._getRotation();IB(this.labelModule.getSize(),t,i)&&e.push({edgeId:this.id,labelId:0})}var n={left:t.x,top:t.y};return this.isOverlappingWith(n)&&e.push({edgeId:this.id}),e}},{key:"isOverlappingWith",value:function(t){if(this.connected){var e=this.from.x,i=this.from.y,n=this.to.x,o=this.to.y,r=t.left,s=t.top;return this.edgeType.getDistanceToEdge(e,i,n,o,r,s)<10}return!1}},{key:"_getRotation",value:function(t){var e=this.edgeType.getViaNode(),i=this.edgeType.getPoint(.5,e);void 0!==t&&this.labelModule.calculateLabelSize(t,this.selected,this.hover,i.x,i.y);var n={x:i.x,y:this.labelModule.size.yLine,angle:0};if(!this.labelModule.visible())return n;if("horizontal"===this.options.font.align)return n;var o=this.from.y-this.to.y,r=this.from.x-this.to.x,s=Math.atan2(o,r);return(s<-1&&r<0||s>0&&r<0)&&(s+=Math.PI),n.angle=s,n}},{key:"_pointOnCircle",value:function(t,e,i,n){return{x:t+i*Math.cos(n),y:e-i*Math.sin(n)}}},{key:"select",value:function(){this.selected=!0}},{key:"unselect",value:function(){this.selected=!1}},{key:"cleanup",value:function(){return this.edgeType.cleanup()}},{key:"remove",value:function(){this.cleanup(),this.disconnect(),delete this.body.edges[this.id]}},{key:"endPointsValid",value:function(){return void 0!==this.body.nodes[this.fromId]&&void 0!==this.body.nodes[this.toId]}}],[{key:"parseOptions",value:function(t,e){var i=arguments.length>2&&void 0!==arguments[2]&&arguments[2],n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:{},o=arguments.length>4&&void 0!==arguments[4]&&arguments[4];if(qx(["endPointOffset","arrowStrikethrough","id","from","hidden","hoverWidth","labelHighlightBold","length","line","opacity","physics","scaling","selectionWidth","selfReferenceSize","selfReference","to","title","value","width","font","chosen","widthConstraint"],t,e,i),void 0!==e.endPointOffset&&void 0!==e.endPointOffset.from&&(eO(e.endPointOffset.from)?t.endPointOffset.from=e.endPointOffset.from:(t.endPointOffset.from=void 0!==n.endPointOffset.from?n.endPointOffset.from:0,console.error("endPointOffset.from is not a valid number"))),void 0!==e.endPointOffset&&void 0!==e.endPointOffset.to&&(eO(e.endPointOffset.to)?t.endPointOffset.to=e.endPointOffset.to:(t.endPointOffset.to=void 0!==n.endPointOffset.to?n.endPointOffset.to:0,console.error("endPointOffset.to is not a valid number"))),BB(e.label)?t.label=e.label:BB(t.label)||(t.label=void 0),pk(t,e,"smooth",n),pk(t,e,"shadow",n),pk(t,e,"background",n),void 0!==e.dashes&&null!==e.dashes?t.dashes=e.dashes:!0===i&&null===e.dashes&&(t.dashes=mm(n.dashes)),void 0!==e.scaling&&null!==e.scaling?(void 0!==e.scaling.min&&(t.scaling.min=e.scaling.min),void 0!==e.scaling.max&&(t.scaling.max=e.scaling.max),pk(t.scaling,e.scaling,"label",n.scaling)):!0===i&&null===e.scaling&&(t.scaling=mm(n.scaling)),void 0!==e.arrows&&null!==e.arrows)if("string"==typeof e.arrows){var r=e.arrows.toLowerCase();t.arrows.to.enabled=-1!=tm(r).call(r,"to"),t.arrows.middle.enabled=-1!=tm(r).call(r,"middle"),t.arrows.from.enabled=-1!=tm(r).call(r,"from")}else{if("object"!==Of(e.arrows))throw new Error("The arrow newOptions can only be an object or a string. Refer to the documentation. You used:"+Om(e.arrows));pk(t.arrows,e.arrows,"to",n.arrows),pk(t.arrows,e.arrows,"middle",n.arrows),pk(t.arrows,e.arrows,"from",n.arrows)}else!0===i&&null===e.arrows&&(t.arrows=mm(n.arrows));if(void 0!==e.color&&null!==e.color){var s=jx(e.color)?{color:e.color,highlight:e.color,hover:e.color,inherit:!1,opacity:1}:e.color,a=t.color;if(o)Ux(a,n.color,!1,i);else for(var h in a)Object.prototype.hasOwnProperty.call(a,h)&&delete a[h];if(jx(a))a.color=a,a.highlight=a,a.hover=a,a.inherit=!1,void 0===s.opacity&&(a.opacity=1);else{var l=!1;void 0!==s.color&&(a.color=s.color,l=!0),void 0!==s.highlight&&(a.highlight=s.highlight,l=!0),void 0!==s.hover&&(a.hover=s.hover,l=!0),void 0!==s.inherit&&(a.inherit=s.inherit),void 0!==s.opacity&&(a.opacity=Math.min(1,Math.max(0,s.opacity))),!0===l?a.inherit=!1:void 0===a.inherit&&(a.inherit="from")}}else!0===i&&null===e.color&&(t.color=fk(n.color));!0===i&&null===e.font&&(t.font=fk(n.font)),Object.prototype.hasOwnProperty.call(e,"selfReferenceSize")&&(console.warn("The selfReferenceSize property has been deprecated. Please use selfReference property instead. The selfReference can be set like thise selfReference:{size:30, angle:Math.PI / 4}"),t.selfReference.size=e.selfReferenceSize)}}]),t}(),jz=function(){function t(e,i,n){var o,r=this;pu(this,t),this.body=e,this.images=i,this.groups=n,this.body.functions.createEdge=Yn(o=this.create).call(o,this),this.edgesListeners={add:function(t,e){r.add(e.items)},update:function(t,e){r.update(e.items)},remove:function(t,e){r.remove(e.items)}},this.options={},this.defaultOptions={arrows:{to:{enabled:!1,scaleFactor:1,type:"arrow"},middle:{enabled:!1,scaleFactor:1,type:"arrow"},from:{enabled:!1,scaleFactor:1,type:"arrow"}},endPointOffset:{from:0,to:0},arrowStrikethrough:!0,color:{color:"#848484",highlight:"#848484",hover:"#848484",inherit:"from",opacity:1},dashes:!1,font:{color:"#343434",size:14,face:"arial",background:"none",strokeWidth:2,strokeColor:"#ffffff",align:"horizontal",multi:!1,vadjust:0,bold:{mod:"bold"},boldital:{mod:"bold italic"},ital:{mod:"italic"},mono:{mod:"",size:15,face:"courier new",vadjust:2}},hidden:!1,hoverWidth:1.5,label:void 0,labelHighlightBold:!0,length:void 0,physics:!0,scaling:{min:1,max:15,label:{enabled:!0,min:14,max:30,maxVisible:30,drawThreshold:5},customScalingFunction:function(t,e,i,n){if(e===t)return.5;var o=1/(e-t);return Math.max(0,(n-t)*o)}},selectionWidth:1.5,selfReference:{size:20,angle:Math.PI/4,renderBehindTheNode:!0},shadow:{enabled:!1,color:"rgba(0,0,0,0.5)",size:10,x:5,y:5},background:{enabled:!1,color:"rgba(111,111,111,1)",size:10,dashes:!1},smooth:{enabled:!0,type:"dynamic",forceDirection:"none",roundness:.5},title:void 0,width:1,value:void 0},Ux(this.options,this.defaultOptions),this.bindEventListeners()}return Nf(t,[{key:"bindEventListeners",value:function(){var t,e,i=this;this.body.emitter.on("_forceDisableDynamicCurves",(function(t){var e=!(arguments.length>1&&void 0!==arguments[1])||arguments[1];"dynamic"===t&&(t="continuous");var n=!1;for(var o in i.body.edges)if(Object.prototype.hasOwnProperty.call(i.body.edges,o)){var r=i.body.edges[o],s=i.body.data.edges.get(o);if(null!=s){var a=s.smooth;void 0!==a&&!0===a.enabled&&"dynamic"===a.type&&(void 0===t?r.setOptions({smooth:!1}):r.setOptions({smooth:{type:t}}),n=!0)}}!0===e&&!0===n&&i.body.emitter.emit("_dataChanged")})),this.body.emitter.on("_dataUpdated",(function(){i.reconnectEdges()})),this.body.emitter.on("refreshEdges",Yn(t=this.refresh).call(t,this)),this.body.emitter.on("refresh",Yn(e=this.refresh).call(e,this)),this.body.emitter.on("destroy",(function(){$x(i.edgesListeners,(function(t,e){i.body.data.edges&&i.body.data.edges.off(e,t)})),delete i.body.functions.createEdge,delete i.edgesListeners.add,delete i.edgesListeners.update,delete i.edgesListeners.remove,delete i.edgesListeners}))}},{key:"setOptions",value:function(t){if(void 0!==t){Az.parseOptions(this.options,t,!0,this.defaultOptions,!0);var e=!1;if(void 0!==t.smooth)for(var i in this.body.edges)Object.prototype.hasOwnProperty.call(this.body.edges,i)&&(e=this.body.edges[i].updateEdgeType()||e);if(void 0!==t.font)for(var n in this.body.edges)Object.prototype.hasOwnProperty.call(this.body.edges,n)&&this.body.edges[n].updateLabelModule();void 0===t.hidden&&void 0===t.physics&&!0!==e||this.body.emitter.emit("_dataChanged")}}},{key:"setData",value:function(t){var e=this,i=arguments.length>1&&void 0!==arguments[1]&&arguments[1],n=this.body.data.edges;if(sB("id",t))this.body.data.edges=t;else if(Wp(t))this.body.data.edges=new nB,this.body.data.edges.add(t);else{if(t)throw new TypeError("Array or DataSet expected");this.body.data.edges=new nB}if(n&&$x(this.edgesListeners,(function(t,e){n.off(e,t)})),this.body.edges={},this.body.data.edges){$x(this.edgesListeners,(function(t,i){e.body.data.edges.on(i,t)}));var o=this.body.data.edges.getIds();this.add(o,!0)}this.body.emitter.emit("_adjustEdgesForHierarchicalLayout"),!1===i&&this.body.emitter.emit("_dataChanged")}},{key:"add",value:function(t){for(var e=arguments.length>1&&void 0!==arguments[1]&&arguments[1],i=this.body.edges,n=this.body.data.edges,o=0;o<t.length;o++){var r=t[o],s=i[r];s&&s.disconnect();var a=n.get(r,{showInternalIds:!0});i[r]=this.create(a)}this.body.emitter.emit("_adjustEdgesForHierarchicalLayout"),!1===e&&this.body.emitter.emit("_dataChanged")}},{key:"update",value:function(t){for(var e=this.body.edges,i=this.body.data.edges,n=!1,o=0;o<t.length;o++){var r=t[o],s=i.get(r),a=e[r];void 0!==a?(a.disconnect(),n=a.setOptions(s)||n,a.connect()):(this.body.edges[r]=this.create(s),n=!0)}!0===n?(this.body.emitter.emit("_adjustEdgesForHierarchicalLayout"),this.body.emitter.emit("_dataChanged")):this.body.emitter.emit("_dataUpdated")}},{key:"remove",value:function(t){var e=!(arguments.length>1&&void 0!==arguments[1])||arguments[1];if(0!==t.length){var i=this.body.edges;$x(t,(function(t){var e=i[t];void 0!==e&&e.remove()})),e&&this.body.emitter.emit("_dataChanged")}}},{key:"refresh",value:function(){var t=this;$x(this.body.edges,(function(e,i){var n=t.body.data.edges.get(i);void 0!==n&&e.setOptions(n)}))}},{key:"create",value:function(t){return new Az(t,this.body,this.images,this.options,this.defaultOptions)}},{key:"reconnectEdges",value:function(){var t,e=this.body.nodes,i=this.body.edges;for(t in e)Object.prototype.hasOwnProperty.call(e,t)&&(e[t].edges=[]);for(t in i)if(Object.prototype.hasOwnProperty.call(i,t)){var n=i[t];n.from=null,n.to=null,n.connect()}}},{key:"getConnectedNodes",value:function(t){var e=[];if(void 0!==this.body.edges[t]){var i=this.body.edges[t];void 0!==i.fromId&&e.push(i.fromId),void 0!==i.toId&&e.push(i.toId)}return e}},{key:"_updateState",value:function(){this._addMissingEdges(),this._removeInvalidEdges()}},{key:"_removeInvalidEdges",value:function(){var t=this,e=[];$x(this.body.edges,(function(i,n){var o=t.body.nodes[i.toId],r=t.body.nodes[i.fromId];void 0!==o&&!0===o.isCluster||void 0!==r&&!0===r.isCluster||void 0!==o&&void 0!==r||e.push(n)})),this.remove(e,!1)}},{key:"_addMissingEdges",value:function(){var t=this.body.data.edges;if(null!=t){var e=this.body.edges,i=[];Cv(t).call(t,(function(t,n){void 0===e[n]&&i.push(n)})),this.add(i,!0)}}}]),t}(),Rz=function(){function t(e,i,n){pu(this,t),this.body=e,this.physicsBody=i,this.barnesHutTree,this.setOptions(n),this._rng=Tx("BARNES HUT SOLVER")}return Nf(t,[{key:"setOptions",value:function(t){this.options=t,this.thetaInversed=1/this.options.theta,this.overlapAvoidanceFactor=1-Math.max(0,Math.min(1,this.options.avoidOverlap))}},{key:"solve",value:function(){if(0!==this.options.gravitationalConstant&&this.physicsBody.physicsNodeIndices.length>0){var t,e=this.body.nodes,i=this.physicsBody.physicsNodeIndices,n=i.length,o=this._formBarnesHutTree(e,i);this.barnesHutTree=o;for(var r=0;r<n;r++)(t=e[i[r]]).options.mass>0&&this._getForceContributions(o.root,t)}}},{key:"_getForceContributions",value:function(t,e){this._getForceContribution(t.children.NW,e),this._getForceContribution(t.children.NE,e),this._getForceContribution(t.children.SW,e),this._getForceContribution(t.children.SE,e)}},{key:"_getForceContribution",value:function(t,e){if(t.childrenCount>0){var i=t.centerOfMass.x-e.x,n=t.centerOfMass.y-e.y,o=Math.sqrt(i*i+n*n);o*t.calcSize>this.thetaInversed?this._calculateForces(o,i,n,e,t):4===t.childrenCount?this._getForceContributions(t,e):t.children.data.id!=e.id&&this._calculateForces(o,i,n,e,t)}}},{key:"_calculateForces",value:function(t,e,i,n,o){0===t&&(e=t=.1),this.overlapAvoidanceFactor<1&&n.shape.radius&&(t=Math.max(.1+this.overlapAvoidanceFactor*n.shape.radius,t-n.shape.radius));var r=this.options.gravitationalConstant*o.mass*n.options.mass/Math.pow(t,3),s=e*r,a=i*r;this.physicsBody.forces[n.id].x+=s,this.physicsBody.forces[n.id].y+=a}},{key:"_formBarnesHutTree",value:function(t,e){for(var i,n=e.length,o=t[e[0]].x,r=t[e[0]].y,s=t[e[0]].x,a=t[e[0]].y,h=1;h<n;h++){var l=t[e[h]],d=l.x,c=l.y;l.options.mass>0&&(d<o&&(o=d),d>s&&(s=d),c<r&&(r=c),c>a&&(a=c))}var u=Math.abs(s-o)-Math.abs(a-r);u>0?(r-=.5*u,a+=.5*u):(o+=.5*u,s-=.5*u);var f=Math.max(1e-5,Math.abs(s-o)),p=.5*f,v=.5*(o+s),g=.5*(r+a),y={root:{centerOfMass:{x:0,y:0},mass:0,range:{minX:v-p,maxX:v+p,minY:g-p,maxY:g+p},size:f,calcSize:1/f,children:{data:null},maxWidth:0,level:0,childrenCount:4}};this._splitBranch(y.root);for(var m=0;m<n;m++)(i=t[e[m]]).options.mass>0&&this._placeInTree(y.root,i);return y}},{key:"_updateBranchMass",value:function(t,e){var i=t.centerOfMass,n=t.mass+e.options.mass,o=1/n;i.x=i.x*t.mass+e.x*e.options.mass,i.x*=o,i.y=i.y*t.mass+e.y*e.options.mass,i.y*=o,t.mass=n;var r=Math.max(Math.max(e.height,e.radius),e.width);t.maxWidth=t.maxWidth<r?r:t.maxWidth}},{key:"_placeInTree",value:function(t,e,i){1==i&&void 0!==i||this._updateBranchMass(t,e);var n,o=t.children.NW.range;n=o.maxX>e.x?o.maxY>e.y?"NW":"SW":o.maxY>e.y?"NE":"SE",this._placeInRegion(t,e,n)}},{key:"_placeInRegion",value:function(t,e,i){var n=t.children[i];switch(n.childrenCount){case 0:n.children.data=e,n.childrenCount=1,this._updateBranchMass(n,e);break;case 1:n.children.data.x===e.x&&n.children.data.y===e.y?(e.x+=this._rng(),e.y+=this._rng()):(this._splitBranch(n),this._placeInTree(n,e));break;case 4:this._placeInTree(n,e)}}},{key:"_splitBranch",value:function(t){var e=null;1===t.childrenCount&&(e=t.children.data,t.mass=0,t.centerOfMass.x=0,t.centerOfMass.y=0),t.childrenCount=4,t.children.data=null,this._insertRegion(t,"NW"),this._insertRegion(t,"NE"),this._insertRegion(t,"SW"),this._insertRegion(t,"SE"),null!=e&&this._placeInTree(t,e)}},{key:"_insertRegion",value:function(t,e){var i,n,o,r,s=.5*t.size;switch(e){case"NW":i=t.range.minX,n=t.range.minX+s,o=t.range.minY,r=t.range.minY+s;break;case"NE":i=t.range.minX+s,n=t.range.maxX,o=t.range.minY,r=t.range.minY+s;break;case"SW":i=t.range.minX,n=t.range.minX+s,o=t.range.minY+s,r=t.range.maxY;break;case"SE":i=t.range.minX+s,n=t.range.maxX,o=t.range.minY+s,r=t.range.maxY}t.children[e]={centerOfMass:{x:0,y:0},mass:0,range:{minX:i,maxX:n,minY:o,maxY:r},size:.5*t.size,calcSize:2*t.calcSize,children:{data:null},maxWidth:0,level:t.level+1,childrenCount:0}}},{key:"_debug",value:function(t,e){void 0!==this.barnesHutTree&&(t.lineWidth=1,this._drawBranch(this.barnesHutTree.root,t,e))}},{key:"_drawBranch",value:function(t,e,i){void 0===i&&(i="#FF0000"),4===t.childrenCount&&(this._drawBranch(t.children.NW,e),this._drawBranch(t.children.NE,e),this._drawBranch(t.children.SE,e),this._drawBranch(t.children.SW,e)),e.strokeStyle=i,e.beginPath(),e.moveTo(t.range.minX,t.range.minY),e.lineTo(t.range.maxX,t.range.minY),e.stroke(),e.beginPath(),e.moveTo(t.range.maxX,t.range.minY),e.lineTo(t.range.maxX,t.range.maxY),e.stroke(),e.beginPath(),e.moveTo(t.range.maxX,t.range.maxY),e.lineTo(t.range.minX,t.range.maxY),e.stroke(),e.beginPath(),e.moveTo(t.range.minX,t.range.maxY),e.lineTo(t.range.minX,t.range.minY),e.stroke()}}]),t}(),Lz=function(){function t(e,i,n){pu(this,t),this._rng=Tx("REPULSION SOLVER"),this.body=e,this.physicsBody=i,this.setOptions(n)}return Nf(t,[{key:"setOptions",value:function(t){this.options=t}},{key:"solve",value:function(){for(var t,e,i,n,o,r,s,a,h=this.body.nodes,l=this.physicsBody.physicsNodeIndices,d=this.physicsBody.forces,c=this.options.nodeDistance,u=-2/3/c,f=0;f<l.length-1;f++){s=h[l[f]];for(var p=f+1;p<l.length;p++)t=(a=h[l[p]]).x-s.x,e=a.y-s.y,0===(i=Math.sqrt(t*t+e*e))&&(t=i=.1*this._rng()),i<2*c&&(r=i<.5*c?1:u*i+1.3333333333333333,n=t*(r/=i),o=e*r,d[s.id].x-=n,d[s.id].y-=o,d[a.id].x+=n,d[a.id].y+=o)}}}]),t}(),Hz=function(){function t(e,i,n){pu(this,t),this.body=e,this.physicsBody=i,this.setOptions(n)}return Nf(t,[{key:"setOptions",value:function(t){this.options=t,this.overlapAvoidanceFactor=Math.max(0,Math.min(1,this.options.avoidOverlap||0))}},{key:"solve",value:function(){for(var t=this.body.nodes,e=this.physicsBody.physicsNodeIndices,i=this.physicsBody.forces,n=this.options.nodeDistance,o=0;o<e.length-1;o++)for(var r=t[e[o]],s=o+1;s<e.length;s++){var a=t[e[s]];if(r.level===a.level){var h=n+this.overlapAvoidanceFactor*((r.shape.radius||0)/2+(a.shape.radius||0)/2),l=a.x-r.x,d=a.y-r.y,c=Math.sqrt(l*l+d*d),u=void 0;u=c<h?-Math.pow(.05*c,2)+Math.pow(.05*h,2):0,0!==c&&(u/=c);var f=l*u,p=d*u;i[r.id].x-=f,i[r.id].y-=p,i[a.id].x+=f,i[a.id].y+=p}}}}]),t}(),Wz=function(){function t(e,i,n){pu(this,t),this.body=e,this.physicsBody=i,this.setOptions(n)}return Nf(t,[{key:"setOptions",value:function(t){this.options=t}},{key:"solve",value:function(){for(var t,e,i,n,o,r=this.physicsBody.physicsEdgeIndices,s=this.body.edges,a=0;a<r.length;a++)!0===(e=s[r[a]]).connected&&e.toId!==e.fromId&&void 0!==this.body.nodes[e.toId]&&void 0!==this.body.nodes[e.fromId]&&(void 0!==e.edgeType.via?(t=void 0===e.options.length?this.options.springLength:e.options.length,i=e.to,n=e.edgeType.via,o=e.from,this._calculateSpringForce(i,n,.5*t),this._calculateSpringForce(n,o,.5*t)):(t=void 0===e.options.length?1.5*this.options.springLength:e.options.length,this._calculateSpringForce(e.from,e.to,t)))}},{key:"_calculateSpringForce",value:function(t,e,i){var n=t.x-e.x,o=t.y-e.y,r=Math.max(Math.sqrt(n*n+o*o),.01),s=this.options.springConstant*(i-r)/r,a=n*s,h=o*s;void 0!==this.physicsBody.forces[t.id]&&(this.physicsBody.forces[t.id].x+=a,this.physicsBody.forces[t.id].y+=h),void 0!==this.physicsBody.forces[e.id]&&(this.physicsBody.forces[e.id].x-=a,this.physicsBody.forces[e.id].y-=h)}}]),t}(),qz=function(){function t(e,i,n){pu(this,t),this.body=e,this.physicsBody=i,this.setOptions(n)}return Nf(t,[{key:"setOptions",value:function(t){this.options=t}},{key:"solve",value:function(){for(var t,e,i,n,o,r,s,a,h,l,d=this.body.edges,c=.5,u=this.physicsBody.physicsEdgeIndices,f=this.physicsBody.physicsNodeIndices,p=this.physicsBody.forces,v=0;v<f.length;v++){var g=f[v];p[g].springFx=0,p[g].springFy=0}for(var y=0;y<u.length;y++)!0===(e=d[u[y]]).connected&&(t=void 0===e.options.length?this.options.springLength:e.options.length,i=e.from.x-e.to.x,n=e.from.y-e.to.y,a=0===(a=Math.sqrt(i*i+n*n))?.01:a,o=i*(s=this.options.springConstant*(t-a)/a),r=n*s,e.to.level!=e.from.level?(void 0!==p[e.toId]&&(p[e.toId].springFx-=o,p[e.toId].springFy-=r),void 0!==p[e.fromId]&&(p[e.fromId].springFx+=o,p[e.fromId].springFy+=r)):(void 0!==p[e.toId]&&(p[e.toId].x-=c*o,p[e.toId].y-=c*r),void 0!==p[e.fromId]&&(p[e.fromId].x+=c*o,p[e.fromId].y+=c*r)));s=1;for(var m=0;m<f.length;m++){var b=f[m];h=Math.min(s,Math.max(-s,p[b].springFx)),l=Math.min(s,Math.max(-s,p[b].springFy)),p[b].x+=h,p[b].y+=l}for(var w=0,x=0,k=0;k<f.length;k++){var _=f[k];w+=p[_].x,x+=p[_].y}for(var E=w/f.length,O=x/f.length,C=0;C<f.length;C++){var S=f[C];p[S].x-=E,p[S].y-=O}}}]),t}(),Vz=function(){function t(e,i,n){pu(this,t),this.body=e,this.physicsBody=i,this.setOptions(n)}return Nf(t,[{key:"setOptions",value:function(t){this.options=t}},{key:"solve",value:function(){for(var t,e,i,n,o=this.body.nodes,r=this.physicsBody.physicsNodeIndices,s=this.physicsBody.forces,a=0;a<r.length;a++){t=-(n=o[r[a]]).x,e=-n.y,i=Math.sqrt(t*t+e*e),this._calculateForces(i,t,e,s,n)}}},{key:"_calculateForces",value:function(t,e,i,n,o){var r=0===t?0:this.options.centralGravity/t;n[o.id].x=e*r,n[o.id].y=i*r}}]),t}();function Uz(t){var e=function(){if("undefined"==typeof Reflect||!jI)return!1;if(jI.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(jI(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=AO(t);if(e){var o=AO(this).constructor;i=jI(n,arguments,o)}else i=n.apply(this,arguments);return DO(this,i)}}var Yz=function(t){PO(i,t);var e=Uz(i);function i(t,n,o){var r;return pu(this,i),(r=e.call(this,t,n,o))._rng=Tx("FORCE ATLAS 2 BASED REPULSION SOLVER"),r}return Nf(i,[{key:"_calculateForces",value:function(t,e,i,n,o){0===t&&(e=t=.1*this._rng()),this.overlapAvoidanceFactor<1&&n.shape.radius&&(t=Math.max(.1+this.overlapAvoidanceFactor*n.shape.radius,t-n.shape.radius));var r=n.edges.length+1,s=this.options.gravitationalConstant*o.mass*n.options.mass*r/Math.pow(t,2),a=e*s,h=i*s;this.physicsBody.forces[n.id].x+=a,this.physicsBody.forces[n.id].y+=h}}]),i}(Rz);function Xz(t){var e=function(){if("undefined"==typeof Reflect||!jI)return!1;if(jI.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(jI(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=AO(t);if(e){var o=AO(this).constructor;i=jI(n,arguments,o)}else i=n.apply(this,arguments);return DO(this,i)}}var Gz=function(t){PO(i,t);var e=Xz(i);function i(t,n,o){return pu(this,i),e.call(this,t,n,o)}return Nf(i,[{key:"_calculateForces",value:function(t,e,i,n,o){if(t>0){var r=o.edges.length+1,s=this.options.centralGravity*r*o.options.mass;n[o.id].x=e*s,n[o.id].y=i*s}}}]),i}(Vz),Kz=function(){function t(e){pu(this,t),this.body=e,this.physicsBody={physicsNodeIndices:[],physicsEdgeIndices:[],forces:{},velocities:{}},this.physicsEnabled=!0,this.simulationInterval=1e3/60,this.requiresTimeout=!0,this.previousStates={},this.referenceState={},this.freezeCache={},this.renderTimer=void 0,this.adaptiveTimestep=!1,this.adaptiveTimestepEnabled=!1,this.adaptiveCounter=0,this.adaptiveInterval=3,this.stabilized=!1,this.startedStabilization=!1,this.stabilizationIterations=0,this.ready=!1,this.options={},this.defaultOptions={enabled:!0,barnesHut:{theta:.5,gravitationalConstant:-2e3,centralGravity:.3,springLength:95,springConstant:.04,damping:.09,avoidOverlap:0},forceAtlas2Based:{theta:.5,gravitationalConstant:-50,centralGravity:.01,springConstant:.08,springLength:100,damping:.4,avoidOverlap:0},repulsion:{centralGravity:.2,springLength:200,springConstant:.05,nodeDistance:100,damping:.09,avoidOverlap:0},hierarchicalRepulsion:{centralGravity:0,springLength:100,springConstant:.01,nodeDistance:120,damping:.09},maxVelocity:50,minVelocity:.75,solver:"barnesHut",stabilization:{enabled:!0,iterations:1e3,updateInterval:50,onlyDynamicEdges:!1,fit:!0},timestep:.5,adaptiveTimestep:!0,wind:{x:0,y:0}},xn(this.options,this.defaultOptions),this.timestep=.5,this.layoutFailed=!1,this.bindEventListeners()}return Nf(t,[{key:"bindEventListeners",value:function(){var t=this;this.body.emitter.on("initPhysics",(function(){t.initPhysics()})),this.body.emitter.on("_layoutFailed",(function(){t.layoutFailed=!0})),this.body.emitter.on("resetPhysics",(function(){t.stopSimulation(),t.ready=!1})),this.body.emitter.on("disablePhysics",(function(){t.physicsEnabled=!1,t.stopSimulation()})),this.body.emitter.on("restorePhysics",(function(){t.setOptions(t.options),!0===t.ready&&t.startSimulation()})),this.body.emitter.on("startSimulation",(function(){!0===t.ready&&t.startSimulation()})),this.body.emitter.on("stopSimulation",(function(){t.stopSimulation()})),this.body.emitter.on("destroy",(function(){t.stopSimulation(!1),t.body.emitter.off()})),this.body.emitter.on("_dataChanged",(function(){t.updatePhysicsData()}))}},{key:"setOptions",value:function(t){if(void 0!==t)if(!1===t)this.options.enabled=!1,this.physicsEnabled=!1,this.stopSimulation();else if(!0===t)this.options.enabled=!0,this.physicsEnabled=!0,this.startSimulation();else{this.physicsEnabled=!0,Vx(["stabilization"],this.options,t),pk(this.options,t,"stabilization"),void 0===t.enabled&&(this.options.enabled=!0),!1===this.options.enabled&&(this.physicsEnabled=!1,this.stopSimulation());var e=this.options.wind;e&&(("number"!=typeof e.x||KE(e.x))&&(e.x=0),("number"!=typeof e.y||KE(e.y))&&(e.y=0)),this.timestep=this.options.timestep}this.init()}},{key:"init",value:function(){var t;"forceAtlas2Based"===this.options.solver?(t=this.options.forceAtlas2Based,this.nodesSolver=new Yz(this.body,this.physicsBody,t),this.edgesSolver=new Wz(this.body,this.physicsBody,t),this.gravitySolver=new Gz(this.body,this.physicsBody,t)):"repulsion"===this.options.solver?(t=this.options.repulsion,this.nodesSolver=new Lz(this.body,this.physicsBody,t),this.edgesSolver=new Wz(this.body,this.physicsBody,t),this.gravitySolver=new Vz(this.body,this.physicsBody,t)):"hierarchicalRepulsion"===this.options.solver?(t=this.options.hierarchicalRepulsion,this.nodesSolver=new Hz(this.body,this.physicsBody,t),this.edgesSolver=new qz(this.body,this.physicsBody,t),this.gravitySolver=new Vz(this.body,this.physicsBody,t)):(t=this.options.barnesHut,this.nodesSolver=new Rz(this.body,this.physicsBody,t),this.edgesSolver=new Wz(this.body,this.physicsBody,t),this.gravitySolver=new Vz(this.body,this.physicsBody,t)),this.modelOptions=t}},{key:"initPhysics",value:function(){!0===this.physicsEnabled&&!0===this.options.enabled?!0===this.options.stabilization.enabled?this.stabilize():(this.stabilized=!1,this.ready=!0,this.body.emitter.emit("fit",{},this.layoutFailed),this.startSimulation()):(this.ready=!0,this.body.emitter.emit("fit"))}},{key:"startSimulation",value:function(){var t;!0===this.physicsEnabled&&!0===this.options.enabled?(this.stabilized=!1,this.adaptiveTimestep=!1,this.body.emitter.emit("_resizeNodes"),void 0===this.viewFunction&&(this.viewFunction=Yn(t=this.simulationStep).call(t,this),this.body.emitter.on("initRedraw",this.viewFunction),this.body.emitter.emit("_startRendering"))):this.body.emitter.emit("_redraw")}},{key:"stopSimulation",value:function(){var t=!(arguments.length>0&&void 0!==arguments[0])||arguments[0];this.stabilized=!0,!0===t&&this._emitStabilized(),void 0!==this.viewFunction&&(this.body.emitter.off("initRedraw",this.viewFunction),this.viewFunction=void 0,!0===t&&this.body.emitter.emit("_stopRendering"))}},{key:"simulationStep",value:function(){var t=cv();this.physicsTick(),(cv()-t<.4*this.simulationInterval||!0===this.runDoubleSpeed)&&!1===this.stabilized&&(this.physicsTick(),this.runDoubleSpeed=!0),!0===this.stabilized&&this.stopSimulation()}},{key:"_emitStabilized",value:function(){var t=this,e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:this.stabilizationIterations;(this.stabilizationIterations>1||!0===this.startedStabilization)&&Gm((function(){t.body.emitter.emit("stabilized",{iterations:e}),t.startedStabilization=!1,t.stabilizationIterations=0}),0)}},{key:"physicsStep",value:function(){this.gravitySolver.solve(),this.nodesSolver.solve(),this.edgesSolver.solve(),this.moveNodes()}},{key:"adjustTimeStep",value:function(){!0===this._evaluateStepQuality()?this.timestep=1.2*this.timestep:this.timestep/1.2<this.options.timestep?this.timestep=this.options.timestep:(this.adaptiveCounter=-1,this.timestep=Math.max(this.options.timestep,this.timestep/1.2))}},{key:"physicsTick",value:function(){if(this._startStabilizing(),!0!==this.stabilized){if(!0===this.adaptiveTimestep&&!0===this.adaptiveTimestepEnabled)this.adaptiveCounter%this.adaptiveInterval==0?(this.timestep=2*this.timestep,this.physicsStep(),this.revert(),this.timestep=.5*this.timestep,this.physicsStep(),this.physicsStep(),this.adjustTimeStep()):this.physicsStep(),this.adaptiveCounter+=1;else this.timestep=this.options.timestep,this.physicsStep();!0===this.stabilized&&this.revert(),this.stabilizationIterations++}}},{key:"updatePhysicsData",value:function(){this.physicsBody.forces={},this.physicsBody.physicsNodeIndices=[],this.physicsBody.physicsEdgeIndices=[];var t=this.body.nodes,e=this.body.edges;for(var i in t)Object.prototype.hasOwnProperty.call(t,i)&&!0===t[i].options.physics&&this.physicsBody.physicsNodeIndices.push(t[i].id);for(var n in e)Object.prototype.hasOwnProperty.call(e,n)&&!0===e[n].options.physics&&this.physicsBody.physicsEdgeIndices.push(e[n].id);for(var o=0;o<this.physicsBody.physicsNodeIndices.length;o++){var r=this.physicsBody.physicsNodeIndices[o];this.physicsBody.forces[r]={x:0,y:0},void 0===this.physicsBody.velocities[r]&&(this.physicsBody.velocities[r]={x:0,y:0})}for(var s in this.physicsBody.velocities)void 0===t[s]&&delete this.physicsBody.velocities[s]}},{key:"revert",value:function(){var t=ov(this.previousStates),e=this.body.nodes,i=this.physicsBody.velocities;this.referenceState={};for(var n=0;n<t.length;n++){var o=t[n];void 0!==e[o]?!0===e[o].options.physics&&(this.referenceState[o]={positions:{x:e[o].x,y:e[o].y}},i[o].x=this.previousStates[o].vx,i[o].y=this.previousStates[o].vy,e[o].x=this.previousStates[o].x,e[o].y=this.previousStates[o].y):delete this.previousStates[o]}}},{key:"_evaluateStepQuality",value:function(){var t,e,i=this.body.nodes,n=this.referenceState;for(var o in this.referenceState)if(Object.prototype.hasOwnProperty.call(this.referenceState,o)&&void 0!==i[o]&&(t=i[o].x-n[o].positions.x,e=i[o].y-n[o].positions.y,Math.sqrt(Math.pow(t,2)+Math.pow(e,2))>.3))return!1;return!0}},{key:"moveNodes",value:function(){for(var t=this.physicsBody.physicsNodeIndices,e=0,i=0,n=0;n<t.length;n++){var o=t[n],r=this._performStep(o);e=Math.max(e,r),i+=r}this.adaptiveTimestepEnabled=i/t.length<5,this.stabilized=e<this.options.minVelocity}},{key:"calculateComponentVelocity",value:function(t,e,i){t+=(e-this.modelOptions.damping*t)/i*this.timestep;var n=this.options.maxVelocity||1e9;return Math.abs(t)>n&&(t=t>0?n:-n),t}},{key:"_performStep",value:function(t){var e=this.body.nodes[t],i=this.physicsBody.forces[t];this.options.wind&&(i.x+=this.options.wind.x,i.y+=this.options.wind.y);var n=this.physicsBody.velocities[t];return this.previousStates[t]={x:e.x,y:e.y,vx:n.x,vy:n.y},!1===e.options.fixed.x?(n.x=this.calculateComponentVelocity(n.x,i.x,e.options.mass),e.x+=n.x*this.timestep):(i.x=0,n.x=0),!1===e.options.fixed.y?(n.y=this.calculateComponentVelocity(n.y,i.y,e.options.mass),e.y+=n.y*this.timestep):(i.y=0,n.y=0),Math.sqrt(Math.pow(n.x,2)+Math.pow(n.y,2))}},{key:"_freezeNodes",value:function(){var t=this.body.nodes;for(var e in t)if(Object.prototype.hasOwnProperty.call(t,e)&&t[e].x&&t[e].y){var i=t[e].options.fixed;this.freezeCache[e]={x:i.x,y:i.y},i.x=!0,i.y=!0}}},{key:"_restoreFrozenNodes",value:function(){var t=this.body.nodes;for(var e in t)Object.prototype.hasOwnProperty.call(t,e)&&void 0!==this.freezeCache[e]&&(t[e].options.fixed.x=this.freezeCache[e].x,t[e].options.fixed.y=this.freezeCache[e].y);this.freezeCache={}}},{key:"stabilize",value:function(){var t=this,e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:this.options.stabilization.iterations;"number"!=typeof e&&(e=this.options.stabilization.iterations,console.error("The stabilize method needs a numeric amount of iterations. Switching to default: ",e)),0!==this.physicsBody.physicsNodeIndices.length?(this.adaptiveTimestep=this.options.adaptiveTimestep,this.body.emitter.emit("_resizeNodes"),this.stopSimulation(),this.stabilized=!1,this.body.emitter.emit("_blockRedraw"),this.targetIterations=e,!0===this.options.stabilization.onlyDynamicEdges&&this._freezeNodes(),this.stabilizationIterations=0,Gm((function(){return t._stabilizationBatch()}),0)):this.ready=!0}},{key:"_startStabilizing",value:function(){return!0!==this.startedStabilization&&(this.body.emitter.emit("startStabilizing"),this.startedStabilization=!0,!0)}},{key:"_stabilizationBatch",value:function(){var t=this,e=function(){return!1===t.stabilized&&t.stabilizationIterations<t.targetIterations},i=function(){t.body.emitter.emit("stabilizationProgress",{iterations:t.stabilizationIterations,total:t.targetIterations})};this._startStabilizing()&&i();for(var n,o=0;e()&&o<this.options.stabilization.updateInterval;)this.physicsTick(),o++;(i(),e())?Gm(Yn(n=this._stabilizationBatch).call(n,this),0):this._finalizeStabilization()}},{key:"_finalizeStabilization",value:function(){this.body.emitter.emit("_allowRedraw"),!0===this.options.stabilization.fit&&this.body.emitter.emit("fit"),!0===this.options.stabilization.onlyDynamicEdges&&this._restoreFrozenNodes(),this.body.emitter.emit("stabilizationIterationsDone"),this.body.emitter.emit("_requestRedraw"),!0===this.stabilized?this._emitStabilized():this.startSimulation(),this.ready=!0}},{key:"_drawForces",value:function(t){for(var e=0;e<this.physicsBody.physicsNodeIndices.length;e++){var i=this.physicsBody.physicsNodeIndices[e],n=this.body.nodes[i],o=this.physicsBody.forces[i],r=Math.sqrt(Math.pow(o.x,2)+Math.pow(o.x,2)),s=Math.min(Math.max(5,r),15),a=3*s,h=hk((180-180*Math.min(1,Math.max(0,.03*r)))/360,1,1),l={x:n.x+20*o.x,y:n.y+20*o.y};t.lineWidth=s,t.strokeStyle=h,t.beginPath(),t.moveTo(n.x,n.y),t.lineTo(l.x,l.y),t.stroke();var d=Math.atan2(o.y,o.x);t.fillStyle=h,bz.draw(t,{type:"arrow",point:l,angle:d,length:a}),hb(t).call(t)}}}]),t}(),$z=function(){function t(){pu(this,t)}return Nf(t,null,[{key:"getRange",value:function(t){var e,i=arguments.length>1&&void 0!==arguments[1]?arguments[1]:[],n=1e9,o=-1e9,r=1e9,s=-1e9;if(i.length>0)for(var a=0;a<i.length;a++)r>(e=t[i[a]]).shape.boundingBox.left&&(r=e.shape.boundingBox.left),s<e.shape.boundingBox.right&&(s=e.shape.boundingBox.right),n>e.shape.boundingBox.top&&(n=e.shape.boundingBox.top),o<e.shape.boundingBox.bottom&&(o=e.shape.boundingBox.bottom);return 1e9===r&&-1e9===s&&1e9===n&&-1e9===o&&(n=0,o=0,r=0,s=0),{minX:r,maxX:s,minY:n,maxY:o}}},{key:"getRangeCore",value:function(t){var e,i=arguments.length>1&&void 0!==arguments[1]?arguments[1]:[],n=1e9,o=-1e9,r=1e9,s=-1e9;if(i.length>0)for(var a=0;a<i.length;a++)r>(e=t[i[a]]).x&&(r=e.x),s<e.x&&(s=e.x),n>e.y&&(n=e.y),o<e.y&&(o=e.y);return 1e9===r&&-1e9===s&&1e9===n&&-1e9===o&&(n=0,o=0,r=0,s=0),{minX:r,maxX:s,minY:n,maxY:o}}},{key:"findCenter",value:function(t){return{x:.5*(t.maxX+t.minX),y:.5*(t.maxY+t.minY)}}},{key:"cloneOptions",value:function(t,e){var i={};return void 0===e||"node"===e?(Ux(i,t.options,!0),i.x=t.x,i.y=t.y,i.amountOfConnections=t.edges.length):Ux(i,t.options,!0),i}}]),t}();function Zz(t){var e=function(){if("undefined"==typeof Reflect||!jI)return!1;if(jI.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(jI(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=AO(t);if(e){var o=AO(this).constructor;i=jI(n,arguments,o)}else i=n.apply(this,arguments);return DO(this,i)}}var Qz=function(t){PO(i,t);var e=Zz(i);function i(t,n,o,r,s,a){var h;return pu(this,i),(h=e.call(this,t,n,o,r,s,a)).isCluster=!0,h.containedNodes={},h.containedEdges={},h}return Nf(i,[{key:"_openChildCluster",value:function(t){var e=this,i=this.body.nodes[t];if(void 0===this.containedNodes[t])throw new Error("node with id: "+t+" not in current cluster");if(!i.isCluster)throw new Error("node with id: "+t+" is not a cluster");delete this.containedNodes[t],$x(i.edges,(function(t){delete e.containedEdges[t.id]})),$x(i.containedNodes,(function(t,i){e.containedNodes[i]=t})),i.containedNodes={},$x(i.containedEdges,(function(t,i){e.containedEdges[i]=t})),i.containedEdges={},$x(i.edges,(function(t){$x(e.edges,(function(i){var n,o,r=tm(n=i.clusteringEdgeReplacingIds).call(n,t.id);-1!==r&&($x(t.clusteringEdgeReplacingIds,(function(t){i.clusteringEdgeReplacingIds.push(t),e.body.edges[t].edgeReplacedById=i.id})),vg(o=i.clusteringEdgeReplacingIds).call(o,r,1))}))})),i.edges=[]}}]),i}(TN),Jz=function(){function t(e){var i=this;pu(this,t),this.body=e,this.clusteredNodes={},this.clusteredEdges={},this.options={},this.defaultOptions={},xn(this.options,this.defaultOptions),this.body.emitter.on("_resetData",(function(){i.clusteredNodes={},i.clusteredEdges={}}))}return Nf(t,[{key:"clusterByHubsize",value:function(t,e){void 0===t?t=this._getHubSize():"object"===Of(t)&&(e=this._checkOptions(t),t=this._getHubSize());for(var i=[],n=0;n<this.body.nodeIndices.length;n++){var o=this.body.nodes[this.body.nodeIndices[n]];o.edges.length>=t&&i.push(o.id)}for(var r=0;r<i.length;r++)this.clusterByConnection(i[r],e,!0);this.body.emitter.emit("_dataChanged")}},{key:"cluster",value:function(){var t=this,e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{},i=!(arguments.length>1&&void 0!==arguments[1])||arguments[1];if(void 0===e.joinCondition)throw new Error("Cannot call clusterByNodeData without a joinCondition function in the options.");e=this._checkOptions(e);var n={},o={};$x(this.body.nodes,(function(i,r){i.options&&!0===e.joinCondition(i.options)&&(n[r]=i,$x(i.edges,(function(e){void 0===t.clusteredEdges[e.id]&&(o[e.id]=e)})))})),this._cluster(n,o,e,i)}},{key:"clusterByEdgeCount",value:function(t,e){var i=this,n=!(arguments.length>2&&void 0!==arguments[2])||arguments[2];e=this._checkOptions(e);for(var o,r,s,a=[],h={},l=function(){var n={},l={},c=i.body.nodeIndices[d],u=i.body.nodes[c];if(void 0===h[c]){s=0,r=[];for(var f=0;f<u.edges.length;f++)o=u.edges[f],void 0===i.clusteredEdges[o.id]&&(o.toId!==o.fromId&&s++,r.push(o));if(s===t){for(var p=function(t){if(void 0===e.joinCondition||null===e.joinCondition)return!0;var i=$z.cloneOptions(t);return e.joinCondition(i)},v=!0,g=0;g<r.length;g++){o=r[g];var y=i._getConnectedId(o,c);if(!p(u)){v=!1;break}l[o.id]=o,n[c]=u,n[y]=i.body.nodes[y],h[c]=!0}if(ov(n).length>0&&ov(l).length>0&&!0===v){var m=function(){for(var t=0;t<a.length;++t)for(var e in n)if(void 0!==a[t].nodes[e])return a[t]}();if(void 0!==m){for(var b in n)void 0===m.nodes[b]&&(m.nodes[b]=n[b]);for(var w in l)void 0===m.edges[w]&&(m.edges[w]=l[w])}else a.push({nodes:n,edges:l})}}}},d=0;d<this.body.nodeIndices.length;d++)l();for(var c=0;c<a.length;c++)this._cluster(a[c].nodes,a[c].edges,e,!1);!0===n&&this.body.emitter.emit("_dataChanged")}},{key:"clusterOutliers",value:function(t){var e=!(arguments.length>1&&void 0!==arguments[1])||arguments[1];this.clusterByEdgeCount(1,t,e)}},{key:"clusterBridges",value:function(t){var e=!(arguments.length>1&&void 0!==arguments[1])||arguments[1];this.clusterByEdgeCount(2,t,e)}},{key:"clusterByConnection",value:function(t,e){var i,n=!(arguments.length>2&&void 0!==arguments[2])||arguments[2];if(void 0===t)throw new Error("No nodeId supplied to clusterByConnection!");if(void 0===this.body.nodes[t])throw new Error("The nodeId given to clusterByConnection does not exist!");var o=this.body.nodes[t];void 0===(e=this._checkOptions(e,o)).clusterNodeProperties.x&&(e.clusterNodeProperties.x=o.x),void 0===e.clusterNodeProperties.y&&(e.clusterNodeProperties.y=o.y),void 0===e.clusterNodeProperties.fixed&&(e.clusterNodeProperties.fixed={},e.clusterNodeProperties.fixed.x=o.options.fixed.x,e.clusterNodeProperties.fixed.y=o.options.fixed.y);var r={},s={},a=o.id,h=$z.cloneOptions(o);r[a]=o;for(var l=0;l<o.edges.length;l++){var d=o.edges[l];if(void 0===this.clusteredEdges[d.id]){var c=this._getConnectedId(d,a);if(void 0===this.clusteredNodes[c])if(c!==a)if(void 0===e.joinCondition)s[d.id]=d,r[c]=this.body.nodes[c];else{var u=$z.cloneOptions(this.body.nodes[c]);!0===e.joinCondition(h,u)&&(s[d.id]=d,r[c]=this.body.nodes[c])}else s[d.id]=d}}var f=Qp(i=ov(r)).call(i,(function(t){return r[t].id}));for(var p in r)if(Object.prototype.hasOwnProperty.call(r,p))for(var v=r[p],g=0;g<v.edges.length;g++){var y=v.edges[g];tm(f).call(f,this._getConnectedId(y,v.id))>-1&&(s[y.id]=y)}this._cluster(r,s,e,n)}},{key:"_createClusterEdges",value:function(t,e,i,n){for(var o,r,s,a,h,l,d=ov(t),c=[],u=0;u<d.length;u++){s=t[r=d[u]];for(var f=0;f<s.edges.length;f++)o=s.edges[f],void 0===this.clusteredEdges[o.id]&&(o.toId==o.fromId?e[o.id]=o:o.toId==r?(a=i.id,l=h=o.fromId):(a=o.toId,h=i.id,l=a),void 0===t[l]&&c.push({edge:o,fromId:h,toId:a}))}for(var p=[],v=function(t){for(var e=0;e<p.length;e++){var i=p[e],n=t.fromId===i.fromId&&t.toId===i.toId,o=t.fromId===i.toId&&t.toId===i.fromId;if(n||o)return i}return null},g=0;g<c.length;g++){var y=c[g],m=y.edge,b=v(y);null===b?(b=this._createClusteredEdge(y.fromId,y.toId,m,n),p.push(b)):b.clusteringEdgeReplacingIds.push(m.id),this.body.edges[m.id].edgeReplacedById=b.id,this._backupEdgeOptions(m),m.setOptions({physics:!1})}}},{key:"_checkOptions",value:function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{};return void 0===t.clusterEdgeProperties&&(t.clusterEdgeProperties={}),void 0===t.clusterNodeProperties&&(t.clusterNodeProperties={}),t}},{key:"_cluster",value:function(t,e,i){var n=!(arguments.length>3&&void 0!==arguments[3])||arguments[3],o=[];for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&void 0!==this.clusteredNodes[r]&&o.push(r);for(var s=0;s<o.length;++s)delete t[o[s]];if(0!=ov(t).length&&(1!=ov(t).length||1==i.clusterNodeProperties.allowSingleNodeCluster)){var a=Ux({},i.clusterNodeProperties);if(void 0!==i.processProperties){var h=[];for(var l in t)if(Object.prototype.hasOwnProperty.call(t,l)){var d=$z.cloneOptions(t[l]);h.push(d)}var c=[];for(var u in e)if(Object.prototype.hasOwnProperty.call(e,u)&&"clusterEdge:"!==u.substr(0,12)){var f=$z.cloneOptions(e[u],"edge");c.push(f)}if(!(a=i.processProperties(a,h,c)))throw new Error("The processProperties function does not return properties!")}void 0===a.id&&(a.id="cluster:"+UI());var p=a.id;void 0===a.label&&(a.label="cluster");var v=void 0;void 0===a.x&&(v=this._getClusterPosition(t),a.x=v.x),void 0===a.y&&(void 0===v&&(v=this._getClusterPosition(t)),a.y=v.y),a.id=p;var g=this.body.functions.createNode(a,Qz);g.containedNodes=t,g.containedEdges=e,g.clusterEdgeProperties=i.clusterEdgeProperties,this.body.nodes[a.id]=g,this._clusterEdges(t,e,a,i.clusterEdgeProperties),a.id=void 0,!0===n&&this.body.emitter.emit("_dataChanged")}}},{key:"_backupEdgeOptions",value:function(t){void 0===this.clusteredEdges[t.id]&&(this.clusteredEdges[t.id]={physics:t.options.physics})}},{key:"_restoreEdge",value:function(t){var e=this.clusteredEdges[t.id];void 0!==e&&(t.setOptions({physics:e.physics}),delete this.clusteredEdges[t.id])}},{key:"isCluster",value:function(t){return void 0!==this.body.nodes[t]?!0===this.body.nodes[t].isCluster:(console.error("Node does not exist."),!1)}},{key:"_getClusterPosition",value:function(t){for(var e,i=ov(t),n=t[i[0]].x,o=t[i[0]].x,r=t[i[0]].y,s=t[i[0]].y,a=1;a<i.length;a++)n=(e=t[i[a]]).x<n?e.x:n,o=e.x>o?e.x:o,r=e.y<r?e.y:r,s=e.y>s?e.y:s;return{x:.5*(n+o),y:.5*(r+s)}}},{key:"openCluster",value:function(t,e){var i=!(arguments.length>2&&void 0!==arguments[2])||arguments[2];if(void 0===t)throw new Error("No clusterNodeId supplied to openCluster.");var n=this.body.nodes[t];if(void 0===n)throw new Error("The clusterNodeId supplied to openCluster does not exist.");if(!0!==n.isCluster||void 0===n.containedNodes||void 0===n.containedEdges)throw new Error("The node:"+t+" is not a valid cluster.");var o=this.findNode(t),r=tm(o).call(o,t)-1;if(r>=0){var s=o[r];return this.body.nodes[s]._openChildCluster(t),delete this.body.nodes[t],void(!0===i&&this.body.emitter.emit("_dataChanged"))}var a=n.containedNodes,h=n.containedEdges;if(void 0!==e&&void 0!==e.releaseFunction&&"function"==typeof e.releaseFunction){var l={},d={x:n.x,y:n.y};for(var c in a)if(Object.prototype.hasOwnProperty.call(a,c)){var u=this.body.nodes[c];l[c]={x:u.x,y:u.y}}var f=e.releaseFunction(d,l);for(var p in a)if(Object.prototype.hasOwnProperty.call(a,p)){var v=this.body.nodes[p];void 0!==f[p]&&(v.x=void 0===f[p].x?n.x:f[p].x,v.y=void 0===f[p].y?n.y:f[p].y)}}else $x(a,(function(t){!1===t.options.fixed.x&&(t.x=n.x),!1===t.options.fixed.y&&(t.y=n.y)}));for(var g in a)if(Object.prototype.hasOwnProperty.call(a,g)){var y=this.body.nodes[g];y.vx=n.vx,y.vy=n.vy,y.setOptions({physics:!0}),delete this.clusteredNodes[g]}for(var m=[],b=0;b<n.edges.length;b++)m.push(n.edges[b]);for(var w=0;w<m.length;w++){for(var x=m[w],k=this._getConnectedId(x,t),_=this.clusteredNodes[k],E=0;E<x.clusteringEdgeReplacingIds.length;E++){var O=x.clusteringEdgeReplacingIds[E],C=this.body.edges[O];if(void 0!==C)if(void 0!==_){var S=this.body.nodes[_.clusterId];S.containedEdges[C.id]=C,delete h[C.id];var T=C.fromId,M=C.toId;C.toId==k?M=_.clusterId:T=_.clusterId,this._createClusteredEdge(T,M,C,S.clusterEdgeProperties,{hidden:!1,physics:!0})}else this._restoreEdge(C)}x.remove()}for(var P in h)Object.prototype.hasOwnProperty.call(h,P)&&this._restoreEdge(h[P]);delete this.body.nodes[t],!0===i&&this.body.emitter.emit("_dataChanged")}},{key:"getNodesInCluster",value:function(t){var e=[];if(!0===this.isCluster(t)){var i=this.body.nodes[t].containedNodes;for(var n in i)Object.prototype.hasOwnProperty.call(i,n)&&e.push(this.body.nodes[n].id)}return e}},{key:"findNode",value:function(t){for(var e,i=[],n=0;void 0!==this.clusteredNodes[t]&&n<100;){if(void 0===(e=this.body.nodes[t]))return[];i.push(e.id),t=this.clusteredNodes[t].clusterId,n++}return void 0===(e=this.body.nodes[t])?[]:(i.push(e.id),Rv(i).call(i),i)}},{key:"updateClusteredNode",value:function(t,e){if(void 0===t)throw new Error("No clusteredNodeId supplied to updateClusteredNode.");if(void 0===e)throw new Error("No newOptions supplied to updateClusteredNode.");if(void 0===this.body.nodes[t])throw new Error("The clusteredNodeId supplied to updateClusteredNode does not exist.");this.body.nodes[t].setOptions(e),this.body.emitter.emit("_dataChanged")}},{key:"updateEdge",value:function(t,e){if(void 0===t)throw new Error("No startEdgeId supplied to updateEdge.");if(void 0===e)throw new Error("No newOptions supplied to updateEdge.");if(void 0===this.body.edges[t])throw new Error("The startEdgeId supplied to updateEdge does not exist.");for(var i=this.getClusteredEdges(t),n=0;n<i.length;n++){this.body.edges[i[n]].setOptions(e)}this.body.emitter.emit("_dataChanged")}},{key:"getClusteredEdges",value:function(t){for(var e=[],i=0;void 0!==t&&void 0!==this.body.edges[t]&&i<100;)e.push(this.body.edges[t].id),t=this.body.edges[t].edgeReplacedById,i++;return Rv(e).call(e),e}},{key:"getBaseEdge",value:function(t){return this.getBaseEdges(t)[0]}},{key:"getBaseEdges",value:function(t){for(var e=[t],i=[],n=[],o=0;e.length>0&&o<100;){var r=e.pop();if(void 0!==r){var s=this.body.edges[r];if(void 0!==s){o++;var a=s.clusteringEdgeReplacingIds;if(void 0===a)n.push(r);else for(var h=0;h<a.length;++h){var l=a[h];-1===tm(e).call(e,a)&&-1===tm(i).call(i,a)&&e.push(l)}i.push(r)}}}return n}},{key:"_getConnectedId",value:function(t,e){return t.toId!=e?t.toId:(t.fromId,t.fromId)}},{key:"_getHubSize",value:function(){for(var t=0,e=0,i=0,n=0,o=0;o<this.body.nodeIndices.length;o++){var r=this.body.nodes[this.body.nodeIndices[o]];r.edges.length>n&&(n=r.edges.length),t+=r.edges.length,e+=Math.pow(r.edges.length,2),i+=1}t/=i;var s=(e/=i)-Math.pow(t,2),a=Math.sqrt(s),h=Math.floor(t+2*a);return h>n&&(h=n),h}},{key:"_createClusteredEdge",value:function(t,e,i,n,o){var r=$z.cloneOptions(i,"edge");Ux(r,n),r.from=t,r.to=e,r.id="clusterEdge:"+UI(),void 0!==o&&Ux(r,o);var s=this.body.functions.createEdge(r);return s.clusteringEdgeReplacingIds=[i.id],s.connect(),this.body.edges[s.id]=s,s}},{key:"_clusterEdges",value:function(t,e,i,n){if(e instanceof Az){var o=e,r={};r[o.id]=o,e=r}if(t instanceof TN){var s=t,a={};a[s.id]=s,t=a}if(null==i)throw new Error("_clusterEdges: parameter clusterNode required");for(var h in void 0===n&&(n=i.clusterEdgeProperties),this._createClusterEdges(t,e,i,n),e)if(Object.prototype.hasOwnProperty.call(e,h)&&void 0!==this.body.edges[h]){var l=this.body.edges[h];this._backupEdgeOptions(l),l.setOptions({physics:!1})}for(var d in t)Object.prototype.hasOwnProperty.call(t,d)&&(this.clusteredNodes[d]={clusterId:i.id,node:this.body.nodes[d]},this.body.nodes[d].setOptions({physics:!1}))}},{key:"_getClusterNodeForNode",value:function(t){if(void 0!==t){var e=this.clusteredNodes[t];if(void 0!==e){var i=e.clusterId;if(void 0!==i)return this.body.nodes[i]}}}},{key:"_filter",value:function(t,e){var i=[];return $x(t,(function(t){e(t)&&i.push(t)})),i}},{key:"_updateState",value:function(){var t,e=this,i=[],n={},o=function(t){$x(e.body.nodes,(function(e){!0===e.isCluster&&t(e)}))};for(t in this.clusteredNodes){if(Object.prototype.hasOwnProperty.call(this.clusteredNodes,t))void 0===this.body.nodes[t]&&i.push(t)}o((function(t){for(var e=0;e<i.length;e++)delete t.containedNodes[i[e]]}));for(var r=0;r<i.length;r++)delete this.clusteredNodes[i[r]];$x(this.clusteredEdges,(function(t){var i=e.body.edges[t];void 0!==i&&i.endPointsValid()||(n[t]=t)})),o((function(t){$x(t.containedEdges,(function(t,e){t.endPointsValid()||n[e]||(n[e]=e)}))})),$x(this.body.edges,(function(t,i){var o=!0,r=t.clusteringEdgeReplacingIds;if(void 0!==r){var s=0;$x(r,(function(t){var i=e.body.edges[t];void 0!==i&&i.endPointsValid()&&(s+=1)})),o=s>0}t.endPointsValid()&&o||(n[i]=i)})),o((function(t){$x(n,(function(i){delete t.containedEdges[i],$x(t.edges,(function(o,r){o.id!==i?o.clusteringEdgeReplacingIds=e._filter(o.clusteringEdgeReplacingIds,(function(t){return!n[t]})):t.edges[r]=null})),t.edges=e._filter(t.edges,(function(t){return null!==t}))}))})),$x(n,(function(t){delete e.clusteredEdges[t]})),$x(n,(function(t){delete e.body.edges[t]})),$x(ov(this.body.edges),(function(t){var i=e.body.edges[t],n=e._isClusteredNode(i.fromId)||e._isClusteredNode(i.toId);if(n!==e._isClusteredEdge(i.id))if(n){var o=e._getClusterNodeForNode(i.fromId);void 0!==o&&e._clusterEdges(e.body.nodes[i.fromId],i,o);var r=e._getClusterNodeForNode(i.toId);void 0!==r&&e._clusterEdges(e.body.nodes[i.toId],i,r)}else delete e._clusterEdges[t],e._restoreEdge(i)}));for(var s=!1,a=!0,h=function(){var t=[];o((function(e){var i=ov(e.containedNodes).length,n=!0===e.options.allowSingleNodeCluster;(n&&i<1||!n&&i<2)&&t.push(e.id)}));for(var i=0;i<t.length;++i)e.openCluster(t[i],{},!1);a=t.length>0,s=s||a};a;)h();s&&this._updateState()}},{key:"_isClusteredNode",value:function(t){return void 0!==this.clusteredNodes[t]}},{key:"_isClusteredEdge",value:function(t){return void 0!==this.clusteredEdges[t]}}]),t}();var tF=function(){function t(e,i){var n;pu(this,t),void 0!==window&&(n=window.requestAnimationFrame||window.mozRequestAnimationFrame||window.webkitRequestAnimationFrame||window.msRequestAnimationFrame),window.requestAnimationFrame=void 0===n?function(t){t()}:n,this.body=e,this.canvas=i,this.redrawRequested=!1,this.renderTimer=void 0,this.requiresTimeout=!0,this.renderingActive=!1,this.renderRequests=0,this.allowRedraw=!0,this.dragging=!1,this.zooming=!1,this.options={},this.defaultOptions={hideEdgesOnDrag:!1,hideEdgesOnZoom:!1,hideNodesOnDrag:!1},xn(this.options,this.defaultOptions),this._determineBrowserMethod(),this.bindEventListeners()}return Nf(t,[{key:"bindEventListeners",value:function(){var t,e=this;this.body.emitter.on("dragStart",(function(){e.dragging=!0})),this.body.emitter.on("dragEnd",(function(){e.dragging=!1})),this.body.emitter.on("zoom",(function(){e.zooming=!0,window.clearTimeout(e.zoomTimeoutId),e.zoomTimeoutId=Gm((function(){var t;e.zooming=!1,Yn(t=e._requestRedraw).call(t,e)()}),250)})),this.body.emitter.on("_resizeNodes",(function(){e._resizeNodes()})),this.body.emitter.on("_redraw",(function(){!1===e.renderingActive&&e._redraw()})),this.body.emitter.on("_blockRedraw",(function(){e.allowRedraw=!1})),this.body.emitter.on("_allowRedraw",(function(){e.allowRedraw=!0,e.redrawRequested=!1})),this.body.emitter.on("_requestRedraw",Yn(t=this._requestRedraw).call(t,this)),this.body.emitter.on("_startRendering",(function(){e.renderRequests+=1,e.renderingActive=!0,e._startRendering()})),this.body.emitter.on("_stopRendering",(function(){e.renderRequests-=1,e.renderingActive=e.renderRequests>0,e.renderTimer=void 0})),this.body.emitter.on("destroy",(function(){e.renderRequests=0,e.allowRedraw=!1,e.renderingActive=!1,!0===e.requiresTimeout?clearTimeout(e.renderTimer):window.cancelAnimationFrame(e.renderTimer),e.body.emitter.off()}))}},{key:"setOptions",value:function(t){if(void 0!==t){qx(["hideEdgesOnDrag","hideEdgesOnZoom","hideNodesOnDrag"],this.options,t)}}},{key:"_requestNextFrame",value:function(t,e){if("undefined"!=typeof window){var i,n=window;return!0===this.requiresTimeout?i=Gm(t,e):n.requestAnimationFrame&&(i=n.requestAnimationFrame(t)),i}}},{key:"_startRendering",value:function(){var t;!0===this.renderingActive&&(void 0===this.renderTimer&&(this.renderTimer=this._requestNextFrame(Yn(t=this._renderStep).call(t,this),this.simulationInterval)))}},{key:"_renderStep",value:function(){!0===this.renderingActive&&(this.renderTimer=void 0,!0===this.requiresTimeout&&this._startRendering(),this._redraw(),!1===this.requiresTimeout&&this._startRendering())}},{key:"redraw",value:function(){this.body.emitter.emit("setSize"),this._redraw()}},{key:"_requestRedraw",value:function(){var t=this;!0!==this.redrawRequested&&!1===this.renderingActive&&!0===this.allowRedraw&&(this.redrawRequested=!0,this._requestNextFrame((function(){t._redraw(!1)}),0))}},{key:"_redraw",value:function(){var t=arguments.length>0&&void 0!==arguments[0]&&arguments[0];if(!0===this.allowRedraw){this.body.emitter.emit("initRedraw"),this.redrawRequested=!1;var e={drawExternalLabels:null};0!==this.canvas.frame.canvas.width&&0!==this.canvas.frame.canvas.height||this.canvas.setSize(),this.canvas.setTransform();var i=this.canvas.getContext(),n=this.canvas.frame.canvas.clientWidth,o=this.canvas.frame.canvas.clientHeight;if(i.clearRect(0,0,n,o),0===this.canvas.frame.clientWidth)return;if(i.save(),i.translate(this.body.view.translation.x,this.body.view.translation.y),i.scale(this.body.view.scale,this.body.view.scale),i.beginPath(),this.body.emitter.emit("beforeDrawing",i),i.closePath(),!1===t&&(!1===this.dragging||!0===this.dragging&&!1===this.options.hideEdgesOnDrag)&&(!1===this.zooming||!0===this.zooming&&!1===this.options.hideEdgesOnZoom)&&this._drawEdges(i),!1===this.dragging||!0===this.dragging&&!1===this.options.hideNodesOnDrag){var r=this._drawNodes(i,t).drawExternalLabels;e.drawExternalLabels=r}!1===t&&(!1===this.dragging||!0===this.dragging&&!1===this.options.hideEdgesOnDrag)&&(!1===this.zooming||!0===this.zooming&&!1===this.options.hideEdgesOnZoom)&&this._drawArrows(i),null!=e.drawExternalLabels&&e.drawExternalLabels(),!1===t&&this._drawSelectionBox(i),i.beginPath(),this.body.emitter.emit("afterDrawing",i),i.closePath(),i.restore(),!0===t&&i.clearRect(0,0,n,o)}}},{key:"_resizeNodes",value:function(){this.canvas.setTransform();var t=this.canvas.getContext();t.save(),t.translate(this.body.view.translation.x,this.body.view.translation.y),t.scale(this.body.view.scale,this.body.view.scale);var e,i=this.body.nodes;for(var n in i)Object.prototype.hasOwnProperty.call(i,n)&&((e=i[n]).resize(t),e.updateBoundingBox(t,e.selected));t.restore()}},{key:"_drawNodes",value:function(t){for(var e,i,n=arguments.length>1&&void 0!==arguments[1]&&arguments[1],o=this.body.nodes,r=this.body.nodeIndices,s=[],a=[],h=this.canvas.DOMtoCanvas({x:-20,y:-20}),l=this.canvas.DOMtoCanvas({x:this.canvas.frame.canvas.clientWidth+20,y:this.canvas.frame.canvas.clientHeight+20}),d={top:h.y,left:h.x,bottom:l.y,right:l.x},c=[],u=0;u<r.length;u++)if((e=o[r[u]]).hover)a.push(r[u]);else if(e.isSelected())s.push(r[u]);else if(!0===n){var f=e.draw(t);null!=f.drawExternalLabel&&c.push(f.drawExternalLabel)}else if(!0===e.isBoundingBoxOverlappingWith(d)){var p=e.draw(t);null!=p.drawExternalLabel&&c.push(p.drawExternalLabel)}else e.updateBoundingBox(t,e.selected);var v=s.length,g=a.length;for(i=0;i<v;i++){var y=(e=o[s[i]]).draw(t);null!=y.drawExternalLabel&&c.push(y.drawExternalLabel)}for(i=0;i<g;i++){var m=(e=o[a[i]]).draw(t);null!=m.drawExternalLabel&&c.push(m.drawExternalLabel)}return{drawExternalLabels:function(){for(var t=0,e=c;t<e.length;t++){(0,e[t])()}}}}},{key:"_drawEdges",value:function(t){for(var e=this.body.edges,i=this.body.edgeIndices,n=0;n<i.length;n++){var o=e[i[n]];!0===o.connected&&o.draw(t)}}},{key:"_drawArrows",value:function(t){for(var e=this.body.edges,i=this.body.edgeIndices,n=0;n<i.length;n++){var o=e[i[n]];!0===o.connected&&o.drawArrows(t)}}},{key:"_determineBrowserMethod",value:function(){if("undefined"!=typeof window){var t=navigator.userAgent.toLowerCase();this.requiresTimeout=!1,(-1!=tm(t).call(t,"msie 9.0")||-1!=tm(t).call(t,"safari")&&tm(t).call(t,"chrome")<=-1)&&(this.requiresTimeout=!0)}else this.requiresTimeout=!0}},{key:"_drawSelectionBox",value:function(t){if(this.body.selectionBox.show){t.beginPath();var e=this.body.selectionBox.position.end.x-this.body.selectionBox.position.start.x,i=this.body.selectionBox.position.end.y-this.body.selectionBox.position.start.y;t.rect(this.body.selectionBox.position.start.x,this.body.selectionBox.position.start.y,e,i),t.fillStyle="rgba(151, 194, 252, 0.2)",t.fillRect(this.body.selectionBox.position.start.x,this.body.selectionBox.position.start.y,e,i),t.strokeStyle="rgba(151, 194, 252, 1)",t.stroke()}else t.closePath()}}]),t}(),eF={},iF=nt.setInterval;!function(t){t.exports=iF}({get exports(){return eF},set exports(t){eF=t}});var nF=i(eF);function oF(t,e){e.inputHandler=function(t){t.isFirst&&e(t)},t.on("hammer.input",e.inputHandler)}function rF(t,e){return e.inputHandler=function(t){t.isFinal&&e(t)},t.on("hammer.input",e.inputHandler)}var sF=function(){function t(e){pu(this,t),this.body=e,this.pixelRatio=1,this.cameraState={},this.initialized=!1,this.canvasViewCenter={},this._cleanupCallbacks=[],this.options={},this.defaultOptions={autoResize:!0,height:"100%",width:"100%"},xn(this.options,this.defaultOptions),this.bindEventListeners()}return Nf(t,[{key:"bindEventListeners",value:function(){var t,e=this;this.body.emitter.once("resize",(function(t){0!==t.width&&(e.body.view.translation.x=.5*t.width),0!==t.height&&(e.body.view.translation.y=.5*t.height)})),this.body.emitter.on("setSize",Yn(t=this.setSize).call(t,this)),this.body.emitter.on("destroy",(function(){e.hammerFrame.destroy(),e.hammer.destroy(),e._cleanUp()}))}},{key:"setOptions",value:function(t){var e=this;if(void 0!==t){qx(["width","height","autoResize"],this.options,t)}if(this._cleanUp(),!0===this.options.autoResize){var i;if(window.ResizeObserver){var n=new ResizeObserver((function(){!0===e.setSize()&&e.body.emitter.emit("_requestRedraw")})),o=this.frame;n.observe(o),this._cleanupCallbacks.push((function(){n.unobserve(o)}))}else{var r=nF((function(){!0===e.setSize()&&e.body.emitter.emit("_requestRedraw")}),1e3);this._cleanupCallbacks.push((function(){clearInterval(r)}))}var s=Yn(i=this._onResize).call(i,this);Qx(window,"resize",s),this._cleanupCallbacks.push((function(){Jx(window,"resize",s)}))}}},{key:"_cleanUp",value:function(){var t,e,i;Cv(t=Rv(e=vg(i=this._cleanupCallbacks).call(i,0)).call(e)).call(t,(function(t){try{t()}catch(t){console.error(t)}}))}},{key:"_onResize",value:function(){this.setSize(),this.body.emitter.emit("_redraw")}},{key:"_getCameraState",value:function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:this.pixelRatio;!0===this.initialized&&(this.cameraState.previousWidth=this.frame.canvas.width/t,this.cameraState.previousHeight=this.frame.canvas.height/t,this.cameraState.scale=this.body.view.scale,this.cameraState.position=this.DOMtoCanvas({x:.5*this.frame.canvas.width/t,y:.5*this.frame.canvas.height/t}))}},{key:"_setCameraState",value:function(){if(void 0!==this.cameraState.scale&&0!==this.frame.canvas.clientWidth&&0!==this.frame.canvas.clientHeight&&0!==this.pixelRatio&&this.cameraState.previousWidth>0&&this.cameraState.previousHeight>0){var t=this.frame.canvas.width/this.pixelRatio/this.cameraState.previousWidth,e=this.frame.canvas.height/this.pixelRatio/this.cameraState.previousHeight,i=this.cameraState.scale;1!=t&&1!=e?i=.5*this.cameraState.scale*(t+e):1!=t?i=this.cameraState.scale*t:1!=e&&(i=this.cameraState.scale*e),this.body.view.scale=i;var n=this.DOMtoCanvas({x:.5*this.frame.canvas.clientWidth,y:.5*this.frame.canvas.clientHeight}),o={x:n.x-this.cameraState.position.x,y:n.y-this.cameraState.position.y};this.body.view.translation.x+=o.x*this.body.view.scale,this.body.view.translation.y+=o.y*this.body.view.scale}}},{key:"_prepareValue",value:function(t){if("number"==typeof t)return t+"px";if("string"==typeof t){if(-1!==tm(t).call(t,"%")||-1!==tm(t).call(t,"px"))return t;if(-1===tm(t).call(t,"%"))return t+"px"}throw new Error("Could not use the value supplied for width or height:"+t)}},{key:"_create",value:function(){for(;this.body.container.hasChildNodes();)this.body.container.removeChild(this.body.container.firstChild);if(this.frame=document.createElement("div"),this.frame.className="vis-network",this.frame.style.position="relative",this.frame.style.overflow="hidden",this.frame.tabIndex=0,this.frame.canvas=document.createElement("canvas"),this.frame.canvas.style.position="relative",this.frame.appendChild(this.frame.canvas),this.frame.canvas.getContext)this._setPixelRatio(),this.setTransform();else{var t=document.createElement("DIV");t.style.color="red",t.style.fontWeight="bold",t.style.padding="10px",t.innerText="Error: your browser does not support HTML canvas",this.frame.canvas.appendChild(t)}this.body.container.appendChild(this.frame),this.body.view.scale=1,this.body.view.translation={x:.5*this.frame.canvas.clientWidth,y:.5*this.frame.canvas.clientHeight},this._bindHammer()}},{key:"_bindHammer",value:function(){var t=this;void 0!==this.hammer&&this.hammer.destroy(),this.drag={},this.pinch={},this.hammer=new Mk(this.frame.canvas),this.hammer.get("pinch").set({enable:!0}),this.hammer.get("pan").set({threshold:5,direction:Mk.DIRECTION_ALL}),oF(this.hammer,(function(e){t.body.eventListeners.onTouch(e)})),this.hammer.on("tap",(function(e){t.body.eventListeners.onTap(e)})),this.hammer.on("doubletap",(function(e){t.body.eventListeners.onDoubleTap(e)})),this.hammer.on("press",(function(e){t.body.eventListeners.onHold(e)})),this.hammer.on("panstart",(function(e){t.body.eventListeners.onDragStart(e)})),this.hammer.on("panmove",(function(e){t.body.eventListeners.onDrag(e)})),this.hammer.on("panend",(function(e){t.body.eventListeners.onDragEnd(e)})),this.hammer.on("pinch",(function(e){t.body.eventListeners.onPinch(e)})),this.frame.canvas.addEventListener("wheel",(function(e){t.body.eventListeners.onMouseWheel(e)})),this.frame.canvas.addEventListener("mousemove",(function(e){t.body.eventListeners.onMouseMove(e)})),this.frame.canvas.addEventListener("contextmenu",(function(e){t.body.eventListeners.onContext(e)})),this.hammerFrame=new Mk(this.frame),rF(this.hammerFrame,(function(e){t.body.eventListeners.onRelease(e)}))}},{key:"setSize",value:function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:this.options.width,e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:this.options.height;t=this._prepareValue(t),e=this._prepareValue(e);var i=!1,n=this.frame.canvas.width,o=this.frame.canvas.height,r=this.pixelRatio;if(this._setPixelRatio(),t!=this.options.width||e!=this.options.height||this.frame.style.width!=t||this.frame.style.height!=e)this._getCameraState(r),this.frame.style.width=t,this.frame.style.height=e,this.frame.canvas.style.width="100%",this.frame.canvas.style.height="100%",this.frame.canvas.width=Math.round(this.frame.canvas.clientWidth*this.pixelRatio),this.frame.canvas.height=Math.round(this.frame.canvas.clientHeight*this.pixelRatio),this.options.width=t,this.options.height=e,this.canvasViewCenter={x:.5*this.frame.clientWidth,y:.5*this.frame.clientHeight},i=!0;else{var s=Math.round(this.frame.canvas.clientWidth*this.pixelRatio),a=Math.round(this.frame.canvas.clientHeight*this.pixelRatio);this.frame.canvas.width===s&&this.frame.canvas.height===a||this._getCameraState(r),this.frame.canvas.width!==s&&(this.frame.canvas.width=s,i=!0),this.frame.canvas.height!==a&&(this.frame.canvas.height=a,i=!0)}return!0===i&&(this.body.emitter.emit("resize",{width:Math.round(this.frame.canvas.width/this.pixelRatio),height:Math.round(this.frame.canvas.height/this.pixelRatio),oldWidth:Math.round(n/this.pixelRatio),oldHeight:Math.round(o/this.pixelRatio)}),this._setCameraState()),this.initialized=!0,i}},{key:"getContext",value:function(){return this.frame.canvas.getContext("2d")}},{key:"_determinePixelRatio",value:function(){var t=this.getContext();if(void 0===t)throw new Error("Could not get canvax context");var e=1;return"undefined"!=typeof window&&(e=window.devicePixelRatio||1),e/(t.webkitBackingStorePixelRatio||t.mozBackingStorePixelRatio||t.msBackingStorePixelRatio||t.oBackingStorePixelRatio||t.backingStorePixelRatio||1)}},{key:"_setPixelRatio",value:function(){this.pixelRatio=this._determinePixelRatio()}},{key:"setTransform",value:function(){var t=this.getContext();if(void 0===t)throw new Error("Could not get canvax context");t.setTransform(this.pixelRatio,0,0,this.pixelRatio,0,0)}},{key:"_XconvertDOMtoCanvas",value:function(t){return(t-this.body.view.translation.x)/this.body.view.scale}},{key:"_XconvertCanvasToDOM",value:function(t){return t*this.body.view.scale+this.body.view.translation.x}},{key:"_YconvertDOMtoCanvas",value:function(t){return(t-this.body.view.translation.y)/this.body.view.scale}},{key:"_YconvertCanvasToDOM",value:function(t){return t*this.body.view.scale+this.body.view.translation.y}},{key:"canvasToDOM",value:function(t){return{x:this._XconvertCanvasToDOM(t.x),y:this._YconvertCanvasToDOM(t.y)}}},{key:"DOMtoCanvas",value:function(t){return{x:this._XconvertDOMtoCanvas(t.x),y:this._YconvertDOMtoCanvas(t.y)}}}]),t}();var aF=function(){function t(e,i){var n,o,r=this;pu(this,t),this.body=e,this.canvas=i,this.animationSpeed=1/this.renderRefreshRate,this.animationEasingFunction="easeInOutQuint",this.easingTime=0,this.sourceScale=0,this.targetScale=0,this.sourceTranslation=0,this.targetTranslation=0,this.lockedOnNodeId=void 0,this.lockedOnNodeOffset=void 0,this.touchTime=0,this.viewFunction=void 0,this.body.emitter.on("fit",Yn(n=this.fit).call(n,this)),this.body.emitter.on("animationFinished",(function(){r.body.emitter.emit("_stopRendering")})),this.body.emitter.on("unlockNode",Yn(o=this.releaseNode).call(o,this))}return Nf(t,[{key:"setOptions",value:function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{};this.options=t}},{key:"fit",value:function(t){var e=arguments.length>1&&void 0!==arguments[1]&&arguments[1];t=function(t,e){var i=xn({nodes:e,minZoomLevel:Number.MIN_VALUE,maxZoomLevel:1},null!=t?t:{});if(!Wp(i.nodes))throw new TypeError("Nodes has to be an array of ids.");if(0===i.nodes.length&&(i.nodes=e),!("number"==typeof i.minZoomLevel&&i.minZoomLevel>0))throw new TypeError("Min zoom level has to be a number higher than zero.");if(!("number"==typeof i.maxZoomLevel&&i.minZoomLevel<=i.maxZoomLevel))throw new TypeError("Max zoom level has to be a number higher than min zoom level.");return i}(t,this.body.nodeIndices);var i,n,o=this.canvas.frame.canvas.clientWidth,r=this.canvas.frame.canvas.clientHeight;if(0===o||0===r)n=1,i=$z.getRange(this.body.nodes,t.nodes);else if(!0===e){var s=0;for(var a in this.body.nodes){if(Object.prototype.hasOwnProperty.call(this.body.nodes,a))!0===this.body.nodes[a].predefinedPosition&&(s+=1)}if(s>.5*this.body.nodeIndices.length)return void this.fit(t,!1);i=$z.getRange(this.body.nodes,t.nodes),n=12.662/(this.body.nodeIndices.length+7.4147)+.0964822,n*=Math.min(o/600,r/600)}else{this.body.emitter.emit("_resizeNodes"),i=$z.getRange(this.body.nodes,t.nodes);var h=o/(1.1*Math.abs(i.maxX-i.minX)),l=r/(1.1*Math.abs(i.maxY-i.minY));n=h<=l?h:l}n>t.maxZoomLevel?n=t.maxZoomLevel:n<t.minZoomLevel&&(n=t.minZoomLevel);var d={position:$z.findCenter(i),scale:n,animation:t.animation};this.moveTo(d)}},{key:"focus",value:function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{};if(void 0!==this.body.nodes[t]){var i={x:this.body.nodes[t].x,y:this.body.nodes[t].y};e.position=i,e.lockedOnNode=t,this.moveTo(e)}else console.error("Node: "+t+" cannot be found.")}},{key:"moveTo",value:function(t){if(void 0!==t){if(null!=t.offset){if(null!=t.offset.x){if(t.offset.x=+t.offset.x,!eO(t.offset.x))throw new TypeError('The option "offset.x" has to be a finite number.')}else t.offset.x=0;if(null!=t.offset.y){if(t.offset.y=+t.offset.y,!eO(t.offset.y))throw new TypeError('The option "offset.y" has to be a finite number.')}else t.offset.x=0}else t.offset={x:0,y:0};if(null!=t.position){if(null!=t.position.x){if(t.position.x=+t.position.x,!eO(t.position.x))throw new TypeError('The option "position.x" has to be a finite number.')}else t.position.x=0;if(null!=t.position.y){if(t.position.y=+t.position.y,!eO(t.position.y))throw new TypeError('The option "position.y" has to be a finite number.')}else t.position.x=0}else t.position=this.getViewPosition();if(null!=t.scale){if(t.scale=+t.scale,!(t.scale>0))throw new TypeError('The option "scale" has to be a number greater than zero.')}else t.scale=this.body.view.scale;void 0===t.animation&&(t.animation={duration:0}),!1===t.animation&&(t.animation={duration:0}),!0===t.animation&&(t.animation={}),void 0===t.animation.duration&&(t.animation.duration=1e3),void 0===t.animation.easingFunction&&(t.animation.easingFunction="easeInOutQuad"),this.animateView(t)}else t={}}},{key:"animateView",value:function(t){if(void 0!==t){this.animationEasingFunction=t.animation.easingFunction,this.releaseNode(),!0===t.locked&&(this.lockedOnNodeId=t.lockedOnNode,this.lockedOnNodeOffset=t.offset),0!=this.easingTime&&this._transitionRedraw(!0),this.sourceScale=this.body.view.scale,this.sourceTranslation=this.body.view.translation,this.targetScale=t.scale,this.body.view.scale=this.targetScale;var e,i,n=this.canvas.DOMtoCanvas({x:.5*this.canvas.frame.canvas.clientWidth,y:.5*this.canvas.frame.canvas.clientHeight}),o=n.x-t.position.x,r=n.y-t.position.y;if(this.targetTranslation={x:this.sourceTranslation.x+o*this.targetScale+t.offset.x,y:this.sourceTranslation.y+r*this.targetScale+t.offset.y},0===t.animation.duration)if(null!=this.lockedOnNodeId)this.viewFunction=Yn(e=this._lockedRedraw).call(e,this),this.body.emitter.on("initRedraw",this.viewFunction);else this.body.view.scale=this.targetScale,this.body.view.translation=this.targetTranslation,this.body.emitter.emit("_requestRedraw");else this.animationSpeed=1/(60*t.animation.duration*.001)||1/60,this.animationEasingFunction=t.animation.easingFunction,this.viewFunction=Yn(i=this._transitionRedraw).call(i,this),this.body.emitter.on("initRedraw",this.viewFunction),this.body.emitter.emit("_startRendering")}}},{key:"_lockedRedraw",value:function(){var t=this.body.nodes[this.lockedOnNodeId].x,e=this.body.nodes[this.lockedOnNodeId].y,i=this.canvas.DOMtoCanvas({x:.5*this.canvas.frame.canvas.clientWidth,y:.5*this.canvas.frame.canvas.clientHeight}),n=i.x-t,o=i.y-e,r=this.body.view.translation,s={x:r.x+n*this.body.view.scale+this.lockedOnNodeOffset.x,y:r.y+o*this.body.view.scale+this.lockedOnNodeOffset.y};this.body.view.translation=s}},{key:"releaseNode",value:function(){void 0!==this.lockedOnNodeId&&void 0!==this.viewFunction&&(this.body.emitter.off("initRedraw",this.viewFunction),this.lockedOnNodeId=void 0,this.lockedOnNodeOffset=void 0)}},{key:"_transitionRedraw",value:function(){var t=arguments.length>0&&void 0!==arguments[0]&&arguments[0];this.easingTime+=this.animationSpeed,this.easingTime=!0===t?1:this.easingTime;var e=vk[this.animationEasingFunction](this.easingTime);if(this.body.view.scale=this.sourceScale+(this.targetScale-this.sourceScale)*e,this.body.view.translation={x:this.sourceTranslation.x+(this.targetTranslation.x-this.sourceTranslation.x)*e,y:this.sourceTranslation.y+(this.targetTranslation.y-this.sourceTranslation.y)*e},this.easingTime>=1){var i;if(this.body.emitter.off("initRedraw",this.viewFunction),this.easingTime=0,null!=this.lockedOnNodeId)this.viewFunction=Yn(i=this._lockedRedraw).call(i,this),this.body.emitter.on("initRedraw",this.viewFunction);this.body.emitter.emit("animationFinished")}}},{key:"getScale",value:function(){return this.body.view.scale}},{key:"getViewPosition",value:function(){return this.canvas.DOMtoCanvas({x:.5*this.canvas.frame.canvas.clientWidth,y:.5*this.canvas.frame.canvas.clientHeight})}}]),t}();function hF(t){var e,i=t&&t.preventDefault||!1,n=t&&t.container||window,o={},r={keydown:{},keyup:{}},s={};for(e=97;e<=122;e++)s[String.fromCharCode(e)]={code:e-97+65,shift:!1};for(e=65;e<=90;e++)s[String.fromCharCode(e)]={code:e,shift:!0};for(e=0;e<=9;e++)s[""+e]={code:48+e,shift:!1};for(e=1;e<=12;e++)s["F"+e]={code:111+e,shift:!1};for(e=0;e<=9;e++)s["num"+e]={code:96+e,shift:!1};s["num*"]={code:106,shift:!1},s["num+"]={code:107,shift:!1},s["num-"]={code:109,shift:!1},s["num/"]={code:111,shift:!1},s["num."]={code:110,shift:!1},s.left={code:37,shift:!1},s.up={code:38,shift:!1},s.right={code:39,shift:!1},s.down={code:40,shift:!1},s.space={code:32,shift:!1},s.enter={code:13,shift:!1},s.shift={code:16,shift:void 0},s.esc={code:27,shift:!1},s.backspace={code:8,shift:!1},s.tab={code:9,shift:!1},s.ctrl={code:17,shift:!1},s.alt={code:18,shift:!1},s.delete={code:46,shift:!1},s.pageup={code:33,shift:!1},s.pagedown={code:34,shift:!1},s["="]={code:187,shift:!1},s["-"]={code:189,shift:!1},s["]"]={code:221,shift:!1},s["["]={code:219,shift:!1};var a=function(t){l(t,"keydown")},h=function(t){l(t,"keyup")},l=function(t,e){if(void 0!==r[e][t.keyCode]){for(var n=r[e][t.keyCode],o=0;o<n.length;o++)(void 0===n[o].shift||1==n[o].shift&&1==t.shiftKey||0==n[o].shift&&0==t.shiftKey)&&n[o].fn(t);1==i&&t.preventDefault()}};return o.bind=function(t,e,i){if(void 0===i&&(i="keydown"),void 0===s[t])throw new Error("unsupported key: "+t);void 0===r[i][s[t].code]&&(r[i][s[t].code]=[]),r[i][s[t].code].push({fn:e,shift:s[t].shift})},o.bindAll=function(t,e){for(var i in void 0===e&&(e="keydown"),s)s.hasOwnProperty(i)&&o.bind(i,t,e)},o.getKey=function(t){for(var e in s)if(s.hasOwnProperty(e)){if(1==t.shiftKey&&1==s[e].shift&&t.keyCode==s[e].code)return e;if(0==t.shiftKey&&0==s[e].shift&&t.keyCode==s[e].code)return e;if(t.keyCode==s[e].code&&"shift"==e)return e}return"unknown key, currently not supported"},o.unbind=function(t,e,i){if(void 0===i&&(i="keydown"),void 0===s[t])throw new Error("unsupported key: "+t);if(void 0!==e){var n=[],o=r[i][s[t].code];if(void 0!==o)for(var a=0;a<o.length;a++)o[a].fn==e&&o[a].shift==s[t].shift||n.push(r[i][s[t].code][a]);r[i][s[t].code]=n}else r[i][s[t].code]=[]},o.reset=function(){r={keydown:{},keyup:{}}},o.destroy=function(){r={keydown:{},keyup:{}},n.removeEventListener("keydown",a,!0),n.removeEventListener("keyup",h,!0)},n.addEventListener("keydown",a,!0),n.addEventListener("keyup",h,!0),o}var lF=Object.freeze({__proto__:null,default:hF}),dF=function(){function t(e,i){var n=this;pu(this,t),this.body=e,this.canvas=i,this.iconsCreated=!1,this.navigationHammers=[],this.boundFunctions={},this.touchTime=0,this.activated=!1,this.body.emitter.on("activate",(function(){n.activated=!0,n.configureKeyboardBindings()})),this.body.emitter.on("deactivate",(function(){n.activated=!1,n.configureKeyboardBindings()})),this.body.emitter.on("destroy",(function(){void 0!==n.keycharm&&n.keycharm.destroy()})),this.options={}}return Nf(t,[{key:"setOptions",value:function(t){void 0!==t&&(this.options=t,this.create())}},{key:"create",value:function(){!0===this.options.navigationButtons?!1===this.iconsCreated&&this.loadNavigationElements():!0===this.iconsCreated&&this.cleanNavigation(),this.configureKeyboardBindings()}},{key:"cleanNavigation",value:function(){if(0!=this.navigationHammers.length){for(var t=0;t<this.navigationHammers.length;t++)this.navigationHammers[t].destroy();this.navigationHammers=[]}this.navigationDOM&&this.navigationDOM.wrapper&&this.navigationDOM.wrapper.parentNode&&this.navigationDOM.wrapper.parentNode.removeChild(this.navigationDOM.wrapper),this.iconsCreated=!1}},{key:"loadNavigationElements",value:function(){var t=this;this.cleanNavigation(),this.navigationDOM={};var e=["up","down","left","right","zoomIn","zoomOut","zoomExtends"],i=["_moveUp","_moveDown","_moveLeft","_moveRight","_zoomIn","_zoomOut","_fit"];this.navigationDOM.wrapper=document.createElement("div"),this.navigationDOM.wrapper.className="vis-navigation",this.canvas.frame.appendChild(this.navigationDOM.wrapper);for(var n=0;n<e.length;n++){this.navigationDOM[e[n]]=document.createElement("div"),this.navigationDOM[e[n]].className="vis-button vis-"+e[n],this.navigationDOM.wrapper.appendChild(this.navigationDOM[e[n]]);var o,r,s=new Mk(this.navigationDOM[e[n]]);if("_fit"===i[n])oF(s,Yn(o=this._fit).call(o,this));else oF(s,Yn(r=this.bindToRedraw).call(r,this,i[n]));this.navigationHammers.push(s)}var a=new Mk(this.canvas.frame);rF(a,(function(){t._stopMovement()})),this.navigationHammers.push(a),this.iconsCreated=!0}},{key:"bindToRedraw",value:function(t){var e;void 0===this.boundFunctions[t]&&(this.boundFunctions[t]=Yn(e=this[t]).call(e,this),this.body.emitter.on("initRedraw",this.boundFunctions[t]),this.body.emitter.emit("_startRendering"))}},{key:"unbindFromRedraw",value:function(t){void 0!==this.boundFunctions[t]&&(this.body.emitter.off("initRedraw",this.boundFunctions[t]),this.body.emitter.emit("_stopRendering"),delete this.boundFunctions[t])}},{key:"_fit",value:function(){(new Date).valueOf()-this.touchTime>700&&(this.body.emitter.emit("fit",{duration:700}),this.touchTime=(new Date).valueOf())}},{key:"_stopMovement",value:function(){for(var t in this.boundFunctions)Object.prototype.hasOwnProperty.call(this.boundFunctions,t)&&(this.body.emitter.off("initRedraw",this.boundFunctions[t]),this.body.emitter.emit("_stopRendering"));this.boundFunctions={}}},{key:"_moveUp",value:function(){this.body.view.translation.y+=this.options.keyboard.speed.y}},{key:"_moveDown",value:function(){this.body.view.translation.y-=this.options.keyboard.speed.y}},{key:"_moveLeft",value:function(){this.body.view.translation.x+=this.options.keyboard.speed.x}},{key:"_moveRight",value:function(){this.body.view.translation.x-=this.options.keyboard.speed.x}},{key:"_zoomIn",value:function(){var t=this.body.view.scale,e=this.body.view.scale*(1+this.options.keyboard.speed.zoom),i=this.body.view.translation,n=e/t,o=(1-n)*this.canvas.canvasViewCenter.x+i.x*n,r=(1-n)*this.canvas.canvasViewCenter.y+i.y*n;this.body.view.scale=e,this.body.view.translation={x:o,y:r},this.body.emitter.emit("zoom",{direction:"+",scale:this.body.view.scale,pointer:null})}},{key:"_zoomOut",value:function(){var t=this.body.view.scale,e=this.body.view.scale/(1+this.options.keyboard.speed.zoom),i=this.body.view.translation,n=e/t,o=(1-n)*this.canvas.canvasViewCenter.x+i.x*n,r=(1-n)*this.canvas.canvasViewCenter.y+i.y*n;this.body.view.scale=e,this.body.view.translation={x:o,y:r},this.body.emitter.emit("zoom",{direction:"-",scale:this.body.view.scale,pointer:null})}},{key:"configureKeyboardBindings",value:function(){var t,e,i,n,o,r,s,a,h,l,d,c,u,f,p,v,g,y,m,b,w,x,k,_,E=this;(void 0!==this.keycharm&&this.keycharm.destroy(),!0===this.options.keyboard.enabled)&&(!0===this.options.keyboard.bindToWindow?this.keycharm=hF({container:window,preventDefault:!0}):this.keycharm=hF({container:this.canvas.frame,preventDefault:!0}),this.keycharm.reset(),!0===this.activated&&(Yn(t=this.keycharm).call(t,"up",(function(){E.bindToRedraw("_moveUp")}),"keydown"),Yn(e=this.keycharm).call(e,"down",(function(){E.bindToRedraw("_moveDown")}),"keydown"),Yn(i=this.keycharm).call(i,"left",(function(){E.bindToRedraw("_moveLeft")}),"keydown"),Yn(n=this.keycharm).call(n,"right",(function(){E.bindToRedraw("_moveRight")}),"keydown"),Yn(o=this.keycharm).call(o,"=",(function(){E.bindToRedraw("_zoomIn")}),"keydown"),Yn(r=this.keycharm).call(r,"num+",(function(){E.bindToRedraw("_zoomIn")}),"keydown"),Yn(s=this.keycharm).call(s,"num-",(function(){E.bindToRedraw("_zoomOut")}),"keydown"),Yn(a=this.keycharm).call(a,"-",(function(){E.bindToRedraw("_zoomOut")}),"keydown"),Yn(h=this.keycharm).call(h,"[",(function(){E.bindToRedraw("_zoomOut")}),"keydown"),Yn(l=this.keycharm).call(l,"]",(function(){E.bindToRedraw("_zoomIn")}),"keydown"),Yn(d=this.keycharm).call(d,"pageup",(function(){E.bindToRedraw("_zoomIn")}),"keydown"),Yn(c=this.keycharm).call(c,"pagedown",(function(){E.bindToRedraw("_zoomOut")}),"keydown"),Yn(u=this.keycharm).call(u,"up",(function(){E.unbindFromRedraw("_moveUp")}),"keyup"),Yn(f=this.keycharm).call(f,"down",(function(){E.unbindFromRedraw("_moveDown")}),"keyup"),Yn(p=this.keycharm).call(p,"left",(function(){E.unbindFromRedraw("_moveLeft")}),"keyup"),Yn(v=this.keycharm).call(v,"right",(function(){E.unbindFromRedraw("_moveRight")}),"keyup"),Yn(g=this.keycharm).call(g,"=",(function(){E.unbindFromRedraw("_zoomIn")}),"keyup"),Yn(y=this.keycharm).call(y,"num+",(function(){E.unbindFromRedraw("_zoomIn")}),"keyup"),Yn(m=this.keycharm).call(m,"num-",(function(){E.unbindFromRedraw("_zoomOut")}),"keyup"),Yn(b=this.keycharm).call(b,"-",(function(){E.unbindFromRedraw("_zoomOut")}),"keyup"),Yn(w=this.keycharm).call(w,"[",(function(){E.unbindFromRedraw("_zoomOut")}),"keyup"),Yn(x=this.keycharm).call(x,"]",(function(){E.unbindFromRedraw("_zoomIn")}),"keyup"),Yn(k=this.keycharm).call(k,"pageup",(function(){E.unbindFromRedraw("_zoomIn")}),"keyup"),Yn(_=this.keycharm).call(_,"pagedown",(function(){E.unbindFromRedraw("_zoomOut")}),"keyup")))}}]),t}();function cF(t,e){var i=void 0!==Op&&xh(t)||t["@@iterator"];if(!i){if(Wp(t)||(i=function(t,e){var i;if(!t)return;if("string"==typeof t)return uF(t,e);var n=Fp(i=Object.prototype.toString.call(t)).call(i,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return Za(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return uF(t,e)}(t))||e&&t&&"number"==typeof t.length){i&&(t=i);var n=0,o=function(){};return{s:o,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var r,s=!0,a=!1;return{s:function(){i=i.call(t)},n:function(){var t=i.next();return s=t.done,t},e:function(t){a=!0,r=t},f:function(){try{s||null==i.return||i.return()}finally{if(a)throw r}}}}function uF(t,e){(null==e||e>t.length)&&(e=t.length);for(var i=0,n=new Array(e);i<e;i++)n[i]=t[i];return n}var fF=function(){function t(e,i,n){var o,r,s,a,h,l,d,c,u,f,p,v,g;pu(this,t),this.body=e,this.canvas=i,this.selectionHandler=n,this.navigationHandler=new dF(e,i),this.body.eventListeners.onTap=Yn(o=this.onTap).call(o,this),this.body.eventListeners.onTouch=Yn(r=this.onTouch).call(r,this),this.body.eventListeners.onDoubleTap=Yn(s=this.onDoubleTap).call(s,this),this.body.eventListeners.onHold=Yn(a=this.onHold).call(a,this),this.body.eventListeners.onDragStart=Yn(h=this.onDragStart).call(h,this),this.body.eventListeners.onDrag=Yn(l=this.onDrag).call(l,this),this.body.eventListeners.onDragEnd=Yn(d=this.onDragEnd).call(d,this),this.body.eventListeners.onMouseWheel=Yn(c=this.onMouseWheel).call(c,this),this.body.eventListeners.onPinch=Yn(u=this.onPinch).call(u,this),this.body.eventListeners.onMouseMove=Yn(f=this.onMouseMove).call(f,this),this.body.eventListeners.onRelease=Yn(p=this.onRelease).call(p,this),this.body.eventListeners.onContext=Yn(v=this.onContext).call(v,this),this.touchTime=0,this.drag={},this.pinch={},this.popup=void 0,this.popupObj=void 0,this.popupTimer=void 0,this.body.functions.getPointer=Yn(g=this.getPointer).call(g,this),this.options={},this.defaultOptions={dragNodes:!0,dragView:!0,hover:!1,keyboard:{enabled:!1,speed:{x:10,y:10,zoom:.02},bindToWindow:!0,autoFocus:!0},navigationButtons:!1,tooltipDelay:300,zoomView:!0,zoomSpeed:1},xn(this.options,this.defaultOptions),this.bindEventListeners()}return Nf(t,[{key:"bindEventListeners",value:function(){var t=this;this.body.emitter.on("destroy",(function(){clearTimeout(t.popupTimer),delete t.body.functions.getPointer}))}},{key:"setOptions",value:function(t){if(void 0!==t){Vx(["hideEdgesOnDrag","hideEdgesOnZoom","hideNodesOnDrag","keyboard","multiselect","selectable","selectConnectedEdges"],this.options,t),pk(this.options,t,"keyboard"),t.tooltip&&(xn(this.options.tooltip,t.tooltip),t.tooltip.color&&(this.options.tooltip.color=ok(t.tooltip.color)))}this.navigationHandler.setOptions(this.options)}},{key:"getPointer",value:function(t){return{x:t.x-Gx(this.canvas.frame.canvas),y:t.y-Kx(this.canvas.frame.canvas)}}},{key:"onTouch",value:function(t){(new Date).valueOf()-this.touchTime>50&&(this.drag.pointer=this.getPointer(t.center),this.drag.pinched=!1,this.pinch.scale=this.body.view.scale,this.touchTime=(new Date).valueOf())}},{key:"onTap",value:function(t){var e=this.getPointer(t.center),i=this.selectionHandler.options.multiselect&&(t.changedPointers[0].ctrlKey||t.changedPointers[0].metaKey);this.checkSelectionChanges(e,i),this.selectionHandler.commitAndEmit(e,t),this.selectionHandler.generateClickEvent("click",t,e)}},{key:"onDoubleTap",value:function(t){var e=this.getPointer(t.center);this.selectionHandler.generateClickEvent("doubleClick",t,e)}},{key:"onHold",value:function(t){var e=this.getPointer(t.center),i=this.selectionHandler.options.multiselect;this.checkSelectionChanges(e,i),this.selectionHandler.commitAndEmit(e,t),this.selectionHandler.generateClickEvent("click",t,e),this.selectionHandler.generateClickEvent("hold",t,e)}},{key:"onRelease",value:function(t){if((new Date).valueOf()-this.touchTime>10){var e=this.getPointer(t.center);this.selectionHandler.generateClickEvent("release",t,e),this.touchTime=(new Date).valueOf()}}},{key:"onContext",value:function(t){var e=this.getPointer({x:t.clientX,y:t.clientY});this.selectionHandler.generateClickEvent("oncontext",t,e)}},{key:"checkSelectionChanges",value:function(t){!0===(arguments.length>1&&void 0!==arguments[1]&&arguments[1])?this.selectionHandler.selectAdditionalOnPoint(t):this.selectionHandler.selectOnPoint(t)}},{key:"_determineDifference",value:function(t,e){var i=function(t,e){for(var i=[],n=0;n<t.length;n++){var o=t[n];-1===tm(e).call(e,o)&&i.push(o)}return i};return{nodes:i(t.nodes,e.nodes),edges:i(t.edges,e.edges)}}},{key:"onDragStart",value:function(t){if(!this.drag.dragging){void 0===this.drag.pointer&&this.onTouch(t);var e=this.selectionHandler.getNodeAt(this.drag.pointer);if(this.drag.dragging=!0,this.drag.selection=[],this.drag.translation=xn({},this.body.view.translation),this.drag.nodeId=void 0,t.srcEvent.shiftKey){this.body.selectionBox.show=!0;var i=this.getPointer(t.center);this.body.selectionBox.position.start={x:this.canvas._XconvertDOMtoCanvas(i.x),y:this.canvas._YconvertDOMtoCanvas(i.y)},this.body.selectionBox.position.end={x:this.canvas._XconvertDOMtoCanvas(i.x),y:this.canvas._YconvertDOMtoCanvas(i.y)}}else if(void 0!==e&&!0===this.options.dragNodes){this.drag.nodeId=e.id,!1===e.isSelected()&&this.selectionHandler.setSelection({nodes:[e.id]}),this.selectionHandler.generateClickEvent("dragStart",t,this.drag.pointer);var n,o=cF(this.selectionHandler.getSelectedNodes());try{for(o.s();!(n=o.n()).done;){var r=n.value,s={id:r.id,node:r,x:r.x,y:r.y,xFixed:r.options.fixed.x,yFixed:r.options.fixed.y};r.options.fixed.x=!0,r.options.fixed.y=!0,this.drag.selection.push(s)}}catch(t){o.e(t)}finally{o.f()}}else this.selectionHandler.generateClickEvent("dragStart",t,this.drag.pointer,void 0,!0)}}},{key:"onDrag",value:function(t){var e=this;if(!0!==this.drag.pinched){this.body.emitter.emit("unlockNode");var i=this.getPointer(t.center),n=this.drag.selection;if(n&&n.length&&!0===this.options.dragNodes){this.selectionHandler.generateClickEvent("dragging",t,i);var o=i.x-this.drag.pointer.x,r=i.y-this.drag.pointer.y;Cv(n).call(n,(function(t){var i=t.node;!1===t.xFixed&&(i.x=e.canvas._XconvertDOMtoCanvas(e.canvas._XconvertCanvasToDOM(t.x)+o)),!1===t.yFixed&&(i.y=e.canvas._YconvertDOMtoCanvas(e.canvas._YconvertCanvasToDOM(t.y)+r))})),this.body.emitter.emit("startSimulation")}else{if(t.srcEvent.shiftKey){if(this.selectionHandler.generateClickEvent("dragging",t,i,void 0,!0),void 0===this.drag.pointer)return void this.onDragStart(t);this.body.selectionBox.position.end={x:this.canvas._XconvertDOMtoCanvas(i.x),y:this.canvas._YconvertDOMtoCanvas(i.y)},this.body.emitter.emit("_requestRedraw")}if(!0===this.options.dragView&&!t.srcEvent.shiftKey){if(this.selectionHandler.generateClickEvent("dragging",t,i,void 0,!0),void 0===this.drag.pointer)return void this.onDragStart(t);var s=i.x-this.drag.pointer.x,a=i.y-this.drag.pointer.y;this.body.view.translation={x:this.drag.translation.x+s,y:this.drag.translation.y+a},this.body.emitter.emit("_requestRedraw")}}}}},{key:"onDragEnd",value:function(t){var e=this;if(this.drag.dragging=!1,this.body.selectionBox.show){var i;this.body.selectionBox.show=!1;var n=this.body.selectionBox.position,o={minX:Math.min(n.start.x,n.end.x),minY:Math.min(n.start.y,n.end.y),maxX:Math.max(n.start.x,n.end.x),maxY:Math.max(n.start.y,n.end.y)},r=ny(i=this.body.nodeIndices).call(i,(function(t){var i=e.body.nodes[t];return i.x>=o.minX&&i.x<=o.maxX&&i.y>=o.minY&&i.y<=o.maxY}));Cv(r).call(r,(function(t){return e.selectionHandler.selectObject(e.body.nodes[t])}));var s=this.getPointer(t.center);this.selectionHandler.commitAndEmit(s,t),this.selectionHandler.generateClickEvent("dragEnd",t,this.getPointer(t.center),void 0,!0),this.body.emitter.emit("_requestRedraw")}else{var a=this.drag.selection;a&&a.length?(Cv(a).call(a,(function(t){t.node.options.fixed.x=t.xFixed,t.node.options.fixed.y=t.yFixed})),this.selectionHandler.generateClickEvent("dragEnd",t,this.getPointer(t.center)),this.body.emitter.emit("startSimulation")):(this.selectionHandler.generateClickEvent("dragEnd",t,this.getPointer(t.center),void 0,!0),this.body.emitter.emit("_requestRedraw"))}}},{key:"onPinch",value:function(t){var e=this.getPointer(t.center);this.drag.pinched=!0,void 0===this.pinch.scale&&(this.pinch.scale=1);var i=this.pinch.scale*t.scale;this.zoom(i,e)}},{key:"zoom",value:function(t,e){if(!0===this.options.zoomView){var i=this.body.view.scale;t<1e-5&&(t=1e-5),t>10&&(t=10);var n=void 0;void 0!==this.drag&&!0===this.drag.dragging&&(n=this.canvas.DOMtoCanvas(this.drag.pointer));var o=this.body.view.translation,r=t/i,s=(1-r)*e.x+o.x*r,a=(1-r)*e.y+o.y*r;if(this.body.view.scale=t,this.body.view.translation={x:s,y:a},null!=n){var h=this.canvas.canvasToDOM(n);this.drag.pointer.x=h.x,this.drag.pointer.y=h.y}this.body.emitter.emit("_requestRedraw"),i<t?this.body.emitter.emit("zoom",{direction:"+",scale:this.body.view.scale,pointer:e}):this.body.emitter.emit("zoom",{direction:"-",scale:this.body.view.scale,pointer:e})}}},{key:"onMouseWheel",value:function(t){if(!0===this.options.zoomView){if(0!==t.deltaY){var e=this.body.view.scale;e*=1+(t.deltaY<0?1:-1)*(.1*this.options.zoomSpeed);var i=this.getPointer({x:t.clientX,y:t.clientY});this.zoom(e,i)}t.preventDefault()}}},{key:"onMouseMove",value:function(t){var e=this,i=this.getPointer({x:t.clientX,y:t.clientY}),n=!1;void 0!==this.popup&&(!1===this.popup.hidden&&this._checkHidePopup(i),!1===this.popup.hidden&&(n=!0,this.popup.setPosition(i.x+3,i.y-5),this.popup.show())),this.options.keyboard.autoFocus&&!1===this.options.keyboard.bindToWindow&&!0===this.options.keyboard.enabled&&this.canvas.frame.focus(),!1===n&&(void 0!==this.popupTimer&&(clearInterval(this.popupTimer),this.popupTimer=void 0),this.drag.dragging||(this.popupTimer=Gm((function(){return e._checkShowPopup(i)}),this.options.tooltipDelay))),!0===this.options.hover&&this.selectionHandler.hoverObject(t,i)}},{key:"_checkShowPopup",value:function(t){var e=this.canvas._XconvertDOMtoCanvas(t.x),i=this.canvas._YconvertDOMtoCanvas(t.y),n={left:e,top:i,right:e,bottom:i},o=void 0===this.popupObj?void 0:this.popupObj.id,r=!1,s="node";if(void 0===this.popupObj){for(var a,h=this.body.nodeIndices,l=this.body.nodes,d=[],c=0;c<h.length;c++)!0===(a=l[h[c]]).isOverlappingWith(n)&&(r=!0,void 0!==a.getTitle()&&d.push(h[c]));d.length>0&&(this.popupObj=l[d[d.length-1]],r=!0)}if(void 0===this.popupObj&&!1===r){for(var u,f=this.body.edgeIndices,p=this.body.edges,v=[],g=0;g<f.length;g++)!0===(u=p[f[g]]).isOverlappingWith(n)&&!0===u.connected&&void 0!==u.getTitle()&&v.push(f[g]);v.length>0&&(this.popupObj=p[v[v.length-1]],s="edge")}void 0!==this.popupObj?this.popupObj.id!==o&&(void 0===this.popup&&(this.popup=new Pk(this.canvas.frame)),this.popup.popupTargetType=s,this.popup.popupTargetId=this.popupObj.id,this.popup.setPosition(t.x+3,t.y-5),this.popup.setText(this.popupObj.getTitle()),this.popup.show(),this.body.emitter.emit("showPopup",this.popupObj.id)):void 0!==this.popup&&(this.popup.hide(),this.body.emitter.emit("hidePopup"))}},{key:"_checkHidePopup",value:function(t){var e=this.selectionHandler._pointerToPositionObject(t),i=!1;if("node"===this.popup.popupTargetType){if(void 0!==this.body.nodes[this.popup.popupTargetId]&&!0===(i=this.body.nodes[this.popup.popupTargetId].isOverlappingWith(e))){var n=this.selectionHandler.getNodeAt(t);i=void 0!==n&&n.id===this.popup.popupTargetId}}else void 0===this.selectionHandler.getNodeAt(t)&&void 0!==this.body.edges[this.popup.popupTargetId]&&(i=this.body.edges[this.popup.popupTargetId].isOverlappingWith(e));!1===i&&(this.popupObj=void 0,this.popup.hide(),this.body.emitter.emit("hidePopup"))}}]),t}(),pF={},vF={get exports(){return pF},set exports(t){pF=t}},gF=m,yF=kE,mF=y_.getWeakData,bF=oE,wF=ni,xF=X,kF=it,_F=eE,EF=Jt,OF=Xo.set,CF=Xo.getterFor,SF=vl.find,TF=vl.findIndex,MF=gF([].splice),PF=0,DF=function(t){return t.frozen||(t.frozen=new IF)},IF=function(){this.entries=[]},BF=function(t,e){return SF(t.entries,(function(t){return t[0]===e}))};IF.prototype={get:function(t){var e=BF(this,t);if(e)return e[1]},has:function(t){return!!BF(this,t)},set:function(t,e){var i=BF(this,t);i?i[1]=e:this.entries.push([t,e])},delete:function(t){var e=TF(this.entries,(function(e){return e[0]===t}));return~e&&MF(this.entries,e,1),!!~e}};var NF,zF={getConstructor:function(t,e,i,n){var o=t((function(t,o){bF(t,r),OF(t,{type:e,id:PF++,frozen:void 0}),xF(o)||_F(o,t[n],{that:t,AS_ENTRIES:i})})),r=o.prototype,s=CF(e),a=function(t,e,i){var n=s(t),o=mF(wF(e),!0);return!0===o?DF(n).set(e,i):o[n.id]=i,t};return yF(r,{delete:function(t){var e=s(this);if(!kF(t))return!1;var i=mF(t);return!0===i?DF(e).delete(t):i&&EF(i,e.id)&&delete i[e.id]},has:function(t){var e=s(this);if(!kF(t))return!1;var i=mF(t);return!0===i?DF(e).has(t):i&&EF(i,e.id)}}),yF(r,i?{get:function(t){var e=s(this);if(kF(t)){var i=mF(t);return!0===i?DF(e).get(t):i?i[e.id]:void 0}},set:function(t,e){return a(this,t,e)}}:{add:function(t){return a(this,t,!0)}}),o}},FF=C_,AF=s,jF=m,RF=kE,LF=y_,HF=wE,WF=zF,qF=it,VF=Xo.enforce,UF=a,YF=Po,XF=Object,GF=Array.isArray,KF=XF.isExtensible,$F=XF.isFrozen,ZF=XF.isSealed,QF=XF.freeze,JF=XF.seal,tA={},eA={},iA=!AF.ActiveXObject&&"ActiveXObject"in AF,nA=function(t){return function(){return t(this,arguments.length?arguments[0]:void 0)}},oA=HF("WeakMap",nA,WF),rA=oA.prototype,sA=jF(rA.set);if(YF)if(iA){NF=WF.getConstructor(nA,"WeakMap",!0),LF.enable();var aA=jF(rA.delete),hA=jF(rA.has),lA=jF(rA.get);RF(rA,{delete:function(t){if(qF(t)&&!KF(t)){var e=VF(this);return e.frozen||(e.frozen=new NF),aA(this,t)||e.frozen.delete(t)}return aA(this,t)},has:function(t){if(qF(t)&&!KF(t)){var e=VF(this);return e.frozen||(e.frozen=new NF),hA(this,t)||e.frozen.has(t)}return hA(this,t)},get:function(t){if(qF(t)&&!KF(t)){var e=VF(this);return e.frozen||(e.frozen=new NF),hA(this,t)?lA(this,t):e.frozen.get(t)}return lA(this,t)},set:function(t,e){if(qF(t)&&!KF(t)){var i=VF(this);i.frozen||(i.frozen=new NF),hA(this,t)?sA(this,t,e):i.frozen.set(t,e)}else sA(this,t,e);return this}})}else FF&&UF((function(){var t=QF([]);return sA(new oA,t,1),!$F(t)}))&&RF(rA,{set:function(t,e){var i;return GF(t)&&($F(t)?i=tA:ZF(t)&&(i=eA)),sA(this,t,e),i==tA&&QF(t),i==eA&&JF(t),this}});var dA=nt.WeakMap;!function(t){t.exports=dA}(vF);var cA,uA,fA,pA,vA,gA=i(pF);function yA(t,e,i,n){if("a"===i&&!n)throw new TypeError("Private accessor was defined without a getter");if("function"==typeof e?t!==e||!n:!e.has(t))throw new TypeError("Cannot read private member from an object whose class did not declare it");return"m"===i?n:"a"===i?n.call(t):n?n.value:e.get(t)}function mA(t,e,i,n,o){if("m"===n)throw new TypeError("Private method is not writable");if("a"===n&&!o)throw new TypeError("Private accessor was defined without a setter");if("function"==typeof e?t!==e||!o:!e.has(t))throw new TypeError("Cannot write private member to an object whose class did not declare it");return"a"===n?o.call(t,i):o?o.value=i:e.set(t,i),i}function bA(t,e){var i=void 0!==Op&&xh(t)||t["@@iterator"];if(!i){if(Wp(t)||(i=function(t,e){var i;if(!t)return;if("string"==typeof t)return wA(t,e);var n=Fp(i=Object.prototype.toString.call(t)).call(i,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return Za(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return wA(t,e)}(t))||e&&t&&"number"==typeof t.length){i&&(t=i);var n=0,o=function(){};return{s:o,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var r,s=!0,a=!1;return{s:function(){i=i.call(t)},n:function(){var t=i.next();return s=t.done,t},e:function(t){a=!0,r=t},f:function(){try{s||null==i.return||i.return()}finally{if(a)throw r}}}}function wA(t,e){(null==e||e>t.length)&&(e=t.length);for(var i=0,n=new Array(e);i<e;i++)n[i]=t[i];return n}function xA(t,e){var i,n=new XP,o=bA(e);try{for(o.s();!(i=o.n()).done;){var r=i.value;t.has(r)||n.add(r)}}catch(t){o.e(t)}finally{o.f()}return n}var kA=function(){function t(){pu(this,t),cA.set(this,new XP),uA.set(this,new XP)}return Nf(t,[{key:"size",get:function(){return yA(this,uA,"f").size}},{key:"add",value:function(){for(var t=arguments.length,e=new Array(t),i=0;i<t;i++)e[i]=arguments[i];for(var n=0,o=e;n<o.length;n++){var r=o[n];yA(this,uA,"f").add(r)}}},{key:"delete",value:function(){for(var t=arguments.length,e=new Array(t),i=0;i<t;i++)e[i]=arguments[i];for(var n=0,o=e;n<o.length;n++){var r=o[n];yA(this,uA,"f").delete(r)}}},{key:"clear",value:function(){yA(this,uA,"f").clear()}},{key:"getSelection",value:function(){return _p(yA(this,uA,"f"))}},{key:"getChanges",value:function(){return{added:_p(xA(yA(this,cA,"f"),yA(this,uA,"f"))),deleted:_p(xA(yA(this,uA,"f"),yA(this,cA,"f"))),previous:_p(new XP(yA(this,cA,"f"))),current:_p(new XP(yA(this,uA,"f")))}}},{key:"commit",value:function(){var t=this.getChanges();mA(this,cA,yA(this,uA,"f"),"f"),mA(this,uA,new XP(yA(this,cA,"f")),"f");var e,i=bA(t.added);try{for(i.s();!(e=i.n()).done;){e.value.select()}}catch(t){i.e(t)}finally{i.f()}var n,o=bA(t.deleted);try{for(o.s();!(n=o.n()).done;){n.value.unselect()}}catch(t){o.e(t)}finally{o.f()}return t}}]),t}();cA=new gA,uA=new gA;var _A=function(){function t(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:function(){};pu(this,t),fA.set(this,new kA),pA.set(this,new kA),vA.set(this,void 0),mA(this,vA,e,"f")}return Nf(t,[{key:"sizeNodes",get:function(){return yA(this,fA,"f").size}},{key:"sizeEdges",get:function(){return yA(this,pA,"f").size}},{key:"getNodes",value:function(){return yA(this,fA,"f").getSelection()}},{key:"getEdges",value:function(){return yA(this,pA,"f").getSelection()}},{key:"addNodes",value:function(){var t;(t=yA(this,fA,"f")).add.apply(t,arguments)}},{key:"addEdges",value:function(){var t;(t=yA(this,pA,"f")).add.apply(t,arguments)}},{key:"deleteNodes",value:function(t){yA(this,fA,"f").delete(t)}},{key:"deleteEdges",value:function(t){yA(this,pA,"f").delete(t)}},{key:"clear",value:function(){yA(this,fA,"f").clear(),yA(this,pA,"f").clear()}},{key:"commit",value:function(){for(var t,e,i={nodes:yA(this,fA,"f").commit(),edges:yA(this,pA,"f").commit()},n=arguments.length,o=new Array(n),r=0;r<n;r++)o[r]=arguments[r];return(t=yA(this,vA,"f")).call.apply(t,Np(e=[this,i]).call(e,o)),i}}]),t}();function EA(t,e){var i=void 0!==Op&&xh(t)||t["@@iterator"];if(!i){if(Wp(t)||(i=function(t,e){var i;if(!t)return;if("string"==typeof t)return OA(t,e);var n=Fp(i=Object.prototype.toString.call(t)).call(i,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return Za(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return OA(t,e)}(t))||e&&t&&"number"==typeof t.length){i&&(t=i);var n=0,o=function(){};return{s:o,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var r,s=!0,a=!1;return{s:function(){i=i.call(t)},n:function(){var t=i.next();return s=t.done,t},e:function(t){a=!0,r=t},f:function(){try{s||null==i.return||i.return()}finally{if(a)throw r}}}}function OA(t,e){(null==e||e>t.length)&&(e=t.length);for(var i=0,n=new Array(e);i<e;i++)n[i]=t[i];return n}fA=new gA,pA=new gA,vA=new gA;var CA=function(){function t(e,i){var n=this;pu(this,t),this.body=e,this.canvas=i,this._selectionAccumulator=new _A,this.hoverObj={nodes:{},edges:{}},this.options={},this.defaultOptions={multiselect:!1,selectable:!0,selectConnectedEdges:!0,hoverConnectedEdges:!0},xn(this.options,this.defaultOptions),this.body.emitter.on("_dataChanged",(function(){n.updateSelection()}))}return Nf(t,[{key:"setOptions",value:function(t){if(void 0!==t){qx(["multiselect","hoverConnectedEdges","selectable","selectConnectedEdges"],this.options,t)}}},{key:"selectOnPoint",value:function(t){var e=!1;if(!0===this.options.selectable){var i=this.getNodeAt(t)||this.getEdgeAt(t);this.unselectAll(),void 0!==i&&(e=this.selectObject(i)),this.body.emitter.emit("_requestRedraw")}return e}},{key:"selectAdditionalOnPoint",value:function(t){var e=!1;if(!0===this.options.selectable){var i=this.getNodeAt(t)||this.getEdgeAt(t);void 0!==i&&(e=!0,!0===i.isSelected()?this.deselectObject(i):this.selectObject(i),this.body.emitter.emit("_requestRedraw"))}return e}},{key:"_initBaseEvent",value:function(t,e){var i={};return i.pointer={DOM:{x:e.x,y:e.y},canvas:this.canvas.DOMtoCanvas(e)},i.event=t,i}},{key:"generateClickEvent",value:function(t,e,i,n){var o=arguments.length>4&&void 0!==arguments[4]&&arguments[4],r=this._initBaseEvent(e,i);if(!0===o)r.nodes=[],r.edges=[];else{var s=this.getSelection();r.nodes=s.nodes,r.edges=s.edges}void 0!==n&&(r.previousSelection=n),"click"==t&&(r.items=this.getClickedItems(i)),void 0!==e.controlEdge&&(r.controlEdge=e.controlEdge),this.body.emitter.emit(t,r)}},{key:"selectObject",value:function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:this.options.selectConnectedEdges;if(void 0!==t){if(t instanceof TN){var i;if(!0===e)(i=this._selectionAccumulator).addEdges.apply(i,_p(t.edges));this._selectionAccumulator.addNodes(t)}else this._selectionAccumulator.addEdges(t);return!0}return!1}},{key:"deselectObject",value:function(t){!0===t.isSelected()&&(t.selected=!1,this._removeFromSelection(t))}},{key:"_getAllNodesOverlappingWith",value:function(t){for(var e=[],i=this.body.nodes,n=0;n<this.body.nodeIndices.length;n++){var o=this.body.nodeIndices[n];i[o].isOverlappingWith(t)&&e.push(o)}return e}},{key:"_pointerToPositionObject",value:function(t){var e=this.canvas.DOMtoCanvas(t);return{left:e.x-1,top:e.y+1,right:e.x+1,bottom:e.y-1}}},{key:"getNodeAt",value:function(t){var e=!(arguments.length>1&&void 0!==arguments[1])||arguments[1],i=this._pointerToPositionObject(t),n=this._getAllNodesOverlappingWith(i);return n.length>0?!0===e?this.body.nodes[n[n.length-1]]:n[n.length-1]:void 0}},{key:"_getEdgesOverlappingWith",value:function(t,e){for(var i=this.body.edges,n=0;n<this.body.edgeIndices.length;n++){var o=this.body.edgeIndices[n];i[o].isOverlappingWith(t)&&e.push(o)}}},{key:"_getAllEdgesOverlappingWith",value:function(t){var e=[];return this._getEdgesOverlappingWith(t,e),e}},{key:"getEdgeAt",value:function(t){for(var e=!(arguments.length>1&&void 0!==arguments[1])||arguments[1],i=this.canvas.DOMtoCanvas(t),n=10,o=null,r=this.body.edges,s=0;s<this.body.edgeIndices.length;s++){var a=this.body.edgeIndices[s],h=r[a];if(h.connected){var l=h.from.x,d=h.from.y,c=h.to.x,u=h.to.y,f=h.edgeType.getDistanceToEdge(l,d,c,u,i.x,i.y);f<n&&(o=a,n=f)}}return null!==o?!0===e?this.body.edges[o]:o:void 0}},{key:"_addToHover",value:function(t){t instanceof TN?this.hoverObj.nodes[t.id]=t:this.hoverObj.edges[t.id]=t}},{key:"_removeFromSelection",value:function(t){var e;t instanceof TN?(this._selectionAccumulator.deleteNodes(t),(e=this._selectionAccumulator).deleteEdges.apply(e,_p(t.edges))):this._selectionAccumulator.deleteEdges(t)}},{key:"unselectAll",value:function(){this._selectionAccumulator.clear()}},{key:"getSelectedNodeCount",value:function(){return this._selectionAccumulator.sizeNodes}},{key:"getSelectedEdgeCount",value:function(){return this._selectionAccumulator.sizeEdges}},{key:"_hoverConnectedEdges",value:function(t){for(var e=0;e<t.edges.length;e++){var i=t.edges[e];i.hover=!0,this._addToHover(i)}}},{key:"emitBlurEvent",value:function(t,e,i){var n=this._initBaseEvent(t,e);!0===i.hover&&(i.hover=!1,i instanceof TN?(n.node=i.id,this.body.emitter.emit("blurNode",n)):(n.edge=i.id,this.body.emitter.emit("blurEdge",n)))}},{key:"emitHoverEvent",value:function(t,e,i){var n=this._initBaseEvent(t,e),o=!1;return!1===i.hover&&(i.hover=!0,this._addToHover(i),o=!0,i instanceof TN?(n.node=i.id,this.body.emitter.emit("hoverNode",n)):(n.edge=i.id,this.body.emitter.emit("hoverEdge",n))),o}},{key:"hoverObject",value:function(t,e){var i=this.getNodeAt(e);void 0===i&&(i=this.getEdgeAt(e));var n=!1;for(var o in this.hoverObj.nodes)Object.prototype.hasOwnProperty.call(this.hoverObj.nodes,o)&&(void 0===i||i instanceof TN&&i.id!=o||i instanceof Az)&&(this.emitBlurEvent(t,e,this.hoverObj.nodes[o]),delete this.hoverObj.nodes[o],n=!0);for(var r in this.hoverObj.edges)Object.prototype.hasOwnProperty.call(this.hoverObj.edges,r)&&(!0===n?(this.hoverObj.edges[r].hover=!1,delete this.hoverObj.edges[r]):(void 0===i||i instanceof Az&&i.id!=r||i instanceof TN&&!i.hover)&&(this.emitBlurEvent(t,e,this.hoverObj.edges[r]),delete this.hoverObj.edges[r],n=!0));if(void 0!==i){var s=ov(this.hoverObj.edges).length,a=ov(this.hoverObj.nodes).length;(n||i instanceof Az&&0===s&&0===a||i instanceof TN&&0===s&&0===a)&&(n=this.emitHoverEvent(t,e,i)),i instanceof TN&&!0===this.options.hoverConnectedEdges&&this._hoverConnectedEdges(i)}!0===n&&this.body.emitter.emit("_requestRedraw")}},{key:"commitWithoutEmitting",value:function(){this._selectionAccumulator.commit()}},{key:"commitAndEmit",value:function(t,e){var i=!1,n=this._selectionAccumulator.commit(),o={nodes:n.nodes.previous,edges:n.edges.previous};n.edges.deleted.length>0&&(this.generateClickEvent("deselectEdge",e,t,o),i=!0),n.nodes.deleted.length>0&&(this.generateClickEvent("deselectNode",e,t,o),i=!0),n.nodes.added.length>0&&(this.generateClickEvent("selectNode",e,t),i=!0),n.edges.added.length>0&&(this.generateClickEvent("selectEdge",e,t),i=!0),!0===i&&this.generateClickEvent("select",e,t)}},{key:"getSelection",value:function(){return{nodes:this.getSelectedNodeIds(),edges:this.getSelectedEdgeIds()}}},{key:"getSelectedNodes",value:function(){return this._selectionAccumulator.getNodes()}},{key:"getSelectedEdges",value:function(){return this._selectionAccumulator.getEdges()}},{key:"getSelectedNodeIds",value:function(){var t;return Qp(t=this._selectionAccumulator.getNodes()).call(t,(function(t){return t.id}))}},{key:"getSelectedEdgeIds",value:function(){var t;return Qp(t=this._selectionAccumulator.getEdges()).call(t,(function(t){return t.id}))}},{key:"setSelection",value:function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{};if(!t||!t.nodes&&!t.edges)throw new TypeError("Selection must be an object with nodes and/or edges properties");if((e.unselectAll||void 0===e.unselectAll)&&this.unselectAll(),t.nodes){var i,n=EA(t.nodes);try{for(n.s();!(i=n.n()).done;){var o=i.value,r=this.body.nodes[o];if(!r)throw new RangeError('Node with id "'+o+'" not found');this.selectObject(r,e.highlightEdges)}}catch(t){n.e(t)}finally{n.f()}}if(t.edges){var s,a=EA(t.edges);try{for(a.s();!(s=a.n()).done;){var h=s.value,l=this.body.edges[h];if(!l)throw new RangeError('Edge with id "'+h+'" not found');this.selectObject(l)}}catch(t){a.e(t)}finally{a.f()}}this.body.emitter.emit("_requestRedraw"),this._selectionAccumulator.commit()}},{key:"selectNodes",value:function(t){var e=!(arguments.length>1&&void 0!==arguments[1])||arguments[1];if(!t||void 0===t.length)throw"Selection must be an array with ids";this.setSelection({nodes:t},{highlightEdges:e})}},{key:"selectEdges",value:function(t){if(!t||void 0===t.length)throw"Selection must be an array with ids";this.setSelection({edges:t})}},{key:"updateSelection",value:function(){for(var t in this._selectionAccumulator.getNodes())Object.prototype.hasOwnProperty.call(this.body.nodes,t.id)||this._selectionAccumulator.deleteNodes(t);for(var e in this._selectionAccumulator.getEdges())Object.prototype.hasOwnProperty.call(this.body.edges,e.id)||this._selectionAccumulator.deleteEdges(e)}},{key:"getClickedItems",value:function(t){for(var e=this.canvas.DOMtoCanvas(t),i=[],n=this.body.nodeIndices,o=this.body.nodes,r=n.length-1;r>=0;r--){var s=o[n[r]].getItemsOnPoint(e);i.push.apply(i,s)}for(var a=this.body.edgeIndices,h=this.body.edges,l=a.length-1;l>=0;l--){var d=h[a[l]].getItemsOnPoint(e);i.push.apply(i,d)}return i}}]),t}(),SA={},TA={get exports(){return SA},set exports(t){SA=t}},MA={};!function(t){!function(t){function e(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")}t.__esModule=!0,t.sort=v;var i=32,n=7,o=256,r=[1,10,100,1e3,1e4,1e5,1e6,1e7,1e8,1e9];function s(t){return t<1e5?t<100?t<10?0:1:t<1e4?t<1e3?2:3:4:t<1e7?t<1e6?5:6:t<1e9?t<1e8?7:8:9}function a(t,e){if(t===e)return 0;if(~~t===t&&~~e===e){if(0===t||0===e)return t<e?-1:1;if(t<0||e<0){if(e>=0)return-1;if(t>=0)return 1;t=-t,e=-e}var i=s(t),n=s(e),o=0;return i<n?(t*=r[n-i-1],e/=10,o=-1):i>n&&(e*=r[i-n-1],t/=10,o=1),t===e?o:t<e?-1:1}var a=String(t),h=String(e);return a===h?0:a<h?-1:1}function h(t){for(var e=0;t>=i;)e|=1&t,t>>=1;return t+e}function l(t,e,i,n){var o=e+1;if(o===i)return 1;if(n(t[o++],t[e])<0){for(;o<i&&n(t[o],t[o-1])<0;)o++;d(t,e,o)}else for(;o<i&&n(t[o],t[o-1])>=0;)o++;return o-e}function d(t,e,i){for(i--;e<i;){var n=t[e];t[e++]=t[i],t[i--]=n}}function c(t,e,i,n,o){for(n===e&&n++;n<i;n++){for(var r=t[n],s=e,a=n;s<a;){var h=s+a>>>1;o(r,t[h])<0?a=h:s=h+1}var l=n-s;switch(l){case 3:t[s+3]=t[s+2];case 2:t[s+2]=t[s+1];case 1:t[s+1]=t[s];break;default:for(;l>0;)t[s+l]=t[s+l-1],l--}t[s]=r}}function u(t,e,i,n,o,r){var s=0,a=0,h=1;if(r(t,e[i+o])>0){for(a=n-o;h<a&&r(t,e[i+o+h])>0;)s=h,(h=1+(h<<1))<=0&&(h=a);h>a&&(h=a),s+=o,h+=o}else{for(a=o+1;h<a&&r(t,e[i+o-h])<=0;)s=h,(h=1+(h<<1))<=0&&(h=a);h>a&&(h=a);var l=s;s=o-h,h=o-l}for(s++;s<h;){var d=s+(h-s>>>1);r(t,e[i+d])>0?s=d+1:h=d}return h}function f(t,e,i,n,o,r){var s=0,a=0,h=1;if(r(t,e[i+o])<0){for(a=o+1;h<a&&r(t,e[i+o-h])<0;)s=h,(h=1+(h<<1))<=0&&(h=a);h>a&&(h=a);var l=s;s=o-h,h=o-l}else{for(a=n-o;h<a&&r(t,e[i+o+h])>=0;)s=h,(h=1+(h<<1))<=0&&(h=a);h>a&&(h=a),s+=o,h+=o}for(s++;s<h;){var d=s+(h-s>>>1);r(t,e[i+d])<0?h=d:s=d+1}return h}var p=function(){function t(i,r){e(this,t),this.array=null,this.compare=null,this.minGallop=n,this.length=0,this.tmpStorageLength=o,this.stackLength=0,this.runStart=null,this.runLength=null,this.stackSize=0,this.array=i,this.compare=r,this.length=i.length,this.length<2*o&&(this.tmpStorageLength=this.length>>>1),this.tmp=new Array(this.tmpStorageLength),this.stackLength=this.length<120?5:this.length<1542?10:this.length<119151?19:40,this.runStart=new Array(this.stackLength),this.runLength=new Array(this.stackLength)}return t.prototype.pushRun=function(t,e){this.runStart[this.stackSize]=t,this.runLength[this.stackSize]=e,this.stackSize+=1},t.prototype.mergeRuns=function(){for(;this.stackSize>1;){var t=this.stackSize-2;if(t>=1&&this.runLength[t-1]<=this.runLength[t]+this.runLength[t+1]||t>=2&&this.runLength[t-2]<=this.runLength[t]+this.runLength[t-1])this.runLength[t-1]<this.runLength[t+1]&&t--;else if(this.runLength[t]>this.runLength[t+1])break;this.mergeAt(t)}},t.prototype.forceMergeRuns=function(){for(;this.stackSize>1;){var t=this.stackSize-2;t>0&&this.runLength[t-1]<this.runLength[t+1]&&t--,this.mergeAt(t)}},t.prototype.mergeAt=function(t){var e=this.compare,i=this.array,n=this.runStart[t],o=this.runLength[t],r=this.runStart[t+1],s=this.runLength[t+1];this.runLength[t]=o+s,t===this.stackSize-3&&(this.runStart[t+1]=this.runStart[t+2],this.runLength[t+1]=this.runLength[t+2]),this.stackSize--;var a=f(i[r],i,n,o,0,e);n+=a,0!=(o-=a)&&0!==(s=u(i[n+o-1],i,r,s,s-1,e))&&(o<=s?this.mergeLow(n,o,r,s):this.mergeHigh(n,o,r,s))},t.prototype.mergeLow=function(t,e,i,o){var r=this.compare,s=this.array,a=this.tmp,h=0;for(h=0;h<e;h++)a[h]=s[t+h];var l=0,d=i,c=t;if(s[c++]=s[d++],0!=--o)if(1!==e){for(var p=this.minGallop;;){var v=0,g=0,y=!1;do{if(r(s[d],a[l])<0){if(s[c++]=s[d++],g++,v=0,0==--o){y=!0;break}}else if(s[c++]=a[l++],v++,g=0,1==--e){y=!0;break}}while((v|g)<p);if(y)break;do{if(0!==(v=f(s[d],a,l,e,0,r))){for(h=0;h<v;h++)s[c+h]=a[l+h];if(c+=v,l+=v,(e-=v)<=1){y=!0;break}}if(s[c++]=s[d++],0==--o){y=!0;break}if(0!==(g=u(a[l],s,d,o,0,r))){for(h=0;h<g;h++)s[c+h]=s[d+h];if(c+=g,d+=g,0==(o-=g)){y=!0;break}}if(s[c++]=a[l++],1==--e){y=!0;break}p--}while(v>=n||g>=n);if(y)break;p<0&&(p=0),p+=2}if(this.minGallop=p,p<1&&(this.minGallop=1),1===e){for(h=0;h<o;h++)s[c+h]=s[d+h];s[c+o]=a[l]}else{if(0===e)throw new Error("mergeLow preconditions were not respected");for(h=0;h<e;h++)s[c+h]=a[l+h]}}else{for(h=0;h<o;h++)s[c+h]=s[d+h];s[c+o]=a[l]}else for(h=0;h<e;h++)s[c+h]=a[l+h]},t.prototype.mergeHigh=function(t,e,i,o){var r=this.compare,s=this.array,a=this.tmp,h=0;for(h=0;h<o;h++)a[h]=s[i+h];var l=t+e-1,d=o-1,c=i+o-1,p=0,v=0;if(s[c--]=s[l--],0!=--e)if(1!==o){for(var g=this.minGallop;;){var y=0,m=0,b=!1;do{if(r(a[d],s[l])<0){if(s[c--]=s[l--],y++,m=0,0==--e){b=!0;break}}else if(s[c--]=a[d--],m++,y=0,1==--o){b=!0;break}}while((y|m)<g);if(b)break;do{if(0!=(y=e-f(a[d],s,t,e,e-1,r))){for(e-=y,v=1+(c-=y),p=1+(l-=y),h=y-1;h>=0;h--)s[v+h]=s[p+h];if(0===e){b=!0;break}}if(s[c--]=a[d--],1==--o){b=!0;break}if(0!=(m=o-u(s[l],a,0,o,o-1,r))){for(o-=m,v=1+(c-=m),p=1+(d-=m),h=0;h<m;h++)s[v+h]=a[p+h];if(o<=1){b=!0;break}}if(s[c--]=s[l--],0==--e){b=!0;break}g--}while(y>=n||m>=n);if(b)break;g<0&&(g=0),g+=2}if(this.minGallop=g,g<1&&(this.minGallop=1),1===o){for(v=1+(c-=e),p=1+(l-=e),h=e-1;h>=0;h--)s[v+h]=s[p+h];s[c]=a[d]}else{if(0===o)throw new Error("mergeHigh preconditions were not respected");for(p=c-(o-1),h=0;h<o;h++)s[p+h]=a[h]}}else{for(v=1+(c-=e),p=1+(l-=e),h=e-1;h>=0;h--)s[v+h]=s[p+h];s[c]=a[d]}else for(p=c-(o-1),h=0;h<o;h++)s[p+h]=a[h]},t}();function v(t,e,n,o){if(!Array.isArray(t))throw new TypeError("Can only sort arrays");e?"function"!=typeof e&&(o=n,n=e,e=a):e=a,n||(n=0),o||(o=t.length);var r=o-n;if(!(r<2)){var s=0;if(r<i)c(t,n,o,n+(s=l(t,n,o,e)),e);else{var d=new p(t,e),u=h(r);do{if((s=l(t,n,o,e))<u){var f=r;f>u&&(f=u),c(t,n,n+f,n+s,e),s=f}d.pushRun(n,s),d.mergeRuns(),r-=s,n+=s}while(0!==r);d.forceMergeRuns()}}}}(t)}(MA),function(t){t.exports=MA}(TA);var PA=i(SA);function DA(t){var e=function(){if("undefined"==typeof Reflect||!jI)return!1;if(jI.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(jI(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=AO(t);if(e){var o=AO(this).constructor;i=jI(n,arguments,o)}else i=n.apply(this,arguments);return DO(this,i)}}var IA=function(){function t(){pu(this,t)}return Nf(t,[{key:"abstract",value:function(){throw new Error("Can't instantiate abstract class!")}},{key:"fake_use",value:function(){}},{key:"curveType",value:function(){return this.abstract()}},{key:"getPosition",value:function(t){return this.fake_use(t),this.abstract()}},{key:"setPosition",value:function(t,e){var i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:void 0;this.fake_use(t,e,i),this.abstract()}},{key:"getTreeSize",value:function(t){return this.fake_use(t),this.abstract()}},{key:"sort",value:function(t){this.fake_use(t),this.abstract()}},{key:"fix",value:function(t,e){this.fake_use(t,e),this.abstract()}},{key:"shift",value:function(t,e){this.fake_use(t,e),this.abstract()}}]),t}(),BA=function(t){PO(i,t);var e=DA(i);function i(t){var n;return pu(this,i),(n=e.call(this)).layout=t,n}return Nf(i,[{key:"curveType",value:function(){return"horizontal"}},{key:"getPosition",value:function(t){return t.x}},{key:"setPosition",value:function(t,e){var i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:void 0;void 0!==i&&this.layout.hierarchical.addToOrdering(t,i),t.x=e}},{key:"getTreeSize",value:function(t){var e=this.layout.hierarchical.getTreeSize(this.layout.body.nodes,t);return{min:e.min_x,max:e.max_x}}},{key:"sort",value:function(t){SA.sort(t,(function(t,e){return t.x-e.x}))}},{key:"fix",value:function(t,e){t.y=this.layout.options.hierarchical.levelSeparation*e,t.options.fixed.y=!0}},{key:"shift",value:function(t,e){this.layout.body.nodes[t].x+=e}}]),i}(IA),NA=function(t){PO(i,t);var e=DA(i);function i(t){var n;return pu(this,i),(n=e.call(this)).layout=t,n}return Nf(i,[{key:"curveType",value:function(){return"vertical"}},{key:"getPosition",value:function(t){return t.y}},{key:"setPosition",value:function(t,e){var i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:void 0;void 0!==i&&this.layout.hierarchical.addToOrdering(t,i),t.y=e}},{key:"getTreeSize",value:function(t){var e=this.layout.hierarchical.getTreeSize(this.layout.body.nodes,t);return{min:e.min_y,max:e.max_y}}},{key:"sort",value:function(t){SA.sort(t,(function(t,e){return t.y-e.y}))}},{key:"fix",value:function(t,e){t.x=this.layout.options.hierarchical.levelSeparation*e,t.options.fixed.x=!0}},{key:"shift",value:function(t,e){this.layout.body.nodes[t].y+=e}}]),i}(IA),zA={},FA={get exports(){return zA},set exports(t){zA=t}},AA=vl.every;Mi({target:"Array",proto:!0,forced:!vv("every")},{every:function(t){return AA(this,t,arguments.length>1?arguments[1]:void 0)}});var jA=Rn("Array").every,RA=lt,LA=jA,HA=Array.prototype,WA=function(t){var e=t.every;return t===HA||RA(HA,t)&&e===HA.every?LA:e},qA=WA;!function(t){t.exports=qA}(FA);var VA=i(zA);function UA(t,e){var i=void 0!==Op&&xh(t)||t["@@iterator"];if(!i){if(Wp(t)||(i=function(t,e){var i;if(!t)return;if("string"==typeof t)return YA(t,e);var n=Fp(i=Object.prototype.toString.call(t)).call(i,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return Za(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return YA(t,e)}(t))||e&&t&&"number"==typeof t.length){i&&(t=i);var n=0,o=function(){};return{s:o,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var r,s=!0,a=!1;return{s:function(){i=i.call(t)},n:function(){var t=i.next();return s=t.done,t},e:function(t){a=!0,r=t},f:function(){try{s||null==i.return||i.return()}finally{if(a)throw r}}}}function YA(t,e){(null==e||e>t.length)&&(e=t.length);for(var i=0,n=new Array(e);i<e;i++)n[i]=t[i];return n}function XA(t,e){var i=new XP;return Cv(t).call(t,(function(t){var e;Cv(e=t.edges).call(e,(function(t){t.connected&&i.add(t)}))})),Cv(i).call(i,(function(t){var i=t.from.id,n=t.to.id;null==e[i]&&(e[i]=0),(null==e[n]||e[i]>=e[n])&&(e[n]=e[i]+1)})),e}function GA(t,e,i,n){var o,r,s=mm(null),a=EP(o=_p(lI(n).call(n))).call(o,(function(t,e){return t+1+e.edges.length}),0),h=i+"Id",l="to"===i?1:-1,d=UA(n);try{var c=function(){var o=kp(r.value,2),d=o[0],c=o[1];if(!n.has(d)||!t(c))return"continue";s[d]=0;for(var u,f=[c],p=0,v=function(){var t,o;if(!n.has(d))return"continue";var r=s[u.id]+l;if(Cv(t=ny(o=u.edges).call(o,(function(t){return t.connected&&t.to!==t.from&&t[i]!==u&&n.has(t.toId)&&n.has(t.fromId)}))).call(t,(function(t){var n=t[h],o=s[n];(null==o||e(r,o))&&(s[n]=r,f.push(t[i]))})),p>a)return{v:{v:XA(n,s)}};++p};u=f.pop();){var g=v();if("continue"!==g&&"object"===Of(g))return g.v}};for(d.s();!(r=d.n()).done;){var u=c();if("continue"!==u&&"object"===Of(u))return u.v}}catch(t){d.e(t)}finally{d.f()}return s}var KA=function(){function t(){pu(this,t),this.childrenReference={},this.parentReference={},this.trees={},this.distributionOrdering={},this.levels={},this.distributionIndex={},this.isTree=!1,this.treeIndex=-1}return Nf(t,[{key:"addRelation",value:function(t,e){void 0===this.childrenReference[t]&&(this.childrenReference[t]=[]),this.childrenReference[t].push(e),void 0===this.parentReference[e]&&(this.parentReference[e]=[]),this.parentReference[e].push(t)}},{key:"checkIfTree",value:function(){for(var t in this.parentReference)if(this.parentReference[t].length>1)return void(this.isTree=!1);this.isTree=!0}},{key:"numTrees",value:function(){return this.treeIndex+1}},{key:"setTreeIndex",value:function(t,e){void 0!==e&&void 0===this.trees[t.id]&&(this.trees[t.id]=e,this.treeIndex=Math.max(e,this.treeIndex))}},{key:"ensureLevel",value:function(t){void 0===this.levels[t]&&(this.levels[t]=0)}},{key:"getMaxLevel",value:function(t){var e=this,i={};return function t(n){if(void 0!==i[n])return i[n];var o=e.levels[n];if(e.childrenReference[n]){var r=e.childrenReference[n];if(r.length>0)for(var s=0;s<r.length;s++)o=Math.max(o,t(r[s]))}return i[n]=o,o}(t)}},{key:"levelDownstream",value:function(t,e){void 0===this.levels[e.id]&&(void 0===this.levels[t.id]&&(this.levels[t.id]=0),this.levels[e.id]=this.levels[t.id]+1)}},{key:"setMinLevelToZero",value:function(t){var e=1e9;for(var i in t)Object.prototype.hasOwnProperty.call(t,i)&&void 0!==this.levels[i]&&(e=Math.min(this.levels[i],e));for(var n in t)Object.prototype.hasOwnProperty.call(t,n)&&void 0!==this.levels[n]&&(this.levels[n]-=e)}},{key:"getTreeSize",value:function(t,e){var i=1e9,n=-1e9,o=1e9,r=-1e9;for(var s in this.trees)if(Object.prototype.hasOwnProperty.call(this.trees,s)&&this.trees[s]===e){var a=t[s];i=Math.min(a.x,i),n=Math.max(a.x,n),o=Math.min(a.y,o),r=Math.max(a.y,r)}return{min_x:i,max_x:n,min_y:o,max_y:r}}},{key:"hasSameParent",value:function(t,e){var i=this.parentReference[t.id],n=this.parentReference[e.id];if(void 0===i||void 0===n)return!1;for(var o=0;o<i.length;o++)for(var r=0;r<n.length;r++)if(i[o]==n[r])return!0;return!1}},{key:"inSameSubNetwork",value:function(t,e){return this.trees[t.id]===this.trees[e.id]}},{key:"getLevels",value:function(){return ov(this.distributionOrdering)}},{key:"addToOrdering",value:function(t,e){void 0===this.distributionOrdering[e]&&(this.distributionOrdering[e]=[]);var i=!1,n=this.distributionOrdering[e];for(var o in n)if(n[o]===t){i=!0;break}i||(this.distributionOrdering[e].push(t),this.distributionIndex[t.id]=this.distributionOrdering[e].length-1)}}]),t}(),$A=function(){function t(e){pu(this,t),this.body=e,this._resetRNG(Math.random()+":"+cv()),this.setPhysics=!1,this.options={},this.optionsBackup={physics:{}},this.defaultOptions={randomSeed:void 0,improvedLayout:!0,clusterThreshold:150,hierarchical:{enabled:!1,levelSeparation:150,nodeSpacing:100,treeSpacing:200,blockShifting:!0,edgeMinimization:!0,parentCentralization:!0,direction:"UD",sortMethod:"hubsize"}},xn(this.options,this.defaultOptions),this.bindEventListeners()}return Nf(t,[{key:"bindEventListeners",value:function(){var t=this;this.body.emitter.on("_dataChanged",(function(){t.setupHierarchicalLayout()})),this.body.emitter.on("_dataLoaded",(function(){t.layoutNetwork()})),this.body.emitter.on("_resetHierarchicalLayout",(function(){t.setupHierarchicalLayout()})),this.body.emitter.on("_adjustEdgesForHierarchicalLayout",(function(){if(!0===t.options.hierarchical.enabled){var e=t.direction.curveType();t.body.emitter.emit("_forceDisableDynamicCurves",e,!1)}}))}},{key:"setOptions",value:function(t,e){if(void 0!==t){var i=this.options.hierarchical,n=i.enabled;if(qx(["randomSeed","improvedLayout","clusterThreshold"],this.options,t),pk(this.options,t,"hierarchical"),void 0!==t.randomSeed&&this._resetRNG(t.randomSeed),!0===i.enabled)return!0===n&&this.body.emitter.emit("refresh",!0),"RL"===i.direction||"DU"===i.direction?i.levelSeparation>0&&(i.levelSeparation*=-1):i.levelSeparation<0&&(i.levelSeparation*=-1),this.setDirectionStrategy(),this.body.emitter.emit("_resetHierarchicalLayout"),this.adaptAllOptionsForHierarchicalLayout(e);if(!0===n)return this.body.emitter.emit("refresh"),Ux(e,this.optionsBackup)}return e}},{key:"_resetRNG",value:function(t){this.initialRandomSeed=t,this._rng=Tx(this.initialRandomSeed)}},{key:"adaptAllOptionsForHierarchicalLayout",value:function(t){if(!0===this.options.hierarchical.enabled){var e=this.optionsBackup.physics;void 0===t.physics||!0===t.physics?(t.physics={enabled:void 0===e.enabled||e.enabled,solver:"hierarchicalRepulsion"},e.enabled=void 0===e.enabled||e.enabled,e.solver=e.solver||"barnesHut"):"object"===Of(t.physics)?(e.enabled=void 0===t.physics.enabled||t.physics.enabled,e.solver=t.physics.solver||"barnesHut",t.physics.solver="hierarchicalRepulsion"):!1!==t.physics&&(e.solver="barnesHut",t.physics={solver:"hierarchicalRepulsion"});var i=this.direction.curveType();if(void 0===t.edges)this.optionsBackup.edges={smooth:{enabled:!0,type:"dynamic"}},t.edges={smooth:!1};else if(void 0===t.edges.smooth)this.optionsBackup.edges={smooth:{enabled:!0,type:"dynamic"}},t.edges.smooth=!1;else if("boolean"==typeof t.edges.smooth)this.optionsBackup.edges={smooth:t.edges.smooth},t.edges.smooth={enabled:t.edges.smooth,type:i};else{var n=t.edges.smooth;void 0!==n.type&&"dynamic"!==n.type&&(i=n.type),this.optionsBackup.edges={smooth:{enabled:void 0===n.enabled||n.enabled,type:void 0===n.type?"dynamic":n.type,roundness:void 0===n.roundness?.5:n.roundness,forceDirection:void 0!==n.forceDirection&&n.forceDirection}},t.edges.smooth={enabled:void 0===n.enabled||n.enabled,type:i,roundness:void 0===n.roundness?.5:n.roundness,forceDirection:void 0!==n.forceDirection&&n.forceDirection}}this.body.emitter.emit("_forceDisableDynamicCurves",i)}return t}},{key:"positionInitially",value:function(t){if(!0!==this.options.hierarchical.enabled){this._resetRNG(this.initialRandomSeed);for(var e=t.length+50,i=0;i<t.length;i++){var n=t[i],o=2*Math.PI*this._rng();void 0===n.x&&(n.x=e*Math.cos(o)),void 0===n.y&&(n.y=e*Math.sin(o))}}}},{key:"layoutNetwork",value:function(){if(!0!==this.options.hierarchical.enabled&&!0===this.options.improvedLayout){for(var t=this.body.nodeIndices,e=0,i=0;i<t.length;i++){!0===this.body.nodes[t[i]].predefinedPosition&&(e+=1)}if(e<.5*t.length){var n=0,o=this.options.clusterThreshold,r={clusterNodeProperties:{shape:"ellipse",label:"",group:"",font:{multi:!1}},clusterEdgeProperties:{label:"",font:{multi:!1},smooth:{enabled:!1}}};if(t.length>o){for(var s=t.length;t.length>o&&n<=10;){n+=1;var a=t.length;if(n%3==0?this.body.modules.clustering.clusterBridges(r):this.body.modules.clustering.clusterOutliers(r),a==t.length&&n%3!=0)return this._declusterAll(),this.body.emitter.emit("_layoutFailed"),void console.info("This network could not be positioned by this version of the improved layout algorithm. Please disable improvedLayout for better performance.")}this.body.modules.kamadaKawai.setOptions({springLength:Math.max(150,2*s)})}n>10&&console.info("The clustering didn't succeed within the amount of interations allowed, progressing with partial result."),this.body.modules.kamadaKawai.solve(t,this.body.edgeIndices,!0),this._shiftToCenter();for(var h=0;h<t.length;h++){var l=this.body.nodes[t[h]];!1===l.predefinedPosition&&(l.x+=70*(.5-this._rng()),l.y+=70*(.5-this._rng()))}this._declusterAll(),this.body.emitter.emit("_repositionBezierNodes")}}}},{key:"_shiftToCenter",value:function(){for(var t=$z.getRangeCore(this.body.nodes,this.body.nodeIndices),e=$z.findCenter(t),i=0;i<this.body.nodeIndices.length;i++){var n=this.body.nodes[this.body.nodeIndices[i]];n.x-=e.x,n.y-=e.y}}},{key:"_declusterAll",value:function(){for(var t=!0;!0===t;){t=!1;for(var e=0;e<this.body.nodeIndices.length;e++)!0===this.body.nodes[this.body.nodeIndices[e]].isCluster&&(t=!0,this.body.modules.clustering.openCluster(this.body.nodeIndices[e],{},!1));!0===t&&this.body.emitter.emit("_dataChanged")}}},{key:"getSeed",value:function(){return this.initialRandomSeed}},{key:"setupHierarchicalLayout",value:function(){if(!0===this.options.hierarchical.enabled&&this.body.nodeIndices.length>0){var t,e,i=!1,n=!1;for(e in this.lastNodeOnLevel={},this.hierarchical=new KA,this.body.nodes)Object.prototype.hasOwnProperty.call(this.body.nodes,e)&&(void 0!==(t=this.body.nodes[e]).options.level?(i=!0,this.hierarchical.levels[e]=t.options.level):n=!0);if(!0===n&&!0===i)throw new Error("To use the hierarchical layout, nodes require either no predefined levels or levels have to be defined for all nodes.");if(!0===n){var o=this.options.hierarchical.sortMethod;"hubsize"===o?this._determineLevelsByHubsize():"directed"===o?this._determineLevelsDirected():"custom"===o&&this._determineLevelsCustomCallback()}for(var r in this.body.nodes)Object.prototype.hasOwnProperty.call(this.body.nodes,r)&&this.hierarchical.ensureLevel(r);var s=this._getDistribution();this._generateMap(),this._placeNodesByHierarchy(s),this._condenseHierarchy(),this._shiftToCenter()}}},{key:"_condenseHierarchy",value:function(){var t=this,e=!1,i={},n=function(e,i){var n=t.hierarchical.trees;for(var o in n)Object.prototype.hasOwnProperty.call(n,o)&&n[o]===e&&t.direction.shift(o,i)},o=function(){for(var e=[],i=0;i<t.hierarchical.numTrees();i++)e.push(t.direction.getTreeSize(i));return e},r=function e(i,n){if(!n[i.id]&&(n[i.id]=!0,t.hierarchical.childrenReference[i.id])){var o=t.hierarchical.childrenReference[i.id];if(o.length>0)for(var r=0;r<o.length;r++)e(t.body.nodes[o[r]],n)}},s=function(e){var i=arguments.length>1&&void 0!==arguments[1]?arguments[1]:1e9,n=1e9,o=1e9,r=1e9,s=-1e9;for(var a in e)if(Object.prototype.hasOwnProperty.call(e,a)){var h=t.body.nodes[a],l=t.hierarchical.levels[h.id],d=t.direction.getPosition(h),c=kp(t._getSpaceAroundNode(h,e),2),u=c[0],f=c[1];n=Math.min(u,n),o=Math.min(f,o),l<=i&&(r=Math.min(d,r),s=Math.max(d,s))}return[r,s,n,o]},a=function(e,i){var n=t.hierarchical.getMaxLevel(e.id),o=t.hierarchical.getMaxLevel(i.id);return Math.min(n,o)},h=function(e,i,n){for(var o=t.hierarchical,r=0;r<i.length;r++){var s=i[r],a=o.distributionOrdering[s];if(a.length>1)for(var h=0;h<a.length-1;h++){var l=a[h],d=a[h+1];o.hasSameParent(l,d)&&o.inSameSubNetwork(l,d)&&e(l,d,n)}}},l=function(i,n){var o=arguments.length>2&&void 0!==arguments[2]&&arguments[2],h=t.direction.getPosition(i),l=t.direction.getPosition(n),d=Math.abs(l-h),c=t.options.hierarchical.nodeSpacing;if(d>c){var u={},f={};r(i,u),r(n,f);var p=a(i,n),v=s(u,p),g=s(f,p),y=v[1],m=g[0],b=g[2];if(Math.abs(y-m)>c){var w=y-m+c;w<-b+c&&(w=-b+c),w<0&&(t._shiftBlock(n.id,w),e=!0,!0===o&&t._centerParent(n))}}},d=function(n,o){for(var a=o.id,h=o.edges,l=t.hierarchical.levels[o.id],d=t.options.hierarchical.levelSeparation*t.options.hierarchical.levelSeparation,c={},u=[],f=0;f<h.length;f++){var p=h[f];if(p.toId!=p.fromId){var v=p.toId==a?p.from:p.to;c[h[f].id]=v,t.hierarchical.levels[v.id]<l&&u.push(p)}}var g=function(e,i){for(var n=0,o=0;o<i.length;o++)if(void 0!==c[i[o].id]){var r=t.direction.getPosition(c[i[o].id])-e;n+=r/Math.sqrt(r*r+d)}return n},y=function(e,i){for(var n=0,o=0;o<i.length;o++)if(void 0!==c[i[o].id]){var r=t.direction.getPosition(c[i[o].id])-e;n-=d*Math.pow(r*r+d,-1.5)}return n},m=function(e,i){for(var n=t.direction.getPosition(o),r={},s=0;s<e;s++){var a=g(n,i),h=y(n,i);if(void 0!==r[n-=Math.max(-40,Math.min(40,Math.round(a/h)))])break;r[n]=s}return n},b=m(n,u);!function(n){var a=t.direction.getPosition(o);if(void 0===i[o.id]){var h={};r(o,h),i[o.id]=h}var l=s(i[o.id]),d=l[2],c=l[3],u=n-a,f=0;u>0?f=Math.min(u,c-t.options.hierarchical.nodeSpacing):u<0&&(f=-Math.min(-u,d-t.options.hierarchical.nodeSpacing)),0!=f&&(t._shiftBlock(o.id,f),e=!0)}(b),function(i){var n=t.direction.getPosition(o),r=kp(t._getSpaceAroundNode(o),2),s=r[0],a=r[1],h=i-n,l=n;h>0?l=Math.min(n+(a-t.options.hierarchical.nodeSpacing),i):h<0&&(l=Math.max(n-(s-t.options.hierarchical.nodeSpacing),i)),l!==n&&(t.direction.setPosition(o,l),e=!0)}(b=m(n,h))};!0===this.options.hierarchical.blockShifting&&(function(i){var n=t.hierarchical.getLevels();n=Rv(n).call(n);for(var o=0;o<i&&(e=!1,h(l,n,!0),!0===e);o++);}(5),function(){for(var e in t.body.nodes)Object.prototype.hasOwnProperty.call(t.body.nodes,e)&&t._centerParent(t.body.nodes[e])}()),!0===this.options.hierarchical.edgeMinimization&&function(i){var n=t.hierarchical.getLevels();n=Rv(n).call(n);for(var o=0;o<i;o++){e=!1;for(var r=0;r<n.length;r++)for(var s=n[r],a=t.hierarchical.distributionOrdering[s],h=0;h<a.length;h++)d(1e3,a[h]);if(!0!==e)break}}(20),!0===this.options.hierarchical.parentCentralization&&function(){var e=t.hierarchical.getLevels();e=Rv(e).call(e);for(var i=0;i<e.length;i++)for(var n=e[i],o=t.hierarchical.distributionOrdering[n],r=0;r<o.length;r++)t._centerParent(o[r])}(),function(){for(var e=o(),i=0,r=0;r<e.length-1;r++){i+=e[r].max-e[r+1].min+t.options.hierarchical.treeSpacing,n(r+1,i)}}()}},{key:"_getSpaceAroundNode",value:function(t,e){var i=!0;void 0===e&&(i=!1);var n=this.hierarchical.levels[t.id];if(void 0!==n){var o=this.hierarchical.distributionIndex[t.id],r=this.direction.getPosition(t),s=this.hierarchical.distributionOrdering[n],a=1e9,h=1e9;if(0!==o){var l=s[o-1];if(!0===i&&void 0===e[l.id]||!1===i)a=r-this.direction.getPosition(l)}if(o!=s.length-1){var d=s[o+1];if(!0===i&&void 0===e[d.id]||!1===i){var c=this.direction.getPosition(d);h=Math.min(h,c-r)}}return[a,h]}return[0,0]}},{key:"_centerParent",value:function(t){if(this.hierarchical.parentReference[t.id])for(var e=this.hierarchical.parentReference[t.id],i=0;i<e.length;i++){var n=e[i],o=this.body.nodes[n],r=this.hierarchical.childrenReference[n];if(void 0!==r){var s=this._getCenterPosition(r),a=this.direction.getPosition(o),h=kp(this._getSpaceAroundNode(o),2),l=h[0],d=h[1],c=a-s;(c<0&&Math.abs(c)<d-this.options.hierarchical.nodeSpacing||c>0&&Math.abs(c)<l-this.options.hierarchical.nodeSpacing)&&this.direction.setPosition(o,s)}}}},{key:"_placeNodesByHierarchy",value:function(t){for(var e in this.positionedNodes={},t)if(Object.prototype.hasOwnProperty.call(t,e)){var i,n=ov(t[e]);n=this._indexArrayToNodes(n),HD(i=this.direction).call(i,n);for(var o=0,r=0;r<n.length;r++){var s=n[r];if(void 0===this.positionedNodes[s.id]){var a=this.options.hierarchical.nodeSpacing,h=a*o;o>0&&(h=this.direction.getPosition(n[r-1])+a),this.direction.setPosition(s,h,e),this._validatePositionAndContinue(s,e,h),o++}}}}},{key:"_placeBranchNodes",value:function(t,e){var i,n=this.hierarchical.childrenReference[t];if(void 0!==n){for(var o=[],r=0;r<n.length;r++)o.push(this.body.nodes[n[r]]);HD(i=this.direction).call(i,o);for(var s=0;s<o.length;s++){var a=o[s],h=this.hierarchical.levels[a.id];if(!(h>e&&void 0===this.positionedNodes[a.id]))return;var l=this.options.hierarchical.nodeSpacing,d=void 0;d=0===s?this.direction.getPosition(this.body.nodes[t]):this.direction.getPosition(o[s-1])+l,this.direction.setPosition(a,d,h),this._validatePositionAndContinue(a,h,d)}var c=this._getCenterPosition(o);this.direction.setPosition(this.body.nodes[t],c,e)}}},{key:"_validatePositionAndContinue",value:function(t,e,i){if(this.hierarchical.isTree){if(void 0!==this.lastNodeOnLevel[e]){var n=this.direction.getPosition(this.body.nodes[this.lastNodeOnLevel[e]]);if(i-n<this.options.hierarchical.nodeSpacing){var o=n+this.options.hierarchical.nodeSpacing-i,r=this._findCommonParent(this.lastNodeOnLevel[e],t.id);this._shiftBlock(r.withChild,o)}}this.lastNodeOnLevel[e]=t.id,this.positionedNodes[t.id]=!0,this._placeBranchNodes(t.id,e)}}},{key:"_indexArrayToNodes",value:function(t){for(var e=[],i=0;i<t.length;i++)e.push(this.body.nodes[t[i]]);return e}},{key:"_getDistribution",value:function(){var t,e,i={};for(t in this.body.nodes)if(Object.prototype.hasOwnProperty.call(this.body.nodes,t)){e=this.body.nodes[t];var n=void 0===this.hierarchical.levels[t]?0:this.hierarchical.levels[t];this.direction.fix(e,n),void 0===i[n]&&(i[n]={}),i[n][t]=e}return i}},{key:"_getActiveEdges",value:function(t){var e=this,i=[];return $x(t.edges,(function(t){var n;-1!==tm(n=e.body.edgeIndices).call(n,t.id)&&i.push(t)})),i}},{key:"_getHubSizes",value:function(){var t=this,e={};$x(this.body.nodeIndices,(function(i){var n=t.body.nodes[i],o=t._getActiveEdges(n).length;e[o]=!0}));var i=[];return $x(e,(function(t){i.push(Number(t))})),HD(PA).call(PA,i,(function(t,e){return e-t})),i}},{key:"_determineLevelsByHubsize",value:function(){for(var t=this,e=function(e,i){t.hierarchical.levelDownstream(e,i)},i=this._getHubSizes(),n=function(){var n=i[o];if(0===n)return"break";$x(t.body.nodeIndices,(function(i){var o=t.body.nodes[i];n===t._getActiveEdges(o).length&&t._crawlNetwork(e,i)}))},o=0;o<i.length;++o){if("break"===n())break}}},{key:"_determineLevelsCustomCallback",value:function(){var t=this;this._crawlNetwork((function(e,i,n){var o=t.hierarchical.levels[e.id];void 0===o&&(o=t.hierarchical.levels[e.id]=1e5);var r=($z.cloneOptions(e,"node"),$z.cloneOptions(i,"node"),void $z.cloneOptions(n,"edge"));t.hierarchical.levels[i.id]=o+r})),this.hierarchical.setMinLevelToZero(this.body.nodes)}},{key:"_determineLevelsDirected",value:function(){var t,e=this,i=EP(t=this.body.nodeIndices).call(t,(function(t,i){return t.set(i,e.body.nodes[i]),t}),new VE);"roots"===this.options.hierarchical.shakeTowards?this.hierarchical.levels=function(t){return GA((function(e){var i,n;return VA(i=ny(n=e.edges).call(n,(function(e){return t.has(e.toId)}))).call(i,(function(t){return t.from===e}))}),(function(t,e){return e<t}),"to",t)}(i):this.hierarchical.levels=function(t){return GA((function(e){var i,n;return VA(i=ny(n=e.edges).call(n,(function(e){return t.has(e.toId)}))).call(i,(function(t){return t.to===e}))}),(function(t,e){return e>t}),"from",t)}(i),this.hierarchical.setMinLevelToZero(this.body.nodes)}},{key:"_generateMap",value:function(){var t=this;this._crawlNetwork((function(e,i){t.hierarchical.levels[i.id]>t.hierarchical.levels[e.id]&&t.hierarchical.addRelation(e.id,i.id)})),this.hierarchical.checkIfTree()}},{key:"_crawlNetwork",value:function(){var t=this,e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:function(){},i=arguments.length>1?arguments[1]:void 0,n={},o=function i(o,r){if(void 0===n[o.id]){var s;t.hierarchical.setTreeIndex(o,r),n[o.id]=!0;for(var a=t._getActiveEdges(o),h=0;h<a.length;h++){var l=a[h];!0===l.connected&&(s=l.toId==o.id?l.from:l.to,o.id!=s.id&&(e(o,s,l),i(s,r)))}}};if(void 0===i)for(var r=0,s=0;s<this.body.nodeIndices.length;s++){var a=this.body.nodeIndices[s];if(void 0===n[a])o(this.body.nodes[a],r),r+=1}else{var h=this.body.nodes[i];if(void 0===h)return void console.error("Node not found:",i);o(h)}}},{key:"_shiftBlock",value:function(t,e){var i=this,n={};!function t(o){if(!n[o]){n[o]=!0,i.direction.shift(o,e);var r=i.hierarchical.childrenReference[o];if(void 0!==r)for(var s=0;s<r.length;s++)t(r[s])}}(t)}},{key:"_findCommonParent",value:function(t,e){var i=this,n={};return function t(e,n){var o=i.hierarchical.parentReference[n];if(void 0!==o)for(var r=0;r<o.length;r++){var s=o[r];e[s]=!0,t(e,s)}}(n,t),function t(e,n){var o=i.hierarchical.parentReference[n];if(void 0!==o)for(var r=0;r<o.length;r++){var s=o[r];if(void 0!==e[s])return{foundParent:s,withChild:n};var a=t(e,s);if(null!==a.foundParent)return a}return{foundParent:null,withChild:n}}(n,e)}},{key:"setDirectionStrategy",value:function(){var t="UD"===this.options.hierarchical.direction||"DU"===this.options.hierarchical.direction;this.direction=t?new BA(this):new NA(this)}},{key:"_getCenterPosition",value:function(t){for(var e=1e9,i=-1e9,n=0;n<t.length;n++){var o=void 0;if(void 0!==t[n].id)o=t[n];else{var r=t[n];o=this.body.nodes[r]}var s=this.direction.getPosition(o);e=Math.min(e,s),i=Math.max(i,s)}return.5*(e+i)}}]),t}();function ZA(t,e){var i=void 0!==Op&&xh(t)||t["@@iterator"];if(!i){if(Wp(t)||(i=function(t,e){var i;if(!t)return;if("string"==typeof t)return QA(t,e);var n=Fp(i=Object.prototype.toString.call(t)).call(i,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return Za(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return QA(t,e)}(t))||e&&t&&"number"==typeof t.length){i&&(t=i);var n=0,o=function(){};return{s:o,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var r,s=!0,a=!1;return{s:function(){i=i.call(t)},n:function(){var t=i.next();return s=t.done,t},e:function(t){a=!0,r=t},f:function(){try{s||null==i.return||i.return()}finally{if(a)throw r}}}}function QA(t,e){(null==e||e>t.length)&&(e=t.length);for(var i=0,n=new Array(e);i<e;i++)n[i]=t[i];return n}var JA=function(){function t(e,i,n,o){var r,s,a=this;pu(this,t),this.body=e,this.canvas=i,this.selectionHandler=n,this.interactionHandler=o,this.editMode=!1,this.manipulationDiv=void 0,this.editModeDiv=void 0,this.closeDiv=void 0,this._domEventListenerCleanupQueue=[],this.temporaryUIFunctions={},this.temporaryEventFunctions=[],this.touchTime=0,this.temporaryIds={nodes:[],edges:[]},this.guiEnabled=!1,this.inMode=!1,this.selectedControlNode=void 0,this.options={},this.defaultOptions={enabled:!1,initiallyActive:!1,addNode:!0,addEdge:!0,editNode:void 0,editEdge:!0,deleteNode:!0,deleteEdge:!0,controlNodeStyle:{shape:"dot",size:6,color:{background:"#ff0000",border:"#3c3c3c",highlight:{background:"#07f968",border:"#3c3c3c"}},borderWidth:2,borderWidthSelected:2}},xn(this.options,this.defaultOptions),this.body.emitter.on("destroy",(function(){a._clean()})),this.body.emitter.on("_dataChanged",Yn(r=this._restore).call(r,this)),this.body.emitter.on("_resetData",Yn(s=this._restore).call(s,this))}return Nf(t,[{key:"_restore",value:function(){!1!==this.inMode&&(!0===this.options.initiallyActive?this.enableEditMode():this.disableEditMode())}},{key:"setOptions",value:function(t,e,i){void 0!==e&&(void 0!==e.locale?this.options.locale=e.locale:this.options.locale=i.locale,void 0!==e.locales?this.options.locales=e.locales:this.options.locales=i.locales),void 0!==t&&("boolean"==typeof t?this.options.enabled=t:(this.options.enabled=!0,Ux(this.options,t)),!0===this.options.initiallyActive&&(this.editMode=!0),this._setup())}},{key:"toggleEditMode",value:function(){!0===this.editMode?this.disableEditMode():this.enableEditMode()}},{key:"enableEditMode",value:function(){this.editMode=!0,this._clean(),!0===this.guiEnabled&&(this.manipulationDiv.style.display="block",this.closeDiv.style.display="block",this.editModeDiv.style.display="none",this.showManipulatorToolbar())}},{key:"disableEditMode",value:function(){this.editMode=!1,this._clean(),!0===this.guiEnabled&&(this.manipulationDiv.style.display="none",this.closeDiv.style.display="none",this.editModeDiv.style.display="block",this._createEditButton())}},{key:"showManipulatorToolbar",value:function(){if(this._clean(),this.manipulationDOM={},!0===this.guiEnabled){var t,e;this.editMode=!0,this.manipulationDiv.style.display="block",this.closeDiv.style.display="block";var i=this.selectionHandler.getSelectedNodeCount(),n=this.selectionHandler.getSelectedEdgeCount(),o=i+n,r=this.options.locales[this.options.locale],s=!1;!1!==this.options.addNode&&(this._createAddNodeButton(r),s=!0),!1!==this.options.addEdge&&(!0===s?this._createSeperator(1):s=!0,this._createAddEdgeButton(r)),1===i&&"function"==typeof this.options.editNode?(!0===s?this._createSeperator(2):s=!0,this._createEditNodeButton(r)):1===n&&0===i&&!1!==this.options.editEdge&&(!0===s?this._createSeperator(3):s=!0,this._createEditEdgeButton(r)),0!==o&&(i>0&&!1!==this.options.deleteNode||0===i&&!1!==this.options.deleteEdge)&&(!0===s&&this._createSeperator(4),this._createDeleteButton(r)),this._bindElementEvents(this.closeDiv,Yn(t=this.toggleEditMode).call(t,this)),this._temporaryBindEvent("select",Yn(e=this.showManipulatorToolbar).call(e,this))}this.body.emitter.emit("_redraw")}},{key:"addNodeMode",value:function(){var t;if(!0!==this.editMode&&this.enableEditMode(),this._clean(),this.inMode="addNode",!0===this.guiEnabled){var e,i=this.options.locales[this.options.locale];this.manipulationDOM={},this._createBackButton(i),this._createSeperator(),this._createDescription(i.addDescription||this.options.locales.en.addDescription),this._bindElementEvents(this.closeDiv,Yn(e=this.toggleEditMode).call(e,this))}this._temporaryBindEvent("click",Yn(t=this._performAddNode).call(t,this))}},{key:"editNode",value:function(){var t=this;!0!==this.editMode&&this.enableEditMode(),this._clean();var e=this.selectionHandler.getSelectedNodes()[0];if(void 0!==e){if(this.inMode="editNode","function"!=typeof this.options.editNode)throw new Error("No function has been configured to handle the editing of nodes.");if(!0!==e.isCluster){var i=Ux({},e.options,!1);if(i.x=e.x,i.y=e.y,2!==this.options.editNode.length)throw new Error("The function for edit does not support two arguments (data, callback)");this.options.editNode(i,(function(e){null!=e&&"editNode"===t.inMode&&t.body.data.nodes.getDataSet().update(e),t.showManipulatorToolbar()}))}else alert(this.options.locales[this.options.locale].editClusterError||this.options.locales.en.editClusterError)}else this.showManipulatorToolbar()}},{key:"addEdgeMode",value:function(){var t,e,i,n,o;if(!0!==this.editMode&&this.enableEditMode(),this._clean(),this.inMode="addEdge",!0===this.guiEnabled){var r,s=this.options.locales[this.options.locale];this.manipulationDOM={},this._createBackButton(s),this._createSeperator(),this._createDescription(s.edgeDescription||this.options.locales.en.edgeDescription),this._bindElementEvents(this.closeDiv,Yn(r=this.toggleEditMode).call(r,this))}this._temporaryBindUI("onTouch",Yn(t=this._handleConnect).call(t,this)),this._temporaryBindUI("onDragEnd",Yn(e=this._finishConnect).call(e,this)),this._temporaryBindUI("onDrag",Yn(i=this._dragControlNode).call(i,this)),this._temporaryBindUI("onRelease",Yn(n=this._finishConnect).call(n,this)),this._temporaryBindUI("onDragStart",Yn(o=this._dragStartEdge).call(o,this)),this._temporaryBindUI("onHold",(function(){}))}},{key:"editEdgeMode",value:function(){if(!0!==this.editMode&&this.enableEditMode(),this._clean(),this.inMode="editEdge","object"!==Of(this.options.editEdge)||"function"!=typeof this.options.editEdge.editWithoutDrag||(this.edgeBeingEditedId=this.selectionHandler.getSelectedEdgeIds()[0],void 0===this.edgeBeingEditedId)){if(!0===this.guiEnabled){var t,e=this.options.locales[this.options.locale];this.manipulationDOM={},this._createBackButton(e),this._createSeperator(),this._createDescription(e.editEdgeDescription||this.options.locales.en.editEdgeDescription),this._bindElementEvents(this.closeDiv,Yn(t=this.toggleEditMode).call(t,this))}if(this.edgeBeingEditedId=this.selectionHandler.getSelectedEdgeIds()[0],void 0!==this.edgeBeingEditedId){var i,n,o,r,s=this.body.edges[this.edgeBeingEditedId],a=this._getNewTargetNode(s.from.x,s.from.y),h=this._getNewTargetNode(s.to.x,s.to.y);this.temporaryIds.nodes.push(a.id),this.temporaryIds.nodes.push(h.id),this.body.nodes[a.id]=a,this.body.nodeIndices.push(a.id),this.body.nodes[h.id]=h,this.body.nodeIndices.push(h.id),this._temporaryBindUI("onTouch",Yn(i=this._controlNodeTouch).call(i,this)),this._temporaryBindUI("onTap",(function(){})),this._temporaryBindUI("onHold",(function(){})),this._temporaryBindUI("onDragStart",Yn(n=this._controlNodeDragStart).call(n,this)),this._temporaryBindUI("onDrag",Yn(o=this._controlNodeDrag).call(o,this)),this._temporaryBindUI("onDragEnd",Yn(r=this._controlNodeDragEnd).call(r,this)),this._temporaryBindUI("onMouseMove",(function(){})),this._temporaryBindEvent("beforeDrawing",(function(t){var e=s.edgeType.findBorderPositions(t);!1===a.selected&&(a.x=e.from.x,a.y=e.from.y),!1===h.selected&&(h.x=e.to.x,h.y=e.to.y)})),this.body.emitter.emit("_redraw")}else this.showManipulatorToolbar()}else{var l=this.body.edges[this.edgeBeingEditedId];this._performEditEdge(l.from.id,l.to.id)}}},{key:"deleteSelected",value:function(){var t=this;!0!==this.editMode&&this.enableEditMode(),this._clean(),this.inMode="delete";var e=this.selectionHandler.getSelectedNodeIds(),i=this.selectionHandler.getSelectedEdgeIds(),n=void 0;if(e.length>0){for(var o=0;o<e.length;o++)if(!0===this.body.nodes[e[o]].isCluster)return void alert(this.options.locales[this.options.locale].deleteClusterError||this.options.locales.en.deleteClusterError);"function"==typeof this.options.deleteNode&&(n=this.options.deleteNode)}else i.length>0&&"function"==typeof this.options.deleteEdge&&(n=this.options.deleteEdge);if("function"==typeof n){var r={nodes:e,edges:i};if(2!==n.length)throw new Error("The function for delete does not support two arguments (data, callback)");n(r,(function(e){null!=e&&"delete"===t.inMode?(t.body.data.edges.getDataSet().remove(e.edges),t.body.data.nodes.getDataSet().remove(e.nodes),t.body.emitter.emit("startSimulation"),t.showManipulatorToolbar()):(t.body.emitter.emit("startSimulation"),t.showManipulatorToolbar())}))}else this.body.data.edges.getDataSet().remove(i),this.body.data.nodes.getDataSet().remove(e),this.body.emitter.emit("startSimulation"),this.showManipulatorToolbar()}},{key:"_setup",value:function(){!0===this.options.enabled?(this.guiEnabled=!0,this._createWrappers(),!1===this.editMode?this._createEditButton():this.showManipulatorToolbar()):(this._removeManipulationDOM(),this.guiEnabled=!1)}},{key:"_createWrappers",value:function(){var t,e;(void 0===this.manipulationDiv&&(this.manipulationDiv=document.createElement("div"),this.manipulationDiv.className="vis-manipulation",!0===this.editMode?this.manipulationDiv.style.display="block":this.manipulationDiv.style.display="none",this.canvas.frame.appendChild(this.manipulationDiv)),void 0===this.editModeDiv&&(this.editModeDiv=document.createElement("div"),this.editModeDiv.className="vis-edit-mode",!0===this.editMode?this.editModeDiv.style.display="none":this.editModeDiv.style.display="block",this.canvas.frame.appendChild(this.editModeDiv)),void 0===this.closeDiv)&&(this.closeDiv=document.createElement("button"),this.closeDiv.className="vis-close",this.closeDiv.setAttribute("aria-label",null!==(t=null===(e=this.options.locales[this.options.locale])||void 0===e?void 0:e.close)&&void 0!==t?t:this.options.locales.en.close),this.closeDiv.style.display=this.manipulationDiv.style.display,this.canvas.frame.appendChild(this.closeDiv))}},{key:"_getNewTargetNode",value:function(t,e){var i=Ux({},this.options.controlNodeStyle);i.id="targetNode"+UI(),i.hidden=!1,i.physics=!1,i.x=t,i.y=e;var n=this.body.functions.createNode(i);return n.shape.boundingBox={left:t,right:t,top:e,bottom:e},n}},{key:"_createEditButton",value:function(){var t;this._clean(),this.manipulationDOM={},Ax(this.editModeDiv);var e=this.options.locales[this.options.locale],i=this._createButton("editMode","vis-edit vis-edit-mode",e.edit||this.options.locales.en.edit);this.editModeDiv.appendChild(i),this._bindElementEvents(i,Yn(t=this.toggleEditMode).call(t,this))}},{key:"_clean",value:function(){this.inMode=!1,!0===this.guiEnabled&&(Ax(this.editModeDiv),Ax(this.manipulationDiv),this._cleanupDOMEventListeners()),this._cleanupTemporaryNodesAndEdges(),this._unbindTemporaryUIs(),this._unbindTemporaryEvents(),this.body.emitter.emit("restorePhysics")}},{key:"_cleanupDOMEventListeners",value:function(){var t,e,i=ZA(vg(t=this._domEventListenerCleanupQueue).call(t,0));try{for(i.s();!(e=i.n()).done;){(0,e.value)()}}catch(t){i.e(t)}finally{i.f()}}},{key:"_removeManipulationDOM",value:function(){this._clean(),Ax(this.manipulationDiv),Ax(this.editModeDiv),Ax(this.closeDiv),this.manipulationDiv&&this.canvas.frame.removeChild(this.manipulationDiv),this.editModeDiv&&this.canvas.frame.removeChild(this.editModeDiv),this.closeDiv&&this.canvas.frame.removeChild(this.closeDiv),this.manipulationDiv=void 0,this.editModeDiv=void 0,this.closeDiv=void 0}},{key:"_createSeperator",value:function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:1;this.manipulationDOM["seperatorLineDiv"+t]=document.createElement("div"),this.manipulationDOM["seperatorLineDiv"+t].className="vis-separator-line",this.manipulationDiv.appendChild(this.manipulationDOM["seperatorLineDiv"+t])}},{key:"_createAddNodeButton",value:function(t){var e,i=this._createButton("addNode","vis-add",t.addNode||this.options.locales.en.addNode);this.manipulationDiv.appendChild(i),this._bindElementEvents(i,Yn(e=this.addNodeMode).call(e,this))}},{key:"_createAddEdgeButton",value:function(t){var e,i=this._createButton("addEdge","vis-connect",t.addEdge||this.options.locales.en.addEdge);this.manipulationDiv.appendChild(i),this._bindElementEvents(i,Yn(e=this.addEdgeMode).call(e,this))}},{key:"_createEditNodeButton",value:function(t){var e,i=this._createButton("editNode","vis-edit",t.editNode||this.options.locales.en.editNode);this.manipulationDiv.appendChild(i),this._bindElementEvents(i,Yn(e=this.editNode).call(e,this))}},{key:"_createEditEdgeButton",value:function(t){var e,i=this._createButton("editEdge","vis-edit",t.editEdge||this.options.locales.en.editEdge);this.manipulationDiv.appendChild(i),this._bindElementEvents(i,Yn(e=this.editEdgeMode).call(e,this))}},{key:"_createDeleteButton",value:function(t){var e,i;i=this.options.rtl?"vis-delete-rtl":"vis-delete";var n=this._createButton("delete",i,t.del||this.options.locales.en.del);this.manipulationDiv.appendChild(n),this._bindElementEvents(n,Yn(e=this.deleteSelected).call(e,this))}},{key:"_createBackButton",value:function(t){var e,i=this._createButton("back","vis-back",t.back||this.options.locales.en.back);this.manipulationDiv.appendChild(i),this._bindElementEvents(i,Yn(e=this.showManipulatorToolbar).call(e,this))}},{key:"_createButton",value:function(t,e,i){var n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:"vis-label";return this.manipulationDOM[t+"Div"]=document.createElement("button"),this.manipulationDOM[t+"Div"].className="vis-button "+e,this.manipulationDOM[t+"Label"]=document.createElement("div"),this.manipulationDOM[t+"Label"].className=n,this.manipulationDOM[t+"Label"].innerText=i,this.manipulationDOM[t+"Div"].appendChild(this.manipulationDOM[t+"Label"]),this.manipulationDOM[t+"Div"]}},{key:"_createDescription",value:function(t){this.manipulationDOM.descriptionLabel=document.createElement("div"),this.manipulationDOM.descriptionLabel.className="vis-none",this.manipulationDOM.descriptionLabel.innerText=t,this.manipulationDiv.appendChild(this.manipulationDOM.descriptionLabel)}},{key:"_temporaryBindEvent",value:function(t,e){this.temporaryEventFunctions.push({event:t,boundFunction:e}),this.body.emitter.on(t,e)}},{key:"_temporaryBindUI",value:function(t,e){if(void 0===this.body.eventListeners[t])throw new Error("This UI function does not exist. Typo? You tried: "+t+" possible are: "+Om(ov(this.body.eventListeners)));this.temporaryUIFunctions[t]=this.body.eventListeners[t],this.body.eventListeners[t]=e}},{key:"_unbindTemporaryUIs",value:function(){for(var t in this.temporaryUIFunctions)Object.prototype.hasOwnProperty.call(this.temporaryUIFunctions,t)&&(this.body.eventListeners[t]=this.temporaryUIFunctions[t],delete this.temporaryUIFunctions[t]);this.temporaryUIFunctions={}}},{key:"_unbindTemporaryEvents",value:function(){for(var t=0;t<this.temporaryEventFunctions.length;t++){var e=this.temporaryEventFunctions[t].event,i=this.temporaryEventFunctions[t].boundFunction;this.body.emitter.off(e,i)}this.temporaryEventFunctions=[]}},{key:"_bindElementEvents",value:function(t,e){var i=new Mk(t,{});oF(i,e),this._domEventListenerCleanupQueue.push((function(){i.destroy()}));var n=function(t){var i=t.keyCode,n=t.key;"Enter"!==n&&" "!==n&&13!==i&&32!==i||e()};t.addEventListener("keyup",n,!1),this._domEventListenerCleanupQueue.push((function(){t.removeEventListener("keyup",n,!1)}))}},{key:"_cleanupTemporaryNodesAndEdges",value:function(){for(var t=0;t<this.temporaryIds.edges.length;t++){var e;this.body.edges[this.temporaryIds.edges[t]].disconnect(),delete this.body.edges[this.temporaryIds.edges[t]];var i,n=tm(e=this.body.edgeIndices).call(e,this.temporaryIds.edges[t]);if(-1!==n)vg(i=this.body.edgeIndices).call(i,n,1)}for(var o=0;o<this.temporaryIds.nodes.length;o++){var r;delete this.body.nodes[this.temporaryIds.nodes[o]];var s,a=tm(r=this.body.nodeIndices).call(r,this.temporaryIds.nodes[o]);if(-1!==a)vg(s=this.body.nodeIndices).call(s,a,1)}this.temporaryIds={nodes:[],edges:[]}}},{key:"_controlNodeTouch",value:function(t){this.selectionHandler.unselectAll(),this.lastTouch=this.body.functions.getPointer(t.center),this.lastTouch.translation=xn({},this.body.view.translation)}},{key:"_controlNodeDragStart",value:function(){var t=this.lastTouch,e=this.selectionHandler._pointerToPositionObject(t),i=this.body.nodes[this.temporaryIds.nodes[0]],n=this.body.nodes[this.temporaryIds.nodes[1]],o=this.body.edges[this.edgeBeingEditedId];this.selectedControlNode=void 0;var r=i.isOverlappingWith(e),s=n.isOverlappingWith(e);!0===r?(this.selectedControlNode=i,o.edgeType.from=i):!0===s&&(this.selectedControlNode=n,o.edgeType.to=n),void 0!==this.selectedControlNode&&this.selectionHandler.selectObject(this.selectedControlNode),this.body.emitter.emit("_redraw")}},{key:"_controlNodeDrag",value:function(t){this.body.emitter.emit("disablePhysics");var e=this.body.functions.getPointer(t.center),i=this.canvas.DOMtoCanvas(e);void 0!==this.selectedControlNode?(this.selectedControlNode.x=i.x,this.selectedControlNode.y=i.y):this.interactionHandler.onDrag(t),this.body.emitter.emit("_redraw")}},{key:"_controlNodeDragEnd",value:function(t){var e=this.body.functions.getPointer(t.center),i=this.selectionHandler._pointerToPositionObject(e),n=this.body.edges[this.edgeBeingEditedId];if(void 0!==this.selectedControlNode){this.selectionHandler.unselectAll();for(var o=this.selectionHandler._getAllNodesOverlappingWith(i),r=void 0,s=o.length-1;s>=0;s--)if(o[s]!==this.selectedControlNode.id){r=this.body.nodes[o[s]];break}if(void 0!==r&&void 0!==this.selectedControlNode)if(!0===r.isCluster)alert(this.options.locales[this.options.locale].createEdgeError||this.options.locales.en.createEdgeError);else{var a=this.body.nodes[this.temporaryIds.nodes[0]];this.selectedControlNode.id===a.id?this._performEditEdge(r.id,n.to.id):this._performEditEdge(n.from.id,r.id)}else n.updateEdgeType(),this.body.emitter.emit("restorePhysics");this.body.emitter.emit("_redraw")}}},{key:"_handleConnect",value:function(t){if((new Date).valueOf()-this.touchTime>100){this.lastTouch=this.body.functions.getPointer(t.center),this.lastTouch.translation=xn({},this.body.view.translation),this.interactionHandler.drag.pointer=this.lastTouch,this.interactionHandler.drag.translation=this.lastTouch.translation;var e=this.lastTouch,i=this.selectionHandler.getNodeAt(e);if(void 0!==i)if(!0===i.isCluster)alert(this.options.locales[this.options.locale].createEdgeError||this.options.locales.en.createEdgeError);else{var n=this._getNewTargetNode(i.x,i.y);this.body.nodes[n.id]=n,this.body.nodeIndices.push(n.id);var o=this.body.functions.createEdge({id:"connectionEdge"+UI(),from:i.id,to:n.id,physics:!1,smooth:{enabled:!0,type:"continuous",roundness:.5}});this.body.edges[o.id]=o,this.body.edgeIndices.push(o.id),this.temporaryIds.nodes.push(n.id),this.temporaryIds.edges.push(o.id)}this.touchTime=(new Date).valueOf()}}},{key:"_dragControlNode",value:function(t){var e=this.body.functions.getPointer(t.center),i=this.selectionHandler._pointerToPositionObject(e),n=void 0;void 0!==this.temporaryIds.edges[0]&&(n=this.body.edges[this.temporaryIds.edges[0]].fromId);for(var o=this.selectionHandler._getAllNodesOverlappingWith(i),r=void 0,s=o.length-1;s>=0;s--){var a;if(-1===tm(a=this.temporaryIds.nodes).call(a,o[s])){r=this.body.nodes[o[s]];break}}if(t.controlEdge={from:n,to:r?r.id:void 0},this.selectionHandler.generateClickEvent("controlNodeDragging",t,e),void 0!==this.temporaryIds.nodes[0]){var h=this.body.nodes[this.temporaryIds.nodes[0]];h.x=this.canvas._XconvertDOMtoCanvas(e.x),h.y=this.canvas._YconvertDOMtoCanvas(e.y),this.body.emitter.emit("_redraw")}else this.interactionHandler.onDrag(t)}},{key:"_finishConnect",value:function(t){var e=this.body.functions.getPointer(t.center),i=this.selectionHandler._pointerToPositionObject(e),n=void 0;void 0!==this.temporaryIds.edges[0]&&(n=this.body.edges[this.temporaryIds.edges[0]].fromId);for(var o=this.selectionHandler._getAllNodesOverlappingWith(i),r=void 0,s=o.length-1;s>=0;s--){var a;if(-1===tm(a=this.temporaryIds.nodes).call(a,o[s])){r=this.body.nodes[o[s]];break}}this._cleanupTemporaryNodesAndEdges(),void 0!==r&&(!0===r.isCluster?alert(this.options.locales[this.options.locale].createEdgeError||this.options.locales.en.createEdgeError):void 0!==this.body.nodes[n]&&void 0!==this.body.nodes[r.id]&&this._performAddEdge(n,r.id)),t.controlEdge={from:n,to:r?r.id:void 0},this.selectionHandler.generateClickEvent("controlNodeDragEnd",t,e),this.body.emitter.emit("_redraw")}},{key:"_dragStartEdge",value:function(t){var e=this.lastTouch;this.selectionHandler.generateClickEvent("dragStart",t,e,void 0,!0)}},{key:"_performAddNode",value:function(t){var e=this,i={id:UI(),x:t.pointer.canvas.x,y:t.pointer.canvas.y,label:"new"};if("function"==typeof this.options.addNode){if(2!==this.options.addNode.length)throw this.showManipulatorToolbar(),new Error("The function for add does not support two arguments (data,callback)");this.options.addNode(i,(function(t){null!=t&&"addNode"===e.inMode&&e.body.data.nodes.getDataSet().add(t),e.showManipulatorToolbar()}))}else this.body.data.nodes.getDataSet().add(i),this.showManipulatorToolbar()}},{key:"_performAddEdge",value:function(t,e){var i=this,n={from:t,to:e};if("function"==typeof this.options.addEdge){if(2!==this.options.addEdge.length)throw new Error("The function for connect does not support two arguments (data,callback)");this.options.addEdge(n,(function(t){null!=t&&"addEdge"===i.inMode&&(i.body.data.edges.getDataSet().add(t),i.selectionHandler.unselectAll(),i.showManipulatorToolbar())}))}else this.body.data.edges.getDataSet().add(n),this.selectionHandler.unselectAll(),this.showManipulatorToolbar()}},{key:"_performEditEdge",value:function(t,e){var i=this,n={id:this.edgeBeingEditedId,from:t,to:e,label:this.body.data.edges.get(this.edgeBeingEditedId).label},o=this.options.editEdge;if("object"===Of(o)&&(o=o.editWithoutDrag),"function"==typeof o){if(2!==o.length)throw new Error("The function for edit does not support two arguments (data, callback)");o(n,(function(t){null==t||"editEdge"!==i.inMode?(i.body.edges[n.id].updateEdgeType(),i.body.emitter.emit("_redraw"),i.showManipulatorToolbar()):(i.body.data.edges.getDataSet().update(t),i.selectionHandler.unselectAll(),i.showManipulatorToolbar())}))}else this.body.data.edges.getDataSet().update(n),this.selectionHandler.unselectAll(),this.showManipulatorToolbar()}}]),t}(),tj="string",ej="boolean",ij="number",nj="array",oj="object",rj=["arrow","bar","box","circle","crow","curve","diamond","image","inv_curve","inv_triangle","triangle","vee"],sj={borderWidth:{number:ij},borderWidthSelected:{number:ij,undefined:"undefined"},brokenImage:{string:tj,undefined:"undefined"},chosen:{label:{boolean:ej,function:"function"},node:{boolean:ej,function:"function"},__type__:{object:oj,boolean:ej}},color:{border:{string:tj},background:{string:tj},highlight:{border:{string:tj},background:{string:tj},__type__:{object:oj,string:tj}},hover:{border:{string:tj},background:{string:tj},__type__:{object:oj,string:tj}},__type__:{object:oj,string:tj}},opacity:{number:ij,undefined:"undefined"},fixed:{x:{boolean:ej},y:{boolean:ej},__type__:{object:oj,boolean:ej}},font:{align:{string:tj},color:{string:tj},size:{number:ij},face:{string:tj},background:{string:tj},strokeWidth:{number:ij},strokeColor:{string:tj},vadjust:{number:ij},multi:{boolean:ej,string:tj},bold:{color:{string:tj},size:{number:ij},face:{string:tj},mod:{string:tj},vadjust:{number:ij},__type__:{object:oj,string:tj}},boldital:{color:{string:tj},size:{number:ij},face:{string:tj},mod:{string:tj},vadjust:{number:ij},__type__:{object:oj,string:tj}},ital:{color:{string:tj},size:{number:ij},face:{string:tj},mod:{string:tj},vadjust:{number:ij},__type__:{object:oj,string:tj}},mono:{color:{string:tj},size:{number:ij},face:{string:tj},mod:{string:tj},vadjust:{number:ij},__type__:{object:oj,string:tj}},__type__:{object:oj,string:tj}},group:{string:tj,number:ij,undefined:"undefined"},heightConstraint:{minimum:{number:ij},valign:{string:tj},__type__:{object:oj,boolean:ej,number:ij}},hidden:{boolean:ej},icon:{face:{string:tj},code:{string:tj},size:{number:ij},color:{string:tj},weight:{string:tj,number:ij},__type__:{object:oj}},id:{string:tj,number:ij},image:{selected:{string:tj,undefined:"undefined"},unselected:{string:tj,undefined:"undefined"},__type__:{object:oj,string:tj}},imagePadding:{top:{number:ij},right:{number:ij},bottom:{number:ij},left:{number:ij},__type__:{object:oj,number:ij}},label:{string:tj,undefined:"undefined"},labelHighlightBold:{boolean:ej},level:{number:ij,undefined:"undefined"},margin:{top:{number:ij},right:{number:ij},bottom:{number:ij},left:{number:ij},__type__:{object:oj,number:ij}},mass:{number:ij},physics:{boolean:ej},scaling:{min:{number:ij},max:{number:ij},label:{enabled:{boolean:ej},min:{number:ij},max:{number:ij},maxVisible:{number:ij},drawThreshold:{number:ij},__type__:{object:oj,boolean:ej}},customScalingFunction:{function:"function"},__type__:{object:oj}},shadow:{enabled:{boolean:ej},color:{string:tj},size:{number:ij},x:{number:ij},y:{number:ij},__type__:{object:oj,boolean:ej}},shape:{string:["custom","ellipse","circle","database","box","text","image","circularImage","diamond","dot","star","triangle","triangleDown","square","icon","hexagon"]},ctxRenderer:{function:"function"},shapeProperties:{borderDashes:{boolean:ej,array:nj},borderRadius:{number:ij},interpolation:{boolean:ej},useImageSize:{boolean:ej},useBorderWithImage:{boolean:ej},coordinateOrigin:{string:["center","top-left"]},__type__:{object:oj}},size:{number:ij},title:{string:tj,dom:"dom",undefined:"undefined"},value:{number:ij,undefined:"undefined"},widthConstraint:{minimum:{number:ij},maximum:{number:ij},__type__:{object:oj,boolean:ej,number:ij}},x:{number:ij},y:{number:ij},__type__:{object:oj}},aj={configure:{enabled:{boolean:ej},filter:{boolean:ej,string:tj,array:nj,function:"function"},container:{dom:"dom"},showButton:{boolean:ej},__type__:{object:oj,boolean:ej,string:tj,array:nj,function:"function"}},edges:{arrows:{to:{enabled:{boolean:ej},scaleFactor:{number:ij},type:{string:rj},imageHeight:{number:ij},imageWidth:{number:ij},src:{string:tj},__type__:{object:oj,boolean:ej}},middle:{enabled:{boolean:ej},scaleFactor:{number:ij},type:{string:rj},imageWidth:{number:ij},imageHeight:{number:ij},src:{string:tj},__type__:{object:oj,boolean:ej}},from:{enabled:{boolean:ej},scaleFactor:{number:ij},type:{string:rj},imageWidth:{number:ij},imageHeight:{number:ij},src:{string:tj},__type__:{object:oj,boolean:ej}},__type__:{string:["from","to","middle"],object:oj}},endPointOffset:{from:{number:ij},to:{number:ij},__type__:{object:oj,number:ij}},arrowStrikethrough:{boolean:ej},background:{enabled:{boolean:ej},color:{string:tj},size:{number:ij},dashes:{boolean:ej,array:nj},__type__:{object:oj,boolean:ej}},chosen:{label:{boolean:ej,function:"function"},edge:{boolean:ej,function:"function"},__type__:{object:oj,boolean:ej}},color:{color:{string:tj},highlight:{string:tj},hover:{string:tj},inherit:{string:["from","to","both"],boolean:ej},opacity:{number:ij},__type__:{object:oj,string:tj}},dashes:{boolean:ej,array:nj},font:{color:{string:tj},size:{number:ij},face:{string:tj},background:{string:tj},strokeWidth:{number:ij},strokeColor:{string:tj},align:{string:["horizontal","top","middle","bottom"]},vadjust:{number:ij},multi:{boolean:ej,string:tj},bold:{color:{string:tj},size:{number:ij},face:{string:tj},mod:{string:tj},vadjust:{number:ij},__type__:{object:oj,string:tj}},boldital:{color:{string:tj},size:{number:ij},face:{string:tj},mod:{string:tj},vadjust:{number:ij},__type__:{object:oj,string:tj}},ital:{color:{string:tj},size:{number:ij},face:{string:tj},mod:{string:tj},vadjust:{number:ij},__type__:{object:oj,string:tj}},mono:{color:{string:tj},size:{number:ij},face:{string:tj},mod:{string:tj},vadjust:{number:ij},__type__:{object:oj,string:tj}},__type__:{object:oj,string:tj}},hidden:{boolean:ej},hoverWidth:{function:"function",number:ij},label:{string:tj,undefined:"undefined"},labelHighlightBold:{boolean:ej},length:{number:ij,undefined:"undefined"},physics:{boolean:ej},scaling:{min:{number:ij},max:{number:ij},label:{enabled:{boolean:ej},min:{number:ij},max:{number:ij},maxVisible:{number:ij},drawThreshold:{number:ij},__type__:{object:oj,boolean:ej}},customScalingFunction:{function:"function"},__type__:{object:oj}},selectionWidth:{function:"function",number:ij},selfReferenceSize:{number:ij},selfReference:{size:{number:ij},angle:{number:ij},renderBehindTheNode:{boolean:ej},__type__:{object:oj}},shadow:{enabled:{boolean:ej},color:{string:tj},size:{number:ij},x:{number:ij},y:{number:ij},__type__:{object:oj,boolean:ej}},smooth:{enabled:{boolean:ej},type:{string:["dynamic","continuous","discrete","diagonalCross","straightCross","horizontal","vertical","curvedCW","curvedCCW","cubicBezier"]},roundness:{number:ij},forceDirection:{string:["horizontal","vertical","none"],boolean:ej},__type__:{object:oj,boolean:ej}},title:{string:tj,undefined:"undefined"},width:{number:ij},widthConstraint:{maximum:{number:ij},__type__:{object:oj,boolean:ej,number:ij}},value:{number:ij,undefined:"undefined"},__type__:{object:oj}},groups:{useDefaultGroups:{boolean:ej},__any__:sj,__type__:{object:oj}},interaction:{dragNodes:{boolean:ej},dragView:{boolean:ej},hideEdgesOnDrag:{boolean:ej},hideEdgesOnZoom:{boolean:ej},hideNodesOnDrag:{boolean:ej},hover:{boolean:ej},keyboard:{enabled:{boolean:ej},speed:{x:{number:ij},y:{number:ij},zoom:{number:ij},__type__:{object:oj}},bindToWindow:{boolean:ej},autoFocus:{boolean:ej},__type__:{object:oj,boolean:ej}},multiselect:{boolean:ej},navigationButtons:{boolean:ej},selectable:{boolean:ej},selectConnectedEdges:{boolean:ej},hoverConnectedEdges:{boolean:ej},tooltipDelay:{number:ij},zoomView:{boolean:ej},zoomSpeed:{number:ij},__type__:{object:oj}},layout:{randomSeed:{undefined:"undefined",number:ij,string:tj},improvedLayout:{boolean:ej},clusterThreshold:{number:ij},hierarchical:{enabled:{boolean:ej},levelSeparation:{number:ij},nodeSpacing:{number:ij},treeSpacing:{number:ij},blockShifting:{boolean:ej},edgeMinimization:{boolean:ej},parentCentralization:{boolean:ej},direction:{string:["UD","DU","LR","RL"]},sortMethod:{string:["hubsize","directed"]},shakeTowards:{string:["leaves","roots"]},__type__:{object:oj,boolean:ej}},__type__:{object:oj}},manipulation:{enabled:{boolean:ej},initiallyActive:{boolean:ej},addNode:{boolean:ej,function:"function"},addEdge:{boolean:ej,function:"function"},editNode:{function:"function"},editEdge:{editWithoutDrag:{function:"function"},__type__:{object:oj,boolean:ej,function:"function"}},deleteNode:{boolean:ej,function:"function"},deleteEdge:{boolean:ej,function:"function"},controlNodeStyle:sj,__type__:{object:oj,boolean:ej}},nodes:sj,physics:{enabled:{boolean:ej},barnesHut:{theta:{number:ij},gravitationalConstant:{number:ij},centralGravity:{number:ij},springLength:{number:ij},springConstant:{number:ij},damping:{number:ij},avoidOverlap:{number:ij},__type__:{object:oj}},forceAtlas2Based:{theta:{number:ij},gravitationalConstant:{number:ij},centralGravity:{number:ij},springLength:{number:ij},springConstant:{number:ij},damping:{number:ij},avoidOverlap:{number:ij},__type__:{object:oj}},repulsion:{centralGravity:{number:ij},springLength:{number:ij},springConstant:{number:ij},nodeDistance:{number:ij},damping:{number:ij},__type__:{object:oj}},hierarchicalRepulsion:{centralGravity:{number:ij},springLength:{number:ij},springConstant:{number:ij},nodeDistance:{number:ij},damping:{number:ij},avoidOverlap:{number:ij},__type__:{object:oj}},maxVelocity:{number:ij},minVelocity:{number:ij},solver:{string:["barnesHut","repulsion","hierarchicalRepulsion","forceAtlas2Based"]},stabilization:{enabled:{boolean:ej},iterations:{number:ij},updateInterval:{number:ij},onlyDynamicEdges:{boolean:ej},fit:{boolean:ej},__type__:{object:oj,boolean:ej}},timestep:{number:ij},adaptiveTimestep:{boolean:ej},wind:{x:{number:ij},y:{number:ij},__type__:{object:oj}},__type__:{object:oj,boolean:ej}},autoResize:{boolean:ej},clickToUse:{boolean:ej},locale:{string:tj},locales:{__any__:{any:"any"},__type__:{object:oj}},height:{string:tj},width:{string:tj},__type__:{object:oj}},hj={nodes:{borderWidth:[1,0,10,1],borderWidthSelected:[2,0,10,1],color:{border:["color","#2B7CE9"],background:["color","#97C2FC"],highlight:{border:["color","#2B7CE9"],background:["color","#D2E5FF"]},hover:{border:["color","#2B7CE9"],background:["color","#D2E5FF"]}},opacity:[0,0,1,.1],fixed:{x:!1,y:!1},font:{color:["color","#343434"],size:[14,0,100,1],face:["arial","verdana","tahoma"],background:["color","none"],strokeWidth:[0,0,50,1],strokeColor:["color","#ffffff"]},hidden:!1,labelHighlightBold:!0,physics:!0,scaling:{min:[10,0,200,1],max:[30,0,200,1],label:{enabled:!1,min:[14,0,200,1],max:[30,0,200,1],maxVisible:[30,0,200,1],drawThreshold:[5,0,20,1]}},shadow:{enabled:!1,color:"rgba(0,0,0,0.5)",size:[10,0,20,1],x:[5,-30,30,1],y:[5,-30,30,1]},shape:["ellipse","box","circle","database","diamond","dot","square","star","text","triangle","triangleDown","hexagon"],shapeProperties:{borderDashes:!1,borderRadius:[6,0,20,1],interpolation:!0,useImageSize:!1},size:[25,0,200,1]},edges:{arrows:{to:{enabled:!1,scaleFactor:[1,0,3,.05],type:"arrow"},middle:{enabled:!1,scaleFactor:[1,0,3,.05],type:"arrow"},from:{enabled:!1,scaleFactor:[1,0,3,.05],type:"arrow"}},endPointOffset:{from:[0,-10,10,1],to:[0,-10,10,1]},arrowStrikethrough:!0,color:{color:["color","#848484"],highlight:["color","#848484"],hover:["color","#848484"],inherit:["from","to","both",!0,!1],opacity:[1,0,1,.05]},dashes:!1,font:{color:["color","#343434"],size:[14,0,100,1],face:["arial","verdana","tahoma"],background:["color","none"],strokeWidth:[2,0,50,1],strokeColor:["color","#ffffff"],align:["horizontal","top","middle","bottom"]},hidden:!1,hoverWidth:[1.5,0,5,.1],labelHighlightBold:!0,physics:!0,scaling:{min:[1,0,100,1],max:[15,0,100,1],label:{enabled:!0,min:[14,0,200,1],max:[30,0,200,1],maxVisible:[30,0,200,1],drawThreshold:[5,0,20,1]}},selectionWidth:[1.5,0,5,.1],selfReferenceSize:[20,0,200,1],selfReference:{size:[20,0,200,1],angle:[Math.PI/2,-6*Math.PI,6*Math.PI,Math.PI/8],renderBehindTheNode:!0},shadow:{enabled:!1,color:"rgba(0,0,0,0.5)",size:[10,0,20,1],x:[5,-30,30,1],y:[5,-30,30,1]},smooth:{enabled:!0,type:["dynamic","continuous","discrete","diagonalCross","straightCross","horizontal","vertical","curvedCW","curvedCCW","cubicBezier"],forceDirection:["horizontal","vertical","none"],roundness:[.5,0,1,.05]},width:[1,0,30,1]},layout:{hierarchical:{enabled:!1,levelSeparation:[150,20,500,5],nodeSpacing:[100,20,500,5],treeSpacing:[200,20,500,5],blockShifting:!0,edgeMinimization:!0,parentCentralization:!0,direction:["UD","DU","LR","RL"],sortMethod:["hubsize","directed"],shakeTowards:["leaves","roots"]}},interaction:{dragNodes:!0,dragView:!0,hideEdgesOnDrag:!1,hideEdgesOnZoom:!1,hideNodesOnDrag:!1,hover:!1,keyboard:{enabled:!1,speed:{x:[10,0,40,1],y:[10,0,40,1],zoom:[.02,0,.1,.005]},bindToWindow:!0,autoFocus:!0},multiselect:!1,navigationButtons:!1,selectable:!0,selectConnectedEdges:!0,hoverConnectedEdges:!0,tooltipDelay:[300,0,1e3,25],zoomView:!0,zoomSpeed:[1,.1,2,.1]},manipulation:{enabled:!1,initiallyActive:!1},physics:{enabled:!0,barnesHut:{theta:[.5,.1,1,.05],gravitationalConstant:[-2e3,-3e4,0,50],centralGravity:[.3,0,10,.05],springLength:[95,0,500,5],springConstant:[.04,0,1.2,.005],damping:[.09,0,1,.01],avoidOverlap:[0,0,1,.01]},forceAtlas2Based:{theta:[.5,.1,1,.05],gravitationalConstant:[-50,-500,0,1],centralGravity:[.01,0,1,.005],springLength:[95,0,500,5],springConstant:[.08,0,1.2,.005],damping:[.4,0,1,.01],avoidOverlap:[0,0,1,.01]},repulsion:{centralGravity:[.2,0,10,.05],springLength:[200,0,500,5],springConstant:[.05,0,1.2,.005],nodeDistance:[100,0,500,5],damping:[.09,0,1,.01]},hierarchicalRepulsion:{centralGravity:[.2,0,10,.05],springLength:[100,0,500,5],springConstant:[.01,0,1.2,.005],nodeDistance:[120,0,500,5],damping:[.09,0,1,.01],avoidOverlap:[0,0,1,.01]},maxVelocity:[50,0,150,1],minVelocity:[.1,.01,.5,.01],solver:["barnesHut","forceAtlas2Based","repulsion","hierarchicalRepulsion"],timestep:[.5,.01,1,.01],wind:{x:[0,-10,10,.1],y:[0,-10,10,.1]}}},lj=function(t,e,i){var n;return!(!Lg(t).call(t,"physics")||!Lg(n=hj.physics.solver).call(n,e)||i.physics.solver===e||"wind"===e)},dj=Object.freeze({__proto__:null,allOptions:aj,configuratorHideOption:lj,configureOptions:hj}),cj=function(){function t(){pu(this,t)}return Nf(t,[{key:"getDistances",value:function(t,e,i){for(var n={},o=t.edges,r=0;r<e.length;r++){var s={};n[e[r]]=s;for(var a=0;a<e.length;a++)s[e[a]]=r==a?0:1e9}for(var h=0;h<i.length;h++){var l=o[i[h]];!0===l.connected&&void 0!==n[l.fromId]&&void 0!==n[l.toId]&&(n[l.fromId][l.toId]=1,n[l.toId][l.fromId]=1)}for(var d=e.length,c=0;c<d;c++)for(var u=e[c],f=n[u],p=0;p<d-1;p++)for(var v=e[p],g=n[v],y=p+1;y<d;y++){var m=e[y],b=n[m],w=Math.min(g[m],g[u]+f[m]);g[m]=w,b[v]=w}return n}}]),t}(),uj=function(){function t(e,i,n){pu(this,t),this.body=e,this.springLength=i,this.springConstant=n,this.distanceSolver=new cj}return Nf(t,[{key:"setOptions",value:function(t){t&&(t.springLength&&(this.springLength=t.springLength),t.springConstant&&(this.springConstant=t.springConstant))}},{key:"solve",value:function(t,e){var i=arguments.length>2&&void 0!==arguments[2]&&arguments[2],n=this.distanceSolver.getDistances(this.body,t,e);this._createL_matrix(n),this._createK_matrix(n),this._createE_matrix();for(var o=0,r=Math.max(1e3,Math.min(10*this.body.nodeIndices.length,6e3)),s=1e9,a=0,h=0,l=0,d=0,c=0;s>.01&&o<r;){o+=1;var u=kp(this._getHighestEnergyNode(i),4);for(a=u[0],s=u[1],h=u[2],l=u[3],d=s,c=0;d>1&&c<5;){c+=1,this._moveNode(a,h,l);var f=kp(this._getEnergy(a),3);d=f[0],h=f[1],l=f[2]}}}},{key:"_getHighestEnergyNode",value:function(t){for(var e=this.body.nodeIndices,i=this.body.nodes,n=0,o=e[0],r=0,s=0,a=0;a<e.length;a++){var h=e[a];if(!0!==i[h].predefinedPosition||!0===i[h].isCluster&&!0===t||!0!==i[h].options.fixed.x||!0!==i[h].options.fixed.y){var l=kp(this._getEnergy(h),3),d=l[0],c=l[1],u=l[2];n<d&&(n=d,o=h,r=c,s=u)}}return[o,n,r,s]}},{key:"_getEnergy",value:function(t){var e=kp(this.E_sums[t],2),i=e[0],n=e[1];return[Math.sqrt(Math.pow(i,2)+Math.pow(n,2)),i,n]}},{key:"_moveNode",value:function(t,e,i){for(var n=this.body.nodeIndices,o=this.body.nodes,r=0,s=0,a=0,h=o[t].x,l=o[t].y,d=this.K_matrix[t],c=this.L_matrix[t],u=0;u<n.length;u++){var f=n[u];if(f!==t){var p=o[f].x,v=o[f].y,g=d[f],y=c[f],m=1/Math.pow(Math.pow(h-p,2)+Math.pow(l-v,2),1.5);r+=g*(1-y*Math.pow(l-v,2)*m),s+=g*(y*(h-p)*(l-v)*m),a+=g*(1-y*Math.pow(h-p,2)*m)}}var b=(e/r+i/s)/(s/r-a/s),w=-(s*b+e)/r;o[t].x+=w,o[t].y+=b,this._updateE_matrix(t)}},{key:"_createL_matrix",value:function(t){var e=this.body.nodeIndices,i=this.springLength;this.L_matrix=[];for(var n=0;n<e.length;n++){this.L_matrix[e[n]]={};for(var o=0;o<e.length;o++)this.L_matrix[e[n]][e[o]]=i*t[e[n]][e[o]]}}},{key:"_createK_matrix",value:function(t){var e=this.body.nodeIndices,i=this.springConstant;this.K_matrix=[];for(var n=0;n<e.length;n++){this.K_matrix[e[n]]={};for(var o=0;o<e.length;o++)this.K_matrix[e[n]][e[o]]=i*Math.pow(t[e[n]][e[o]],-2)}}},{key:"_createE_matrix",value:function(){var t=this.body.nodeIndices,e=this.body.nodes;this.E_matrix={},this.E_sums={};for(var i=0;i<t.length;i++)this.E_matrix[t[i]]=[];for(var n=0;n<t.length;n++){for(var o=t[n],r=e[o].x,s=e[o].y,a=0,h=0,l=n;l<t.length;l++){var d=t[l];if(d!==o){var c=e[d].x,u=e[d].y,f=1/Math.sqrt(Math.pow(r-c,2)+Math.pow(s-u,2));this.E_matrix[o][l]=[this.K_matrix[o][d]*(r-c-this.L_matrix[o][d]*(r-c)*f),this.K_matrix[o][d]*(s-u-this.L_matrix[o][d]*(s-u)*f)],this.E_matrix[d][n]=this.E_matrix[o][l],a+=this.E_matrix[o][l][0],h+=this.E_matrix[o][l][1]}}this.E_sums[o]=[a,h]}}},{key:"_updateE_matrix",value:function(t){for(var e=this.body.nodeIndices,i=this.body.nodes,n=this.E_matrix[t],o=this.K_matrix[t],r=this.L_matrix[t],s=i[t].x,a=i[t].y,h=0,l=0,d=0;d<e.length;d++){var c=e[d];if(c!==t){var u=n[d],f=u[0],p=u[1],v=i[c].x,g=i[c].y,y=1/Math.sqrt(Math.pow(s-v,2)+Math.pow(a-g,2)),m=o[c]*(s-v-r[c]*(s-v)*y),b=o[c]*(a-g-r[c]*(a-g)*y);n[d]=[m,b],h+=m,l+=b;var w=this.E_sums[c];w[0]+=m-f,w[1]+=b-p}}this.E_sums[t]=[h,l]}}]),t}();function fj(t,e,i){var n,o,r,s,a=this;if(!(this instanceof fj))throw new SyntaxError("Constructor must be called with the new operator");this.options={},this.defaultOptions={locale:"en",locales:u_,clickToUse:!1},xn(this.options,this.defaultOptions),this.body={container:t,nodes:{},nodeIndices:[],edges:{},edgeIndices:[],emitter:{on:Yn(n=this.on).call(n,this),off:Yn(o=this.off).call(o,this),emit:Yn(r=this.emit).call(r,this),once:Yn(s=this.once).call(s,this)},eventListeners:{onTap:function(){},onTouch:function(){},onDoubleTap:function(){},onHold:function(){},onDragStart:function(){},onDrag:function(){},onDragEnd:function(){},onMouseWheel:function(){},onPinch:function(){},onMouseMove:function(){},onRelease:function(){},onContext:function(){}},data:{nodes:null,edges:null},functions:{createNode:function(){},createEdge:function(){},getPointer:function(){}},modules:{},view:{scale:1,translation:{x:0,y:0}},selectionBox:{show:!1,position:{start:{x:0,y:0},end:{x:0,y:0}}}},this.bindEventListeners(),this.images=new p_((function(){return a.body.emitter.emit("_requestRedraw")})),this.groups=new UE,this.canvas=new sF(this.body),this.selectionHandler=new CA(this.body,this.canvas),this.interactionHandler=new fF(this.body,this.canvas,this.selectionHandler),this.view=new aF(this.body,this.canvas),this.renderer=new tF(this.body,this.canvas),this.physics=new Kz(this.body),this.layoutEngine=new $A(this.body),this.clustering=new Jz(this.body),this.manipulation=new JA(this.body,this.canvas,this.selectionHandler,this.interactionHandler),this.nodesHandler=new DN(this.body,this.images,this.groups,this.layoutEngine),this.edgesHandler=new jz(this.body,this.images,this.groups),this.body.modules.kamadaKawai=new uj(this.body,150,.05),this.body.modules.clustering=this.clustering,this.canvas._create(),this.setOptions(i),this.setData(e)}function pj(t){for(var e in t)Object.prototype.hasOwnProperty.call(t,e)&&(t[e].redundant=t[e].used,t[e].used=[])}function vj(t){for(var e in t)if(Object.prototype.hasOwnProperty.call(t,e)&&t[e].redundant){for(var i=0;i<t[e].redundant.length;i++)t[e].redundant[i].parentNode.removeChild(t[e].redundant[i]);t[e].redundant=[]}}function gj(t,e,i){var n;return Object.prototype.hasOwnProperty.call(e,t)?e[t].redundant.length>0?(n=e[t].redundant[0],e[t].redundant.shift()):(n=document.createElementNS("http://www.w3.org/2000/svg",t),i.appendChild(n)):(n=document.createElementNS("http://www.w3.org/2000/svg",t),e[t]={used:[],redundant:[]},i.appendChild(n)),e[t].used.push(n),n}to(fj.prototype),fj.prototype.setOptions=function(t){var e=this;if(null===t&&(t=void 0),void 0!==t){!0===Ik.validate(t,aj)&&console.error("%cErrors have been found in the supplied options object.",Dk);if(qx(["locale","locales","clickToUse"],this.options,t),void 0!==t.locale&&(t.locale=function(t,e){try{var i=kp(e.split(/[-_ /]/,2),2),n=i[0],o=i[1],r=null!=n?n.toLowerCase():null,s=null!=o?o.toUpperCase():null;if(r&&s){var a,h=r+"-"+s;if(Object.prototype.hasOwnProperty.call(t,h))return h;console.warn(Np(a="Unknown variant ".concat(s," of language ")).call(a,r,"."))}if(r){var l=r;if(Object.prototype.hasOwnProperty.call(t,l))return l;console.warn("Unknown language ".concat(r))}return console.warn("Unknown locale ".concat(e,", falling back to English.")),"en"}catch(t){return console.error(t),console.warn("Unexpected error while normalizing locale ".concat(e,", falling back to English.")),"en"}}(t.locales||this.options.locales,t.locale)),t=this.layoutEngine.setOptions(t.layout,t),this.canvas.setOptions(t),this.groups.setOptions(t.groups),this.nodesHandler.setOptions(t.nodes),this.edgesHandler.setOptions(t.edges),this.physics.setOptions(t.physics),this.manipulation.setOptions(t.manipulation,t,this.options),this.interactionHandler.setOptions(t.interaction),this.renderer.setOptions(t.interaction),this.selectionHandler.setOptions(t.interaction),void 0!==t.groups&&this.body.emitter.emit("refreshNodes"),"configure"in t&&(this.configurator||(this.configurator=new Tk(this,this.body.container,hj,this.canvas.pixelRatio,lj)),this.configurator.setOptions(t.configure)),this.configurator&&!0===this.configurator.options.enabled){var i={nodes:{},edges:{},layout:{},interaction:{},manipulation:{},physics:{},global:{}};Ux(i.nodes,this.nodesHandler.options),Ux(i.edges,this.edgesHandler.options),Ux(i.layout,this.layoutEngine.options),Ux(i.interaction,this.selectionHandler.options),Ux(i.interaction,this.renderer.options),Ux(i.interaction,this.interactionHandler.options),Ux(i.manipulation,this.manipulation.options),Ux(i.physics,this.physics.options),Ux(i.global,this.canvas.options),Ux(i.global,this.options),this.configurator.setModuleOptions(i)}void 0!==t.clickToUse?!0===t.clickToUse?void 0===this.activator&&(this.activator=new Ck(this.canvas.frame),this.activator.on("change",(function(){e.body.emitter.emit("activate")}))):(void 0!==this.activator&&(this.activator.destroy(),delete this.activator),this.body.emitter.emit("activate")):this.body.emitter.emit("activate"),this.canvas.setSize(),this.body.emitter.emit("startSimulation")}},fj.prototype._updateVisibleIndices=function(){var t=this.body.nodes,e=this.body.edges;for(var i in this.body.nodeIndices=[],this.body.edgeIndices=[],t)Object.prototype.hasOwnProperty.call(t,i)&&(this.clustering._isClusteredNode(i)||!1!==t[i].options.hidden||this.body.nodeIndices.push(t[i].id));for(var n in e)if(Object.prototype.hasOwnProperty.call(e,n)){var o=e[n],r=t[o.fromId],s=t[o.toId],a=void 0!==r&&void 0!==s;!this.clustering._isClusteredEdge(n)&&!1===o.options.hidden&&a&&!1===r.options.hidden&&!1===s.options.hidden&&this.body.edgeIndices.push(o.id)}},fj.prototype.bindEventListeners=function(){var t=this;this.body.emitter.on("_dataChanged",(function(){t.edgesHandler._updateState(),t.body.emitter.emit("_dataUpdated")})),this.body.emitter.on("_dataUpdated",(function(){t.clustering._updateState(),t._updateVisibleIndices(),t._updateValueRange(t.body.nodes),t._updateValueRange(t.body.edges),t.body.emitter.emit("startSimulation"),t.body.emitter.emit("_requestRedraw")}))},fj.prototype.setData=function(t){if(this.body.emitter.emit("resetPhysics"),this.body.emitter.emit("_resetData"),this.selectionHandler.unselectAll(),t&&t.dot&&(t.nodes||t.edges))throw new SyntaxError('Data must contain either parameter "dot" or  parameter pair "nodes" and "edges", but not both.');if(this.setOptions(t&&t.options),t&&t.dot){console.warn("The dot property has been deprecated. Please use the static convertDot method to convert DOT into vis.network format and use the normal data format with nodes and edges. This converter is used like this: var data = vis.network.convertDot(dotString);");var e=h_(t.dot);this.setData(e)}else if(t&&t.gephi){console.warn("The gephi property has been deprecated. Please use the static convertGephi method to convert gephi into vis.network format and use the normal data format with nodes and edges. This converter is used like this: var data = vis.network.convertGephi(gephiJson);");var i=d_(t.gephi);this.setData(i)}else this.nodesHandler.setData(t&&t.nodes,!0),this.edgesHandler.setData(t&&t.edges,!0),this.body.emitter.emit("_dataChanged"),this.body.emitter.emit("_dataLoaded"),this.body.emitter.emit("initPhysics")},fj.prototype.destroy=function(){for(var t in this.body.emitter.emit("destroy"),this.body.emitter.off(),this.off(),delete this.groups,delete this.canvas,delete this.selectionHandler,delete this.interactionHandler,delete this.view,delete this.renderer,delete this.physics,delete this.layoutEngine,delete this.clustering,delete this.manipulation,delete this.nodesHandler,delete this.edgesHandler,delete this.configurator,delete this.images,this.body.nodes)Object.prototype.hasOwnProperty.call(this.body.nodes,t)&&delete this.body.nodes[t];for(var e in this.body.edges)Object.prototype.hasOwnProperty.call(this.body.edges,e)&&delete this.body.edges[e];Ax(this.body.container)},fj.prototype._updateValueRange=function(t){var e,i=void 0,n=void 0,o=0;for(e in t)if(Object.prototype.hasOwnProperty.call(t,e)){var r=t[e].getValue();void 0!==r&&(i=void 0===i?r:Math.min(r,i),n=void 0===n?r:Math.max(r,n),o+=r)}if(void 0!==i&&void 0!==n)for(e in t)Object.prototype.hasOwnProperty.call(t,e)&&t[e].setValueRange(i,n,o)},fj.prototype.isActive=function(){return!this.activator||this.activator.active},fj.prototype.setSize=function(){return this.canvas.setSize.apply(this.canvas,arguments)},fj.prototype.canvasToDOM=function(){return this.canvas.canvasToDOM.apply(this.canvas,arguments)},fj.prototype.DOMtoCanvas=function(){return this.canvas.DOMtoCanvas.apply(this.canvas,arguments)},fj.prototype.findNode=function(){return this.clustering.findNode.apply(this.clustering,arguments)},fj.prototype.isCluster=function(){return this.clustering.isCluster.apply(this.clustering,arguments)},fj.prototype.openCluster=function(){return this.clustering.openCluster.apply(this.clustering,arguments)},fj.prototype.cluster=function(){return this.clustering.cluster.apply(this.clustering,arguments)},fj.prototype.getNodesInCluster=function(){return this.clustering.getNodesInCluster.apply(this.clustering,arguments)},fj.prototype.clusterByConnection=function(){return this.clustering.clusterByConnection.apply(this.clustering,arguments)},fj.prototype.clusterByHubsize=function(){return this.clustering.clusterByHubsize.apply(this.clustering,arguments)},fj.prototype.updateClusteredNode=function(){return this.clustering.updateClusteredNode.apply(this.clustering,arguments)},fj.prototype.getClusteredEdges=function(){return this.clustering.getClusteredEdges.apply(this.clustering,arguments)},fj.prototype.getBaseEdge=function(){return this.clustering.getBaseEdge.apply(this.clustering,arguments)},fj.prototype.getBaseEdges=function(){return this.clustering.getBaseEdges.apply(this.clustering,arguments)},fj.prototype.updateEdge=function(){return this.clustering.updateEdge.apply(this.clustering,arguments)},fj.prototype.clusterOutliers=function(){return this.clustering.clusterOutliers.apply(this.clustering,arguments)},fj.prototype.getSeed=function(){return this.layoutEngine.getSeed.apply(this.layoutEngine,arguments)},fj.prototype.enableEditMode=function(){return this.manipulation.enableEditMode.apply(this.manipulation,arguments)},fj.prototype.disableEditMode=function(){return this.manipulation.disableEditMode.apply(this.manipulation,arguments)},fj.prototype.addNodeMode=function(){return this.manipulation.addNodeMode.apply(this.manipulation,arguments)},fj.prototype.editNode=function(){return this.manipulation.editNode.apply(this.manipulation,arguments)},fj.prototype.editNodeMode=function(){return console.warn("Deprecated: Please use editNode instead of editNodeMode."),this.manipulation.editNode.apply(this.manipulation,arguments)},fj.prototype.addEdgeMode=function(){return this.manipulation.addEdgeMode.apply(this.manipulation,arguments)},fj.prototype.editEdgeMode=function(){return this.manipulation.editEdgeMode.apply(this.manipulation,arguments)},fj.prototype.deleteSelected=function(){return this.manipulation.deleteSelected.apply(this.manipulation,arguments)},fj.prototype.getPositions=function(){return this.nodesHandler.getPositions.apply(this.nodesHandler,arguments)},fj.prototype.getPosition=function(){return this.nodesHandler.getPosition.apply(this.nodesHandler,arguments)},fj.prototype.storePositions=function(){return this.nodesHandler.storePositions.apply(this.nodesHandler,arguments)},fj.prototype.moveNode=function(){return this.nodesHandler.moveNode.apply(this.nodesHandler,arguments)},fj.prototype.getBoundingBox=function(){return this.nodesHandler.getBoundingBox.apply(this.nodesHandler,arguments)},fj.prototype.getConnectedNodes=function(t){return void 0!==this.body.nodes[t]?this.nodesHandler.getConnectedNodes.apply(this.nodesHandler,arguments):this.edgesHandler.getConnectedNodes.apply(this.edgesHandler,arguments)},fj.prototype.getConnectedEdges=function(){return this.nodesHandler.getConnectedEdges.apply(this.nodesHandler,arguments)},fj.prototype.startSimulation=function(){return this.physics.startSimulation.apply(this.physics,arguments)},fj.prototype.stopSimulation=function(){return this.physics.stopSimulation.apply(this.physics,arguments)},fj.prototype.stabilize=function(){return this.physics.stabilize.apply(this.physics,arguments)},fj.prototype.getSelection=function(){return this.selectionHandler.getSelection.apply(this.selectionHandler,arguments)},fj.prototype.setSelection=function(){return this.selectionHandler.setSelection.apply(this.selectionHandler,arguments)},fj.prototype.getSelectedNodes=function(){return this.selectionHandler.getSelectedNodeIds.apply(this.selectionHandler,arguments)},fj.prototype.getSelectedEdges=function(){return this.selectionHandler.getSelectedEdgeIds.apply(this.selectionHandler,arguments)},fj.prototype.getNodeAt=function(){var t=this.selectionHandler.getNodeAt.apply(this.selectionHandler,arguments);return void 0!==t&&void 0!==t.id?t.id:t},fj.prototype.getEdgeAt=function(){var t=this.selectionHandler.getEdgeAt.apply(this.selectionHandler,arguments);return void 0!==t&&void 0!==t.id?t.id:t},fj.prototype.selectNodes=function(){return this.selectionHandler.selectNodes.apply(this.selectionHandler,arguments)},fj.prototype.selectEdges=function(){return this.selectionHandler.selectEdges.apply(this.selectionHandler,arguments)},fj.prototype.unselectAll=function(){this.selectionHandler.unselectAll.apply(this.selectionHandler,arguments),this.selectionHandler.commitWithoutEmitting.apply(this.selectionHandler),this.redraw()},fj.prototype.redraw=function(){return this.renderer.redraw.apply(this.renderer,arguments)},fj.prototype.getScale=function(){return this.view.getScale.apply(this.view,arguments)},fj.prototype.getViewPosition=function(){return this.view.getViewPosition.apply(this.view,arguments)},fj.prototype.fit=function(){return this.view.fit.apply(this.view,arguments)},fj.prototype.moveTo=function(){return this.view.moveTo.apply(this.view,arguments)},fj.prototype.focus=function(){return this.view.focus.apply(this.view,arguments)},fj.prototype.releaseNode=function(){return this.view.releaseNode.apply(this.view,arguments)},fj.prototype.getOptionsFromConfigurator=function(){var t={};return this.configurator&&(t=this.configurator.getOptions.apply(this.configurator)),t};var yj=Object.freeze({__proto__:null,cleanupElements:vj,drawBar:function(t,e,i,n,o,r,s,a){if(0!=n){n<0&&(e-=n*=-1);var h=gj("rect",r,s);h.setAttributeNS(null,"x",t-.5*i),h.setAttributeNS(null,"y",e),h.setAttributeNS(null,"width",i),h.setAttributeNS(null,"height",n),h.setAttributeNS(null,"class",o),a&&h.setAttributeNS(null,"style",a)}},drawPoint:function(t,e,i,n,o,r){var s;if("circle"==i.style?((s=gj("circle",n,o)).setAttributeNS(null,"cx",t),s.setAttributeNS(null,"cy",e),s.setAttributeNS(null,"r",.5*i.size)):((s=gj("rect",n,o)).setAttributeNS(null,"x",t-.5*i.size),s.setAttributeNS(null,"y",e-.5*i.size),s.setAttributeNS(null,"width",i.size),s.setAttributeNS(null,"height",i.size)),void 0!==i.styles&&s.setAttributeNS(null,"style",i.styles),s.setAttributeNS(null,"class",i.className+" vis-point"),r){var a=gj("text",n,o);r.xOffset&&(t+=r.xOffset),r.yOffset&&(e+=r.yOffset),r.content&&(a.textContent=r.content),r.className&&a.setAttributeNS(null,"class",r.className+" vis-label"),a.setAttributeNS(null,"x",t),a.setAttributeNS(null,"y",e)}return s},getDOMElement:function(t,e,i,n){var o;return Object.prototype.hasOwnProperty.call(e,t)?e[t].redundant.length>0?(o=e[t].redundant[0],e[t].redundant.shift()):(o=document.createElement(t),void 0!==n?i.insertBefore(o,n):i.appendChild(o)):(o=document.createElement(t),e[t]={used:[],redundant:[]},void 0!==n?i.insertBefore(o,n):i.appendChild(o)),e[t].used.push(o),o},getSVGElement:gj,prepareElements:pj,resetElements:function(t){pj(t),vj(t),pj(t)}}),mj={Images:p_,dotparser:l_,gephiParser:c_,allOptions:dj,convertDot:h_,convertGephi:d_},bj=Object.freeze({__proto__:null,DOMutil:yj,DataSet:nB,DataView:oB,Hammer:Mk,Network:fj,Queue:tB,data:aB,keycharm:lF,network:mj,util:Bk});t.DOMutil=yj,t.DataSet=nB,t.DataView=oB,t.Hammer=Mk,t.Network=fj,t.Queue=tB,t.data=aB,t.default=bj,t.keycharm=lF,t.network=mj,t.util=Bk,Object.defineProperty(t,"__esModule",{value:!0})}));
//# sourceMappingURL=vis-network.min.js.map
